(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 9.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    127562,       3432]
NotebookOptionsPosition[    117277,       3159]
NotebookOutlinePosition[    118672,       3201]
CellTagsIndexPosition[    118603,       3196]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["DataImport", "Title"],

Cell[CellGroupData[{

Cell["Begin package", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<DataAnalysis`DataImport`\>\"", ",", 
    RowBox[{
    "{", "\[IndentingNewLine]", "\"\<DataAnalysis`\>\"", 
     "\[IndentingNewLine]", "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Messages", "Section"],

Cell[CellGroupData[{

Cell["Functions", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImportDataTable", "::", "usage"}], "=", 
   "\"\<ImportDataTable[file,elements] imports data from a file or folder \
into a DataTable object based on the elements specified.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Element", " ", "XR"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ElementXRImportASC", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ICPMSCalibrationFactor", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ICPMSProcessData", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ICPMSDetectionLimit", "::", "usage"}], "=", "\"\<\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ElementXRImportASCFolder", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ICPMSCalibrationFig", "::", "usage"}], "=", "\"\<\>\""}], ";"}],
    "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ICPMSCalibrationFigData", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ICPMSCalibrationInfo", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AgilentImportCSV", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NeptuneImportExpFolder", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NeptuneImportExp", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"Schott", " ", "Titration"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProcessSchottTitrations", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProcessSchottTitration", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ProcessTitrationData", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"InelXRDImportASCII", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"XRDPeakDetect", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"XRDProfileFig", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ConvertXRDTheta", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"FillICDDXRDData", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CPIXRDImport", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"CryscalXYImport", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"NewXRDToulouseImport", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"GetCODData", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LI820ImportASCII", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LI820Fig", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LI820CorrectNoise", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LI820IntegrateArea", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AAnalystImportXLS", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AASCalibrationParameters", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AASProcessData", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AASCalibrationFig", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AASCalibrationFigData", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AASCalibrationInfo", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"AASInterpolations", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SpectroPhotoImportCSV", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SpectroPhotoImportCSVFolder", "::", "usage"}], "=", 
     "\"\<\>\""}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"QuantiCalibrationFigData", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"QuantiCalibrationFig", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"QuantiProcessData", "::", "usage"}], "=", "\"\<\>\""}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"QuantiProcessStdSmplBracketing", "::", "usage"}], "=", 
     "\"\<\>\""}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"QuantiCalculateMeans", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"QuantiSSBSubstractBlanks", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"QuantiSSBBracketSamples", "::", "usage"}], "=", "\"\<\>\""}], 
    ";"}]}]}]], "Input"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Options", "Subsection"],

Cell[BoxData[""], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Errors", "Subsection"],

Cell[BoxData[""], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin private context", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Error handling", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ErrorMessage", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ErrorMessage", "[", "Args___", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Message", "[", "Args", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Abort", "[", "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"CatchError", ",", "HoldAll"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CatchError", "[", "Body_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Catch", "[", "Body", "]"}], "===", "$ErrorFlag"}], ")"}]}], 
  ";"}]}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["ICP-MS", "Section",
 CellTags->"Null"],

Cell[CellGroupData[{

Cell["Agilent ICPMS", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImportDataTable", "[", 
   RowBox[{"file_", ",", "\"\<AgilentCSV\>\""}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"RawDat", ",", "TmpDat", ",", "OutDat"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RawDat", "=", 
       RowBox[{"Import", "[", 
        RowBox[{"file", ",", "\"\<CSV\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RawDat", "=", 
       RowBox[{"RawDat", "[", 
        RowBox[{"[", 
         RowBox[{"2", ";;"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"AppendTo", "[", 
         RowBox[{
          RowBox[{"RawDat", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{
          RowBox[{"RawDat", "[", 
           RowBox[{"[", "2", "]"}], "]"}], ",", "\"\<\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AppendTo", "[", 
         RowBox[{
          RowBox[{"RawDat", "[", 
           RowBox[{"[", "3", "]"}], "]"}], ",", "\"\<\>\""}], "]"}], ";"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"RawDat", "=", 
       RowBox[{"RawDat", "//", "Transpose"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"TmpDat", "=", 
       RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"#1", "[", 
             RowBox[{"[", 
              RowBox[{"{", "1", "}"}], "]"}], "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"DateObject", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#1", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                 "\"\<Day\>\"", ",", "\"\<Month\>\"", ",", "\"\<Year\>\"", 
                  ",", "\"\<Hour\>\"", ",", "\"\<Minute\>\""}], "}"}]}], 
               "}"}], "]"}], "}"}], ",", 
            RowBox[{"MapThread", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"NDV", "[", 
                 RowBox[{"#1", ",", 
                  RowBox[{"#1", "*", 
                   RowBox[{
                    RowBox[{"ToExpression", "[", 
                    RowBox[{"StringDrop", "[", 
                    RowBox[{"#2", ",", 
                    RowBox[{"-", "1"}]}], "]"}], "]"}], "/", "100"}]}]}], 
                 "]"}], ")"}], "&"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#1", "[", 
                 RowBox[{"[", 
                  RowBox[{"4", ";;"}], "]"}], "]"}], ",", 
                RowBox[{"#2", "[", 
                 RowBox[{"[", 
                  RowBox[{"4", ";;"}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
           "]"}], "&"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Take", "[", 
            RowBox[{"RawDat", ",", 
             RowBox[{"{", 
              RowBox[{"2", ",", 
               RowBox[{"-", "1"}], ",", "2"}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Take", "[", 
            RowBox[{"RawDat", ",", 
             RowBox[{"{", 
              RowBox[{"3", ",", 
               RowBox[{"-", "1"}], ",", "2"}], "}"}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}]}], ";",
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{"Prepend", "[", 
        RowBox[{"TmpDat", ",", 
         RowBox[{
          RowBox[{"Drop", "[", 
           RowBox[{
            RowBox[{"RawDat", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{"{", "3", "}"}]}], "]"}], "/.", 
          RowBox[{"\"\<Date/Time:\>\"", "\[Rule]", "\"\<Time\>\""}]}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{"OutDat", "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"NDV", "[", 
           RowBox[{"\"\<<###> \>\"", ",", "___"}], "]"}], "\[Rule]", 
          RowBox[{"Missing", "[", "]"}]}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{"DataTable", "[", "OutDat", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "OutDat"}], 
     "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"a7e1d227-3b5f-4772-94b9-6f365913763a"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Element XR", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ElementXRImportASC", "[", 
    RowBox[{"file_", ",", "isotopes_", ",", 
     RowBox[{"multi_:", "True"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"RawDat", ",", "OutDat", ",", "TblStart", ",", "ColPos"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"RawDat", "=", 
        RowBox[{"Import", "[", 
         RowBox[{"file", ",", "\"\<TSV\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{"multi", ",", "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"RawDat", "=", 
            RowBox[{"RawDat", "[", 
             RowBox[{"[", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"1", ",", "2", ",", "4"}], "}"}], ",", 
                RowBox[{
                 RowBox[{"Map", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Position", "[", 
                    RowBox[{
                    RowBox[{"RawDat", "[", 
                    RowBox[{"[", 
                    RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"s_String", "/;", 
                    RowBox[{"StringMatchQ", "[", 
                    RowBox[{"s", ",", 
                    RowBox[{"#", "~~", "__"}]}], "]"}]}]}], "]"}], "&"}], ",",
                    "isotopes"}], "]"}], "//", "Flatten"}]}], "]"}], "]"}], 
             "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"RawDat", "=", 
            RowBox[{"RawDat", "//", "Transpose"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"OutDat", "=", 
            RowBox[{"{", 
             RowBox[{"Join", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"\"\<ID\>\"", ",", "\"\<Time\>\""}], "}"}], ",", 
               "isotopes"}], "]"}], "}"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"RawDat", "=", 
            RowBox[{"Partition", "[", 
             RowBox[{
              RowBox[{"RawDat", "[", 
               RowBox[{"[", 
                RowBox[{"2", ";;"}], "]"}], "]"}], ",", "14"}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"Scan", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"(", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"AppendTo", "[", 
                 RowBox[{"OutDat", ",", 
                  RowBox[{"Join", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"AbsoluteTime", "[", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}]}], "}"}], 
                    ",", 
                    RowBox[{"MapThread", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"NDV", "[", 
                    RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", 
                    RowBox[{"4", ";;"}]}], "]"}], "]"}], ",", 
                    RowBox[{"#", "[", 
                    RowBox[{"[", 
                    RowBox[{"5", ",", 
                    RowBox[{"4", ";;"}]}], "]"}], "]"}]}], "}"}]}], "]"}]}], 
                   "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", ")"}], "&"}],
              ",", "RawDat"}], "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"MakeDataTable", "[", "OutDat", "]"}]}], 
          "\[IndentingNewLine]", ")"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"TblStart", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{
                RowBox[{"RawDat", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
                "\"\<Isotope\>\""}], "]"}], "//", "Flatten"}], "//", 
             "First"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"OutDat", "=", 
            RowBox[{"Select", "[", 
             RowBox[{
              RowBox[{"RawDat", "[", 
               RowBox[{"[", 
                RowBox[{"TblStart", ";;"}], "]"}], "]"}], ",", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Length", "[", "#", "]"}], "\[Equal]", 
                  RowBox[{"Length", "[", 
                   RowBox[{"RawDat", "[", 
                    RowBox[{"[", "TblStart", "]"}], "]"}], "]"}]}], "&&", 
                 RowBox[{"StringMatchQ", "[", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Alternatives", "@@", "isotopes"}], ")"}], "~~", 
                    "\"\<(LR)\>\""}]}], "]"}]}], ")"}], "&"}]}], "]"}]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"PrependTo", "[", 
            RowBox[{"OutDat", ",", 
             RowBox[{"RawDat", "[", 
              RowBox[{"[", "TblStart", "]"}], "]"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"ColPos", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"Position", "[", 
               RowBox[{
                RowBox[{"OutDat", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"Except", "[", "\"\<\>\"", "]"}]}], "]"}], "//", 
              "Flatten"}], "//", "Rest"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"OutDat", "=", 
            RowBox[{"MakeDataTable", "[", 
             RowBox[{"OutDat", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "ColPos"}], "]"}], "]"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"OutDat", "=", 
            RowBox[{"OutDat", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", 
               RowBox[{"{", 
                RowBox[{
                "\"\<Intensity AVG\>\"", ",", "\"\<Intensity RSD\>\""}], 
                "}"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"OutDat", "=", 
            RowBox[{"OutDat", "//", "DTBody"}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"OutDat", "=", 
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"NDV", "[", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "2", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"#", "[", 
                    RowBox[{"[", "3", "]"}], "]"}], "*", 
                   RowBox[{
                    RowBox[{"#", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "/", "100"}]}]}], "]"}]}],
                "}"}], "&"}], "/@", "OutDat"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"PrependTo", "[", 
            RowBox[{"OutDat", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<Time\>\"", ",", 
               RowBox[{"AbsoluteTime", "[", 
                RowBox[{"RawDat", "[", 
                 RowBox[{"[", 
                  RowBox[{"5", ",", "3"}], "]"}], "]"}], "]"}]}], "}"}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"PrependTo", "[", 
            RowBox[{"OutDat", ",", 
             RowBox[{"{", 
              RowBox[{"\"\<ID\>\"", ",", 
               RowBox[{"FileBaseName", "[", "file", "]"}]}], 
              RowBox[{"(*", 
               RowBox[{"StringReplace", "[", 
                RowBox[{
                 RowBox[{"FileBaseName", "[", "file", "]"}], ",", 
                 RowBox[{
                  RowBox[{"StartOfString", "~~", 
                   RowBox[{"DigitCharacter", ".."}], "~~", "\"\<-\>\""}], 
                  "\[Rule]", "\"\<\>\""}]}], "]"}], "*)"}], "}"}]}], "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"OutDat", "=", 
            RowBox[{"OutDat", "//", "Transpose"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"OutDat", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "=", 
            RowBox[{
             RowBox[{
              RowBox[{"StringReplace", "[", 
               RowBox[{"#", ",", 
                RowBox[{
                 RowBox[{"\"\<(\>\"", "~~", "__", "~~", "\"\<)\>\""}], 
                 "\[Rule]", "\"\<\>\""}]}], "]"}], "&"}], "/@", 
             RowBox[{"OutDat", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "OutDat"}], "\[IndentingNewLine]", ")"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ElementXRImportASCFolder", "[", 
   RowBox[{"folder_", ",", "isotopes_"}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Files", ",", "OutDat"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Files", "=", 
       RowBox[{"FileNames", "[", 
        RowBox[{"\"\<*.ASC\>\"", ",", 
         RowBox[{"{", "folder", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{
        RowBox[{"ElementXRImportASC", "[", 
         RowBox[{
          RowBox[{"Files", "//", "First"}], ",", "isotopes", ",", "False"}], 
         "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"{", "1", "}"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Scan", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{"OutDat", ",", 
           RowBox[{
            RowBox[{"ElementXRImportASC", "[", 
             RowBox[{"#", ",", "isotopes", ",", "False"}], "]"}], "//", 
            "Last"}]}], "]"}], "&"}], ",", "Files"}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"OutDat", "//", "MakeDataTable"}]}], "\[IndentingNewLine]", 
     ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Neptune", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImportDataTable", "[", 
   RowBox[{"location_", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<ThermoFisherNeptune\>\"", ",", "isotopes_", ",", 
      RowBox[{"dateFormat_:", 
       RowBox[{"{", 
        RowBox[{"\"\<Month\>\"", ",", "\"\<Day\>\"", ",", "\"\<Year\>\""}], 
        "}"}]}], ",", 
      RowBox[{"dateFunction_:", 
       RowBox[{"(", 
        RowBox[{"#", "&"}], ")"}]}]}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Files", ",", "OutDat"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Files", "=", 
       RowBox[{"FileNames", "[", 
        RowBox[{"\"\<*.exp\>\"", ",", 
         RowBox[{"{", "location", "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "@", "Files"}], ">", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Join", "@@", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"ImportNeptuneEXPFile", "[", 
                RowBox[{"#", ",", "isotopes"}], "]"}], "&"}], "/@", "Files"}],
              ")"}]}], ")"}], "[", 
          RowBox[{"SortBy", "[", 
           RowBox[{"#\"Time\"", "&"}], "]"}], "]"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"OutDat", "=", 
           RowBox[{"DataTable", "[", 
            RowBox[{"Association", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", "\"\<SampleID\>\""}], "]"}], "]"}], 
                "\[Rule]", "#"}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Normal", "@", 
                  RowBox[{"ImportNeptuneEXPFile", "[", 
                   RowBox[{
                   "#", ",", "isotopes", ",", "False", ",", "dateFormat"}], 
                   "]"}]}], "&"}], "/@", "Files"}], ")"}]}], "]"}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"QueryTo", "[", 
           RowBox[{"OutDat", ",", "All", ",", "All", ",", 
            RowBox[{
             RowBox[{"KeyDrop", "[", 
              RowBox[{"#", ",", 
               RowBox[{"{", "\"\<SampleID\>\"", "}"}]}], "]"}], "&"}]}], 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"QueryTo", "[", 
           RowBox[{"OutDat", ",", "All", ",", "All", ",", "dateFunction"}], 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"OutDat", "[", 
           RowBox[{"SortBy", "[", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "\"\<Time\>\""}], "]"}], "]"}], "&"}], "]"}],
            "]"}]}], "\[IndentingNewLine]", ")"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "@", "Files"}], "\[Equal]", "1"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ImportNeptuneEXPFile", "[", 
           RowBox[{
            RowBox[{"First", "@", "Files"}], ",", "isotopes", ",", 
            "dateFormat"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ImportNeptuneEXPFile", "[", 
           RowBox[{"location", ",", "isotopes", ",", "dateFormat"}], "]"}]}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
     "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"2232d547-934b-4fbf-933e-3db8e652b49d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImportNeptuneEXPFile", "[", 
   RowBox[{"file_", ",", "isotopes_", ",", 
    RowBox[{"removeOutliers_:", "False"}], ",", 
    RowBox[{"dateFormat_:", 
     RowBox[{"{", 
      RowBox[{"\"\<Month\>\"", ",", "\"\<Day\>\"", ",", "\"\<Year\>\""}], 
      "}"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "RawDat", ",", "OutDat", ",", "TblStart", ",", "DateStr", ",", 
      "FirstTime", ",", "SampleID"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RawDat", "=", 
       RowBox[{"Import", "[", 
        RowBox[{"file", ",", "\"\<TSV\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"TblStart", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{"RawDat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", "\"\<Cycle\>\""}], 
          "]"}], "//", "Flatten"}], "//", "First"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"StringPosition", "[", 
              RowBox[{
               RowBox[{"RawDat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{";;", 
                   RowBox[{"TblStart", "-", "1"}]}], ",", "1"}], "]"}], "]"}],
                ",", 
               RowBox[{"\"\<Analysis date:\>\"", "~~", "__"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "__"}], "}"}]}], "]"}], "//", "Flatten"}], 
          "]"}], ">", "0"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"DateStr", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{
               RowBox[{"StringPosition", "[", 
                RowBox[{
                 RowBox[{"RawDat", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{";;", 
                    RowBox[{"TblStart", "-", "1"}]}], ",", "1"}], "]"}], 
                  "]"}], ",", 
                 RowBox[{"\"\<Analysis date:\>\"", "~~", "__"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "__"}], "}"}]}], "]"}], "//", "Flatten"}], "//",
             "First"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"DateStr", "=", 
           RowBox[{"StringDrop", "[", 
            RowBox[{
             RowBox[{"RawDat", "[", 
              RowBox[{"[", 
               RowBox[{"DateStr", ",", "1"}], "]"}], "]"}], ",", "15"}], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"DateStr", "=", 
           RowBox[{"DateObject", "[", 
            RowBox[{"{", 
             RowBox[{"DateStr", ",", "dateFormat"}], "}"}], "]"}]}], ";"}], 
         "\[IndentingNewLine]", ")"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"DateStr", "=", 
           RowBox[{"DateObject", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
         ")"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"$VersionNumber", "\[GreaterEqual]", "11.1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"DateStr", "=", 
          RowBox[{"Normal", "@", 
           RowBox[{"DateObject", "[", 
            RowBox[{"DateStr", ",", "\"\<Day\>\""}], "]"}]}]}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"StringPosition", "[", 
              RowBox[{
               RowBox[{"RawDat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{";;", 
                   RowBox[{"TblStart", "-", "1"}]}], ",", "1"}], "]"}], "]"}],
                ",", 
               RowBox[{"\"\<Analysis time:\>\"", "~~", "__"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "__"}], "}"}]}], "]"}], "//", "Flatten"}], 
          "]"}], ">", "0"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FirstTime", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{
               RowBox[{"StringPosition", "[", 
                RowBox[{
                 RowBox[{"RawDat", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{";;", 
                    RowBox[{"TblStart", "-", "1"}]}], ",", "1"}], "]"}], 
                  "]"}], ",", 
                 RowBox[{"\"\<Analysis time:\>\"", "~~", "__"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "__"}], "}"}]}], "]"}], "//", "Flatten"}], "//",
             "First"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"FirstTime", "=", 
           RowBox[{"StringDrop", "[", 
            RowBox[{
             RowBox[{"RawDat", "[", 
              RowBox[{"[", 
               RowBox[{"FirstTime", ",", "1"}], "]"}], "]"}], ",", "15"}], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"FirstTime", "=", 
           RowBox[{"DateObject", "[", 
            RowBox[{"DateStr", ",", 
             RowBox[{"TimeObject", "[", 
              RowBox[{"DateObject", "[", 
               RowBox[{"{", 
                RowBox[{"FirstTime", ",", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<Hour\>\"", ",", "\"\<Minute\>\"", ",", 
                   "\"\<Second\>\""}], "}"}]}], "}"}], "]"}], "]"}]}], 
            "]"}]}], ";"}], "\[IndentingNewLine]", ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FirstTime", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{
               RowBox[{"RawDat", "[", 
                RowBox[{"[", "TblStart", "]"}], "]"}], ",", "\"\<Time\>\""}], 
              "]"}], "//", "Flatten"}], "//", "First"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"FirstTime", "=", 
           RowBox[{"RawDat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"TblStart", "+", "1"}], ",", "FirstTime"}], "]"}], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"FirstTime", "=", 
           RowBox[{"DateObject", "[", 
            RowBox[{"DateStr", ",", 
             RowBox[{"TimeObject", "[", 
              RowBox[{"DateObject", "[", 
               RowBox[{"{", 
                RowBox[{"FirstTime", ",", 
                 RowBox[{"{", 
                  RowBox[{
                  "\"\<Hour\>\"", ",", "\"\<Minute\>\"", ",", 
                   "\"\<Second\>\"", ",", "\"\<Millisecond\>\""}], "}"}]}], 
                "}"}], "]"}], "]"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
         ")"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", 
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{"StringPosition", "[", 
              RowBox[{
               RowBox[{"RawDat", "[", 
                RowBox[{"[", 
                 RowBox[{
                  RowBox[{";;", 
                   RowBox[{"TblStart", "-", "1"}]}], ",", "1"}], "]"}], "]"}],
                ",", 
               RowBox[{"\"\<Sample ID:\>\"", "~~", "__"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "__"}], "}"}]}], "]"}], "//", "Flatten"}], 
          "]"}], ">", "0"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SampleID", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"Position", "[", 
              RowBox[{
               RowBox[{"StringPosition", "[", 
                RowBox[{
                 RowBox[{"RawDat", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{";;", 
                    RowBox[{"TblStart", "-", "1"}]}], ",", "1"}], "]"}], 
                  "]"}], ",", 
                 RowBox[{"\"\<Sample ID:\>\"", "~~", "__"}]}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"1", ",", "__"}], "}"}]}], "]"}], "//", "Flatten"}], "//",
             "First"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"SampleID", "=", 
           RowBox[{"StringDrop", "[", 
            RowBox[{
             RowBox[{"RawDat", "[", 
              RowBox[{"[", 
               RowBox[{"SampleID", ",", "1"}], "]"}], "]"}], ",", "11"}], 
            "]"}]}], ";"}], "\[IndentingNewLine]", ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"SampleID", "=", 
           RowBox[{"FileBaseName", "[", "file", "]"}]}], ";"}], 
         "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{"Select", "[", 
        RowBox[{
         RowBox[{"RawDat", "[", 
          RowBox[{"[", 
           RowBox[{"TblStart", ";;"}], "]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "#", "]"}], "\[Equal]", 
             RowBox[{"Length", "[", 
              RowBox[{"RawDat", "[", 
               RowBox[{"[", "TblStart", "]"}], "]"}], "]"}]}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"!", 
               RowBox[{"StringQ", "[", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "||", 
              RowBox[{"StringMatchQ", "[", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", "\"\<Cycle\>\""}], 
               "]"}]}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"!", 
              RowBox[{"Or", "@@", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"StringMatchQ", "[", 
                   RowBox[{
                    RowBox[{"ToString", "[", "#", "]"}], ",", "\"\<\>\""}], 
                   "]"}], "&"}], "/@", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", 
                   RowBox[{";;", 
                    RowBox[{"-", "2"}]}], "]"}], "]"}]}], ")"}]}]}], ")"}]}], 
           ")"}], "&"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{"OutDat", "[", 
        RowBox[{"[", 
         RowBox[{"All", ",", 
          RowBox[{";;", 
           RowBox[{"-", "2"}]}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OutDat", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "=", 
       RowBox[{
        RowBox[{
         RowBox[{"StringReplace", "[", 
          RowBox[{
           RowBox[{"ToString", "[", "#", "]"}], ",", 
           RowBox[{"\"\<24.174\>\"", "\[Rule]", "\"\<24Mg\>\""}]}], "]"}], 
         "&"}], "/@", 
        RowBox[{"OutDat", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{"Map", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"StringQ", "[", "#", "]"}], "&&", 
             RowBox[{"StringMatchQ", "[", 
              RowBox[{"#", ",", 
               RowBox[{"\"\<X\>\"", "~~", "NumberString", "~~", "___"}]}], 
              "]"}]}], ",", 
            RowBox[{
             RowBox[{"Interpreter", "[", "\"\<Number\>\"", "]"}], "[", 
             RowBox[{"StringDrop", "[", 
              RowBox[{"#", ",", "1"}], "]"}], "]"}], ",", "#"}], "]"}], "&"}],
          ",", "OutDat", ",", 
         RowBox[{"{", "2", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{"DataTable", "[", "OutDat", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"QueryTo", "[", 
       RowBox[{"OutDat", ",", "All", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"#", "/.", 
           RowBox[{"#\"Time\"", "\[Rule]", 
            RowBox[{"DateObject", "[", 
             RowBox[{"DateStr", ",", 
              RowBox[{"TimeObject", "[", 
               RowBox[{"DateObject", "[", 
                RowBox[{"{", 
                 RowBox[{"#\"Time\"", ",", 
                  RowBox[{"{", 
                   RowBox[{
                   "\"\<Hour\>\"", ",", "\"\<Minute\>\"", ",", 
                    "\"\<Second\>\"", ",", "\"\<Millisecond\>\""}], "}"}]}], 
                 "}"}], "]"}], "]"}]}], "]"}]}]}], ")"}], "&"}]}], "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"QueryTo", "[", 
       RowBox[{"OutDat", ",", "All", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"#\"Time\"", "<", "FirstTime"}], ",", 
            RowBox[{"#", "/.", 
             RowBox[{"#\"Time\"", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"#\"Time\"", "+", 
                RowBox[{"Quantity", "[", 
                 RowBox[{"1", ",", "\"\<Days\>\""}], "]"}]}], ")"}]}]}], ",", 
            "#"}], "]"}], ")"}], "&"}]}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"QueryTo", "[", 
       RowBox[{"OutDat", ",", "All", ",", 
        RowBox[{
         RowBox[{"Prepend", "[", 
          RowBox[{"#", ",", 
           RowBox[{"\"\<SampleID\>\"", "\[Rule]", "SampleID"}]}], "]"}], 
         "&"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"OutDat", "[", 
       RowBox[{"All", ",", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"\"\<SampleID\>\"", ",", "\"\<Time\>\""}], "}"}], ",", 
          "isotopes"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"52e56ee2-4249-4bb5-8e0a-3356b8d2f2db"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TIMS", "Section"],

Cell[CellGroupData[{

Cell["Triton", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ImportDataTable", "[", 
   RowBox[{"location_", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<ThermoFisherTriton\>\"", ",", "isotopes_", ",", 
      RowBox[{"dateFormat_:", 
       RowBox[{"{", 
        RowBox[{"\"\<Month\>\"", ",", "\"\<Day\>\"", ",", "\"\<Year\>\""}], 
        "}"}]}]}], "}"}]}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Files", ",", "OutDat"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Files", "=", 
       RowBox[{"FileNames", "[", 
        RowBox[{"\"\<*.exp\>\"", ",", 
         RowBox[{"{", "location", "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "@", "Files"}], ">", "1"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"OutDat", "=", 
           RowBox[{"DataTable", "[", 
            RowBox[{"Association", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", "\"\<SampleID\>\""}], "]"}], "]"}], 
                "\[Rule]", "#"}], "&"}], "/@", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"Normal", "@", 
                  RowBox[{"ImportNeptuneEXPFile", "[", 
                   RowBox[{
                   "#", ",", "isotopes", ",", "False", ",", "dateFormat"}], 
                   "]"}]}], "&"}], "/@", "Files"}], ")"}]}], "]"}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"QueryTo", "[", 
           RowBox[{"OutDat", ",", "All", ",", "All", ",", 
            RowBox[{
             RowBox[{"KeyDrop", "[", 
              RowBox[{"#", ",", 
               RowBox[{"{", "\"\<SampleID\>\"", "}"}]}], "]"}], "&"}]}], 
           "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"OutDat", "[", 
           RowBox[{"SortBy", "[", 
            RowBox[{
             RowBox[{"#", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "\"\<Time\>\""}], "]"}], "]"}], "&"}], "]"}],
            "]"}]}], "\[IndentingNewLine]", ")"}], ",", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Length", "@", "Files"}], "\[Equal]", "1"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"ImportNeptuneEXPFile", "[", 
           RowBox[{
            RowBox[{"First", "@", "Files"}], ",", "isotopes", ",", "False", 
            ",", "dateFormat"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ImportNeptuneEXPFile", "[", 
           RowBox[{
           "location", ",", "isotopes", ",", "False", ",", "dateFormat"}], 
           "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       "]"}]}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["AAS", "Section"],

Cell[CellGroupData[{

Cell["Perkin Elmer", "Subsection",
 CellTags->"Null"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ImportDataTable", "[", 
    RowBox[{"file_", ",", "\"\<PerkinElmerAAS\>\""}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"RawDat", ",", "TmpDat", ",", "OutDat", ",", "Elements"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"RawDat", "=", 
        RowBox[{
         RowBox[{"Import", "[", "file", "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"OutDat", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"DateObject", "[", 
             RowBox[{
              RowBox[{"AbsoluteTime", "[", 
               RowBox[{"#", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "]"}], "+", 
              RowBox[{"AbsoluteTime", "[", 
               RowBox[{"#", "[", 
                RowBox[{"[", "3", "]"}], "]"}], "]"}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"#", "[", 
             RowBox[{"[", "5", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"NDV", "[", 
             RowBox[{
              RowBox[{"Mean", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "9", "]"}], "]"}], ",", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "11", "]"}], "]"}]}], "}"}], "]"}], ",", 
              RowBox[{
               RowBox[{"StandardDeviation", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"#", "[", 
                   RowBox[{"[", "9", "]"}], "]"}], ",", 
                  RowBox[{"#", "[", 
                   RowBox[{"[", "11", "]"}], "]"}]}], "}"}], "]"}], "/", 
               RowBox[{"Sqrt", "[", "2", "]"}]}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], "&"}], "/@", 
         RowBox[{"RawDat", "[", 
          RowBox[{"[", 
           RowBox[{"2", ";;"}], "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Elements", "=", 
        RowBox[{"DeleteDuplicates", "[", 
         RowBox[{"OutDat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "3"}], "]"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"PrependTo", "[", 
        RowBox[{"OutDat", ",", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Sample\>\"", ",", "\"\<Time\>\"", ",", "\"\<Element\>\"", ",", 
           "\"\<Absorbance\>\""}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"OutDat", "=", 
        RowBox[{"DataTable", "[", "OutDat", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"QueryTo", "[", 
        RowBox[{"OutDat", ",", "All", ",", 
         RowBox[{
          RowBox[{"<|", 
           RowBox[{
            RowBox[{"\"\<Time\>\"", "\[Rule]", "#\"Time\""}], ",", 
            RowBox[{"#\"Element\"", "\[Rule]", "#\"Absorbance\""}]}], "|>"}], 
          "&"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "Elements", "]"}], ">", "1"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"QueryTo", "[", 
          RowBox[{"OutDat", ",", "All", ",", 
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"<|", 
               RowBox[{"\"\<Time\>\"", "\[Rule]", "#\"Time\""}], "|>"}], ",", 
              RowBox[{"<|", 
               RowBox[{
                RowBox[{
                 RowBox[{"#", "\[Rule]", 
                  RowBox[{"Missing", "[", "]"}]}], "&"}], "/@", "Elements"}], 
               "|>"}], ",", "#"}], "]"}], "&"}]}], "]"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "OutDat"}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->
  True,ExpressionUUID->"b619dd42-743a-456a-9b64-c7f9b87fa86d"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Spectrophotometer", "Section"],

Cell[CellGroupData[{

Cell["Import", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SpectroPhotoImportCSV", "[", 
    RowBox[{"file_", ",", "name_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"RawDat", ",", "OutDat", ",", "TblEnd", ",", "TimeRow"}], "}"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"RawDat", "=", 
        RowBox[{"Import", "[", 
         RowBox[{"file", ",", "\"\<CSV\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"TblEnd", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Position", "[", 
             RowBox[{"RawDat", ",", 
              RowBox[{"{", "\"\<\>\"", "}"}]}], "]"}], "//", "Flatten"}], "//",
            "First"}], ")"}], "-", "1"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"OutDat", "=", 
        RowBox[{"RawDat", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"3", ";;", "TblEnd"}], ",", "2"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"TimeRow", "=", 
        RowBox[{
         RowBox[{"Select", "[", 
          RowBox[{
           RowBox[{"RawDat", "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"StringQ", "[", "#", "]"}], ",", 
              RowBox[{"StringMatchQ", "[", 
               RowBox[{"#", ",", 
                RowBox[{"\"\<Collection Time: \>\"", "~~", "__"}]}], "]"}], 
              ",", "False"}], "]"}], "&"}]}], "]"}], "//", "First"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"OutDat", "=", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"name", ",", 
           RowBox[{"EV", "[", 
            RowBox[{
             RowBox[{"OutDat", "//", "Mean"}], ",", 
             RowBox[{"(", 
              RowBox[{"OutDat", "//", "StandardDeviation"}], ")"}]}], 
            RowBox[{"(*", 
             RowBox[{"/", 
              RowBox[{"Sqrt", "[", 
               RowBox[{"OutDat", "//", "Length"}], "]"}]}], "*)"}], "]"}]}], 
          "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"PrependTo", "[", 
        RowBox[{"OutDat", ",", 
         RowBox[{"{", 
          RowBox[{"\"\<Time\>\"", ",", 
           RowBox[{"AbsoluteTime", "[", 
            RowBox[{"StringTake", "[", 
             RowBox[{"TimeRow", ",", 
              RowBox[{"18", ";;"}]}], "]"}], "]"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"PrependTo", "[", 
        RowBox[{"OutDat", ",", 
         RowBox[{"{", 
          RowBox[{"\"\<ID\>\"", ",", 
           RowBox[{"FileBaseName", "[", "file", "]"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"OutDat", "=", 
        RowBox[{"OutDat", "//", "Transpose"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "OutDat"}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"SpectroPhotoImportCSVFolder", "[", 
   RowBox[{"folder_", ",", "name_"}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Files", ",", "OutDat"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Files", "=", 
       RowBox[{"FileNames", "[", 
        RowBox[{"\"\<*.csv\>\"", ",", 
         RowBox[{"{", "folder", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"OutDat", "=", 
       RowBox[{
        RowBox[{"SpectroPhotoImportCSV", "[", 
         RowBox[{
          RowBox[{"Files", "//", "First"}], ",", "name"}], "]"}], "[", 
        RowBox[{"[", 
         RowBox[{"{", "1", "}"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Scan", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{"OutDat", ",", 
           RowBox[{
            RowBox[{"SpectroPhotoImportCSV", "[", 
             RowBox[{"#", ",", "name"}], "]"}], "//", "Last"}]}], "]"}], 
         "&"}], ",", "Files"}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"OutDat", "//", "MakeDataTable"}]}], "\[IndentingNewLine]", 
     ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Schott Titration", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProcessSchottTitrations", "[", 
    RowBox[{"titrs_", ",", "nPoints_", ",", "iterations_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"OutDat", ",", "OutDt"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"OutDat", "=", 
        RowBox[{"{", 
         RowBox[{"Join", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "\"\<ID\>\"", ",", "\"\<Analyte / g\>\"", ",", 
             "\"\<C(Titrant) / mol/L\>\""}], "}"}], ",", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"\"\<EQ \>\"", "<>", 
              RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\< / ml\>\""}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"i", ",", "nPoints"}], "}"}]}], "]"}]}], "]"}], "}"}]}],
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"OutDat", "=", 
        RowBox[{"Join", "[", 
         RowBox[{"OutDat", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"Join", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "3", "]"}], "]"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "4", "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"ProcessSchottTitration", "[", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", "nPoints", ",", 
                "iterations"}], "]"}]}], "]"}], "&"}], "/@", "titrs"}]}], 
         "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"OutDt", "=", 
        RowBox[{"OutDat", "//", "MakeDataTable"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"SmartMap", "[", 
        RowBox[{"OutDt", ",", "\[IndentingNewLine]", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\"\<EQ \>\"", "<>", 
             RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\< / ml\>\""}], 
            "*", 
            RowBox[{"10", "^", 
             RowBox[{"-", "3"}]}], "*", 
            RowBox[{"\"\<C(Titrant) / mol/L\>\"", "/", 
             RowBox[{"(", 
              RowBox[{"\"\<Analyte / g\>\"", "*", 
               RowBox[{"10", "^", 
                RowBox[{"-", "3"}]}]}], ")"}]}]}], ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "nPoints"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Header", "\[Rule]", 
          RowBox[{"Table", "[", 
           RowBox[{
            RowBox[{"\"\<EQ \>\"", "<>", 
             RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\< / mol/L\>\""}], 
            ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "nPoints"}], "}"}]}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProcessSchottTitration", "[", 
    RowBox[{"file_", ",", "nPoints_", ",", "iterations_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "Dt", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Dt", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"Import", "[", "file", "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", 
            RowBox[{";;", 
             RowBox[{"-", "2"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1", ",", "3"}], "}"}]}], "]"}], "]"}], "//", 
         "MakeDataTable"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Dt", "=", 
        RowBox[{"AppendColumns", "[", 
         RowBox[{"Dt", ",", 
          RowBox[{"Join", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", "\"\<dml\>\"", "}"}], ",", 
              RowBox[{"{", "0", "}"}]}], "}"}], ",", 
            RowBox[{"Differences", "[", 
             RowBox[{
              RowBox[{"Dt", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "\"\<ml\>\""}], "]"}], "]"}], "//", 
              "DTValues"}], "]"}]}], "]"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Dt", "=", 
        RowBox[{"SmartMap", "[", 
         RowBox[{"Dt", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"EV", "[", 
             RowBox[{"\"\<dml\>\"", ",", "0.02"}], "]"}], ",", 
            RowBox[{"EV", "[", 
             RowBox[{"\"\<pH\>\"", ",", "0.02"}], "]"}]}], "}"}], ",", 
          RowBox[{"Header", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"\"\<dml\>\"", ",", "\"\<pH\>\""}], "}"}]}]}], "]"}]}], 
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"ProcessTitrationData", "[", 
        RowBox[{
         RowBox[{"Dt", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<dml\>\"", ",", "\"\<pH\>\""}], "}"}]}], "]"}], 
          "]"}], ",", "nPoints", ",", "iterations"}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ProcessTitrationData", "[", 
    RowBox[{"dt_", ",", "nPoints_", ",", "iterations_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Dat", ",", 
       RowBox[{"OutDat", "=", 
        RowBox[{"{", "}"}]}], ",", "i", ",", "j", ",", "LL", ",", "UL", ",", 
       "Points", ",", "DL"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Dat", "=", 
        RowBox[{"dt", "//", "DTValues"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"LL", "=", 
        RowBox[{"Min", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Dat", "//", "EVValues"}], ")"}], "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"UL", "=", 
        RowBox[{"Max", "[", 
         RowBox[{"Total", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Dat", "//", "EVValues"}], ")"}], "[", 
           RowBox[{"[", 
            RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"DL", "=", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"Dat", "//", "EVErrors"}], ")"}], "[", 
            RowBox[{"[", 
             RowBox[{"All", ",", "1"}], "]"}], "]"}], "//", "Mean"}], ")"}], 
         "*", "30"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Off", "[", 
        RowBox[{
         StyleBox[
          RowBox[{"NDSolve", "::", "evcvmit"}], "MessageName"], ",", 
         StyleBox[
          RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"]}], 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Points", "=", 
        RowBox[{"FindEQPoints", "[", 
         RowBox[{
          RowBox[{"Dat", "//", "EVValues"}], ",", "nPoints", ",", "LL", ",", 
          "UL", ",", "True"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Points", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"First", "[", 
           RowBox[{"FindEQPoints", "[", 
            RowBox[{
             RowBox[{"Dat", "//", "EVValues"}], ",", "1", ",", 
             RowBox[{"#", "-", "DL"}], ",", 
             RowBox[{"#", "+", "DL"}]}], "]"}], "]"}], "&"}], "/@", 
         "Points"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"OutDat", "=", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"FindEQPoints", "[", 
            RowBox[{
             RowBox[{"Dat", "//", "RandomData"}], ",", "1", ",", 
             RowBox[{
              RowBox[{"Points", "[", 
               RowBox[{"[", "j", "]"}], "]"}], "-", "DL"}], ",", 
             RowBox[{
              RowBox[{"Points", "[", 
               RowBox[{"[", "j", "]"}], "]"}], "+", "DL"}]}], "]"}], "//", 
           "First"}], ",", 
          RowBox[{"{", 
           RowBox[{"i", ",", "iterations"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "nPoints"}], "}"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"For", "[", 
          RowBox[{
           RowBox[{"i", "=", "1"}], ",", 
           RowBox[{"i", "\[LessEqual]", "nPoints"}], ",", 
           RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
           RowBox[{"For", "[", 
            RowBox[{
             RowBox[{"j", "=", "1"}], ",", 
             RowBox[{"j", "\[LessEqual]", "iterations"}], ",", 
             RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"AppendTo", "[", 
                RowBox[{"OutDat", ",", 
                 RowBox[{"FindEQPoints", "[", 
                  RowBox[{
                   RowBox[{"Dat", "//", "RandomData"}], ",", "1", ",", "LL", 
                   ",", "UL"}], "]"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
              ")"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
          "]"}], ";"}], "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"On", "[", 
        RowBox[{
         StyleBox[
          RowBox[{"NDSolve", "::", "evcvmit"}], "MessageName"], ",", 
         StyleBox[
          RowBox[{"InterpolatingFunction", "::", "dmval"}], "MessageName"]}], 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"MapThread", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"EV", "[", 
           RowBox[{"#1", ",", "#2"}], "]"}], "&"}], ",", 
         RowBox[{"{", 
          RowBox[{"Points", ",", 
           RowBox[{"StandardDeviation", "[", "OutDat", "]"}]}], "}"}]}], 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FindEQPoints", "[", 
    RowBox[{"dat_", ",", "nPoints_", ",", "ll_", ",", "ul_", ",", 
     RowBox[{"smooth_:", "False"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "IP", ",", "EQVolumes", ",", "OutList", ",", "i", ",", "Dat", ",", 
       "MaxC"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Dat", "=", "dat"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Dat", "[", 
         RowBox[{"[", 
          RowBox[{"All", ",", "1"}], "]"}], "]"}], "=", 
        RowBox[{"Accumulate", "[", 
         RowBox[{"Dat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"smooth", "\[Equal]", "True"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Dat", "=", 
           RowBox[{"MovingAverage", "[", 
            RowBox[{"Dat", ",", "3"}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"IP", "=", 
        RowBox[{"Interpolation", "[", "Dat", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"IP", "'"}], "[", "x", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", "0", ",", "15"}], "}"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", "Full"}]}], "]"}], "//", 
          "Print"}], ";", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Plot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"IP", "''"}], "[", "x", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"x", ",", "0", ",", "15"}], "}"}], ",", 
            RowBox[{"PlotRange", "\[Rule]", "Full"}]}], "]"}], "//", 
          "Print"}], ";"}], "*)"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"EQVolumes", "=", 
        RowBox[{
         RowBox[{"Reap", "[", 
          RowBox[{"soln", "=", 
           RowBox[{
            RowBox[{"y", "[", "x", "]"}], "/.", 
            RowBox[{"First", "[", 
             RowBox[{"NDSolve", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"y", "'"}], "[", "x", "]"}], "\[Equal]", 
                  RowBox[{"Evaluate", "[", 
                   RowBox[{"D", "[", 
                    RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"IP", "'"}], "[", "x", "]"}]}], ",", "x"}], "]"}],
                    "]"}]}], ",", 
                 RowBox[{
                  RowBox[{"y", "[", "ll", "]"}], "\[Equal]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    RowBox[{
                    RowBox[{"IP", "'"}], "[", "x", "]"}]}], "/.", 
                    RowBox[{"x", "\[Rule]", "ll"}]}], ")"}]}]}], "}"}], ",", 
               RowBox[{"y", "[", "x", "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"x", ",", "ll", ",", "ul"}], "}"}], ",", 
               RowBox[{"Method", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"\"\<EventLocator\>\"", ",", 
                  RowBox[{"\"\<Event\>\"", "\[Rule]", 
                   RowBox[{
                    RowBox[{"y", "'"}], "[", "x", "]"}]}], ",", 
                  RowBox[{"\"\<EventAction\>\"", "\[RuleDelayed]", 
                   RowBox[{"Sow", "[", 
                    RowBox[{"{", 
                    RowBox[{"x", ",", 
                    RowBox[{"y", "[", "x", "]"}]}], "}"}], "]"}]}]}], 
                 "}"}]}]}], "]"}], "]"}]}]}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"EQVolumes", "=", 
        RowBox[{"Sort", "[", 
         RowBox[{"EQVolumes", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"#1", "[", 
             RowBox[{"[", "2", "]"}], "]"}], ">", 
            RowBox[{"#2", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"OutList", "=", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", "=", "1"}], ",", 
         RowBox[{"i", "\[LessEqual]", "nPoints"}], ",", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{"AppendTo", "[", 
           RowBox[{"OutList", ",", 
            RowBox[{"EQVolumes", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "1"}], "]"}], "]"}]}], "]"}], 
          "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "OutList"}], 
      "\[IndentingNewLine]", ")"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["XRD", "Section",
 CellTags->"Null"],

Cell[CellGroupData[{

Cell["Importing Inel ASCII files with CPS data", "Subsection",
 CellTags->"Null"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InelXRDImportASCII", "[", "file_", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "FileDat", ",", "CpsList", ",", "AngleList", ",", "wavelength"}], "}"}],
      ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FileDat", "=", 
        RowBox[{"Import", "[", 
         RowBox[{"file", ",", "\"\<Table\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"CpsList", "=", 
        RowBox[{
         RowBox[{"FileDat", "[", 
          RowBox[{"[", 
           RowBox[{"10", ";;"}], "]"}], "]"}], "//", "Flatten"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"AngleList", "=", 
        RowBox[{
         RowBox[{"Table", "[", 
          RowBox[{"i", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"FileDat", "[", 
              RowBox[{"[", 
               RowBox[{"9", ",", "1"}], "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"FileDat", "[", 
               RowBox[{"[", 
                RowBox[{"9", ",", "3"}], "]"}], "]"}], "+", "5"}], ",", 
             RowBox[{"FileDat", "[", 
              RowBox[{"[", 
               RowBox[{"9", ",", "2"}], "]"}], "]"}]}], "}"}]}], "]"}], "[", 
         RowBox[{"[", 
          RowBox[{";;", 
           RowBox[{"(", 
            RowBox[{"CpsList", "//", "Length"}], ")"}]}], "]"}], "]"}]}], ";",
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"wavelength", "=", 
        RowBox[{"FileDat", "[", 
         RowBox[{"[", 
          RowBox[{"5", ",", "2"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]",
        "\[IndentingNewLine]", 
       RowBox[{"Prepend", "[", 
        RowBox[{
         RowBox[{"MapThread", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"#1", ",", 
              RowBox[{
               FractionBox["1", "2"], " ", "wavelength", " ", 
               RowBox[{"Csc", "[", 
                FractionBox[
                 RowBox[{"Degree", " ", "#1"}], "2"], "]"}]}], ",", "#2"}], 
             "}"}], "&"}], ",", 
           RowBox[{"{", 
            RowBox[{"AngleList", ",", "CpsList"}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "\"\<2\[Theta] / \[Degree]\>\"", ",", "\"\<d / \[Angstrom]\>\"", 
           ",", "\"\<Int / cps\>\""}], "}"}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"CPIXRDImport", "[", "file_", "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"CpsList", ",", "LambdList", ",", "Lambda", ",", "Filecont"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Filecont", "=", 
       RowBox[{"Import", "[", 
        RowBox[{"file", ",", "\"\<Table\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"CpsList", "=", 
       RowBox[{"Filecont", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"11", ";;"}], ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LambdList", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"x", ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"Filecont", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"Filecont", "[", 
            RowBox[{"[", 
             RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"Filecont", "[", 
            RowBox[{"[", 
             RowBox[{"4", ",", "1"}], "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Lambda", "=", 
       RowBox[{"Filecont", "[", 
        RowBox[{"[", 
         RowBox[{"6", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#1", ",", 
             RowBox[{
              FractionBox["1", "2"], " ", "Lambda", " ", 
              RowBox[{"Csc", "[", 
               FractionBox[
                RowBox[{"Degree", " ", "#1"}], "2"], "]"}]}], ",", "#2"}], 
            "}"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"LambdList", ",", "CpsList"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<2\[Theta] / \[Degree]\>\"", ",", "\"\<d / \[Angstrom]\>\"", 
          ",", "\"\<Int / cps\>\""}], "}"}]}], "]"}]}], "\[IndentingNewLine]",
      ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"CryscalXYImport", "[", "file_", "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Filecont", ",", "Lambda"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Filecont", "=", 
       RowBox[{"Import", "[", 
        RowBox[{"file", ",", "\"\<Table\>\""}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Lambda", "=", 
       RowBox[{"Filecont", "[", 
        RowBox[{"[", 
         RowBox[{"3", ",", "4"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             FractionBox["1", "2"], " ", "Lambda", " ", 
             RowBox[{"Csc", "[", 
              FractionBox[
               RowBox[{"Degree", " ", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "2"], "]"}]}], ",", 
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], "/@", 
         RowBox[{"Filecont", "[", 
          RowBox[{"[", 
           RowBox[{"12", ";;"}], "]"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<2\[Theta] / \[Degree]\>\"", ",", "\"\<d / \[Angstrom]\>\"", 
          ",", "\"\<Int / cps\>\""}], "}"}]}], "]"}]}], "\[IndentingNewLine]",
      ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"NewXRDToulouseImport", "[", 
   RowBox[{"file_", ",", "lambda_"}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "Filecont", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Filecont", "=", 
       RowBox[{
        RowBox[{"Import", "[", 
         RowBox[{"file", ",", "\"\<Table\>\""}], "]"}], "//", "Rest"}]}], ";",
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"#", "[", 
             RowBox[{"[", "1", "]"}], "]"}], ",", 
            RowBox[{
             FractionBox["1", "2"], " ", "lambda", " ", 
             RowBox[{"Csc", "[", 
              FractionBox[
               RowBox[{"Degree", " ", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "2"], "]"}]}], ",", 
            RowBox[{"#", "[", 
             RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], "/@", 
         "Filecont"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<2\[Theta] / \[Degree]\>\"", ",", "\"\<d / \[Angstrom]\>\"", 
          ",", "\"\<Int / cps\>\""}], "}"}]}], "]"}]}], "\[IndentingNewLine]",
      ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Import crystallographic data", "Subsection",
 CellTags->"Null"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetAMCSDData", "[", "id_", "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "File", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"File", "=", 
       RowBox[{"Import", "[", 
        RowBox[{
         RowBox[{
         "\"\<http://rruff.geo.arizona.edu/AMS/xtal_data/DIFfiles/\>\"", "<>", 
          RowBox[{"ToString", "[", "id", "]"}], "<>", "\"\<.txt\>\""}], ",", 
         "\"\<Table\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"File", "[", 
       RowBox[{"[", 
        RowBox[{"12", ";;"}], "]"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"GetCODData", "[", "id_", "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"File", ",", "CpsList", ",", "LambdList", ",", "Lambda"}], "}"}],
     ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"URLSave", "[", 
       RowBox[{
        RowBox[{"\"\<http://www.crystallography.net/cif/\>\"", "<>", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{"ToString", "[", "id", "]"}], ",", "1"}], "]"}], "<>", 
         "\"\</\>\"", "<>", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{"ToString", "[", "id", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3"}], "}"}]}], "]"}], "<>", "\"\</\>\"", "<>", 
         RowBox[{"StringTake", "[", 
          RowBox[{
           RowBox[{"ToString", "[", "id", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", ",", "5"}], "}"}]}], "]"}], "<>", "\"\</\>\"", "<>", 
         RowBox[{"ToString", "[", "id", "]"}], "<>", "\"\<.cif\>\""}], ",", 
        RowBox[{"$TemporaryDirectory", "<>", "\"\<\\\\\>\"", "<>", 
         RowBox[{"ToString", "[", "id", "]"}], "<>", "\"\<.cif\>\""}]}], 
       "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Run", "[", 
       RowBox[{
       "\"\<cd \>\"", "<>", "$TemporaryDirectory", "<>", 
        "\"\< & start /B /MIN platon.exe -o -Q \>\"", "<>", 
        RowBox[{"ToString", "[", "id", "]"}], "<>", 
        "\"\<.cif & PING 1.1.1.1 -n 1 -w 1000 >NUL & TASKKILL /F /IM \
platon.exe\>\""}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"File", "=", 
       RowBox[{"Import", "[", 
        RowBox[{
         RowBox[{"$TemporaryDirectory", "<>", "\"\<\\\\\>\"", "<>", 
          RowBox[{"ToString", "[", "id", "]"}], "<>", "\"\<.cpi\>\""}], ",", 
         "\"\<Table\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"DeleteFile", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"$TemporaryDirectory", "<>", "\"\<\\\\\>\"", "<>", 
           RowBox[{"ToString", "[", "id", "]"}], "<>", "#"}], ")"}], "&"}], "/@", 
        RowBox[{"{", 
         RowBox[{
         "\"\<.cif\>\"", ",", "\"\<.cpi\>\"", ",", "\"\<.eld\>\"", ",", 
          "\"\<.lis\>\"", ",", "\"\<.ps\>\""}], "}"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"DeleteFile", "[", 
       RowBox[{"$TemporaryDirectory", "<>", "\"\<\\\\platon.out\>\""}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"CpsList", "=", 
       RowBox[{"File", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"11", ";;"}], ",", "1"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LambdList", "=", 
       RowBox[{"Table", "[", 
        RowBox[{"x", ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", 
           RowBox[{"File", "[", 
            RowBox[{"[", 
             RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"File", "[", 
            RowBox[{"[", 
             RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"File", "[", 
            RowBox[{"[", 
             RowBox[{"4", ",", "1"}], "]"}], "]"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Lambda", "=", 
       RowBox[{"File", "[", 
        RowBox[{"[", 
         RowBox[{"6", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Prepend", "[", 
       RowBox[{
        RowBox[{"MapThread", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"#1", ",", 
             RowBox[{
              FractionBox["1", "2"], " ", "Lambda", " ", 
              RowBox[{"Csc", "[", 
               FractionBox[
                RowBox[{"Degree", " ", "#1"}], "2"], "]"}]}], ",", "#2"}], 
            "}"}], "&"}], ",", 
          RowBox[{"{", 
           RowBox[{"LambdList", ",", "CpsList"}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
         "\"\<2\[Theta] / \[Degree]\>\"", ",", "\"\<d / \[Angstrom]\>\"", 
          ",", "\"\<Int / cps\>\""}], "}"}]}], "]"}]}], "\[IndentingNewLine]",
      ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"ConvertXRDTheta", "[", 
   RowBox[{"data_", ",", "lambda_"}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "OutData", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"data", "[", 
        RowBox[{"[", 
         RowBox[{"{", "1", "}"}], "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"2", 
            RowBox[{
             RowBox[{"ArcSin", "[", 
              RowBox[{"lambda", "/", 
               RowBox[{"(", 
                RowBox[{"2", 
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], "]"}], "/", 
             "Degree"}]}], ",", 
           RowBox[{"#", "[", 
            RowBox[{"[", "2", "]"}], "]"}], ",", 
           RowBox[{"#", "[", 
            RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "&"}], "/@", 
        RowBox[{"data", "[", 
         RowBox[{"[", 
          RowBox[{"2", ";;"}], "]"}], "]"}]}]}], "]"}], "\[IndentingNewLine]",
      ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"FillICDDXRDData", "[", "data_", "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{"Prepend", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{
         RowBox[{"Map", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "+", "0.0001"}], ",", "0"}],
                "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", 
                RowBox[{"#", "[", 
                 RowBox[{"[", "3", "]"}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"#", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"#", "[", 
                  RowBox[{"[", "2", "]"}], "]"}], "-", "0.0001"}], ",", "0"}],
                "}"}]}], "\[IndentingNewLine]", "}"}], "&"}], ",", 
           RowBox[{"data", "//", "Rest"}]}], "]"}], ",", "1"}], "]"}], ",", 
       RowBox[{"data", "//", "First"}]}], "]"}], "\[IndentingNewLine]", 
     ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Profile plotting", "Subsection",
 CellTags->"Null"],

Cell[BoxData[
 RowBox[{
  RowBox[{"XRDProfileFig", "[", 
   RowBox[{"data_", ",", "labels_", ",", 
    RowBox[{"peaks_:", 
     RowBox[{"{", "}"}]}]}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "XMax", ",", "YMax", ",", "XMaxTmp", ",", "YMaxTmp", ",", "PlotDat"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PlotDat", "=", "data"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"TrueQ", "[", 
         RowBox[{
          RowBox[{"Head", "[", "data", "]"}], "==", "List"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"XMax", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"YMax", "=", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"Scan", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"XMaxTmp", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"#", "//", "DTValues"}], "//", "EVValues"}], 
                   ")"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "1"}], "]"}], "]"}], "//", "Max"}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"XMax", ",", 
                 RowBox[{"Ceiling", "[", 
                  RowBox[{"XMaxTmp", ",", 
                   RowBox[{
                    RowBox[{"10", "^", 
                    RowBox[{"(", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Log10", "[", "XMaxTmp", "]"}], "//", "Floor"}], 
                    ")"}], ")"}]}], "/", "10"}]}], "]"}]}], "]"}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"YMaxTmp", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"#", "//", "DTValues"}], "//", "EVValues"}], 
                   ")"}], "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "2"}], "]"}], "]"}], "//", "Max"}]}], 
               ";", "\[IndentingNewLine]", 
               RowBox[{"AppendTo", "[", 
                RowBox[{"YMax", ",", "YMaxTmp"}], 
                RowBox[{"(*", 
                 RowBox[{"Ceiling", "[", 
                  RowBox[{"YMaxTmp", ",", 
                   RowBox[{
                    RowBox[{"10", "^", 
                    RowBox[{"(", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Log10", "[", "YMaxTmp", "]"}], "//", "Floor"}], 
                    ")"}], ")"}]}], "/", "5"}]}], "]"}], "*)"}], "]"}], ";"}],
               "\[IndentingNewLine]", ")"}], "&"}], ",", "data"}], "]"}], ";",
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"PlotDat", "=", 
           RowBox[{"MapThread", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"SmartMap", "[", 
               RowBox[{"#1", ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"#1", "//", "DTRightHeader"}], ")"}], "*", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", 
                   RowBox[{"100", "/", "#2"}]}], "}"}]}], ",", 
                RowBox[{"PreserveDTHeader", "\[Rule]", "True"}]}], "]"}], 
              "&"}], ",", 
             RowBox[{"{", 
              RowBox[{"PlotDat", ",", "YMax"}], "}"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"XMax", "=", 
           RowBox[{"Max", "[", "XMax", "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"YMax", "=", "100"}], ";"}], "\[IndentingNewLine]", ")"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"XMax", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"data", "//", "DTValues"}], "//", "EVValues"}], ")"}], 
             "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "1"}], "]"}], "]"}], "//", "Max"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"XMax", "=", 
           RowBox[{"Ceiling", "[", 
            RowBox[{"XMax", ",", 
             RowBox[{
              RowBox[{"10", "^", 
               RowBox[{"(", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Log10", "[", "XMax", "]"}], "//", "Floor"}], ")"}],
                 ")"}]}], "/", "5"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"YMax", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"data", "//", "DTValues"}], "//", "EVValues"}], ")"}], 
             "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "2"}], "]"}], "]"}], "//", "Max"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"YMax", "=", 
           RowBox[{"Ceiling", "[", 
            RowBox[{"YMax", ",", 
             RowBox[{"10", "^", 
              RowBox[{"(", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Log10", "[", "YMax", "]"}], "//", "Floor"}], ")"}], 
               ")"}]}]}], "]"}]}], ";"}], "\[IndentingNewLine]", ")"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"DataAnalysis`ListLineFig", "[", 
       RowBox[{"PlotDat", ",", 
        RowBox[{"PlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0", ",", "XMax"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "YMax"}], "}"}]}], "}"}]}], ",", 
        RowBox[{"ShowPoints", "\[Rule]", "False"}], ",", 
        RowBox[{"LegendNames", "\[Rule]", "labels"}], ",", 
        RowBox[{"LegendPos", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.8", ",", "0.8"}], "}"}]}], ",", 
        RowBox[{"ImageSize", "\[Rule]", 
         RowBox[{"150", "*", 
          RowBox[{"{", 
           RowBox[{"6", ",", "3"}], "}"}]}]}]}], "]"}]}], 
     "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Peak detection", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"RawPeakDetect", "=", 
   RowBox[{"Compile", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"data", ",", "_Real", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"width", ",", "_Integer"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"cut", ",", "_Real"}], "}"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", "width", "}"}]}], "]"}], "~", "Join", "~", 
        RowBox[{"UnitStep", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Take", "[", 
              RowBox[{"data", ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"1", "+", "width"}], ",", 
                 RowBox[{
                  RowBox[{"-", "1"}], "-", "width"}]}], "}"}]}], "]"}], "-", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Module", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"tot", "=", 
                    RowBox[{"Total", "[", 
                    RowBox[{"#1", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ";;", 
                    RowBox[{"#2", "-", "1"}]}], "]"}], "]"}], "]"}]}], ",", 
                   RowBox[{"last", "=", "0."}]}], "}"}], ",", 
                 RowBox[{"Table", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"tot", "=", 
                    RowBox[{"tot", "+", 
                    RowBox[{"#1", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", "+", "#2"}], "]"}], "]"}], "-", "last"}]}], 
                    ";", "\[IndentingNewLine]", 
                    RowBox[{"last", "=", 
                    RowBox[{"#1", "[", 
                    RowBox[{"[", 
                    RowBox[{"j", "+", "1"}], "]"}], "]"}]}], ";", 
                    "\[IndentingNewLine]", "tot"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"j", ",", "0", ",", 
                    RowBox[{
                    RowBox[{"Length", "[", "#1", "]"}], "-", "#2"}]}], 
                    "}"}]}], "]"}]}], "]"}], "/", "#2"}], ")"}]}], "&"}], "[", 
           RowBox[{"data", ",", 
            RowBox[{"1", "+", 
             RowBox[{"2", " ", "width"}]}]}], "]"}], "-", "cut"}], "]"}], "~",
         "Join", "~", 
        RowBox[{"Table", "[", 
         RowBox[{"0", ",", 
          RowBox[{"{", "width", "}"}]}], "]"}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", "0", "}"}], "~", "Join", "~", 
        RowBox[{"Table", "[", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Sign", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"data", "[", 
                  RowBox[{"[", 
                   RowBox[{"ii", "+", "1"}], "]"}], "]"}], "-", 
                 RowBox[{"data", "[", 
                  RowBox[{"[", "ii", "]"}], "]"}]}], ",", 
                RowBox[{
                 RowBox[{"data", "[", 
                  RowBox[{"[", 
                   RowBox[{"ii", "+", "2"}], "]"}], "]"}], "-", 
                 RowBox[{"data", "[", 
                  RowBox[{"[", 
                   RowBox[{"ii", "+", "1"}], "]"}], "]"}]}]}], "}"}], "]"}], 
             "\[Equal]", 
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}]}], ",", "1", ",", "0"}], "]"}], 
          ",", 
          RowBox[{"{", 
           RowBox[{"ii", ",", "1", ",", 
            RowBox[{
             RowBox[{"Length", "[", "data", "]"}], "-", "2"}]}], "}"}]}], 
         "]"}], "~", "Join", "~", 
        RowBox[{"{", "0", "}"}]}], ")"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"RawPeakDetect2", "[", 
   RowBox[{"data_", ",", 
    RowBox[{"ther_:", " ", ".2"}], ",", 
    RowBox[{"min_:", " ", "0"}], ",", 
    RowBox[{"cther_:", " ", "50"}]}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Function", "[", 
    RowBox[{"peaks", ",", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", 
       RowBox[{"peaks", ",", 
        RowBox[{"data", "[", 
         RowBox[{"[", "peaks", "]"}], "]"}]}], "}"}], "]"}]}], "]"}], "[", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"#", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"Ordering", "[", 
          RowBox[{
           RowBox[{"data", "[", 
            RowBox[{"[", "#", "]"}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}], "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}], "]"}], "&"}], "/@", 
     RowBox[{"Split", "[", 
      RowBox[{
       RowBox[{"Flatten", "[", 
        RowBox[{"Position", "[", 
         RowBox[{
          RowBox[{"Normal", "[", 
           RowBox[{"CrossingDetect", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"Abs", "[", "#", "]"}], "<", "ther"}], ",", "0", ",",
                 "#"}], "]"}], "&"}], "/@", 
             RowBox[{"InverseWaveletTransform", "[", 
              RowBox[{
               RowBox[{"DiscreteWaveletTransform", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"If", "[", 
                    RowBox[{
                    RowBox[{"#", "<", "min"}], ",", "0", ",", "#"}], "]"}], 
                   "&"}], "/@", "data"}], ",", 
                 RowBox[{"HaarWavelet", "[", "]"}], ",", "1"}], "]"}], ",", 
               RowBox[{"HaarWavelet", "[", "]"}], ",", 
               RowBox[{"{", "1", "}"}]}], "]"}]}], "]"}], "]"}], ",", "1"}], 
         "]"}], "]"}], ",", 
       RowBox[{
        RowBox[{
         RowBox[{"Abs", "[", 
          RowBox[{"#1", "-", "#2"}], "]"}], "<", "cther"}], "&"}]}], "]"}]}], 
    ")"}], "]"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"XRDPeakDetect", "[", 
   RowBox[{"data_", ",", "ther_", ",", "min_", ",", "cther_"}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Peaks", ",", "Dat"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Dat", "=", 
       RowBox[{"data", "//", "Rest"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Peaks", "=", 
         RowBox[{"DeleteCases", "[", 
          RowBox[{
           RowBox[{"MapThread", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"#2", "\[Equal]", "1"}], ",", "#1", ",", "False"}], 
               "]"}], "&"}], ",", 
             RowBox[{"{", 
              RowBox[{"Dat", ",", 
               RowBox[{"RawPeakDetect", "[", 
                RowBox[{
                 RowBox[{"Dat", "[", 
                  RowBox[{"[", 
                   RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", "hw", ",", 
                 "tt"}], "]"}]}], "}"}]}], "]"}], ",", "False"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"Peaks", "=", 
         RowBox[{"Sort", "[", 
          RowBox[{"Peaks", ",", 
           RowBox[{
            RowBox[{
             RowBox[{"#1", "[", 
              RowBox[{"[", "2", "]"}], "]"}], ">", 
             RowBox[{"#2", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "&"}]}], "]"}]}], ";"}], 
       "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Peaks", "=", 
       RowBox[{"RawPeakDetect2", "[", 
        RowBox[{
         RowBox[{"Dat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", "2"}], "]"}], "]"}], ",", "ther", ",", "min", 
         ",", "cther"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Peaks", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Dat", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"#", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", "1"}], "]"}], "]"}], ",", 
           RowBox[{"#", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], "/@", "Peaks"}]}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Prepend", "[", 
       RowBox[{"Peaks", ",", 
        RowBox[{"data", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "\[IndentingNewLine]", 
     ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["CO2-Analyzer", "Section",
 CellTags->"Null"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LI820ImportASCII", "[", "file_", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "FileDat", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FileDat", "=", 
        RowBox[{
         RowBox[{"Import", "[", 
          RowBox[{"file", ",", "\"\<Table\>\""}], "]"}], "//", "Rest"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FileDat", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"2", ";;"}], ",", "1"}], "]"}], "]"}], "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"AbsoluteTime", "[", "#", "]"}], "-", 
            RowBox[{"AbsoluteTime", "[", 
             RowBox[{"FileDat", "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}]}], ")"}], "&"}], "/@", 
         RowBox[{"FileDat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"2", ";;"}], ",", "1"}], "]"}], "]"}]}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FileDat", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], "=", "\"\<Time / s\>\""}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"MakeDataTable", "[", 
        RowBox[{"FileDat", ",", 
         RowBox[{"IDColumnN", "\[Rule]", "0"}]}], "]"}]}], 
      "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LI820Fig", "[", "dat_", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"XMax", ",", "YMax"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"XMax", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"dat", "[", 
             RowBox[{"[", 
              RowBox[{"All", ",", "\"\<Time / s\>\""}], "]"}], "]"}], ")"}], "//",
            "DTValues"}], "//", "Flatten"}], "//", "Last"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"XMax", "=", 
        RowBox[{"Ceiling", "[", 
         RowBox[{"XMax", ",", 
          RowBox[{
           RowBox[{"10", "^", 
            RowBox[{"(", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Log10", "[", "XMax", "]"}], "//", "Floor"}], ")"}], 
             ")"}]}], "/", "10"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"YMax", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"dat", "[", 
              RowBox[{"[", 
               RowBox[{"All", ",", "\"\<CO2(ppm)\>\""}], "]"}], "]"}], ")"}], 
            "//", "DTValues"}], "//", "EVValues"}], "//", "Flatten"}], "//", 
         "Max"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"YMax", "=", 
        RowBox[{"Ceiling", "[", 
         RowBox[{"YMax", ",", 
          RowBox[{
           RowBox[{"10", "^", 
            RowBox[{"(", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"Log10", "[", "YMax", "]"}], "//", "Floor"}], ")"}], 
             ")"}]}], "/", "10"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"ListLineFig", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"dat", "[", 
          RowBox[{"[", 
           RowBox[{"All", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Time / s\>\"", ",", "\"\<CO2(ppm)\>\""}], "}"}]}], 
           "]"}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"PlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "XMax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", "5"}], ",", "YMax"}], "}"}]}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"ShowPoints", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
        "]"}]}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"LI820CorrectNoise", "[", 
   RowBox[{"dat_", ",", "bgRegion_"}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ID1", ",", "ID2", ",", "StdDev", ",", "MeanBG"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ID1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"dat", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "\"\<Time / s\>\""}], "]"}], "]"}], ")"}],
              "//", "DTValues"}], "//", "Flatten"}], ",", 
           RowBox[{"bgRegion", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "//", "Flatten"}], "//", 
        "First"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ID2", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"dat", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "\"\<Time / s\>\""}], "]"}], "]"}], ")"}],
              "//", "DTValues"}], "//", "Flatten"}], ",", 
           RowBox[{"bgRegion", "[", 
            RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "//", "Flatten"}], "//", 
        "First"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"MeanBG", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"dat", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{
              RowBox[{"ToString", "[", "ID1", "]"}], ";;", 
              RowBox[{"ToString", "[", "ID2", "]"}]}], ",", 
             "\"\<CO2(ppm)\>\""}], "]"}], "]"}], ")"}], "//", "DTValues"}], "//",
         "Flatten"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"StdDev", "=", 
       RowBox[{"StandardDeviation", "[", "MeanBG", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"MeanBG", "=", 
       RowBox[{"EV", "[", 
        RowBox[{
         RowBox[{"Mean", "[", "MeanBG", "]"}], ",", "StdDev"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"SmartMap", "[", 
       RowBox[{"dat", ",", 
        RowBox[{"{", 
         RowBox[{"\"\<Time / s\>\"", ",", 
          RowBox[{
           RowBox[{"ProcessEVFunction", "[", 
            RowBox[{
             RowBox[{"EV", "[", 
              RowBox[{"\"\<CO2(ppm)\>\"", ",", "StdDev"}], "]"}], "-", 
             "MeanBG"}], "]"}], "//", "Hold"}]}], "}"}], ",", 
        RowBox[{"Header", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"\"\<Time / s\>\"", ",", "\"\<CO2(ppm)\>\""}], "}"}]}]}], 
       "]"}]}], "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"LI820IntegrateArea", "[", 
   RowBox[{"dat_", ",", "region_", ",", "iterations_"}], "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"ID1", ",", "ID2", ",", "TmpDat", ",", "F", ",", "Areas"}], 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ID1", "=", 
       RowBox[{
        RowBox[{
         RowBox[{"Position", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"dat", "[", 
               RowBox[{"[", 
                RowBox[{"All", ",", "\"\<Time / s\>\""}], "]"}], "]"}], ")"}],
              "//", "DTValues"}], "//", "Flatten"}], ",", 
           RowBox[{"region", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "//", "Flatten"}], "//", 
        "First"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ID2", "=", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"region", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", "Infinity"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"dat", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "\"\<Time / s\>\""}], "]"}], "]"}], 
                ")"}], "//", "DTValues"}], "//", "Flatten"}], ",", 
             RowBox[{"(", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"dat", "[", 
                   RowBox[{"[", 
                    RowBox[{"All", ",", "\"\<Time / s\>\""}], "]"}], "]"}], 
                  ")"}], "//", "DTValues"}], "//", "Flatten"}], "//", 
               "Last"}], "\[IndentingNewLine]", ")"}]}], "]"}], "//", 
           "Flatten"}], "//", "First"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Position", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"dat", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "\"\<Time / s\>\""}], "]"}], "]"}], 
                ")"}], "//", "DTValues"}], "//", "Flatten"}], ",", 
             RowBox[{"region", "[", 
              RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "//", "Flatten"}], "//",
           "First"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"TmpDat", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"dat", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{
             RowBox[{"ToString", "[", "ID1", "]"}], ";;", 
             RowBox[{"ToString", "[", "ID2", "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"\"\<Time / s\>\"", ",", "\"\<CO2(ppm)\>\""}], "}"}]}], 
           "]"}], "]"}], ")"}], "//", "DTValues"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"TmpDat", "=", 
       RowBox[{"DeleteDuplicates", "[", 
        RowBox[{"TmpDat", ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"#1", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "\[Equal]", 
            RowBox[{"#2", "[", 
             RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "&"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Areas", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"(", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"F", "=", 
            RowBox[{"Interpolation", "[", 
             RowBox[{
              RowBox[{"TmpDat", "//", "RandomData"}], ",", 
              RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"NIntegrate", "[", 
            RowBox[{
             RowBox[{"F", "[", "t", "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"t", ",", 
               RowBox[{"Min", "@", 
                RowBox[{"TmpDat", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ",", 
               RowBox[{"Max", "@", 
                RowBox[{"TmpDat", "[", 
                 RowBox[{"[", 
                  RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "}"}], ",", 
             RowBox[{"Method", "\[Rule]", "\"\<LocalAdaptive\>\""}]}], 
            "]"}]}], "\[IndentingNewLine]", ")"}], ",", 
         RowBox[{"{", "iterations", "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"EV", "[", 
       RowBox[{
        RowBox[{"(", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"F", "=", 
           RowBox[{"Interpolation", "[", 
            RowBox[{
             RowBox[{"TmpDat", "//", "EVValues"}], ",", 
             RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"NIntegrate", "[", 
           RowBox[{
            RowBox[{"F", "[", "t", "]"}], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", 
              RowBox[{"Min", "@", 
               RowBox[{"TmpDat", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "1"}], "]"}], "]"}]}], ",", 
              RowBox[{"Max", "@", 
               RowBox[{"TmpDat", "[", 
                RowBox[{"[", 
                 RowBox[{"All", ",", "1"}], "]"}], "]"}]}]}], "}"}], ",", 
            RowBox[{"Method", "\[Rule]", "\"\<LocalAdaptive\>\""}]}], "]"}]}],
          "\[IndentingNewLine]", ")"}], ",", 
        RowBox[{"StandardDeviation", "[", "Areas", "]"}]}], "]"}]}], 
     "\[IndentingNewLine]", ")"}]}], "\[IndentingNewLine]", "]"}]}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["End private context", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["End package", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowSize->{1680, 946},
WindowMargins->{{Automatic, -1688}, {Automatic, -8}},
DockedCells->FEPrivate`FrontEndResource["FEExpressions", "PackageToolbar"],
FrontEndVersion->"11.1 for Microsoft Windows (64-bit) (March 13, 2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Null"->{
  Cell[9118, 308, 44, 1, 
  49, "Section", "ExpressionUUID" -> "2e3579e2-0409-406b-bd5a-e547ec3754c6",
   CellTags->"Null"],
  Cell[46910, 1273, 53, 1, 
  43, "Subsection", "ExpressionUUID" -> "f6038b44-ec72-41a8-b2e9-2764565eb895",
   CellTags->"Null"],
  Cell[71794, 1918, 41, 1, 
  49, "Section", "ExpressionUUID" -> "dad60ba6-e139-4d48-ba27-02e22188e14d",
   CellTags->"Null"],
  Cell[71860, 1923, 81, 1, 
  43, "Subsection", "ExpressionUUID" -> "41d4b73c-d6eb-4954-acbc-35a2420ca4e2",
   CellTags->"Null"],
  Cell[79861, 2146, 69, 1, 
  43, "Subsection", "ExpressionUUID" -> "bc9b7ead-03fd-4c4e-823c-eb1a006273b0",
   CellTags->"Null"],
  Cell[88101, 2363, 57, 1, 
  43, "Subsection", "ExpressionUUID" -> "c4a1a33c-7074-436e-95e1-2f1fb9b70cd6",
   CellTags->"Null"],
  Cell[103630, 2781, 50, 1, 
  49, "Section", "ExpressionUUID" -> "fbd9cc4e-0834-4a5b-b31a-e8585be46068",
   CellTags->"Null"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Null", 117679, 3171}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 27, 0, 90, "Title", "ExpressionUUID" -> \
"0dcbbad5-7ad6-4884-a7ae-28d9feb9ef27"],
Cell[CellGroupData[{
Cell[631, 26, 32, 0, 63, "Section", "ExpressionUUID" -> \
"92e4d9ac-d359-458e-8fe9-a5a4d576fd6e"],
Cell[666, 28, 267, 7, 85, "Input", "ExpressionUUID" -> \
"4a38a8fb-13d7-48f7-8bfb-587db145b8e2",
 InitializationCell->True],
Cell[936, 37, 184, 5, 49, "Input", "ExpressionUUID" -> \
"b82cf0c9-5ea1-49ae-8645-dbc60646c06e",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[1157, 47, 27, 0, 63, "Section", "ExpressionUUID" -> \
"1f22a828-c808-4cb1-8ca6-88da7b8df600"],
Cell[CellGroupData[{
Cell[1209, 51, 31, 0, 43, "Subsection", "ExpressionUUID" -> \
"1ccd59e8-9da5-4e83-a56c-d69732304845"],
Cell[1243, 53, 275, 7, 46, "Input", "ExpressionUUID" -> \
"df1c7474-06a1-413b-906e-9577b501d564",
 InitializationCell->True],
Cell[1521, 62, 6111, 178, 1038, "Input", "ExpressionUUID" -> \
"5e46a05f-15ad-488c-ae0e-ec28aa1aba0c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7669, 245, 29, 0, 43, "Subsection", "ExpressionUUID" -> \
"17d6cebc-f119-41a6-b1b8-517722fa8a28"],
Cell[7701, 247, 53, 1, 46, "Input", "ExpressionUUID" -> \
"f0a8ab9b-fec5-4dc1-9350-9d0a01ecedb4",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[7791, 253, 28, 0, 43, "Subsection", "ExpressionUUID" -> \
"ef5abdac-db60-4bfe-9aec-6b762b78314c"],
Cell[7822, 255, 53, 1, 46, "Input", "ExpressionUUID" -> \
"72ff9246-e439-4c9a-a6a2-6e9e70d260b7",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7924, 262, 40, 0, 63, "Section", "ExpressionUUID" -> \
"88a09396-1e4d-4d9b-b940-06b85114be63"],
Cell[7967, 264, 119, 3, 40, "Input", "ExpressionUUID" -> \
"4f7f04aa-8e34-4ddf-b9aa-ff23f74bc182",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[8123, 272, 33, 0, 49, "Section", "ExpressionUUID" -> \
"65566600-c1ca-4935-b389-6e1426af32af"],
Cell[8159, 274, 552, 15, 114, "Input", "ExpressionUUID" -> \
"4239b080-0758-4134-afee-6a5cdbc282bd",
 InitializationCell->True],
Cell[8714, 291, 367, 12, 46, "Input", "ExpressionUUID" -> \
"8839e2e6-6dea-44c2-84be-24c1d5b31f99",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[9118, 308, 44, 1, 49, "Section", "ExpressionUUID" -> \
"2e3579e2-0409-406b-bd5a-e547ec3754c6",
 CellTags->"Null"],
Cell[CellGroupData[{
Cell[9187, 313, 35, 0, 43, "Subsection", "ExpressionUUID" -> \
"b9355dd6-49d0-41c3-ba63-a5eeff1c4496"],
Cell[9225, 315, 4716, 120, 503, "Input", "ExpressionUUID" -> \
"a7e1d227-3b5f-4772-94b9-6f365913763a",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[13978, 440, 32, 0, 43, "Subsection", "ExpressionUUID" -> \
"b3f20138-00e5-4639-b7a4-e38dac918dd2"],
Cell[14013, 442, 9613, 225, 845, "Input", "ExpressionUUID" -> \
"0d25fd2f-6b90-49a6-a285-c98b7697dc74",
 InitializationCell->True],
Cell[23629, 669, 1431, 36, 256, "Input", "ExpressionUUID" -> \
"474b39b6-20ea-4b86-a044-504f577fbb12",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[25097, 710, 29, 0, 35, "Subsection", "ExpressionUUID" -> \
"0accdfd7-15cb-4baa-a5c5-b210b0f6aa45"],
Cell[25129, 712, 3819, 94, 408, "Input", "ExpressionUUID" -> \
"2232d547-934b-4fbf-933e-3db8e652b49d",
 InitializationCell->True],
Cell[28951, 808, 14649, 367, 1143, "Input", "ExpressionUUID" -> \
"52e56ee2-4249-4bb5-8e0a-3356b8d2f2db",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43649, 1181, 23, 0, 63, "Section", "ExpressionUUID" -> \
"b94235c1-c8bd-4a6e-a915-1b3f60ddc469"],
Cell[CellGroupData[{
Cell[43697, 1185, 28, 0, 43, "Subsection", "ExpressionUUID" -> \
"7f907b57-2e24-4e9d-b7f6-935678dfb561"],
Cell[43728, 1187, 3086, 76, 370, "Input", "ExpressionUUID" -> \
"b448e867-6952-4e93-9343-8668871103a6",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[46863, 1269, 22, 0, 63, "Section", "ExpressionUUID" -> \
"73d128ed-2d7b-4a30-9f44-4b07bd461eff"],
Cell[CellGroupData[{
Cell[46910, 1273, 53, 1, 43, "Subsection", "ExpressionUUID" -> \
"f6038b44-ec72-41a8-b2e9-2764565eb895",
 CellTags->"Null"],
Cell[46966, 1276, 4178, 101, 446, "Input", "ExpressionUUID" -> \
"b619dd42-743a-456a-9b64-c7f9b87fa86d",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[51193, 1383, 36, 0, 63, "Section", "ExpressionUUID" -> \
"81d24876-1e0f-427c-b13b-72c1dd820a17"],
Cell[CellGroupData[{
Cell[51254, 1387, 28, 0, 43, "Subsection", "ExpressionUUID" -> \
"be5bf4db-1c11-417d-afc3-2002c521df20"],
Cell[51285, 1389, 3161, 80, 370, "Input", "ExpressionUUID" -> \
"daeb9bcd-f802-43cc-a585-f0c819919fda",
 InitializationCell->True],
Cell[54449, 1471, 1387, 35, 256, "Input", "ExpressionUUID" -> \
"fdc50818-c4e4-4f5d-b96b-cc0c95e2e9ad",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[55885, 1512, 35, 0, 49, "Section", "ExpressionUUID" -> \
"e3591e74-4fe1-42e2-b07b-364a745a244b"],
Cell[55923, 1514, 3178, 79, 413, "Input", "ExpressionUUID" -> \
"e54d071b-0f24-4974-bddf-1e979fc7c092",
 InitializationCell->True],
Cell[59104, 1595, 2290, 60, 233, "Input", "ExpressionUUID" -> \
"bc870a2e-72ae-4f8d-80dc-7d2e708f8662",
 InitializationCell->True],
Cell[61397, 1657, 5041, 124, 653, "Input", "ExpressionUUID" -> \
"e7a4cda5-ac6b-4dff-9b8a-1dda72d5622f",
 InitializationCell->True],
Cell[66441, 1783, 5316, 130, 784, "Input", "ExpressionUUID" -> \
"dab93bdf-a29d-4baf-a710-8fb7fb73c62f",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[71794, 1918, 41, 1, 49, "Section", "ExpressionUUID" -> \
"dad60ba6-e139-4d48-ba27-02e22188e14d",
 CellTags->"Null"],
Cell[CellGroupData[{
Cell[71860, 1923, 81, 1, 43, "Subsection", "ExpressionUUID" -> \
"41d4b73c-d6eb-4954-acbc-35a2420ca4e2",
 CellTags->"Null"],
Cell[71944, 1926, 2579, 69, 327, "Input", "ExpressionUUID" -> \
"5e483443-1e29-4916-a652-562ba1ca0640",
 InitializationCell->True],
Cell[74526, 1997, 2258, 60, 327, "Input", "ExpressionUUID" -> \
"ea7a76cc-b0b3-4ca6-a439-e06dad07987c",
 InitializationCell->True],
Cell[76787, 2059, 1626, 43, 270, "Input", "ExpressionUUID" -> \
"b0b6249e-1419-4da3-9fad-91ded3a0821b",
 InitializationCell->True],
Cell[78416, 2104, 1408, 37, 235, "Input", "ExpressionUUID" -> \
"d3f32274-c7bd-4d9a-ade4-020735ca1930",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[79861, 2146, 69, 1, 43, "Subsection", "ExpressionUUID" -> \
"bc9b7ead-03fd-4c4e-823c-eb1a006273b0",
 CellTags->"Null"],
Cell[79933, 2149, 800, 20, 172, "Input", "ExpressionUUID" -> \
"4152f61c-8d88-426c-9f9f-af7a8ffde1d5",
 InitializationCell->True],
Cell[80736, 2171, 4353, 105, 495, "Input", "ExpressionUUID" -> \
"717192bf-5fd3-4c03-8af3-e4a392354e8f",
 InitializationCell->True],
Cell[85092, 2278, 1214, 34, 132, "Input", "ExpressionUUID" -> \
"350324c1-6420-40b4-ad6b-3e1df9209f07",
 InitializationCell->True],
Cell[86309, 2314, 1755, 44, 212, "Input", "ExpressionUUID" -> \
"fbe8e269-391b-4c06-a9e0-c8dd8f9ffc19",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[88101, 2363, 57, 1, 43, "Subsection", "ExpressionUUID" -> \
"c4a1a33c-7074-436e-95e1-2f1fb9b70cd6",
 CellTags->"Null"],
Cell[88161, 2366, 6631, 164, 772, "Input", "ExpressionUUID" -> \
"5c92c832-349b-4b06-96d3-36df2d85c668",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[94829, 2535, 36, 0, 35, "Subsection", "ExpressionUUID" -> \
"249c0bd7-0971-49cb-b342-d419e738f988"],
Cell[94868, 2537, 3960, 105, 112, "Input", "ExpressionUUID" -> \
"0bedacc4-dc9d-4bc2-b2ec-47115a87a7b9",
 InitializationCell->True],
Cell[98831, 2644, 2127, 60, 172, "Input", "ExpressionUUID" -> \
"f3912d4e-d2d2-4cfa-8ebc-8608d3eb230e",
 InitializationCell->True],
Cell[100961, 2706, 2620, 69, 292, "Input", "ExpressionUUID" -> \
"0515fbc7-25f6-4d03-a2d5-fafb8f7203cc",
 InitializationCell->True]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[103630, 2781, 50, 1, 49, "Section", "ExpressionUUID" -> \
"fbd9cc4e-0834-4a5b-b31a-e8585be46068",
 CellTags->"Null"],
Cell[103683, 2784, 1568, 43, 192, "Input", "ExpressionUUID" -> \
"d71a49be-ea05-4dc6-9a4e-9b1480701320",
 InitializationCell->True],
Cell[105254, 2829, 2697, 73, 332, "Input", "ExpressionUUID" -> \
"fcb8d733-8b5f-4fb4-ad00-4a87703b8de3",
 InitializationCell->True],
Cell[107954, 2904, 2886, 76, 292, "Input", "ExpressionUUID" -> \
"0a3266ac-6c3c-4e95-82c0-c9b509891617",
 InitializationCell->True],
Cell[110843, 2982, 5918, 149, 512, "Input", "ExpressionUUID" -> \
"5ac9249c-e14a-4807-a580-2b29a0597676",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[116798, 3136, 38, 0, 49, "Section", "ExpressionUUID" -> \
"b64cb8c8-32dd-4c66-9782-057a50ec96f7"],
Cell[116839, 3138, 96, 3, 40, "Input", "ExpressionUUID" -> \
"5d3dc4c1-c579-483b-a585-4a20a983b6af",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[116972, 3146, 30, 0, 49, "Section", "ExpressionUUID" -> \
"d9a27aa4-b020-46e5-b77d-815e7f725b88"],
Cell[117005, 3148, 244, 7, 68, "Input", "ExpressionUUID" -> \
"addbfcea-e734-4b75-a7b4-031d099be0f6",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

