(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     40996,       1172]
NotebookOptionsPosition[     32721,       1017]
NotebookOutlinePosition[     34723,       1062]
CellTagsIndexPosition[     34680,       1059]
WindowTitle->DataAnalysis Package
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE GUIDE", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Functions",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Functions", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CalibrateCompositionalData\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/CalibrateCompositionalData"], \
"\<\"CalibrationPlot\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/CalibrationPlot"], "\<\"ChemElementName\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/ChemElementName"], "\<\"ColNames\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/ColNames"], "\<\"ConvertComps\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/ConvertComps"], "\<\"Dataset\"\>":>
       Documentation`HelpLookup["paclet:ref/Dataset"], "\<\"DataTable\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DataTable"], "\<\"DTPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DTPlot"], "\<\"DV\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DV"], "\<\"DVEvaluate\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVEvaluate"], "\<\"DVMeans\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVMeans"], "\<\"DVSEs\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVSEs"], "\<\"EffectiveVarianceFit\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/EffectiveVarianceFit"], "\<\"Fig\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/Fig"], "\<\"FigColumn\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/FigColumn"], "\<\"FigGrid\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/FigGrid"], "\<\"FoldValues\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/FoldValues"], "\<\"FV\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/FV"], "\<\"GroupByKey\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/GroupByKey"], "\<\"ImportDataTable\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/ImportDataTable"], "\<\"IV\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/IV"], "\<\"JoinT\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/JoinT"], "\<\"KeyExcept\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/KeyExcept"], "\<\"KeyFind\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/KeyFind"], "\<\"MassFractionTomMolality\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassFractionTomMolality"], \
"\<\"MassFractionToMolality\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassFractionToMolality"], \
"\<\"MassToMoles\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassToMoles"], "\<\"MCEvaluate\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MCEvaluate"], "\<\"MeanAndStandardDeviation\"\
\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MeanAndStandardDeviation"], \
"\<\"MeanAndStandardError\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MeanAndStandardError"], \
"\<\"MinFormulaCations\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MinFormulaCations"], \
"\<\"MolalityToMassFraction\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolalityToMassFraction"], \
"\<\"MolalityToPpm\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolalityToPpm"], "\<\"MolarMass\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolarMass"], "\<\"MolesToMass\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolesToMass"], "\<\"MonteCarloSimulation\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MonteCarloSimulation"], "\<\"NDV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/NDV"], "\<\"NK\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/NK"], "\<\"NumericDVQ\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/NumericDVQ"], "\<\"NV\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/NV"], "\<\"PartitionAssociation\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PartitionAssociation"], "\<\"PhreeqcCloseLink\
\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcCloseLink"], "\<\"PhreeqcLoadDB\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcLoadDB"], "\<\"PhreeqcOpenLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcOpenLink"], "\<\"PhreeqcRunFile\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcRunFile"], "\<\"PhreeqcRunString\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcRunString"], "\<\"PpmTomMolality\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PpmTomMolality"], "\<\"PpmToMolality\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PpmToMolality"], "\<\"QueryTo\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/QueryTo"], "\<\"RegisterComp\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterComp"], "\<\"RegisterOxide\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterOxide"], \
"\<\"RemoveNonDetectableValues\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RemoveNonDetectableValues"], \
"\<\"ReplaceDatum\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/ReplaceDatum"], "\<\"SciDrawPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SciDrawPlot"], \
"\<\"SSBCalculateCalibrationFit\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SSBCalculateCalibrationFit"], \
"\<\"SSBCalculateDeltas\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SSBCalculateDeltas"], \
"\<\"SSBCalculateMeanRatios\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SSBCalculateMeanRatios"], \
"\<\"SSBSubstractBlanks\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SSBSubstractBlanks"], "\<\"ToArray\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/ToArray"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideFunction"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Tutorials",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Tutorials", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"Examples\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/tutorial/Examples"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideTutorial"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/guide/Overview\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/guide/Overview"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/guide/\
Overview.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$9091], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/guide/Overview", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["DataAnalysis Package", "GuideTitle",
 CellID->942062912],

Cell[TextData[{
 "DataAnalysis is a free package for Wolfram Mathematica which provides \
functions for uncertainty propagation and extended data table operations. It \
also allows processing of chemical analyses of various sorts (import, \
calibration, ...) and the conversion of compositions between different sets \
of components. Furthermore, the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PHREEQC"]],
    "https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"},
   "WebLink",
   BaseStyle->{"GuideAbstract"}]]],
 " software package can be run using this package, allowing thermodynamic and \
kinetic calculations in natural aquatic systems."
}], "GuideAbstract",
 CellID->2001916300],

Cell["\<\
Below you can find an overview over the basic functions provided by the \
package and links to their detailed documentation.\
\>", "GuideAbstract",
 CellID->543854311]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Reference"
}], "GuideReferenceSection",
 WholeCellGroupOpener->True],

Cell["", "SectionHeaderSpacer"],

Cell[CellGroupData[{

Cell["Data processing & uncertainty propagation", "GuideFunctionsSubsection",
 CellID->26100144],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Extends the ",
 ButtonBox["Dataset",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Dataset"],
 " type with several features"
}], "GuideText",
 CellID->203374175],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Propagation of uncertainties in ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " values using linearizations"
}], "GuideText",
 CellID->748647436],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["EffectiveVarianceFit"]],
    "paclet:DataAnalysis/ref/EffectiveVarianceFit"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Effective variance fit using uncertainties in all variables"
}], "GuideText",
 CellID->33086723],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Propagation of uncertainties in ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " values using Monte Carlo simulations"
}], "GuideText",
 CellID->1205267],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Analysis of uncertainties using Monte Carlo simulations"
}], "GuideText",
 CellID->3833630],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["$UsePlusMinusForm"]],
    "paclet:DataAnalysis/ref/$UsePlusMinusForm"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ColNames"]],"paclet:DataAnalysis/ref/ColNames"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVMeans"]],"paclet:DataAnalysis/ref/DVMeans"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVSEs"]],"paclet:DataAnalysis/ref/DVSEs"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FV"]],"paclet:DataAnalysis/ref/FV"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FoldValues"]],"paclet:DataAnalysis/ref/FoldValues"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GroupByKey"]],"paclet:DataAnalysis/ref/GroupByKey"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["IV"]],"paclet:DataAnalysis/ref/IV"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["JoinT"]],"paclet:DataAnalysis/ref/JoinT"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["KeyExcept"]],"paclet:DataAnalysis/ref/KeyExcept"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["KeyFind"]],"paclet:DataAnalysis/ref/KeyFind"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MeanAndStandardDeviation"]],
    "paclet:DataAnalysis/ref/MeanAndStandardDeviation"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MeanAndStandardError"]],
    "paclet:DataAnalysis/ref/MeanAndStandardError"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NK"]],"paclet:DataAnalysis/ref/NK"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NV"]],"paclet:DataAnalysis/ref/NV"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NumericDVQ"]],"paclet:DataAnalysis/ref/NumericDVQ"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PartitionAssociation"]],
    "paclet:DataAnalysis/ref/PartitionAssociation"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QueryTo"]],"paclet:DataAnalysis/ref/QueryTo"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ReplaceDatum"]],"paclet:DataAnalysis/ref/ReplaceDatum"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ToArray"]],"paclet:DataAnalysis/ref/ToArray"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"]
}], "InlineGuideFunctionListing",
 CellID->51779591]
}, Open  ]],

Cell["\t", "GuideDelimiterSubsection",
 CellID->20659147],

Cell[CellGroupData[{

Cell["Plotting", "GuideFunctionsSubsection",
 CellID->35756497],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DTPlot"]],"paclet:DataAnalysis/ref/DTPlot"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Plots from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " objects"
}], "GuideText",
 CellID->1463276848],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Fig"]],"paclet:DataAnalysis/ref/Fig"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Creates a data figure using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDraw"]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"GuideText"}]]],
 " package"
}], "GuideText",
 CellID->192628548],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigColumn"]],"paclet:DataAnalysis/ref/FigColumn"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Creates a data plot column using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDraw"]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"GuideText"}]]],
 " package"
}], "GuideText",
 CellID->261826293],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigGrid"]],"paclet:DataAnalysis/ref/FigGrid"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Creates a data plot grid using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDraw"]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"GuideText"}]]],
 " package"
}], "GuideText",
 CellID->175492473],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDrawPlot"]],"paclet:DataAnalysis/ref/SciDrawPlot"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Creates a data plot using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDraw"]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"GuideText"}]]],
 " package"
}], "GuideText",
 CellID->241967199]
}, Open  ]],

Cell["\t", "GuideDelimiterSubsection",
 CellID->311258892],

Cell[CellGroupData[{

Cell["Compositional analysis", "GuideFunctionsSubsection",
 CellID->742249250],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrateCompositionalData"]],
    "paclet:DataAnalysis/ref/CalibrateCompositionalData"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Processes chemical analyses & calibrates the data"
}], "GuideText",
 CellID->57133475],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrationPlot"]],"paclet:DataAnalysis/ref/CalibrationPlot"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Plots the calibration curves for chemical analyses"
}], "GuideText",
 CellID->469400672],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ImportDataTable"]],"paclet:DataAnalysis/ref/ImportDataTable"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Import data from special formats"
}], "GuideText",
 CellID->157488116],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SSBCalculateCalibrationFit"]],
    "paclet:DataAnalysis/ref/SSBCalculateCalibrationFit"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Processes Sample-Standard-Bracketing analyses"
}], "GuideText",
 CellID->60814895],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SSBCalculateMeanRatios"]],
    "paclet:DataAnalysis/ref/SSBCalculateMeanRatios"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Processes Sample-Standard-Bracketing analyses"
}], "GuideText",
 CellID->310180832],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SSBCalculateDeltas"]],
    "paclet:DataAnalysis/ref/SSBCalculateDeltas"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Processes Sample-Standard-Bracketing analyses"
}], "GuideText",
 CellID->328840264],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SSBSubstractBlanks"]],
    "paclet:DataAnalysis/ref/SSBSubstractBlanks"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Processes Sample-Standard-Bracketing analyses"
}], "GuideText",
 CellID->461236771],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["RemoveNonDetectableValues"]],
   "paclet:DataAnalysis/ref/RemoveNonDetectableValues"},
  "RefLink",
  BaseStyle->
   "InlineFunctionSans"]], "InlineFunctionSans"]], \
"InlineGuideFunctionListing",
 CellID->407856725]
}, Open  ]],

Cell["\t", "GuideDelimiterSubsection",
 CellID->115925423],

Cell[CellGroupData[{

Cell["(Geo)Chemical calculations", "GuideFunctionsSubsection",
 CellID->72464118],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ConvertComps"]],"paclet:DataAnalysis/ref/ConvertComps"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Convert chemical compositions to a different set of component"
}], "GuideText",
 CellID->363568060],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassFractionToMolality"]],
    "paclet:DataAnalysis/ref/MassFractionToMolality"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Convert mass fractions to molalities"
}], "GuideText",
 CellID->214028878],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassToMoles"]],"paclet:DataAnalysis/ref/MassToMoles"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Convert masses to moles"
}], "GuideText",
 CellID->345393473],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MinFormulaCations"]],
    "paclet:DataAnalysis/ref/MinFormulaCations"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Calculate mineral formulas"
}], "GuideText",
 CellID->81710881],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolalityToMassFraction"]],
    "paclet:DataAnalysis/ref/MolalityToMassFraction"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Convert molalities to mass fractions"
}], "GuideText",
 CellID->80385647],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Get molar mass for a chemical species"
}], "GuideText",
 CellID->402664676],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolesToMass"]],"paclet:DataAnalysis/ref/MolesToMass"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Convert moles to masses"
}], "GuideText",
 CellID->47143776],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Register a chemical component for later use"
}], "GuideText",
 CellID->126573758],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Register an oxide for later use"
}], "GuideText",
 CellID->176009990],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ChemElementName"]],"paclet:DataAnalysis/ref/ChemElementName"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassFractionTomMolality"]],
    "paclet:DataAnalysis/ref/MassFractionTomMolality"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolalityToPpm"]],"paclet:DataAnalysis/ref/MolalityToPpm"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PpmToMolality"]],"paclet:DataAnalysis/ref/PpmToMolality"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PpmTomMolality"]],"paclet:DataAnalysis/ref/PpmTomMolality"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"]
}], "InlineGuideFunctionListing",
 CellID->741249426]
}, Open  ]],

Cell["\t", "GuideDelimiterSubsection",
 CellID->35390670],

Cell[CellGroupData[{

Cell["PHREEQC", "GuideFunctionsSubsection",
 CellID->85367335],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PHREEQC"]],
    "https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"},
   "WebLink",
   BaseStyle->{"GuideText"}]]],
 " is a computer program created by the USGS for thermodynamic and kinetic \
calculations with aqueous solutionss and minerals. The DataAnalysis package \
allows to run PHREEQC scripts from within Mathematica."
}], "GuideText",
 CellID->73093420],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcCloseLink"]],"paclet:DataAnalysis/ref/PhreeqcCloseLink"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Close a link to PHREEQC"
}], "GuideText",
 CellID->475623267],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcLoadDB"]],"paclet:DataAnalysis/ref/PhreeqcLoadDB"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Load a PHREEQC database file"
}], "GuideText",
 CellID->194393605],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcOpenLink"]],"paclet:DataAnalysis/ref/PhreeqcOpenLink"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Open a link to PHREEQC"
}], "GuideText",
 CellID->516539662],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunFile"]],"paclet:DataAnalysis/ref/PhreeqcRunFile"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Run a file as PHREEQC script"
}], "GuideText",
 CellID->457910155],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunString"]],"paclet:DataAnalysis/ref/PhreeqcRunString"},
   "RefLink",
   BaseStyle->"InlineFunctionSans"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " Run a string as PHREEQC script"
}], "GuideText",
 CellID->82280193]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DataAnalysis Package",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Wolfram Language", ButtonData -> "paclet:guide/WolframRoot", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 35, 48.9861911}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Guide", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "DataAnalysis is a free package for Wolfram Mathematica which provides \
functions for uncertainty propagation and extended data table operations. It \
also allows processing of chemical analyses of various sorts (import, \
calibration, ...) and the conversion of compositions between different sets \
of components. Furthermore, the PHREEQC software package can be run using \
this package, allowing thermodynamic and kinetic calculations in natural \
aquatic systems.", "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$8920, "title" -> 
    "DataAnalysis Package", "titlemodifier" -> "", "windowtitle" -> 
    "DataAnalysis Package", "type" -> "Guide", "uri" -> 
    "DataAnalysis/guide/Overview"}},
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "UTF-8"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 9656, 203, 70, "AnchorBarGrid",ExpressionUUID->"00a8ac6a-e60f-4b66-95bf-0ba14f8ba19c",
 CellID->1],
Cell[CellGroupData[{
Cell[10273, 228, 62, 1, 70, "GuideTitle",ExpressionUUID->"db68bde7-8bd8-49ea-b8e8-798444fcf608",
 CellID->942062912],
Cell[10338, 231, 703, 15, 70, "GuideAbstract",ExpressionUUID->"8f5d135f-5bfd-4ac3-9c51-aa8dd2cc337e",
 CellID->2001916300],
Cell[11044, 248, 177, 4, 70, "GuideAbstract",ExpressionUUID->"00f8ff37-096f-4fad-b55f-ceb172f05b08",
 CellID->543854311]
}, Open  ]],
Cell[CellGroupData[{
Cell[11258, 257, 137, 6, 70, "GuideReferenceSection",ExpressionUUID->"ba1d7ebe-34a0-41ed-8d03-3f35a2004319"],
Cell[11398, 265, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"2dadf987-e32e-409c-94e5-81927e9e53a6"],
Cell[CellGroupData[{
Cell[11454, 269, 96, 1, 70, "GuideFunctionsSubsection",ExpressionUUID->"604c1dc5-6e26-409c-828e-7c35db5ab639",
 CellID->26100144],
Cell[11553, 272, 405, 14, 70, "GuideText",ExpressionUUID->"5722224d-61f8-409f-8c91-2e8df57fc9a3",
 CellID->203374175],
Cell[11961, 288, 686, 22, 70, "GuideText",ExpressionUUID->"fd5b6def-e252-4d55-aae1-5113e7ec94cb",
 CellID->748647436],
Cell[12650, 312, 366, 11, 70, "GuideText",ExpressionUUID->"a6dea859-1162-46af-93d9-47510e86d649",
 CellID->33086723],
Cell[13019, 325, 520, 16, 70, "GuideText",ExpressionUUID->"e7dfabff-0ad2-4051-9688-c08a16b4d449",
 CellID->1205267],
Cell[13542, 343, 361, 11, 70, "GuideText",ExpressionUUID->"ab6b7c41-12c6-4860-a246-6d1c3f2864ff",
 CellID->3833630],
Cell[13906, 356, 6466, 200, 70, "InlineGuideFunctionListing",ExpressionUUID->"0c101092-c2f0-405a-a3df-385cc66a71be",
 CellID->51779591]
}, Open  ]],
Cell[20387, 559, 57, 1, 70, "GuideDelimiterSubsection",ExpressionUUID->"2e717380-1934-4424-b28d-99e530feadf0",
 CellID->20659147],
Cell[CellGroupData[{
Cell[20469, 564, 63, 1, 70, "GuideFunctionsSubsection",ExpressionUUID->"35996867-c847-4bf9-bf02-f02251533c55",
 CellID->35756497],
Cell[20535, 567, 477, 16, 70, "GuideText",ExpressionUUID->"be093871-4751-49c7-96db-e1301c78fa35",
 CellID->1463276848],
Cell[21015, 585, 450, 16, 70, "GuideText",ExpressionUUID->"89972821-24e7-4e84-a076-722553dc43eb",
 CellID->192628548],
Cell[21468, 603, 467, 16, 70, "GuideText",ExpressionUUID->"b8dbfc45-dc52-4c9d-b2fc-56c2cfaf6017",
 CellID->261826293],
Cell[21938, 621, 461, 16, 70, "GuideText",ExpressionUUID->"3ceeab21-a1b1-4399-85a9-0c8c5dec6e5b",
 CellID->175492473],
Cell[22402, 639, 464, 16, 70, "GuideText",ExpressionUUID->"26b75c6c-e35e-4973-b8a7-65c5eda6fd26",
 CellID->241967199]
}, Open  ]],
Cell[22881, 658, 58, 1, 70, "GuideDelimiterSubsection",ExpressionUUID->"03fb6e97-acb3-4a8d-8957-cbeb9adef3f9",
 CellID->311258892],
Cell[CellGroupData[{
Cell[22964, 663, 78, 1, 70, "GuideFunctionsSubsection",ExpressionUUID->"48fc4003-e977-4b04-9b15-0110d188ff72",
 CellID->742249250],
Cell[23045, 666, 368, 11, 70, "GuideText",ExpressionUUID->"0e8bd48c-d209-425d-a2d7-30acdce862ba",
 CellID->57133475],
Cell[23416, 679, 343, 10, 70, "GuideText",ExpressionUUID->"658c506e-43d2-4178-a5d3-8545adda8831",
 CellID->469400672],
Cell[23762, 691, 325, 10, 70, "GuideText",ExpressionUUID->"dd67ad17-7792-4b0c-9985-26f1a5939432",
 CellID->157488116],
Cell[24090, 703, 364, 11, 70, "GuideText",ExpressionUUID->"c0459846-c58d-4214-a3cd-1a997832b7ab",
 CellID->60814895],
Cell[24457, 716, 357, 11, 70, "GuideText",ExpressionUUID->"2957f057-389e-4728-b0e6-c537c39a1ee9",
 CellID->310180832],
Cell[24817, 729, 349, 11, 70, "GuideText",ExpressionUUID->"edfef8af-d829-4968-a822-16461c42c052",
 CellID->328840264],
Cell[25169, 742, 349, 11, 70, "GuideText",ExpressionUUID->"802fb6e1-72ae-4447-be79-1643dd29fd2f",
 CellID->461236771],
Cell[25521, 755, 278, 8, 70, "InlineGuideFunctionListing",ExpressionUUID->"4436b7cd-6377-4687-8b77-053a84e9f17c",
 CellID->407856725]
}, Open  ]],
Cell[25814, 766, 58, 1, 70, "GuideDelimiterSubsection",ExpressionUUID->"4795fcfd-03e3-4e84-8092-b389b0f561b0",
 CellID->115925423],
Cell[CellGroupData[{
Cell[25897, 771, 81, 1, 70, "GuideFunctionsSubsection",ExpressionUUID->"5fe30310-f765-42b1-8b69-e9760b2383ef",
 CellID->72464118],
Cell[25981, 774, 348, 10, 70, "GuideText",ExpressionUUID->"555b05c8-0b48-4315-92a5-4c587ed04aff",
 CellID->363568060],
Cell[26332, 786, 348, 11, 70, "GuideText",ExpressionUUID->"bddb5dfd-631c-4768-a1d0-a08c718cbcfe",
 CellID->214028878],
Cell[26683, 799, 308, 10, 70, "GuideText",ExpressionUUID->"fdf83887-7c71-4718-b7df-5ecf1fab022b",
 CellID->345393473],
Cell[26994, 811, 327, 11, 70, "GuideText",ExpressionUUID->"b530b895-6420-4350-8b88-c2c0087db18f",
 CellID->81710881],
Cell[27324, 824, 347, 11, 70, "GuideText",ExpressionUUID->"4ac03bf0-53b8-43e9-ba5c-ef19e2dbd410",
 CellID->80385647],
Cell[27674, 837, 318, 10, 70, "GuideText",ExpressionUUID->"0240fc2c-4376-428f-b598-9a1680f968ac",
 CellID->402664676],
Cell[27995, 849, 307, 10, 70, "GuideText",ExpressionUUID->"413558f4-1fae-4710-b402-aba111bcd8d6",
 CellID->47143776],
Cell[28305, 861, 330, 10, 70, "GuideText",ExpressionUUID->"0edc1a11-4288-48cf-b3ed-f8c0966c7dd1",
 CellID->126573758],
Cell[28638, 873, 320, 10, 70, "GuideText",ExpressionUUID->"d17a12ef-d459-41c8-a870-b45cc95da310",
 CellID->176009990],
Cell[28961, 885, 1500, 44, 70, "InlineGuideFunctionListing",ExpressionUUID->"c68c76eb-7260-4f31-90b9-b46d8beca750",
 CellID->741249426]
}, Open  ]],
Cell[30476, 932, 57, 1, 70, "GuideDelimiterSubsection",ExpressionUUID->"5b538a0f-fb39-4ec9-80d9-52db11879a05",
 CellID->35390670],
Cell[CellGroupData[{
Cell[30558, 937, 62, 1, 70, "GuideFunctionsSubsection",ExpressionUUID->"35875d66-7ac7-49ad-971b-89fd644eca2a",
 CellID->85367335],
Cell[30623, 940, 436, 11, 70, "GuideText",ExpressionUUID->"081f87d0-a742-492f-acd6-0421f2ef2cdf",
 CellID->73093420],
Cell[31062, 953, 318, 10, 70, "GuideText",ExpressionUUID->"594a969c-af3c-42d2-add9-3b7f79d9f47c",
 CellID->475623267],
Cell[31383, 965, 317, 10, 70, "GuideText",ExpressionUUID->"a8ac1557-b9f1-4c85-9f60-a914b9bbcce8",
 CellID->194393605],
Cell[31703, 977, 315, 10, 70, "GuideText",ExpressionUUID->"805aee7a-7677-4872-a5e7-58ed2ff57d7f",
 CellID->516539662],
Cell[32021, 989, 319, 10, 70, "GuideText",ExpressionUUID->"81b5db00-9564-4149-bbf6-74bbf214c89e",
 CellID->457910155],
Cell[32343, 1001, 324, 10, 70, "GuideText",ExpressionUUID->"a302ea60-b2fb-4d8e-9068-aeaf44a92ef9",
 CellID->82280193]
}, Open  ]]
}, Open  ]],
Cell[32694, 1015, 23, 0, 70, "FooterCell",ExpressionUUID->"b3370220-31cd-47fc-93ef-1fcad591804e"]
}
]
*)

(* End of internal cache information *)
