(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     19115,        506]
NotebookOptionsPosition[     13712,        387]
NotebookOutlinePosition[     16035,        446]
CellTagsIndexPosition[     15950,        441]
WindowTitle->$UsePlusMinusForm
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "322b42d0-3adc-4ffd-9b70-520f47cc72db"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"12703b7d-96f5-4658-8f9c-dc977c134f30"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"NDV\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/NDV"], "\<\"DVSet\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVSet"], "\<\"ConfidenceLevel\"\>":>
       Documentation`HelpLookup["paclet:ref/ConfidenceLevel"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "fdbfcc36-e6af-44fc-a6d1-4df92d03a883"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"e87eac53-b41b-409a-8e0e-c8a685fa631e"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0dbcd425-7cfd-4b82-9ab4-996b43d253e8"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"eda0ad95-ab65-47b4-b52c-34a22bbd26bb"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/$UsePlusMinusForm\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/$UsePlusMinusForm"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/$\
UsePlusMinusForm.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$54714], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/$UsePlusMinusForm", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ffd4f4ea-d363-48ee-bf4a-5c324fbfe110"]
    }], "AnchorBar",ExpressionUUID->"085eac5d-2df4-4396-bfe0-eef5c0a91cd5"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"463899c8-d36e-4785-9926-06438850c37a"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["$UsePlusMinusForm", "ObjectName",ExpressionUUID->
  "ed018c33-f797-443e-8be0-9369118a2d28"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"99e5282c-a656-4f69-9738-8229a7f663fb"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "d14a41e0-1856-4f5b-a31b-bf477926483b"]
}], "ObjectNameGrid",ExpressionUUID->"3be2edd3-8a39-4793-bf0c-fd4597c23768"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
     "$UsePlusMinusForm"], "InlineFormula",ExpressionUUID->
      "471049cb-1001-4d88-b839-4b792eabab33"],
     "\[LineSeparator]is a boolean value specifying whether uncertanties are \
displayed with the \[PlusMinus] form or with parentheses."
    }],ExpressionUUID->"d974131c-bdb6-4b6c-a731-14a2c5baabf9"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"b2a91764-461e-472b-b908-4f855f647430"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"8fe2637e-5f5e-4965-9464-e849c3b52e08"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"c9179a2f-c668-4ab2-857c-6aabecdeecc4"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"67716bc7-4230-4da5-9127-af3f5a03474e"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->21847808,ExpressionUUID->"cf725fac-2376-4e98-9415-08b56518f61b"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"41c8369b-4e51-4d19-ac30-1a10d54f0b59"],

Cell[TextData[{
 "By default, ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["$UsePlusMinusForm"]],
    "paclet:DataAnalysis/ref/$UsePlusMinusForm"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "c15b0df8-847b-4fb3-a6b4-2a4f82b20833"],
 " is False and values are displayed using the parentheses form. For example, \
\"1.00(20)\" stands for a value of 1.00 with an uncertainty of 0.20."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"c367c0d9-bfd0-4a32-9536-259f1ba37a1d"],

Cell[TextData[{
 "Setting ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["$UsePlusMinusForm"]],
    "paclet:DataAnalysis/ref/$UsePlusMinusForm"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "c9e02599-a862-4b4b-b8fc-9733bb666f12"],
 " to True results in values displayed as \"1.00\[PlusMinus]0.20\"."
}], "Notes",
 CellID->12840508,ExpressionUUID->"7f7240e4-6435-4ccb-9b00-57264fa924a5"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"07f9a427-edf2-4016-a502-97a216fcaed7"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"bfe5c3e8-c6a2-4e7a-befe-e57574785f3b"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "68b6a01f-ef8a-48db-8739-1bc4235e3f58"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->215658826,ExpressionUUID->"f361e2aa-3e39-4eb5-84e8-6af00513f282"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "0ad985ff-5e77-4d17-aad5-ef793ab6fa34"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->486341818,ExpressionUUID->"2093923a-9c65-408b-bb56-ff69dfc0fb07"],

Cell[TextData[{
 "By default, ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["$UsePlusMinusForm"]],
    "paclet:DataAnalysis/ref/$UsePlusMinusForm"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "6c03fc83-89b7-4d96-a016-06a2d5b44afe"],
 " is False and values are displayed in the parentheses form:"
}], "ExampleText",
 CellID->208854496,ExpressionUUID->"db073a9f-6783-4a5b-9ec9-3f19d70f7265"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NDV", "[", 
  RowBox[{"1", ",", "0.1"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->465344693,ExpressionUUID->"5950d269-dad6-46e0-bb53-c62150732d21"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "20","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1, 0.1, $CellContext`dv$370747]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->163200931,ExpressionUUID->"e38ee099-ec21-4023-920b-8aaa4c304297"]
}, Open  ]],

Cell["Use the \[PlusMinus] form to display uncertanties:", "ExampleText",
 CellID->191259567,ExpressionUUID->"c8ded7bb-8c69-4600-84ed-3650b17c23db"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$UsePlusMinusForm", "=", "True"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->16400352,ExpressionUUID->"6fe69652-5cba-42aa-b390-4c3f9fbfa290"],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->54081543,ExpressionUUID->"bcdf4bcc-187c-42f4-8583-4ebf43774531"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NDV", "[", 
  RowBox[{"1", ",", "0.1"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->18451073,ExpressionUUID->"a4834d25-ced8-4b0b-b726-68f65a74eb8e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus]\"",TagBox[
      InterpretationBox["\"0.20\"", 0.1959963984540054, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ]},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1, 0.1, $CellContext`dv$371072]]], "Output",
 ImageSize->{67, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->109881884,ExpressionUUID->"ee791920-8b2e-4183-909f-45742f1c3b3c"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"a3df7034-2841-42c5-b392-9817ea9e7ed7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"27f4bb57-0b27-4aa7-8c56-15cef848908a"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"0cfb5fe7-6a56-4915-bddb-6379a7e455a3"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"304b57cd-8962-4fd0-b944-6c06c1edf668"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVSet"]],"paclet:DataAnalysis/ref/DVSet"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"e23b3e3d-a35c-465f-87d8-3387997e3953"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ConfidenceLevel"]],"paclet:ref/ConfidenceLevel"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"8d28e954-0a9f-4cfa-a4a4-00d43aee75ae"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"1fe1f545-2b2e-44a9-878a-b68423abd015"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"10615761-d890-4af3-a763-d3f288d5ce37"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"24f32156-4d63-4eb8-9232-f5e6d926da62"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"ae0bd745-da91-495b-ba50-e3ce8085e5c2"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->237864955,ExpressionUUID->"e9c8a4ca-8bd6-4c48-b7e3-09fc4539c5c0"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"c80cc110-9ae1-490b-9cdb-18cd492bc4aa"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"$UsePlusMinusForm",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 38, 5.8443528}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "$UsePlusMinusForm is a boolean value specifying whether uncertanties are \
displayed with the \\[PlusMinus] form or with parentheses.", "synonyms" -> {},
     "tabletags" -> {}, "title" -> "$UsePlusMinusForm", "titlemodifier" -> "",
     "windowtitle" -> "$UsePlusMinusForm", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/$UsePlusMinusForm"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7975, 207, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"f361e2aa-3e39-4eb5-84e8-6af00513f282",
   CellTags->"PrimaryExamplesSection",
   CellID->215658826]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15752, 434}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[589, 21, 4309, 96, 55, "AnchorBarGrid",ExpressionUUID->"463899c8-d36e-4785-9926-06438850c37a",
 CellID->1],
Cell[CellGroupData[{
Cell[4923, 121, 402, 9, 52, "ObjectNameGrid",ExpressionUUID->"3be2edd3-8a39-4793-bf0c-fd4597c23768"],
Cell[5328, 132, 584, 13, 109, "Usage",ExpressionUUID->"b2a91764-461e-472b-b908-4f855f647430"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5949, 150, 854, 21, 37, "NotesSection",ExpressionUUID->"cf725fac-2376-4e98-9415-08b56518f61b",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->21847808],
Cell[6806, 173, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"41c8369b-4e51-4d19-ac30-1a10d54f0b59"],
Cell[6895, 175, 519, 12, 70, "Notes",ExpressionUUID->"c367c0d9-bfd0-4a32-9536-259f1ba37a1d",
 CellID->1067943069],
Cell[7417, 189, 432, 11, 70, "Notes",ExpressionUUID->"7f7240e4-6435-4ccb-9b00-57264fa924a5",
 CellID->12840508],
Cell[7852, 202, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"07f9a427-edf2-4016-a502-97a216fcaed7"]
}, Closed]],
Cell[CellGroupData[{
Cell[7975, 207, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"f361e2aa-3e39-4eb5-84e8-6af00513f282",
 CellTags->"PrimaryExamplesSection",
 CellID->215658826],
Cell[CellGroupData[{
Cell[8435, 222, 308, 7, 29, "ExampleSection",ExpressionUUID->"2093923a-9c65-408b-bb56-ff69dfc0fb07",
 CellID->486341818],
Cell[8746, 231, 437, 11, 39, "ExampleText",ExpressionUUID->"db073a9f-6783-4a5b-9ec9-3f19d70f7265",
 CellID->208854496],
Cell[CellGroupData[{
Cell[9208, 246, 179, 4, 26, "Input",ExpressionUUID->"5950d269-dad6-46e0-bb53-c62150732d21",
 CellID->465344693],
Cell[9390, 252, 566, 15, 35, "Output",ExpressionUUID->"e38ee099-ec21-4023-920b-8aaa4c304297",
 CellID->163200931]
}, Open  ]],
Cell[9971, 270, 148, 1, 38, "ExampleText",ExpressionUUID->"c8ded7bb-8c69-4600-84ed-3650b17c23db",
 CellID->191259567],
Cell[CellGroupData[{
Cell[10144, 275, 165, 3, 26, "Input",ExpressionUUID->"6fe69652-5cba-42aa-b390-4c3f9fbfa290",
 CellID->16400352],
Cell[10312, 280, 215, 5, 35, "Output",ExpressionUUID->"bcdf4bcc-187c-42f4-8583-4ebf43774531",
 CellID->54081543]
}, Open  ]],
Cell[CellGroupData[{
Cell[10564, 290, 178, 4, 26, "Input",ExpressionUUID->"a4834d25-ced8-4b0b-b726-68f65a74eb8e",
 CellID->18451073],
Cell[10745, 296, 738, 18, 35, "Output",ExpressionUUID->"ee791920-8b2e-4183-909f-45742f1c3b3c",
 CellID->109881884]
}, Open  ]]
}, Open  ]],
Cell[11510, 318, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"a3df7034-2841-42c5-b392-9817ea9e7ed7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11633, 323, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"0cfb5fe7-6a56-4915-bddb-6379a7e455a3",
 CellID->1255426704],
Cell[11896, 332, 1077, 28, 24, "SeeAlso",ExpressionUUID->"1fe1f545-2b2e-44a9-878a-b68423abd015",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[13010, 365, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"24f32156-4d63-4eb8-9232-f5e6d926da62",
 CellID->38303248],
Cell[13279, 374, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"ae0bd745-da91-495b-ba50-e3ce8085e5c2"],
Cell[13368, 376, 247, 6, 70, "MoreAbout",ExpressionUUID->"e9c8a4ca-8bd6-4c48-b7e3-09fc4539c5c0",
 CellID->237864955]
}, Open  ]],
Cell[13630, 385, 78, 0, 70, "FooterCell",ExpressionUUID->"c80cc110-9ae1-490b-9cdb-18cd492bc4aa"]
}
]
*)

(* End of internal cache information *)

