(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14198,        384]
NotebookOptionsPosition[     10142,        289]
NotebookOutlinePosition[     12404,        348]
CellTagsIndexPosition[     12319,        343]
WindowTitle->AssumeND
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "c7e1e12d-05d2-41f3-85b4-90713aa2d128"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"971185d0-69b8-4917-bc44-804b01f4e9e5"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DVEvaluate\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVEvaluate"], "\<\"NDV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/NDV"], "\<\"DV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/DV"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "73dbaa5b-eb5c-4f8c-916d-4f373f85192c"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"6aed4913-9733-42a5-bcd2-f133a07fcaaa"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/AssumeND\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/AssumeND"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
AssumeND.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$10579], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/AssumeND", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "1efccaa9-f5eb-4047-829c-fe2f1396cb92"]
    }], "AnchorBar",ExpressionUUID->"ac77307c-e05d-4fe1-87bb-9b5c1ea863dc"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"48105531-300d-4ceb-bd67-1d782c7f3f56"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["AssumeND", "ObjectName",ExpressionUUID->
  "a80fc3f9-485b-4dd5-8ba9-4c51eb922c61"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"4893c5f5-5850-490e-a61a-121b29ffe0e4"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "e23c36a2-2444-4ca9-8384-e223b18023b3"]
}], "ObjectNameGrid",ExpressionUUID->"e89fd80a-cd28-4d47-9283-05504954fe20"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
     "AssumeND"], "InlineFormula",ExpressionUUID->
      "601a618d-6175-44d0-bbab-2ee8125aa976"],
     "\[LineSeparator]is an option for ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "90d7e9a9-0974-44b8-a1ce-1546e582bee0"],
     " to specify whether to assume that the resulting distribution is a \
normal distribution (True) or not (False)."
    }],ExpressionUUID->"06abab21-3bc6-481f-bb56-373fe1319786"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"751d7e18-7064-4e51-b40d-06f18fee196d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"7bd3523f-68e1-4b97-9f25-d1175322931d"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "be454fff-aef1-4770-988f-f8163ae76c4d"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->407385333,ExpressionUUID->"8e2e0f7a-3b9c-44f8-b66d-78ef7c719b7b"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "04825291-a6da-4b38-a747-ff5e4f1f87d5"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->140526235,ExpressionUUID->"089ebf34-2904-4471-963f-7e541b50158b"],

Cell["\<\
By default, it is assumed that the resulting distribution is normal, even if \
input variables are not normally distributed:\
\>", "ExampleText",
 CellID->194223949,ExpressionUUID->"5c652b95-aec2-4b23-8e20-745e0cfaaa67"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DVEvaluate", "[", 
   RowBox[{
    RowBox[{"NDV", "[", 
     RowBox[{"1", ",", "0.1"}], "]"}], "+", 
    RowBox[{"DV", "[", 
     RowBox[{"2", ",", "0.1"}], "]"}]}], "]"}], "//", "Head"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->68066961,ExpressionUUID->"290eb336-0e0f-43b1-bebd-b9a9f55e1627"],

Cell[BoxData["NDV"], "Output",
 ImageSize->{25, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->210554197,ExpressionUUID->"e22c52d5-711a-4009-b76f-bb4a4bcf24c0"]
}, Open  ]],

Cell[TextData[{
 "Changing ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["AssumeND"]],"paclet:DataAnalysis/ref/AssumeND"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "edee2431-0b45-49a4-892e-8f059bc9f08c"],
 " to False leads ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "8832c17d-dde0-466c-8e42-42afc0f1c5e2"],
 " to return a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f0d1c5c0-730e-4b55-b925-af9ee7b19855"],
 ":"
}], "ExampleText",
 CellID->252804116,ExpressionUUID->"22f778ec-1985-4039-94ee-d67fe3170cd7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DVEvaluate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NDV", "[", 
      RowBox[{"1", ",", "0.1"}], "]"}], "+", 
     RowBox[{"DV", "[", 
      RowBox[{"2", ",", "0.1"}], "]"}]}], ",", 
    RowBox[{"AssumeND", "\[Rule]", "False"}]}], "]"}], "//", 
  "Head"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->132280730,ExpressionUUID->"9c7e0e43-9e5f-4879-a94b-3f02f23aac1e"],

Cell[BoxData["DV"], "Output",
 ImageSize->{18, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->745114898,ExpressionUUID->"2e596e14-9133-4e84-a967-80f82232e406"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"a2ffb80f-7427-4edb-bee3-72b7074ce1d0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"5eec74b4-b9ba-43a0-b2fd-99baebad77e6"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"c0b7c8b1-2210-43d2-b6de-9d813218472e"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"2c91578d-7902-4a2d-b0d3-b1d49c1aa77b"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"07213e82-3ffe-4154-bf5c-b6ee11cb5c56"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"53a3718d-9e8d-423f-8cb2-79ce72523bf1"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"4b9d1412-36dc-4854-a93c-30c310c479f5"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"7c07e300-c244-4f9c-ab79-1752a5586647"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"AssumeND",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 35, 51.1345158}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "AssumeND is an option for DVEvaluate to specify whether to assume that \
the resulting distribution is a normal distribution (True) or not (False).", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "AssumeND", 
    "titlemodifier" -> "", "windowtitle" -> "AssumeND", "type" -> "Symbol", 
    "uri" -> "DataAnalysis/ref/AssumeND"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5488, 140, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"8e2e0f7a-3b9c-44f8-b66d-78ef7c719b7b",
   CellTags->"PrimaryExamplesSection",
   CellID->407385333]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12121, 336}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[580, 21, 3599, 79, 55, "AnchorBarGrid",ExpressionUUID->"48105531-300d-4ceb-bd67-1d782c7f3f56",
 CellID->1],
Cell[CellGroupData[{
Cell[4204, 104, 393, 9, 52, "ObjectNameGrid",ExpressionUUID->"e89fd80a-cd28-4d47-9283-05504954fe20"],
Cell[4600, 115, 851, 20, 131, "Usage",ExpressionUUID->"751d7e18-7064-4e51-b40d-06f18fee196d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5488, 140, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"8e2e0f7a-3b9c-44f8-b66d-78ef7c719b7b",
 CellTags->"PrimaryExamplesSection",
 CellID->407385333],
Cell[CellGroupData[{
Cell[5948, 155, 308, 7, 29, "ExampleSection",ExpressionUUID->"089ebf34-2904-4471-963f-7e541b50158b",
 CellID->140526235],
Cell[6259, 164, 230, 4, 57, "ExampleText",ExpressionUUID->"5c652b95-aec2-4b23-8e20-745e0cfaaa67",
 CellID->194223949],
Cell[CellGroupData[{
Cell[6514, 172, 330, 9, 26, "Input",ExpressionUUID->"290eb336-0e0f-43b1-bebd-b9a9f55e1627",
 CellID->68066961],
Cell[6847, 183, 215, 5, 35, "Output",ExpressionUUID->"e22c52d5-711a-4009-b76f-bb4a4bcf24c0",
 CellID->210554197]
}, Open  ]],
Cell[7077, 191, 834, 24, 39, "ExampleText",ExpressionUUID->"22f778ec-1985-4039-94ee-d67fe3170cd7",
 CellID->252804116],
Cell[CellGroupData[{
Cell[7936, 219, 405, 12, 26, "Input",ExpressionUUID->"9c7e0e43-9e5f-4879-a94b-3f02f23aac1e",
 CellID->132280730],
Cell[8344, 233, 214, 5, 35, "Output",ExpressionUUID->"2e596e14-9133-4e84-a967-80f82232e406",
 CellID->745114898]
}, Open  ]]
}, Open  ]],
Cell[8585, 242, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"a2ffb80f-7427-4edb-bee3-72b7074ce1d0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8708, 247, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"c0b7c8b1-2210-43d2-b6de-9d813218472e",
 CellID->1255426704],
Cell[8971, 256, 1074, 28, 24, "SeeAlso",ExpressionUUID->"4b9d1412-36dc-4854-a93c-30c310c479f5",
 CellID->929782353]
}, Open  ]],
Cell[10060, 287, 78, 0, 41, "FooterCell",ExpressionUUID->"7c07e300-c244-4f9c-ab79-1752a5586647"]
}
]
*)

(* End of internal cache information *)

