(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[      9965,        283]
NotebookOptionsPosition[      7051,        216]
NotebookOutlinePosition[      9016,        267]
CellTagsIndexPosition[      8973,        264]
WindowTitle->BlankPattern
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CalibrateCompositionalData\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/CalibrateCompositionalData"], \
"\<\"CalibrationPlot\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/CalibrationPlot"], \
"\<\"RemoveNonDetectableValues\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RemoveNonDetectableValues"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/BlankPattern\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/BlankPattern"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
BlankPattern.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$11092], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/BlankPattern", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["BlankPattern", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["BlankPattern"], "InlineFormula"],
     "\[LineSeparator]is an option to specify a string pattern that matches \
the row keys (IDs) of all blank measurements."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 "The option is used by the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrateCompositionalData"]],
    "paclet:DataAnalysis/ref/CalibrateCompositionalData"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrationPlot"]],"paclet:DataAnalysis/ref/CalibrationPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 ", and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RemoveNonDetectableValues"]],
    "paclet:DataAnalysis/ref/RemoveNonDetectableValues"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula"],
 " functions."
}], "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrateCompositionalData"]],
    "paclet:DataAnalysis/ref/CalibrateCompositionalData"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrationPlot"]],"paclet:DataAnalysis/ref/CalibrationPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RemoveNonDetectableValues"]],
    "paclet:DataAnalysis/ref/RemoveNonDetectableValues"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"BlankPattern",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 35, 52.8943079}", 
    "history" -> {"XX", "", "", ""}, "context" -> 
    "DataAnalysis`CompositionalAnalysis`", "keywords" -> {}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "BlankPattern is an option to specify a string pattern that matches the \
row keys (IDs) of all blank measurements.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "BlankPattern", "titlemodifier" -> "", 
    "windowtitle" -> "BlankPattern", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/BlankPattern"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[584, 21, 3326, 79, 70, "AnchorBarGrid",ExpressionUUID->"cf470065-3f2d-41de-b262-19e8b55e4552",
 CellID->1],
Cell[3913, 102, 169, 6, 70, "ObjectNameGrid",ExpressionUUID->"b99eef76-8122-4285-8ed4-188bcf3c6ef5"],
Cell[4085, 110, 386, 10, 70, "Usage",ExpressionUUID->"ed00fc4e-4dcf-4124-86c3-e0cf16b9394a"],
Cell[CellGroupData[{
Cell[4496, 124, 621, 19, 70, "NotesSection",ExpressionUUID->"e587f657-30d6-408c-a081-ff45c98a4c66",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[5120, 145, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"7b774530-77f8-45b4-9b48-d7c9eb47c756"],
Cell[5154, 147, 708, 23, 70, "Notes",ExpressionUUID->"857965bf-4322-4202-bff6-c5aef2abc3af",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[5899, 175, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"696b5aa6-f4c6-4fb7-a77a-636ce8d949eb",
 CellID->1255426704],
Cell[6052, 184, 957, 27, 70, "SeeAlso",ExpressionUUID->"6d33ea4e-5ded-47a4-a527-d57a5388eb18",
 CellID->929782353]
}, Open  ]],
Cell[7024, 214, 23, 0, 70, "FooterCell",ExpressionUUID->"b3595231-c1f5-4210-a019-33a7a6ca81ea"]
}
]
*)

(* End of internal cache information *)
