(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    610658,      12808]
NotebookOptionsPosition[    600581,      12599]
NotebookOutlinePosition[    603014,      12659]
CellTagsIndexPosition[    602926,      12654]
WindowTitle->CalibrateCompositionalData
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "7d81affd-cc67-48bb-86bb-a584c1cd0500"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"87e356e3-1dee-4fab-a846-304c7e434a69"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CalibrationPlot\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/CalibrationPlot"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "efba4363-6d28-42ad-b080-7016cd960ba5"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"def35bfc-a924-43a0-9884-f21f361cfe36"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "b13e0f50-ea81-4f27-8998-9debbe31fc02"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"8162c929-8c59-45fb-8cdc-7bab2ef1d029"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"DataAnalysis/ref/CalibrateCompositionalData\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/CalibrateCompositionalData"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
CalibrateCompositionalData.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$11793], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/CalibrateCompositionalData", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "740c4013-e978-4974-aa25-44e7a2ce01df"]
    }], "AnchorBar",ExpressionUUID->"4528b990-d01b-4fd6-a8f1-843fed0b448a"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"2d119f2a-95f6-4837-b767-c5a7a89ff6db"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["CalibrateCompositionalData", "ObjectName",ExpressionUUID->
  "5c26f24c-8a98-4bc5-bdf7-e1c9089db33d"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"ce8bb101-0591-488c-ba66-b8a25158722b"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "ee5fc4cf-df99-4675-8521-d4705b97d65f"]
}], "ObjectNameGrid",ExpressionUUID->"43d21c6e-c822-4eed-bdc6-643c0fc0d0d4"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
     "CalibrateCompositionalData"], "InlineFormula",ExpressionUUID->
      "2d446547-9837-4c57-bc29-7cf4bb396803"],
     "[",
     Cell[BoxData[
      StyleBox["datatable", "TI"]], "InlineFormula",ExpressionUUID->
      "fcecc405-8ab3-474f-9036-520a3e083c5c"],
     ",",
     Cell[BoxData[
      StyleBox["standardData", "TI"]], "InlineFormula",ExpressionUUID->
      "98110c07-80c9-4785-ab5b-8e91da21509d"],
     ",{",
     Cell[BoxData[
      SubscriptBox["column", "1"]], "InlineFormula",ExpressionUUID->
      "3e86952c-cd43-44c6-ac78-74ca531bf611"],
     ",",
     Cell[BoxData[
      SubscriptBox["column", "2"]], "InlineFormula",ExpressionUUID->
      "fd4acba2-4bfa-4729-8ffd-e6c1dad0d4bd"],
     ",",
     Cell[BoxData[
      StyleBox["\[Ellipsis]", "TR"]], "InlineFormula",ExpressionUUID->
      "ca293e3c-1a4a-487c-9144-8134189cb117"],
     "}]\[LineSeparator]calibrates the measurements for the compounds in a \
set of columns in a ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "28555cb3-1a7d-4fa8-8f1f-355d955e78c5"],
     " using the standardData."
    }],ExpressionUUID->"be1046ea-0238-465e-8518-1906f1e25042"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"fd34056c-0d25-484a-9022-3479d54600b6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"ab58213e-79ed-4e23-b9cb-1dcc00081272"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"e9e3b1b5-6410-4c72-8f58-7613ac30d1dc"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"da920005-63f3-40db-8933-ebade5aeb3e4"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->262620297,ExpressionUUID->"f1081f79-b031-4221-8949-c79e8d113c44"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"418eb171-8a56-4c1c-a358-4ebb411e98b1"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrateCompositionalData"]],
    "paclet:DataAnalysis/ref/CalibrateCompositionalData"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "0f29a3c8-a060-49d5-9d70-c71e035925ce"],
 " processes raw data of compositional (chemical) analyses using a set of \
standards of known composition to calculate concentrations of chemical \
elements, components, isotopes, etc."
}], "Notes",
 CellID->9613756,ExpressionUUID->"fb7ec5b3-02c5-4e0b-a5dc-9bd4b9bde873"],

Cell[TextData[{
 "The function requires a column named \"Time\" containing values that can be \
processed by ",
 ButtonBox["AbsoluteTime",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/AbsoluteTime"],
 " (e.g. a ",
 ButtonBox["DateObject",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/DateObject"],
 ", a number, or a date string) for each row in the measurements ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "3822991c-fe64-4089-90cd-70b851f6322f"],
 "."
}], "Notes",
 CellID->268649051,ExpressionUUID->"5d9d9494-7861-4e9d-a238-e85205fa919a"],

Cell["\<\
Multiple repeat standard measurements can be specified for the set of \
standards, and each individual measurement is calibrated using the linear \
interpolations of these standard measurements for the time of each analysis.\
\>", "Notes",
 CellID->639061216,ExpressionUUID->"269f31c3-ee13-477d-a686-bb17007ff9b0"],

Cell[TextData[{
 "By default, a linear calibration curve of the form ",
 StyleBox["y=b*x", "InlineCode",
  FontSlant->"Italic"],
 " is used, but a constant basis, i.e. ",
 StyleBox["y=a+b*x", "InlineCode",
  FontSlant->"Italic"],
 ", and/or a quadratic term, i.e. ",
 StyleBox["y=b*x+c*", "InlineCode",
  FontSlant->"Italic"],
 StyleBox[Cell[BoxData[
  SuperscriptBox["x", "2"]], "InlineCode", "InlineFormula",
  FontSlant->"Italic",ExpressionUUID->"76b0944e-5199-4270-90b4-f061dc230c66"],
   "InlineCode"],
 StyleBox[", can be used using the options ", "ExampleText"],
 StyleBox[ButtonBox["IncludeConstantBasis",
  BaseStyle->"Link",
  ButtonData->"paclet:DataAnalysis/ref/IncludeConstantBasis"], "ExampleText"],
 StyleBox[" and ", "ExampleText"],
 StyleBox[ButtonBox["IncludeQuadraticTerm",
  BaseStyle->"Link",
  ButtonData->"paclet:DataAnalysis/ref/IncludeQuadraticTerm"], "ExampleText"],
 StyleBox[".", "ExampleText"]
}], "Notes",
 CellID->30105571,ExpressionUUID->"07dead20-4e27-4fb2-b922-5134dd87ba54"],

Cell[TextData[{
 "Blank measurements can be specified using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["BlankPattern"]],"paclet:DataAnalysis/ref/BlankPattern"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "5ad851e4-cb78-4788-b853-5add58b9103e"],
 "."
}], "Notes",
 CellID->355868542,ExpressionUUID->"aeb286dc-272e-48d1-a253-bbc271d91cad"],

Cell["The following options can be given: ", "Notes",ExpressionUUID->"310b1392-375d-40cd-97b8-c66e28f09111"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "b1435f25-18ea-4706-94ae-bb574eda7276"], 
    ButtonBox["IncludeConstantBasis",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/IncludeConstantBasis"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell["\<\
Specifies whether a constant term should be included if not explicitly given \
in the list of basis functions.\
\>", "TableText",ExpressionUUID->"b678dada-4a07-437a-82c4-1a4ad9a44185"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "3dee6a21-2772-4fa1-80bb-6b937db7f821"], 
    ButtonBox["IncludeQuadraticTerm",
     BaseStyle->"Link",
     ButtonData->
      "paclet:DataAnalysisCompositionalAnalysis/ref/IncludeQuadraticTerm"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell["\<\
Specifies whether to include a quadratric term in the calibration curve.\
\>", "TableText",ExpressionUUID->"110b5d33-ca70-4ed7-900e-c1f7e98dc5ea"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "eab21ad5-0a26-4a9e-842b-6d25f8781924"], 
    ButtonBox["BlankPattern",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/BlankPattern"], 
    ButtonBox["Null",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Null"], Cell["\<\
A string pattern that matches the row keys (IDs) of all blank measurements.\
\>", "TableText",ExpressionUUID->"e9d411e8-9397-4110-a87e-a044c5d6786a"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "33eb2513-794f-4435-918b-5c1d10f30f02"], 
    ButtonBox["DriftStandard",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/DriftStandard"], 
    ButtonBox["Null",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Null"], Cell["\<\
A string pattern that matches the row keys (IDs) of drift standard \
measurements.\
\>", "TableText",ExpressionUUID->"ece23335-7f1b-4ce4-903a-8f169560c36c"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True, True, True, 
      True}}}},ExpressionUUID->"c359a8b1-06f5-400e-9183-cd03350a60ae"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"0333d93e-9556-4eb9-adee-1dfabd498bef"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"db5eacd5-3e14-47d4-aaef-d704ee070585"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(5)", "ExampleCount",ExpressionUUID->
  "5182ba9d-2460-4fc1-9781-39bce300ede3"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->66112022,ExpressionUUID->"79ca33a0-dddd-4a40-9fb2-0576dd6bef0c"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "005239ac-21d1-40b1-90c2-e0756851c6de"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->77406727,ExpressionUUID->"21659314-2eca-49cf-bcd7-aff0f7f9f4bf"],

Cell["\<\
Load known concentrations of calibration standards and measurement data (more \
than one element, isotope or compound can be used):\
\>", "ExampleText",
 CellID->3921242,ExpressionUUID->"e76f1f28-5616-45fa-95ff-bbd580d61c3d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stds", "=", 
  RowBox[{"DataTable", "@", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<STD 1\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{"\"\<Ca / ppm\>\"", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"0.5049652620285187", ",", "0.0005222986739878592"}], 
         "]"}]}], "|>"}]}], ",", 
     RowBox[{"\"\<STD 2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{"\"\<Ca / ppm\>\"", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"1.623565252889819", ",", "0.0007242565923152135"}], "]"}]}],
        "|>"}]}], ",", 
     RowBox[{"\"\<STD 3\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{"\"\<Ca / ppm\>\"", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"3.1122617784207023", ",", "0.0011361423406811462"}], 
         "]"}]}], "|>"}]}], ",", 
     RowBox[{"\"\<STD 4\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{"\"\<Ca / ppm\>\"", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"4.993042482195919", ",", "0.001721214491302021"}], "]"}]}], 
       "|>"}]}]}], "|>"}]}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->312812059,ExpressionUUID->"e431142e-a35f-47c2-b607-5f94b1a368ae"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "STD 1" -> Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5049652620285187, 
                  0.0005222986739878592, $CellContext`dv$394787]], "STD 2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.623565252889819, 
                  0.0007242565923152135, $CellContext`dv$394788]], "STD 3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.1122617784207023`, 
                  0.0011361423406811462`, $CellContext`dv$394789]], "STD 4" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.993042482195919, 
                  0.001721214491302021, $CellContext`dv$394790]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
             Association["ID" -> 37306216827995]]]]], Appearance -> Automatic,
         Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "STD 1" -> Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5049652620285187, 
                  0.0005222986739878592, $CellContext`dv$394787]], "STD 2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.623565252889819, 
                  0.0007242565923152135, $CellContext`dv$394788]], "STD 3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.1122617784207023`, 
                  0.0011361423406811462`, $CellContext`dv$394789]], "STD 4" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.993042482195919, 
                  0.001721214491302021, $CellContext`dv$394790]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
             Association["ID" -> 37306216827995]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "STD 1" -> Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5049652620285187, 
                   0.0005222986739878592, $CellContext`dv$394787]], "STD 2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.623565252889819, 
                   0.0007242565923152135, $CellContext`dv$394788]], "STD 3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.1122617784207023`, 
                   0.0011361423406811462`, $CellContext`dv$394789]], "STD 4" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.993042482195919, 
                   0.001721214491302021, $CellContext`dv$394790]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
              Association["ID" -> 37306216827995]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "STD 1" -> Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5049652620285187, 
                   0.0005222986739878592, $CellContext`dv$394787]], "STD 2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.623565252889819, 
                   0.0007242565923152135, $CellContext`dv$394788]], "STD 3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.1122617784207023`, 
                   0.0011361423406811462`, $CellContext`dv$394789]], "STD 4" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.993042482195919, 
                   0.001721214491302021, $CellContext`dv$394790]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
              Association["ID" -> 37306216827995]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[38]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[48.00000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               4, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[1711026344], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1711026344]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1", 
                    Style[
                    "STD 1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    Key["STD 1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 1"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.5050\"", 0.5049652620285187, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "13", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.5049652620285187, 
                    0.0005222986739878592, $CellContext`dv$394787]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 1"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2", 
                    Style[
                    "STD 2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    Key["STD 2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 2"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.6236\"", 1.623565252889819, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "19", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.623565252889819, 
                    0.0007242565923152135, $CellContext`dv$394788]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3", 
                    Style[
                    "STD 3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    Key["STD 3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 3"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.1123\"", 3.1122617784207023`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "29", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.1122617784207023`, 
                    0.0011361423406811462`, $CellContext`dv$394789]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4", 
                    Style[
                    "STD 4", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    Key["STD 4"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 4"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.9930\"", 4.993042482195919, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "44", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.993042482195919, 
                    0.001721214491302021, $CellContext`dv$394790]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 4"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[492935801][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[492935801][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {149., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->531943659,ExpressionUUID->"a35c710e-bc22-4f46-ae10-6b76baf7e1be"]
}, Open  ]],

Cell["Define some measurements:", "ExampleText",
 CellID->26645253,ExpressionUUID->"d22c9a32-2b1b-46fe-bc3e-32f3475ebd22"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"measurements", "=", 
  RowBox[{"DataTable", "@", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<Blanc-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "55", ",", "21."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{
           RowBox[{"-", "0.01758562332"}], ",", "0.00033863693000000036"}], 
          "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<STD 1-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "56", ",", "11."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.03964178048", ",", "0.0004196894400000026"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 2-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "57", ",", "1."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.12384595475", ",", "0.0016846698500000005"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 3-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "57", ",", "52."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.23293354845", ",", "0.0006201796499999968"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 4-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "58", ",", "44."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.3619620833", ",", "0.0008638827000000127"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 00\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "1", ",", "20."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.19625917165", ",", "0.001488907949999993"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 07\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "3", ",", "4."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.15008595425", ",", "0.0003870700500000074"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 05\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "3", ",", "57."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.1584623842", ",", "0.0022980622000000057"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 06\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "4", ",", "47."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.155255631", ",", "0.0004266695999999986"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Blanc-3\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "5", ",", "36."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{
           RowBox[{"-", "0.001228706227"}], ",", "0.00005203780300000005"}], 
          "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<DRIFT-3\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "6", ",", "26."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.36115560739999997", ",", "0.00001406480000001875"}], 
          "]"}]}]}], "|>"}]}]}], "|>"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->792318828,ExpressionUUID->"d7ab8855-843c-4378-b966-1ab63be6b075"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.01758562332, 
                  0.00033863693000000036`, $CellContext`dv$388908]], 
              "STD 1-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.03964178048, 
                  0.0004196894400000026, $CellContext`dv$388909]], "STD 2-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.12384595475, 
                  0.0016846698500000005`, $CellContext`dv$388910]], "STD 3-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.23293354845, 
                  0.0006201796499999968, $CellContext`dv$388911]], "STD 4-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.3619620833, 
                  0.0008638827000000127, $CellContext`dv$388912]], 
              "Sample 00" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.19625917165, 
                  0.001488907949999993, $CellContext`dv$388913]], "Sample 07" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.15008595425, 
                  0.0003870700500000074, $CellContext`dv$388914]], 
              "Sample 05" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.1584623842, 
                  0.0022980622000000057`, $CellContext`dv$388915]], 
              "Sample 06" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.155255631, 0.0004266695999999986, $CellContext`dv$388916]],
               "Blanc-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.001228706227, 
                  0.00005203780300000005, $CellContext`dv$388917]], "DRIFT-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.36115560739999997`, 
                  0.00001406480000001875, $CellContext`dv$388918]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
             Association["ID" -> 146686148955122]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.01758562332, 
                  0.00033863693000000036`, $CellContext`dv$388908]], 
              "STD 1-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.03964178048, 
                  0.0004196894400000026, $CellContext`dv$388909]], "STD 2-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.12384595475, 
                  0.0016846698500000005`, $CellContext`dv$388910]], "STD 3-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.23293354845, 
                  0.0006201796499999968, $CellContext`dv$388911]], "STD 4-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.3619620833, 
                  0.0008638827000000127, $CellContext`dv$388912]], 
              "Sample 00" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.19625917165, 
                  0.001488907949999993, $CellContext`dv$388913]], "Sample 07" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.15008595425, 
                  0.0003870700500000074, $CellContext`dv$388914]], 
              "Sample 05" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.1584623842, 
                  0.0022980622000000057`, $CellContext`dv$388915]], 
              "Sample 06" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.155255631, 0.0004266695999999986, $CellContext`dv$388916]],
               "Blanc-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.001228706227, 
                  0.00005203780300000005, $CellContext`dv$388917]], "DRIFT-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.36115560739999997`, 
                  0.00001406480000001875, $CellContext`dv$388918]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
             Association["ID" -> 146686148955122]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.01758562332, 
                   0.00033863693000000036`, $CellContext`dv$388908]], 
               "STD 1-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.03964178048, 
                   0.0004196894400000026, $CellContext`dv$388909]], "STD 2-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.12384595475, 
                   0.0016846698500000005`, $CellContext`dv$388910]], 
               "STD 3-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.23293354845, 
                   0.0006201796499999968, $CellContext`dv$388911]], "STD 4-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.3619620833, 
                   0.0008638827000000127, $CellContext`dv$388912]], 
               "Sample 00" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.19625917165, 
                   0.001488907949999993, $CellContext`dv$388913]], 
               "Sample 07" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.15008595425, 
                   0.0003870700500000074, $CellContext`dv$388914]], 
               "Sample 05" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.1584623842, 
                   0.0022980622000000057`, $CellContext`dv$388915]], 
               "Sample 06" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.155255631, 
                   0.0004266695999999986, $CellContext`dv$388916]], "Blanc-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.001228706227, 
                   0.00005203780300000005, $CellContext`dv$388917]], 
               "DRIFT-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.36115560739999997`, 
                   0.00001406480000001875, $CellContext`dv$388918]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Time", "Ca"}, {
                 TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
              Association["ID" -> 146686148955122]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.01758562332, 
                   0.00033863693000000036`, $CellContext`dv$388908]], 
               "STD 1-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.03964178048, 
                   0.0004196894400000026, $CellContext`dv$388909]], "STD 2-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.12384595475, 
                   0.0016846698500000005`, $CellContext`dv$388910]], 
               "STD 3-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.23293354845, 
                   0.0006201796499999968, $CellContext`dv$388911]], "STD 4-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.3619620833, 
                   0.0008638827000000127, $CellContext`dv$388912]], 
               "Sample 00" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.19625917165, 
                   0.001488907949999993, $CellContext`dv$388913]], 
               "Sample 07" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.15008595425, 
                   0.0003870700500000074, $CellContext`dv$388914]], 
               "Sample 05" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.1584623842, 
                   0.0022980622000000057`, $CellContext`dv$388915]], 
               "Sample 06" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.155255631, 
                   0.0004266695999999986, $CellContext`dv$388916]], "Blanc-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.001228706227, 
                   0.00005203780300000005, $CellContext`dv$388917]], 
               "DRIFT-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.36115560739999997`, 
                   0.00001406480000001875, $CellContext`dv$388918]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Time", "Ca"}, {
                 TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
              Association["ID" -> 146686148955122]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[37]} -> 1, {All, "Time"} -> 
               1, {All, "Ca"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Time" -> TypeSystem`PackageScope`AtomShape[75], "Ca" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 11, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[2143726770], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[2143726770]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Time\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Time\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    All, "Time"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[All, "Time"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    All, "Ca"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[All, "Ca"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:55:21\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.01759\"", -0.01758562332, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "87", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.01758562332, 
                    0.00033863693000000036`, $CellContext`dv$388908]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:56:11\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.0396\"", 0.03964178048, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.03964178048, 
                    0.0004196894400000026, $CellContext`dv$388909]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:57:01\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1238\"", 0.12384595475, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "43", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.12384595475, 
                    0.0016846698500000005`, $CellContext`dv$388910]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:57:52\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.2329\"", 0.23293354845, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.23293354845, 
                    0.0006201796499999968, $CellContext`dv$388911]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:58:44\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.3620\"", 0.3619620833, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "22", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.3619620833, 
                    0.0008638827000000127, $CellContext`dv$388912]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:01:20\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1963\"", 0.19625917165, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "38", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.19625917165, 
                    0.001488907949999993, $CellContext`dv$388913]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:03:04\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.15009\"", 0.15008595425, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "100", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.15008595425, 
                    0.0003870700500000074, $CellContext`dv$388914]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:03:57\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1585\"", 0.1584623842, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.1584623842, 
                    0.0022980622000000057`, $CellContext`dv$388915]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:04:47\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1553\"", 0.155255631, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.155255631, 
                    0.0004266695999999986, $CellContext`dv$388916]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:05:36\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.00123\"", -0.001228706227, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "13", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.001228706227, 
                    0.00005203780300000005, $CellContext`dv$388917]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:06:26\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.361156\"", 0.36115560739999997`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 6}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "36", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.36115560739999997`, 
                    0.00001406480000001875, $CellContext`dv$388918]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[761380414][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[761380414][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {381., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{385, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->335711839,ExpressionUUID->"5f2b9877-341e-4158-ab62-a9e12b5003d3"]
}, Open  ]],

Cell["\<\
Process the measurements using the calibration defined by the analyses of the \
standards and the known standard concentrations:\
\>", "ExampleText",
 CellID->262614986,ExpressionUUID->"596fb6a3-c543-492b-bc31-e83bfd64b59b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->255783851,ExpressionUUID->"68d049a4-ae10-4f91-845d-64375e1d030c"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22671109651240204`, 
                  0.016133598728604377`, $CellContext`dv$398325]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.505085356721548, 
                  0.017921828167261015`, $CellContext`dv$398359]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613806140707826, 
                  0.03869735056006944, $CellContext`dv$398393]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112949605710551, 
                  0.06292559103956663, $CellContext`dv$398427]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12111731684957971`, $CellContext`dv$398461]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.603240200398011, 
                  0.048865766217893576`, $CellContext`dv$398495]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9707776677963589`, 
                  0.030896600392822875`, $CellContext`dv$398529]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0852688522822533`, 
                  0.044207316264084216`, $CellContext`dv$398563]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.042036066525968, 
                  0.03003457664039987, $CellContext`dv$398597]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019357837373813518`, 
                  0.009438202591552744, $CellContext`dv$398631]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.99247000650331, 
                  0.091372761188262, $CellContext`dv$398665]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[190610779491492]]], "ID" -> 
              190615074458788]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22671109651240204`, 
                  0.016133598728604377`, $CellContext`dv$398325]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.505085356721548, 
                  0.017921828167261015`, $CellContext`dv$398359]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613806140707826, 
                  0.03869735056006944, $CellContext`dv$398393]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112949605710551, 
                  0.06292559103956663, $CellContext`dv$398427]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12111731684957971`, $CellContext`dv$398461]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.603240200398011, 
                  0.048865766217893576`, $CellContext`dv$398495]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9707776677963589`, 
                  0.030896600392822875`, $CellContext`dv$398529]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0852688522822533`, 
                  0.044207316264084216`, $CellContext`dv$398563]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.042036066525968, 
                  0.03003457664039987, $CellContext`dv$398597]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019357837373813518`, 
                  0.009438202591552744, $CellContext`dv$398631]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.99247000650331, 
                  0.091372761188262, $CellContext`dv$398665]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[190610779491492]]], "ID" -> 
              190615074458788]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22671109651240204`, 
                   0.016133598728604377`, $CellContext`dv$398325]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.505085356721548, 
                   0.017921828167261015`, $CellContext`dv$398359]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613806140707826, 
                   0.03869735056006944, $CellContext`dv$398393]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112949605710551, 
                   0.06292559103956663, $CellContext`dv$398427]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12111731684957971`, $CellContext`dv$398461]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.603240200398011, 
                   0.048865766217893576`, $CellContext`dv$398495]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9707776677963589`, 
                   0.030896600392822875`, $CellContext`dv$398529]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0852688522822533`, 
                   0.044207316264084216`, $CellContext`dv$398563]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.042036066525968, 
                   0.03003457664039987, $CellContext`dv$398597]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019357837373813518`, 
                   0.009438202591552744, $CellContext`dv$398631]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.99247000650331, 
                   0.091372761188262, $CellContext`dv$398665]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[190610779491492]]], "ID" -> 
               190615074458788]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22671109651240204`, 
                   0.016133598728604377`, $CellContext`dv$398325]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.505085356721548, 
                   0.017921828167261015`, $CellContext`dv$398359]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613806140707826, 
                   0.03869735056006944, $CellContext`dv$398393]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112949605710551, 
                   0.06292559103956663, $CellContext`dv$398427]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12111731684957971`, $CellContext`dv$398461]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.603240200398011, 
                   0.048865766217893576`, $CellContext`dv$398495]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9707776677963589`, 
                   0.030896600392822875`, $CellContext`dv$398529]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0852688522822533`, 
                   0.044207316264084216`, $CellContext`dv$398563]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.042036066525968, 
                   0.03003457664039987, $CellContext`dv$398597]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019357837373813518`, 
                   0.009438202591552744, $CellContext`dv$398631]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.99247000650331, 
                   0.091372761188262, $CellContext`dv$398665]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[190610779491492]]], "ID" -> 
               190615074458788]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[39]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[1254446090], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1254446090]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1962951224][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1962951224][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.227\"", -0.22671109651240204`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "42", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.22671109651240204`, 
                    0.016133598728604377`, $CellContext`dv$398325]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.505\"", 0.505085356721548, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "46", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.505085356721548, 
                    0.017921828167261015`, $CellContext`dv$398359]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.614\"", 1.613806140707826, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "100", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.613806140707826, 
                    0.03869735056006944, $CellContext`dv$398393]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.11\"", 3.112949605710551, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.112949605710551, 
                    0.06292559103956663, $CellContext`dv$398427]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.992377480653775, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "31", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.992377480653775, 
                    0.12111731684957971`, $CellContext`dv$398461]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.60\"", 2.603240200398011, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "13", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.603240200398011, 
                    0.048865766217893576`, $CellContext`dv$398495]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.971\"", 1.9707776677963589`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "80", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.9707776677963589`, 
                    0.030896600392822875`, $CellContext`dv$398529]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.09\"", 2.0852688522822533`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.0852688522822533`, 
                    0.044207316264084216`, $CellContext`dv$398563]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.042\"", 2.042036066525968, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "77", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.042036066525968, 
                    0.03003457664039987, $CellContext`dv$398597]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.019\"", -0.019357837373813518`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[-0.019357837373813518`, 
                    0.009438202591552744, $CellContext`dv$398631]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.99247000650331, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.99247000650331, 
                    0.091372761188262, $CellContext`dv$398665]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1962951224][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1962951224]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1962951224][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1962951224][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {187., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->996106020,ExpressionUUID->"e4cb4e7b-e1d9-4c59-8676-f7c18d947b30"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount",ExpressionUUID->
  "5cd2b3b2-562b-4601-82b2-0d1ea845cfb8"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"f0b8e1e1-3456-48b0-8045-c62a48544b68"],

Cell[CellGroupData[{

Cell[TextData[{
 "IncludeConstantBasis",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "c17eb384-ac2e-4b05-941d-69cec1b34896"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"0d52bcdb-3bd4-4262-8f38-23dbd6c920a3"],

Cell[TextData[{
 "By default, no constant basis (",
 StyleBox["y=b*x", "InlineCode",
  FontSlant->"Italic"],
 ") is used for the calibration curve:"
}], "ExampleText",
 CellID->227649573,ExpressionUUID->"92760573-151f-4280-b5e8-2fc395eaad69"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->467315169,ExpressionUUID->"1765a3bc-f21e-439c-bfb1-f58702436eaa"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.00021915358694432643`, 
                  0.0061468845946855725`, $CellContext`dv$461971]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.7151292711147926, 
                  0.0071057870447810804`, $CellContext`dv$461995]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.7837168588628391`, 
                  0.022831849549221194`, $CellContext`dv$462019]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.184109927301784, 
                  0.013847212310817128`, $CellContext`dv$462043]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.857579621802821, 
                  0.019445005311291626`, $CellContext`dv$462067]], 
              "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6938628415998416`, 
                  0.020961121347663578`, $CellContext`dv$462091]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.07034057808036, 
                  0.007143839501561162, $CellContext`dv$462115]], "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.175093246263309, 
                  0.031160959953693012`, $CellContext`dv$462139]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.125417211390718, 
                  0.007201741751111847, $CellContext`dv$462163]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.000033057555189045025`, 
                  0.000995512774477136, $CellContext`dv$462187]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.915249835154216, 
                  0.008978279525330967, $CellContext`dv$462211]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[198565058925165]]], "ID" -> 
              198569353892461]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.00021915358694432643`, 
                  0.0061468845946855725`, $CellContext`dv$461971]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.7151292711147926, 
                  0.0071057870447810804`, $CellContext`dv$461995]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.7837168588628391`, 
                  0.022831849549221194`, $CellContext`dv$462019]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.184109927301784, 
                  0.013847212310817128`, $CellContext`dv$462043]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.857579621802821, 
                  0.019445005311291626`, $CellContext`dv$462067]], 
              "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6938628415998416`, 
                  0.020961121347663578`, $CellContext`dv$462091]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.07034057808036, 
                  0.007143839501561162, $CellContext`dv$462115]], "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.175093246263309, 
                  0.031160959953693012`, $CellContext`dv$462139]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.125417211390718, 
                  0.007201741751111847, $CellContext`dv$462163]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.000033057555189045025`, 
                  0.000995512774477136, $CellContext`dv$462187]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.915249835154216, 
                  0.008978279525330967, $CellContext`dv$462211]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[198565058925165]]], "ID" -> 
              198569353892461]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.00021915358694432643`, 
                   0.0061468845946855725`, $CellContext`dv$461971]], 
               "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.7151292711147926, 
                   0.0071057870447810804`, $CellContext`dv$461995]], 
               "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.7837168588628391`, 
                   0.022831849549221194`, $CellContext`dv$462019]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.184109927301784, 
                   0.013847212310817128`, $CellContext`dv$462043]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.857579621802821, 
                   0.019445005311291626`, $CellContext`dv$462067]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6938628415998416`, 
                   0.020961121347663578`, $CellContext`dv$462091]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.07034057808036, 
                   0.007143839501561162, $CellContext`dv$462115]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.175093246263309, 
                   0.031160959953693012`, $CellContext`dv$462139]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.125417211390718, 
                   0.007201741751111847, $CellContext`dv$462163]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.000033057555189045025`, 
                   0.000995512774477136, $CellContext`dv$462187]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.915249835154216, 
                   0.008978279525330967, $CellContext`dv$462211]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[198565058925165]]], "ID" -> 
               198569353892461]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.00021915358694432643`, 
                   0.0061468845946855725`, $CellContext`dv$461971]], 
               "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.7151292711147926, 
                   0.0071057870447810804`, $CellContext`dv$461995]], 
               "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.7837168588628391`, 
                   0.022831849549221194`, $CellContext`dv$462019]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.184109927301784, 
                   0.013847212310817128`, $CellContext`dv$462043]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.857579621802821, 
                   0.019445005311291626`, $CellContext`dv$462067]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6938628415998416`, 
                   0.020961121347663578`, $CellContext`dv$462091]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.07034057808036, 
                   0.007143839501561162, $CellContext`dv$462115]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.175093246263309, 
                   0.031160959953693012`, $CellContext`dv$462139]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.125417211390718, 
                   0.007201741751111847, $CellContext`dv$462163]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.000033057555189045025`, 
                   0.000995512774477136, $CellContext`dv$462187]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.915249835154216, 
                   0.008978279525330967, $CellContext`dv$462211]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[198565058925165]]], "ID" -> 
               198569353892461]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[48]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[20713303], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[20713303]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{"2", "\"(\"", "158", "\")\[Times]\"", 
                    TemplateBox[{"10", 
                    RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
                    SuperscriptBox]}, "RowDefault"], ShowStringCharacters -> 
                    False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.00021915358694432643`, 
                    0.0061468845946855725`, $CellContext`dv$461971]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.715\"", 0.7151292711147926, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.7151292711147926, 
                    0.0071057870447810804`, $CellContext`dv$461995]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.784\"", 1.7837168588628391`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.7837168588628391`, 
                    0.022831849549221194`, $CellContext`dv$462019]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.184\"", 3.184109927301784, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "36", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.184109927301784, 
                    0.013847212310817128`, $CellContext`dv$462043]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.858\"", 4.857579621802821, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "50", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.857579621802821, 
                    0.019445005311291626`, $CellContext`dv$462067]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.694\"", 2.6938628415998416`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "54", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.6938628415998416`, 
                    0.020961121347663578`, $CellContext`dv$462091]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.070\"", 2.07034057808036, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.07034057808036, 
                    0.007143839501561162, $CellContext`dv$462115]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.175\"", 2.175093246263309, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "80", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.175093246263309, 
                    0.031160959953693012`, $CellContext`dv$462139]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.125\"", 2.125417211390718, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "19", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.125417211390718, 
                    0.007201741751111847, $CellContext`dv$462163]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    RowBox[{"-", "3"}], "\"(\"", "256", "\")\[Times]\"", 
                    TemplateBox[{"10", 
                    RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
                    SuperscriptBox]}, "RowDefault"], ShowStringCharacters -> 
                    False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.000033057555189045025`, 
                    0.000995512774477136, $CellContext`dv$462187]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.915\"", 4.915249835154216, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "23", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.915249835154216, 
                    0.008978279525330967, $CellContext`dv$462211]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    956723158][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 956723158]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[956723158][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[956723158][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {199., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->31806462,ExpressionUUID->"3467e244-49f3-4346-84b5-145bbf368ba1"]
}, Open  ]],

Cell[TextData[{
 "Specify to use a constant basis (",
 StyleBox["y=a+b*x", "InlineCode",
  FontSlant->"Italic"],
 ") in the calibration curve expression:"
}], "ExampleText",
 CellID->106986945,ExpressionUUID->"2a8d839d-b981-496b-98e8-82c32aa61bb0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->472668707,ExpressionUUID->"4846e2b9-2d2d-48d9-928d-d98f62913417"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.3019642173685499, 
                  0.01324366389382588, $CellContext`dv$463303]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.488907421067461, 
                  0.01347015059135249, $CellContext`dv$463332]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.6526137392407854`, 
                  0.02719055060296244, $CellContext`dv$463361]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.160325050469421, 
                  0.020311683461005273`, $CellContext`dv$463390]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.943813779398391, 
                  0.027063554759839306`, $CellContext`dv$463419]], 
              "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6562122194490128`, 
                  0.024690253096027345`, $CellContext`dv$463448]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.019315312064409, 
                  0.012099430155953153`, $CellContext`dv$463477]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.1356957098138283`, 
                  0.03346204952709795, $CellContext`dv$463506]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0919485665465007`, 
                  0.011556404596209189`, $CellContext`dv$463535]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.0702796748641929, 
                  0.007343128934154223, $CellContext`dv$463564]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.938791423823909, 
                  0.01533109755912744, $CellContext`dv$463593]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[117338637423218]]], "ID" -> 
              117342932390514]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.3019642173685499, 
                  0.01324366389382588, $CellContext`dv$463303]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.488907421067461, 
                  0.01347015059135249, $CellContext`dv$463332]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.6526137392407854`, 
                  0.02719055060296244, $CellContext`dv$463361]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.160325050469421, 
                  0.020311683461005273`, $CellContext`dv$463390]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.943813779398391, 
                  0.027063554759839306`, $CellContext`dv$463419]], 
              "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6562122194490128`, 
                  0.024690253096027345`, $CellContext`dv$463448]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.019315312064409, 
                  0.012099430155953153`, $CellContext`dv$463477]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.1356957098138283`, 
                  0.03346204952709795, $CellContext`dv$463506]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0919485665465007`, 
                  0.011556404596209189`, $CellContext`dv$463535]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.0702796748641929, 
                  0.007343128934154223, $CellContext`dv$463564]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.938791423823909, 
                  0.01533109755912744, $CellContext`dv$463593]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[117338637423218]]], "ID" -> 
              117342932390514]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.3019642173685499, 
                   0.01324366389382588, $CellContext`dv$463303]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.488907421067461, 
                   0.01347015059135249, $CellContext`dv$463332]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.6526137392407854`, 
                   0.02719055060296244, $CellContext`dv$463361]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.160325050469421, 
                   0.020311683461005273`, $CellContext`dv$463390]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.943813779398391, 
                   0.027063554759839306`, $CellContext`dv$463419]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6562122194490128`, 
                   0.024690253096027345`, $CellContext`dv$463448]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.019315312064409, 
                   0.012099430155953153`, $CellContext`dv$463477]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.1356957098138283`, 
                   0.03346204952709795, $CellContext`dv$463506]], "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0919485665465007`, 
                   0.011556404596209189`, $CellContext`dv$463535]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.0702796748641929, 
                   0.007343128934154223, $CellContext`dv$463564]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.938791423823909, 
                   0.01533109755912744, $CellContext`dv$463593]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[117338637423218]]], "ID" -> 
               117342932390514]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.3019642173685499, 
                   0.01324366389382588, $CellContext`dv$463303]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.488907421067461, 
                   0.01347015059135249, $CellContext`dv$463332]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.6526137392407854`, 
                   0.02719055060296244, $CellContext`dv$463361]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.160325050469421, 
                   0.020311683461005273`, $CellContext`dv$463390]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.943813779398391, 
                   0.027063554759839306`, $CellContext`dv$463419]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6562122194490128`, 
                   0.024690253096027345`, $CellContext`dv$463448]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.019315312064409, 
                   0.012099430155953153`, $CellContext`dv$463477]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.1356957098138283`, 
                   0.03346204952709795, $CellContext`dv$463506]], "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0919485665465007`, 
                   0.011556404596209189`, $CellContext`dv$463535]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.0702796748641929, 
                   0.007343128934154223, $CellContext`dv$463564]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.938791423823909, 
                   0.01533109755912744, $CellContext`dv$463593]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[117338637423218]]], "ID" -> 
               117342932390514]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[49]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[251519605], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[251519605]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1668312340][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1668312340][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.302\"", -0.3019642173685499, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "34", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.3019642173685499, 
                    0.01324366389382588, $CellContext`dv$463303]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.489\"", 0.488907421067461, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "35", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.488907421067461, 
                    0.01347015059135249, $CellContext`dv$463332]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.653\"", 1.6526137392407854`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "70", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.6526137392407854`, 
                    0.02719055060296244, $CellContext`dv$463361]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.160\"", 3.160325050469421, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "52", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.160325050469421, 
                    0.020311683461005273`, $CellContext`dv$463390]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.944\"", 4.943813779398391, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "70", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.943813779398391, 
                    0.027063554759839306`, $CellContext`dv$463419]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.656\"", 2.6562122194490128`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "64", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.6562122194490128`, 
                    0.024690253096027345`, $CellContext`dv$463448]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.019\"", 2.019315312064409, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "31", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.019315312064409, 
                    0.012099430155953153`, $CellContext`dv$463477]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.136\"", 2.1356957098138283`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "86", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.1356957098138283`, 
                    0.03346204952709795, $CellContext`dv$463506]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.092\"", 2.0919485665465007`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "30", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.0919485665465007`, 
                    0.011556404596209189`, $CellContext`dv$463535]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.070\"", -0.0702796748641929, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "19", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.0702796748641929, 
                    0.007343128934154223, $CellContext`dv$463564]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.939\"", 4.938791423823909, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.938791423823909, 
                    0.01533109755912744, $CellContext`dv$463593]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1668312340][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1668312340]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1668312340][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1668312340][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {187., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->886498528,ExpressionUUID->"b97448f2-50a2-4644-88d4-03b7527828bd"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "IncludeQuadraticTerm",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "106cac60-5c08-4181-a5e3-afac860e5f9a"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"612aec0e-2f48-4822-8a2b-2ad97047616c"],

Cell[TextData[{
 "By default, no quadratic term (",
 StyleBox["y=b*x", "InlineCode",
  FontSlant->"Italic"],
 ") is used for the calibration curve:"
}], "ExampleText",
 CellID->348072352,ExpressionUUID->"7b30bc28-04e3-4550-b38f-bf604b473b24"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->847327418,ExpressionUUID->"0e465587-c082-4311-a5d2-09b99e2024b7"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.00021915358694432643`, 
                  0.0061468845946855725`, $CellContext`dv$464966]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.7151292711147926, 
                  0.0071057870447810804`, $CellContext`dv$464990]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.7837168588628391`, 
                  0.022831849549221194`, $CellContext`dv$465014]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.184109927301784, 
                  0.013847212310817128`, $CellContext`dv$465038]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.857579621802821, 
                  0.019445005311291626`, $CellContext`dv$465062]], 
              "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6938628415998416`, 
                  0.020961121347663578`, $CellContext`dv$465086]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.07034057808036, 
                  0.007143839501561162, $CellContext`dv$465110]], "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.175093246263309, 
                  0.031160959953693012`, $CellContext`dv$465134]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.125417211390718, 
                  0.007201741751111847, $CellContext`dv$465158]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.000033057555189045025`, 
                  0.000995512774477136, $CellContext`dv$465182]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.915249835154216, 
                  0.008978279525330967, $CellContext`dv$465206]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[85856527143542]]], "ID" -> 
              85860822110838]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.00021915358694432643`, 
                  0.0061468845946855725`, $CellContext`dv$464966]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.7151292711147926, 
                  0.0071057870447810804`, $CellContext`dv$464990]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.7837168588628391`, 
                  0.022831849549221194`, $CellContext`dv$465014]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.184109927301784, 
                  0.013847212310817128`, $CellContext`dv$465038]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.857579621802821, 
                  0.019445005311291626`, $CellContext`dv$465062]], 
              "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6938628415998416`, 
                  0.020961121347663578`, $CellContext`dv$465086]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.07034057808036, 
                  0.007143839501561162, $CellContext`dv$465110]], "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.175093246263309, 
                  0.031160959953693012`, $CellContext`dv$465134]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.125417211390718, 
                  0.007201741751111847, $CellContext`dv$465158]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.000033057555189045025`, 
                  0.000995512774477136, $CellContext`dv$465182]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.915249835154216, 
                  0.008978279525330967, $CellContext`dv$465206]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[85856527143542]]], "ID" -> 
              85860822110838]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.00021915358694432643`, 
                   0.0061468845946855725`, $CellContext`dv$464966]], 
               "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.7151292711147926, 
                   0.0071057870447810804`, $CellContext`dv$464990]], 
               "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.7837168588628391`, 
                   0.022831849549221194`, $CellContext`dv$465014]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.184109927301784, 
                   0.013847212310817128`, $CellContext`dv$465038]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.857579621802821, 
                   0.019445005311291626`, $CellContext`dv$465062]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6938628415998416`, 
                   0.020961121347663578`, $CellContext`dv$465086]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.07034057808036, 
                   0.007143839501561162, $CellContext`dv$465110]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.175093246263309, 
                   0.031160959953693012`, $CellContext`dv$465134]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.125417211390718, 
                   0.007201741751111847, $CellContext`dv$465158]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.000033057555189045025`, 
                   0.000995512774477136, $CellContext`dv$465182]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.915249835154216, 
                   0.008978279525330967, $CellContext`dv$465206]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[85856527143542]]], "ID" -> 
               85860822110838]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.00021915358694432643`, 
                   0.0061468845946855725`, $CellContext`dv$464966]], 
               "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.7151292711147926, 
                   0.0071057870447810804`, $CellContext`dv$464990]], 
               "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.7837168588628391`, 
                   0.022831849549221194`, $CellContext`dv$465014]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.184109927301784, 
                   0.013847212310817128`, $CellContext`dv$465038]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.857579621802821, 
                   0.019445005311291626`, $CellContext`dv$465062]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6938628415998416`, 
                   0.020961121347663578`, $CellContext`dv$465086]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.07034057808036, 
                   0.007143839501561162, $CellContext`dv$465110]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.175093246263309, 
                   0.031160959953693012`, $CellContext`dv$465134]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.125417211390718, 
                   0.007201741751111847, $CellContext`dv$465158]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.000033057555189045025`, 
                   0.000995512774477136, $CellContext`dv$465182]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.915249835154216, 
                   0.008978279525330967, $CellContext`dv$465206]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[85856527143542]]], "ID" -> 
               85860822110838]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[50]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[297132124], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[297132124]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1183658232][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1183658232][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{"2", "\"(\"", "158", "\")\[Times]\"", 
                    TemplateBox[{"10", 
                    RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
                    SuperscriptBox]}, "RowDefault"], ShowStringCharacters -> 
                    False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.00021915358694432643`, 
                    0.0061468845946855725`, $CellContext`dv$464966]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.715\"", 0.7151292711147926, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.7151292711147926, 
                    0.0071057870447810804`, $CellContext`dv$464990]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.784\"", 1.7837168588628391`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.7837168588628391`, 
                    0.022831849549221194`, $CellContext`dv$465014]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.184\"", 3.184109927301784, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "36", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.184109927301784, 
                    0.013847212310817128`, $CellContext`dv$465038]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.858\"", 4.857579621802821, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "50", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.857579621802821, 
                    0.019445005311291626`, $CellContext`dv$465062]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.694\"", 2.6938628415998416`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "54", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.6938628415998416`, 
                    0.020961121347663578`, $CellContext`dv$465086]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.070\"", 2.07034057808036, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.07034057808036, 
                    0.007143839501561162, $CellContext`dv$465110]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.175\"", 2.175093246263309, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "80", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.175093246263309, 
                    0.031160959953693012`, $CellContext`dv$465134]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.125\"", 2.125417211390718, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "19", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.125417211390718, 
                    0.007201741751111847, $CellContext`dv$465158]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    RowBox[{"-", "3"}], "\"(\"", "256", "\")\[Times]\"", 
                    TemplateBox[{"10", 
                    RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
                    SuperscriptBox]}, "RowDefault"], ShowStringCharacters -> 
                    False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.000033057555189045025`, 
                    0.000995512774477136, $CellContext`dv$465182]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.915\"", 4.915249835154216, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "23", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.915249835154216, 
                    0.008978279525330967, $CellContext`dv$465206]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1183658232][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1183658232]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1183658232][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1183658232][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {199., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->587891839,ExpressionUUID->"55b27a43-1689-4780-9db9-0998f471e33c"]
}, Open  ]],

Cell[TextData[{
 "Specify to use a quadratric term (",
 StyleBox["y=b*x+c*", "InlineCode",
  FontSlant->"Italic"],
 StyleBox[Cell[BoxData[
  SuperscriptBox["x", "2"]], "InlineCode", "InlineFormula",
  FontSlant->"Italic",ExpressionUUID->"df5ac7cc-9eae-49d3-a7dc-e854f5a00926"],
   "InlineCode"],
 ") in the calibration curve expression if needed:"
}], "ExampleText",
 CellID->650993065,ExpressionUUID->"674786a9-8041-4137-8c06-9612b544a069"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->23475826,ExpressionUUID->"d4752c4b-6609-4031-9378-073500e925c8"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.00018226158062689592`, 
                  0.005112164584831015, $CellContext`dv$466930]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.6138024044071496, 
                  0.007917142262382172, $CellContext`dv$466959]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.6019205846068059`, 
                  0.026241545945760465`, $CellContext`dv$466988]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.0418818962118914`, 
                  0.038554722417009774`, $CellContext`dv$467017]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 5.039085368236059, 
                  0.0918856389765869, $CellContext`dv$467046]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.562145538920838, 
                  0.032763367019370195`, $CellContext`dv$467075]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9530797789148655`, 
                  0.017569440490923658`, $CellContext`dv$467104]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.069477215216399, 
                  0.03546287915504332, $CellContext`dv$467133]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.031366643184223, 
                  0.017573303464789723`, $CellContext`dv$467162]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.00003058744206643205, 
                  0.0009211259803433965, $CellContext`dv$467191]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.993307476568887, 
                  0.059592248492045224`, $CellContext`dv$467220]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[108456645055106]]], "ID" -> 
              108460940022402]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.00018226158062689592`, 
                  0.005112164584831015, $CellContext`dv$466930]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.6138024044071496, 
                  0.007917142262382172, $CellContext`dv$466959]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.6019205846068059`, 
                  0.026241545945760465`, $CellContext`dv$466988]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.0418818962118914`, 
                  0.038554722417009774`, $CellContext`dv$467017]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 5.039085368236059, 
                  0.0918856389765869, $CellContext`dv$467046]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.562145538920838, 
                  0.032763367019370195`, $CellContext`dv$467075]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9530797789148655`, 
                  0.017569440490923658`, $CellContext`dv$467104]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.069477215216399, 
                  0.03546287915504332, $CellContext`dv$467133]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.031366643184223, 
                  0.017573303464789723`, $CellContext`dv$467162]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.00003058744206643205, 
                  0.0009211259803433965, $CellContext`dv$467191]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.993307476568887, 
                  0.059592248492045224`, $CellContext`dv$467220]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[108456645055106]]], "ID" -> 
              108460940022402]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.00018226158062689592`, 
                   0.005112164584831015, $CellContext`dv$466930]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.6138024044071496, 
                   0.007917142262382172, $CellContext`dv$466959]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.6019205846068059`, 
                   0.026241545945760465`, $CellContext`dv$466988]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.0418818962118914`, 
                   0.038554722417009774`, $CellContext`dv$467017]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  5.039085368236059, 
                   0.0918856389765869, $CellContext`dv$467046]], "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.562145538920838, 
                   0.032763367019370195`, $CellContext`dv$467075]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9530797789148655`, 
                   0.017569440490923658`, $CellContext`dv$467104]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.069477215216399, 
                   0.03546287915504332, $CellContext`dv$467133]], "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.031366643184223, 
                   0.017573303464789723`, $CellContext`dv$467162]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.00003058744206643205, 
                   0.0009211259803433965, $CellContext`dv$467191]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.993307476568887, 
                   0.059592248492045224`, $CellContext`dv$467220]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[108456645055106]]], "ID" -> 
               108460940022402]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.00018226158062689592`, 
                   0.005112164584831015, $CellContext`dv$466930]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.6138024044071496, 
                   0.007917142262382172, $CellContext`dv$466959]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.6019205846068059`, 
                   0.026241545945760465`, $CellContext`dv$466988]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.0418818962118914`, 
                   0.038554722417009774`, $CellContext`dv$467017]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  5.039085368236059, 
                   0.0918856389765869, $CellContext`dv$467046]], "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.562145538920838, 
                   0.032763367019370195`, $CellContext`dv$467075]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9530797789148655`, 
                   0.017569440490923658`, $CellContext`dv$467104]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.069477215216399, 
                   0.03546287915504332, $CellContext`dv$467133]], "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.031366643184223, 
                   0.017573303464789723`, $CellContext`dv$467162]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.00003058744206643205, 
                   0.0009211259803433965, $CellContext`dv$467191]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.993307476568887, 
                   0.059592248492045224`, $CellContext`dv$467220]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[108456645055106]]], "ID" -> 
               108460940022402]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[51]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[1901207685], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1901207685]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1524249790][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1524249790][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{"2", "\"(\"", "132", "\")\[Times]\"", 
                    TemplateBox[{"10", 
                    RowBox[{"-", "4"}]}, "Superscript", SyntaxForm -> 
                    SuperscriptBox]}, "RowDefault"], ShowStringCharacters -> 
                    False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.00018226158062689592`, 
                    0.005112164584831015, $CellContext`dv$466930]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.614\"", 0.6138024044071496, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.6138024044071496, 
                    0.007917142262382172, $CellContext`dv$466959]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.602\"", 1.6019205846068059`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "68", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.6019205846068059`, 
                    0.026241545945760465`, $CellContext`dv$466988]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.042\"", 3.0418818962118914`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "99", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.0418818962118914`, 
                    0.038554722417009774`, $CellContext`dv$467017]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"5.04\"", 5.039085368236059, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    5.039085368236059, 
                    0.0918856389765869, $CellContext`dv$467046]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.562\"", 2.562145538920838, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "84", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.562145538920838, 
                    0.032763367019370195`, $CellContext`dv$467075]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.953\"", 1.9530797789148655`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "45", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.9530797789148655`, 
                    0.017569440490923658`, $CellContext`dv$467104]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.069\"", 2.069477215216399, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "91", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.069477215216399, 
                    0.03546287915504332, $CellContext`dv$467133]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.031\"", 2.031366643184223, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "45", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.031366643184223, 
                    0.017573303464789723`, $CellContext`dv$467162]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    RowBox[{"-", "3"}], "\"(\"", "237", "\")\[Times]\"", 
                    TemplateBox[{"10", 
                    RowBox[{"-", "5"}]}, "Superscript", SyntaxForm -> 
                    SuperscriptBox]}, "RowDefault"], ShowStringCharacters -> 
                    False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.00003058744206643205, 
                    0.0009211259803433965, $CellContext`dv$467191]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.993307476568887, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "15", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.993307476568887, 
                    0.059592248492045224`, $CellContext`dv$467220]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1524249790][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1524249790]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1524249790][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1524249790][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {199., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->539008241,ExpressionUUID->"ee622077-ab47-4c36-bfd9-5031a4db0578"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "BlankPattern",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "5d934a3b-217c-44df-8ece-460a859b35b5"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"fcf22ca5-133f-4057-94e0-83b74d556746"],

Cell["\<\
By default, no blank substraction is applied to the measurements:\
\>", "ExampleText",
 CellID->47380013,ExpressionUUID->"dbabe822-ecda-426b-8506-bc8df4bd0b4e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->504523589,ExpressionUUID->"ebcc71d8-2c75-455c-95de-7f1b171da812"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.2266746385108589, 
                  0.009749209933377034, $CellContext`dv$431795]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5048310104682022, 
                  0.011625046880209993`, $CellContext`dv$431827]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613315241321771, 
                  0.03100932962733708, $CellContext`dv$431859]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112486989422588, 
                  0.0451530608250505, $CellContext`dv$431891]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992484121857599, 
                  0.08952185118099182, $CellContext`dv$431923]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6029085793185316`, 
                  0.04055275373982494, $CellContext`dv$431955]], "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9705428303601253`, 
                  0.025910282273252986`, $CellContext`dv$431987]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0850769611916604`, 
                  0.04130427865042333, $CellContext`dv$432019]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.04188953528543, 
                  0.026912047557499087`, $CellContext`dv$432051]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019363332039608938`, 
                  0.008483314123597686, $CellContext`dv$432083]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992484121857599, 
                  0.08761001464282478, $CellContext`dv$432115]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[182974327639483]]], "ID" -> 
              182978622606779]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.2266746385108589, 
                  0.009749209933377034, $CellContext`dv$431795]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5048310104682022, 
                  0.011625046880209993`, $CellContext`dv$431827]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613315241321771, 
                  0.03100932962733708, $CellContext`dv$431859]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112486989422588, 
                  0.0451530608250505, $CellContext`dv$431891]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992484121857599, 
                  0.08952185118099182, $CellContext`dv$431923]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6029085793185316`, 
                  0.04055275373982494, $CellContext`dv$431955]], "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9705428303601253`, 
                  0.025910282273252986`, $CellContext`dv$431987]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0850769611916604`, 
                  0.04130427865042333, $CellContext`dv$432019]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.04188953528543, 
                  0.026912047557499087`, $CellContext`dv$432051]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019363332039608938`, 
                  0.008483314123597686, $CellContext`dv$432083]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992484121857599, 
                  0.08761001464282478, $CellContext`dv$432115]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[182974327639483]]], "ID" -> 
              182978622606779]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.2266746385108589, 
                   0.009749209933377034, $CellContext`dv$431795]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5048310104682022, 
                   0.011625046880209993`, $CellContext`dv$431827]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613315241321771, 
                   0.03100932962733708, $CellContext`dv$431859]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112486989422588, 
                   0.0451530608250505, $CellContext`dv$431891]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992484121857599, 
                   0.08952185118099182, $CellContext`dv$431923]], "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6029085793185316`, 
                   0.04055275373982494, $CellContext`dv$431955]], "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9705428303601253`, 
                   0.025910282273252986`, $CellContext`dv$431987]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0850769611916604`, 
                   0.04130427865042333, $CellContext`dv$432019]], "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.04188953528543, 
                   0.026912047557499087`, $CellContext`dv$432051]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019363332039608938`, 
                   0.008483314123597686, $CellContext`dv$432083]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992484121857599, 
                   0.08761001464282478, $CellContext`dv$432115]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[182974327639483]]], "ID" -> 
               182978622606779]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.2266746385108589, 
                   0.009749209933377034, $CellContext`dv$431795]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5048310104682022, 
                   0.011625046880209993`, $CellContext`dv$431827]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613315241321771, 
                   0.03100932962733708, $CellContext`dv$431859]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112486989422588, 
                   0.0451530608250505, $CellContext`dv$431891]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992484121857599, 
                   0.08952185118099182, $CellContext`dv$431923]], "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6029085793185316`, 
                   0.04055275373982494, $CellContext`dv$431955]], "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9705428303601253`, 
                   0.025910282273252986`, $CellContext`dv$431987]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0850769611916604`, 
                   0.04130427865042333, $CellContext`dv$432019]], "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.04188953528543, 
                   0.026912047557499087`, $CellContext`dv$432051]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019363332039608938`, 
                   0.008483314123597686, $CellContext`dv$432083]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992484121857599, 
                   0.08761001464282478, $CellContext`dv$432115]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[182974327639483]]], "ID" -> 
               182978622606779]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[45]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[174767504], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[174767504]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1373850244][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1373850244][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.227\"", -0.2266746385108589, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "25", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.2266746385108589, 
                    0.009749209933377034, $CellContext`dv$431795]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.505\"", 0.5048310104682022, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "30", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.5048310104682022, 
                    0.011625046880209993`, $CellContext`dv$431827]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.613\"", 1.613315241321771, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "80", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.613315241321771, 
                    0.03100932962733708, $CellContext`dv$431859]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.11\"", 3.112486989422588, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "12", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.112486989422588, 
                    0.0451530608250505, $CellContext`dv$431891]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.992484121857599, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "23", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.992484121857599, 
                    0.08952185118099182, $CellContext`dv$431923]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.60\"", 2.6029085793185316`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "10", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.6029085793185316`, 
                    0.04055275373982494, $CellContext`dv$431955]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.971\"", 1.9705428303601253`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "67", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.9705428303601253`, 
                    0.025910282273252986`, $CellContext`dv$431987]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.09\"", 2.0850769611916604`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.0850769611916604`, 
                    0.04130427865042333, $CellContext`dv$432019]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.042\"", 2.04188953528543, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "69", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.04188953528543, 
                    0.026912047557499087`, $CellContext`dv$432051]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.019\"", -0.019363332039608938`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "22", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[-0.019363332039608938`, 
                    0.008483314123597686, $CellContext`dv$432083]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.992484121857599, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "23", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.992484121857599, 
                    0.08761001464282478, $CellContext`dv$432115]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1373850244][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1373850244]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1373850244][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1373850244][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {187., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->578155565,ExpressionUUID->"607db501-1dc1-46f6-a30e-aaeac3760159"]
}, Open  ]],

Cell[TextData[{
 "Specifying a string pattern for the keys of the blank measurements leads to \
the substraction of interpolated blank values from all measurements when \
using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrateCompositionalData"]],
    "paclet:DataAnalysis/ref/CalibrateCompositionalData"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "6a969836-f50e-4e08-a817-112bb9859666"],
 ":"
}], "ExampleText",
 CellID->743683371,ExpressionUUID->"20ae500e-7dc3-4e52-bc27-0e4c6a20c4a5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->82404788,ExpressionUUID->"e072ee77-2dd5-44d0-b392-aa8e9fd00699"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22671109651240204`, 
                  0.016133598728604377`, $CellContext`dv$437380]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.505085356721548, 
                  0.017921828167261015`, $CellContext`dv$437414]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613806140707826, 
                  0.03869735056006944, $CellContext`dv$437448]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112949605710551, 
                  0.06292559103956663, $CellContext`dv$437482]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12111731684957971`, $CellContext`dv$437516]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.603240200398011, 
                  0.048865766217893576`, $CellContext`dv$437550]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9707776677963589`, 
                  0.030896600392822875`, $CellContext`dv$437584]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0852688522822533`, 
                  0.044207316264084216`, $CellContext`dv$437618]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.042036066525968, 
                  0.03003457664039987, $CellContext`dv$437652]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019357837373813518`, 
                  0.009438202591552744, $CellContext`dv$437686]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.99247000650331, 
                  0.091372761188262, $CellContext`dv$437720]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[176892653948388]]], "ID" -> 
              176896948915684]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22671109651240204`, 
                  0.016133598728604377`, $CellContext`dv$437380]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.505085356721548, 
                  0.017921828167261015`, $CellContext`dv$437414]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613806140707826, 
                  0.03869735056006944, $CellContext`dv$437448]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112949605710551, 
                  0.06292559103956663, $CellContext`dv$437482]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12111731684957971`, $CellContext`dv$437516]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.603240200398011, 
                  0.048865766217893576`, $CellContext`dv$437550]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9707776677963589`, 
                  0.030896600392822875`, $CellContext`dv$437584]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0852688522822533`, 
                  0.044207316264084216`, $CellContext`dv$437618]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.042036066525968, 
                  0.03003457664039987, $CellContext`dv$437652]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019357837373813518`, 
                  0.009438202591552744, $CellContext`dv$437686]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.99247000650331, 
                  0.091372761188262, $CellContext`dv$437720]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[176892653948388]]], "ID" -> 
              176896948915684]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22671109651240204`, 
                   0.016133598728604377`, $CellContext`dv$437380]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.505085356721548, 
                   0.017921828167261015`, $CellContext`dv$437414]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613806140707826, 
                   0.03869735056006944, $CellContext`dv$437448]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112949605710551, 
                   0.06292559103956663, $CellContext`dv$437482]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12111731684957971`, $CellContext`dv$437516]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.603240200398011, 
                   0.048865766217893576`, $CellContext`dv$437550]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9707776677963589`, 
                   0.030896600392822875`, $CellContext`dv$437584]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0852688522822533`, 
                   0.044207316264084216`, $CellContext`dv$437618]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.042036066525968, 
                   0.03003457664039987, $CellContext`dv$437652]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019357837373813518`, 
                   0.009438202591552744, $CellContext`dv$437686]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.99247000650331, 
                   0.091372761188262, $CellContext`dv$437720]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[176892653948388]]], "ID" -> 
               176896948915684]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22671109651240204`, 
                   0.016133598728604377`, $CellContext`dv$437380]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.505085356721548, 
                   0.017921828167261015`, $CellContext`dv$437414]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613806140707826, 
                   0.03869735056006944, $CellContext`dv$437448]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112949605710551, 
                   0.06292559103956663, $CellContext`dv$437482]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12111731684957971`, $CellContext`dv$437516]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.603240200398011, 
                   0.048865766217893576`, $CellContext`dv$437550]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9707776677963589`, 
                   0.030896600392822875`, $CellContext`dv$437584]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0852688522822533`, 
                   0.044207316264084216`, $CellContext`dv$437618]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.042036066525968, 
                   0.03003457664039987, $CellContext`dv$437652]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019357837373813518`, 
                   0.009438202591552744, $CellContext`dv$437686]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.99247000650331, 
                   0.091372761188262, $CellContext`dv$437720]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[176892653948388]]], "ID" -> 
               176896948915684]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[46]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[933047307], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[933047307]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1846927498][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1846927498][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.227\"", -0.22671109651240204`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "42", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.22671109651240204`, 
                    0.016133598728604377`, $CellContext`dv$437380]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.505\"", 0.505085356721548, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "46", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.505085356721548, 
                    0.017921828167261015`, $CellContext`dv$437414]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.614\"", 1.613806140707826, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "100", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.613806140707826, 
                    0.03869735056006944, $CellContext`dv$437448]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.11\"", 3.112949605710551, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.112949605710551, 
                    0.06292559103956663, $CellContext`dv$437482]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.992377480653775, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "31", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.992377480653775, 
                    0.12111731684957971`, $CellContext`dv$437516]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.60\"", 2.603240200398011, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "13", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.603240200398011, 
                    0.048865766217893576`, $CellContext`dv$437550]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.971\"", 1.9707776677963589`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "80", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.9707776677963589`, 
                    0.030896600392822875`, $CellContext`dv$437584]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.09\"", 2.0852688522822533`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.0852688522822533`, 
                    0.044207316264084216`, $CellContext`dv$437618]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.042\"", 2.042036066525968, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "77", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.042036066525968, 
                    0.03003457664039987, $CellContext`dv$437652]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.019\"", -0.019357837373813518`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[-0.019357837373813518`, 
                    0.009438202591552744, $CellContext`dv$437686]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.99247000650331, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.99247000650331, 
                    0.091372761188262, $CellContext`dv$437720]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1846927498][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1846927498][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {187., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->683653819,ExpressionUUID->"e70b3cce-c2a0-4523-82b0-f6fe90f5a26e"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "DriftStandard",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "5860ce3b-524d-4f48-9765-2c974305531e"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"f3903b8f-d9d4-43b4-8a0e-e97c0bb8401f"],

Cell["By default, no drift standard is used:", "ExampleText",
 CellID->119144940,ExpressionUUID->"60e5fb06-00f2-4774-86eb-ea21021bf3da"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->742452924,ExpressionUUID->"964bff1d-edde-48d3-bfa6-c6537f657d2f"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22692875788967562`, 
                  0.01611751422580977, $CellContext`dv$445095]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5054637038677795, 
                  0.017852546706415732`, $CellContext`dv$445127]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.61463063350567, 
                  0.03841334496548393, $CellContext`dv$445159]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.1137726692092413`, 
                  0.06234274944264964, $CellContext`dv$445191]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12041674433152219`, $CellContext`dv$445223]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6011932822628343`, 
                  0.04862816091510891, $CellContext`dv$445255]], "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9682217031411664`, 
                  0.030778757902164056`, $CellContext`dv$445287]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.082007078497643, 
                  0.04410114046292259, $CellContext`dv$445319]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0383342236940774`, 
                  0.029955033242908678`, $CellContext`dv$445351]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019326694199508693`, 
                  0.009438109675628123, $CellContext`dv$445383]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.9803240689734976`, 
                  0.09100527926495237, $CellContext`dv$445415]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[240505414569539]]], "ID" -> 
              240509709536835]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22692875788967562`, 
                  0.01611751422580977, $CellContext`dv$445095]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5054637038677795, 
                  0.017852546706415732`, $CellContext`dv$445127]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.61463063350567, 
                  0.03841334496548393, $CellContext`dv$445159]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.1137726692092413`, 
                  0.06234274944264964, $CellContext`dv$445191]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12041674433152219`, $CellContext`dv$445223]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.6011932822628343`, 
                  0.04862816091510891, $CellContext`dv$445255]], "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9682217031411664`, 
                  0.030778757902164056`, $CellContext`dv$445287]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.082007078497643, 
                  0.04410114046292259, $CellContext`dv$445319]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0383342236940774`, 
                  0.029955033242908678`, $CellContext`dv$445351]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019326694199508693`, 
                  0.009438109675628123, $CellContext`dv$445383]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.9803240689734976`, 
                  0.09100527926495237, $CellContext`dv$445415]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[240505414569539]]], "ID" -> 
              240509709536835]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22692875788967562`, 
                   0.01611751422580977, $CellContext`dv$445095]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5054637038677795, 
                   0.017852546706415732`, $CellContext`dv$445127]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.61463063350567, 
                   0.03841334496548393, $CellContext`dv$445159]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.1137726692092413`, 
                   0.06234274944264964, $CellContext`dv$445191]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12041674433152219`, $CellContext`dv$445223]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6011932822628343`, 
                   0.04862816091510891, $CellContext`dv$445255]], "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9682217031411664`, 
                   0.030778757902164056`, $CellContext`dv$445287]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.082007078497643, 
                   0.04410114046292259, $CellContext`dv$445319]], "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0383342236940774`, 
                   0.029955033242908678`, $CellContext`dv$445351]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019326694199508693`, 
                   0.009438109675628123, $CellContext`dv$445383]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.9803240689734976`, 
                   0.09100527926495237, $CellContext`dv$445415]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[240505414569539]]], "ID" -> 
               240509709536835]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22692875788967562`, 
                   0.01611751422580977, $CellContext`dv$445095]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5054637038677795, 
                   0.017852546706415732`, $CellContext`dv$445127]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.61463063350567, 
                   0.03841334496548393, $CellContext`dv$445159]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.1137726692092413`, 
                   0.06234274944264964, $CellContext`dv$445191]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12041674433152219`, $CellContext`dv$445223]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.6011932822628343`, 
                   0.04862816091510891, $CellContext`dv$445255]], "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9682217031411664`, 
                   0.030778757902164056`, $CellContext`dv$445287]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.082007078497643, 
                   0.04410114046292259, $CellContext`dv$445319]], "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0383342236940774`, 
                   0.029955033242908678`, $CellContext`dv$445351]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019326694199508693`, 
                   0.009438109675628123, $CellContext`dv$445383]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.9803240689734976`, 
                   0.09100527926495237, $CellContext`dv$445415]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[240505414569539]]], "ID" -> 
               240509709536835]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[47]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[560153783], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[560153783]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    2066116934][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    2066116934][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.227\"", -0.22692875788967562`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "42", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.22692875788967562`, 
                    0.01611751422580977, $CellContext`dv$445095]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.505\"", 0.5054637038677795, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "46", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.5054637038677795, 
                    0.017852546706415732`, $CellContext`dv$445127]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.615\"", 1.61463063350567, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "99", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.61463063350567, 
                    0.03841334496548393, $CellContext`dv$445159]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.11\"", 3.1137726692092413`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.1137726692092413`, 
                    0.06234274944264964, $CellContext`dv$445191]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.992377480653775, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "31", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.992377480653775, 
                    0.12041674433152219`, $CellContext`dv$445223]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.60\"", 2.6011932822628343`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "13", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.6011932822628343`, 
                    0.04862816091510891, $CellContext`dv$445255]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.968\"", 1.9682217031411664`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "79", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.9682217031411664`, 
                    0.030778757902164056`, $CellContext`dv$445287]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.08\"", 2.082007078497643, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.082007078497643, 
                    0.04410114046292259, $CellContext`dv$445319]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.038\"", 2.0383342236940774`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "77", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.0383342236940774`, 
                    0.029955033242908678`, $CellContext`dv$445351]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.019\"", -0.019326694199508693`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[-0.019326694199508693`, 
                    0.009438109675628123, $CellContext`dv$445383]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.98\"", 4.9803240689734976`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "23", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.9803240689734976`, 
                    0.09100527926495237, $CellContext`dv$445415]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2066116934][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2066116934]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[2066116934][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[2066116934][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {187., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->269374997,ExpressionUUID->"14200e45-897c-4c79-bfb5-f1851eab7a7d"]
}, Open  ]],

Cell[TextData[{
 "Specifying a string pattern for the keys of a drift standard leads to the \
use of this standard as a \"drift standard\". This means that measurements \
whose key contains the string \"DRIFT\" (or the same pattern as specified as ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DriftStandard"]],"paclet:DataAnalysis/ref/DriftStandard"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "b799349b-1d85-4139-805a-82e5415bbf45"],
 ") are regarded as repeat measurements of this standard, and are used to \
re-calibrate the slope of the calibration curve."
}], "ExampleText",
 CellID->399699711,ExpressionUUID->"22c3587b-35f5-437f-97e3-f508d69b3fa2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->7580745,ExpressionUUID->"40b8eeb2-26c5-4a1e-9739-9167650d380a"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22671109651240204`, 
                  0.016133598728604377`, $CellContext`dv$437380]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.505085356721548, 
                  0.017921828167261015`, $CellContext`dv$437414]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613806140707826, 
                  0.03869735056006944, $CellContext`dv$437448]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112949605710551, 
                  0.06292559103956663, $CellContext`dv$437482]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12111731684957971`, $CellContext`dv$437516]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.603240200398011, 
                  0.048865766217893576`, $CellContext`dv$437550]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9707776677963589`, 
                  0.030896600392822875`, $CellContext`dv$437584]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0852688522822533`, 
                  0.044207316264084216`, $CellContext`dv$437618]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.042036066525968, 
                  0.03003457664039987, $CellContext`dv$437652]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019357837373813518`, 
                  0.009438202591552744, $CellContext`dv$437686]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.99247000650331, 
                  0.091372761188262, $CellContext`dv$437720]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[176892653948388]]], "ID" -> 
              176896948915684]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22671109651240204`, 
                  0.016133598728604377`, $CellContext`dv$437380]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.505085356721548, 
                  0.017921828167261015`, $CellContext`dv$437414]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613806140707826, 
                  0.03869735056006944, $CellContext`dv$437448]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112949605710551, 
                  0.06292559103956663, $CellContext`dv$437482]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12111731684957971`, $CellContext`dv$437516]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.603240200398011, 
                  0.048865766217893576`, $CellContext`dv$437550]], 
              "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9707776677963589`, 
                  0.030896600392822875`, $CellContext`dv$437584]], 
              "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0852688522822533`, 
                  0.044207316264084216`, $CellContext`dv$437618]], 
              "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.042036066525968, 
                  0.03003457664039987, $CellContext`dv$437652]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019357837373813518`, 
                  0.009438202591552744, $CellContext`dv$437686]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.99247000650331, 
                  0.091372761188262, $CellContext`dv$437720]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[176892653948388]]], "ID" -> 
              176896948915684]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22671109651240204`, 
                   0.016133598728604377`, $CellContext`dv$437380]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.505085356721548, 
                   0.017921828167261015`, $CellContext`dv$437414]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613806140707826, 
                   0.03869735056006944, $CellContext`dv$437448]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112949605710551, 
                   0.06292559103956663, $CellContext`dv$437482]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12111731684957971`, $CellContext`dv$437516]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.603240200398011, 
                   0.048865766217893576`, $CellContext`dv$437550]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9707776677963589`, 
                   0.030896600392822875`, $CellContext`dv$437584]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0852688522822533`, 
                   0.044207316264084216`, $CellContext`dv$437618]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.042036066525968, 
                   0.03003457664039987, $CellContext`dv$437652]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019357837373813518`, 
                   0.009438202591552744, $CellContext`dv$437686]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.99247000650331, 
                   0.091372761188262, $CellContext`dv$437720]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[176892653948388]]], "ID" -> 
               176896948915684]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22671109651240204`, 
                   0.016133598728604377`, $CellContext`dv$437380]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.505085356721548, 
                   0.017921828167261015`, $CellContext`dv$437414]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613806140707826, 
                   0.03869735056006944, $CellContext`dv$437448]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112949605710551, 
                   0.06292559103956663, $CellContext`dv$437482]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12111731684957971`, $CellContext`dv$437516]], 
               "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.603240200398011, 
                   0.048865766217893576`, $CellContext`dv$437550]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9707776677963589`, 
                   0.030896600392822875`, $CellContext`dv$437584]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0852688522822533`, 
                   0.044207316264084216`, $CellContext`dv$437618]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.042036066525968, 
                   0.03003457664039987, $CellContext`dv$437652]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019357837373813518`, 
                   0.009438202591552744, $CellContext`dv$437686]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.99247000650331, 
                   0.091372761188262, $CellContext`dv$437720]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[176892653948388]]], "ID" -> 
               176896948915684]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[46]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[933047307], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[933047307]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1846927498][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1846927498][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.227\"", -0.22671109651240204`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "42", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.22671109651240204`, 
                    0.016133598728604377`, $CellContext`dv$437380]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.505\"", 0.505085356721548, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "46", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.505085356721548, 
                    0.017921828167261015`, $CellContext`dv$437414]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.614\"", 1.613806140707826, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "100", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.613806140707826, 
                    0.03869735056006944, $CellContext`dv$437448]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.11\"", 3.112949605710551, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.112949605710551, 
                    0.06292559103956663, $CellContext`dv$437482]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.992377480653775, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "31", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.992377480653775, 
                    0.12111731684957971`, $CellContext`dv$437516]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.60\"", 2.603240200398011, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "13", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.603240200398011, 
                    0.048865766217893576`, $CellContext`dv$437550]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.971\"", 1.9707776677963589`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "80", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.9707776677963589`, 
                    0.030896600392822875`, $CellContext`dv$437584]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.09\"", 2.0852688522822533`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.0852688522822533`, 
                    0.044207316264084216`, $CellContext`dv$437618]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.042\"", 2.042036066525968, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "77", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.042036066525968, 
                    0.03003457664039987, $CellContext`dv$437652]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.019\"", -0.019357837373813518`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[-0.019357837373813518`, 
                    0.009438202591552744, $CellContext`dv$437686]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.99247000650331, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.99247000650331, 
                    0.091372761188262, $CellContext`dv$437720]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1846927498][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1846927498]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1846927498][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1846927498][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {187., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->158347717,ExpressionUUID->"732b2efc-7290-4427-930f-03a87be49ed8"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"80aff937-b5f7-443b-89ae-da001d4d7f0b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"dd251b85-2824-4de3-b044-661b1e0c7f6c"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"a46df2e2-5a0a-4ee9-a34a-77b9a1c4a4a7"],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["CalibrationPlot"]],"paclet:DataAnalysis/ref/CalibrationPlot"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> 
    "Verdana"}]], \
"InlineFormula",ExpressionUUID->"db8b68c0-11c1-4d03-9303-6358a043a71f"]], \
"SeeAlso",
 CellID->929782353,ExpressionUUID->"14af7942-7f25-4312-ab66-6b8342e26b03"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"2347221a-330c-4865-81fb-0146579d6a74"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"f897bce5-d10e-4f53-ae2d-5ce4d787e4c9"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"fab68e6d-4136-447e-aa16-35400acc2bd0"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->629679051,ExpressionUUID->"b6980d34-39d0-44f7-93d8-b5edb502de2a"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"6a600f23-f41d-411c-a4b1-ca1d0f6348fc"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CalibrateCompositionalData",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 35, 55.2063285}", 
    "history" -> {"XX", "", "", ""}, "context" -> 
    "DataAnalysis`CompositionalAnalysis`", "keywords" -> {}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "CalibrateCompositionalData[datatable,standardData,{column1,column2,...}] \
calibrates the measurements for the compounds in a set of columns in a \
DataTable using the standardData.", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "CalibrateCompositionalData", "titlemodifier" -> "", 
    "windowtitle" -> "CalibrateCompositionalData", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/CalibrateCompositionalData"}, "SearchTextTranslated" -> 
  "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[13281, 343, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"79ca33a0-dddd-4a40-9fb2-0576dd6bef0c",
   CellTags->"PrimaryExamplesSection",
   CellID->66112022]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 602728, 12647}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 4222, 96, 55, "AnchorBarGrid",ExpressionUUID->"2d119f2a-95f6-4837-b767-c5a7a89ff6db",
 CellID->1],
Cell[CellGroupData[{
Cell[4845, 121, 411, 9, 52, "ObjectNameGrid",ExpressionUUID->"43d21c6e-c822-4eed-bdc6-643c0fc0d0d4"],
Cell[5259, 132, 1569, 40, 132, "Usage",ExpressionUUID->"fd34056c-0d25-484a-9022-3479d54600b6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6865, 177, 855, 21, 37, "NotesSection",ExpressionUUID->"f1081f79-b031-4221-8949-c79e8d113c44",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->262620297],
Cell[7723, 200, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"418eb171-8a56-4c1c-a358-4ebb411e98b1"],
Cell[7812, 202, 554, 12, 70, "Notes",ExpressionUUID->"fb7ec5b3-02c5-4e0b-a5dc-9bd4b9bde873",
 CellID->9613756],
Cell[8369, 216, 689, 19, 70, "Notes",ExpressionUUID->"5d9d9494-7861-4e9d-a238-e85205fa919a",
 CellID->268649051],
Cell[9061, 237, 324, 5, 70, "Notes",ExpressionUUID->"269f31c3-ee13-477d-a686-bb17007ff9b0",
 CellID->639061216],
Cell[9388, 244, 1009, 24, 70, "Notes",ExpressionUUID->"07dead20-4e27-4fb2-b922-5134dd87ba54",
 CellID->30105571],
Cell[10400, 270, 388, 10, 70, "Notes",ExpressionUUID->"aeb286dc-272e-48d1-a253-bbc271d91cad",
 CellID->355868542],
Cell[10791, 282, 108, 0, 70, "Notes",ExpressionUUID->"310b1392-375d-40cd-97b8-c66e28f09111"],
Cell[10902, 284, 2253, 52, 70, "3ColumnTableMod",ExpressionUUID->"c359a8b1-06f5-400e-9183-cd03350a60ae"],
Cell[13158, 338, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"0333d93e-9556-4eb9-adee-1dfabd498bef"]
}, Closed]],
Cell[CellGroupData[{
Cell[13281, 343, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"79ca33a0-dddd-4a40-9fb2-0576dd6bef0c",
 CellTags->"PrimaryExamplesSection",
 CellID->66112022],
Cell[CellGroupData[{
Cell[13740, 358, 307, 7, 29, "ExampleSection",ExpressionUUID->"21659314-2eca-49cf-bcd7-aff0f7f9f4bf",
 CellID->77406727],
Cell[14050, 367, 235, 4, 57, "ExampleText",ExpressionUUID->"e76f1f28-5616-45fa-95ff-bbd580d61c3d",
 CellID->3921242],
Cell[CellGroupData[{
Cell[14310, 375, 1185, 30, 91, "Input",ExpressionUUID->"e431142e-a35f-47c2-b607-5f94b1a368ae",
 CellID->312812059],
Cell[15498, 407, 29147, 586, 197, "Output",ExpressionUUID->"a35c710e-bc22-4f46-ae10-6b76baf7e1be",
 CellID->531943659]
}, Open  ]],
Cell[44660, 996, 122, 1, 38, "ExampleText",ExpressionUUID->"d22c9a32-2b1b-46fe-bc3e-32f3475ebd22",
 CellID->26645253],
Cell[CellGroupData[{
Cell[44807, 1001, 6756, 173, 70, "Input",ExpressionUUID->"d7ab8855-843c-4378-b966-1ab63be6b075",
 CellID->792318828],
Cell[51566, 1176, 64929, 1328, 70, "Output",ExpressionUUID->"5f2b9877-341e-4158-ab62-a9e12b5003d3",
 CellID->335711839]
}, Open  ]],
Cell[116510, 2507, 234, 4, 70, "ExampleText",ExpressionUUID->"596fb6a3-c543-492b-bc31-e83bfd64b59b",
 CellID->262614986],
Cell[CellGroupData[{
Cell[116769, 2515, 535, 10, 70, "Input",ExpressionUUID->"68d049a4-ae10-4f91-845d-64375e1d030c",
 CellID->255783851],
Cell[117307, 2527, 52628, 1086, 70, "Output",ExpressionUUID->"e4cb4e7b-e1d9-4c59-8676-f7c18d947b30",
 CellID->996106020]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[169984, 3619, 284, 7, 70, "ExampleSection",ExpressionUUID->"f0b8e1e1-3456-48b0-8045-c62a48544b68"],
Cell[CellGroupData[{
Cell[170293, 3630, 303, 7, 70, "ExampleSubsection",ExpressionUUID->"0d52bcdb-3bd4-4262-8f38-23dbd6c920a3"],
Cell[170599, 3639, 242, 6, 70, "ExampleText",ExpressionUUID->"92760573-151f-4280-b5e8-2fc395eaad69",
 CellID->227649573],
Cell[CellGroupData[{
Cell[170866, 3649, 411, 8, 70, "Input",ExpressionUUID->"1765a3bc-f21e-439c-bfb1-f58702436eaa",
 CellID->467315169],
Cell[171280, 3659, 52621, 1090, 70, "Output",ExpressionUUID->"3467e244-49f3-4346-84b5-145bbf368ba1",
 CellID->31806462]
}, Open  ]],
Cell[223916, 4752, 248, 6, 70, "ExampleText",ExpressionUUID->"2a8d839d-b981-496b-98e8-82c32aa61bb0",
 CellID->106986945],
Cell[CellGroupData[{
Cell[224189, 4762, 473, 9, 70, "Input",ExpressionUUID->"4846e2b9-2d2d-48d9-928d-d98f62913417",
 CellID->472668707],
Cell[224665, 4773, 52624, 1085, 70, "Output",ExpressionUUID->"b97448f2-50a2-4644-88d4-03b7527828bd",
 CellID->886498528]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[277338, 5864, 303, 7, 70, "ExampleSubsection",ExpressionUUID->"612aec0e-2f48-4822-8a2b-2ad97047616c"],
Cell[277644, 5873, 242, 6, 70, "ExampleText",ExpressionUUID->"7b30bc28-04e3-4550-b38f-bf604b473b24",
 CellID->348072352],
Cell[CellGroupData[{
Cell[277911, 5883, 411, 8, 70, "Input",ExpressionUUID->"0e465587-c082-4311-a5d2-09b99e2024b7",
 CellID->847327418],
Cell[278325, 5893, 52657, 1090, 70, "Output",ExpressionUUID->"55b27a43-1689-4780-9db9-0998f471e33c",
 CellID->587891839]
}, Open  ]],
Cell[330997, 6986, 441, 10, 70, "ExampleText",ExpressionUUID->"674786a9-8041-4137-8c06-9612b544a069",
 CellID->650993065],
Cell[CellGroupData[{
Cell[331463, 7000, 472, 9, 70, "Input",ExpressionUUID->"d4752c4b-6609-4031-9378-073500e925c8",
 CellID->23475826],
Cell[331938, 7011, 52490, 1080, 70, "Output",ExpressionUUID->"ee622077-ab47-4c36-bfd9-5031a4db0578",
 CellID->539008241]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[384477, 8097, 295, 7, 70, "ExampleSubsection",ExpressionUUID->"fcf22ca5-133f-4057-94e0-83b74d556746"],
Cell[384775, 8106, 170, 3, 70, "ExampleText",ExpressionUUID->"dbabe822-ecda-426b-8506-bc8df4bd0b4e",
 CellID->47380013],
Cell[CellGroupData[{
Cell[384970, 8113, 445, 8, 70, "Input",ExpressionUUID->"ebcc71d8-2c75-455c-95de-7f1b171da812",
 CellID->504523589],
Cell[385418, 8123, 52460, 1076, 70, "Output",ExpressionUUID->"607db501-1dc1-46f6-a30e-aaeac3760159",
 CellID->578155565]
}, Open  ]],
Cell[437893, 9202, 544, 13, 70, "ExampleText",ExpressionUUID->"20ae500e-7dc3-4e52-bc27-0e4c6a20c4a5",
 CellID->743683371],
Cell[CellGroupData[{
Cell[438462, 9219, 534, 10, 70, "Input",ExpressionUUID->"e072ee77-2dd5-44d0-b392-aa8e9fd00699",
 CellID->82404788],
Cell[438999, 9231, 52626, 1086, 70, "Output",ExpressionUUID->"e70b3cce-c2a0-4523-82b0-f6fe90f5a26e",
 CellID->683653819]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[491674, 10323, 296, 7, 70, "ExampleSubsection",ExpressionUUID->"f3903b8f-d9d4-43b4-8a0e-e97c0bb8401f"],
Cell[491973, 10332, 136, 1, 70, "ExampleText",ExpressionUUID->"60e5fb06-00f2-4774-86eb-ea21021bf3da",
 CellID->119144940],
Cell[CellGroupData[{
Cell[492134, 10337, 471, 9, 70, "Input",ExpressionUUID->"964bff1d-edde-48d3-bfa6-c6537f657d2f",
 CellID->742452924],
Cell[492608, 10348, 52533, 1078, 70, "Output",ExpressionUUID->"14200e45-897c-4c79-bfb5-f1851eab7a7d",
 CellID->269374997]
}, Open  ]],
Cell[545156, 11429, 705, 13, 70, "ExampleText",ExpressionUUID->"22c3587b-35f5-437f-97e3-f508d69b3fa2",
 CellID->399699711],
Cell[CellGroupData[{
Cell[545886, 11446, 533, 10, 70, "Input",ExpressionUUID->"40b8eeb2-26c5-4a1e-9739-9167650d380a",
 CellID->7580745],
Cell[546422, 11458, 52626, 1086, 70, "Output",ExpressionUUID->"732b2efc-7290-4427-930f-03a87be49ed8",
 CellID->158347717]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[599087, 12549, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"80aff937-b5f7-443b-89ae-da001d4d7f0b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[599210, 12554, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"a46df2e2-5a0a-4ee9-a34a-77b9a1c4a4a7",
 CellID->1255426704],
Cell[599473, 12563, 369, 9, 70, "SeeAlso",ExpressionUUID->"14af7942-7f25-4312-ab66-6b8342e26b03",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[599879, 12577, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"f897bce5-d10e-4f53-ae2d-5ce4d787e4c9",
 CellID->38303248],
Cell[600148, 12586, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"fab68e6d-4136-447e-aa16-35400acc2bd0"],
Cell[600237, 12588, 247, 6, 70, "MoreAbout",ExpressionUUID->"b6980d34-39d0-44f7-93d8-b5edb502de2a",
 CellID->629679051]
}, Open  ]],
Cell[600499, 12597, 78, 0, 70, "FooterCell",ExpressionUUID->"6a600f23-f41d-411c-a4b1-ca1d0f6348fc"]
}
]
*)

(* End of internal cache information *)

