(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    240105,       5347]
NotebookOptionsPosition[    232148,       5181]
NotebookOutlinePosition[    234813,       5245]
CellTagsIndexPosition[    234726,       5240]
WindowTitle->CalibrationPlot
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "60d636f3-de61-406e-ae61-755d4689420f"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"fac8a531-4323-43e7-88fc-7215c2ae86ca"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"CalibrateCompositionalData\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/CalibrateCompositionalData"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "29543f74-a24e-42fd-a654-08ecd82d36d9"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"9c33f11f-6661-4390-a687-19d76f18c0cd"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "dc8ead7e-8de5-4e46-a1f5-5b00c082ca0f"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"2404c828-fe62-4f76-ae6c-16c5358108b4"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/CalibrationPlot\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/CalibrationPlot"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
CalibrationPlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$12443], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/CalibrationPlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "49f0773e-47f5-4921-ab22-6f3a1bff5b7e"]
    }], "AnchorBar",ExpressionUUID->"676db80c-0600-423f-99e9-76a812779d9f"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"ce07d8a2-45e7-4650-a661-e2cad91408ff"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["CalibrationPlot", "ObjectName",ExpressionUUID->
  "bc7a9f42-d488-438a-bdd0-845b7fd8148a"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"8285393f-8286-4c85-94f1-83a87d48c079"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "ddc3b5bf-09db-4024-8705-1c12666b9318"]
}], "ObjectNameGrid",ExpressionUUID->"c3eb78aa-306a-4014-b788-890d5a0072b8"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
     "CalibrationPlot"], "InlineFormula",ExpressionUUID->
      "14709f06-df4e-4b7c-bfd8-c20a84d49a33"],
     "[",
     Cell[BoxData[
      StyleBox["datatable", "TI"]], "InlineFormula",ExpressionUUID->
      "588d44d8-7fb0-4f7c-a9f4-dbddf26c568e"],
     ",",
     Cell[BoxData[
      StyleBox["standardData", "TI"]], "InlineFormula",ExpressionUUID->
      "bc5b4cce-d71d-4e62-9707-c896ea0b732d"],
     ",",
     Cell[BoxData[
      StyleBox["column", "TI"]], "InlineFormula",ExpressionUUID->
      "39ce295c-56d8-4044-be9d-8082109fd10a"],
     ",{",
     Cell[BoxData[
      SubscriptBox["standardPattern", "1"]], "InlineFormula",ExpressionUUID->
      "8871de8b-6cc5-431f-ab12-54f423248476"],
     ",",
     Cell[BoxData[
      SubscriptBox["standardPattern", "2"]], "InlineFormula",ExpressionUUID->
      "52f083f0-f967-473f-94ad-d6e8844a9d17"],
     ",",
     Cell[BoxData[
      StyleBox["\[Ellipsis]", "TR"]], "InlineFormula",ExpressionUUID->
      "40b0f044-9b25-4a15-af1e-4ae1b7118589"],
     "}]\[LineSeparator]plots the measurements in a specific column (e.g. \
compound) of the DataTable for the standards matched by each ",
     Cell[BoxData[
      SubscriptBox["standardPattern", "i"]], "InlineFormula",ExpressionUUID->
      "b4479060-cb46-4749-9480-39e29b789310"],
     " vs. the corresponding concentrations specified by the standards."
    }],ExpressionUUID->"3bc1c3be-08d9-4235-8c5e-d8b65d3474bd"]},
   {"", Cell[TextData[{
     Cell[BoxData[
     "CalibrationPlot"], "InlineFormula",ExpressionUUID->
      "255bb2b3-e440-45cb-9131-ab692e2c0c2a"],
     "[",
     Cell[BoxData[
      StyleBox["datatable", "TI"]], "InlineFormula",ExpressionUUID->
      "fc30b983-089a-41bb-a402-71e57f9bcbcf"],
     ",",
     Cell[BoxData[
      StyleBox["standardData", "TI"]], "InlineFormula",ExpressionUUID->
      "affa4723-9a39-48b5-8fcd-029a8bb92e50"],
     ",{",
     Cell[BoxData[
      SubscriptBox["column", "1"]], "InlineFormula",ExpressionUUID->
      "55a83746-a1ad-497c-84d6-9bc70c98880a"],
     ",",
     Cell[BoxData[
      SubscriptBox["column", "2"]], "InlineFormula",ExpressionUUID->
      "b4fcb94b-ccc9-4e04-95d2-86773557c5aa"],
     ",",
     Cell[BoxData[
      StyleBox["\[Ellipsis]", "TR"]], "InlineFormula",ExpressionUUID->
      "40198ed5-695e-4f77-8b55-2027ccee573b"],
     "},{",
     Cell[BoxData[
      SubscriptBox["standardPattern", "1"]], "InlineFormula",ExpressionUUID->
      "ac6743dd-225b-44cf-9db3-e2ea16e72c34"],
     ",",
     Cell[BoxData[
      SubscriptBox["standardPattern", "2"]], "InlineFormula",ExpressionUUID->
      "f2fd7a42-ae24-45b3-a683-9a540b6e97c1"],
     ",",
     Cell[BoxData[
      StyleBox["\[Ellipsis]", "TR"]], "InlineFormula",ExpressionUUID->
      "ce554409-6e31-4d39-9136-9f83a0415941"],
     "}]\[LineSeparator]plots the measurements in a series of columns (e.g. \
compounds)."
    }],ExpressionUUID->"982a58e3-80e9-4db3-8d6d-759cb97bd084"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"fe8ae8a5-29ae-4c98-b601-33d492ea1f30"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"f878fc88-9406-4aa4-8f7e-becfada2c5ce"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"a5186114-739d-46f3-a1e8-403f730fb1d7"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"4bb2744f-d9da-41ce-92dd-5307ad587ead"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->282378875,ExpressionUUID->"07c1896b-6d54-46d7-9434-f31e3c3ce706"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"45042d24-1e34-48b4-98d1-4e9a7c055088"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrationPlot"]],"paclet:DataAnalysis/ref/CalibrationPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "6ee91afc-3c3f-4593-a7e5-2a5d66dc35fc"],
 " function allows the inspection of the calibration curves for a set of \
analyses of compositional (chemical) standards of known composition."
}], "Notes",
 CellID->129691455,ExpressionUUID->"26d24f98-86d0-44c3-a846-d69731b0720f"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrationPlot"]],"paclet:DataAnalysis/ref/CalibrationPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "9d849892-9be0-4fdb-8c79-de1396beb5f1"],
 " function is closely related to the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CalibrateCompositionalData"]],
    "paclet:DataAnalysis/ref/CalibrateCompositionalData"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "964c3806-637e-4d15-9c6d-868b6c2a2bd2"],
 " function, which processes raw data of compositional (chemical) analyses \
using a set of standards of known composition to calculate concentrations of \
chemical elements, components, isotopes, etc."
}], "Notes",
 CellID->39075408,ExpressionUUID->"145f0f4d-2924-40f2-9eb6-e3363e40aafa"],

Cell["The following options can be given: ", "Notes",ExpressionUUID->"f997b615-d69b-4549-b81b-a6b66dceda10"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "d2b2b244-4c21-4dec-bd9c-0d84cccdbda6"], 
    ButtonBox["IncludeConstantBasis",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/IncludeConstantBasis"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell["\<\
IncludeConstantBasis is an option for LinearModelFit and other fitting \
functions that specifies whether a constant term should be included if not \
explicitly given in the list of basis functions.\
\>", "TableText",ExpressionUUID->"65997eb8-bf2b-47c2-a99b-0dd36797f055"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "7dbfceaa-2583-4bbe-b71e-99b531c742a7"], 
    ButtonBox["BlankPattern",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/BlankPattern"], 
    ButtonBox["Null",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Null"], Cell["\<\
BlankPattern is an option to specify a string pattern that matches the row \
keys (IDs) of all blank measurements.\
\>", "TableText",ExpressionUUID->"edd9b950-292e-479c-8dea-4ea82a8d1631"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True, 
      True}}}},ExpressionUUID->"bdfc2916-bf35-41dc-8733-6e34107f8632"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"1a9c172b-885c-4aa2-b307-947b22ff221a"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"a6a6b743-71e0-4e3e-953f-8b27b77f97bf"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount",ExpressionUUID->
  "e99fa40a-485d-4488-b3f7-8bab0117d302"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->542794083,ExpressionUUID->"e8ab11f3-5951-4ca0-aec5-ff0dcbd41b77"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "c3849fda-c7eb-407d-aa7f-87ef589ca3bf"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->341469767,ExpressionUUID->"e06f6586-b93a-4ca7-9617-773aa66723a6"],

Cell["\<\
Load known concentrations of calibration standards and measurement data (more \
than one element, isotope or compound can be used):\
\>", "ExampleText",
 CellID->3921242,ExpressionUUID->"e106559c-186a-41c4-a44d-037e474dfc45"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stds", "=", 
  RowBox[{"DataTable", "@", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<STD 1\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{"\"\<Ca / ppm\>\"", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"0.5049652620285187", ",", "0.0005222986739878592"}], 
         "]"}]}], "|>"}]}], ",", 
     RowBox[{"\"\<STD 2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{"\"\<Ca / ppm\>\"", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"1.623565252889819", ",", "0.0007242565923152135"}], "]"}]}],
        "|>"}]}], ",", 
     RowBox[{"\"\<STD 3\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{"\"\<Ca / ppm\>\"", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"3.1122617784207023", ",", "0.0011361423406811462"}], 
         "]"}]}], "|>"}]}], ",", 
     RowBox[{"\"\<STD 4\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{"\"\<Ca / ppm\>\"", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"4.993042482195919", ",", "0.001721214491302021"}], "]"}]}], 
       "|>"}]}]}], "|>"}]}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->312812059,ExpressionUUID->"3a539e43-54b4-41ca-b429-bb19de4104ef"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "STD 1" -> Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5049652620285187, 
                  0.0005222986739878592, $CellContext`dv$394787]], "STD 2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.623565252889819, 
                  0.0007242565923152135, $CellContext`dv$394788]], "STD 3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.1122617784207023`, 
                  0.0011361423406811462`, $CellContext`dv$394789]], "STD 4" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.993042482195919, 
                  0.001721214491302021, $CellContext`dv$394790]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
             Association["ID" -> 37306216827995]]]]], Appearance -> Automatic,
         Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "STD 1" -> Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5049652620285187, 
                  0.0005222986739878592, $CellContext`dv$394787]], "STD 2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.623565252889819, 
                  0.0007242565923152135, $CellContext`dv$394788]], "STD 3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.1122617784207023`, 
                  0.0011361423406811462`, $CellContext`dv$394789]], "STD 4" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.993042482195919, 
                  0.001721214491302021, $CellContext`dv$394790]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
             Association["ID" -> 37306216827995]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "STD 1" -> Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5049652620285187, 
                   0.0005222986739878592, $CellContext`dv$394787]], "STD 2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.623565252889819, 
                   0.0007242565923152135, $CellContext`dv$394788]], "STD 3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.1122617784207023`, 
                   0.0011361423406811462`, $CellContext`dv$394789]], "STD 4" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.993042482195919, 
                   0.001721214491302021, $CellContext`dv$394790]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
              Association["ID" -> 37306216827995]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "STD 1" -> Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5049652620285187, 
                   0.0005222986739878592, $CellContext`dv$394787]], "STD 2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.623565252889819, 
                   0.0007242565923152135, $CellContext`dv$394788]], "STD 3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.1122617784207023`, 
                   0.0011361423406811462`, $CellContext`dv$394789]], "STD 4" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.993042482195919, 
                   0.001721214491302021, $CellContext`dv$394790]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
              Association["ID" -> 37306216827995]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[38]} -> 
               1, {All, "Ca / ppm"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[48.00000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               4, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[1711026344], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1711026344]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1", 
                    Style[
                    "STD 1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    Key["STD 1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 1"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.5050\"", 0.5049652620285187, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "13", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.5049652620285187, 
                    0.0005222986739878592, $CellContext`dv$394787]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 1"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2", 
                    Style[
                    "STD 2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    Key["STD 2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 2"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.6236\"", 1.623565252889819, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "19", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.623565252889819, 
                    0.0007242565923152135, $CellContext`dv$394788]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3", 
                    Style[
                    "STD 3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    Key["STD 3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 3"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.1123\"", 3.1122617784207023`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "29", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.1122617784207023`, 
                    0.0011361423406811462`, $CellContext`dv$394789]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4", 
                    Style[
                    "STD 4", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][{
                    Key["STD 4"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 4"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.9930\"", 4.993042482195919, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "44", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.993042482195919, 
                    0.001721214491302021, $CellContext`dv$394790]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    492935801][
                    GeneralUtilities`Slice[
                    Key["STD 4"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 492935801]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[492935801][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[492935801][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {149., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->531943659,ExpressionUUID->"5801fb8f-bc94-4af8-93b9-d73101a37ddd"]
}, Open  ]],

Cell["Define some measurements:", "ExampleText",
 CellID->26645253,ExpressionUUID->"e623b894-d867-4f33-b3c4-11b2ed104450"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"measurements", "=", 
  RowBox[{"DataTable", "@", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<Blanc-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "55", ",", "21."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{
           RowBox[{"-", "0.01758562332"}], ",", "0.00033863693000000036"}], 
          "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<STD 1-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "56", ",", "11."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.03964178048", ",", "0.0004196894400000026"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 2-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "57", ",", "1."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.12384595475", ",", "0.0016846698500000005"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 3-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "57", ",", "52."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.23293354845", ",", "0.0006201796499999968"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 4-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "58", ",", "44."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.3619620833", ",", "0.0008638827000000127"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 00\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "1", ",", "20."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.19625917165", ",", "0.001488907949999993"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 07\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "3", ",", "4."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.15008595425", ",", "0.0003870700500000074"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 05\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "3", ",", "57."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.1584623842", ",", "0.0022980622000000057"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 06\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "4", ",", "47."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.155255631", ",", "0.0004266695999999986"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Blanc-3\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "5", ",", "36."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{
           RowBox[{"-", "0.001228706227"}], ",", "0.00005203780300000005"}], 
          "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<DRIFT-3\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "6", ",", "26."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.36115560739999997", ",", "0.00001406480000001875"}], 
          "]"}]}]}], "|>"}]}]}], "|>"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->792318828,ExpressionUUID->"8c72aedb-11cc-413d-bb32-188b4a2d7fa4"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.01758562332, 
                  0.00033863693000000036`, $CellContext`dv$388908]], 
              "STD 1-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.03964178048, 
                  0.0004196894400000026, $CellContext`dv$388909]], "STD 2-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.12384595475, 
                  0.0016846698500000005`, $CellContext`dv$388910]], "STD 3-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.23293354845, 
                  0.0006201796499999968, $CellContext`dv$388911]], "STD 4-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.3619620833, 
                  0.0008638827000000127, $CellContext`dv$388912]], 
              "Sample 00" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.19625917165, 
                  0.001488907949999993, $CellContext`dv$388913]], "Sample 07" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.15008595425, 
                  0.0003870700500000074, $CellContext`dv$388914]], 
              "Sample 05" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.1584623842, 
                  0.0022980622000000057`, $CellContext`dv$388915]], 
              "Sample 06" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.155255631, 0.0004266695999999986, $CellContext`dv$388916]],
               "Blanc-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.001228706227, 
                  0.00005203780300000005, $CellContext`dv$388917]], "DRIFT-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.36115560739999997`, 
                  0.00001406480000001875, $CellContext`dv$388918]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
             Association["ID" -> 146686148955122]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.01758562332, 
                  0.00033863693000000036`, $CellContext`dv$388908]], 
              "STD 1-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.03964178048, 
                  0.0004196894400000026, $CellContext`dv$388909]], "STD 2-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.12384595475, 
                  0.0016846698500000005`, $CellContext`dv$388910]], "STD 3-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.23293354845, 
                  0.0006201796499999968, $CellContext`dv$388911]], "STD 4-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.3619620833, 
                  0.0008638827000000127, $CellContext`dv$388912]], 
              "Sample 00" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.19625917165, 
                  0.001488907949999993, $CellContext`dv$388913]], "Sample 07" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.15008595425, 
                  0.0003870700500000074, $CellContext`dv$388914]], 
              "Sample 05" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.1584623842, 
                  0.0022980622000000057`, $CellContext`dv$388915]], 
              "Sample 06" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.155255631, 0.0004266695999999986, $CellContext`dv$388916]],
               "Blanc-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.001228706227, 
                  0.00005203780300000005, $CellContext`dv$388917]], "DRIFT-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.36115560739999997`, 
                  0.00001406480000001875, $CellContext`dv$388918]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
             Association["ID" -> 146686148955122]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.01758562332, 
                   0.00033863693000000036`, $CellContext`dv$388908]], 
               "STD 1-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.03964178048, 
                   0.0004196894400000026, $CellContext`dv$388909]], "STD 2-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.12384595475, 
                   0.0016846698500000005`, $CellContext`dv$388910]], 
               "STD 3-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.23293354845, 
                   0.0006201796499999968, $CellContext`dv$388911]], "STD 4-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.3619620833, 
                   0.0008638827000000127, $CellContext`dv$388912]], 
               "Sample 00" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.19625917165, 
                   0.001488907949999993, $CellContext`dv$388913]], 
               "Sample 07" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.15008595425, 
                   0.0003870700500000074, $CellContext`dv$388914]], 
               "Sample 05" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.1584623842, 
                   0.0022980622000000057`, $CellContext`dv$388915]], 
               "Sample 06" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.155255631, 
                   0.0004266695999999986, $CellContext`dv$388916]], "Blanc-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.001228706227, 
                   0.00005203780300000005, $CellContext`dv$388917]], 
               "DRIFT-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.36115560739999997`, 
                   0.00001406480000001875, $CellContext`dv$388918]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Time", "Ca"}, {
                 TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
              Association["ID" -> 146686148955122]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.01758562332, 
                   0.00033863693000000036`, $CellContext`dv$388908]], 
               "STD 1-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.03964178048, 
                   0.0004196894400000026, $CellContext`dv$388909]], "STD 2-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.12384595475, 
                   0.0016846698500000005`, $CellContext`dv$388910]], 
               "STD 3-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.23293354845, 
                   0.0006201796499999968, $CellContext`dv$388911]], "STD 4-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.3619620833, 
                   0.0008638827000000127, $CellContext`dv$388912]], 
               "Sample 00" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.19625917165, 
                   0.001488907949999993, $CellContext`dv$388913]], 
               "Sample 07" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.15008595425, 
                   0.0003870700500000074, $CellContext`dv$388914]], 
               "Sample 05" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.1584623842, 
                   0.0022980622000000057`, $CellContext`dv$388915]], 
               "Sample 06" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.155255631, 
                   0.0004266695999999986, $CellContext`dv$388916]], "Blanc-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.001228706227, 
                   0.00005203780300000005, $CellContext`dv$388917]], 
               "DRIFT-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.36115560739999997`, 
                   0.00001406480000001875, $CellContext`dv$388918]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Time", "Ca"}, {
                 TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
              Association["ID" -> 146686148955122]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[37]} -> 1, {All, "Time"} -> 
               1, {All, "Ca"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Time" -> TypeSystem`PackageScope`AtomShape[75], "Ca" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 11, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[2143726770], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[2143726770]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Time\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Time\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    All, "Time"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[All, "Time"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    All, "Ca"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[All, "Ca"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:55:21\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.01759\"", -0.01758562332, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "87", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.01758562332, 
                    0.00033863693000000036`, $CellContext`dv$388908]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:56:11\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.0396\"", 0.03964178048, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.03964178048, 
                    0.0004196894400000026, $CellContext`dv$388909]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:57:01\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1238\"", 0.12384595475, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "43", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.12384595475, 
                    0.0016846698500000005`, $CellContext`dv$388910]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:57:52\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.2329\"", 0.23293354845, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.23293354845, 
                    0.0006201796499999968, $CellContext`dv$388911]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:58:44\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.3620\"", 0.3619620833, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "22", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.3619620833, 
                    0.0008638827000000127, $CellContext`dv$388912]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:01:20\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1963\"", 0.19625917165, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "38", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.19625917165, 
                    0.001488907949999993, $CellContext`dv$388913]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:03:04\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.15009\"", 0.15008595425, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "100", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.15008595425, 
                    0.0003870700500000074, $CellContext`dv$388914]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:03:57\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1585\"", 0.1584623842, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.1584623842, 
                    0.0022980622000000057`, $CellContext`dv$388915]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:04:47\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1553\"", 0.155255631, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "11", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.155255631, 
                    0.0004266695999999986, $CellContext`dv$388916]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:05:36\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.00123\"", -0.001228706227, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "13", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.001228706227, 
                    0.00005203780300000005, $CellContext`dv$388917]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:06:26\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.361156\"", 0.36115560739999997`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 6}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "36", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.36115560739999997`, 
                    0.00001406480000001875, $CellContext`dv$388918]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    761380414][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 761380414]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[761380414][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[761380414][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {381., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{385, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->335711839,ExpressionUUID->"96efb6d7-3f04-46b1-ab12-124dbbf7acf8"]
}, Open  ]],

Cell["\<\
Show the calibration curve for a simple linear calibration through zero:\
\>", "ExampleText",
 CellID->419374998,ExpressionUUID->"c393918e-b600-4810-85fe-fd342a68b447"],

Cell[BoxData[
 RowBox[{
  RowBox[{"<<", "DataAnalysis`"}], ";"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->177615652,ExpressionUUID->"5e86b4ac-e132-4573-8cca-fc6c05c17866"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrationPlot", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<STD\>\"", "~~", "__", "~~", "\"\<-2\>\""}], "}"}]}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->25033209,ExpressionUUID->"caf4dcfc-ed6e-46f1-a7d4-b1a74b62ec71"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{GraphicsBox[{{{}, {{{}, {
             Hue[0.67, 0.6, 0.6], 
             Directive[
              PointSize[0.012833333333333334`], 
              AbsoluteThickness[1.6], 
              RGBColor[0.368417, 0.506779, 0.709798]], {
              
              PointBox[{{0.5049652620285187, 0.03964178048}, {
               1.623565252889819, 0.12384595475}, {3.1122617784207023`, 
               0.23293354845}, {4.993042482195919, 0.3619620833}}], {{{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{0.5059889486187079, 0.03964178048}, {
                  0.5039415754383294, 0.03964178048}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {0.5059889486187079, 0.03964178048}], 
                   Offset[{0, -1.5}, {0.5059889486187079, 0.03964178048}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {0.5039415754383294, 0.03964178048}], 
                   Offset[{0, -1.5}, {0.5039415754383294, 0.03964178048}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{0.5049652620285187, 0.04046435666709179}, {
                  0.5049652620285187, 0.03881920429290821}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {0.5049652620285187, 
                    0.04046435666709179}], 
                   
                   Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.04046435666709179}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {0.5049652620285187, 
                    0.03881920429290821}], 
                   
                   Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.03881920429290821}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{1.6249847697263224`, 0.12384595475}, {
                  1.6221457360533156`, 0.12384595475}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {1.6249847697263224`, 0.12384595475}], 
                   
                   Offset[{0, -1.5}, {1.6249847697263224`, 
                    0.12384595475}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {1.6221457360533156`, 0.12384595475}], 
                   
                   Offset[{0, -1.5}, {1.6221457360533156`, 
                    0.12384595475}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{1.623565252889819, 0.1271478469818405}, {
                  1.623565252889819, 0.12054406251815951`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{1.5, 0}, {1.623565252889819, 0.1271478469818405}], 
                   
                   Offset[{-1.5, 0}, {1.623565252889819, 
                    0.1271478469818405}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {1.623565252889819, 
                    0.12054406251815951`}], 
                   
                   Offset[{-1.5, 0}, {1.623565252889819, 
                    0.12054406251815951`}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{3.1144885764897485`, 0.23293354845}, {
                  3.110034980351656, 0.23293354845}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {3.1144885764897485`, 0.23293354845}], 
                   
                   Offset[{0, -1.5}, {3.1144885764897485`, 
                    0.23293354845}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {3.110034980351656, 0.23293354845}], 
                   Offset[{0, -1.5}, {3.110034980351656, 0.23293354845}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{3.1122617784207023`, 0.23414907822794465`}, {
                  3.1122617784207023`, 0.23171801867205535`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.23414907822794465`}], 
                   
                   Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.23414907822794465`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.23171801867205535`}], 
                   
                   Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.23171801867205535`}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{4.996416000608539, 0.3619620833}, {
                  4.9896689637832985`, 0.3619620833}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {4.996416000608539, 0.3619620833}], 
                   Offset[{0, -1.5}, {4.996416000608539, 0.3619620833}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {4.9896689637832985`, 0.3619620833}], 
                   Offset[{0, -1.5}, {4.9896689637832985`, 0.3619620833}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{4.993042482195919, 0.36365526227886724`}, {
                  4.993042482195919, 0.3602689043211328}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {4.993042482195919, 
                    0.36365526227886724`}], 
                   
                   Offset[{-1.5, 0}, {4.993042482195919, 
                    0.36365526227886724`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{1.5, 0}, {4.993042482195919, 0.3602689043211328}], 
                   
                   Offset[{-1.5, 0}, {4.993042482195919, 
                    0.3602689043211328}]}]}}}}}, {}}, {
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{0.5049652620285187, 0.03964178048}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{0.5059889486187079, 0.03964178048}, {
                    0.5039415754383294, 0.03964178048}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {0.5059889486187079, 0.03964178048}], 
                    
                    Offset[{0, -1.5}, {0.5059889486187079, 
                    0.03964178048}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {0.5039415754383294, 0.03964178048}], 
                    
                    Offset[{0, -1.5}, {0.5039415754383294, 
                    0.03964178048}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{0.5049652620285187, 0.04046435666709179}, {
                    0.5049652620285187, 0.03881920429290821}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {0.5049652620285187, 
                    0.04046435666709179}], 
                    
                    Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.04046435666709179}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {0.5049652620285187, 
                    0.03881920429290821}], 
                    
                    Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.03881920429290821}]}]}}}}}, 
              "\"STD 1 {0.5050(10), 0.03964(82)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 1 {0.5050(10), 0.03964(82)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{1.623565252889819, 0.12384595475}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{1.6249847697263224`, 0.12384595475}, {
                    1.6221457360533156`, 0.12384595475}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {1.6249847697263224`, 0.12384595475}], 
                    Offset[{0, -1.5}, {1.6249847697263224`, 
                    0.12384595475}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {1.6221457360533156`, 0.12384595475}], 
                    
                    Offset[{0, -1.5}, {1.6221457360533156`, 
                    0.12384595475}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{1.623565252889819, 0.1271478469818405}, {
                    1.623565252889819, 0.12054406251815951`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{1.5, 0}, {1.623565252889819, 0.1271478469818405}], 
                    
                    Offset[{-1.5, 0}, {1.623565252889819, 
                    0.1271478469818405}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {1.623565252889819, 
                    0.12054406251815951`}], 
                    
                    Offset[{-1.5, 0}, {1.623565252889819, 
                    0.12054406251815951`}]}]}}}}}, 
              "\"STD 2 {1.6236(14), 0.1238(33)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 2 {1.6236(14), 0.1238(33)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{3.1122617784207023`, 0.23293354845}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{3.1144885764897485`, 0.23293354845}, {
                    3.110034980351656, 0.23293354845}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {3.1144885764897485`, 0.23293354845}], 
                    
                    Offset[{0, -1.5}, {3.1144885764897485`, 
                    0.23293354845}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {3.110034980351656, 0.23293354845}], 
                    Offset[{0, -1.5}, {3.110034980351656, 0.23293354845}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{3.1122617784207023`, 0.23414907822794465`}, {
                    3.1122617784207023`, 0.23171801867205535`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.23414907822794465`}], 
                    
                    Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.23414907822794465`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.23171801867205535`}], 
                    
                    Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.23171801867205535`}]}]}}}}}, 
              "\"STD 3 {3.1123(22), 0.2329(12)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 3 {3.1123(22), 0.2329(12)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{4.993042482195919, 0.3619620833}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{4.996416000608539, 0.3619620833}, {
                    4.9896689637832985`, 0.3619620833}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {4.996416000608539, 0.3619620833}], 
                    Offset[{0, -1.5}, {4.996416000608539, 0.3619620833}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {4.9896689637832985`, 0.3619620833}], 
                    
                    Offset[{0, -1.5}, {4.9896689637832985`, 
                    0.3619620833}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{4.993042482195919, 0.36365526227886724`}, {
                    4.993042482195919, 0.3602689043211328}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {4.993042482195919, 
                    0.36365526227886724`}], 
                    
                    Offset[{-1.5, 0}, {4.993042482195919, 
                    0.36365526227886724`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{1.5, 0}, {4.993042482195919, 0.3602689043211328}], 
                    
                    Offset[{-1.5, 0}, {4.993042482195919, 
                    0.3602689043211328}]}]}}}}}, 
              "\"STD 4 {4.9930(34), 0.3620(17)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 4 {4.9930(34), 0.3620(17)}", 
              "Tooltip"]& ]}}, {}, {}, {}, {}}, {{{{}, {}, 
            TagBox[{
              Directive[
               Opacity[1.], 
               AbsoluteThickness[1.6], 
               GrayLevel[0]], 
              LineBox[CompressedData["
1:eJwVyms0lHkcwHFy25hkPJ2OUuPRsaaGklrbzfj9Ux2SW0UttjZThq0QNaeW
VG5JF6YSUk+zjKaVQ1uGjZiEjJkx4zLypJktx6ByKZemjOu2L77n8+Zry4re
EzZPT0/P53v/S5xjGTsfiXe7sSmtg2eH3BqUuPd+PAiY0gddYmI5zDWKknH8
d8DPrPRII1YDUXvNxgj/AyxbPsywCSYcZ3Iiv9mkw5VJz659hA8opyKyRmxu
g4eFrtGXOAAmqh76sE0R2Fu31XgRkZAv5cUM2lTCLZxZ6UkkQOmjdNXxNVKA
f57IcHUGhEPb7aFYJczf4HSlcCgbovpWaYSlXVCVStKzd9wDU9sU+ruN3bCu
JZo+SeNDhoWMkX9IA+eedzkvIgXAUgU8N2juh6ask4m9bx9CzMsUVjR9AIT8
iqsaZSk8PkHZa7VzGHxk0WK2+2PIjz82sHb/CLhtWDZY4V4GSbzp3V+GRsHh
1pbL03g56Cm7UXXcOHzMdErr0laA/Sn2mQCGFuwTngmujz2FXm3OPrOar3Dw
16qtIK8Cr76jCTdiJmDRmt1z4pZq8O3lOtBok0DcrV76oUkEA/WsC00lU8A9
J38961cLa6idy7f9NgPUvy65nPZ7AaagDVWPzwLXa8ZvgFkHHsPB31YE6iHf
/popL1QPr+uO6Ac76iNOa8S+b8wGKL/UcBDX6qO89fKoe4yXwDbidCsU89Bs
ZoLVeodGOBwbX07JM0CHwt6fr1sqBqdwB4V3qCFipG/JJoyaoMXS0YyzyQj9
JFAx2YYSeFaadMfRwBi5urrwV41JIF6f4d/8rzFKlr25/WZcCqbqOM8ooQla
X3QUyBEZ9Alss3hnf0Ddc2UFCnUzZK1cYlgZOB/J/XbmlKnlwM1ji0NxU1Rp
lbvzpkwBwVkHFJT3poiytu2hqLwFJrbf1/FEZsgfL1YMBrWCps/9TF0aBVmF
SQWc1lYoYDpby0MXoERBpsdX/zYoSeVQw1ebo4hCZ48vTW2QFnh4l4HWHKVI
PGm5bu3gos4vSpMvRDBoJFonaofcVXdK5LssUJyEV+3looTztddyd1VaoIDC
d8lBFUrwsQ68L7WjIpYga4W5SwdsjRKHUNOp6NMRexwVdwBvGcuuWUtFS/GD
/REOr8Cu/kG2b4glEufEmi3kvwLu6jpGu8gSPfh52iTEqhPY44ZtEgaG6O0O
ciKnE1iPx/D0TAz9yNg4esCchONJe6e9rmNoc8+I0wkLEjh7hSTlJoZ88oqi
kixJuKTlZHCzMcQxtR4SLCahdJNuKofAUMPATP9nGgm6F3OdgmIMsYrr1YlO
JHDbKdcaxBjiOfo13fcnIY8fGXFRgiFhr4nJ0z0k8E8ptnnKMCS+W7tDGkBC
xWLupEyBoc+UdfWffiFBHYxFKF9hyG14kWhDKAl0zZJtPRoMqUvelEliSFgr
jKMV9n3/w26OqU6SsDlVpQt7jyFDmrfzJw4J3nTi748DGGJk1JRaxpEQewyn
jY5iKC7qz6KQJBLOuibqnoxjKMM+6ENkCgmpC3o6TmkxVPCWSr9wkYTcR/wr
ExMYkvgmFxZeJqHggmF41SSG3hq7aiquklC8O8z97DSGRkVfbCUZJAhXNC53
m8WQ0emSQyouCaJxe93cHIaWOLF5wzdI+A8gB1RY
               "]]}, 
             Annotation[#, "Charting`Private`Tag$511960#1"]& ]}}, {}, {}}}, {
        DisplayFunction -> Identity, PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.05]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, AxesOrigin -> {0, 0}, PlotRange -> 
         NCache[{{0, 5}, {0, 
             Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True,
          ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
         NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {False, False},
          AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
         Identity, Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
            FormBox["\"Measurement\"", TraditionalForm], None}, {
            FormBox["\"Concentration\"", TraditionalForm], None}}, FrameStyle -> 
         GrayLevel[0], 
         FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
         FrameTicksStyle -> 12, GridLines -> {None, None}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 500, LabelStyle -> 12, 
         Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& ), "CopiedValueFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& )}}, PlotLabel -> FormBox[
           StyleBox["\"Ca\"", 16, 
            GrayLevel[0], StripOnInput -> False], TraditionalForm], PlotRange -> 
         NCache[{{0, 5}, {0, 
             Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True,
          PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.05]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           RowBox[{"\"STD\"", "~~", "__", "~~", "\"-2\""}]}, "PointLegend", 
          DisplayFunction -> (FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    PointBox[
                    NCache[{
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}]}, {
                    Scaled[{0.5, 0.5}]}]]}}}, AspectRatio -> Full, 
                    ImageSize -> {10, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.038000000000000006`] -> 
                    Baseline)], #}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 12, FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]& ), 
          InterpretationFunction :> (RowBox[{"PointLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 
                    1.35 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                    Magnification])}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False]}], "]"}], "}"}], ",", 
               RowBox[{"{", #, "}"}], ",", 
               RowBox[{"LegendMarkers", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"False", ",", "Automatic"}], "}"}], "}"}]}], ",", 
               RowBox[{"Joined", "\[Rule]", 
                 RowBox[{"{", "False", "}"}]}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", "12"}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
          Editable -> True], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Center}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{5}}}],
  "Column"]], "Output",
 ImageSize->{629, 343},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->7457263,ExpressionUUID->"765897c4-1a6a-49fc-b80c-82e40060def6"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount",ExpressionUUID->
  "8642ce40-974c-43a9-a937-799865558608"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"80bd2a98-9e88-45d1-9405-065a5886da27"],

Cell[CellGroupData[{

Cell[TextData[{
 "IncludeConstantBasis",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "d065afa3-c416-463e-b7fd-b06f8fc558c9"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"6340e028-3162-4cd4-8558-5d67346a9a81"],

Cell["\<\
By default, the calibration curve is forced through zero, but a constant \
basis can be included:\
\>", "ExampleText",
 CellID->432298880,ExpressionUUID->"7539cc0b-b2b6-44b7-b681-e0651328bab7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrationPlot", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<STD\>\"", "~~", "__", "~~", "\"\<-2\>\""}], "}"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->139674814,ExpressionUUID->"ed84e615-c00b-4f46-8e6a-3c44e71cf7b2"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{GraphicsBox[{{{}, {{{}, {
             Hue[0.67, 0.6, 0.6], 
             Directive[
              PointSize[0.012833333333333334`], 
              AbsoluteThickness[1.6], 
              RGBColor[0.368417, 0.506779, 0.709798]], {
              
              PointBox[{{0.5049652620285187, 0.03964178048}, {
               1.623565252889819, 0.12384595475}, {3.1122617784207023`, 
               0.23293354845}, {4.993042482195919, 0.3619620833}}], {{{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{0.5063106142581814, 0.03964178048}, {
                  0.503619909798856, 0.03964178048}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {0.5063106142581814, 0.03964178048}], 
                   Offset[{0, -1.5}, {0.5063106142581814, 0.03964178048}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {0.503619909798856, 0.03964178048}], 
                   Offset[{0, -1.5}, {0.503619909798856, 0.03964178048}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{0.5049652620285187, 0.04072282883794203}, {
                  0.5049652620285187, 0.03856073212205797}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {0.5049652620285187, 
                    0.04072282883794203}], 
                   
                   Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.04072282883794203}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {0.5049652620285187, 
                    0.03856073212205797}], 
                   
                   Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.03856073212205797}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{1.625430814243593, 0.12384595475}, {
                  1.621699691536045, 0.12384595475}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {1.625430814243593, 0.12384595475}], 
                   Offset[{0, -1.5}, {1.625430814243593, 0.12384595475}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {1.621699691536045, 0.12384595475}], 
                   Offset[{0, -1.5}, {1.621699691536045, 0.12384595475}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{1.623565252889819, 0.12818537671643535`}, {
                  1.623565252889819, 0.11950653278356467`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {1.623565252889819, 
                    0.12818537671643535`}], 
                   
                   Offset[{-1.5, 0}, {1.623565252889819, 
                    0.12818537671643535`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {1.623565252889819, 
                    0.11950653278356467`}], 
                   
                   Offset[{-1.5, 0}, {1.623565252889819, 
                    0.11950653278356467`}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{3.1151882871548313`, 0.23293354845}, {
                  3.1093352696865733`, 0.23293354845}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {3.1151882871548313`, 0.23293354845}], 
                   
                   Offset[{0, -1.5}, {3.1151882871548313`, 
                    0.23293354845}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {3.1093352696865733`, 0.23293354845}], 
                   
                   Offset[{0, -1.5}, {3.1093352696865733`, 
                    0.23293354845}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{3.1122617784207023`, 0.2345310253659347}, {
                  3.1122617784207023`, 0.2313360715340653}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.2345310253659347}], 
                   
                   Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.2345310253659347}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.2313360715340653}], 
                   
                   Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.2313360715340653}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{4.9974760369203075`, 0.3619620833}, {
                  4.98860892747153, 0.3619620833}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {4.9974760369203075`, 0.3619620833}], 
                   Offset[{0, -1.5}, {4.9974760369203075`, 0.3619620833}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {4.98860892747153, 0.3619620833}], 
                   Offset[{0, -1.5}, {4.98860892747153, 0.3619620833}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{4.993042482195919, 0.364187297673489}, {
                  4.993042482195919, 0.359736868926511}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{1.5, 0}, {4.993042482195919, 0.364187297673489}], 
                   
                   Offset[{-1.5, 0}, {4.993042482195919, 
                    0.364187297673489}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{1.5, 0}, {4.993042482195919, 0.359736868926511}], 
                   
                   Offset[{-1.5, 0}, {4.993042482195919, 
                    0.359736868926511}]}]}}}}}, {}}, {
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{0.5049652620285187, 0.03964178048}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{0.5063106142581814, 0.03964178048}, {
                    0.503619909798856, 0.03964178048}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {0.5063106142581814, 0.03964178048}], 
                    
                    Offset[{0, -1.5}, {0.5063106142581814, 
                    0.03964178048}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {0.503619909798856, 0.03964178048}], 
                    Offset[{0, -1.5}, {0.503619909798856, 0.03964178048}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{0.5049652620285187, 0.04072282883794203}, {
                    0.5049652620285187, 0.03856073212205797}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {0.5049652620285187, 
                    0.04072282883794203}], 
                    
                    Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.04072282883794203}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {0.5049652620285187, 
                    0.03856073212205797}], 
                    
                    Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.03856073212205797}]}]}}}}}, 
              "\"STD 1 {0.5050(13), 0.0396(11)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 1 {0.5050(13), 0.0396(11)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{1.623565252889819, 0.12384595475}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{1.625430814243593, 0.12384595475}, {
                    1.621699691536045, 0.12384595475}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {1.625430814243593, 0.12384595475}], 
                    Offset[{0, -1.5}, {1.625430814243593, 0.12384595475}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {1.621699691536045, 0.12384595475}], 
                    Offset[{0, -1.5}, {1.621699691536045, 0.12384595475}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{1.623565252889819, 0.12818537671643535`}, {
                    1.623565252889819, 0.11950653278356467`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {1.623565252889819, 
                    0.12818537671643535`}], 
                    
                    Offset[{-1.5, 0}, {1.623565252889819, 
                    0.12818537671643535`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {1.623565252889819, 
                    0.11950653278356467`}], 
                    
                    Offset[{-1.5, 0}, {1.623565252889819, 
                    0.11950653278356467`}]}]}}}}}, 
              "\"STD 2 {1.6236(19), 0.1238(43)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 2 {1.6236(19), 0.1238(43)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{3.1122617784207023`, 0.23293354845}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{3.1151882871548313`, 0.23293354845}, {
                    3.1093352696865733`, 0.23293354845}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {3.1151882871548313`, 0.23293354845}], 
                    
                    Offset[{0, -1.5}, {3.1151882871548313`, 
                    0.23293354845}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {3.1093352696865733`, 0.23293354845}], 
                    
                    Offset[{0, -1.5}, {3.1093352696865733`, 
                    0.23293354845}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{3.1122617784207023`, 0.2345310253659347}, {
                    3.1122617784207023`, 0.2313360715340653}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.2345310253659347}], 
                    
                    Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.2345310253659347}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.2313360715340653}], 
                    
                    Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.2313360715340653}]}]}}}}}, 
              "\"STD 3 {3.1123(29), 0.2329(16)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 3 {3.1123(29), 0.2329(16)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{4.993042482195919, 0.3619620833}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{4.9974760369203075`, 0.3619620833}, {
                    4.98860892747153, 0.3619620833}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {4.9974760369203075`, 0.3619620833}], 
                    
                    Offset[{0, -1.5}, {4.9974760369203075`, 
                    0.3619620833}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {4.98860892747153, 0.3619620833}], 
                    Offset[{0, -1.5}, {4.98860892747153, 0.3619620833}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{4.993042482195919, 0.364187297673489}, {
                    4.993042482195919, 0.359736868926511}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{1.5, 0}, {4.993042482195919, 0.364187297673489}], 
                    
                    Offset[{-1.5, 0}, {4.993042482195919, 
                    0.364187297673489}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{1.5, 0}, {4.993042482195919, 0.359736868926511}], 
                    
                    Offset[{-1.5, 0}, {4.993042482195919, 
                    0.359736868926511}]}]}}}}}, 
              "\"STD 4 {4.9930(44), 0.3620(22)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 4 {4.9930(44), 0.3620(22)}", 
              "Tooltip"]& ]}}, {}, {}, {}, {}}, {{{{}, {}, 
            TagBox[{
              Directive[
               Opacity[1.], 
               AbsoluteThickness[1.6], 
               GrayLevel[0]], 
              LineBox[CompressedData["
1:eJwVxX0803kcAHBPo5t52H53XZ2yTcsilFKdQ5/voThWKa1dXGrzWDEP4Rqu
61zIy8XKesDJTaVUiJtKRfO4GCtmfq65zlkol3txbmXE7vrj/XrTefF7Io0M
DAx2/O/DpSd4pq4R6VtHDnrxXzznQ5uSxuLQ9sOu9og+Zls86DuafqTRDkPY
J9tL7u9LgFLpGSqBJoDutDi9IUqEWK+UuHfUXLi+7ZFMRDkGyvkY0RS1CMLU
+79+cC8VzNQjzElqJXSZnhcQjE6AuKss8S9qA/RVE17sCMyG6ppcdaxLF8hd
HS9MkgohGnqL3iQpocjNQ0/lFwN/1EEjqf4NOKYd9XTVL0Ckn2L+8fkwPM99
6VLbfBXyreWO4kMaEP357vTmozeAp9772Lh7DDqDDCvcw29DYvspXjxzAoLY
7PIQxh2oTSAFL/tqEjixDF6hthbE6Ucn1nOmwKaAb2z+96+QWfZ+979vpmHe
ZuP5hbZ6MFAOo0dpM7D2siz69rl7YJ8cdXyvoxaWOeE2xTkN8FJ7cZ9541ug
M7hSo9CHEDB65LtzibMwxozafpPdCDtfCtfa2s7BAs3DwtLvMUy08k4+qZqH
T7238VLzpOBCHljpc3AB8gU3XQg5zUAELXdoZhGwMdax3sQW8JsMeWfHNkCp
g7fXeCW0wmBLhGGIkyHKbE9eND3SBvWn28JoWkP087iAZRncDlGElGGFwgiJ
CjzN63d1QHhSej2p2BgVx3p6F3nIYF30WgWLa4L8fa8Wqe2ewFOKk3mKOwGp
xJ3cxpWd8LA6s8TJ2BTFuzmVD5l1QbqhY1D376boFYsVXEKQA3EozZ8vMUPE
Q/2M+4tyGK2gi8oyliD3G0V8yng3iNYsN2lgf4S2p65wIGl6QFgcJePSiIgn
GAr1USggRHRAQRonIvtvTWoGJU9h1vearqzJHEUsJDdkc56BZtT7eEsOCTXu
z8ah+xmUe7na9HAtEEHwtupJQC9UZaWQo50tkXJDFpqS9kIOOzzQWGuJ3r72
03S49cGmIXFlTo8VWhJxeGtcXR9cciip6gm0RuLjlew6phK+l565FNhgjRyC
/FfLKpSww4Z9rYtBRoTVNoS8Vf3wJV8WSs4loxgRSTx5sR/KVvAY3VoyetDx
jZa6VAWM1usXdoZSkKhQTpjOU4HQucWxr4mCmg/w7RP1KoiaMentdMTQi4l4
vTRjAHi1/9ByCzCUSRGKaqYHIDYz+H3AWQzdZQokDTMDkBIswUmFGJrw5PW3
agfgtDYlX3gBQ3ui3T4e1A1Atbtu/mIphuweDRYaGOGga9YPVNzCkDSSXrib
goOwj3SmTYahxft1Z2c24FB8JS4muxNDGxUltQtuOFxJVvj4yzEUpTnVa7YF
h7tLhXNyBYYUFhzyCg8chkKwGKUKQ5d580JfHxyYmuU+IxoMeZF8heeDcVgv
SbO9OoqhBLrznTI2Dl9kqXWR4xi6tnnps0oODixm6Z3XExgicV9ZNYXikHSU
Zjs9jSF1/U8FY+E4ZHj+oKubwZC1PKVmKhKHLIuR/mQthnyGw57OReNwqeZK
3uwshm4RXa2sYnEoP2kS/WAOQ8PUz9Yt5+Nwa3ekd8Z7DGGbjHetSsBBYtex
cusihvwC3vCdk3BomrHX6fUYSj+oyt+SjMN/QSFBZg==
               "]]}, 
             Annotation[#, "Charting`Private`Tag$493972#1"]& ]}}, {}, {}}}, {
        DisplayFunction -> Identity, PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.05]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, AxesOrigin -> {0, 0}, PlotRange -> 
         NCache[{{0, 5}, {0, 
             Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True,
          ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
         NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {False, False},
          AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
         Identity, Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
            FormBox["\"Measurement\"", TraditionalForm], None}, {
            FormBox["\"Concentration\"", TraditionalForm], None}}, FrameStyle -> 
         GrayLevel[0], 
         FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
         FrameTicksStyle -> 12, GridLines -> {None, None}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 500, LabelStyle -> 12, 
         Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& ), "CopiedValueFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& )}}, PlotLabel -> FormBox[
           StyleBox["\"Ca\"", 16, 
            GrayLevel[0], StripOnInput -> False], TraditionalForm], PlotRange -> 
         NCache[{{0, 5}, {0, 
             Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True,
          PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.05]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           RowBox[{"\"STD\"", "~~", "__", "~~", "\"-2\""}]}, "PointLegend", 
          DisplayFunction -> (FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    PointBox[
                    NCache[{
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}]}, {
                    Scaled[{0.5, 0.5}]}]]}}}, AspectRatio -> Full, 
                    ImageSize -> {10, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.038000000000000006`] -> 
                    Baseline)], #}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 12, FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]& ), 
          InterpretationFunction :> (RowBox[{"PointLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False]}], "]"}], "}"}], ",", 
               RowBox[{"{", #, "}"}], ",", 
               RowBox[{"LegendMarkers", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"False", ",", "Automatic"}], "}"}], "}"}]}], ",", 
               RowBox[{"Joined", "\[Rule]", 
                 RowBox[{"{", "False", "}"}]}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", "12"}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
          Editable -> True], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Center}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{5}}}],
  "Column"]], "Output",
 ImageSize->{629, 343},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->242546102,ExpressionUUID->"d889239e-16a0-412f-9d29-df62e3b1e216"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "IncludeQuadraticTerm",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "ba84f3e8-64fa-494a-bd0d-3bbcf9b29fe2"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"967a8df4-f3d0-46b7-b142-0499a0629c65"],

Cell["\<\
By default, a linear calibration curve is used, but a quadratic term can be \
included:\
\>", "ExampleText",
 CellID->20320721,ExpressionUUID->"a1d5f5c3-ac1e-487a-8b4d-655e5ce860de"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrationPlot", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<STD\>\"", "~~", "__", "~~", "\"\<-2\>\""}], "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->646456666,ExpressionUUID->"b4195ec1-dea4-4061-b956-0afbb722847a"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{GraphicsBox[{{{}, {{{}, {
             Hue[0.67, 0.6, 0.6], 
             Directive[
              PointSize[0.012833333333333334`], 
              AbsoluteThickness[1.6], 
              RGBColor[0.368417, 0.506779, 0.709798]], {
              
              PointBox[{{0.5049652620285187, 0.03964178048}, {
               1.623565252889819, 0.12384595475}, {3.1122617784207023`, 
               0.23293354845}, {4.993042482195919, 0.3619620833}}], {{{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{0.5063106142581814, 0.03964178048}, {
                  0.503619909798856, 0.03964178048}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {0.5063106142581814, 0.03964178048}], 
                   Offset[{0, -1.5}, {0.5063106142581814, 0.03964178048}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {0.503619909798856, 0.03964178048}], 
                   Offset[{0, -1.5}, {0.503619909798856, 0.03964178048}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{0.5049652620285187, 0.04072282883794203}, {
                  0.5049652620285187, 0.03856073212205797}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {0.5049652620285187, 
                    0.04072282883794203}], 
                   
                   Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.04072282883794203}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {0.5049652620285187, 
                    0.03856073212205797}], 
                   
                   Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.03856073212205797}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{1.625430814243593, 0.12384595475}, {
                  1.621699691536045, 0.12384595475}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {1.625430814243593, 0.12384595475}], 
                   Offset[{0, -1.5}, {1.625430814243593, 0.12384595475}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {1.621699691536045, 0.12384595475}], 
                   Offset[{0, -1.5}, {1.621699691536045, 0.12384595475}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{1.623565252889819, 0.12818537671643535`}, {
                  1.623565252889819, 0.11950653278356467`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {1.623565252889819, 
                    0.12818537671643535`}], 
                   
                   Offset[{-1.5, 0}, {1.623565252889819, 
                    0.12818537671643535`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {1.623565252889819, 
                    0.11950653278356467`}], 
                   
                   Offset[{-1.5, 0}, {1.623565252889819, 
                    0.11950653278356467`}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{3.1151882871548313`, 0.23293354845}, {
                  3.1093352696865733`, 0.23293354845}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {3.1151882871548313`, 0.23293354845}], 
                   
                   Offset[{0, -1.5}, {3.1151882871548313`, 
                    0.23293354845}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {3.1093352696865733`, 0.23293354845}], 
                   
                   Offset[{0, -1.5}, {3.1093352696865733`, 
                    0.23293354845}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{3.1122617784207023`, 0.2345310253659347}, {
                  3.1122617784207023`, 0.2313360715340653}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.2345310253659347}], 
                   
                   Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.2345310253659347}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.2313360715340653}], 
                   
                   Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.2313360715340653}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{4.9974760369203075`, 0.3619620833}, {
                  4.98860892747153, 0.3619620833}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {4.9974760369203075`, 0.3619620833}], 
                   Offset[{0, -1.5}, {4.9974760369203075`, 0.3619620833}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {4.98860892747153, 0.3619620833}], 
                   Offset[{0, -1.5}, {4.98860892747153, 0.3619620833}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{4.993042482195919, 0.364187297673489}, {
                  4.993042482195919, 0.359736868926511}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{1.5, 0}, {4.993042482195919, 0.364187297673489}], 
                   
                   Offset[{-1.5, 0}, {4.993042482195919, 
                    0.364187297673489}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{1.5, 0}, {4.993042482195919, 0.359736868926511}], 
                   
                   Offset[{-1.5, 0}, {4.993042482195919, 
                    0.359736868926511}]}]}}}}}, {}}, {
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{0.5049652620285187, 0.03964178048}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{0.5063106142581814, 0.03964178048}, {
                    0.503619909798856, 0.03964178048}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {0.5063106142581814, 0.03964178048}], 
                    
                    Offset[{0, -1.5}, {0.5063106142581814, 
                    0.03964178048}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {0.503619909798856, 0.03964178048}], 
                    Offset[{0, -1.5}, {0.503619909798856, 0.03964178048}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{0.5049652620285187, 0.04072282883794203}, {
                    0.5049652620285187, 0.03856073212205797}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {0.5049652620285187, 
                    0.04072282883794203}], 
                    
                    Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.04072282883794203}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {0.5049652620285187, 
                    0.03856073212205797}], 
                    
                    Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.03856073212205797}]}]}}}}}, 
              "\"STD 1 {0.5050(13), 0.0396(11)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 1 {0.5050(13), 0.0396(11)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{1.623565252889819, 0.12384595475}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{1.625430814243593, 0.12384595475}, {
                    1.621699691536045, 0.12384595475}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {1.625430814243593, 0.12384595475}], 
                    Offset[{0, -1.5}, {1.625430814243593, 0.12384595475}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {1.621699691536045, 0.12384595475}], 
                    Offset[{0, -1.5}, {1.621699691536045, 0.12384595475}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{1.623565252889819, 0.12818537671643535`}, {
                    1.623565252889819, 0.11950653278356467`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {1.623565252889819, 
                    0.12818537671643535`}], 
                    
                    Offset[{-1.5, 0}, {1.623565252889819, 
                    0.12818537671643535`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {1.623565252889819, 
                    0.11950653278356467`}], 
                    
                    Offset[{-1.5, 0}, {1.623565252889819, 
                    0.11950653278356467`}]}]}}}}}, 
              "\"STD 2 {1.6236(19), 0.1238(43)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 2 {1.6236(19), 0.1238(43)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{3.1122617784207023`, 0.23293354845}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{3.1151882871548313`, 0.23293354845}, {
                    3.1093352696865733`, 0.23293354845}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {3.1151882871548313`, 0.23293354845}], 
                    
                    Offset[{0, -1.5}, {3.1151882871548313`, 
                    0.23293354845}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {3.1093352696865733`, 0.23293354845}], 
                    
                    Offset[{0, -1.5}, {3.1093352696865733`, 
                    0.23293354845}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{3.1122617784207023`, 0.2345310253659347}, {
                    3.1122617784207023`, 0.2313360715340653}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.2345310253659347}], 
                    
                    Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.2345310253659347}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.2313360715340653}], 
                    
                    Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.2313360715340653}]}]}}}}}, 
              "\"STD 3 {3.1123(29), 0.2329(16)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 3 {3.1123(29), 0.2329(16)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{4.993042482195919, 0.3619620833}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{4.9974760369203075`, 0.3619620833}, {
                    4.98860892747153, 0.3619620833}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {4.9974760369203075`, 0.3619620833}], 
                    
                    Offset[{0, -1.5}, {4.9974760369203075`, 
                    0.3619620833}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{0, 1.5}, {4.98860892747153, 0.3619620833}], 
                    Offset[{0, -1.5}, {4.98860892747153, 0.3619620833}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{4.993042482195919, 0.364187297673489}, {
                    4.993042482195919, 0.359736868926511}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{1.5, 0}, {4.993042482195919, 0.364187297673489}], 
                    
                    Offset[{-1.5, 0}, {4.993042482195919, 
                    0.364187297673489}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{1.5, 0}, {4.993042482195919, 0.359736868926511}], 
                    
                    Offset[{-1.5, 0}, {4.993042482195919, 
                    0.359736868926511}]}]}}}}}, 
              "\"STD 4 {4.9930(44), 0.3620(22)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 4 {4.9930(44), 0.3620(22)}", 
              "Tooltip"]& ]}}, {}, {}, {}, {}}, {{{{}, {}, 
            TagBox[{
              Directive[
               Opacity[1.], 
               AbsoluteThickness[1.6], 
               GrayLevel[0]], 
              LineBox[CompressedData["
1:eJwVkGs01Hkch41BhdGMf+2qKSYpl1xGq87as3x/okPCplwO7a6MW2rQZca2
RlvGpdSZmkolJYlaFiMZ7bqupsllZoyQ/387dFLT0E5ZxMQwm7UvPud587x4
zmcDK21vgqGBgUHw0v5n8S8sE/d4nnel5GUK+Pl4SwcYQZGMKBApzvN31NjA
YkdbNoORDOvI+PeyajcobhfYGDN+Bgfy2G8+1QBsL27KrE0+vAjqxOKrvoOB
hYMFkzY3wMR4TC6pjIFlQ2/sx20qQbYswk1wPw1KZSVH39s0Ah+XpzncOQWi
2vwhtqsMXIIfRq4/LoQk6Lvx4dgAvE8WbeQlFkKq2lElFr2ACUHlbNfqO2C6
Icf+1dcjUBN1u5G2qxwuUOVOpQdU0NCbWerjXgGsobA/yYpRmGpY9fFccjUc
fZrDSrPXwNp5Ns1z5wOoO2K+z2rXOPhTV/CzmQ+hlHdYw4ychJTRwWqOrxj4
JfrQmQ9T8PJArX+a+yMwGBhBLRnT0P16p6H1qj9gMyfxRJiTFh6E5RhSrZvg
rfZ6hFnrJ2DTZXQ2uQUC1YdOXj46B9natObGlW0Q8la4xdp6HhbsKhghy9tB
84R1uqtmAT70dk3c+9QOrjR8vW/Mv8DdM1PhO/cYTEEbOzz9Ga5QnB1ej0nA
fzx61jbcAKly8vg3NU/gL0k8KdqZhO4WuZ6sH5NCw1npjwwtCVXsZXzS9z+F
RGPuiFJpiIRx77Yz+zog7hivwbyIjD5uNA8WtXaCW9IWZVCsEbIvLq1rKe+C
XktnM66nMTIou0zJvt0NzSL+TWeyCXohna2Q5smAR3Lao3hpgnZWmgRezZKD
6XBGQKp4GfK7NXJ1NF0B6vsbCkoyl6Pea+mP3kb3QIHDGqPG8BWoqCl63DtU
CcKixM5YhimKt1r0itneC9EFPyjNx0yRktMcu8bsGcz53dOVtJkhTVpUlFXO
M1Cpd5yQnDFHHqTkrMszz+Culzu9J5aCSt6t41BS+6Aml0tLcrFA9IqYAOqr
PjgTHrebrLVA80qaZ3pwP2wbLq0807MSedavJEml/VDoeLOmZzcVuTLTNXVf
DcCpdkHh7kYqohcGOB6vGoBgevg9mR0NbT3gV3uR8Rx8Ujv30/JpyM5nrXOC
4DmUrGPZKbQ01EG5wpsxHAS7J79eC9lviaT++uRdRwZB6CJx6m+zRJPnmics
hwYhcdqor9sJQ6a5rYknQ3Bg1X1k5F/EEG3SouppIw5s/j594CUMxYiC5GXN
OHD3iQnzKxgKTTmvymrF4ayWe0F4DUObx830Xo9xEHnqFq4XY+jSjFVPQxcO
useL+P0qDLFt4ybKCByE/eYCaSeGPOZ/98jQ4lBUlnIwrxtDzJ7V4ZGzOJRx
lL4Bcgz13uGkeOhwePSFcF6uxJBB4La8f/Q4DEdjBwcGMWRbLolkGRFgr1rj
+0aFocM/UXgBGAFMcYZ1uRpDLWE8+qbVBHyTO6RLGMOQeKumnvQlAUH2xQ/+
1iz1TcoUTWsJOHaYYT01hSEqp/C2sy0Bmd9m6R5OY0gQYbG43I6AXMqb5xwt
hmo9cyPVmwgorC07PzeHITUpfbLYkYC7p42SmuYxNDc6wczYQkBVaMKOTP2S
rziUHOFCgNi2Y733ZwxR6kdvbHUjoG16s25xcenfojiJhTsB/wFH30ey
               "]]}, 
             Annotation[#, "Charting`Private`Tag$498445#1"]& ]}}, {}, {}}}, {
        DisplayFunction -> Identity, PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.05]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, AxesOrigin -> {0, 0}, PlotRange -> 
         NCache[{{0, 5}, {0, 
             Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True,
          ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
         NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {False, False},
          AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
         Identity, Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
            FormBox["\"Measurement\"", TraditionalForm], None}, {
            FormBox["\"Concentration\"", TraditionalForm], None}}, FrameStyle -> 
         GrayLevel[0], 
         FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
         FrameTicksStyle -> 12, GridLines -> {None, None}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 500, LabelStyle -> 12, 
         Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& ), "CopiedValueFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& )}}, PlotLabel -> FormBox[
           StyleBox["\"Ca\"", 16, 
            GrayLevel[0], StripOnInput -> False], TraditionalForm], PlotRange -> 
         NCache[{{0, 5}, {0, 
             Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True,
          PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.05]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           RowBox[{"\"STD\"", "~~", "__", "~~", "\"-2\""}]}, "PointLegend", 
          DisplayFunction -> (FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    PointBox[
                    NCache[{
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}]}, {
                    Scaled[{0.5, 0.5}]}]]}}}, AspectRatio -> Full, 
                    ImageSize -> {10, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.038000000000000006`] -> 
                    Baseline)], #}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 12, FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]& ), 
          InterpretationFunction :> (RowBox[{"PointLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False]}], "]"}], "}"}], ",", 
               RowBox[{"{", #, "}"}], ",", 
               RowBox[{"LegendMarkers", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"False", ",", "Automatic"}], "}"}], "}"}]}], ",", 
               RowBox[{"Joined", "\[Rule]", 
                 RowBox[{"{", "False", "}"}]}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", "12"}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
          Editable -> True], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Center}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{5}}}],
  "Column"]], "Output",
 ImageSize->{629, 343},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->673251083,ExpressionUUID->"292b20cf-3e1a-4aaf-bf48-5b27b031ab2f"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "BlankPattern",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "d4ab6c4d-3155-4f1c-bce3-a4048271f9e8"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"2f38077e-5747-4033-8f72-bcb9f4a99661"],

Cell["\<\
By default, no blank measurements are substracted, but a string pattern for \
keys of blank measurements can be specified, leading to the substraction of \
the interpolated blank values from all measurements:\
\>", "ExampleText",
 CellID->151883212,ExpressionUUID->"22200ea7-9cf4-4d85-b12a-6f531e05a05c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrationPlot", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<STD\>\"", "~~", "__", "~~", "\"\<-2\>\""}], "}"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->159914913,ExpressionUUID->"1a85da6d-592f-4d72-a87f-72ba741f4e08"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{GraphicsBox[{{{}, {{{}, {
             Hue[0.67, 0.6, 0.6], 
             Directive[
              PointSize[0.012833333333333334`], 
              AbsoluteThickness[1.6], 
              RGBColor[0.368417, 0.506779, 0.709798]], {
              
              PointBox[{{0.5049652620285187, 0.05589757314203252}, {
               1.623565252889819, 0.13877191675406503`}, {3.1122617784207023`,
                0.2465030831829382}, {4.993042482195919, 
               0.37414859414865204`}}], {{{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{0.5063106142581814, 0.05589757314203252}, {
                  0.503619909798856, 0.05589757314203252}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{0, 1.5}, {0.5063106142581814, 
                    0.05589757314203252}], 
                   
                   Offset[{0, -1.5}, {0.5063106142581814, 
                    0.05589757314203252}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {0.503619909798856, 0.05589757314203252}], 
                   
                   Offset[{0, -1.5}, {0.503619909798856, 
                    0.05589757314203252}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{0.5049652620285187, 0.05724976365300012}, {
                  0.5049652620285187, 0.05454538263106491}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {0.5049652620285187, 
                    0.05724976365300012}], 
                   
                   Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.05724976365300012}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {0.5049652620285187, 
                    0.05454538263106491}], 
                   
                   Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.05454538263106491}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{1.625430814243593, 0.13877191675406503`}, {
                  1.621699691536045, 0.13877191675406503`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{0, 1.5}, {1.625430814243593, 
                    0.13877191675406503`}], 
                   
                   Offset[{0, -1.5}, {1.625430814243593, 
                    0.13877191675406503`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{0, 1.5}, {1.621699691536045, 
                    0.13877191675406503`}], 
                   
                   Offset[{0, -1.5}, {1.621699691536045, 
                    0.13877191675406503`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{1.623565252889819, 0.14317605550983709`}, {
                  1.623565252889819, 0.13436777799829297`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {1.623565252889819, 
                    0.14317605550983709`}], 
                   
                   Offset[{-1.5, 0}, {1.623565252889819, 
                    0.14317605550983709`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {1.623565252889819, 
                    0.13436777799829297`}], 
                   
                   Offset[{-1.5, 0}, {1.623565252889819, 
                    0.13436777799829297`}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{3.1151882871548313`, 0.2465030831829382}, {
                  3.1093352696865733`, 0.2465030831829382}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{0, 1.5}, {3.1151882871548313`, 
                    0.2465030831829382}], 
                   
                   Offset[{0, -1.5}, {3.1151882871548313`, 
                    0.2465030831829382}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{0, 1.5}, {3.1093352696865733`, 
                    0.2465030831829382}], 
                   
                   Offset[{0, -1.5}, {3.1093352696865733`, 
                    0.2465030831829382}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{3.1122617784207023`, 0.24824360992204766`}, {
                  3.1122617784207023`, 0.24476255644382874`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.24824360992204766`}], 
                   
                   Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.24824360992204766`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.24476255644382874`}], 
                   
                   Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.24476255644382874`}]}]}}, {{
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{4.9974760369203075`, 0.37414859414865204`}, {
                  4.98860892747153, 0.37414859414865204`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{0, 1.5}, {4.9974760369203075`, 
                    0.37414859414865204`}], 
                   
                   Offset[{0, -1.5}, {4.9974760369203075`, 
                    0.37414859414865204`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{0, 1.5}, {4.98860892747153, 0.37414859414865204`}], 
                   
                   Offset[{0, -1.5}, {4.98860892747153, 
                    0.37414859414865204`}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 
                 LineBox[{{4.993042482195919, 0.3764608896563305}, {
                  4.993042482195919, 0.37183629864097356`}}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   Offset[{1.5, 0}, {4.993042482195919, 0.3764608896563305}], 
                   
                   Offset[{-1.5, 0}, {4.993042482195919, 
                    0.3764608896563305}]}]}, {
                 GrayLevel[0], 
                 Thickness[Tiny], 
                 Dashing[{}], 
                 LineBox[{
                   
                   Offset[{1.5, 0}, {4.993042482195919, 
                    0.37183629864097356`}], 
                   
                   Offset[{-1.5, 0}, {4.993042482195919, 
                    0.37183629864097356`}]}]}}}}}, {}}, {
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{0.5049652620285187, 0.05589757314203252}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{0.5063106142581814, 0.05589757314203252}, {
                    0.503619909798856, 0.05589757314203252}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{0, 1.5}, {0.5063106142581814, 
                    0.05589757314203252}], 
                    
                    Offset[{0, -1.5}, {0.5063106142581814, 
                    0.05589757314203252}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{0, 1.5}, {0.503619909798856, 
                    0.05589757314203252}], 
                    
                    Offset[{0, -1.5}, {0.503619909798856, 
                    0.05589757314203252}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{0.5049652620285187, 0.05724976365300012}, {
                    0.5049652620285187, 0.05454538263106491}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {0.5049652620285187, 
                    0.05724976365300012}], 
                    
                    Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.05724976365300012}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {0.5049652620285187, 
                    0.05454538263106491}], 
                    
                    Offset[{-1.5, 0}, {0.5049652620285187, 
                    0.05454538263106491}]}]}}}}}, 
              "\"STD 1 {0.5050(13), 0.0559(14)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 1 {0.5050(13), 0.0559(14)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{1.623565252889819, 0.13877191675406503`}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{1.625430814243593, 0.13877191675406503`}, {
                    1.621699691536045, 0.13877191675406503`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{0, 1.5}, {1.625430814243593, 
                    0.13877191675406503`}], 
                    
                    Offset[{0, -1.5}, {1.625430814243593, 
                    0.13877191675406503`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{0, 1.5}, {1.621699691536045, 
                    0.13877191675406503`}], 
                    
                    Offset[{0, -1.5}, {1.621699691536045, 
                    0.13877191675406503`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{1.623565252889819, 0.14317605550983709`}, {
                    1.623565252889819, 0.13436777799829297`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {1.623565252889819, 
                    0.14317605550983709`}], 
                    
                    Offset[{-1.5, 0}, {1.623565252889819, 
                    0.14317605550983709`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {1.623565252889819, 
                    0.13436777799829297`}], 
                    
                    Offset[{-1.5, 0}, {1.623565252889819, 
                    0.13436777799829297`}]}]}}}}}, 
              "\"STD 2 {1.6236(19), 0.1388(44)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 2 {1.6236(19), 0.1388(44)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{3.1122617784207023`, 0.2465030831829382}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{{3.1151882871548313`, 0.2465030831829382}, {
                    3.1093352696865733`, 0.2465030831829382}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{0, 1.5}, {3.1151882871548313`, 
                    0.2465030831829382}], 
                    
                    Offset[{0, -1.5}, {3.1151882871548313`, 
                    0.2465030831829382}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{0, 1.5}, {3.1093352696865733`, 
                    0.2465030831829382}], 
                    
                    Offset[{0, -1.5}, {3.1093352696865733`, 
                    0.2465030831829382}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{3.1122617784207023`, 0.24824360992204766`}, {
                    3.1122617784207023`, 0.24476255644382874`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.24824360992204766`}], 
                    
                    Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.24824360992204766`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {3.1122617784207023`, 
                    0.24476255644382874`}], 
                    
                    Offset[{-1.5, 0}, {3.1122617784207023`, 
                    0.24476255644382874`}]}]}}}}}, 
              "\"STD 3 {3.1123(29), 0.2465(17)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 3 {3.1123(29), 0.2465(17)}", "Tooltip"]& ], 
            TagBox[
             TooltipBox[{
               Opacity[0.], {
                PointBox[{{4.993042482195919, 0.37414859414865204`}}], {{{
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{4.9974760369203075`, 0.37414859414865204`}, {
                    4.98860892747153, 0.37414859414865204`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{0, 1.5}, {4.9974760369203075`, 
                    0.37414859414865204`}], 
                    
                    Offset[{0, -1.5}, {4.9974760369203075`, 
                    0.37414859414865204`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{0, 1.5}, {4.98860892747153, 
                    0.37414859414865204`}], 
                    
                    Offset[{0, -1.5}, {4.98860892747153, 
                    0.37414859414865204`}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   
                   LineBox[{{4.993042482195919, 0.3764608896563305}, {
                    4.993042482195919, 0.37183629864097356`}}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    Offset[{1.5, 0}, {4.993042482195919, 0.3764608896563305}], 
                    
                    Offset[{-1.5, 0}, {4.993042482195919, 
                    0.3764608896563305}]}]}, {
                   GrayLevel[0], 
                   Thickness[Tiny], 
                   Dashing[{}], 
                   LineBox[{
                    
                    Offset[{1.5, 0}, {4.993042482195919, 
                    0.37183629864097356`}], 
                    
                    Offset[{-1.5, 0}, {4.993042482195919, 
                    0.37183629864097356`}]}]}}}}}, 
              "\"STD 4 {4.9930(44), 0.3741(23)}\"", LabelStyle -> 
              "TextStyling"], 
             Annotation[#, "STD 4 {4.9930(44), 0.3741(23)}", 
              "Tooltip"]& ]}}, {}, {}, {}, {}}, {{{{}, {}, 
            TagBox[{
              Directive[
               Opacity[1.], 
               AbsoluteThickness[1.6], 
               GrayLevel[0]], 
              LineBox[CompressedData["
1:eJwVxWdQkwcYAOBAGE1IKOGrOEAShkQi06qolLyvYk8rcUMpeI4EBBEBQaIi
KhalyHlq1BQiHOQQEDxlyAUUB3uPyM5nwaoMlShXVpAAStsfzz1Wooi9R3Qp
FMqO//x/+gWRgWtgLP8Z03Rwyyfk13ZxBL4cPwjn5Cnc6GxYqC+/xOGEgJ1U
ajhFc4b0ymtsfU4M6Crprp00gOMe4rAv7CQYU9f9XEXbBV1zR6Vj7DsQHGPT
/oR2CAz7Brij7PuQhXv/VNAiILNZHvmJXQabskdOF9PioKAwqe+4UzOcP+hF
+WeVBIKh487nqC4Q8CPrnxnIIHzYflBR8Apcpg99NHsqB7rVZe6b9W+htmiB
t4WeDddNWniZhwchs6+MsB7LBVGfdwW19T1sOCywvmr/ECLrLosiuGoIyxMW
pnOL4NEJxr4lv4yC7/5bQY1mxZAZG6p28R0Dtnth0RNnBcTL5/dMfR6HOJ+q
23O2pUDpeovPz07CUE4dU2TyBOyig8548zSwwqZ02fUVT2FIk/Kr0YtpoPSl
VTIWP4ftw8fO34qcgccVYdrdq8th55BklaXlLGwclQX2W1WCukZ0sTF/DoZS
NLKyJVXgxOpd7nnoK3z7rTE5xrYa6KAR9k9+g4DHi96JLGtg66j/F2sfCro5
vJpycqwFsjpQx99BB5nPF3Uz3Oqg5ErtQY5GB11GWhcI53oI0he/VSp1scph
duqrewMERMWWMFKpKGfeXcdyawTn4FVKgVAP42g1nuscm+ClqYOReIM+Ks39
l/HXN8Ozgvg0B6oBhrSEekS4tkCsDm9362sDjLo5aX8JWoHef3ZbuMIQ46Km
3uVta4Phe1ZS+bnvUDUW8f4LKEG6cqlemQ8NMxKECnvBS5CkBjUIOXR81RcU
vNmmHfylB5SMD3QMjPf7aya9HWa25Gjl5UbIXWNYzLHpgMHhzWeqExl4Y82E
8wF5B9z1cDVvEzLRBWWmRnadkJ8gZgU7GuOp1Ni0tqxOSPQJ8KJqjJEfb05f
yu6Ctf2Z9xPbvkcP8anXPdldILNPy2/zMsGBUmPfXKtuiKu8JvMqM8EKqmit
Oq8bdpj75DTbstDi70htiWMPbApv2M9KYiHbsCIg+X4PyC1Etq0aFvq5N6z+
6NwLtjW5yTv3m6J7OSNvZ34vSByreZ3lppihNKbyV6ogaFKvo4lH4Hp1S3VG
vgpEjyY4STcIPO1dv/IHHgnH4/fNb79J4GLVjiFwIEG8T6Fi3CawxK9HHupE
whWN+LokmcCJg0NmNatJKNignUtJJzAsRFc/yp0EbdVC770HBAov8N+9FJAg
6WRcq20gcHte6Z2rESSkZoUd/aOJwBEe3+dxJAlZ0UrPbS0EJubXmQyeJKHU
TDLboiSwtrg7ceMZEvr9iaNdPQTCiwnxyEUSuINLPQcGCfyx02nv1lskuCjO
WmYPE9jhXco8KSVhY0Kf9sgHAk+oPJoykkkQcNOLRtQEPuwX4HQqCVGhHMvx
cQK5H4455WSRcO6n37XFkwTWh0yMtOeQkMAc6I7WEBj4OSZnPpcEWWHW1ZkZ
AjPHr1h4PyTh7kW94KezBG6KNiHjCkh4sOfI5nPzBL6ZTrn9oIgEhXX9cv43
As/HsHepikkon7TTLiwQaDF/j04tIeFfC7lDTA==
               "]]}, 
             Annotation[#, "Charting`Private`Tag$503242#1"]& ]}}, {}, {}}}, {
        DisplayFunction -> Identity, PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.05]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, AxesOrigin -> {0, 0}, PlotRange -> 
         NCache[{{0, 5}, {0, 
             Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True,
          ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
         NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {False, False},
          AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
         Identity, Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
            FormBox["\"Measurement\"", TraditionalForm], None}, {
            FormBox["\"Concentration\"", TraditionalForm], None}}, FrameStyle -> 
         GrayLevel[0], 
         FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
         FrameTicksStyle -> 12, GridLines -> {None, None}, GridLinesStyle -> 
         Directive[
           GrayLevel[0.5, 0.4]], ImageSize -> 500, LabelStyle -> 12, 
         Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& ), "CopiedValueFunction" -> ({
               (Identity[#]& )[
                Part[#, 1]], 
               (Identity[#]& )[
                Part[#, 2]]}& )}}, PlotLabel -> FormBox[
           StyleBox["\"Ca\"", 16, 
            GrayLevel[0], StripOnInput -> False], TraditionalForm], PlotRange -> 
         NCache[{{0, 5}, {0, 
             Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True,
          PlotRangePadding -> {{
            Scaled[0.02], 
            Scaled[0.05]}, {
            Scaled[0.02], 
            Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
        FormBox[
         TemplateBox[{
           RowBox[{"\"STD\"", "~~", "__", "~~", "\"-2\""}]}, "PointLegend", 
          DisplayFunction -> (FormBox[
            StyleBox[
             StyleBox[
              PaneBox[
               TagBox[
                GridBox[{{
                   TagBox[
                    GridBox[{{
                    GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    PointBox[
                    NCache[{
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}]}, {
                    Scaled[{0.5, 0.5}]}]]}}}, AspectRatio -> Full, 
                    ImageSize -> {10, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.038000000000000006`] -> 
                    Baseline)], #}}, 
                    GridBoxAlignment -> {
                    "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                    AutoDelete -> False, 
                    GridBoxDividers -> {
                    "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{All}}, "Rows" -> {{All}}}, 
                    GridBoxSpacings -> {
                    "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {{Left}}, "Rows" -> {{Top}}}, AutoDelete -> 
                 False, GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
                "Grid"], Alignment -> Left, AppearanceElements -> None, 
               ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
               "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
             FontSize -> 12, FontFamily -> "Arial"}, Background -> Automatic, 
             StripOnInput -> False], TraditionalForm]& ), 
          InterpretationFunction :> (RowBox[{"PointLegend", "[", 
             RowBox[{
               RowBox[{"{", 
                 RowBox[{"Directive", "[", 
                   RowBox[{
                    RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                    ",", 
                    RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                    InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False]}], "]"}], "}"}], ",", 
               RowBox[{"{", #, "}"}], ",", 
               RowBox[{"LegendMarkers", "\[Rule]", 
                 RowBox[{"{", 
                   RowBox[{"{", 
                    RowBox[{"False", ",", "Automatic"}], "}"}], "}"}]}], ",", 
               RowBox[{"Joined", "\[Rule]", 
                 RowBox[{"{", "False", "}"}]}], ",", 
               RowBox[{"LabelStyle", "\[Rule]", "12"}], ",", 
               RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
          Editable -> True], TraditionalForm], TraditionalForm]},
      "Legended",
      DisplayFunction->(GridBox[{{
          TagBox[
           ItemBox[
            PaneBox[
             TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline},
              BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
           "SkipImageSizeLevel"], 
          ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
        GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
        AutoDelete -> False, GridBoxItemSize -> Automatic, 
        BaselinePosition -> {1, 1}]& ),
      Editable->True,
      InterpretationFunction->(RowBox[{"Legended", "[", 
         RowBox[{#, ",", 
           RowBox[{"Placed", "[", 
             RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Center}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{5}}}],
  "Column"]], "Output",
 ImageSize->{629, 343},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->345826119,ExpressionUUID->"40526da1-0936-41a7-b4ee-23332bccbb24"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"26a2874b-92b6-4486-8be9-a70c0f722a48"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"78f065c2-1d3e-4114-93b8-e88697cea09c"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"e0ea4bc8-0126-4c27-afe4-3e5197428e8a"],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["CalibrateCompositionalData"]],
   "paclet:DataAnalysis/ref/CalibrateCompositionalData"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> 
    "Verdana"}]], \
"InlineFormula",ExpressionUUID->"1aad7608-bb1a-43e0-8f07-d54df91958ce"]], \
"SeeAlso",
 CellID->929782353,ExpressionUUID->"f53776da-dcb5-42a6-8883-f90fa62e9a80"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"6bfef641-29c0-48bb-8ea8-6e76efba7507"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"0813b327-296d-46df-9bab-86ca0fcf88b4"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"f31d9997-7067-4e52-9368-c406da7b50fa"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->70422118,ExpressionUUID->"a8b0faa1-a973-4e9f-9ecd-4182e6c673a7"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"5c565baf-dbd4-4907-ac1f-dca7b98e6152"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CalibrationPlot",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 35, 58.9409706}", 
    "history" -> {"XX", "", "", ""}, "context" -> 
    "DataAnalysis`CompositionalAnalysis`", "keywords" -> {}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "CalibrationPlot[datatable,standardData,column,{standardPattern1,\
standardPattern2,...}] plots the measurements in a specific column (e.g. \
compound) of the DataTable for the standards matched by each standardPatterni \
vs. the corresponding concentrations specified by the standards. \
CalibrationPlot[datatable,standardData,{column1,column2,...},{\
standardPattern1,standardPattern2,...}] plots the measurements in a series of \
columns (e.g. compounds).", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "CalibrationPlot", "titlemodifier" -> "", "windowtitle" -> 
    "CalibrationPlot", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/CalibrationPlot"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[12352, 316, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"e8ab11f3-5951-4ca0-aec5-ff0dcbd41b77",
   CellTags->"PrimaryExamplesSection",
   CellID->542794083]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 234527, 5233}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[587, 21, 4172, 94, 55, "AnchorBarGrid",ExpressionUUID->"ce07d8a2-45e7-4650-a661-e2cad91408ff",
 CellID->1],
Cell[CellGroupData[{
Cell[4784, 119, 400, 9, 52, "ObjectNameGrid",ExpressionUUID->"c3eb78aa-306a-4014-b788-890d5a0072b8"],
Cell[5187, 130, 3190, 80, 226, "Usage",ExpressionUUID->"fe8ae8a5-29ae-4c98-b601-33d492ea1f30"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8414, 215, 855, 21, 37, "NotesSection",ExpressionUUID->"07c1896b-6d54-46d7-9434-f31e3c3ce706",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->282378875],
Cell[9272, 238, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"45042d24-1e34-48b4-98d1-4e9a7c055088"],
Cell[9361, 240, 496, 11, 70, "Notes",ExpressionUUID->"26d24f98-86d0-44c3-a846-d69731b0720f",
 CellID->129691455],
Cell[9860, 253, 860, 20, 70, "Notes",ExpressionUUID->"145f0f4d-2924-40f2-9eb6-e3363e40aafa",
 CellID->39075408],
Cell[10723, 275, 108, 0, 70, "Notes",ExpressionUUID->"f997b615-d69b-4549-b81b-a6b66dceda10"],
Cell[10834, 277, 1392, 32, 70, "3ColumnTableMod",ExpressionUUID->"bdfc2916-bf35-41dc-8733-6e34107f8632"],
Cell[12229, 311, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"1a9c172b-885c-4aa2-b307-947b22ff221a"]
}, Closed]],
Cell[CellGroupData[{
Cell[12352, 316, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"e8ab11f3-5951-4ca0-aec5-ff0dcbd41b77",
 CellTags->"PrimaryExamplesSection",
 CellID->542794083],
Cell[CellGroupData[{
Cell[12812, 331, 308, 7, 29, "ExampleSection",ExpressionUUID->"e06f6586-b93a-4ca7-9617-773aa66723a6",
 CellID->341469767],
Cell[13123, 340, 235, 4, 57, "ExampleText",ExpressionUUID->"e106559c-186a-41c4-a44d-037e474dfc45",
 CellID->3921242],
Cell[CellGroupData[{
Cell[13383, 348, 1185, 30, 91, "Input",ExpressionUUID->"3a539e43-54b4-41ca-b429-bb19de4104ef",
 CellID->312812059],
Cell[14571, 380, 29147, 586, 197, "Output",ExpressionUUID->"5801fb8f-bc94-4af8-93b9-d73101a37ddd",
 CellID->531943659]
}, Open  ]],
Cell[43733, 969, 122, 1, 70, "ExampleText",ExpressionUUID->"e623b894-d867-4f33-b3c4-11b2ed104450",
 CellID->26645253],
Cell[CellGroupData[{
Cell[43880, 974, 6756, 173, 70, "Input",ExpressionUUID->"8c72aedb-11cc-413d-bb32-188b4a2d7fa4",
 CellID->792318828],
Cell[50639, 1149, 64929, 1328, 70, "Output",ExpressionUUID->"96efb6d7-3f04-46b1-ab12-124dbbf7acf8",
 CellID->335711839]
}, Open  ]],
Cell[115583, 2480, 178, 3, 70, "ExampleText",ExpressionUUID->"c393918e-b600-4810-85fe-fd342a68b447",
 CellID->419374998],
Cell[115764, 2485, 173, 4, 70, "Input",ExpressionUUID->"5e86b4ac-e132-4573-8cca-fc6c05c17866",
 CellID->177615652],
Cell[CellGroupData[{
Cell[115962, 2493, 339, 8, 70, "Input",ExpressionUUID->"caf4dcfc-ed6e-46f1-a7d4-b1a74b62ec71",
 CellID->25033209],
Cell[116304, 2503, 27489, 619, 70, "Output",ExpressionUUID->"765897c4-1a6a-49fc-b80c-82e40060def6",
 CellID->7457263]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[143842, 3128, 284, 7, 70, "ExampleSection",ExpressionUUID->"80bd2a98-9e88-45d1-9405-065a5886da27"],
Cell[CellGroupData[{
Cell[144151, 3139, 303, 7, 70, "ExampleSubsection",ExpressionUUID->"6340e028-3162-4cd4-8558-5d67346a9a81"],
Cell[144457, 3148, 203, 4, 70, "ExampleText",ExpressionUUID->"7539cc0b-b2b6-44b7-b681-e0651328bab7",
 CellID->432298880],
Cell[CellGroupData[{
Cell[144685, 3156, 399, 8, 70, "Input",ExpressionUUID->"ed84e615-c00b-4f46-8e6a-3c44e71cf7b2",
 CellID->139674814],
Cell[145087, 3166, 27306, 613, 70, "Output",ExpressionUUID->"d889239e-16a0-412f-9d29-df62e3b1e216",
 CellID->242546102]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[172442, 3785, 303, 7, 70, "ExampleSubsection",ExpressionUUID->"967a8df4-f3d0-46b7-b142-0499a0629c65"],
Cell[172748, 3794, 192, 4, 70, "ExampleText",ExpressionUUID->"a1d5f5c3-ac1e-487a-8b4d-655e5ce860de",
 CellID->20320721],
Cell[CellGroupData[{
Cell[172965, 3802, 399, 8, 70, "Input",ExpressionUUID->"b4195ec1-dea4-4061-b956-0afbb722847a",
 CellID->646456666],
Cell[173367, 3812, 27318, 613, 70, "Output",ExpressionUUID->"292b20cf-3e1a-4aaf-bf48-5b27b031ab2f",
 CellID->673251083]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[200734, 4431, 295, 7, 70, "ExampleSubsection",ExpressionUUID->"2f38077e-5747-4033-8f72-bcb9f4a99661"],
Cell[201032, 4440, 314, 5, 70, "ExampleText",ExpressionUUID->"22200ea7-9cf4-4d85-b12a-6f531e05a05c",
 CellID->151883212],
Cell[CellGroupData[{
Cell[201371, 4449, 427, 9, 70, "Input",ExpressionUUID->"1a85da6d-592f-4d72-a87f-72ba741f4e08",
 CellID->159914913],
Cell[201801, 4460, 28789, 665, 70, "Output",ExpressionUUID->"40526da1-0936-41a7-b4ee-23332bccbb24",
 CellID->345826119]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[230629, 5130, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"26a2874b-92b6-4486-8be9-a70c0f722a48"]
}, Open  ]],
Cell[CellGroupData[{
Cell[230752, 5135, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"e0ea4bc8-0126-4c27-afe4-3e5197428e8a",
 CellID->1255426704],
Cell[231015, 5144, 395, 10, 70, "SeeAlso",ExpressionUUID->"f53776da-dcb5-42a6-8883-f90fa62e9a80",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[231447, 5159, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"0813b327-296d-46df-9bab-86ca0fcf88b4",
 CellID->38303248],
Cell[231716, 5168, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"f31d9997-7067-4e52-9368-c406da7b50fa"],
Cell[231805, 5170, 246, 6, 70, "MoreAbout",ExpressionUUID->"a8b0faa1-a973-4e9f-9ecd-4182e6c673a7",
 CellID->70422118]
}, Open  ]],
Cell[232066, 5179, 78, 0, 70, "FooterCell",ExpressionUUID->"5c565baf-dbd4-4907-ac1f-dca7b98e6152"]
}
]
*)

(* End of internal cache information *)

