(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     12855,        339]
NotebookOptionsPosition[      8775,        245]
NotebookOutlinePosition[     11066,        304]
CellTagsIndexPosition[     10981,        299]
WindowTitle->ChemElementName
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "bfd63c85-3bff-4114-9060-84a1ebe2e162"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"5b708c60-bb41-4469-9699-f011955c2aa7"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"RegisterOxide\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/RegisterOxide"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "72000308-007a-4bc2-abae-acdd73c0891c"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"b3fdc9a6-6e85-49c8-8ab3-f5c1250c3752"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "9b8dd1f0-3a30-4adc-a16c-c29d59d7e8c1"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"8e576125-6368-430e-8ab0-0e2886b65c49"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/ChemElementName\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/ChemElementName"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
ChemElementName.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$12963], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/ChemElementName", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "813b0f4e-7c4a-48a7-8d84-3f5d5a04fb45"]
    }], "AnchorBar",ExpressionUUID->"b49e0aaf-e683-425c-aa05-0ad9e1ede5c7"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"56b3e11c-9bbb-4537-b7a2-7a2e61c1eab2"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["ChemElementName", "ObjectName",ExpressionUUID->
  "123b6145-59c0-455f-9664-801ccd7701d2"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"4be572f0-39a1-4b04-af53-5af881ac729f"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "ad90f365-a5d7-4c47-88cf-e4639fa7099e"]
}], "ObjectNameGrid",ExpressionUUID->"7495bfef-da8b-4223-90a2-9d5f9082ea15"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"ChemElementName", "[", 
       StyleBox["oxide", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "1fd5f8d0-b6e5-4c4c-83da-800de08373de"],
     "\[LineSeparator]returns the element string for the registered chemical \
oxide compound ",
     Cell[BoxData[
      StyleBox["oxide", "TI"]], "InlineFormula",ExpressionUUID->
      "c3d34061-cf3a-4026-bbc8-d457641b8a83"],
     "."
    }],ExpressionUUID->"6dc529fd-7c93-4b79-b2c8-9066c9bb9ad1"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"9f97024a-e0e6-43e3-bf9e-c6c9eabf2b5d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"250eecba-cb3c-4df3-8db8-0bc147f2ba4b"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "fec7d648-78a8-4447-91b7-62f55f8f11ee"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->327407694,ExpressionUUID->"bb8f6cad-4252-4849-89b6-54e0c38832e2"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "502cd277-e05c-40d1-bcf0-f62c8d5118d3"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->53302366,ExpressionUUID->"90380a31-fa7f-410a-8186-499d5514a2a1"],

Cell["Get the element name of a defined oxide:", "ExampleText",
 CellID->239321507,ExpressionUUID->"e5bdcbfe-3393-4023-a74f-2a5ef456ceea"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChemElementName", "[", "\"\<CO2\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->329063717,ExpressionUUID->"3a640a91-eac8-40e2-a126-0158e0aa6c10"],

Cell[BoxData["\<\"C\"\>"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->279115020,ExpressionUUID->"2f5e8884-3200-4510-a43a-3a87317e4823"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"59145b6f-33c2-467f-a6aa-b40d32329055"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"da092243-4b1c-45bd-a2c2-39afc5fbd10d"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"d745730a-5141-43f1-bf5e-a5178a0d3913"],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> 
    "Verdana"}]], \
"InlineFormula",ExpressionUUID->"ff6b9260-a728-4cd2-b7e0-6ec50c58deb5"]], \
"SeeAlso",
 CellID->929782353,ExpressionUUID->"39247016-40b7-47f8-8ee1-a1fb9f616496"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"0616c1f3-a1b9-4084-a6eb-4d01ed0ea498"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"991c2fd2-b94f-471c-8055-6cd207b028a7"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"ce48bbae-84d9-4e30-b7c1-e994f6071ef8"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->249064885,ExpressionUUID->"6a994a54-1b5b-46bf-b1a6-8b53985d2265"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"e3e17c25-dc5d-4720-8c40-5840d1f8c17d"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ChemElementName",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 1.3096034}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "ChemElementName[oxide] returns the element string for the registered \
chemical oxide compound oxide.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "ChemElementName", "titlemodifier" -> "", "windowtitle" -> 
    "ChemElementName", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/ChemElementName"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5925, 152, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"bb8f6cad-4252-4849-89b6-54e0c38832e2",
   CellTags->"PrimaryExamplesSection",
   CellID->327407694]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 10783, 292}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[587, 21, 4138, 93, 55, "AnchorBarGrid",ExpressionUUID->"56b3e11c-9bbb-4537-b7a2-7a2e61c1eab2",
 CellID->1],
Cell[CellGroupData[{
Cell[4750, 118, 400, 9, 52, "ObjectNameGrid",ExpressionUUID->"7495bfef-da8b-4223-90a2-9d5f9082ea15"],
Cell[5153, 129, 735, 18, 109, "Usage",ExpressionUUID->"9f97024a-e0e6-43e3-bf9e-c6c9eabf2b5d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5925, 152, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"bb8f6cad-4252-4849-89b6-54e0c38832e2",
 CellTags->"PrimaryExamplesSection",
 CellID->327407694],
Cell[CellGroupData[{
Cell[6385, 167, 307, 7, 29, "ExampleSection",ExpressionUUID->"90380a31-fa7f-410a-8186-499d5514a2a1",
 CellID->53302366],
Cell[6695, 176, 138, 1, 38, "ExampleText",ExpressionUUID->"e5bdcbfe-3393-4023-a74f-2a5ef456ceea",
 CellID->239321507],
Cell[CellGroupData[{
Cell[6858, 181, 176, 3, 26, "Input",ExpressionUUID->"3a640a91-eac8-40e2-a126-0158e0aa6c10",
 CellID->329063717],
Cell[7037, 186, 221, 5, 35, "Output",ExpressionUUID->"2f5e8884-3200-4510-a43a-3a87317e4823",
 CellID->279115020]
}, Open  ]]
}, Open  ]],
Cell[7285, 195, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"59145b6f-33c2-467f-a6aa-b40d32329055"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7408, 200, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"d745730a-5141-43f1-bf5e-a5178a0d3913",
 CellID->1255426704],
Cell[7671, 209, 365, 9, 24, "SeeAlso",ExpressionUUID->"39247016-40b7-47f8-8ee1-a1fb9f616496",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[8073, 223, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"991c2fd2-b94f-471c-8055-6cd207b028a7",
 CellID->38303248],
Cell[8342, 232, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"ce48bbae-84d9-4e30-b7c1-e994f6071ef8"],
Cell[8431, 234, 247, 6, 24, "MoreAbout",ExpressionUUID->"6a994a54-1b5b-46bf-b1a6-8b53985d2265",
 CellID->249064885]
}, Open  ]],
Cell[8693, 243, 78, 0, 41, "FooterCell",ExpressionUUID->"e3e17c25-dc5d-4720-8c40-5840d1f8c17d"]
}
]
*)

(* End of internal cache information *)

