(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     13687,        366]
NotebookOptionsPosition[      9542,        270]
NotebookOutlinePosition[     11896,        330]
CellTagsIndexPosition[     11811,        325]
WindowTitle->CorrelatedErrors
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "24591ac8-2e2f-477f-a764-ab8646a31223"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"5b820c16-ed5d-4d12-95da-f9b64911e044"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DVEvaluate\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVEvaluate"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "401bab2e-5bbb-4417-95ae-34f2c96470f0"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"452dfbd1-377a-43a5-bffa-8cbc3656ecc2"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/CorrelatedErrors\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/CorrelatedErrors"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
CorrelatedErrors.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$14775], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/CorrelatedErrors", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "820ff7d7-2e6f-413e-bc5a-34caaa281615"]
    }], "AnchorBar",ExpressionUUID->"a1b749ac-f933-4db3-a603-e785ee9026b6"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"2cdd2b88-1d23-470b-a777-285e3afdc671"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["CorrelatedErrors", "ObjectName",ExpressionUUID->
  "d6be3869-6a27-413e-9b46-3461a49aa85f"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"48f18d59-9a1b-4422-84b0-366ab05e4230"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "1fe878cf-a570-4ada-8960-42f498db0043"]
}], "ObjectNameGrid",ExpressionUUID->"88b783cf-01c8-4b38-b552-ce8a4b877326"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
     "CorrelatedErrors"], "InlineFormula",ExpressionUUID->
      "25683cdd-00be-408e-bc86-1081491dc653"],
     "\[LineSeparator]is an option for ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "01f6a2f7-d3ae-466f-9827-b4a12de6785e"],
     " to specify whether to assume that all random errors are perfectly \
correlated (True) or completely uncorrelated (False)."
    }],ExpressionUUID->"f2818423-cff9-4352-858c-8d93b67e65ec"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"fab860ba-50dc-45d6-96f1-2de729d2b7d6"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"18e1c58c-9ad9-4ecd-b4c2-c50b2da4ca30"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "11c83f2e-5245-49f5-ae39-2fa6f5a1e2c8"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->291035635,ExpressionUUID->"dd4f1cfe-003e-47cd-8123-6a1232ebd659"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "d1f733e3-8240-42e3-8a66-352a0e963189"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->522639025,ExpressionUUID->"5dea01cc-0de4-49f8-b9d5-ba2e8e0ec566"],

Cell["By default, uncertainties are assumed to be independent:", "ExampleText",
 CellID->394312261,ExpressionUUID->"8538adb2-be0b-456b-9ff4-ed281eb410bf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"NDV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}], "+", 
   RowBox[{"NDV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91034830,ExpressionUUID->"cc3ad64a-3de5-4c85-bad9-0b4c03b6390d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"10.0\"", 10., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "11","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[
  10., 0.5656854249492381, $CellContext`dv$417464]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->493117322,ExpressionUUID->"8fa67ba7-0f90-4c37-a993-7753779cfb2c"]
}, Open  ]],

Cell[TextData[{
 "Setting ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CorrelatedErrors"]],"paclet:DataAnalysis/ref/CorrelatedErrors"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "9532e313-a36e-4920-912e-8480753fb3d8"],
 " to True assumes that all variables with uncertainties are perfectly \
correlated:"
}], "ExampleText",
 CellID->196478336,ExpressionUUID->"3f34dbdf-dee2-41ad-a0b7-37b5c1f19d8b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NDV", "[", 
     RowBox[{"5", ",", "0.4"}], "]"}], "+", 
    RowBox[{"NDV", "[", 
     RowBox[{"5", ",", "0.4"}], "]"}]}], ",", 
   RowBox[{"CorrelatedErrors", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->174807330,ExpressionUUID->"82cf990e-70bc-44da-9fc8-0c0ce8f77635"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"10.0\"", 10., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "16","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[10., 0.8, $CellContext`dv$422103]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->3531948,ExpressionUUID->"bb6084f3-e7f3-4d10-8b4a-d43cdeae66fc"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"b2e60157-798d-4714-942e-7dbe3128fdfa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"b430fae2-c537-446f-a305-ca0286ecced1"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"033bef98-f4c7-4333-b837-f8141bb96118"],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> 
    "Verdana"}]], \
"InlineFormula",ExpressionUUID->"632c91f4-8a79-4b2c-a9e7-1fb01e628a86"]], \
"SeeAlso",
 CellID->929782353,ExpressionUUID->"335c98e2-4c64-4913-927a-9a681ea0c4dd"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"cc006715-0b25-447b-8dc8-4ae4a5dbc3aa"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CorrelatedErrors",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 7.4301116}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "CorrelatedErrors is an option for DVEvaluate to specify whether to \
assume that all random errors are perfectly correlated (True) or completely \
uncorrelated (False).", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "CorrelatedErrors", "titlemodifier" -> "", "windowtitle" -> 
    "CorrelatedErrors", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/CorrelatedErrors"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5399, 138, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"dd4f1cfe-003e-47cd-8123-6a1232ebd659",
   CellTags->"PrimaryExamplesSection",
   CellID->291035635]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 11613, 318}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[588, 21, 3475, 77, 55, "AnchorBarGrid",ExpressionUUID->"2cdd2b88-1d23-470b-a777-285e3afdc671",
 CellID->1],
Cell[CellGroupData[{
Cell[4088, 102, 401, 9, 52, "ObjectNameGrid",ExpressionUUID->"88b783cf-01c8-4b38-b552-ce8a4b877326"],
Cell[4492, 113, 870, 20, 131, "Usage",ExpressionUUID->"fab860ba-50dc-45d6-96f1-2de729d2b7d6"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5399, 138, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"dd4f1cfe-003e-47cd-8123-6a1232ebd659",
 CellTags->"PrimaryExamplesSection",
 CellID->291035635],
Cell[CellGroupData[{
Cell[5859, 153, 308, 7, 29, "ExampleSection",ExpressionUUID->"5dea01cc-0de4-49f8-b9d5-ba2e8e0ec566",
 CellID->522639025],
Cell[6170, 162, 154, 1, 38, "ExampleText",ExpressionUUID->"8538adb2-be0b-456b-9ff4-ed281eb410bf",
 CellID->394312261],
Cell[CellGroupData[{
Cell[6349, 167, 299, 8, 26, "Input",ExpressionUUID->"cc3ad64a-3de5-4c85-bad9-0b4c03b6390d",
 CellID->91034830],
Cell[6651, 177, 587, 16, 35, "Output",ExpressionUUID->"8fa67ba7-0f90-4c37-a993-7753779cfb2c",
 CellID->493117322]
}, Open  ]],
Cell[7253, 196, 449, 11, 58, "ExampleText",ExpressionUUID->"3f34dbdf-dee2-41ad-a0b7-37b5c1f19d8b",
 CellID->196478336],
Cell[CellGroupData[{
Cell[7727, 211, 376, 10, 26, "Input",ExpressionUUID->"82cf990e-70bc-44da-9fc8-0c0ce8f77635",
 CellID->174807330],
Cell[8106, 223, 567, 15, 35, "Output",ExpressionUUID->"bb6084f3-e7f3-4d10-8b4a-d43cdeae66fc",
 CellID->3531948]
}, Open  ]]
}, Open  ]],
Cell[8700, 242, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"b2e60157-798d-4714-942e-7dbe3128fdfa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8823, 247, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"033bef98-f4c7-4333-b837-f8141bb96118",
 CellID->1255426704],
Cell[9086, 256, 359, 9, 24, "SeeAlso",ExpressionUUID->"335c98e2-4c64-4913-927a-9a681ea0c4dd",
 CellID->929782353]
}, Open  ]],
Cell[9460, 268, 78, 0, 41, "FooterCell",ExpressionUUID->"cc006715-0b25-447b-8dc8-4ae4a5dbc3aa"]
}
]
*)

(* End of internal cache information *)

