(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    103428,       2316]
NotebookOptionsPosition[     96907,       2175]
NotebookOutlinePosition[     99188,       2234]
CellTagsIndexPosition[     99102,       2229]
WindowTitle->DTPlot
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "838e5fd6-6f18-4bd4-9cb3-4479e566c857"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"d05e731d-1aec-4164-9fa7-d4fa64e58eed"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataTable\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DataTable"], "\<\"NDV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/NDV"], "\<\"DV\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DV"], "\<\"ErrorListPlot\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/ErrorListPlot"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "2003ede2-4324-4d0e-b5b7-73ebeb74cbb6"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"bab755d9-0afc-437c-8410-b32b56d695c5"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "66596829-8ade-43d4-99c0-3e3f76b39e19"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"cd45fbd5-1530-4a1b-bb84-27371745735f"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/DTPlot\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/DTPlot"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
DTPlot.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$16849], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/DTPlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4fbb50c0-46ff-4c15-ac75-e557b6f2d185"]
    }], "AnchorBar",ExpressionUUID->"73d48ea0-6f33-4de6-9ee5-0408bc773de0"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"e58492f4-b9d4-4b27-ab47-3ffe874453fa"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["DTPlot", "ObjectName",ExpressionUUID->
  "235afab6-7fe2-4a93-b0e2-7dbaaa77aea9"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"f322430f-d1d4-4226-939a-35ebef7a4e63"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "8c987887-3bdc-45a7-ba1e-8ac0ac251161"]
}], "ObjectNameGrid",ExpressionUUID->"261e0e83-6170-434a-b178-6930529e4be3"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DTPlot", "[", 
       StyleBox["datatable", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "25e9e1ac-928a-4ef1-858e-dcca920dc620"],
     "\[LineSeparator]returns a plots of the ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "6378b93f-429d-4982-91b4-6d73ae287202"],
     " object. "
    }],ExpressionUUID->"7f470b0d-a597-46a2-b31b-6e25365be4bc"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DTPlot", "[", 
       RowBox[{
        SubscriptBox[
         StyleBox["datatable", "TI"], 
         StyleBox["1", "TR"]], ",", 
        SubscriptBox[
         StyleBox["datatable", "TI"], 
         StyleBox["2", "TR"]]}], "]"}]], "InlineFormula",
      ShowStringCharacters->False,ExpressionUUID->
      "4478d781-8ebe-4b83-9b2f-040575ababc0"],
     "\[LineSeparator]returns a plots of the ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "b2844704-5656-408a-93b8-c4440b748291"],
     " objects."
    }],ExpressionUUID->"78a0be48-d45a-4b11-b741-761feb5e712a"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"95f26a2f-acb0-4e3e-a9ce-c96cecdfeef2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"2157f7b3-57e8-465a-8f55-ec656ee0d32c"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"9d144a29-8593-4b5f-82eb-97ffeeeac305"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"683e1cb8-6645-4f0e-80cd-9a7b289ca14d"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->54457891,ExpressionUUID->"3d6b522c-91bd-473b-8b83-167b267b938d"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"00c27441-fa55-43c4-8e8a-8e745053ebe8"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DTPlot"]],"paclet:DataAnalysis/ref/DTPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "b8e64793-8e2d-4e3c-91ff-755657e8efed"],
 " allows the generation of simple plots from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "7a63b2b6-aae0-4896-a15d-13018ca8eb28"],
 " objects."
}], "Notes",
 CellID->515141998,ExpressionUUID->"96b5c643-798b-4cfd-9973-e2c70619935d"],

Cell[TextData[{
 "Error bars are plotted for ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "8f041abc-7238-4114-a043-629ed634e11e"],
 " and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "e7e148f5-8f00-4019-b496-621e0930339b"],
 " symbols in the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "5da8317d-934b-4336-b404-b24f0ae7e272"],
 "."
}], "Notes",
 CellID->517570381,ExpressionUUID->"10b2f580-4c7a-42d6-84cf-33a50477a508"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DTPlot"]],"paclet:DataAnalysis/ref/DTPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "790c5e63-1327-4c5f-b3f8-ac3f018c9d13"],
 " has the same options as ",
 ButtonBox["ErrorListPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ErrorBarPlots/ref/ErrorListPlot"],
 ", with the following additions and changes:"
}], "Notes",ExpressionUUID->"3958f189-1246-4443-9871-d8562a38a3ad"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "85286d68-7093-4ccf-97e3-faf25ccd58da"], 
    ButtonBox["Axes",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Axes"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell["\<\
Axes is an option for graphics functions that specifies whether axes should \
be drawn. \
\>", "TableText",ExpressionUUID->"dcede33b-9aa8-4601-b176-462bb625bd25"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "1cb782c2-1e01-45ec-935a-6849486be93f"], 
    ButtonBox["Frame",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Frame"], 
    ButtonBox["True",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/True"], Cell["\<\
Frame is an option for Graphics, Grid, and other constructs that specifies \
whether to include a frame. \
\>", "TableText",ExpressionUUID->"e79a43fb-65dd-4b09-84d2-61085ca1353c"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "63608da4-1442-48ef-81a9-1bb2c138d1a2"], 
    ButtonBox["FrameLabel",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/FrameLabel"], 
    RowBox[{"Automatic", " ", "labels"}], Cell["\<\
FrameLabel is an option for Graphics, Manipulate, and related functions that \
specifies labels to be placed on the edges of a frame. \
\>", "TableText",ExpressionUUID->"555575d5-4ca0-43c5-ba8b-a44c993e5f70"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "cda61aaf-48d8-439c-9794-e86a6b69f0a8"], 
    ButtonBox["FrameStyle",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/FrameStyle"], 
    ButtonBox["Black",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Black"], Cell["\<\
FrameStyle is an option for Graphics, Grid, and other constructs that \
specifies the style in which to draw frames.\
\>", "TableText",ExpressionUUID->"b9fdae52-d300-4a83-948e-c6427643a186"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "87f09ad6-c0d1-49d4-8511-6fcfc0bb4bf0"], 
    ButtonBox["FrameTicksStyle",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/FrameTicksStyle"], "12", Cell["\<\
FrameTicksStyle is an option for 2D graphics functions that specifies how \
frame ticks should be rendered.\
\>", "TableText",ExpressionUUID->"aca7811b-cb88-45d4-b66a-3e58c07f7e76"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "5cc4f286-443b-4c83-8cc8-4dd89e987028"], 
    ButtonBox["ImageSize",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/ImageSize"], "400", Cell["\<\
ImageSize is an option that specifies the overall size of an image to display \
for an object. \
\>", "TableText",ExpressionUUID->"5442a6f6-e37e-46d4-bfab-c10d2e9d7da9"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "163f5d73-44d9-488a-8fb7-48a32aadf50d"], 
    ButtonBox["PlotLegends",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/PlotLegends"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell["\<\
PlotLegends is an option for plot functions that specifies what legends to \
use. \
\>", "TableText",ExpressionUUID->"1d09e5d4-4562-4e01-b8f0-3b42d439be70"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "75b6a732-d455-48ab-9031-9e37016e516a"], 
    ButtonBox["PlotRange",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/PlotRange"], 
    ButtonBox["Full",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Full"], Cell["\<\
PlotRange is an option for graphics functions that specifies what range of \
coordinates to include in a plot. \
\>", "TableText",ExpressionUUID->"6eb2015f-1b3e-4ae1-bb7e-57dd08a12b05"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "bb2cb2f3-3249-45db-aea2-e048c4260220"], 
    ButtonBox["ErrorBarFunction",
     BaseStyle->"Link",
     ButtonData->"paclet:ErrorBarPlots/ref/ErrorBarFunction"], 
    RowBox[{
     ButtonBox["Automatic",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/Automatic"], " ", 
     RowBox[{"(", "modified", ")"}]}], Cell["\<\
ErrorBarFunction is an option for ErrorListPlot that specifies a function to \
apply to determine the shape of error bars. \
\>", "TableText",ExpressionUUID->"42a8f82e-868e-4aba-a02d-9c12616543c4"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, None, None, None, None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True, True, True, True, True, True, True, True, 
      True}}}},ExpressionUUID->"d69fa47a-956b-4a53-8500-bb9b9b2475cc"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"c4f3c5b2-0b59-4244-8a7e-d4f424b309c3"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"107909c8-05c1-4c3c-9e18-5a1e358c10d1"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "aed9022d-5df6-4631-a4bb-c5aa9525fcd7"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->22667170,ExpressionUUID->"3bf04abc-230f-4f7b-bbb8-8d36acc24238"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "13cbec64-a107-45e7-8c3e-356b4c26c072"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->604478407,ExpressionUUID->"333eb22f-869e-4bc3-ac85-e8c64397e288"],

Cell["Define some data:", "ExampleText",
 CellID->2258467,ExpressionUUID->"99047646-f28b-4811-acd0-b70e96927b9f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataset", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<row1\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<a\>\"", "\[Rule]", "1"}], ",", 
        RowBox[{"\"\<b\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"2", ",", "0.1"}], "]"}]}], ",", 
        RowBox[{"\"\<c\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"3", ",", "0.2"}], "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<row2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<a\>\"", "\[Rule]", "4"}], ",", 
        RowBox[{"\"\<b\>\"", "\[Rule]", "4"}], ",", 
        RowBox[{"\"\<c\>\"", "\[Rule]", "8"}]}], "|>"}]}]}], "|>"}], 
   "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->92978254,ExpressionUUID->"a52d3390-1a7d-4371-b2f4-a48a1a496361"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row1" -> Association[
               "a" -> 1, "b" -> 
                DataAnalysis`NDV[2, 0.1, $CellContext`dv$516509], "c" -> 
                DataAnalysis`NDV[3, 0.2, $CellContext`dv$516510]], "row2" -> 
              Association["a" -> 4, "b" -> 4, "c" -> 8]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 2], 
             Association["ID" -> 236240512133757]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row1" -> Association[
               "a" -> 1, "b" -> 
                DataAnalysis`NDV[2, 0.1, $CellContext`dv$516509], "c" -> 
                DataAnalysis`NDV[3, 0.2, $CellContext`dv$516510]], "row2" -> 
              Association["a" -> 4, "b" -> 4, "c" -> 8]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 2], 
             Association["ID" -> 236240512133757]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row1" -> Association[
                "a" -> 1, "b" -> 
                 DataAnalysis`NDV[2, 0.1, $CellContext`dv$516509], "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$516510]], "row2" -> 
               Association["a" -> 4, "b" -> 4, "c" -> 8]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"a", "b", "c"}, {
                 TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                 TypeSystem`AnyType}], 2], 
              Association["ID" -> 236240512133757]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row1" -> Association[
                "a" -> 1, "b" -> 
                 DataAnalysis`NDV[2, 0.1, $CellContext`dv$516509], "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$516510]], "row2" -> 
               Association["a" -> 4, "b" -> 4, "c" -> 8]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"a", "b", "c"}, {
                 TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                 TypeSystem`AnyType}], 2], 
              Association["ID" -> 236240512133757]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 2, "Length" -> 2, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 2], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[25]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[38.400000000000006`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`AtomShape[34], "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 2, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[729989715], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 2], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[729989715]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 227926446][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 227926446][{
                    All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 227926446][{
                    All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 227926446][{
                    All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row1", 
                    Style[
                    "row1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 227926446][{
                    Key["row1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[
                    Key["row1"]]], "Mouse"], 
                    ImageSize -> {{38.400000000000006`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[
                    Key["row1"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"2.00\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[2, 0.1, $CellContext`dv$516509]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[
                    Key["row1"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.00\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[3, 0.2, $CellContext`dv$516510]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[
                    Key["row1"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row2", 
                    Style[
                    "row2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 227926446][{
                    Key["row2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], 
                    ImageSize -> {{38.400000000000006`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["4"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["4"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    227926446][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 227926446][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 227926446]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[227926446][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[227926446][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {239., {43., 49.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 124},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->102743896,ExpressionUUID->"6f0c166d-9208-4bff-b5fa-a6620b508599"]
}, Open  ]],

Cell["Plot the data with error bars:", "ExampleText",
 CellID->124652355,ExpressionUUID->"c82332c6-8297-4ed9-b861-17da99f3ec91"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DTPlot", "[", 
  RowBox[{"dataset", "[", 
   RowBox[{"All", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<b\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->339193927,ExpressionUUID->"42199249-6fe4-4a6e-9488-81f41b7970db"],

Cell[BoxData[
 GraphicsBox[{{}, {{{}, 
     {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
      0.012833333333333334`], AbsoluteThickness[1.6], 
      PointBox[{{2., 3.}, {4., 8.}}], {{
        {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
         LineBox[{{2.1959963984540054`, 3.}, {1.8040036015459946`, 3.}}]}, 
        {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
         LineBox[{
          Offset[{0, 1.5}, {2.1959963984540054`, 3.}], 
           Offset[{0, -1.5}, {2.1959963984540054`, 3.}]}]}, 
        {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
         LineBox[{
          Offset[{0, 1.5}, {1.8040036015459946`, 3.}], 
           Offset[{0, -1.5}, {1.8040036015459946`, 3.}]}]}, 
        {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
         LineBox[{{2., 3.391992796908011}, {2., 2.608007203091989}}]}, 
        {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
         LineBox[{
          Offset[{1.5, 0}, {2., 3.391992796908011}], 
           Offset[{-1.5, 0}, {2., 3.391992796908011}]}]}, 
        {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
         LineBox[{
          Offset[{1.5, 0}, {2., 2.608007203091989}], 
           Offset[{-1.5, 0}, {2., 2.608007203091989}]}]}}, {}}}, {}}, {
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{2., 3.}}], {
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{2.1959963984540054`, 3.}, {1.8040036015459946`, 3.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {2.1959963984540054`, 3.}], 
            Offset[{0, -1.5}, {2.1959963984540054`, 3.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {1.8040036015459946`, 3.}], 
            Offset[{0, -1.5}, {1.8040036015459946`, 3.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{2., 3.391992796908011}, {2., 2.608007203091989}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {2., 3.391992796908011}], 
            Offset[{-1.5, 0}, {2., 3.391992796908011}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {2., 2.608007203091989}], 
            Offset[{-1.5, 0}, {2., 2.608007203091989}]}]}}},
       "\"row1 {2.00(20), 3.00(39)}\"",
       TooltipStyle->"TextStyling"],
      Annotation[#, "row1 {2.00(20), 3.00(39)}", "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{{4., 8.}}], {}},
       "\"row2 {4, 8}\"",
       TooltipStyle->"TextStyling"],
      Annotation[#, "row2 {4, 8}", "Tooltip"]& ]}}, {}, {}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{1.7625000000000002`, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"c\"", TraditionalForm], None}, {
     FormBox["\"b\"", TraditionalForm], None}},
  FrameStyle->GrayLevel[0],
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  FrameTicksStyle->12,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->400,
  LabelStyle->12,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{2., 4.}, {0, 8.}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.1], 
     Scaled[0.1]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 ImageSize->{404, 268},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->214814411,ExpressionUUID->"74c6731b-6a10-43f5-9255-aac34857e7a1"]
}, Open  ]],

Cell["Plot multiple data tables:", "ExampleText",
 CellID->10700423,ExpressionUUID->"c24fef90-c69b-4336-a609-c2044eeb6d89"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataset2", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<row1\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<b\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"2", ",", 
           RowBox[{"0.0", ".5"}]}], "]"}]}], ",", 
        RowBox[{"\"\<c\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"5", ",", "0.1"}], "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<row2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<b\>\"", "\[Rule]", "4"}], ",", 
        RowBox[{"\"\<c\>\"", "\[Rule]", "0"}]}], "|>"}]}]}], "|>"}], 
   "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->218398017,ExpressionUUID->"03e14dac-7885-4df0-a156-38e9f7e3176d"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row1" -> Association[
               "b" -> DataAnalysis`NDV[2, 0., $CellContext`dv$548388], "c" -> 
                DataAnalysis`NDV[5, 0.1, $CellContext`dv$548389]], "row2" -> 
              Association["b" -> 4, "c" -> 0]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType}], 2], 
             Association["ID" -> 248906370689792]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row1" -> Association[
               "b" -> DataAnalysis`NDV[2, 0., $CellContext`dv$548388], "c" -> 
                DataAnalysis`NDV[5, 0.1, $CellContext`dv$548389]], "row2" -> 
              Association["b" -> 4, "c" -> 0]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType}], 2], 
             Association["ID" -> 248906370689792]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row1" -> Association[
                "b" -> DataAnalysis`NDV[2, 0., $CellContext`dv$548388], "c" -> 
                 DataAnalysis`NDV[5, 0.1, $CellContext`dv$548389]], "row2" -> 
               Association["b" -> 4, "c" -> 0]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType}], 2], 
              Association["ID" -> 248906370689792]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row1" -> Association[
                "b" -> DataAnalysis`NDV[2, 0., $CellContext`dv$548388], "c" -> 
                 DataAnalysis`NDV[5, 0.1, $CellContext`dv$548389]], "row2" -> 
               Association["b" -> 4, "c" -> 0]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType}], 2], 
              Association["ID" -> 248906370689792]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 2, "Length" -> 2, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType}], 2], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[30]} -> 1, {All, "b"} -> 
               1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[38.400000000000006`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "b" -> TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 2, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[1275992348], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType}], 2], "HandleQ" -> 
            True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1275992348]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 826135831][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 826135831][{
                    All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 826135831][{
                    All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row1", 
                    Style[
                    "row1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 826135831][{
                    Key["row1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[
                    Key["row1"]]], "Mouse"], 
                    ImageSize -> {{38.400000000000006`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    "2", ShowStringCharacters -> False, StripOnInput -> 
                    False], 
                    DataAnalysis`NDV[2, 0., $CellContext`dv$548388]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[
                    Key["row1"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.1, $CellContext`dv$548389]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[
                    Key["row1"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row2", 
                    Style[
                    "row2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 826135831][{
                    Key["row2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], 
                    ImageSize -> {{38.400000000000006`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["4"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    826135831][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 826135831][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 826135831]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[826135831][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[826135831][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {192., {43., 49.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 124},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->39540909,ExpressionUUID->"422adc52-7d05-446b-8f8a-15e4f4e36758"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DTPlot", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"dataset", "[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<b\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
    "dataset2"}], "}"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->204647600,ExpressionUUID->"7ef78623-8f05-4651-8853-767b3d132565"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{}, {{{}, {
        Hue[0.67, 0.6, 0.6], 
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         RGBColor[0.368417, 0.506779, 0.709798]], {
         PointBox[{{2., 3.}, {4., 8.}}], {{{
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{{2.1959963984540054`, 3.}, {1.8040036015459946`, 3.}}]}, {
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{
              Offset[{0, 1.5}, {2.1959963984540054`, 3.}], 
              Offset[{0, -1.5}, {2.1959963984540054`, 3.}]}]}, {
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{
              Offset[{0, 1.5}, {1.8040036015459946`, 3.}], 
              Offset[{0, -1.5}, {1.8040036015459946`, 3.}]}]}, {
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{{2., 3.391992796908011}, {2., 2.608007203091989}}]}, {
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{
              Offset[{1.5, 0}, {2., 3.391992796908011}], 
              Offset[{-1.5, 0}, {2., 3.391992796908011}]}]}, {
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{
              Offset[{1.5, 0}, {2., 2.608007203091989}], 
              Offset[{-1.5, 0}, {2., 2.608007203091989}]}]}}, {}}}}, {
        Hue[0.9060679774997897, 0.6, 0.6], 
        Directive[
         PointSize[0.012833333333333334`], 
         AbsoluteThickness[1.6], 
         RGBColor[0.880722, 0.611041, 0.142051]], {
         PointBox[{{2., 5.}, {4., 0.}}], {{{
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{{2., 5.195996398454005}, {2., 4.804003601545995}}]}, {
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{
              Offset[{1.5, 0}, {2., 5.195996398454005}], 
              Offset[{-1.5, 0}, {2., 5.195996398454005}]}]}, {
            GrayLevel[0], 
            Thickness[Tiny], 
            Dashing[{}], 
            LineBox[{
              Offset[{1.5, 0}, {2., 4.804003601545995}], 
              Offset[{-1.5, 0}, {2., 4.804003601545995}]}]}}, {}}}}, {}}, {
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{{2., 3.}}], {{{
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              
              LineBox[{{2.1959963984540054`, 3.}, {1.8040036015459946`, 
               3.}}]}, {
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              LineBox[{
                Offset[{0, 1.5}, {2.1959963984540054`, 3.}], 
                Offset[{0, -1.5}, {2.1959963984540054`, 3.}]}]}, {
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              LineBox[{
                Offset[{0, 1.5}, {1.8040036015459946`, 3.}], 
                Offset[{0, -1.5}, {1.8040036015459946`, 3.}]}]}, {
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              LineBox[{{2., 3.391992796908011}, {2., 2.608007203091989}}]}, {
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              LineBox[{
                Offset[{1.5, 0}, {2., 3.391992796908011}], 
                Offset[{-1.5, 0}, {2., 3.391992796908011}]}]}, {
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              LineBox[{
                Offset[{1.5, 0}, {2., 2.608007203091989}], 
                Offset[{-1.5, 0}, {2., 2.608007203091989}]}]}}}}}, 
         "\"row1 {2.00(20), 3.00(39)}\"", LabelStyle -> "TextStyling"], 
        Annotation[#, "row1 {2.00(20), 3.00(39)}", "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{{4., 8.}}], {{}}}}, "\"row2 {4, 8}\"", LabelStyle -> 
         "TextStyling"], Annotation[#, "row2 {4, 8}", "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{{2., 5.}}], {{{
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              LineBox[{{2., 5.195996398454005}, {2., 4.804003601545995}}]}, {
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              LineBox[{
                Offset[{1.5, 0}, {2., 5.195996398454005}], 
                Offset[{-1.5, 0}, {2., 5.195996398454005}]}]}, {
              GrayLevel[0], 
              Thickness[Tiny], 
              Dashing[{}], 
              LineBox[{
                Offset[{1.5, 0}, {2., 4.804003601545995}], 
                Offset[{-1.5, 0}, {2., 4.804003601545995}]}]}}}}}, 
         "\"row1 {2, 5.00(20)}\"", LabelStyle -> "TextStyling"], 
        Annotation[#, "row1 {2, 5.00(20)}", "Tooltip"]& ], 
       TagBox[
        TooltipBox[{
          Opacity[0.], {
           PointBox[{{4., 0.}}], {{}}}}, "\"row2 {4, 0}\"", LabelStyle -> 
         "TextStyling"], 
        Annotation[#, "row2 {4, 0}", "Tooltip"]& ]}}, {}, {}, {}, {}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.1], 
        Scaled[0.1]}, {
        Scaled[0.02], 
        Scaled[0.1]}}, AxesOrigin -> {1.7625000000000002`, 0}, 
     PlotRange -> {{2., 4.}, {0, 8.}}, PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {False, False}, 
     AxesLabel -> {None, None}, AxesOrigin -> {1.7625000000000002`, 0}, 
     DisplayFunction :> Identity, Frame -> {{True, True}, {True, True}}, 
     FrameLabel -> {{
        FormBox["\"c\"", TraditionalForm], None}, {
        FormBox["\"b\"", TraditionalForm], None}}, FrameStyle -> GrayLevel[0],
      FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 12, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 400, LabelStyle -> 12, 
     Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotRange -> {{2., 4.}, {0, 8.}}, 
     PlotRangeClipping -> True, PlotRangePadding -> {{
        Scaled[0.1], 
        Scaled[0.1]}, {
        Scaled[0.02], 
        Scaled[0.1]}}, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       TagBox[
        FrameBox[
         StyleBox["1", Smaller, StripOnInput -> False]], "Placeholder"], 
       TagBox[
        FrameBox[
         StyleBox["2", Smaller, StripOnInput -> False]], "Placeholder"]}, 
      "PointLegend", DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    PointBox[
                    NCache[{
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}]}, {
                    Scaled[{0.5, 0.5}]}]]}}}, AspectRatio -> Full, 
                    ImageSize -> {10, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.038000000000000006`] -> 
                    Baseline)], #}, {
                   GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.880722, 0.611041, 0.142051]], {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.880722, 0.611041, 0.142051]], 
                    PointBox[
                    NCache[{
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}]}, {
                    Scaled[{0.5, 0.5}]}]]}}}, AspectRatio -> Full, 
                    ImageSize -> {10, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.038000000000000006`] -> 
                    Baseline)], #2}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontSize -> 12, FontFamily -> "Arial"}, Background -> Automatic, 
         StripOnInput -> False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                   ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.368417, 0.506779, 0.709798], Editable -> False,
                     Selectable -> False]}], "]"}], ",", 
               RowBox[{"Directive", "[", 
                 RowBox[{
                   RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                   ",", 
                   RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                   InterpretationBox[
                    ButtonBox[
                    TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.880722, 0.611041, 0.142051], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.587148, 0.40736066666666665`, 0.09470066666666668], 
                    FrameTicks -> None, PlotRangePadding -> None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.880722, 0.611041, 0.142051]"], Appearance -> 
                    None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                    DefaultBaseStyle -> {}, ButtonFunction :> 
                    With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.880722, 0.611041, 0.142051]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                    Automatic, Method -> "Preemptive"], 
                    RGBColor[0.880722, 0.611041, 0.142051], Editable -> False,
                     Selectable -> False]}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
             RowBox[{
               TagBox[#, HoldForm], ",", 
               TagBox[#2, HoldForm]}], "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{
                 RowBox[{"{", 
                   RowBox[{"False", ",", "Automatic"}], "}"}], ",", 
                 RowBox[{"{", 
                   RowBox[{"False", ",", "Automatic"}], "}"}]}], "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"False", ",", "False"}], "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", "12"}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 ImageSize->{449, 270},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->218808545,ExpressionUUID->"dd56e039-afc2-4915-a84a-0e78320f97ad"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Possible Issues",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "fb0aa195-efe1-40c7-a016-c98cdab182af"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373,ExpressionUUID->"fea07adc-8d55-4cfc-9ffb-6d3894bd0f7e"],

Cell[TextData[{
 "As of version 11.2. of Mathematica, there is a bug with the ",
 ButtonBox["PlotMarkers",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/PlotMarkers"],
 " option - setting this option removes error bars:"
}], "ExampleText",
 CellID->516805735,ExpressionUUID->"396a4e99-4b27-428e-b7fb-1634034297fc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DTPlot", "[", 
  RowBox[{
   RowBox[{"dataset", "[", 
    RowBox[{"All", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<b\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotMarkers", "\[Rule]", "\"\<x\>\""}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->256488874,ExpressionUUID->"d8338570-406f-4ab1-9a08-7ed54b499417"],

Cell[BoxData[
 GraphicsBox[{{}, {{
     {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
      AbsoluteThickness[1.6], GeometricTransformationBox[{
        TagBox[InsetBox["x", {0., 0.}],
         "InsetString"], {}}, {{{2., 3.}}, {{4., 8.}}}]}, {}}, {
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{2., 3.}], {
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{2.1959963984540054`, 3.}, {1.8040036015459946`, 3.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {2.1959963984540054`, 3.}], 
            Offset[{0, -1.5}, {2.1959963984540054`, 3.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {1.8040036015459946`, 3.}], 
            Offset[{0, -1.5}, {1.8040036015459946`, 3.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{2., 3.391992796908011}, {2., 2.608007203091989}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {2., 3.391992796908011}], 
            Offset[{-1.5, 0}, {2., 3.391992796908011}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {2., 2.608007203091989}], 
            Offset[{-1.5, 0}, {2., 2.608007203091989}]}]}}},
       "\"row1 {2.00(20), 3.00(39)}\"",
       TooltipStyle->"TextStyling"],
      Annotation[#, "row1 {2.00(20), 3.00(39)}", "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       {Opacity[0.], PointBox[{4., 8.}], {}},
       "\"row2 {4, 8}\"",
       TooltipStyle->"TextStyling"],
      Annotation[#, "row2 {4, 8}", "Tooltip"]& ]}}, {}, {}, {}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{1.7625000000000002`, 0},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"c\"", TraditionalForm], None}, {
     FormBox["\"b\"", TraditionalForm], None}},
  FrameStyle->GrayLevel[0],
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  FrameTicksStyle->12,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->400,
  LabelStyle->12,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{2., 4.}, {0, 8.}},
  PlotRangeClipping->True,
  PlotRangePadding->{{
     Scaled[0.1], 
     Scaled[0.1]}, {
     Scaled[0.02], 
     Scaled[0.1]}},
  Ticks->{Automatic, Automatic}]], "Output",
 ImageSize->{404, 268},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->371805380,ExpressionUUID->"781cad8f-dae2-4d22-87e4-3698aa5a5767"]
}, Open  ]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"e9b0ee33-6ffe-4b60-a9e7-a0e6510ab359"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"b7e385bd-eb8c-4aec-bfba-2eff7fe005f0"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"c0ac9c8f-4d75-4b83-a2ad-0ce4a1708834"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"c4cb3121-6ccc-4799-82d2-54e821d1dca5"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"164b442f-0f26-4bfc-bfa7-d9f6c359a687"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"035e1bc7-3b06-4e25-ae9c-0cfe2f5a3616"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ErrorListPlot"]],"paclet:DataAnalysis/ref/ErrorListPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"349385bc-8fe2-4e8a-9298-2a3795c5e3ff"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"10414caf-0d43-4fb0-982c-0cd45e3fecaf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"25b7fb90-b3b3-4409-a130-3519e206d311"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"c60631f8-4287-4091-9331-9d4d349bd519"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"96c4cbd0-736a-497f-a185-d837ccc1793c"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->158173444,ExpressionUUID->"1e58aaa6-4423-4860-acc5-dad5a468045b"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"61346c28-581c-4194-90ef-4052a97ae509"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DTPlot",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 14.4831576}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "DTPlot[datatable] returns a plots of the DataTable object. \
DTPlot[datatable1, datatable2] returns a plots of the DataTable objects.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "DTPlot", "titlemodifier" -> 
    "", "windowtitle" -> "DTPlot", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/DTPlot"}, "SearchTextTranslated" -> "", "NewStyles" -> 
  False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[14538, 372, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3bf04abc-230f-4f7b-bbb8-8d36acc24238",
   CellTags->"PrimaryExamplesSection",
   CellID->22667170]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 98904, 2222}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[578, 21, 4358, 97, 55, "AnchorBarGrid",ExpressionUUID->"e58492f4-b9d4-4b27-ab47-3ffe874453fa",
 CellID->1],
Cell[CellGroupData[{
Cell[4961, 122, 391, 9, 52, "ObjectNameGrid",ExpressionUUID->"261e0e83-6170-434a-b178-6930529e4be3"],
Cell[5355, 133, 1600, 41, 184, "Usage",ExpressionUUID->"95f26a2f-acb0-4e3e-a9ce-c96cecdfeef2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6992, 179, 854, 21, 37, "NotesSection",ExpressionUUID->"3d6b522c-91bd-473b-8b83-167b267b938d",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->54457891],
Cell[7849, 202, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"00c27441-fa55-43c4-8e8a-8e745053ebe8"],
Cell[7938, 204, 613, 16, 70, "Notes",ExpressionUUID->"96b5c643-798b-4cfd-9973-e2c70619935d",
 CellID->515141998],
Cell[8554, 222, 826, 24, 70, "Notes",ExpressionUUID->"10b2f580-4c7a-42d6-84cf-33a50477a508",
 CellID->517570381],
Cell[9383, 248, 487, 12, 70, "Notes",ExpressionUUID->"3958f189-1246-4443-9871-d8562a38a3ad"],
Cell[9873, 262, 4539, 103, 70, "3ColumnTableMod",ExpressionUUID->"d69fa47a-956b-4a53-8500-bb9b9b2475cc"],
Cell[14415, 367, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"c4f3c5b2-0b59-4244-8a7e-d4f424b309c3"]
}, Closed]],
Cell[CellGroupData[{
Cell[14538, 372, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3bf04abc-230f-4f7b-bbb8-8d36acc24238",
 CellTags->"PrimaryExamplesSection",
 CellID->22667170],
Cell[CellGroupData[{
Cell[14997, 387, 308, 7, 29, "ExampleSection",ExpressionUUID->"333eb22f-869e-4bc3-ac85-e8c64397e288",
 CellID->604478407],
Cell[15308, 396, 113, 1, 38, "ExampleText",ExpressionUUID->"99047646-f28b-4811-acd0-b70e96927b9f",
 CellID->2258467],
Cell[CellGroupData[{
Cell[15446, 401, 861, 23, 43, "Input",ExpressionUUID->"a52d3390-1a7d-4371-b2f4-a48a1a496361",
 CellID->92978254],
Cell[16310, 426, 27010, 531, 145, "Output",ExpressionUUID->"6f0c166d-9208-4bff-b5fa-a6620b508599",
 CellID->102743896]
}, Open  ]],
Cell[43335, 960, 128, 1, 38, "ExampleText",ExpressionUUID->"c82332c6-8297-4ed9-b861-17da99f3ec91",
 CellID->124652355],
Cell[CellGroupData[{
Cell[43488, 965, 284, 7, 26, "Input",ExpressionUUID->"42199249-6fe4-4a6e-9488-81f41b7970db",
 CellID->339193927],
Cell[43775, 974, 3946, 96, 289, "Output",ExpressionUUID->"74c6731b-6a10-43f5-9255-aac34857e7a1",
 CellID->214814411]
}, Open  ]],
Cell[47736, 1073, 123, 1, 70, "ExampleText",ExpressionUUID->"c24fef90-c69b-4336-a609-c2044eeb6d89",
 CellID->10700423],
Cell[CellGroupData[{
Cell[47884, 1078, 785, 22, 70, "Input",ExpressionUUID->"03e14dac-7885-4df0-a156-38e9f7e3176d",
 CellID->218398017],
Cell[48672, 1102, 23977, 472, 70, "Output",ExpressionUUID->"422adc52-7d05-446b-8f8a-15e4f4e36758",
 CellID->39540909]
}, Open  ]],
Cell[CellGroupData[{
Cell[72686, 1579, 351, 10, 70, "Input",ExpressionUUID->"7ef78623-8f05-4651-8853-767b3d132565",
 CellID->204647600],
Cell[73040, 1591, 17203, 387, 70, "Output",ExpressionUUID->"dd56e039-afc2-4915-a84a-0e78320f97ad",
 CellID->218808545]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[90292, 1984, 310, 7, 70, "ExampleSection",ExpressionUUID->"fea07adc-8d55-4cfc-9ffb-6d3894bd0f7e",
 CellID->1305812373],
Cell[90605, 1993, 315, 7, 70, "ExampleText",ExpressionUUID->"396a4e99-4b27-428e-b7fb-1634034297fc",
 CellID->516805735],
Cell[CellGroupData[{
Cell[90945, 2004, 359, 9, 70, "Input",ExpressionUUID->"d8338570-406f-4ab1-9a08-7ed54b499417",
 CellID->256488874],
Cell[91307, 2015, 2997, 77, 70, "Output",ExpressionUUID->"781cad8f-dae2-4d22-87e4-3698aa5a5767",
 CellID->371805380]
}, Open  ]]
}, Closed]],
Cell[94331, 2096, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"e9b0ee33-6ffe-4b60-a9e7-a0e6510ab359"]
}, Open  ]],
Cell[CellGroupData[{
Cell[94454, 2101, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"c0ac9c8f-4d75-4b83-a2ad-0ce4a1708834",
 CellID->1255426704],
Cell[94717, 2110, 1451, 38, 70, "SeeAlso",ExpressionUUID->"10414caf-0d43-4fb0-982c-0cd45e3fecaf",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[96205, 2153, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"c60631f8-4287-4091-9331-9d4d349bd519",
 CellID->38303248],
Cell[96474, 2162, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"96c4cbd0-736a-497f-a185-d837ccc1793c"],
Cell[96563, 2164, 247, 6, 70, "MoreAbout",ExpressionUUID->"1e58aaa6-4423-4860-acc5-dad5a468045b",
 CellID->158173444]
}, Open  ]],
Cell[96825, 2173, 78, 0, 70, "FooterCell",ExpressionUUID->"61346c28-581c-4194-90ef-4052a97ae509"]
}
]
*)

(* End of internal cache information *)

