(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     34726,        966]
NotebookOptionsPosition[     26862,        795]
NotebookOutlinePosition[     29307,        856]
CellTagsIndexPosition[     29222,        851]
WindowTitle->DV
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "a2d5cb8f-453c-412e-95ca-4f4a5fd8511f"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"cae32e89-d026-4954-bb6b-d389e76423d4"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"NDV\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/NDV"], "\<\"DVEvaluate\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVEvaluate"], "\<\"MCEvaluate\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MCEvaluate"], "\<\"MonteCarloSimulation\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MonteCarloSimulation"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0cb60f19-ed33-4e9d-9fa8-4befe59c3609"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"dc7deaea-0f32-4463-80fc-592b05b05a7b"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "c5412a9b-bbcf-4fe9-b117-834349bbb503"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"4d8d63a3-9d4a-4103-a903-a58e339707ae"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/DV\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/DV"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/DV.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$19133], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/DV", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "d15d54d6-ee85-4a18-9d8e-fe10f7ff1d7e"]
    }], "AnchorBar",ExpressionUUID->"68b7c966-4ab7-40ec-bfba-250a4770d3bf"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"7248c9eb-e8c8-4784-b6ce-36b5709c9392"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["DV", "ObjectName",ExpressionUUID->
  "790d9c28-415d-47c0-9787-ba5bd2c20d4f"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"38448400-9bc1-4dc5-9185-9f6b7232d54c"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "1d711822-18d7-46a4-99c0-7c07938170b2"]
}], "ObjectNameGrid",ExpressionUUID->"4d2373ed-d75e-4b91-a119-9821ed4ca173"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DV", "[", 
       RowBox[{
        StyleBox["v", "TI"], ",", " ", 
        StyleBox["se", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "bfbe8a8c-5f0e-48a7-ba34-0eb18a449a9d"],
     "\[LineSeparator]represents a value v associated with a standard error \
se. "
    }],ExpressionUUID->"98324afa-8696-42ee-a226-6195c313c17e"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DV", "[", 
       RowBox[{
        StyleBox["v", "TI"], ",", 
        StyleBox["se", "TI"], ",", 
        StyleBox["i", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "ae7efa40-74ee-4f89-8fe5-5d5add0fa0bf"],
     "\[LineSeparator]represents a value associated with an uncertainty in \
the form of mean v corresponding and standard error se as well as symmetric \
relative confidence interval i. "
    }],ExpressionUUID->"48274fe2-9329-469b-8f7f-b39499f5ac57"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DV", "[", 
       RowBox[{
        StyleBox["v", "TI"], ",", 
        StyleBox["se", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["il", "TI"], ",", 
          StyleBox["iu", "TI"]}], "}"}]}], "]"}]], "InlineFormula",
      ExpressionUUID->"708dbc1b-77b6-42b5-bde7-7f131076c9c8"],
     "\[LineSeparator]specifies a confidence interval from ",
     Cell[BoxData[
      StyleBox["v", "TI"]], "InlineFormula",ExpressionUUID->
      "1cb14f67-1bbb-4022-ae87-959adef32fa7"],
     "-",
     Cell[BoxData[
      StyleBox["il", "TI"]], "InlineFormula",ExpressionUUID->
      "d314a040-a9b4-42f7-8b0b-636944955de4"],
     " to ",
     Cell[BoxData[
      StyleBox["v", "TI"]], "InlineFormula",ExpressionUUID->
      "fa50ecdb-3f76-48af-9691-d8010d3d7607"],
     "+",
     Cell[BoxData[
      StyleBox["iu", "TI"]], "InlineFormula",ExpressionUUID->
      "df73a90b-83de-4beb-8b9a-6e8576de43e7"],
     "."
    }],ExpressionUUID->"7c0010e9-9d49-4016-8e2f-711da39dd11b"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"2129e4e1-41aa-4a7d-b4c6-430a94f62775"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"90c88e1a-fac9-4a66-b89a-8d7e6f3e1a75"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"1bf2789a-99b9-4ffe-adba-7bd59c85d3ed"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"972a0d70-d1e4-4098-aab3-ccd15f627c6e"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->50803584,ExpressionUUID->"65bbfb78-92be-4ee3-9703-18e41b29158d"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"7cf04728-5ffc-492c-bb5c-2c3e4d40a029"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "1e688a18-9bfa-44b3-807d-fc412164ac33"],
 " values are mainly used as the output from uncertainty propagations using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "cd4c8642-de2b-4bde-99ea-1ca72afe045c"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "6a57165b-0ab7-45f2-9ee2-1035da233655"],
 " and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "6e4dfa07-38d5-4997-831c-0d9f396f3868"],
 " where the resulting values do not follow a ",
 ButtonBox["NormalDistribution",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NormalDistribution"],
 "."
}], "Notes",
 CellID->342049332,ExpressionUUID->"0b16ada3-3b06-419a-90c4-c32df8cef086"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "7610430e-5fcd-49af-8188-c6cf94453d87"],
 " values can also be used as input to propagate uncertainties using the \
function ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "1bc51307-8148-494c-88d2-d776e851cdfa"],
 ", but the results have to be analyzed with care as it is assumed that ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "65bdab2f-1ccf-432c-87e8-d0060f183760"],
 " is a normally distributed ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "7bec0e82-caeb-4c3b-8f4a-9dc287dadf7d"],
 "."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"fd48b64d-8f03-4882-aac6-a89fc9c401cf"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "18cd2e04-991c-462a-94f0-35e045d87abe"],
 " values are more general than ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "13237f76-8cf5-4d9b-9d82-91e504817e5f"],
 " values, which assume that values follow a ",
 ButtonBox["NormalDistribution",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NormalDistribution"],
 "."
}], "Notes",
 CellID->143301145,ExpressionUUID->"0eb27d2f-52cd-4b2f-b14d-6595c2fea937"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"9aa214c5-c25d-4fa3-a070-cd111b399f89"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"60d0ab9a-b63b-4e60-93d3-b24b87d7d064"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "71c2f78c-e92b-4345-bab9-2bd2e1e3934d"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1302474,ExpressionUUID->"cc78497a-5c12-449f-a90a-6314208b6d70"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "460d93e7-24db-48d9-8904-64e20e519822"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->688647762,ExpressionUUID->"b4f116c3-527f-418d-9332-6c3fd7246621"],

Cell["\<\
Define a normal distribution value with mean 1 and standard error 0.1:\
\>", "ExampleText",
 CellID->320056803,ExpressionUUID->"59b76cee-1c52-4604-9f66-aa70f1fedbab"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "=", 
  RowBox[{"DV", "[", 
   RowBox[{"1", ",", "0.1"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->477503922,ExpressionUUID->"c753d769-8af0-4097-a6c8-6b3e85def45f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(SE=\"",
     TagBox[
      InterpretationBox["\"0.10\"", 0.1, AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[1, 0.1, Null, $CellContext`dv$915395]]], "Output",
 ImageSize->{95, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->547190616,ExpressionUUID->"a31e847b-fe69-447e-af3c-590d32e56d21"]
}, Open  ]],

Cell[TextData[{
 "MCEvaluate returns a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "4400638a-61ca-4049-a891-dd69e8162a1f"],
 ":"
}], "ExampleText",
 CellID->166199296,ExpressionUUID->"2c26a958-7781-43c3-9478-b7b25108617e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MCEvaluate", "[", 
  RowBox[{
   RowBox[{"NDV", "[", 
    RowBox[{"1", ",", "0.1"}], "]"}], "^", "3"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->101430384,ExpressionUUID->"f79c09e3-c52e-4bf0-9a3a-c23901a07081"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(-\"",
     "48","\"+\"","70","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[
  1, 0.3009548201914287, {0.4766263446814808, 
   0.6979668616180938}, $CellContext`dv$935621]]], "Output",
 ImageSize->{88, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->158790741,ExpressionUUID->"12bb7a4d-98ec-4835-9969-23c4c9950f5a"]
}, Open  ]],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "e23b4f07-8a44-4863-96cf-407919a5ae00"],
 " to get a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "ab56c5a1-acb2-41cf-b9b7-fae81e908c1b"],
 ":"
}], "ExampleText",
 CellID->1061558385,ExpressionUUID->"75ac2fee-755a-4595-ab45-6a398028b2ff"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mc", "=", 
  RowBox[{"MonteCarloSimulation", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NDV", "[", 
      RowBox[{"1", ",", "0.1"}], "]"}], "^", "3"}], ",", "10000", ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->25211114,ExpressionUUID->"c450d903-67d5-492a-b0d7-c48cfd0e4eac"],

Cell[BoxData[
 RowBox[{"MonteCarloResult", "[", 
  PanelBox[
   TemplateBox[{"\"n = \"","10000"},
    "RowDefault"],
   FrameMargins->5], "]"}]], "Output",
 ImageSize->{199, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->52182866,ExpressionUUID->"9c8a6f6d-6238-49c4-982e-e408a1ef29e5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mc", "[", "\"\<SingleMeanDV\>\"", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->151401940,ExpressionUUID->"cbbc970a-2d57-4c8c-8ffb-8a490fe7d9fc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(-\"",
     "48","\"+\"","72","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[
  1, 0.3078298008021233, {0.48346272899127685`, 
   0.71500705155805}, $CellContext`dv$955690]]], "Output",
 ImageSize->{88, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->629651377,ExpressionUUID->"ef6dd51b-ac8f-44f9-b048-a8897284c360"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mc", "[", "\"\<DistributionMeanDV\>\"", "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->197112638,ExpressionUUID->"86048599-77d0-4b75-bae1-955e07dda09d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.03\"", 1.030365334509328, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(-\"",
     "51","\"+\"","68","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[
  1.030365334509328, 0.3078298008021233, {0.5138280635006048, 
   0.684641717048722}, $CellContext`dv$955695]]], "Output",
 ImageSize->{88, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->187658551,ExpressionUUID->"bb610c24-7b87-4a68-a346-75da18a248c1"]
}, Open  ]],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f045316d-1e3c-4558-bbca-d337da588a11"],
 " to propagate uncertainties (handle with care - by default assuming that \
the result is a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "dd2a33f1-c8d9-405f-91b7-35a6bce3377a"],
 "):"
}], "ExampleText",
 CellID->65440302,ExpressionUUID->"ab44c67b-7633-4812-8356-db3da6847ccf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"3", "*", "v"}], "+", 
   RowBox[{"DV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->51731737,ExpressionUUID->"e0ddf4c4-fbf8-4c0e-81b9-e7f275bfd88d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"8.00\"", 8., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "98","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[8., 0.5, $CellContext`dv$915492]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->233748240,ExpressionUUID->"09c81ba8-803a-4dbd-a65a-3b9acf24b5df"]
}, Open  ]],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["AssumeND"]],"paclet:DataAnalysis/ref/AssumeND"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "c6880af9-a381-4755-b716-f3bb75033637"],
 " to get a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "9cd13cef-ce66-4e7c-ab16-5edcd523866f"],
 " as a result instead:"
}], "ExampleText",
 CellID->46436054,ExpressionUUID->"bb07544b-d06c-4373-9bee-f669d35556a9"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"3", "*", "v"}], "+", 
    RowBox[{"DV", "[", 
     RowBox[{"5", ",", "0.4"}], "]"}]}], ",", 
   RowBox[{"AssumeND", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->769054116,ExpressionUUID->"cc533e6f-56ad-4458-9aa1-9e04acdaf2cc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"8.00\"", 8., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(SE=\"",
     TagBox[
      InterpretationBox["\"0.50\"", 0.5, AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[8., 0.5, Null, $CellContext`dv$915523]]], "Output",
 ImageSize->{95, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->65346978,ExpressionUUID->"7b0870d2-c52e-4f7e-9122-443613f215c1"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Possible Issues",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "b8b8ce0f-5f5b-4893-b724-f3ab5eec61a6"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373,ExpressionUUID->"3e03284a-19ca-442f-bdb2-159d7c687596"],

Cell[TextData[{
 "Care has to be taken when using a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "822ce3f8-7efc-41e6-bc14-53522c76d6de"],
 " as input for ",
 ButtonBox["DVEValuate",
  BaseStyle->"Link",
  ButtonData->"paclet:DataAnalysis/ref/DVEValuate"],
 ", as it is assumed that the value follows a normal distribution and gives a \
",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "298bf6a7-2f44-41f4-9b13-4858bf871c4a"],
 " as output:"
}], "ExampleText",
 CellID->202476684,ExpressionUUID->"0fa0ca38-738b-4094-ba30-3bf91ab5d5cb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v2", "=", 
  RowBox[{"DV", "[", 
   RowBox[{"1", ",", "0.1", ",", 
    RowBox[{"{", 
     RowBox[{"0.4", ",", "0.1"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->928740015,ExpressionUUID->"b50afb83-2dec-4081-9a21-09e68408e3e2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(-\"",
     "40","\"+\"","10","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[1, 0.1, {0.4, 0.1}, $CellContext`dv$1036079]]], "Output",
 ImageSize->{88, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->836999213,ExpressionUUID->"8b1d3434-21f8-4634-9a85-87ea19fa959c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{"3", "*", "v2"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->95709551,ExpressionUUID->"7e150ae0-5823-481f-9e42-fe924cca0430"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"3.00\"", 3., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "59","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[
  3., 0.30000000000000004`, $CellContext`dv$1036400]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->98555047,ExpressionUUID->"f8f52d01-69b8-4e36-b4d6-350944e29317"]
}, Open  ]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"4f156460-84a1-4828-8cbe-a8ad3c993b56"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"894bf1b1-35f1-4664-bad0-4449e926776e"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"6693f798-34ec-472f-a16a-30412b126d14"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"cb19e52c-53c0-41f2-914f-aa54211672b1"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"9e694e61-d66f-489f-99e4-f978f47f6443"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"f36dc39a-1f5c-4903-ace1-5e3cf6e191c8"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"3c61470c-46a6-4c65-8b93-330bb193fae3"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"85bfff56-d962-430d-813b-9502662875c5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"f0737d80-9176-474c-a833-82f6edb8777b"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"04342d70-43ff-4974-8315-8da0bced7167"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"a4445dfe-89c6-49d6-972c-fc67a2e73b96"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->85496402,ExpressionUUID->"f8308a24-d0bb-42d7-ae81-e062514c8feb"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"39e90bce-12b4-4426-8860-195743031e06"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DV",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 22.6933668}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "DV[v, se] represents a value v associated with a standard error se. \
DV[v, se, i] represents a value associated with an uncertainty in the form of \
mean v corresponding and standard error se as well as symmetric relative \
confidence interval i. DV[v, se, {il, iu}] specifies a confidence interval \
from v-il to v+iu.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "DV", 
    "titlemodifier" -> "", "windowtitle" -> "DV", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/DV"}, "SearchTextTranslated" -> "", "NewStyles" -> 
  False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[11883, 320, 433, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"cc78497a-5c12-449f-a90a-6314208b6d70",
   CellTags->"PrimaryExamplesSection",
   CellID->1302474]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 29025, 844}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[574, 21, 4391, 99, 55, "AnchorBarGrid",ExpressionUUID->"7248c9eb-e8c8-4784-b6ce-36b5709c9392",
 CellID->1],
Cell[CellGroupData[{
Cell[4990, 124, 387, 9, 52, "ObjectNameGrid",ExpressionUUID->"4d2373ed-d75e-4b91-a119-9821ed4ca173"],
Cell[5380, 135, 2214, 58, 276, "Usage",ExpressionUUID->"2129e4e1-41aa-4a7d-b4c6-430a94f62775"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7631, 198, 854, 21, 37, "NotesSection",ExpressionUUID->"65bbfb78-92be-4ee3-9703-18e41b29158d",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->50803584],
Cell[8488, 221, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"7cf04728-5ffc-492c-bb5c-2c3e4d40a029"],
Cell[8577, 223, 1280, 35, 70, "Notes",ExpressionUUID->"0b16ada3-3b06-419a-90c4-c32df8cef086",
 CellID->342049332],
Cell[9860, 260, 1173, 31, 70, "Notes",ExpressionUUID->"fd48b64d-8f03-4882-aac6-a89fc9c401cf",
 CellID->1067943069],
Cell[11036, 293, 721, 20, 70, "Notes",ExpressionUUID->"0eb27d2f-52cd-4b2f-b14d-6595c2fea937",
 CellID->143301145],
Cell[11760, 315, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"9aa214c5-c25d-4fa3-a070-cd111b399f89"]
}, Closed]],
Cell[CellGroupData[{
Cell[11883, 320, 433, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"cc78497a-5c12-449f-a90a-6314208b6d70",
 CellTags->"PrimaryExamplesSection",
 CellID->1302474],
Cell[CellGroupData[{
Cell[12341, 335, 308, 7, 29, "ExampleSection",ExpressionUUID->"b4f116c3-527f-418d-9332-6c3fd7246621",
 CellID->688647762],
Cell[12652, 344, 176, 3, 38, "ExampleText",ExpressionUUID->"59b76cee-1c52-4604-9f66-aa70f1fedbab",
 CellID->320056803],
Cell[CellGroupData[{
Cell[12853, 351, 202, 5, 26, "Input",ExpressionUUID->"c753d769-8af0-4097-a6c8-6b3e85def45f",
 CellID->477503922],
Cell[13058, 358, 721, 17, 35, "Output",ExpressionUUID->"a31e847b-fe69-447e-af3c-590d32e56d21",
 CellID->547190616]
}, Open  ]],
Cell[13794, 378, 353, 10, 39, "ExampleText",ExpressionUUID->"2c26a958-7781-43c3-9478-b7b25108617e",
 CellID->166199296],
Cell[CellGroupData[{
Cell[14172, 392, 242, 6, 26, "Input",ExpressionUUID->"f79c09e3-c52e-4bf0-9a3a-c23901a07081",
 CellID->101430384],
Cell[14417, 400, 643, 17, 35, "Output",ExpressionUUID->"12bb7a4d-98ec-4835-9969-23c4c9950f5a",
 CellID->158790741]
}, Open  ]],
Cell[15075, 420, 606, 18, 39, "ExampleText",ExpressionUUID->"75ac2fee-755a-4595-ab45-6a398028b2ff",
 CellID->1061558385],
Cell[CellGroupData[{
Cell[15706, 442, 339, 9, 26, "Input",ExpressionUUID->"c450d903-67d5-492a-b0d7-c48cfd0e4eac",
 CellID->25211114],
Cell[16048, 453, 340, 10, 56, "Output",ExpressionUUID->"9c8a6f6d-6238-49c4-982e-e408a1ef29e5",
 CellID->52182866]
}, Open  ]],
Cell[CellGroupData[{
Cell[16425, 468, 172, 3, 70, "Input",ExpressionUUID->"cbbc970a-2d57-4c8c-8ffb-8a490fe7d9fc",
 CellID->151401940],
Cell[16600, 473, 643, 17, 35, "Output",ExpressionUUID->"ef6dd51b-ac8f-44f9-b048-a8897284c360",
 CellID->629651377]
}, Open  ]],
Cell[CellGroupData[{
Cell[17280, 495, 178, 3, 70, "Input",ExpressionUUID->"86048599-77d0-4b75-bae1-955e07dda09d",
 CellID->197112638],
Cell[17461, 500, 680, 18, 35, "Output",ExpressionUUID->"bb610c24-7b87-4a68-a346-75da18a248c1",
 CellID->187658551]
}, Open  ]],
Cell[18156, 521, 663, 18, 70, "ExampleText",ExpressionUUID->"ab44c67b-7633-4812-8356-db3da6847ccf",
 CellID->65440302],
Cell[CellGroupData[{
Cell[18844, 543, 264, 7, 70, "Input",ExpressionUUID->"e0ddf4c4-fbf8-4c0e-81b9-e7f275bfd88d",
 CellID->51731737],
Cell[19111, 552, 567, 15, 35, "Output",ExpressionUUID->"09c81ba8-803a-4dbd-a65a-3b9acf24b5df",
 CellID->233748240]
}, Open  ]],
Cell[19693, 570, 595, 17, 70, "ExampleText",ExpressionUUID->"bb07544b-d06c-4373-9bee-f669d35556a9",
 CellID->46436054],
Cell[CellGroupData[{
Cell[20313, 591, 333, 9, 70, "Input",ExpressionUUID->"cc533e6f-56ad-4458-9aa1-9e04acdaf2cc",
 CellID->769054116],
Cell[20649, 602, 721, 17, 35, "Output",ExpressionUUID->"7b0870d2-c52e-4f7e-9122-443613f215c1",
 CellID->65346978]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21419, 625, 310, 7, 70, "ExampleSection",ExpressionUUID->"3e03284a-19ca-442f-bdb2-159d7c687596",
 CellID->1305812373],
Cell[21732, 634, 792, 22, 70, "ExampleText",ExpressionUUID->"0fa0ca38-738b-4094-ba30-3bf91ab5d5cb",
 CellID->202476684],
Cell[CellGroupData[{
Cell[22549, 660, 268, 7, 70, "Input",ExpressionUUID->"b50afb83-2dec-4081-9a21-09e68408e3e2",
 CellID->928740015],
Cell[22820, 669, 592, 15, 35, "Output",ExpressionUUID->"8b1d3434-21f8-4634-9a85-87ea19fa959c",
 CellID->836999213]
}, Open  ]],
Cell[CellGroupData[{
Cell[23449, 689, 184, 4, 70, "Input",ExpressionUUID->"7e150ae0-5823-481f-9e42-fe924cca0430",
 CellID->95709551],
Cell[23636, 695, 587, 16, 35, "Output",ExpressionUUID->"f8f52d01-69b8-4e36-b4d6-350944e29317",
 CellID->98555047]
}, Open  ]]
}, Closed]],
Cell[24250, 715, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"4f156460-84a1-4828-8cbe-a8ad3c993b56"]
}, Open  ]],
Cell[CellGroupData[{
Cell[24373, 720, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"6693f798-34ec-472f-a16a-30412b126d14",
 CellID->1255426704],
Cell[24636, 729, 1488, 39, 70, "SeeAlso",ExpressionUUID->"85bfff56-d962-430d-813b-9502662875c5",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[26161, 773, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"04342d70-43ff-4974-8315-8da0bced7167",
 CellID->38303248],
Cell[26430, 782, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"a4445dfe-89c6-49d6-972c-fc67a2e73b96"],
Cell[26519, 784, 246, 6, 70, "MoreAbout",ExpressionUUID->"f8308a24-d0bb-42d7-ae81-e062514c8feb",
 CellID->85496402]
}, Open  ]],
Cell[26780, 793, 78, 0, 70, "FooterCell",ExpressionUUID->"39e90bce-12b4-4426-8860-195743031e06"]
}
]
*)

(* End of internal cache information *)

