(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15758,        425]
NotebookOptionsPosition[     11395,        325]
NotebookOutlinePosition[     13584,        383]
CellTagsIndexPosition[     13499,        378]
WindowTitle->DVE
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "591c6fc8-2808-4542-be1b-965fe5a5c0c3"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"489375ec-2e55-4721-ae7a-690fc5589439"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DVEvaluate\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVEvaluate"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "a04ab336-b643-48d6-9e2b-aa79f0576f50"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"92b5f58a-3872-4b5e-bc01-12c4511c3d77"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/DVE\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/DVE"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/DVE.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$17426], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/DVE", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "1bbee8e8-91d9-449b-81b6-024b1ca1a473"]
    }], "AnchorBar",ExpressionUUID->"54ce51b0-4b59-47d0-8f67-4099f40c0cd7"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"82adca5f-459e-4239-87e0-414ae05626b4"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["DVE", "ObjectName",ExpressionUUID->
  "c6cea5cb-27be-4ecb-9d71-4684383cf9d8"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"78ac8b9f-98e5-4209-ab95-859db02d5780"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "2613f2ec-ce4a-49f2-a3d3-5bcb670f0ca8"]
}], "ObjectNameGrid",ExpressionUUID->"7e9f1c25-b3b4-42bd-8243-fe1b1734d9a6"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DVE", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "0793ca7e-c08b-48d2-a175-a25be479a223"],
     "\[LineSeparator]represents a short form of ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "abdc9eef-8cdd-4364-91ba-e5863dfe9960"],
     "."
    }],ExpressionUUID->"2b46cb7e-4870-4bd8-9ebe-b029e2f29f4a"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"5e8ef5b6-0379-4a03-8161-5df8f925da90"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"2f9d1d0a-43db-4bcc-bae1-d65f86395d7c"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"d82bba2b-cde9-480a-93dd-9bca5b1cfc41"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"a5201d4d-a068-42bf-82c3-68a402c2a7e5"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->78312193,ExpressionUUID->"1a9796bc-774e-48bc-afa8-0dcbfb6fd276"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"b95cfde7-8011-4ed5-8176-1eae03282971"],

Cell["The following options can be given: ", "Notes",ExpressionUUID->"8c6340ff-a753-4b27-9244-5154a03b1066"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "89e13f7b-9123-4fd5-b531-59fb1356c521"], 
    ButtonBox["CorrelatedErrors",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/CorrelatedErrors"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["CorrelatedErrors"]],
        "paclet:DataAnalysis/ref/CorrelatedErrors"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "ab9e97fc-5703-4e0a-bdaa-97cf5cf6ad8f"],
     " specifies whether to assume that all random errors are perfectly \
correlated (True) or completely uncorrelated (False)."
    }], "TableText",ExpressionUUID->"8d747caf-9c74-4d9b-b674-0e2dad89cdd0"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True}}}},ExpressionUUID->"ba7beaac-83a3-4d59-ab2b-545ad195e69c"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"8179ec25-7d1e-4342-a368-3feda2ab04a9"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "d4bb4e82-c2a3-4f38-b555-1fe98edb5f09"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->191518957,ExpressionUUID->"fb27ab46-8642-4cf5-b3cd-aaa60f50cab7"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "080f7d24-7f41-4a5a-a5d5-f96fe09f4947"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->61809119,ExpressionUUID->"a6ca9b8d-c65c-4bf0-9d58-37e725901492"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVE"]],"paclet:DataAnalysis/ref/DVE"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "d201f16e-eb78-41df-ba36-761e73a91485"],
 " is equivalent to ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "c4f5aa41-e28f-46a0-8c92-fc65c0a65c5a"],
 ":"
}], "ExampleText",
 CellID->25697844,ExpressionUUID->"77d98d7d-7c52-4c0a-adea-d6890828307d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVE", "[", 
  RowBox[{
   RowBox[{"NDV", "[", 
    RowBox[{"1", ",", "0.1"}], "]"}], "*", "2"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->46711560,ExpressionUUID->"8e23ddbd-f603-4969-9a68-43d7a5acd4ed"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"2.00\"", 2., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "39","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[2., 0.2, $CellContext`dv$584677]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->6751416,ExpressionUUID->"60ab36fd-96a9-47d5-8f82-18e3d556eba9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"NDV", "[", 
    RowBox[{"1", ",", "0.1"}], "]"}], "*", "2"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->49890119,ExpressionUUID->"0aaf2675-7ff4-48c4-b2b7-fec7427ec630"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"2.00\"", 2., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "39","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[2., 0.2, $CellContext`dv$585235]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->507573088,ExpressionUUID->"26f2ecc1-b9a4-4fdb-b6f5-a79224fcfda0"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"60687049-c7f0-47e0-874d-e359e18b8406"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"9a3ac760-e2de-4494-9b6f-bc9b834a0fc1"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"8bd55906-1c1e-4714-9d6d-93491529d77e"],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> 
    "Verdana"}]], \
"InlineFormula",ExpressionUUID->"0c5307f0-3a5e-4553-8b20-2cba059e476d"]], \
"SeeAlso",
 CellID->929782353,ExpressionUUID->"82225edf-83bc-4c03-9ecc-02088261bd31"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"d7f99d10-d2c6-420d-8f16-61c37806370a"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DVE",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 16.9157054}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "DVE[expr] represents a short form of DVEvaluate[expr].", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "DVE", "titlemodifier" -> 
    "", "windowtitle" -> "DVE", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/DVE"}, "SearchTextTranslated" -> "", "NewStyles" -> 
  False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7501, 198, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"fb27ab46-8642-4cf5-b3cd-aaa60f50cab7",
   CellTags->"PrimaryExamplesSection",
   CellID->191518957]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13301, 371}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[575, 21, 3422, 77, 55, "AnchorBarGrid",ExpressionUUID->"82adca5f-459e-4239-87e0-414ae05626b4",
 CellID->1],
Cell[CellGroupData[{
Cell[4022, 102, 388, 9, 52, "ObjectNameGrid",ExpressionUUID->"7e9f1c25-b3b4-42bd-8243-fe1b1734d9a6"],
Cell[4413, 113, 862, 22, 110, "Usage",ExpressionUUID->"5e8ef5b6-0379-4a03-8161-5df8f925da90"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5312, 140, 854, 21, 37, "NotesSection",ExpressionUUID->"1a9796bc-774e-48bc-afa8-0dcbfb6fd276",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->78312193],
Cell[6169, 163, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"b95cfde7-8011-4ed5-8176-1eae03282971"],
Cell[6258, 165, 108, 0, 70, "Notes",ExpressionUUID->"8c6340ff-a753-4b27-9244-5154a03b1066"],
Cell[6369, 167, 1095, 26, 70, "3ColumnTableMod",ExpressionUUID->"ba7beaac-83a3-4d59-ab2b-545ad195e69c"]
}, Closed]],
Cell[CellGroupData[{
Cell[7501, 198, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"fb27ab46-8642-4cf5-b3cd-aaa60f50cab7",
 CellTags->"PrimaryExamplesSection",
 CellID->191518957],
Cell[CellGroupData[{
Cell[7961, 213, 307, 7, 29, "ExampleSection",ExpressionUUID->"a6ca9b8d-c65c-4bf0-9d58-37e725901492",
 CellID->61809119],
Cell[8271, 222, 580, 16, 39, "ExampleText",ExpressionUUID->"77d98d7d-7c52-4c0a-adea-d6890828307d",
 CellID->25697844],
Cell[CellGroupData[{
Cell[8876, 242, 234, 6, 26, "Input",ExpressionUUID->"8e23ddbd-f603-4969-9a68-43d7a5acd4ed",
 CellID->46711560],
Cell[9113, 250, 565, 15, 35, "Output",ExpressionUUID->"60ab36fd-96a9-47d5-8f82-18e3d556eba9",
 CellID->6751416]
}, Open  ]],
Cell[CellGroupData[{
Cell[9715, 270, 241, 6, 26, "Input",ExpressionUUID->"0aaf2675-7ff4-48c4-b2b7-fec7427ec630",
 CellID->49890119],
Cell[9959, 278, 567, 15, 35, "Output",ExpressionUUID->"26f2ecc1-b9a4-4fdb-b6f5-a79224fcfda0",
 CellID->507573088]
}, Open  ]]
}, Open  ]],
Cell[10553, 297, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"60687049-c7f0-47e0-874d-e359e18b8406"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10676, 302, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"8bd55906-1c1e-4714-9d6d-93491529d77e",
 CellID->1255426704],
Cell[10939, 311, 359, 9, 24, "SeeAlso",ExpressionUUID->"82225edf-83bc-4c03-9ecc-02088261bd31",
 CellID->929782353]
}, Open  ]],
Cell[11313, 323, 78, 0, 41, "FooterCell",ExpressionUUID->"d7f99d10-d2c6-420d-8f16-61c37806370a"]
}
]
*)

(* End of internal cache information *)

