(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    103987,       2340]
NotebookOptionsPosition[     94846,       2144]
NotebookOutlinePosition[     97147,       2203]
CellTagsIndexPosition[     97061,       2198]
WindowTitle->DVEvaluate
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "74349c6f-4428-4a87-bb2d-9b9a14d0f315"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"b745301b-2965-4b44-9bfb-645d4fdfb4be"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"NDV\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/NDV"], "\<\"DV\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DV"], "\<\"MCEvaluate\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MCEvaluate"], "\<\"MonteCarloSimulation\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MonteCarloSimulation"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "9e9b912f-11f1-4298-b918-8fd35c11d136"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"315e5a1b-5a93-4085-a859-44be99385248"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "c5a88d22-25bc-4a80-a0b2-06ef70a68906"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"9eddcf88-60c1-41a4-b844-b5dcf9c62a3e"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/DVEvaluate\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/DVEvaluate"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
DVEvaluate.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$18009], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/DVEvaluate", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ac5a298c-4d5d-4e8f-ad7c-745d827d6d46"]
    }], "AnchorBar",ExpressionUUID->"d1010900-90c6-42eb-851d-a57b7b8ff867"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"e6db64c4-5de9-4d9b-b9c1-9a4b4c303884"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["DVEvaluate", "ObjectName",ExpressionUUID->
  "c27c1632-7e53-4051-8c65-86d8b45083e4"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"72acdc13-ac98-47cb-b76f-cbe8d3680638"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "a3b717cb-0dd9-4f82-98b5-9e3f13b96e05"]
}], "ObjectNameGrid",ExpressionUUID->"e3cda62d-5c76-4f94-8e52-7aa16fee938a"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DVEvaluate", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "3911d9d0-8cf0-4dba-91ee-ba85a802ba52"],
     "\[LineSeparator]evaluates ",
     Cell[BoxData[
      StyleBox["expr", "TI"]], "InlineFormula",ExpressionUUID->
      "dd7be7da-5f52-4a4b-af5f-c063a3818700"],
     " while propagating standard errors of ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "a1874848-d3e9-4913-ab6c-2e388a69bf91"],
     " and ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "44d62d9e-fbf2-4e54-80c9-68027f33fc3e"],
     " values by linearizing the functions in the expression."
    }],ExpressionUUID->"6b75e721-fc3e-46f9-b246-1b93cb61ec93"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"a064c47e-e576-4d49-a0df-60d9d6051ffd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"d1e11c25-080c-446b-94c7-68944130dfd6"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"eeea38c9-5971-496e-9de3-1b28eb99e974"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"77c0e3e2-8efa-4866-8868-ff9ef0bb6a30"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->138649485,ExpressionUUID->"3404a83d-c1a6-4a1d-9034-f60a59374cbc"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"69d9d051-a32b-4aca-b9a2-91af6f3f97dd"],

Cell[TextData[{
 "DVEvaluate uses ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["linearizations"]],
    "https://en.wikipedia.org/wiki/Propagation_of_uncertainty"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "ac3969c9-ec76-47c8-a767-38a47a501124"],
 " to propagate uncertainties, requiring that the partial derivatives can be \
calculated for the expression."
}], "Notes",
 CellID->480356010,ExpressionUUID->"e62950bf-06d9-433a-a200-a4fbc306c06b"],

Cell[TextData[{
 "For non-correlated errors, the standard error for an expression expr with ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "31afbf1d-5bae-4abd-a241-43892cd60241"],
 "/",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "3a7f8674-1a5f-4b47-ae3e-4613f9f442e1"],
 " values x1, x2, ... is calculated as ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["se", "expr"], "=", 
   SqrtBox[
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"\[PartialD]", "expr"}], 
          RowBox[{"\[PartialD]", 
           SubscriptBox["x", "1"]}]], ")"}], "2"], 
       SubsuperscriptBox["se", 
        SubscriptBox["x", "1"], "2"]}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{"\[PartialD]", "expr"}], 
          RowBox[{"\[PartialD]", 
           SubscriptBox["x", "2"]}]], ")"}], "2"], 
       SubsuperscriptBox["se", 
        SubscriptBox["x", "2"], "2"]}], "+"}], "..."}]]}]], "InlineFormula",
  ExpressionUUID->"6684d807-2894-4a86-8879-d707ef22bad0"],
 "."
}], "Notes",
 CellID->384245398,ExpressionUUID->"ee0aed0c-0bdc-4431-aa2b-0fe8a76b1853"],

Cell[TextData[{
 "For highly non-linear expressions, the linearizations are not valid and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "d5af1c44-5fc1-49e6-bbdc-1a7b3a347fd7"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "e0d9ada0-5fc5-4216-8fb1-0d89d90a2de5"],
 " should be used instead."
}], "Notes",
 CellID->238275191,ExpressionUUID->"8cd238c6-8f30-4559-a816-420e420116db"],

Cell["The following options can be given: ", "Notes",ExpressionUUID->"99558b23-5e04-4397-8dda-930136c27c2f"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "112ab269-6360-4a60-b2f5-f61f55f67b4d"], 
    ButtonBox["CorrelatedErrors",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/CorrelatedErrors"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["CorrelatedErrors"]],
        "paclet:DataAnalysis/ref/CorrelatedErrors"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "5370d265-6e4e-4083-8fe8-d64a96799122"],
     " specifies whether to assume that all random errors are perfectly \
correlated (True) or completely uncorrelated (False)."
    }], "TableText",ExpressionUUID->"839ed251-b3a7-4daf-b16a-acc81c2c6eaa"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "36f65a75-c285-42a1-9358-4c3668b2c5b4"], 
    ButtonBox["AssumeND",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/AssumeND"], 
    ButtonBox["True",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/True"], Cell[TextData[{
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["AssumeND"]],"paclet:DataAnalysis/ref/AssumeND"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "5f84aea2-f3eb-412d-9ac3-e41368090174"],
     " specifies whether to assume that the resulting distribution is a \
normal distribution (True) or not (False)."
    }], "TableText",ExpressionUUID->"aa670e61-c771-4492-86a5-5913c98ce93c"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True, 
      True}}}},ExpressionUUID->"5721d150-a273-4b2f-8f28-4ce26c3aa253"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"1020d9ef-4ddb-47ae-92f6-bae2d49700d2"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"ea2ce029-b55d-4f71-a208-072534b824cb"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount",ExpressionUUID->
  "915a6fc4-d65d-40d9-8bb8-ef10f8464198"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->768151383,ExpressionUUID->"3ca5c452-60f6-4e9f-839f-02f82f43a864"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "da2f0ae4-579a-48ac-8002-85291a78a937"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->588190822,ExpressionUUID->"faf0c2e9-f3d3-4196-9279-259dafab33da"],

Cell["Propagate uncertainties for a simple expression:", "ExampleText",
 CellID->466960344,ExpressionUUID->"7b7eeb88-8a11-42cd-b6e5-db183ce7e4cd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"NDV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}], "+", 
   RowBox[{"2", "*", 
    RowBox[{"NDV", "[", 
     RowBox[{"1", ",", "0.1"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->97848455,ExpressionUUID->"ad58c30f-55ee-4de0-bcb6-98ed0ea7239e"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"7.00\"", 7., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "88","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[7., 0.447213595499958, $CellContext`dv$1036869]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->75754561,ExpressionUUID->"fd3390cc-c50e-43a2-a349-2e22d7885d67"]
}, Open  ]],

Cell[TextData[{
 "Uncertainties of values in ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f148360b-e215-486f-8534-11eeed4aeb2f"],
 " objects are automatically propagated when using ",
 ButtonBox["Query",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Query"],
 " functions:"
}], "ExampleText",
 CellID->90440991,ExpressionUUID->"c0c164ee-7753-42ea-b5ae-42eeef7cd2cc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataset", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<row1\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<a\>\"", "\[Rule]", "1"}], ",", 
        RowBox[{"\"\<b\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"2", ",", "0.1"}], "]"}]}], ",", 
        RowBox[{"\"\<c\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"3", ",", "0.2"}], "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<row2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<a\>\"", "\[Rule]", "4"}], ",", 
        RowBox[{"\"\<b\>\"", "\[Rule]", "4"}], ",", 
        RowBox[{"\"\<c\>\"", "\[Rule]", "8"}]}], "|>"}]}]}], "|>"}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->24554958,ExpressionUUID->"979acc3b-0866-4ce9-8d29-e21dda1ab5e6"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row1" -> Association[
               "a" -> 1, "b" -> 
                DataAnalysis`NDV[2, 0.1, $CellContext`dv$1059818], "c" -> 
                DataAnalysis`NDV[3, 0.2, $CellContext`dv$1059819]], "row2" -> 
              Association["a" -> 4, "b" -> 4, "c" -> 8]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 2], 
             Association["ID" -> 203001760184813]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row1" -> Association[
               "a" -> 1, "b" -> 
                DataAnalysis`NDV[2, 0.1, $CellContext`dv$1059818], "c" -> 
                DataAnalysis`NDV[3, 0.2, $CellContext`dv$1059819]], "row2" -> 
              Association["a" -> 4, "b" -> 4, "c" -> 8]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 2], 
             Association["ID" -> 203001760184813]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row1" -> Association[
                "a" -> 1, "b" -> 
                 DataAnalysis`NDV[2, 0.1, $CellContext`dv$1059818], "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$1059819]], "row2" -> 
               Association["a" -> 4, "b" -> 4, "c" -> 8]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"a", "b", "c"}, {
                 TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                 TypeSystem`AnyType}], 2], 
              Association["ID" -> 203001760184813]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row1" -> Association[
                "a" -> 1, "b" -> 
                 DataAnalysis`NDV[2, 0.1, $CellContext`dv$1059818], "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$1059819]], "row2" -> 
               Association["a" -> 4, "b" -> 4, "c" -> 8]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"a", "b", "c"}, {
                 TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                 TypeSystem`AnyType}], 2], 
              Association["ID" -> 203001760184813]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 2, "Length" -> 2, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 2], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[58]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[38.400000000000006`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`AtomShape[34], "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 2, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[443188061], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 2], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[443188061]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    2090749564][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    2090749564][{All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    2090749564][{All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    2090749564][{All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row1", 
                    Style[
                    "row1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2090749564][{
                    Key["row1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[
                    Key["row1"]]], "Mouse"], 
                    ImageSize -> {{38.400000000000006`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[
                    Key["row1"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"2.00\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[2, 0.1, $CellContext`dv$1059818]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[
                    Key["row1"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.00\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[3, 0.2, $CellContext`dv$1059819]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[
                    Key["row1"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row2", 
                    Style[
                    "row2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2090749564][{
                    Key["row2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], 
                    ImageSize -> {{38.400000000000006`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["4"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["4"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2090749564][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2090749564][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2090749564]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[2090749564][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[2090749564][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {239., {43., 49.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 124},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->103827481,ExpressionUUID->"ccec9241-4c5d-41c9-9135-d618ccf908f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataset", "[", 
  RowBox[{"All", ",", 
   RowBox[{
    RowBox[{"#\"b\"", "*", "#\"c\""}], "&"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->933890490,ExpressionUUID->"c4cd91f7-8e33-4bbc-b14b-52e57687e542"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row1" -> DataAnalysis`NDV[6., 0.5, $CellContext`dv$1063300], 
              "row2" -> 32], 
             TypeSystem`Struct[{"row1", "row2"}, {TypeSystem`AnyType, 
               TypeSystem`Atom[Integer]}], 
             Association[
             "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                Dataset`DatasetHandle[83747698244094]], "ID" -> 
              83769173080574]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row1" -> DataAnalysis`NDV[6., 0.5, $CellContext`dv$1063300], 
              "row2" -> 32], 
             TypeSystem`Struct[{"row1", "row2"}, {TypeSystem`AnyType, 
               TypeSystem`Atom[Integer]}], 
             Association[
             "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                Dataset`DatasetHandle[83747698244094]], "ID" -> 
              83769173080574]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row1" -> DataAnalysis`NDV[6., 0.5, $CellContext`dv$1063300], 
               "row2" -> 32], 
              TypeSystem`Struct[{"row1", "row2"}, {TypeSystem`AnyType, 
                TypeSystem`Atom[Integer]}], 
              Association[
              "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                 Dataset`DatasetHandle[83747698244094]], "ID" -> 
               83769173080574]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row1" -> DataAnalysis`NDV[6., 0.5, $CellContext`dv$1063300], 
               "row2" -> 32], 
              TypeSystem`Struct[{"row1", "row2"}, {TypeSystem`AnyType, 
                TypeSystem`Atom[Integer]}], 
              Association[
              "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                 Dataset`DatasetHandle[83747698244094]], "ID" -> 
               83769173080574]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 20, "Length" -> 2, "InitialType" -> 
            TypeSystem`Struct[{"row1", "row2"}, {TypeSystem`AnyType, 
               TypeSystem`Atom[Integer]}], "Shape" -> 
            TypeSystem`PackageScope`DocumentShape[
              Association[{"row1"} -> 
               TypeSystem`PackageScope`UnknownShape, {"row2"} -> 
               TypeSystem`PackageScope`AtomShape[34]], 1], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[41330830], "Type" -> 
            TypeSystem`Struct[{"row1", "row2"}, {TypeSystem`AnyType, 
               TypeSystem`Atom[Integer]}], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[41330830]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"row1\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"row1\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1072810670][{
                    Key["row1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1072810670][
                    GeneralUtilities`Slice[
                    Key["row1"]]], "Mouse"], Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"6.00\"", 6., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "98", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[6., 0.5, $CellContext`dv$1063300]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1072810670][
                    GeneralUtilities`Slice[
                    Key["row1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"row2\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"row2\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1072810670][{
                    Key["row2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1072810670][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["32"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1072810670][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1072810670][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1072810670]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1072810670][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1072810670][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {116., {30., 36.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 98},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->114041699,ExpressionUUID->"14a5748e-1f4a-41e0-9a2a-d817b6891a08"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dataset", "[", "Total", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->313873096,ExpressionUUID->"07f054a4-198d-45d5-beae-980155c5ae52"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "a" -> 5, "b" -> 
              DataAnalysis`NDV[6., 0.1, $CellContext`dv$1068673], "c" -> 
              DataAnalysis`NDV[11., 0.2, $CellContext`dv$1068676]], 
             TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`Atom[Integer], TypeSystem`AnyType, 
               TypeSystem`AnyType}], 
             Association[
             "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                Dataset`DatasetHandle[92281798261278]], "ID" -> 
              92303273097758]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "a" -> 5, "b" -> 
              DataAnalysis`NDV[6., 0.1, $CellContext`dv$1068673], "c" -> 
              DataAnalysis`NDV[11., 0.2, $CellContext`dv$1068676]], 
             TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`Atom[Integer], TypeSystem`AnyType, 
               TypeSystem`AnyType}], 
             Association[
             "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                Dataset`DatasetHandle[92281798261278]], "ID" -> 
              92303273097758]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "a" -> 5, "b" -> 
               DataAnalysis`NDV[6., 0.1, $CellContext`dv$1068673], "c" -> 
               DataAnalysis`NDV[11., 0.2, $CellContext`dv$1068676]], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 
              Association[
              "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                 Dataset`DatasetHandle[92281798261278]], "ID" -> 
               92303273097758]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "a" -> 5, "b" -> 
               DataAnalysis`NDV[6., 0.1, $CellContext`dv$1068673], "c" -> 
               DataAnalysis`NDV[11., 0.2, $CellContext`dv$1068676]], 
              TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`Atom[Integer], TypeSystem`AnyType, 
                TypeSystem`AnyType}], 
              Association[
              "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                 Dataset`DatasetHandle[92281798261278]], "ID" -> 
               92303273097758]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 20, "Length" -> 3, "InitialType" -> 
            TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`Atom[Integer], TypeSystem`AnyType, 
               TypeSystem`AnyType}], "Shape" -> 
            TypeSystem`PackageScope`DocumentShape[
              
              Association[{"a"} -> 
               TypeSystem`PackageScope`AtomShape[34], {"b"} -> 
               TypeSystem`PackageScope`UnknownShape, {"c"} -> 
               TypeSystem`PackageScope`UnknownShape], 1], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[214467659], "Type" -> 
            TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`Atom[Integer], TypeSystem`AnyType, 
               TypeSystem`AnyType}], "HandleQ" -> True, "RowTarget" -> 20, 
            "Data" -> TypeSystem`PackageScope`CacheHandle[214467659]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1202622408][{
                    Key["a"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1202622408][
                    GeneralUtilities`Slice[
                    Key["a"]]], "Mouse"], Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["5"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1202622408][
                    GeneralUtilities`Slice[
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1202622408][{
                    Key["b"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1202622408][
                    GeneralUtilities`Slice[
                    Key["b"]]], "Mouse"], Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"6.00\"", 6., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[6., 0.1, $CellContext`dv$1068673]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1202622408][
                    GeneralUtilities`Slice[
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1202622408][{
                    Key["c"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1202622408][
                    GeneralUtilities`Slice[
                    Key["c"]]], "Mouse"], Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"11.00\"", 11., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[11., 0.2, $CellContext`dv$1068676]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1202622408][
                    GeneralUtilities`Slice[
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1202622408][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1202622408]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1202622408][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1202622408][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {112., {43., 49.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 124},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->282845827,ExpressionUUID->"3546a646-37c3-42cf-a6fd-0bc2be8c7a7e"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "866dbcaa-01eb-4d99-9050-acdf41d2593f"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"a791ac89-fdf4-4e5a-b161-e9c5778365d3"],

Cell[CellGroupData[{

Cell[TextData[{
 "CorrelatedErrors",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "89d7ae59-97e0-468b-a94a-7cf222bacba4"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"a30ae5c0-0fc0-4f75-aec6-bc90723e5644"],

Cell["By default, uncertainties are assumed to be independent:", "ExampleText",
 CellID->394312261,ExpressionUUID->"8e0dfbf6-4a92-4996-ae5a-a45a2bb85610"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"NDV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}], "+", 
   RowBox[{"NDV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->91034830,ExpressionUUID->"e294bc28-92c2-4c69-8b36-8cdf6d36f925"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"10.0\"", 10., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "11","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[
  10., 0.5656854249492381, $CellContext`dv$417464]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->493117322,ExpressionUUID->"0e7afe3c-9ea4-486b-a8ec-33a3019670f9"]
}, Open  ]],

Cell[TextData[{
 "Setting ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["CorrelatedErrors"]],"paclet:DataAnalysis/ref/CorrelatedErrors"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "d8453ff9-8e4b-4ee1-bc83-0724109e25d0"],
 " to True assumes that all variables with uncertainties are perfectly \
correlated:"
}], "ExampleText",
 CellID->196478336,ExpressionUUID->"576fe612-6591-43ab-b158-6f7eb4442c30"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"NDV", "[", 
     RowBox[{"5", ",", "0.4"}], "]"}], "+", 
    RowBox[{"NDV", "[", 
     RowBox[{"5", ",", "0.4"}], "]"}]}], ",", 
   RowBox[{"CorrelatedErrors", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->174807330,ExpressionUUID->"f540f830-40f7-41ea-875f-75568b4c283d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"10.0\"", 10., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "16","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[10., 0.8, $CellContext`dv$422103]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->3531948,ExpressionUUID->"9fd1b343-08a6-478b-911f-e3e35e772141"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "AssumeND",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "191a9f0d-0b53-4571-bbe0-d9e4f64cbad6"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"9d998ca0-25a2-49d9-b4a1-701e35fe4a02"],

Cell[TextData[{
 "By default, ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "e1cf876f-d9d2-4ae6-ae6f-0dc0846209fe"],
 " gives a NDV value which represents a normally distributed value:"
}], "ExampleText",
 CellID->48473001,ExpressionUUID->"5de22853-af3d-4569-bf2e-26c864d81c55"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DVEvaluate", "[", 
   RowBox[{
    RowBox[{"NDV", "[", 
     RowBox[{"5", ",", "0.4"}], "]"}], "+", 
    RowBox[{"NDV", "[", 
     RowBox[{"5", ",", "0.4"}], "]"}]}], "]"}], "//", "Head"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->190149883,ExpressionUUID->"9bfc2c05-b92d-42a7-abde-b8a2b50b8acc"],

Cell[BoxData["NDV"], "Output",
 ImageSize->{25, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->110012641,ExpressionUUID->"b837cb43-6deb-48c1-a289-92a153205529"]
}, Open  ]],

Cell[TextData[{
 "Setting ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["AssumeND"]],"paclet:DataAnalysis/ref/AssumeND"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "105ef89e-6518-4a25-8663-859faf10539e"],
 " to False gives a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "4bb363dd-cf6c-493e-b010-991f1e1d6258"],
 " object instead:"
}], "ExampleText",
 CellID->65101660,ExpressionUUID->"fd064a95-9b37-4620-baa8-c6dea7d22ac3"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DVEvaluate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"NDV", "[", 
      RowBox[{"5", ",", "0.4"}], "]"}], "+", 
     RowBox[{"NDV", "[", 
      RowBox[{"5", ",", "0.4"}], "]"}]}], ",", 
    RowBox[{"AssumeND", "\[Rule]", "False"}]}], "]"}], "//", 
  "Head"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->187237263,ExpressionUUID->"26025bc0-1a40-45cb-8d7b-51bead6fe1cc"],

Cell[BoxData["DV"], "Output",
 ImageSize->{18, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->148961571,ExpressionUUID->"78277a29-3432-4210-bd5c-4867a9c5b0a7"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Possible Issues",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "8389ba84-c3f8-4d14-adee-61dddcb81562"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373,ExpressionUUID->"e7f4fdc2-156e-4b21-a353-cf168e294da6"],

Cell[TextData[{
 "For highly non-linear functions, ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "6184be14-c972-4d39-800b-8cc156d246da"],
 " and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "411ca874-899e-4c72-85b0-9fb44d5ac4fa"],
 " yield different results as ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "843c7c27-0ca4-4aa2-b375-536eba370242"],
 " uses ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f2949558-7f7a-4a08-a852-3daca2446bf3"],
 " which does not use linearizations:"
}], "ExampleText",
 CellID->378591257,ExpressionUUID->"8d621904-922e-4adf-b170-26fa9fc62761"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"NDV", "[", 
    RowBox[{"1", ",", "0.1"}], "]"}], "^", "5"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->12560657,ExpressionUUID->"3423efab-b802-46e0-938b-524f275d0125"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "98","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1., 0.5, $CellContext`dv$1036885]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->173580685,ExpressionUUID->"66c6795e-7d56-45dc-ac98-76921a52e4b0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MCEvaluate", "[", 
  RowBox[{
   RowBox[{"NDV", "[", 
    RowBox[{"1", ",", "0.1"}], "]"}], "^", "5"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->652441307,ExpressionUUID->"4f6ca73d-7390-48cb-aae9-f75a629d2d98"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(-\"",
     "67","\"+\"","142","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[
  1, 0.545675308678014, {0.6697987075746382, 
   1.4193491277234664`}, $CellContext`dv$1056923]]], "Output",
 ImageSize->{95, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->19541831,ExpressionUUID->"b9e906b3-a2ba-4f32-b555-a0054e6e23b2"]
}, Open  ]],

Cell["\<\
Uncertainties cannot be propagated if partial derivatives cannot be evaluated:\
\>", "ExampleText",
 CellID->3588991,ExpressionUUID->"d88d9738-d650-4ea6-97e4-b9b7f10f1a9e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{"a", "+", 
   RowBox[{"NDV", "[", 
    RowBox[{"1", ",", "0.1"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->527125524,ExpressionUUID->"f5dc82df-7d8c-4634-b384-035a017f8124"],

Cell[BoxData[
 RowBox[{"a", "+", 
  InterpretationBox[
   StyleBox[
    TemplateBox[{TagBox[
       InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
         DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
      "20","\")\""},
     "RowDefault"],
    StripOnInput->False,
    ShowStringCharacters->False],
   DataAnalysis`NDV[1, 0.1, $CellContext`dv$1056927]]}]], "Output",
 ImageSize->{80, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->238447377,ExpressionUUID->"85ab5f56-6b5e-4cb9-91a2-4a3f2b2cfe78"]
}, Open  ]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"d15ef86d-67c1-42f4-a6fc-94a99669a453"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"25168db5-c0d3-401f-aac9-992ba6c9a7d1"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"7b733f9c-56bc-464e-af12-feb9d4b36528"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"be4a13eb-87fa-4328-a243-46ba6bfc72f7"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"c15543ce-0de0-48fb-abe0-9a211b0a8b7f"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"18b2af0a-0771-4834-b381-a2657fd1f6e3"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"1c7253b0-140a-4f78-a8cb-59f78bb917b6"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"9273f95c-fb69-45df-a325-b39b9bf4bed9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"6a4cc7e4-2786-4ae2-8af0-f3550002b5f5"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"504a4af5-1513-4b89-8f4a-69f8054ee721"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"7fe99548-f84b-4727-a54f-72a2edfa7c1f"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->589204770,ExpressionUUID->"05b1cb49-4d30-48c1-a6cd-243846e709ee"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"9f5f18e6-6060-4e87-8055-6ce49b41730f"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DVEvaluate",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 18.7134829}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "DVEvaluate[expr] evaluates expr while propagating standard errors of DV \
and NDV values by linearizing the functions in the expression.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "DVEvaluate", 
    "titlemodifier" -> "", "windowtitle" -> "DVEvaluate", "type" -> "Symbol", 
    "uri" -> "DataAnalysis/ref/DVEvaluate"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[12358, 327, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3ca5c452-60f6-4e9f-839f-02f82f43a864",
   CellTags->"PrimaryExamplesSection",
   CellID->768151383]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 96862, 2191}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[582, 21, 4400, 98, 55, "AnchorBarGrid",ExpressionUUID->"e6db64c4-5de9-4d9b-b9c1-9a4b4c303884",
 CellID->1],
Cell[CellGroupData[{
Cell[5007, 123, 395, 9, 52, "ObjectNameGrid",ExpressionUUID->"e3cda62d-5c76-4f94-8e52-7aa16fee938a"],
Cell[5405, 134, 1257, 31, 131, "Usage",ExpressionUUID->"a064c47e-e576-4d49-a0df-60d9d6051ffd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6699, 170, 855, 21, 37, "NotesSection",ExpressionUUID->"3404a83d-c1a6-4a1d-9034-f60a59374cbc",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->138649485],
Cell[7557, 193, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"69d9d051-a32b-4aca-b9a2-91af6f3f97dd"],
Cell[7646, 195, 470, 12, 70, "Notes",ExpressionUUID->"e62950bf-06d9-433a-a200-a4fbc306c06b",
 CellID->480356010],
Cell[8119, 209, 1435, 43, 70, "Notes",ExpressionUUID->"ee0aed0c-0bdc-4431-aa2b-0fe8a76b1853",
 CellID->384245398],
Cell[9557, 254, 700, 18, 70, "Notes",ExpressionUUID->"8cd238c6-8f30-4559-a816-420e420116db",
 CellID->238275191],
Cell[10260, 274, 108, 0, 70, "Notes",ExpressionUUID->"99558b23-5e04-4397-8dda-930136c27c2f"],
Cell[10371, 276, 1861, 44, 70, "3ColumnTableMod",ExpressionUUID->"5721d150-a273-4b2f-8f28-4ce26c3aa253"],
Cell[12235, 322, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"1020d9ef-4ddb-47ae-92f6-bae2d49700d2"]
}, Closed]],
Cell[CellGroupData[{
Cell[12358, 327, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3ca5c452-60f6-4e9f-839f-02f82f43a864",
 CellTags->"PrimaryExamplesSection",
 CellID->768151383],
Cell[CellGroupData[{
Cell[12818, 342, 308, 7, 29, "ExampleSection",ExpressionUUID->"faf0c2e9-f3d3-4196-9279-259dafab33da",
 CellID->588190822],
Cell[13129, 351, 146, 1, 38, "ExampleText",ExpressionUUID->"7b7eeb88-8a11-42cd-b6e5-db183ce7e4cd",
 CellID->466960344],
Cell[CellGroupData[{
Cell[13300, 356, 325, 9, 26, "Input",ExpressionUUID->"ad58c30f-55ee-4de0-bcb6-98ed0ea7239e",
 CellID->97848455],
Cell[13628, 367, 581, 15, 35, "Output",ExpressionUUID->"fd3390cc-c50e-43a2-a349-2e22d7885d67",
 CellID->75754561]
}, Open  ]],
Cell[14224, 385, 512, 14, 58, "ExampleText",ExpressionUUID->"c0c164ee-7753-42ea-b5ae-42eeef7cd2cc",
 CellID->90440991],
Cell[CellGroupData[{
Cell[14761, 403, 861, 23, 43, "Input",ExpressionUUID->"979acc3b-0866-4ce9-8d29-e21dda1ab5e6",
 CellID->24554958],
Cell[15625, 428, 27042, 531, 145, "Output",ExpressionUUID->"ccec9241-4c5d-41c9-9135-d618ccf908f5",
 CellID->103827481]
}, Open  ]],
Cell[CellGroupData[{
Cell[42704, 964, 237, 6, 26, "Input",ExpressionUUID->"c4cd91f7-8e33-4bbc-b14b-52e57687e542",
 CellID->933890490],
Cell[42944, 972, 17915, 342, 119, "Output",ExpressionUUID->"14a5748e-1f4a-41e0-9a2a-d817b6891a08",
 CellID->114041699]
}, Open  ]],
Cell[CellGroupData[{
Cell[60896, 1319, 162, 3, 70, "Input",ExpressionUUID->"07f054a4-198d-45d5-beae-980155c5ae52",
 CellID->313873096],
Cell[61061, 1324, 21008, 407, 70, "Output",ExpressionUUID->"3546a646-37c3-42cf-a6fd-0bc2be8c7a7e",
 CellID->282845827]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[82118, 1737, 284, 7, 70, "ExampleSection",ExpressionUUID->"a791ac89-fdf4-4e5a-b161-e9c5778365d3"],
Cell[CellGroupData[{
Cell[82427, 1748, 299, 7, 70, "ExampleSubsection",ExpressionUUID->"a30ae5c0-0fc0-4f75-aec6-bc90723e5644"],
Cell[82729, 1757, 154, 1, 70, "ExampleText",ExpressionUUID->"8e0dfbf6-4a92-4996-ae5a-a45a2bb85610",
 CellID->394312261],
Cell[CellGroupData[{
Cell[82908, 1762, 299, 8, 70, "Input",ExpressionUUID->"e294bc28-92c2-4c69-8b36-8cdf6d36f925",
 CellID->91034830],
Cell[83210, 1772, 587, 16, 35, "Output",ExpressionUUID->"0e7afe3c-9ea4-486b-a8ec-33a3019670f9",
 CellID->493117322]
}, Open  ]],
Cell[83812, 1791, 449, 11, 70, "ExampleText",ExpressionUUID->"576fe612-6591-43ab-b158-6f7eb4442c30",
 CellID->196478336],
Cell[CellGroupData[{
Cell[84286, 1806, 376, 10, 70, "Input",ExpressionUUID->"f540f830-40f7-41ea-875f-75568b4c283d",
 CellID->174807330],
Cell[84665, 1818, 567, 15, 35, "Output",ExpressionUUID->"9fd1b343-08a6-478b-911f-e3e35e772141",
 CellID->3531948]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[85281, 1839, 291, 7, 70, "ExampleSubsection",ExpressionUUID->"9d998ca0-25a2-49d9-b4a1-701e35fe4a02"],
Cell[85575, 1848, 423, 10, 70, "ExampleText",ExpressionUUID->"5de22853-af3d-4569-bf2e-26c864d81c55",
 CellID->48473001],
Cell[CellGroupData[{
Cell[86023, 1862, 332, 9, 70, "Input",ExpressionUUID->"9bfc2c05-b92d-42a7-abde-b8a2b50b8acc",
 CellID->190149883],
Cell[86358, 1873, 215, 5, 35, "Output",ExpressionUUID->"b837cb43-6deb-48c1-a289-92a153205529",
 CellID->110012641]
}, Open  ]],
Cell[86588, 1881, 602, 17, 70, "ExampleText",ExpressionUUID->"fd064a95-9b37-4620-baa8-c6dea7d22ac3",
 CellID->65101660],
Cell[CellGroupData[{
Cell[87215, 1902, 406, 12, 70, "Input",ExpressionUUID->"26025bc0-1a40-45cb-8d7b-51bead6fe1cc",
 CellID->187237263],
Cell[87624, 1916, 214, 5, 35, "Output",ExpressionUUID->"78277a29-3432-4210-bd5c-4867a9c5b0a7",
 CellID->148961571]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[87899, 1928, 310, 7, 70, "ExampleSection",ExpressionUUID->"e7f4fdc2-156e-4b21-a353-cf168e294da6",
 CellID->1305812373],
Cell[88212, 1937, 1181, 32, 70, "ExampleText",ExpressionUUID->"8d621904-922e-4adf-b170-26fa9fc62761",
 CellID->378591257],
Cell[CellGroupData[{
Cell[89418, 1973, 241, 6, 70, "Input",ExpressionUUID->"3423efab-b802-46e0-938b-524f275d0125",
 CellID->12560657],
Cell[89662, 1981, 568, 15, 35, "Output",ExpressionUUID->"66c6795e-7d56-45dc-ac98-76921a52e4b0",
 CellID->173580685]
}, Open  ]],
Cell[CellGroupData[{
Cell[90267, 2001, 242, 6, 70, "Input",ExpressionUUID->"4f6ca73d-7390-48cb-aae9-f75a629d2d98",
 CellID->652441307],
Cell[90512, 2009, 644, 17, 35, "Output",ExpressionUUID->"b9e906b3-a2ba-4f32-b555-a0054e6e23b2",
 CellID->19541831]
}, Open  ]],
Cell[91171, 2029, 182, 3, 70, "ExampleText",ExpressionUUID->"d88d9738-d650-4ea6-97e4-b9b7f10f1a9e",
 CellID->3588991],
Cell[CellGroupData[{
Cell[91378, 2036, 242, 6, 70, "Input",ExpressionUUID->"f5dc82df-7d8c-4634-b384-035a017f8124",
 CellID->527125524],
Cell[91623, 2044, 599, 16, 35, "Output",ExpressionUUID->"85ab5f56-6b5e-4cb9-91a2-4a3f2b2cfe78",
 CellID->238447377]
}, Open  ]]
}, Closed]],
Cell[92249, 2064, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"d15ef86d-67c1-42f4-a6fc-94a99669a453"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92372, 2069, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"7b733f9c-56bc-464e-af12-feb9d4b36528",
 CellID->1255426704],
Cell[92635, 2078, 1472, 39, 70, "SeeAlso",ExpressionUUID->"9273f95c-fb69-45df-a325-b39b9bf4bed9",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[94144, 2122, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"504a4af5-1513-4b89-8f4a-69f8054ee721",
 CellID->38303248],
Cell[94413, 2131, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"7fe99548-f84b-4727-a54f-72a2edfa7c1f"],
Cell[94502, 2133, 247, 6, 70, "MoreAbout",ExpressionUUID->"05b1cb49-4d30-48c1-a6cd-243846e709ee",
 CellID->589204770]
}, Open  ]],
Cell[94764, 2142, 78, 0, 70, "FooterCell",ExpressionUUID->"9f5f18e6-6060-4e87-8055-6ce49b41730f"]
}
]
*)

(* End of internal cache information *)

