(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15453,        417]
NotebookOptionsPosition[     11157,        318]
NotebookOutlinePosition[     13394,        376]
CellTagsIndexPosition[     13309,        371]
WindowTitle->DVMeans
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "e567b1b0-10a8-4b8a-b196-e7c68500c986"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"147c181f-452c-482d-ad63-3d9f3073978c"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DVSEs\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVSEs"], "\<\"NDV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/NDV"], "\<\"DV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/DV"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7a98c6ce-5ace-4e1e-af2e-95c845f858f3"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"7ad0456e-dc9a-4de0-a70a-c9d585592355"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "3895e7d4-4611-4896-9be5-4af69b3dc098"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"12c13f84-59fd-45bf-89a7-6021852fff86"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/DVMeans\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/DVMeans"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
DVMeans.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$18576], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/DVMeans", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "f3cc6eb2-7164-4621-92d9-f5f8f261d256"]
    }], "AnchorBar",ExpressionUUID->"b6181737-6ea3-4e81-a1f8-cf2f3c91877b"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"e9e8b1e0-a4c2-4f0e-8cb2-a13b1eaf89bc"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["DVMeans", "ObjectName",ExpressionUUID->
  "f1c32411-1e9e-4c9c-9f41-0f8c08447c41"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"7891ee8e-6e46-4979-85c0-93b3d09d1e4e"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "d3e18a09-5b8e-4088-adc8-e2e7b15fd1ce"]
}], "ObjectNameGrid",ExpressionUUID->"c196118d-a32d-4a52-9163-93706b1af687"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DVMeans", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "27282f2f-a2af-44d0-b3bc-e6f25fcde5fd"],
     "\[LineSeparator]replaces all ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "f1ac8ee7-20f6-49a0-8540-555a1e64c401"],
     ", ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "f1615865-330a-4292-8f3c-100a77957955"],
     " and ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["IV"]],"paclet:DataAnalysis/ref/IV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "e2161fa2-6262-477a-bddf-03dcc528b1ac"],
     " objects in an expression with their mean value."
    }],ExpressionUUID->"4d33b074-30fd-4898-a9cb-3b25cf7e9f45"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"f12dec89-bd5d-4d02-970d-7326980dec98"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"b580fd09-dc4c-4259-8f26-b50def2525a4"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "4f18c40b-558d-485c-b114-609eaa03a650"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->220629127,ExpressionUUID->"9be442c0-ead2-4979-a450-5f2d9b711f79"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "d8401a1a-5c7f-45b6-ac4c-eacf7b58fa10"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->378696715,ExpressionUUID->"b1a6d5d1-3185-4f8e-b3cb-4a6c9cc67512"],

Cell[TextData[{
 "Define a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "4fb7b236-c716-418a-8768-96e12fa33dd2"],
 " and get the mean:"
}], "ExampleText",
 CellID->134214481,ExpressionUUID->"907970da-2af5-47e8-b739-f9b5ec292fa2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "=", 
  RowBox[{"NDV", "[", 
   RowBox[{"1", ",", "0.1"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->134684742,ExpressionUUID->"c3b72916-f273-4b2c-a196-fb169f61de9d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "20","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1, 0.1, $CellContext`dv$18791]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->604647322,ExpressionUUID->"d6130a8d-6231-40a1-816e-5c27cd237520"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVMeans", "[", "v", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->298591856,ExpressionUUID->"e8d5faf4-359e-4b58-8dbf-2153d8bfb2b5"],

Cell[BoxData["1"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->247805574,ExpressionUUID->"c56fa307-b4dd-4a1c-bfd6-a286d81cd777"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"833f27fc-e5e2-416c-9004-98208203738b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"886e6242-b92a-4e4d-977e-42a6c1cc93ce"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"16ea9bb3-a5c5-4d56-9a06-889d37c99678"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVSEs"]],"paclet:DataAnalysis/ref/DVSEs"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"72b125a6-cad7-47c3-b3a8-ce5d358446ea"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"619d9136-7ad8-4033-82ed-8d4e3459fdbe"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"adeef656-40dd-4445-af82-306eb108d5d1"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"e4d45ef3-1ced-4c5b-8bd1-da076e05ef0f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"ddc3ea87-89f3-456c-88cf-ca985d0d13ca"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"30c16c8a-c453-4f7c-921d-071a4cd74d1b"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"b99a0539-64d0-4202-85cc-96a67c8004ac"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->404206210,ExpressionUUID->"202b5ab9-a6fe-426c-aff8-79601379af81"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"4b6756f2-e181-4068-a941-cba1b17433c3"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DVMeans",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 20.7509117}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "DVMeans[expr] replaces all DV, NDV and IV objects in an expression with \
their mean value.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "DVMeans",
     "titlemodifier" -> "", "windowtitle" -> "DVMeans", "type" -> "Symbol", 
    "uri" -> "DataAnalysis/ref/DVMeans"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6603, 170, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"9be442c0-ead2-4979-a450-5f2d9b711f79",
   CellTags->"PrimaryExamplesSection",
   CellID->220629127]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13111, 364}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[579, 21, 4246, 95, 55, "AnchorBarGrid",ExpressionUUID->"e9e8b1e0-a4c2-4f0e-8cb2-a13b1eaf89bc",
 CellID->1],
Cell[CellGroupData[{
Cell[4850, 120, 392, 9, 52, "ObjectNameGrid",ExpressionUUID->"c196118d-a32d-4a52-9163-93706b1af687"],
Cell[5245, 131, 1321, 34, 110, "Usage",ExpressionUUID->"f12dec89-bd5d-4d02-970d-7326980dec98"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6603, 170, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"9be442c0-ead2-4979-a450-5f2d9b711f79",
 CellTags->"PrimaryExamplesSection",
 CellID->220629127],
Cell[CellGroupData[{
Cell[7063, 185, 308, 7, 29, "ExampleSection",ExpressionUUID->"b1a6d5d1-3185-4f8e-b3cb-4a6c9cc67512",
 CellID->378696715],
Cell[7374, 194, 360, 10, 39, "ExampleText",ExpressionUUID->"907970da-2af5-47e8-b739-f9b5ec292fa2",
 CellID->134214481],
Cell[CellGroupData[{
Cell[7759, 208, 203, 5, 26, "Input",ExpressionUUID->"c3b72916-f273-4b2c-a196-fb169f61de9d",
 CellID->134684742],
Cell[7965, 215, 565, 15, 35, "Output",ExpressionUUID->"d6130a8d-6231-40a1-816e-5c27cd237520",
 CellID->604647322]
}, Open  ]],
Cell[CellGroupData[{
Cell[8567, 235, 158, 3, 26, "Input",ExpressionUUID->"e8d5faf4-359e-4b58-8dbf-2153d8bfb2b5",
 CellID->298591856],
Cell[8728, 240, 213, 5, 35, "Output",ExpressionUUID->"c56fa307-b4dd-4a1c-bfd6-a286d81cd777",
 CellID->247805574]
}, Open  ]]
}, Open  ]],
Cell[8968, 249, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"833f27fc-e5e2-416c-9004-98208203738b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9091, 254, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"16ea9bb3-a5c5-4d56-9a06-889d37c99678",
 CellID->1255426704],
Cell[9354, 263, 1064, 28, 24, "SeeAlso",ExpressionUUID->"e4d45ef3-1ced-4c5b-8bd1-da076e05ef0f",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[10455, 296, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"30c16c8a-c453-4f7c-921d-071a4cd74d1b",
 CellID->38303248],
Cell[10724, 305, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"b99a0539-64d0-4202-85cc-96a67c8004ac"],
Cell[10813, 307, 247, 6, 24, "MoreAbout",ExpressionUUID->"202b5ab9-a6fe-426c-aff8-79601379af81",
 CellID->404206210]
}, Open  ]],
Cell[11075, 316, 78, 0, 41, "FooterCell",ExpressionUUID->"4b6756f2-e181-4068-a941-cba1b17433c3"]
}
]
*)

(* End of internal cache information *)

