(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14857,        403]
NotebookOptionsPosition[     10574,        304]
NotebookOutlinePosition[     12801,        362]
CellTagsIndexPosition[     12716,        357]
WindowTitle->DVSEs
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "25bc73ef-00b2-4a60-b807-67e6c4c018f7"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"e8ff3dc5-f712-435d-8d1a-0bf883dcd44f"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DVMeans\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVMeans"], "\<\"NDV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/NDV"], "\<\"DV\"\>":>
       Documentation`HelpLookup["paclet:ref/DV"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "9c0cc44b-6888-4078-a64f-35710bfeff26"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"bb21682d-bfa0-4ed6-9164-c1c1cdd39e2b"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ce077843-9c9b-4f71-bb89-df3a6dffde0e"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"6e946bed-ab05-4d8f-ac55-608a665eeca2"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/DVSEs\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/DVSEs"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/DVSEs.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$19680], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/DVSEs", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4905d7dd-952c-466c-bc7c-8be57e95d82f"]
    }], "AnchorBar",ExpressionUUID->"ab26c696-56e4-4a87-b26d-236788a59070"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"35324334-b594-466d-bb91-3c84a71ad297"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["DVSEs", "ObjectName",ExpressionUUID->
  "c5e71f10-88c0-4ad5-9152-7b3db196da17"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"b5d50c92-bae9-44ae-b932-b1c645374eb8"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "c31f1246-bee1-4534-970e-0132d38523db"]
}], "ObjectNameGrid",ExpressionUUID->"117ab64d-5a5d-4a84-8e80-f7c1f228b414"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["NDVSEs"]],"paclet:ref/NDVSEs"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "7787d3af-c9a2-4a50-a9aa-7f4f6564dcba"],
     "\[LineSeparator]replaces all DV and NDV objects in an expression with \
their standard error."
    }],ExpressionUUID->"86aadd6a-e3ac-492c-90c0-d1e4ca4a0520"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"a0be95eb-a628-4413-8b50-b87278d6a323"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"56f586b5-5544-41b0-bf43-9403982dab72"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "bdc6460f-e4dc-4183-9b28-06e81a818bd2"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->93866474,ExpressionUUID->"bc08f029-922c-47aa-acc2-f23079e02dd4"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "4ad8e6e1-e758-482b-8474-5dd83b5e1e53"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->404095387,ExpressionUUID->"6ab1e7f3-cbee-4d74-ae4f-3dcd527dc08c"],

Cell[TextData[{
 "Define a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "5a825993-9051-4628-ae0c-8b61298fed53"],
 " and get the standard error:"
}], "ExampleText",
 CellID->134214481,ExpressionUUID->"02ec357c-f82a-407f-8a6b-87017a264378"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "=", 
  RowBox[{"NDV", "[", 
   RowBox[{"1", ",", "0.1"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->134684742,ExpressionUUID->"6465121e-f4b7-4ce0-80d5-d928d5b933dc"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "20","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1, 0.1, $CellContext`dv$623594]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->368628967,ExpressionUUID->"4fb0368e-407d-4b27-8b93-aede0bc06804"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVSEs", "[", "v", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->298591856,ExpressionUUID->"003b3f6f-ba41-4f0b-8619-bb0e7bb7cb6e"],

Cell[BoxData["0.1`"], "Output",
 ImageSize->{25, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->438628987,ExpressionUUID->"e47fedd3-4dcd-458d-ba04-56963631283c"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"e755405d-640e-40dc-a2bc-5555d96804af"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"575b466f-596c-437f-ab85-901209246c9c"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"4e6eb70b-9787-4e91-8862-89f5785f3f5c"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVMeans"]],"paclet:DataAnalysis/ref/DVMeans"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"ce2cce89-8ad4-48bb-88ab-d16a59351b15"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"e62a331d-9acd-4cdd-9b46-5be461ea2e09"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  StyleBox[
   TemplateBox[{Cell[
      TextData["DV"]],"paclet:ref/DV"},
    "RefLink",
    BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}], 
   "InlineSeparator"]], "InlineFormula",ExpressionUUID->
  "7179cd56-4a47-464d-af7e-efc88ba0254e"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"7fe2bf26-40d1-4684-a059-97fee7d59329"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"b47dc7e1-80f2-44e8-b6bb-e9f4aca5e48b"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"b149e4c8-9310-469c-88da-985984091569"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"4dc129db-38d4-46f7-8ee1-ef3e33bcfa39"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->643220078,ExpressionUUID->"20f5e593-6935-466e-8de1-32c58297f267"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"88671e9b-059e-43a5-9eda-9b7cbe2d3cc6"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DVSEs",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 24.7129548}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "NDVSEs[expr] replaces all DV and NDV objects in an expression with their \
standard error.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "DVSEs", 
    "titlemodifier" -> "", "windowtitle" -> "DVSEs", "type" -> "Symbol", 
    "uri" -> "DataAnalysis/ref/DVSEs"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5978, 154, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"bc08f029-922c-47aa-acc2-f23079e02dd4",
   CellTags->"PrimaryExamplesSection",
   CellID->93866474]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12519, 350}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[577, 21, 4230, 95, 55, "AnchorBarGrid",ExpressionUUID->"35324334-b594-466d-bb91-3c84a71ad297",
 CellID->1],
Cell[CellGroupData[{
Cell[4832, 120, 390, 9, 52, "ObjectNameGrid",ExpressionUUID->"117ab64d-5a5d-4a84-8e80-f7c1f228b414"],
Cell[5225, 131, 716, 18, 111, "Usage",ExpressionUUID->"a0be95eb-a628-4413-8b50-b87278d6a323"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5978, 154, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"bc08f029-922c-47aa-acc2-f23079e02dd4",
 CellTags->"PrimaryExamplesSection",
 CellID->93866474],
Cell[CellGroupData[{
Cell[6437, 169, 308, 7, 29, "ExampleSection",ExpressionUUID->"6ab1e7f3-cbee-4d74-ae4f-3dcd527dc08c",
 CellID->404095387],
Cell[6748, 178, 370, 10, 39, "ExampleText",ExpressionUUID->"02ec357c-f82a-407f-8a6b-87017a264378",
 CellID->134214481],
Cell[CellGroupData[{
Cell[7143, 192, 203, 5, 26, "Input",ExpressionUUID->"6465121e-f4b7-4ce0-80d5-d928d5b933dc",
 CellID->134684742],
Cell[7349, 199, 566, 15, 35, "Output",ExpressionUUID->"4fb0368e-407d-4b27-8b93-aede0bc06804",
 CellID->368628967]
}, Open  ]],
Cell[CellGroupData[{
Cell[7952, 219, 156, 3, 26, "Input",ExpressionUUID->"003b3f6f-ba41-4f0b-8619-bb0e7bb7cb6e",
 CellID->298591856],
Cell[8111, 224, 216, 5, 35, "Output",ExpressionUUID->"e47fedd3-4dcd-458d-ba04-56963631283c",
 CellID->438628987]
}, Open  ]]
}, Open  ]],
Cell[8354, 233, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"e755405d-640e-40dc-a2bc-5555d96804af"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8477, 238, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"4e6eb70b-9787-4e91-8862-89f5785f3f5c",
 CellID->1255426704],
Cell[8740, 247, 1095, 30, 24, "SeeAlso",ExpressionUUID->"7fe2bf26-40d1-4684-a059-97fee7d59329",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[9872, 282, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"b149e4c8-9310-469c-88da-985984091569",
 CellID->38303248],
Cell[10141, 291, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"4dc129db-38d4-46f7-8ee1-ef3e33bcfa39"],
Cell[10230, 293, 247, 6, 24, "MoreAbout",ExpressionUUID->"20f5e593-6935-466e-8de1-32c58297f267",
 CellID->643220078]
}, Open  ]],
Cell[10492, 302, 78, 0, 41, "FooterCell",ExpressionUUID->"88671e9b-059e-43a5-9eda-9b7cbe2d3cc6"]
}
]
*)

(* End of internal cache information *)

