(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     91289,       1984]
NotebookOptionsPosition[     84746,       1848]
NotebookOutlinePosition[     87682,       1915]
CellTagsIndexPosition[     87596,       1910]
WindowTitle->EffectiveVarianceFit
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "d2b73c8d-348b-4753-8ede-c7c0d5d9cc12"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"fb5ae6dd-48a0-4227-913b-75963140d82c"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataTable\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DataTable"], "\<\"NDV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/NDV"], "\<\"DV\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/DV"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "28bbbc6a-0655-4161-899e-9005d456ebab"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"4deb5e47-da0d-4f63-9793-3476da90ad66"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "2fb5eaf7-6323-4eb0-a7e2-88a07ca06ded"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"6b744d52-9400-4745-901c-3a5546a11d46"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"DataAnalysis/ref/EffectiveVarianceFit\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/EffectiveVarianceFit"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
EffectiveVarianceFit.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$20230], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/EffectiveVarianceFit", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "10b1eb0f-0a56-420e-b19a-d64183e9c9eb"]
    }], "AnchorBar",ExpressionUUID->"b451e014-caf5-48ef-9971-02e79944908f"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"382bb25d-d322-40fc-b87f-e58c4e4be77a"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["EffectiveVarianceFit", "ObjectName",ExpressionUUID->
  "ef552ea6-a383-4df2-9c9a-06ee0e3d5bec"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"e0201b40-49c3-4862-b484-adf616273908"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "beacd3cf-8759-453b-800d-2e62b4c13acc"]
}], "ObjectNameGrid",ExpressionUUID->"a30e9a21-4dfb-4fad-8cec-6b1959e1576c"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"EffectiveVarianceFit", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["x", "TI"], "11"], ",", 
            SubscriptBox[
             StyleBox["x", "TI"], "12"], ",", "\[Ellipsis]", ",", 
            SubscriptBox[
             StyleBox["y", "TI"], "1"]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["x", "TI"], "21"], ",", 
            SubscriptBox[
             StyleBox["x", "TI"], "22"], ",", "\[Ellipsis]", ",", 
            SubscriptBox[
             StyleBox["y", "TI"], "2"]}], "}"}], ",", "\[Ellipsis]"}], "}"}], 
        ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             StyleBox["s", "TI"], 
             SubscriptBox[
              StyleBox["x", "TI"], "11"]}], ",", 
            RowBox[{
             StyleBox["s", "TI"], 
             SubscriptBox[
              StyleBox["x", "TI"], "12"]}], ",", "\[Ellipsis]", ",", 
            RowBox[{
             StyleBox["s", "TI"], 
             SubscriptBox[
              StyleBox["y", "TI"], "1"]}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             StyleBox["s", "TI"], 
             SubscriptBox[
              StyleBox["x", "TI"], "21"]}], ",", 
            RowBox[{
             StyleBox["s", "TI"], 
             SubscriptBox[
              StyleBox["x", "TI"], "22"]}], ",", "\[Ellipsis]", ",", 
            RowBox[{
             StyleBox["s", "TI"], 
             SubscriptBox[
              StyleBox["y", "TI"], "2"]}]}], "}"}], ",", "\[Ellipsis]"}], 
         "}"}], ",", 
        StyleBox["form", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[Beta]", "TR"], "1"], ",", "\[Ellipsis]"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["x", "TI"], "1"], ",", "\[Ellipsis]"}], "}"}], ",", 
        StyleBox["i", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "a8989c24-d80f-4801-a512-84ab83913b90"],
     "\[LineSeparator]constructs a nonlinear model with structure form where \
form depends on variables ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula",ExpressionUUID->
      "b9359a7b-ca01-4f78-a903-7c022b540dc8"],
     " using the parameters ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["\[Beta]", "TR"], 
       StyleBox["i", "TI"]]], "InlineFormula",ExpressionUUID->
      "23ac6837-1faf-44cb-89a8-5348ae3f7402"],
     ". An effective variance technique is used to fit the data using errors ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["sx", "TI"], 
       StyleBox["ij", "TI"]]], "InlineFormula",ExpressionUUID->
      "cd78aedd-94a9-4497-b93b-3356f06636fd"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["sy", "TI"], 
       StyleBox["j", "TI"]]], "InlineFormula",ExpressionUUID->
      "77f1da36-15e5-4cec-b6b9-a41c03968a6f"],
     " in the data points ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["ij", "TI"]]], "InlineFormula",ExpressionUUID->
      "90b2e2da-513b-419a-b555-7d099efadd24"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["y", "TI"], 
       StyleBox["j", "TI"]]], "InlineFormula",ExpressionUUID->
      "39b930a4-96f5-418e-90ad-7b7d9a88e680"],
     " using i iterations."
    }],ExpressionUUID->"26a1b8a1-9ded-4cb0-b36e-70a0108188ff"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"EffectiveVarianceFit", "[", 
       RowBox[{
        StyleBox["datatable", "TI"], ",", 
        StyleBox["form", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[Beta]", "TR"], "1"], ",", "\[Ellipsis]"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["x", "TI"], "1"], ",", "\[Ellipsis]"}], "}"}], ",", 
        StyleBox["i", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "d9329b5e-2988-4a35-ab20-affe168b1375"],
     "\[LineSeparator]constructs a nonlinear model with structure form where \
form depends on variables ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula",ExpressionUUID->
      "bfbe811b-5238-4ec1-b4ed-b15185ce6fcd"],
     " using the parameters ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["\[Beta]", "TR"], 
       StyleBox["i", "TI"]]], "InlineFormula",ExpressionUUID->
      "00dfcaad-e828-447e-9abe-88815339ae74"],
     ". An effective variance technique is used to fit the values and errors \
in the DataTable using i iterations."
    }],ExpressionUUID->"873c2a0e-b58d-44a7-8789-bb7ac308ec0b"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"a418dc0f-5388-47e0-bbc3-a0d3f0bf95bc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"7c92e9f4-450f-44aa-9e34-a738113375db"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"bd9f182c-c965-4565-9211-30ba1137ba01"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"4059ab1f-7525-4c07-90ec-471374958ebe"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->169435747,ExpressionUUID->"1a98368f-46a4-42ae-8025-e77e34bd287a"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"91a405a1-d35a-4a84-afd1-e2fd307ad398"],

Cell[TextData[{
 "The EffectiveVarianceFit accounts for uncertainties in both the variables ",
 Cell[BoxData[
  SubscriptBox["x", "i"]], "InlineFormula",ExpressionUUID->
  "8d638099-4959-4855-a359-138ab38d6891"],
 " and ",
 Cell[BoxData[
  SubscriptBox["y", "i"]], "InlineFormula",ExpressionUUID->
  "d67060e9-2a78-4ae4-8f96-05cf5145136c"],
 " using an effective variance technique, which is calculating the weights \
and variances of each data point by including the partial derivaties function \
with respect to each variable, and iteratively calculating the resulting fit."
}], "Notes",
 CellID->734614449,ExpressionUUID->"c3f7ad9e-0965-4d2d-bd87-1c3a68a9e5e4"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["EffectiveVarianceFit"]],
    "paclet:DataAnalysis/ref/EffectiveVarianceFit"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "00e6d03d-9f5a-4565-9d02-2c82a047c650"],
 " takes the same options as ",
 ButtonBox["NonlinearModelFit",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NonlinearModelFit"],
 ". "
}], "Notes",ExpressionUUID->"79cfe83c-663f-4a08-8d1f-e3a137ccdc22"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"09d017ef-21e7-4fee-a6d0-000d05401f23"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"5553d416-3198-4844-80f2-1fb1e5f61d44"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "ba374abd-2c6c-48a1-94f7-a134d1330cc6"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->73724447,ExpressionUUID->"a2c39a21-8ca6-44e5-a545-8c01a4d692c5"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "50e0fcc8-e340-4895-800b-92e4daa6eac9"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->31283084,ExpressionUUID->"99dc3cd6-6b1f-4393-81fb-68f964dfda60"],

Cell["Define some data:", "ExampleText",
 CellID->463959237,ExpressionUUID->"dc950bfe-10f6-4558-87d9-c321d7527ccf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<ID\>\"", ",", "\"\<a\>\"", ",", "\"\<b\>\"", ",", "\"\<c\>\""}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.05"}], "]"}], ",", "2", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.7"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<l\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.3"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"6", ",", "0.2"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<m\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"7", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"8", ",", "0.1"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.9"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<n\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1.5", ",", "0.8"}], "]"}], ",", "8", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
    "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->894023881,ExpressionUUID->"f4789f67-bccf-4559-a218-6a4ded76ab61"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$683027], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$683028]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$683029], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$683030], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$683031]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$683032], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$683033], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$683034]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$683035], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$683036]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 46355713011586]]]]], Appearance -> Automatic,
         Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$683027], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$683028]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$683029], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$683030], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$683031]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$683032], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$683033], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$683034]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$683035], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$683036]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 46355713011586]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$683027], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$683028]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$683029], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$683030], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$683031]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$683032], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$683033], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$683034]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$683035], 
                 "b" -> 8, "c" -> 
                 DataAnalysis`NDV[4, 0.2, $CellContext`dv$683036]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 46355713011586]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$683027], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$683028]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$683029], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$683030], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$683031]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$683032], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$683033], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$683034]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$683035], 
                 "b" -> 8, "c" -> 
                 DataAnalysis`NDV[4, 0.2, $CellContext`dv$683036]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 46355713011586]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[32]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`UnknownShape, "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 4, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[2074850353], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[2074850353]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][{
                    All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][{
                    All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][{
                    All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.000\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "98", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.05, $CellContext`dv$683027]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.0\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "14", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.7, $CellContext`dv$683028]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.3, $CellContext`dv$683029]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.2, $CellContext`dv$683030]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"6.00\"", 6., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[6, 0.2, $CellContext`dv$683031]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"7.00\"", 7., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[7, 0.2, $CellContext`dv$683032]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"8.00\"", 8., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[8, 0.1, $CellContext`dv$683033]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.0\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.9, $CellContext`dv$683034]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$683035]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.2, $CellContext`dv$683036]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    620539428][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 620539428]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[620539428][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[620539428][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {267., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->585691218,ExpressionUUID->"385ff32d-3390-46e9-9ea7-a1ef07fdb647"]
}, Open  ]],

Cell["Calculate the effective variance fit:", "ExampleText",
 CellID->229498877,ExpressionUUID->"d0d268cc-577f-41b8-9f85-ec55f1fe81c6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"evFit", "=", 
  RowBox[{"EffectiveVarianceFit", "[", 
   RowBox[{
    RowBox[{"tbl", "[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"\"\<a\>\"", "^", "2"}], "*", "x"}], "+", 
     RowBox[{"\"\<a\>\"", "*", "y"}], "+", "z"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", 
    RowBox[{"{", "\"\<a\>\"", "}"}], ",", "5"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->199529541,ExpressionUUID->"58c183ee-d68e-4a08-a362-e87334810478"],

Cell[BoxData[
 TagBox[
  RowBox[{"FittedModel", "[", 
   TagBox[
    PanelBox[
     TagBox[
      RowBox[{
       RowBox[{"-", "1.7237209772845679`"}], "+", 
       RowBox[{"3.2369725008181036`", " ", 
        RowBox[{"VarKey", "[", "\<\"a\"\>", "]"}]}], "-", 
       RowBox[{"0.32580990579558483`", " ", 
        SuperscriptBox[
         RowBox[{"VarKey", "[", "\<\"a\"\>", "]"}], "2"]}]}],
      Short[#, 2]& ],
     FrameMargins->5],
    Editable -> False], "]"}],
  InterpretTemplate[
  FittedModel[{
    "Nonlinear", {$CellContext`x -> -0.32580990579558483`, $CellContext`y -> 
      3.2369725008181036`, $CellContext`z -> -1.7237209772845679`}, {{
       DataAnalysis`VarKey["a"]}, $CellContext`z + $CellContext`y 
       DataAnalysis`VarKey["a"] + $CellContext`x 
       DataAnalysis`VarKey["a"]^2}}, {{1.9735300567983292`, 
    13.199074761963628`, 1.1361669832810302`, 
    0.3024109493854418}}, {{1, 1}, {4, 6}, {7, 5}, {1.5, 4}}, 
    Function[Null, 
     Internal`LocalizedBlock[{$CellContext`x, $CellContext`y, $CellContext`z, 
       DataAnalysis`VarKey["a"]}, #], {HoldAll}], 
    VarianceEstimatorFunction -> (1& )]& ],
  Editable->False,
  SelectWithContents->True,
  Selectable->True]], "Output",
 ImageSize->{363, 36},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->129259251,ExpressionUUID->"6a6dbe0e-4067-4300-b3b1-61eba69225ed"]
}, Open  ]],

Cell[TextData[{
 "Compare to a ",
 ButtonBox["NonlinearModelFit",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NonlinearModelFit"],
 ":"
}], "ExampleText",
 CellID->288411735,ExpressionUUID->"ba07b0eb-1032-4d4e-96b5-b1979c8058a2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit", "=", 
  RowBox[{"NonlinearModelFit", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"tbl", "[", 
       RowBox[{"All", ",", 
        RowBox[{"{", 
         RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], "//", 
      "NV"}], "//", "DVMeans"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"a", "^", "2"}], "*", "x"}], "+", 
     RowBox[{"a", "*", "y"}], "+", "z"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", 
    RowBox[{"{", "a", "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->154859377,ExpressionUUID->"b01fb97f-13af-4fe4-ade1-c4f5f61c68b9"],

Cell[BoxData[
 TagBox[
  RowBox[{"FittedModel", "[", 
   TagBox[
    PanelBox[
     TagBox[
      RowBox[{
       RowBox[{"-", "1.0268410185822439`"}], "+", 
       RowBox[{"3.150263821977517`", " ", "a"}], "-", 
       RowBox[{"0.32851571461344325`", " ", 
        SuperscriptBox["a", "2"]}]}],
      Short[#, 2]& ],
     FrameMargins->5],
    Editable -> False], "]"}],
  InterpretTemplate[
  FittedModel[{
    "Nonlinear", {$CellContext`x -> -0.32851571461344325`, $CellContext`y -> 
      3.150263821977517, $CellContext`z -> -1.0268410185822439`}, \
{{$CellContext`a}, $CellContext`a^2 $CellContext`x + $CellContext`a \
$CellContext`y + $CellContext`z}}, {1}, {{1, 1}, {4, 6}, {7, 5}, {1.5, 4}}, 
    Function[Null, 
     Internal`LocalizedBlock[{$CellContext`a, $CellContext`x, $CellContext`y, \
$CellContext`z}, #], {HoldAll}]]& ],
  Editable->False,
  SelectWithContents->True,
  Selectable->True]], "Output",
 ImageSize->{285, 36},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->64105268,ExpressionUUID->"29819926-3156-419b-a337-bcd457980be7"]
}, Open  ]],

Cell["Plot the results:", "ExampleText",
 CellID->211834863,ExpressionUUID->"fdff38cf-3629-4b6d-b1c7-9c218054945d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DTPlot", "[", 
    RowBox[{
     RowBox[{"tbl", "[", 
      RowBox[{"All", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{"PlotRangePadding", "\[Rule]", "0.8"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"evFit", "[", "a", "]"}], ",", 
       RowBox[{"fit", "[", "a", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "0", ",", "10"}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->327209677,ExpressionUUID->"7dc16d52-3d3d-4de5-afe7-7b813875fa4e"],

Cell[BoxData[
 GraphicsBox[{{{}, {{{}, 
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.012833333333333334`], AbsoluteThickness[1.6], 
       PointBox[{{1., 1.}, {4., 6.}, {7., 5.}, {1.5, 4.}}], {{
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{1.0979981992270027`, 1.}, {0.9020018007729973, 1.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {1.0979981992270027`, 1.}], 
            Offset[{0, -1.5}, {1.0979981992270027`, 1.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {0.9020018007729973, 1.}], 
            Offset[{0, -1.5}, {0.9020018007729973, 1.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{1., 2.371974789178038}, {1., -0.37197478917803783`}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {1., 2.371974789178038}], 
            Offset[{-1.5, 0}, {1., 2.371974789178038}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {1., -0.37197478917803783`}], 
            Offset[{-1.5, 0}, {1., -0.37197478917803783`}]}]}}, {
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{4.587989195362017, 6.}, {3.412010804637984, 6.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {4.587989195362017, 6.}], 
            Offset[{0, -1.5}, {4.587989195362017, 6.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {3.412010804637984, 6.}], 
            Offset[{0, -1.5}, {3.412010804637984, 6.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{4., 6.391992796908011}, {4., 5.608007203091989}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {4., 6.391992796908011}], 
            Offset[{-1.5, 0}, {4., 6.391992796908011}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {4., 5.608007203091989}], 
            Offset[{-1.5, 0}, {4., 5.608007203091989}]}]}}, {
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{7.391992796908011, 5.}, {6.608007203091989, 5.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {7.391992796908011, 5.}], 
            Offset[{0, -1.5}, {7.391992796908011, 5.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {6.608007203091989, 5.}], 
            Offset[{0, -1.5}, {6.608007203091989, 5.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{7., 6.763967586086048}, {7., 3.2360324139139514`}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {7., 6.763967586086048}], 
            Offset[{-1.5, 0}, {7., 6.763967586086048}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {7., 3.2360324139139514`}], 
            Offset[{-1.5, 0}, {7., 3.2360324139139514`}]}]}}, {
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{3.0679711876320432`, 4.}, {-0.06797118763204324, 4.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {3.0679711876320432`, 4.}], 
            Offset[{0, -1.5}, {3.0679711876320432`, 4.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {-0.06797118763204324, 4.}], 
            Offset[{0, -1.5}, {-0.06797118763204324, 4.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{1.5, 4.391992796908011}, {1.5, 3.608007203091989}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {1.5, 4.391992796908011}], 
            Offset[{-1.5, 0}, {1.5, 4.391992796908011}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {1.5, 3.608007203091989}], 
            Offset[{-1.5, 0}, {1.5, 3.608007203091989}]}]}}}}, {}}, {
      TagBox[
       TooltipBox[
        {Opacity[0.], PointBox[{{1., 1.}}], {
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{1.0979981992270027`, 1.}, {0.9020018007729973, 1.}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {1.0979981992270027`, 1.}], 
             Offset[{0, -1.5}, {1.0979981992270027`, 1.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {0.9020018007729973, 1.}], 
             Offset[{0, -1.5}, {0.9020018007729973, 1.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{1., 2.371974789178038}, {1., -0.37197478917803783`}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {1., 2.371974789178038}], 
             Offset[{-1.5, 0}, {1., 2.371974789178038}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {1., -0.37197478917803783`}], 
             Offset[{-1.5, 0}, {1., -0.37197478917803783`}]}]}}},
        "\"k {1.000(98), 1.0(14)}\"",
        TooltipStyle->"TextStyling"],
       Annotation[#, "k {1.000(98), 1.0(14)}", "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {Opacity[0.], PointBox[{{4., 6.}}], {
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{4.587989195362017, 6.}, {3.412010804637984, 6.}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {4.587989195362017, 6.}], 
             Offset[{0, -1.5}, {4.587989195362017, 6.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {3.412010804637984, 6.}], 
             Offset[{0, -1.5}, {3.412010804637984, 6.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{4., 6.391992796908011}, {4., 5.608007203091989}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {4., 6.391992796908011}], 
             Offset[{-1.5, 0}, {4., 6.391992796908011}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {4., 5.608007203091989}], 
             Offset[{-1.5, 0}, {4., 5.608007203091989}]}]}}},
        "\"l {4.00(59), 6.00(39)}\"",
        TooltipStyle->"TextStyling"],
       Annotation[#, "l {4.00(59), 6.00(39)}", "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {Opacity[0.], PointBox[{{7., 5.}}], {
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{7.391992796908011, 5.}, {6.608007203091989, 5.}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {7.391992796908011, 5.}], 
             Offset[{0, -1.5}, {7.391992796908011, 5.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {6.608007203091989, 5.}], 
             Offset[{0, -1.5}, {6.608007203091989, 5.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{7., 6.763967586086048}, {7., 3.2360324139139514`}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {7., 6.763967586086048}], 
             Offset[{-1.5, 0}, {7., 6.763967586086048}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {7., 3.2360324139139514`}], 
             Offset[{-1.5, 0}, {7., 3.2360324139139514`}]}]}}},
        "\"m {7.00(39), 5.0(18)}\"",
        TooltipStyle->"TextStyling"],
       Annotation[#, "m {7.00(39), 5.0(18)}", "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {Opacity[0.], PointBox[{{1.5, 4.}}], {
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{3.0679711876320432`, 4.}, {-0.06797118763204324, 4.}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {3.0679711876320432`, 4.}], 
             Offset[{0, -1.5}, {3.0679711876320432`, 4.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {-0.06797118763204324, 4.}], 
             Offset[{0, -1.5}, {-0.06797118763204324, 4.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{1.5, 4.391992796908011}, {1.5, 3.608007203091989}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {1.5, 4.391992796908011}], 
             Offset[{-1.5, 0}, {1.5, 4.391992796908011}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {1.5, 3.608007203091989}], 
             Offset[{-1.5, 0}, {1.5, 3.608007203091989}]}]}}},
        "\"n {1.5(16), 4.00(39)}\"",
        TooltipStyle->"TextStyling"],
       Annotation[#, "n {1.5(16), 4.00(39)}", 
        "Tooltip"]& ]}}, {}, {}, {}, {}}, {{{}, {}, 
     TagBox[
      {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
       Opacity[1.], LineBox[CompressedData["
1:eJwV13k4FV0YAHBblPXeO3eZq2xRhIRUStw3lSgKJVJZk30pRChSklRkVxRR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        "]]},
      Annotation[#, "Charting`Private`Tag$729579#1"]& ], 
     TagBox[
      {RGBColor[0.880722, 0.611041, 0.142051], AbsoluteThickness[1.6], 
       Opacity[1.], LineBox[CompressedData["
1:eJwV13k8VHsUAPCxhKwzc8fM3CnrFJLQ8kpRc5RKUqGUiPCE7LIkqTxZUlmS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        "]]},
      Annotation[#, "Charting`Private`Tag$729579#2"]& ]}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{0.23799999999999996`, 0.23299999999999996`},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"c\"", TraditionalForm], None}, {
     FormBox["\"a\"", TraditionalForm], None}},
  FrameStyle->GrayLevel[0],
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  FrameTicksStyle->12,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->500,
  LabelStyle->12,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{1., 7.}, {1., 6.}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0.8, 0.8}, {0.8, 0.8}},
  Ticks->{Automatic, Automatic}]], "Output",
 ImageSize->{504, 329},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->64525122,ExpressionUUID->"b9de1017-25df-4fc1-b423-a30e4e88c536"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"d46e2ce3-1289-41fa-a575-59cb961cb235"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"9ec54304-b793-46cb-8fb6-cd7c9fa53414"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"79c0b7ba-2cbf-4024-a1a0-30bab484e206"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"8f7632ca-6c8a-4a1c-bf93-f017d6a90385"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"08fabb1c-4f48-49c8-b636-33db758f2952"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"11744460-8f58-4be8-9856-d535fe0bb736"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"9be62e97-6544-4c59-a09a-92b1fa21e7f1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"4e73fd87-e36e-4586-8988-eed6444b4619"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"53bfb291-a9a2-48d5-8c5e-da6b86e2e0b6"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"25887dc3-ce4b-4454-912f-08cb1a17b961"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->170995539,ExpressionUUID->"c11bfc13-8af7-4ef4-9a23-982a48f94224"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"a47f744b-9585-47a1-9552-65e6f080e1d5"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"EffectiveVarianceFit",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 26.5686098}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "EffectiveVarianceFit[{{x11, x12, ..., y1}, {x21, x22, ..., y2}, ...}, \
{{s x11, s x12, ..., s y1}, {s x21, s x22, ..., s y2}, ...}, form, \
{\\[Beta]1, ...}, {x1, \\ ...}, i] constructs a nonlinear model with \
structure form where form depends on variables xi using the parameters \
\\[Beta]i. An effective variance technique is used to fit the data using \
errors sxij and syj in the data points xij and yj using i iterations. \
EffectiveVarianceFit[datatable, form, {\\[Beta]1, ...}, {x1, \\ ...}, i] \
constructs a nonlinear model with structure form where form depends on \
variables xi using the parameters \\[Beta]i. An effective variance technique \
is used to fit the values and errors in the DataTable using i iterations.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "EffectiveVarianceFit", 
    "titlemodifier" -> "", "windowtitle" -> "EffectiveVarianceFit", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/EffectiveVarianceFit"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[12780, 340, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"a2c39a21-8ca6-44e5-a545-8c01a4d692c5",
   CellTags->"PrimaryExamplesSection",
   CellID->73724447]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 87398, 1903}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 4332, 97, 55, "AnchorBarGrid",ExpressionUUID->"382bb25d-d322-40fc-b87f-e58c4e4be77a",
 CellID->1],
Cell[CellGroupData[{
Cell[4949, 122, 405, 9, 52, "ObjectNameGrid",ExpressionUUID->"a30e9a21-4dfb-4fad-8cec-6b1959e1576c"],
Cell[5357, 133, 5171, 142, 270, "Usage",ExpressionUUID->"a418dc0f-5388-47e0-bbc3-a0d3f0bf95bc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10565, 280, 855, 21, 37, "NotesSection",ExpressionUUID->"1a98368f-46a4-42ae-8025-e77e34bd287a",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->169435747],
Cell[11423, 303, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"91a405a1-d35a-4a84-afd1-e2fd307ad398"],
Cell[11512, 305, 664, 13, 70, "Notes",ExpressionUUID->"c3f7ad9e-0965-4d2d-bd87-1c3a68a9e5e4",
 CellID->734614449],
Cell[12179, 320, 475, 13, 70, "Notes",ExpressionUUID->"79cfe83c-663f-4a08-8d1f-e3a137ccdc22"],
Cell[12657, 335, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"09d017ef-21e7-4fee-a6d0-000d05401f23"]
}, Closed]],
Cell[CellGroupData[{
Cell[12780, 340, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"a2c39a21-8ca6-44e5-a545-8c01a4d692c5",
 CellTags->"PrimaryExamplesSection",
 CellID->73724447],
Cell[CellGroupData[{
Cell[13239, 355, 307, 7, 29, "ExampleSection",ExpressionUUID->"99dc3cd6-6b1f-4393-81fb-68f964dfda60",
 CellID->31283084],
Cell[13549, 364, 115, 1, 38, "ExampleText",ExpressionUUID->"dc950bfe-10f6-4558-87d9-c321d7527ccf",
 CellID->463959237],
Cell[CellGroupData[{
Cell[13689, 369, 1514, 39, 123, "Input",ExpressionUUID->"f4789f67-bccf-4559-a218-6a4ded76ab61",
 CellID->894023881],
Cell[15206, 410, 39882, 786, 197, "Output",ExpressionUUID->"385ff32d-3390-46e9-9ea7-a1ef07fdb647",
 CellID->585691218]
}, Open  ]],
Cell[55103, 1199, 135, 1, 70, "ExampleText",ExpressionUUID->"d0d268cc-577f-41b8-9f85-ec55f1fe81c6",
 CellID->229498877],
Cell[CellGroupData[{
Cell[55263, 1204, 607, 16, 70, "Input",ExpressionUUID->"58c183ee-d68e-4a08-a362-e87334810478",
 CellID->199529541],
Cell[55873, 1222, 1400, 36, 57, "Output",ExpressionUUID->"6a6dbe0e-4067-4300-b3b1-61eba69225ed",
 CellID->129259251]
}, Open  ]],
Cell[57288, 1261, 232, 7, 70, "ExampleText",ExpressionUUID->"ba07b0eb-1032-4d4e-96b5-b1979c8058a2",
 CellID->288411735],
Cell[CellGroupData[{
Cell[57545, 1272, 643, 19, 70, "Input",ExpressionUUID->"b01fb97f-13af-4fe4-ade1-c4f5f61c68b9",
 CellID->154859377],
Cell[58191, 1293, 1102, 30, 57, "Output",ExpressionUUID->"29819926-3156-419b-a337-bcd457980be7",
 CellID->64105268]
}, Open  ]],
Cell[59308, 1326, 115, 1, 70, "ExampleText",ExpressionUUID->"fdff38cf-3629-4b6d-b1c7-9c218054945d",
 CellID->211834863],
Cell[CellGroupData[{
Cell[59448, 1331, 795, 22, 70, "Input",ExpressionUUID->"7dc16d52-3d3d-4de5-afe7-7b813875fa4e",
 CellID->327209677],
Cell[60246, 1355, 22276, 420, 70, "Output",ExpressionUUID->"b9de1017-25df-4fc1-b423-a30e4e88c536",
 CellID->64525122]
}, Open  ]]
}, Open  ]],
Cell[82549, 1779, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"d46e2ce3-1289-41fa-a575-59cb961cb235"]
}, Open  ]],
Cell[CellGroupData[{
Cell[82672, 1784, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"79c0b7ba-2cbf-4024-a1a0-30bab484e206",
 CellID->1255426704],
Cell[82935, 1793, 1072, 28, 70, "SeeAlso",ExpressionUUID->"9be62e97-6544-4c59-a09a-92b1fa21e7f1",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[84044, 1826, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"53bfb291-a9a2-48d5-8c5e-da6b86e2e0b6",
 CellID->38303248],
Cell[84313, 1835, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"25887dc3-ce4b-4454-912f-08cb1a17b961"],
Cell[84402, 1837, 247, 6, 70, "MoreAbout",ExpressionUUID->"c11bfc13-8af7-4ef4-9a23-982a48f94224",
 CellID->170995539]
}, Open  ]],
Cell[84664, 1846, 78, 0, 70, "FooterCell",ExpressionUUID->"a47f744b-9585-47a1-9552-65e6f080e1d5"]
}
]
*)

(* End of internal cache information *)

