(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    130221,       2665]
NotebookOptionsPosition[    120698,       2462]
NotebookOutlinePosition[    123989,       2541]
CellTagsIndexPosition[    123865,       2535]
WindowTitle->Fig
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "27196bdc-96fa-4f4c-9b50-413e646c6c03"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"54ba0e13-5d74-43e6-b630-644319486a8c"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"FigGrid\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/FigGrid"], "\<\"SciDrawPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SciDrawPlot"], "\<\"DTPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DTPlot"], "\<\"DataTable\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/DataTable"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "92356ffb-b476-427d-a111-e9577a2ec265"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"641ec3fc-eb7f-4a90-8989-8df12e300a0e"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "f4322d0c-3dc0-49ee-8d02-181996be4d2a"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"84c4c8eb-57c6-4e90-b88a-6d68d42697ed"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/Fig\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/Fig"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/Fig.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$22151], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/Fig", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "91f71192-74e6-48ca-a283-7563996824ce"]
    }], "AnchorBar",ExpressionUUID->"48a5d879-1fb8-4470-a392-f3e8f07d15b2"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"6a28e21b-bed9-4818-a188-b09453bd293f"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["Fig", "ObjectName",ExpressionUUID->
  "33aa6b48-d099-4d36-a8e3-458820eb0d6b"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"5d2a4b76-c990-4962-bcd1-53efc5c67391"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "bc50892f-ea5f-41c1-87f5-f253399fb1fe"]
}], "ObjectNameGrid",ExpressionUUID->"8b213f92-af9c-4fd0-877e-44bc57e4f322"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Fig", "[", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox[
          StyleBox["object", "TI"], "1"], ",", 
         SubscriptBox[
          StyleBox["object", "TI"], "2"], ",", "..."}], "}"}], "]"}]], 
      "InlineFormula",ExpressionUUID->"0cf452c9-eedc-43f1-9aec-25b212e58471"],
     "\[LineSeparator]returns a figure with plots of the objects using the ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["SciDraw"]],"https://scidraw.nd.edu/"},
       "WebLink",
       BaseStyle->{"Usage"}]],ExpressionUUID->
      "3a1095ca-b4f6-4939-af3e-5f6a22b65b9c"],
     " package. The objects can be of the type ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "274aa713-0cb8-4813-8b10-6e04dfc197ad"],
     " or ",
     ButtonBox["Graphics",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/Graphics"],
     "."
    }],ExpressionUUID->"8fc80206-07e0-420a-b5cb-bffd971d501d"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"14d86925-7e12-462b-861f-f0c452acf46a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"fece7509-bf17-4c69-a6f2-4c4c9d5bf75f"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"d9806423-513b-4f44-958f-64c15d8b97e1"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"8fff85fc-3a68-41ab-b4cc-06ce769b2343"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->501205,ExpressionUUID->"eddb6daf-1fa0-44e1-90cd-e4c3bcbfc423"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"efcee426-be42-49b1-88dc-fd3bd8dbed99"],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Fig"]],"paclet:DataAnalysis/ref/Fig"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "72fa3000-d757-4d74-be44-45c73764547c"],
 " requires that the SciDraw package, created by Mark A. Caprio, University \
of Notre Dame, is installed. The package can be downloaded at ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["https://scidraw.nd.edu/."]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "ff12a1ca-e45a-42f4-969a-a0b07826ce59"]
}], "Notes",
 CellID->632098388,ExpressionUUID->"14e4e601-2220-4f07-b3a2-7a511151e3a4"],

Cell["\<\
The SciDraw package allows the preparation of publication-quality scientific \
figures.\
\>", "Notes",
 CellID->153014549,ExpressionUUID->"addd61c6-6ce9-4f18-b4aa-f65c5897cd1f"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Fig"]],"paclet:DataAnalysis/ref/Fig"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "28b67419-acd0-4a6a-b20f-5ce0a541bc72"],
 " function automatically produces simple figures with SciDraw, and styling \
options are limited."
}], "Notes",
 CellID->35843090,ExpressionUUID->"c0e54a83-24de-4797-acc7-d472c6c72528"],

Cell[TextData[{
 "More flexibility can be achieved using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDrawPlot"]],"paclet:DataAnalysis/ref/SciDrawPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "450236e3-539d-4535-9dec-9404ac88da0d"],
 " function, which is produces a DataPlot object which can be included into \
complex SciDraw figures."
}], "Notes",
 CellID->329613761,ExpressionUUID->"c7641721-3bc9-4aee-b02b-4ab26b45b5c5"],

Cell[TextData[{
 "Figure grids can be created using the ",
 ButtonBox["FigGrid",
  BaseStyle->"Link",
  ButtonData->"paclet:DataAnalysis/ref/FigGrid"],
 " function."
}], "Notes",
 CellID->57211090,ExpressionUUID->"7e7726fd-e27f-457b-b47d-447c081b40b1"],

Cell[TextData[{
 "For simple figures, the Mathematica plotting system can be used with the \
function ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DTPlot"]],"paclet:DataAnalysis/ref/DTPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "4fcff4ce-4650-4de2-930b-da541f3e43d8"],
 "."
}], "Notes",
 CellID->120633291,ExpressionUUID->"711dc38d-ddd8-4469-a500-dee8f28e1488"],

Cell[TextData[{
 ButtonBox["Fig",
  BaseStyle->"Link",
  ButtonData->"paclet:DataAnalysis/ref/Fig"],
 " takes the same options as Figure, FigurePanel and DataPlot (from the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDraw"]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "27d287d8-0f76-4a8c-b934-5bad0c2524b6"],
 " package) with the following additions: "
}], "Notes",ExpressionUUID->"e0c52658-4fc2-4749-b071-60abdbf99cd5"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "1c729845-116c-4c65-8e97-faad3d0af2b0"], 
    ButtonBox["ShowLegend",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/ShowLegend"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "Specifies if a plot legend should be shown", "TableText",ExpressionUUID->
     "3a8e7f89-40e8-4c85-906f-fb32fbfe8501"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "70395af1-f362-4990-a933-8066c12473d3"], 
    ButtonBox["XLogScale",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/XLogScale"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     "Specifies if ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Log10"]],"paclet:ref/Log10"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       StyleBox["x", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "d55e9aff-faad-4424-90d7-1e70100227d8"],
     " should be applied to the x coordinates in the plot"
    }], "TableText",ExpressionUUID->"38565de4-5db8-4923-86f2-dcc3ff84faf8"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "57b51a72-8b0c-4d9c-903a-9e367ff83fad"], 
    ButtonBox["YLogScale",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/YLogScale"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     "Specifies if ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Log10"]],"paclet:ref/Log10"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       StyleBox["y", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "f43e35ab-38e3-406e-8382-8280ca4f1ca1"],
     " should be applied to the y coordinates in the plot"
    }], "TableText",ExpressionUUID->"8b293cd8-8610-41bb-98bf-ef41eab46c27"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->318258773,ExpressionUUID->"c65a62f6-303c-4c9c-a19d-51f5328b561d"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"a1cee5f4-8b52-434b-9ef3-ccb9f387ea0f"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"1a79373d-f69f-4232-99d1-eec593b3330f"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount",ExpressionUUID->
  "d03e53e5-a87d-4d0a-9c2f-8eb299f46feb"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->188512225,ExpressionUUID->"9cc2e52b-7ac5-4ab5-a208-1e1fe5d35b01"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "c48d5d43-8f8f-42ba-9ae7-84dfd2732372"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->413276408,ExpressionUUID->"405053a6-07c7-4d6d-ba94-9598eb33ecc2"],

Cell["Define some data:", "ExampleText",
 CellID->62019171,ExpressionUUID->"a3dd8a1f-5a41-4ae2-a9fe-ea7ed1dc4e58"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<ID\>\"", ",", "\"\<a\>\"", ",", "\"\<b\>\"", ",", "\"\<c\>\""}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.05"}], "]"}], ",", "2", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.7"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<l\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.3"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"6", ",", "0.2"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<m\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"7", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"8", ",", "0.1"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.9"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<n\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1.5", ",", "0.8"}], "]"}], ",", "8", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
    "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->32120805,ExpressionUUID->"09f52b79-923f-43e7-ac67-abb883e9cfab"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$11179], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$11180]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$11181], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$11182], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$11183]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$11184], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$11185], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$11186]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$11187], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$11188]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 260824904983847]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$11179], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$11180]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$11181], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$11182], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$11183]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$11184], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$11185], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$11186]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$11187], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$11188]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 260824904983847]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$11179], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$11180]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$11181], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$11182], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$11183]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$11184], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$11185], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$11186]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$11187], "b" -> 
                 8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$11188]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 260824904983847]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$11179], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$11180]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$11181], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$11182], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$11183]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$11184], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$11185], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$11186]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$11187], "b" -> 
                 8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$11188]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 260824904983847]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[1]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`UnknownShape, "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 4, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[1197702276], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1197702276]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1423887294][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1423887294][{All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1423887294][{All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1423887294][{All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1423887294][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.000\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "98", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.05, $CellContext`dv$11179]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.0\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "14", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.7, $CellContext`dv$11180]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1423887294][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.3, $CellContext`dv$11181]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.2, $CellContext`dv$11182]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"6.00\"", 6., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[6, 0.2, $CellContext`dv$11183]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1423887294][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"7.00\"", 7., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[7, 0.2, $CellContext`dv$11184]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"8.00\"", 8., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[8, 0.1, $CellContext`dv$11185]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.0\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.9, $CellContext`dv$11186]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1423887294][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$11187]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.2, $CellContext`dv$11188]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1423887294][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1423887294][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1423887294]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1423887294][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1423887294][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {267., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->5606840,ExpressionUUID->"7a41f5ab-f630-41b1-a535-43f9d49093d1"]
}, Open  ]],

Cell["Create a figure from the data:", "ExampleText",
 CellID->11107624,ExpressionUUID->"bd838bb7-f921-4518-ab15-9991e2663166"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fig", "[", 
  RowBox[{"tbl", "[", 
   RowBox[{"All", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->579103683,ExpressionUUID->"3036a852-2c0a-4780-abcf-942ebaf91f7b"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3U9sHFWewPHeTWAZFJiEyQ69cRiCMVBASBrMZKKORRqziRp5iVvBrEOj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    "], {{0, 360}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 360},
  PlotRange->{{0, 511}, {0, 360}}]], "Output",
 ImageSize->{515, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->20519931,ExpressionUUID->"a6de3c0d-a99b-4b31-94ab-1905095e19c8"]
}, Open  ]],

Cell["Plot multiple data sets:", "ExampleText",
 CellID->132932993,ExpressionUUID->"6c57a790-499f-4f5e-b86a-5da042270b1c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fig", "[", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tbl", "[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"tbl", "[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<a\>\"", ",", "\"\<b\>\""}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "}"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->309499686,ExpressionUUID->"e15d4cf1-b09d-44c2-a2f5-0042b192494a"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3W9wG/Wdx3FdTUIIiXECISJOIbgGBHFAYOq6wnWEfQnizFg6MHXqjBNC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    "], {{0, 360}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 360},
  PlotRange->{{0, 511}, {0, 360}}]], "Output",
 ImageSize->{515, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->345002701,ExpressionUUID->"b80db8a2-736d-49c8-b8ca-7a092b3d19fc"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount",ExpressionUUID->
  "d10ba4c5-df65-458b-b9a3-d79221056a03"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"cc481aec-9e6e-4b76-a7ff-0146f0a579ef"],

Cell[CellGroupData[{

Cell[TextData[{
 "ShowLegend",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "f5683665-59eb-4de5-bd69-089daf21ac63"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->266667140,ExpressionUUID->"5dd44aa9-dc01-4b9a-8fae-4598ecd343a2"],

Cell["\<\
By default, a legend is shown in the figure if more than one data set is \
plotted:\
\>", "ExampleText",
 CellID->111123942,ExpressionUUID->"b86ac3ed-1b95-4ac9-93cb-8c367a86da68"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fig", "[", 
  RowBox[{"{", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"tbl", "[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"tbl", "[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<a\>\"", ",", "\"\<b\>\""}], "}"}]}], "]"}]}], 
   "\[IndentingNewLine]", "}"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->414899548,ExpressionUUID->"56435552-2807-4993-a307-67e881abcd79"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3W9wG/Wdx3FdTUIIiXECISJOIbgGBHFAYOq6wnWEfQnizFg6MHXqjBNC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    "], {{0, 360}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 360},
  PlotRange->{{0, 511}, {0, 360}}]], "Output",
 ImageSize->{515, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->99528209,ExpressionUUID->"838506dc-5d81-494a-8b92-7fe844a2019a"]
}, Open  ]],

Cell[TextData[{
 "The legend can be hidden using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ShowLegend"]],"paclet:DataAnalysis/ref/ShowLegend"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "6dd91bcd-3fc5-41bb-a882-e65259689ff4"],
 " option:"
}], "ExampleText",
 CellID->167673422,ExpressionUUID->"7c27687b-9927-4bd4-9a46-0ee86a0582d8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fig", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tbl", "[", 
      RowBox[{"All", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"tbl", "[", 
      RowBox[{"All", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<a\>\"", ",", "\"\<b\>\""}], "}"}]}], "]"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"ShowLegend", "\[Rule]", "False"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->85782494,ExpressionUUID->"978342d5-336c-4004-8b96-5f77f9a4ffbb"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3UFwG+Xdx3G9NQkBkuAEQtQ4pcGvAUEcKmrqusKvI5xJEOOOpbeYOnXG
CSHF0LcUBLyMwhReDcz7WmUElQ71dPDQMvMOb91yySHFGU469KCjjjr4kOlJ
Rx119PvYG8sb25HWz660+zzP9zNqRzHyo+e/eva3u49Xu4+88tbP5r4TCoXe
3Sf+72eXM8+9887l91/sFf946c13f/Xam6/+8oU3//PV1159Z+SVHvHD1/8l
FFoV/1t7vgoAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAQPD8
9a9/3bNnTwgAEApdvHjR71Tuki+//HJqaurEiRNtX5ld1/ZloqmbN2+2fo14
QZffsVQqxePxtk29/PLLYoG0fZkYIW1fI9oRrbV9meiV6Fvr17C4moK5uPiA
moL5ATlfXFeuXHFSph7EZzozM+Ok3mvXrjkZSE4+i3q97uQdxduJN237MtGU
aLD1a6rV6tWrV5005aTGVCrV9jVivBUKhbYvS6fTXi0uhyuLk8UluiQ61rYp
UWDbNX3V2eJymC3iQxQfZevXOFxcDsezw8XlJM26P55zuVy5XG77Mifh3/3x
7GHgOB/PmUzGnPDP5/N9fX1is1ipVDxp0MlnEVgOwz+YHIZ/MDkM/2ByGP6B
5ST8A8urwGk0GmIERiKRs2fPum9NCYuLi4lEQmzW2+5sOCR2NsRi9KSp7lta
Wmq7YxlYpXV+90KSWOxi4fvdC0liwIth73cv5Km7z7DqaeCIoySx5z89Pe1J
a8Gn9B4XAHjIqDw0qlgAaMGoPDSqWABowag8NKpYAGjBqDw0qlgAaMGoPFxc
XBwaGspms16d7QMAHXXz5s3ShuvXrzefuzxfXSR/Mpmcmpryqp8Bl8/no9Go
CH+vzvMHgI4SeRXfcO+998ZiMeu5k68T3ol1vq4I/0Qi4WFXg8yowxwAmvH2
W6VG5aFRxRpF3a/aQXseDk4Pw1/0Stc8XCnGbl23bm65+UMlii2VStltlP4q
cadVKhVzjl6hnHQ67eYL3fV6vZkDvb29b731lvXczdx1rVaLRqNK5OGuieiP
FVduPduMfyWKvXjh588/fV968rD9cf/+u9W9iFCnObyMIeALlxfREsP7e0e3
BsLI4/e4uU6FdYEmJfJw124L/1vPVtUJ/08vP/TPLwbsj4fD9xP+d0L4I8jc
h3/s1NEtgSDyn/C/o1vzPpvJL2QymZGRkcK6hYWFUiA98/TJ7eF/9NC+Tz75
xO+uBZT4NGOxmH9DDWhldnZWJI+b4T38xAPbw//SpUtyDS4tLX344YdHjhwR
vZqZmfF78XhteS6007TPwMDA3r17ezc0T5oKjtHR0f339GwP/8MHekSH/e5d
QEWj0f7+fh+HG9DC2bNnI5GIm+H91CP3bQ9/sesu1+Dx48cPHjx41113iV6J
wPF78XjstrkesSHYSH8lDnOY9tmtEtM+CDCmfbpqc8/f/pTw1xPhjyAj/LtM
ZL6ip3q+9stLjx4/KD5u+2Pf3XtqtZrfXQsowh9B5jL8y+Xy/Qf2WTkw+P17
Rk4eEU++d/Q+N7fU0Tv8d6REsfV6ffvfaLgeRQtis6j0vaWgt6WlJSc3F25B
/LqVA+FwWLRmPXfzxR/xu1evXlUiD71iVLEANMPlHaQZVSwAzRD+0orFYk9P
TygUYhYFgBLS6XRoJ+FwWHrmR/yi+HXRyPDwsLe9DSyjtnQA0IJReWhUsQDQ
glF5aFSxANCCUXloVLEA0IJReWhUsQDQglF5aFSxANCCUXmYz+fD4XA8Hnf5
hTsAUFoqlYpEIuPj4353pEvEli6RSLj8ZjQAqK5Sqeh5Pf87MOowBwBaMCoP
jSoWAFowKg+NKhYAWjAqD40qFgBaMCoPjSoWAFowKg8XFhai0Wg2m+WWiABM
VigUksnk5OSk3x3pEsIfAFbNC3+jDnMAoAWj8tCoYgGgBaPy0KhiAaAFo/LQ
qGIBoAWj8tCoYgGgBaPykAu7AYBQLpczmcz09LTfHemSYrHY19cXj8er1arf
fQEAf4i9X+uSzqdPn/a7L11i1GEOALRgVB4aVSwAtKBlHq4UYyGbWHHF+rmW
xQKABM3zcG0zMLe88S/NiwUAx/TOw+U5W/TrXiwAOKdzHord/uaMzzqdiwWA
3dA4D8Vu/+3Zv3aqZ09Pj/WHgH379tVqNb/6BgC+SKVSzb+HDg8P+92dTtgy
5bNG4y0dAOyKtnm4bc5nVeNiAWCXtM3DHXb89S0WAHbJqDw0qlgAaMGoPDSq
WABowag8NKpYAGjBqDycn5+3TvUslUp+9wUA/NFoNCKRiEjC0dFRv/vSJUZt
6QBo4Nq1a9kNFy5c+O1vf2s9z+VyLu9LYlQeGlUsAA2USqVm+Pf29r711lvW
80Kh4LJlo/LQqGIBaObEiRM3b970qjWj8tCoYgFohvCXZlSxADRD+EszqlgA
miH8peXzeesG7pVKxe++AMDueBX+jUZDxH4kEjl79qz71pSwuLiYSCRKpVK9
Xve7LwCwOx7u+ZfL5UwmMz097UlrwWfUYQ4AzTDtI82oYgFohvCXZlSxADRD
+EszqlgAmiH8pRlVLADNEP7SFhcXh4aGstksZ/ug+8rlcmknLi/PBXN4GP6F
QiGZTE5OTnrSWvAtLCxEo1ER/h5uPQEnqtVqfMPg4ODx48eb/1xaWvK7d1CD
h+f553I5Ef6JRMJ9a0ow6jAHgcU4hBymfaQZVSwCi3EIOYS/NKOKRWAxDiGH
8JdmVLEILMYh5BD+0owqFoHFOIQcwl+aKHZiYoK7t8NfRq108JCH4V+pVDKZ
zMzMjCetBV+xWAyHw1zSGf4i/CHHw1M9E4lEJBIZHR1135oSWOkQBIxDyGHa
R5pRxSKwGIeQQ/g7sVKMhSxzy80f6losXPpyXRfeSBxuv/3Oe0eOHtt7976x
+JnuTD9Wq9XXX3+9C2+ETiP82xPRHyuu3Hq2Gf96FgvXsus6/S61Wu3RyMkf
v/BK8jefn3//6zOzHz/y2Knrf19u/5vulEqleDze6XdBFxD+bW1m/+20LBbu
dSf8J1MvPjd99eJH3zQfYhPQ93C/2Ch09H0Jf20Q/m0tz4XmihvzPkz7oJ0u
hL9I+PsPPWhPfuvxg9M/z+VyHX1rwl8bhH9bIvxDG7v+axuCjfjP5/OhDb29
vVzYGZZLly6FOu9wuH97+D+benvP3ns6/dYiNPxexvCAJ+Ev9gSaA0O/Uz3t
gW+fAtJySwf3urDnL9bZBx46xp4/3GDPvz1b+ts3BHoWC9e6M+c/Fj9zZvZj
e/Jf+PDad48/0um7SxD+2iD8nWie6mn/y6+uxcKlrp3tM/DYkyMTrzXP9vn+
wOBXX/2l0+9L+GuD8JdmVLFwrmvn+dfr9V/9+jfN8/zL5XIX3pTz/LVB+Esz
qlgEFuMQcgh/aUYVi8BiHEIO4S8tn89bV/XszuE2sCOjVjp4yMPwT6VSkUhk
fHzck9aCT6x0iUSiVCo1Gg2/+wJzEf6Qw/X8pbHSIQgYh5DDtI80o4pFYDEO
IYfwl2ZUsQgsxiHkEP7SjCoWgcU4hBzCX5pRxSKwGIeQQ/hLW1hYiEaj2Wy2
01dTAbao1WrxDYODg8eOHWv+sztfLoYGPLyBey6XSyaTiUTCfWtKWFxcHBoa
EuHPxZzRfeVyubTh22+/bT5nNMIhD/f8C4WCCP/JyUlPWgs+ow5zAGiGaR9p
RhULQDOEvzSjigWgGcJfmlHFAtAM4S/NqGIBaIbwl8aF3QCoy8PwL5fLmUxm
enrak9aCr1gs9vX1xePxarXqd19gllqttm/fvtBOCoWC372DGjw8z9+6pPPp
06fdt6YEow5zEFiMQ8hh2keaUcUisBiHkEP4SzOqWAQW4xByCH9pRhWLwGIc
Qg7hL82oYhFYjEPIIfyliWInJiZKpZLfHYHRjFrp4CEPw79arWYymdnZWU9a
C775+flwOByPx8l/+IjwhxxO9ZTGSocgYBxCDtM+0owqFoHFOIQcwt+J5bnm
Fyjnljd+qGuxcOnauk6/S61Ws+7ekslkrMuMCJVKpdPvK+Iim812+l1wJ3/8
4x/L5bLLRsQ4Sf771P6Dh378k9GlpSWXrdXr9XQ6rWkerhRjseLK1p9qWizc
yq7r9LucOzM62H8oduroM48fiv7rAfFEPMTeSaffV2xi4vF4p98FdyIyx+Wd
Oj/Jf9p34rGxqcy5y787M/vxE0Nnzj4/4eYCZWJ/QBxE6JmHIvttO/xNehYL
17oT/mOxH/7tvb5/fjFgfxD+2nMZ/mKf/5HHTl348NrFj75pPobPXbz6/gfS
beoc/stzoVgstnXWh/DHzgh/dI7L8H/lyqsjP/21PfnF4/z7X+/ff1C6TZ3D
X1hZsWZ9xEFAM/7n5+d7enqsbUJvby83zobl0qVLO15v01sH7/3OjuHfBWJN
93sZm2t0dNTNZ7d3330vvPrZlvAXj7vvPeh+YIi++b14Osg++6/tlg7usOeP
znG5539+ZvbZ1Ntbkv/Ch9fu239Qetpf5z3/5bnmbI99z1/PYuEa4Y/OcRn+
N27cGBgc2RL+Yy++M33+gnSbOoe/7VRP+0k/uhYLl7oW/i89ezA9edj+IPy1
5/5sn4svXzk18sJL731l7fM/m3zj6Wd+4mbWWu/w35FRxcK5wrpOv4sIYWsr
k0wmo9Go9dxlLDhRqVRSqVSn3wV3kk6n3X+L5Is//fnwA0fErsKevXtfvvxL
l3+vrNVqIyMjRuWhUcUisBiHkMM3fKUZVSwCi3EIOYS/NG7gjiAwaqWDh7iq
pzSx0lnXVHHzzWjAJcIfcjzc8y+Xy5lMZnp62pPWgo+VDkHAOIQcpn2kGVUs
AotxCDmEvzSjikVgMQ4hh/CXZlSxCCzGIeQQ/tKMKhaBxTiEHMJf2uLi4tDQ
UDab5Xqe6DKxzsY3PPnkk8eOHWv+sws3EYMePAz/QqGQTCYnJyc9aS34FhYW
rK/Ve7j1BBwq2Vy/fr35nF0ROOThef65XE6EfyKRcN9a96xfss26UOfaDbtC
O9yu8U6MOswBoBmzp33W7tF1W9rf4Y6NO1KtWADYZHb4b8v6bVuDFlQrFgA2
mR3+q7ZL9Vuc7vavKlksANxifPjLM6pYAJoh/KVxYTcA6vIw/CuVSiaTmZmZ
8aS14Mvn8+FwOB6Pl8tlv/uyM7FVEj0M7SSdTvvdOwB+8jD8rUs6j4+Pe9Ja
8Kl1mMOtVwHYMe0jTa1iCX8AdoS/NLWKJfwB2BH+0tQqlvAHYEf4S1OrWMIf
gB3hL02tYgl/AHaEv7R8Pm+dNily1e++tEf4A7DzMPxFUyIJR0dHPWkt+NTa
0hH+AOzY85emVrGEPwA7wt+5lWLMfslPhYpdWlr6t7HnDj949I033qzVan53
J9DE8snlcn73Aug4wt+pbfd6UaLYRqNx9vmJJ4bOjE1lzl3+3Y8Sc30P91//
u/NrlxqHQyQYgvB3Zm2vf25OvT3/Tz/7fXTsxYsffdN8nH//a5H/7P/fCeEP
QxD+TlgTPipO++zff1CkvT38xUPs/7/xxpt+dy2gCH8YgvBvbyP0t4T/wMDA
3r17ezfEYrF4wIyMjNx74NCW5BePc5d/d/jBo373LqCi0Wh/f7+Pww3oDk/C
P51OWytOJBLR71TP9cn+Tc38z2QyIl0L6xYWFkrB8+233961Z+/28B+byvzb
2HN+9y6gxKcptuP+DjmgCzwJf9GCteLofT1/Fad9nk/89LlffLAl/AcGR27c
uOF31wKqxLQPzMC0j3Mqhn+tVjv63eNnZj9u/rX31MgLF1++4ne/govwhyEI
f2mqFCvyfyx+JhQKHTj00P79B7/405/97lGgVSqVRCLhdy+AjiP8palVrNih
HR4e9rsXauCmzDAB4S9NrWKZzQBgR/hLW1hYiEaj2WzWwwXYOYQ/ADuvwl8c
KedyuWQyac586eLi4tDQkAj/er3ud1/aI/wB2Hm4518oFET4T05OetJa8Kl1
mEP4A7Bj2keaWsUS/gDsCH9pahVL+AOwI/ylqVUs4Q/AjvCXplaxhD8AO8Jf
WvDP9hEdS6VSzYtV9vb2Nq9dKT4pv3sHwE8ehr/Ik2QyOTU15UlrwZfP563z
/CuVit99uSP79SqXlpaaz5X4bgKAzuE8f2lGHeYA0AzTPtKMKhaAZgh/aUYV
C0AzhL80o4oFoBnCX5pRxQLQDOEvTRQ7MTFRKpX87ggA7JqH4V+tVjOZzOzs
rCetBd/8/Hw4HI7H4+Q/AOV4eKpnKpWKRCKnT59235oSjDrMAaAZpn2kGVUs
AM0Q/tKMKhaAZgh/aUYVC0AzhL80o4oFoAGR9s0LfIXD4eb1vtxfoMyoPDSq
WAAayGazzUv79vf3j42NWc9TqZTLlo3Kw2Kx2NPTEwqFgnxVTwDoqEajIQ4i
RBIODw/73ZcuMWpLBwAtGJWHRhULAC3omofLcyHL3PLmD3UtFgB2S888FNF/
K/Q3n63qWiwA7J7ueUj4A8AONM7DlWKMaR8A2JH2eWjf9S8Wi319fdZZsolE
olar+do1AOi2q1evWhmo/VU9xf5/rLhiPRdbOpH5za/L+dovAPBBtVq1AjCT
yUxPT/vdHa/Zdvfte/7aH+YAgEO65mHzVM/mbv+qvsUCwG4ZlYdGFQsALRiV
h0YVCwAtGJWHRhULAC0YlYcLCwvRaDSbzXp4QwQAUE6hUEgmk5OTk353pEsI
fwBYNS/8jTrMAYAWjMpDo4oFgBaMykOjigWAFozKQ6OKBYAWjMpDo4oFgBaM
ysPmhd0ajYbffQEA31QqlUwmMzMz43dHuiSfz4fD4Xg8Xi6X/e4LAPgmlUpF
IpHx8XG/O9IlRh3mAEALRuWhUcUCQAtG5aFRxQJAC0bloVHFAkALRuWhUcUC
QAtG5aFRxQJAC0blYbFY7OnpCYVClUrF774AgD8ajUY4HBZJODw87HdfusST
LV06nQ7tRCxMvjsGQBVG7fl7XuyJEye4NQAAFRH+bhD+ABRF+LtB+ANQFOHv
BuEPQFGEvxuEPwBFGRX+xWLRuqqnV6d6Ev4AlNNoNBKJRCQSGR0d9bsvXSK2
dBMTE6VSyasGCX8AKjLtev5M+wCARdNpn5VibOPLV3PLzZ+6LFb8+pafbA9/
cVjB5gBA8GkZ/mvRfyvzbU9dFyu2JOL/q9Xqvrv3bP+G7399cFX8V9H+9m0E
AASNluFvJ9I/VlyxnnsS/mLfPnbq6D+/GLA/Pr380MULP18l/AEoQvfwX56z
zfsQ/gBg0Tr8RfI39/rX5PP5vr6++LpUKlWv13fVnAh/8YsHDhw4+fDd28P/
4H17RkdHRfviXTyuAwA8kk6nrQyMRCJnz571uzsdsDbZf1vyC4uLi4lEorRh
t02K8Be/NTc39/TAwe3h//RTEfFfRfviXbwqAgC8ValUrADMZDLT09N+d8dr
t/2ZdxPTPgBg0XLaZ3nutvNwPP+D72D/ob+912d//McLhwh/AArRMvzvxJPw
r9Vq586MjsV+KB4P9u4beWbQev6X//vfVcIfgCIIf+e2f3tr+5e8xKaB+3kB
CD7C3w0u7wBAUUaF/+Li4tDQUDab3e1JnndC+ANQkUj+ZDI5NTXld0e6JJ/P
R6NREf5c0hmAsRqNRi6XE+GfSCT87kuXMO0DABajpn0IfwCwEP5uEP4AFEX4
u0H4A1AU4e8G4Q9AUaaFP/fwBQDT7uFbLBbD4XA8HudUTwDGajQaiUQiEomM
jo763ZcuYdoHACymTfsQ/gCwSvi7Q/gDUBTh7wbhD0BRhL8bhD8ARRH+bhD+
ABRlVPgXi8Wenp5QKMSpngCM1Wg0wuGwSMLh4WG/+9Il7PkDgMWoPX/CHwAs
hL8bhD8ARRH+bhD+ABRF+LtB+ANQFOHvBuEPQFFGhX8+n7eu6lkulz1pkPAH
oKJUKhWJRMbHx/3uSJeILV0ikSiVSo1Gw5MGCX8AKjLtev5M+wCARetpn+W5
0Nyy7d8ui91yC7AbN2709vbm8/lardb8odie1ut16bcAgO7QN/xF8gtehr9o
znoi9vafig4NDI78ID7zxI/O9T3c/9VXf7H+k2hfvIv0WwBAd2ga/ivFmIh9
j/f8rfBvNBqPPn7yhVc/u/jRN9bj/Ptfn3j8aXEgsEr4A1CEpuFv6Uj4//f/
zD8dP99Mfuvx0ntfHX7gyCrhD0ARRoX/wsJCNBrNrsvlcrs950eEv/jF/oHH
z8x+vCX8xePe/fe/++67on3xLt6WAQBeEZlvZWAymZycnPS7Ox3SkfB/LHLy
uV98QPgDUJGZ4e/JtM+nn/0+OvbiluT/2dt/Dh87vsq0DwBFGDXt49UffE/9
YMi+83/+/a/7Iz+0TgQl/AEoQevw38qrUz1rtdpY/Mz3BwZPPvvio089y6me
AJRD+Du35Ute5XL50KFDn3/+OV/yAqAcwt8NLu8AQFGmhT8XdgOAcrmcyWSm
p6f97kiXFIvFvr6+eDxerVY9aZDwB6AcsfdrXdL59OnTfvelS5j2AQCLadM+
hD8ArBL+7hD+ABRF+LtB+ANQFOHvBuEPQFGmhf/ExMSW72q5cezYMXXDv1qt
enXKa/fV63V1l7xY7F6db+aLSqXidxfk0XmLGIGZTGZ2dtarBgNufn4+HA7H
43Gv8v+uu+76xz/+4UlT3af0lSisyxL63QtJSu9xiW2uOOD1uxfymhdpUZFX
Uw1mnuoptnRLS0ttX1lZ1/ZlTsJfLGcP31E01XZ3XewVX7t2rW1TDsPfyWvE
gHSyPRW9anvtC4eLy2H4e7i4RIFO1juHi9RJ+Hu4uDwcXQ7Dv/vj2eEH5CT8
uz+eHS4uJ+HvfHHl83l1d0J2S6x0U1NTToauw2xxEv4OVxaH7+jk0xcfqzi6
aduUw/B3srI4TDMnx1wsrqZgLi4+oKZgfkDOF9eVK1fMCf8//OEPIq5DAIBQ
6Ny5c36nMgAAAAAAABAcW28TqYiVYmxjyk/B7ouFrmzfbxEfQKy44ncvdq25
5FVc9puDXr2+29fYNSoOHr1Yq4J6I2ltIN3qte2pKja3t4pueW+tyQquv4pu
stZt9l3BMW+nePe1ID4D8REomz8bVF6fFV34a4t8bk7Bxa5y7Kg8zm+j6KDX
keofhar9t46CVey6lUJKZpEYLLFYTM2Zk7WBXiwq2vlNSo4bXakanuvWVmal
R5J6S39j5VV1JV5ZsTptHfcqZG2KdmOJqzdsNii/xmpF2XG0tuus/DhSLkK1
+bOdckvevqIq1/kNyqaNntT8OFSevLUvcjWX/hol88e2uJXb89dh2Cg5aDSm
5DiynbCn5P5ns//K9bxJ0fVY6SXfPOxSsfNrlAwbAAAAAAAAAAAAAAAAAAAA
AAg8tS+nDQCQYLs6i9LfswYASOIbmwBgEKXvhwUA2L214Ff3LmoAABn2wNfi
qtoAACc2T/ZZu5cju/4AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAKf+H82j18w=

    "], {{0, 360}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 360},
  PlotRange->{{0, 511}, {0, 360}}]], "Output",
 ImageSize->{515, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->352900243,ExpressionUUID->"e872d4c2-48ec-4430-8558-00d629e65fd0"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "XLogScale",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "4d8b58b7-a6f8-43d8-93d9-5bf926e285ea"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"e45a098c-f15d-4090-b3f5-77d72453ffaf"],

Cell["Use a log (base 10) scale for the x-axis:", "ExampleText",
 CellID->8253780,ExpressionUUID->"0ecab717-4778-40a5-8ac5-3148e0f92e8f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fig", "[", 
  RowBox[{
   RowBox[{"tbl", "[", 
    RowBox[{"All", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
   RowBox[{"XLogScale", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->852940988,ExpressionUUID->"b3e135aa-06d5-491a-bc84-2d6c1d241fad"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3U9wm+WdwHHtBrI0G6hDgaoxWRI3kJdCwdRt1nW8juJMsmK8jbUkrIMz
SQhtlO0sJSFpERlgPNBuzIyWlQ5kMjEsXDI1w3TwgcGZnHTgoKOOPviQo48+
6uh9nDeWZcWW5ed5oud9n9/3M27H+ffy/l5JX73va73SrjfOv5L9+0Qicekh
9X+vnMkduHjxzOWjHeoXr7516ffn3jr7u5ff+uPZc2cv9r6xSf3mf/5dIrGg
/rf4/QIAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAANHz1Vdf
PfjggwkAQCJx6tQp11Vuky+//PL1118Pvy+VSqlUynCBO3fuvH37tq1V0qZu
RMMljN1hsgS1HdTWMFwNdYuo28VkCRG5Wc2354KNm1XdtdQdzGQJVranWkIy
mTTZpFYeJlG4WQ0fJuEItm5WK1s1LuqHVdvwwoULhgs0vzupW6FQKBiuRiaT
MVyC2jJTU1MmS7AS/3fffXdmZsZkCeqfq4UYroa6k8zPz5sswUr8zW9Wddcy
fDK18jAxj3+5XB4fHzdcDfOb1fnDJAyO2hRqgxiuhrpZxcbfCvP4e8NK/L1h
Jf7eMI+/N6zE39bKEH8T6im4Wq1aXGB8qe1gvm/mjdIdrtciKq5du7Zjxw7i
v2D8MCH+2kQNC0QHx8hWEH9tooYFooP4W0H8talh0+m0Oh7nXA3QTsTfCoub
sVKp5HK50dFRK0uLvnw+n0wmU6mU4c/KAWwI8bfC4mbMZDJBEAwODlpZWvSJ
OswBooP4W8FpH22ihgWig/hbQfy1iRoWiA7ibwXx1yZqWCA6iL8VxF+bqGEB
PffjtXCdnZ33I/7SXrZH/FsxW+y7+7512enab/o6LGBLoVCwe6X2R3/+y+bN
//CPP3xMPRZHjp8wfHedepVKJZ1O21paLBD/9an09xVn7363nH8/hwXssfuu
RKde/233wNETH0yd+vA79TVw9OLuZ342NzdnZeFW3nE0Xoj/upbbv5KXwwIW
WYz/zZs3dz/fG2a/9nVg5N0jmaNWlk/8DXnZw+lsIltcOu+z8rTP0NBQ+KZb
XOcF3EuV//Tp0yUb/mXgwMCxXEP81dcDD26+deuW+fILhUJfX5/rDdZWVuKv
lhBuQC+v8FXxTyzt+i8+ESzlv1gshlf4hmwdfgLeOHfunCpMyoZHH/vx4TMf
3xv/LQ9v6+3tNV9+d3d3V1eX6w3WVlbif+HChXADBkHQ399vY70ipD749aeA
vDzMASyyeNrnzTff+lU621D+45e/3rr1ESvLL3Hax4yfPayrf/0TgZ/DAvZY
jL/K1E+e3FX7aW/41TN4/KM//8XK8om/IV97WHupZ/1Pfn0dFrDF7qt9btz4
645de/Zl3j585uMDr73/bM/BV0dO2Fo48TckqoeihgU0qKIafkxtg5mZmeOj
J7c+sm0gdXByctLikufm5qR9eBzx1yZqWCA6eHsHK4i/NlHDAtFB/K0g/tpE
DQtEB/G3gvhrEzUsEB3E3wrir03UsEB0EH8riL+2YrG4adOmRCJRqVRcrwsg
CPG3wtZmrFaryWRSlXDv3r3mS4sFUc90QHQQfyvY89cmalggOoi/FcRfm6hh
gegg/lYQf22ihgWig/hbQfy1iRoWiA7ibwXx1yZqWCA6iL8VxF+bqGGB6CD+
VhB/baKGBaKD+FtB/LWJGhZwq1QqjS3p6Og4f/58+L16GLpetbgi/tq4whdo
G9WWWvyPHj363nvvhd+Pj49Xq1XXaxdLXOGrTdQzHQDPsOevTdSwADxD/LWJ
GhaAZ4i/NlHDAvAM8dcmalgAniH+2kQNC8AzxF+bqGEBeIb4axM1LADPEH9t
ooYF4Bnir+3KlSvhFb6lUsn1ugDAxli8wjcIAlXC/v5+86XFgqhnOgCeYc9f
m6hhAXiG+GsTNSwAzxB/baKGBeAZ4q9N1LAAPEP8tYkaFoBniL82UcMC8Azx
1yZqWACeIf7aRA0LwDPEX1s+n08mk6lUqlwuu14XANgYi/HPZDJBEAwODlpZ
WvSpZ7p0Ol0qlfj8aACxYzH+lUoll8uNjo5aWVr0iTrMAeAZTvtoEzUsAM8Q
f22ihgXgGeKvTdSwADxD/FsxnU0syU4v/aavwwLwwNTU1Pz8/Kp/VK1Wr127
1tHR8c477zTpv0pc6/85T3s4W+zrK842/q6nwwLwQSqVWvVzpiqVytN7nnu+
7zcvpkZfGPiPnzy56/rE56suQe3stv6f87OHqv11O/w1fg4LwAurxl8dCzz5
1E+H/3D91IffhV8nPpgKXhr429++uXcJxH/xpE9fX1/jWR9PhwXghVXjf+mP
7/zy8Jla+cOvV97+Irn9yXuXQPwXzc6GZ33UQUAt//l8vrOzM3VHJpNZ6/Qa
ALRfEATd3d2plR597MeHz3zcEH/19dCWh9UebsNfbiX+Fy5cCP+y+s8dOnSo
DXO5Un/2f2JiIrzCN+R0vQBghd7e3kKhUFppb+++A6+9f2/8f7Bl67ffftvw
l1uJf6VSCf9yLpcbGRlpw1xtNZ2tne2p3/P39jAHQPytetrn2rVrz/f9pqH8
6lhAPSncuwRO+yzUvdSz/kU/vg4LwANrvdrnhe6egaMXa+Uf/sP1nwYvzMzM
3Ps3if9aRA0LIF7Wiv/8/PzI8RPJzp2Pbd+9o+tnT+3aXalUVl0C8V+LqGEB
xEvzq3fVrn4ymfzmm1Ve4dniEhqI6qGoYQF4hrd30CZqWACeIf7aRA0LwDPE
X5uoYQF4hvhru3r1and399jYmMUNCADtYTH+hUJheHj4yJEjVpYWfcQfQHwR
f22iDnMAeIbTPtpEDQvAM8Rfm6hhAXiG+GsTNSwAzxB/baKGBeAZ4q9N1LAA
PEP8tYkaFoBniL82UcMC8Azx1zYxMdHT0zM2Nsan9wKIHS7y0sYVvgDiy1b8
q9Xq+Pi4in86nTZfWiyIOswB4BlO+2gTNSwAzxB/baKGBeAZ4q9N1LAAPEP8
tYkaFoBniL82UcMC8Azx1yZqWACeIf7aRA0LwDPEX5saNp1Ol0qlarXqel0A
YGMsxr9cLudyuZGREStLi75isdjZ2ZlKpWZmZlyvSzxcuHAhsZpkMskTKNBm
Fq/wzWQyQRDs37/ffGmxIOowxzq7h5wANorTPtpEDWsd8QfcIv7aRA1rHfEH
3CL+2kQNax3xB9wi/tpEDWsd8QfcIv7aRA1rHfEH3CL+2kQNax3xB9wi/tpE
DWsd8QfcIv7a1LBDQ0OlUsn1isQS8QfcsvgYrFQquVxudHTUytKir1gsJpPJ
VCqlBne9LvFD/AG3LF7hm06ngyDo7+83X1osiDrMsY74A25x2kebqGGtI/6A
W8Rfm6hhrSP+gFvEX5uoYa0j/oBbxF+bqGGtI/6AW8S/dbPFvr7ibO2Xfg97
/3z+f188+qPHE4nEg5s3v37md/Pz867XCB6qVCqZTMb1WkQa8W+VSn8iQfwN
nfv9mz/vffnVP9049eF3Jz6Y2jf85ku//DX9h3WlUimVSrlei0gj/q1Z3OvP
ZtnzN6Iej13BL1T2678Gjl4cOX7C9arBN8R/XcS/FeEJn4bTPrlcrre3t3DH
Z599VsJ6Dh5K78u83RB/tf//gy1bb9265Xrt4BX1qJRzzZEeK/FXSwg3uOrh
yZMnbaxXlCxFvyH+XV1dmzdv7lii7mkpNNXx6OMvn/2kIf7qa8vD29TTqOu1
g1e6u7t3797tMBvRZyX+am8/3OBefobvnZP9y2r99/Uw5/5547dne//tvxrK
f/zy11u3PuJ61eCbEqd91sNpn9bxah9DMzMzO3btOfHBVH389x4+9e7l912v
GnxD/NdF/FtH/M1dn/hc9X/gWO7wmY8Pnvzo2Z6Dh/51qFqtul4v+Ib4r4v4
axM1rEVq/3/4349tfWTbP/+6f3Jy0vXqwE8qa2NjY67XItKIvzZRw1rHFb6A
W8Rfm6hhrSP+gFvEX5uoYa0j/oBbxF+bqGGtI/6AW8Rfm6hhrSP+gFvEX1s+
nw8v+yrxGe4bR/wBtyw+BtWiVAnlvJ+GqGc664g/4BZ7/tpEDWsd8QfcIv7a
RA1rHfEH3CL+2kQNax3xB9wi/tpEDWsd8QfcIv7aRA1rHfEH3CL+2kQNax3x
B9wi/tpEDWsd8QfcIv7aRA1rRe3jPpVkMjk5ORl+Xy6XXa8aIA7x13blypVN
mzZxhW/rCoVC7SNWn3nmmYGBgfD7TCbD57kAbWYr/urBGwQBV/gCQCyw569N
1LAAPCM9/tNZdbSSnV78drbYl0jUf0jvOuI3LAAskR1/lf6VtV98AgifCtYX
t2EBYJns+N/T+nueDZqI27AAsEx2/BfunvdZ1upu/0IshwWAu8THX5+oYQF4
hvhrEzUsAM8Qf22ihgXgGeKvrVgsJpPJVCpVqVRcrwsAbIzFK3zT6XQQBKKu
8B0aGuK9HQDEkcU9f7UDnMvlRkdHrSwt+kQd5gDwDKd9tIkaFoBniL82UcMC
8Azx1yZqWACeIf7aRA0LwDPEX5uoYQF4hvhrEzUsAA9MTU2NLeno6Dh//nz4
faFQMFyyqB6KGhaAB+rjf/r06dr3xH9DisViZ2dnKpWamZlxvS4A4Ea1Ws1k
MkEQ7N+/3/W6tIl6pkun06VSiQ8fByBZuVzO5XIjIyOuV6RNRB3mAEATonoo
algAaEJUD0UNCwBNiOqhqGEBoAlfe1j7oN/6j/j1dVgA2Cg/e6jSfzf6y98t
+DosAGyc7z0k/gCwCo97OFvs47QPAKzK+x7W7/pfvXq1u7u7dn30/Py801UD
gHZTzQ8DODw8nE6nXa/OfaT2//uKs+H3ExMTPT094eDj4+Nc5wtAmtqbBan4
HzlyxPXq2Fa3u1+/5+/9YQ4AtMjXHtZe6lnb7V/wd1gA2ChRPRQ1LAA0IaqH
ooYFgCZE9VDUsADQhKgeihoWAJoQ1UNRwwJAE6J6KGpYAGhCVA9rV/jevn3b
9boAgDOFQsHPi7zWQPwBYEFe/EUd5gBAE6J6KGpYAGhCVA9FDQsATYjqoahh
AaAJUT0UNSwANCGqh6KGBYAmRPVQ1LAA0ISoHooaFgCaENXD2sc48um9ACRT
5R8eHj527JjrFWmTfD4fXuFbqVRcrwsAuFGtVsfHx73/APd6og5zAKAJUT0U
NSwANCGqh6KGBYAmRPVQ1LAA0ISoHooaFgCaENVDUcMCQBOieihqWABoQlQP
RQ0LAE2I6qEaNp1Ol0qlarXqel0AwJlKpZLL5UZHR12vSJvk8/lkMplKpcrl
sut1AQBnMplMEASDg4OuV6RNrBzmqCUkVqO2JAcUAOJC2mkfu8Pu3Lnz9u3b
FhcIAO1B/E0QfwAxRfxNEH8AMUX8TRB/ADFF/E0QfwAxRfxNEH8AMUX8TRB/
ADElLf5DQ0OlUsnWAok/gDiSdoVvsVgMr/C19Rm+xB9A7FSr1XQ6HQRBf3+/
63VpE077AEBI2mkf4g8AC8TfDPEHEFPE3wTxBxBTxN8E8QcQU57Gf7bYt/RW
y9np2u8SfwAIeRn/xfTfbX7dt8QfAJZ4Gf96qv59xdnwe+IPACHf4z+drTvv
Q/wBIOR1/FX5a3v9i4rF4qZNm8IfBTz00ENzc3OG/wHiDyBeMplM7cNn9+7d
63p17oPFk/0ryr/Anj8ALPFzz3/Fj3mXEX8ACHkZ/+lsoh4/8AWABl7Gfy3E
HwBCxN8E8QcQU8TfBPEHEFPE3wTxBxBTxN8E8QcQU8TfBPEHEFOi4l+7wpfP
8AUgVrVaTSaT3l7huxr2/AEgJGrPn/gDQIj4myD+AGKK+Jsg/gBiivibIP4A
Yor4myD+AGKK+Jsg/gBiivibIP4AYor4myD+AGJKVPyvXLkSXuFbKpWsLJD4
A4idarUaBIEqYX9/v+t1aRP2/AEgJGrPn/gDQIj4myD+AGKK+Jsg/gBiivib
IP4AYor4myD+AGKK+Jsg/gBiivibIP4AYor4myD+AGJKVPzz+XwymUylUuVy
2coCiT+AOMpkMkEQDA4Oul6RNlHPdOl0ulQqVatVKwsk/gDiqFKp5HK50dFR
1yvSJpz2AYCQqNM+xB8AQsTfBPEHEFPE3wTxBxBTxN8E8QcQU8TfBPEHEFPE
3wTxBxBTxN8E8QcQU6Lin8/nOzs7U6lUpVKxskDiDyB2qtWqyn4QBIcOHXK9
Lm0yMTERXuE7Pz9vZYHEH0AclcvlXC43MjLiekXahNM+ABASddqH+ANAiPib
IP4AYor4myD+AGLK6/hPZxPZ6bpfrzVsqVTSWPrNmzc7Ojry+fzc3NxG/225
XLb1ttIAoMHf+KvyKy3Ff6M78Oovv9Dds/v53hdTo8/+6nDnP3XduPHXDa1c
KpXSe8YBACs8jf9ssU9lv9U9/w3FX+2xP73nuZfPfnLqw+/Cr+OXv9655yV1
IND6+hF/AG55Gv/QfYn/X/77ykup47Xyh1+v/unGoz96vPU1I/4A3BIV/6tX
r3Z3d4/dMT4+Xjvr/sQTT5w/f36sNV279xw8+VFD/NXXlq0/vHTpUqsL6eq6
deuWk40CQDLV/LBCw8PDR44ccb0698l9if8zwXMHXnuf+AOII5nxt3La538+
+d/ugaMN5X/l7S+S259sfc047QPALVGnfWz9wPfnL/bU7/wfv/x1V/CLDcWc
+ANwy+v4N7L1Us+5ubmB1MGndj//3L6jT7+wj5d6Aogd4r+ge5FXuVzetm3b
9evXucgLQOwQfxO8vQOAmCL+Jog/gJgi/iaIP4CYIv4miD+AmBIV/4mJiZ6e
nrGxMT7GEYBkhULB64u8GtWu8LVVbOIPIHaq1er4+LiKfzqddr0ubcJpHwAI
iTrtQ/wBIET8TWzfvp3411QqFderEBXz8/PcMWq4Y9SLztYg/iYeeOCB77//
3uIC40u1Th0HuV6LqAjfNdH1WkQFb2ZSE6mHidj4q32zqakpwwWax1/dGcwf
F2ouwyVU7jBZgpV7tbpFDF+IZeVmnZycNHzzDSvxN79Z1V3L8ADEyvY0j7+V
h4n5zRqRh4mtm1Vs/NUGVPdJwwWax9/K9k8kEoZLMI+VlXu1eSWs3KzmP8qx
En/zm1XdtQyfQaxsT/Ob1crDJAo3q5WHia2bVVT8P/30U5XrBAAgkTh8+LDr
KgMAAAAAAACOTGfDs2QrPhhy3T/y1Zojzxb7ls4nCtkc6936aov0FWfbu07u
rL01lu8ZQu4YC2wNP6hb8c4jePE2a7i1mvyRr9Ycue43hGyO9W79Ow9yMfFf
e2ssPwUKuWMssDU8seLGWvlQbvJHvmptZBGbY51Nsfib2ayA7RBae2uIuDM0
IBp+UM/hS0/Pdd+u90e+amlkGRuj6aYIH9iCHt5rb43FXxaXznQIuF8sav4w
uXveR8pdI8aIf731R1464PVek02xFH3iH/6ydo/gYVL3+OC0T+RxBFev+ciL
d2cZ22FhnRMd9VfTiNgia2+N+vpJeZy0eBJMynNhfPED33pNf5IlZSOE1r/1
pbRu0dpbQ+ABcvOtUXccJObuEVuNr9paeW+WdC5z0RpbY+m3Je3uNrlj3CEp
/s22Ru1QiK2xUP9IEVQNAAAAAAAAAAAAwC+zxeJaP+6bLsr5uSgAxJLmC1zV
P2vyr6azgl4WAwAxpBf/9ere/LkBAODYivjXXsHd+PYGd17jXnubt5Uv/1/1
nbBlXSEAAHFTF//lCzZXvYpz+T1u6q8Fq/urjc8j7PsDQFQtF3vVpK/2xjZr
7tVLfBccAIilWvxX7Lev2vmlX9zzli5174xRvwR2/QEgqkz3/BfDv9oHoLHn
DwARpnHOvz7yjd/Xgs85fwCIsNZf7bP4cVarvNpn+cU+iy8HqjsKYMcfADyw
8hPu132dP+0HgNiq/1Cv+pxPZ9e5wpdzPgDgo+lsdnr1ffvZxT9q89oAAAAA
AAAAAAAAAAAAAAAA8MT/A31tuAs=
    "], {{0, 360}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 360},
  PlotRange->{{0, 511}, {0, 360}}]], "Output",
 ImageSize->{515, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->181073946,ExpressionUUID->"c5577508-d8ae-4d3a-973d-556e55e86fef"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "YLogScale",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "da1e5742-4717-456b-89b3-b6ca9198baa6"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"03b85fa1-8fe1-4343-a23f-dd90f4e1fea6"],

Cell["Use a log (base 10) scale for the y-axis:", "ExampleText",
 CellID->813250167,ExpressionUUID->"1cad1220-1fc3-42be-a50d-0edacb2a396b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Fig", "[", 
  RowBox[{
   RowBox[{"tbl", "[", 
    RowBox[{"All", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
   RowBox[{"YLogScale", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->121790852,ExpressionUUID->"ebc676ba-77e1-4986-af19-8cb5c63e9b99"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3V1sXNWBwPHZJdCIsm1YdreGUD7SANPlyzS7bGSyZBraaBDdOIKgUFel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    "], {{0, 360}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 360},
  PlotRange->{{0, 511}, {0, 360}}]], "Output",
 ImageSize->{515, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->105936974,ExpressionUUID->"d01775aa-1f5e-45a2-bdbb-781943f5febe"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"6750b990-b114-4335-b59f-e5d4c177fcc9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"afea8f80-a773-4349-81fd-f28359239db3"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"ac98dcee-e08e-4472-a12f-cfbcd5fe58f1"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigGrid"]],"paclet:DataAnalysis/ref/FigGrid"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"06ce2468-7a2a-48b4-ba2e-9f92799cdc34"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDrawPlot"]],"paclet:DataAnalysis/ref/SciDrawPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"f0e3dfc6-221c-4743-9f60-15f03e3117c8"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DTPlot"]],"paclet:DataAnalysis/ref/DTPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"dd3d7ba5-d363-4108-badc-7cdf9f87263f"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"77d20282-c0af-4620-a4ea-8cf71d3a13ff"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"053a5ed2-34d9-459f-b469-37b83bcba204"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"598c8725-eaf9-4725-a278-763895665988"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"18f72d0e-2f66-4c54-b4e0-c2ac75f84796"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"2de658f3-0381-4319-a1e3-bb060d302af3"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->448876740,ExpressionUUID->"0c0a92e3-c916-4b0b-a6a5-8f216b8e296a"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"e7e61c13-0f81-46ad-b130-28faa7abf814"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Fig",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 36.7839569}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "Fig[{object1, object2, ...}] returns a figure with plots of the objects \
using the SciDraw package. The objects can be of the type DataTable or \
Graphics.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "Fig", 
    "titlemodifier" -> "", "windowtitle" -> "Fig", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/Fig"}, "SearchTextTranslated" -> "", "NewStyles" -> 
  False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[13039, 349, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"9cc2e52b-7ac5-4ab5-a208-1e1fe5d35b01",
   CellTags->"PrimaryExamplesSection",
   CellID->188512225]},
 "RasterizedOutput"->{
  Cell[55741, 1220, 8570, 147, 381, "Output",ExpressionUUID->"a6de3c0d-a99b-4b31-94ab-1905095e19c8",
   CellTags->"RasterizedOutput",
   CellID->20519931],
  Cell[65017, 1392, 10841, 185, 381, "Output",ExpressionUUID->"b80db8a2-736d-49c8-b8ca-7a092b3d19fc",
   CellTags->"RasterizedOutput",
   CellID->345002701],
  Cell[77287, 1628, 10840, 185, 70, "Output",ExpressionUUID->"838506dc-5d81-494a-8b92-7fe844a2019a",
   CellTags->"RasterizedOutput",
   CellID->99528209],
  Cell[89178, 1849, 10284, 176, 70, "Output",ExpressionUUID->"e872d4c2-48ec-4430-8558-00d629e65fd0",
   CellTags->"RasterizedOutput",
   CellID->352900243],
  Cell[100316, 2056, 8726, 150, 70, "Output",ExpressionUUID->"c5577508-d8ae-4d3a-973d-556e55e86fef",
   CellTags->"RasterizedOutput",
   CellID->181073946],
  Cell[109898, 2237, 8173, 141, 70, "Output",ExpressionUUID->"d01775aa-1f5e-45a2-bdbb-781943f5febe",
   CellTags->"RasterizedOutput",
   CellID->105936974]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 122701, 2509},
 {"RasterizedOutput", 122900, 2513}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[575, 21, 4367, 98, 55, "AnchorBarGrid",ExpressionUUID->"6a28e21b-bed9-4818-a188-b09453bd293f",
 CellID->1],
Cell[CellGroupData[{
Cell[4967, 123, 388, 9, 52, "ObjectNameGrid",ExpressionUUID->"8b213f92-af9c-4fd0-877e-44bc57e4f322"],
Cell[5358, 134, 1358, 36, 131, "Usage",ExpressionUUID->"14d86925-7e12-462b-861f-f0c452acf46a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6753, 175, 852, 21, 37, "NotesSection",ExpressionUUID->"eddb6daf-1fa0-44e1-90cd-e4c3bcbfc423",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->501205],
Cell[7608, 198, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"efcee426-be42-49b1-88dc-fd3bd8dbed99"],
Cell[7697, 200, 678, 17, 70, "Notes",ExpressionUUID->"14e4e601-2220-4f07-b3a2-7a511151e3a4",
 CellID->632098388],
Cell[8378, 219, 187, 4, 70, "Notes",ExpressionUUID->"addd61c6-6ce9-4f18-b4aa-f65c5897cd1f",
 CellID->153014549],
Cell[8568, 225, 426, 11, 70, "Notes",ExpressionUUID->"c0e54a83-24de-4797-acc7-d472c6c72528",
 CellID->35843090],
Cell[8997, 238, 486, 11, 70, "Notes",ExpressionUUID->"c7641721-3bc9-4aee-b02b-4ab26b45b5c5",
 CellID->329613761],
Cell[9486, 251, 252, 7, 70, "Notes",ExpressionUUID->"7e7726fd-e27f-457b-b47d-447c081b40b1",
 CellID->57211090],
Cell[9741, 260, 418, 11, 70, "Notes",ExpressionUUID->"711dc38d-ddd8-4469-a500-dee8f28e1488",
 CellID->120633291],
Cell[10162, 273, 477, 12, 70, "Notes",ExpressionUUID->"e0c52658-4fc2-4749-b071-60abdbf99cd5"],
Cell[10642, 287, 2271, 55, 70, "3ColumnTableMod",ExpressionUUID->"c65a62f6-303c-4c9c-a19d-51f5328b561d",
 CellID->318258773],
Cell[12916, 344, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"a1cee5f4-8b52-434b-9ef3-ccb9f387ea0f"]
}, Closed]],
Cell[CellGroupData[{
Cell[13039, 349, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"9cc2e52b-7ac5-4ab5-a208-1e1fe5d35b01",
 CellTags->"PrimaryExamplesSection",
 CellID->188512225],
Cell[CellGroupData[{
Cell[13499, 364, 308, 7, 29, "ExampleSection",ExpressionUUID->"405053a6-07c7-4d6d-ba94-9598eb33ecc2",
 CellID->413276408],
Cell[13810, 373, 114, 1, 38, "ExampleText",ExpressionUUID->"a3dd8a1f-5a41-4ae2-a9fe-ea7ed1dc4e58",
 CellID->62019171],
Cell[CellGroupData[{
Cell[13949, 378, 1513, 39, 123, "Input",ExpressionUUID->"09f52b79-923f-43e7-ac67-abb883e9cfab",
 CellID->32120805],
Cell[15465, 419, 39829, 784, 197, "Output",ExpressionUUID->"7a41f5ab-f630-41b1-a535-43f9d49093d1",
 CellID->5606840]
}, Open  ]],
Cell[55309, 1206, 127, 1, 38, "ExampleText",ExpressionUUID->"bd838bb7-f921-4518-ab15-9991e2663166",
 CellID->11107624],
Cell[CellGroupData[{
Cell[55461, 1211, 277, 7, 26, "Input",ExpressionUUID->"3036a852-2c0a-4780-abcf-942ebaf91f7b",
 CellID->579103683],
Cell[55741, 1220, 8570, 147, 381, "Output",ExpressionUUID->"a6de3c0d-a99b-4b31-94ab-1905095e19c8",
 CellTags->"RasterizedOutput",
 CellID->20519931]
}, Open  ]],
Cell[64326, 1370, 122, 1, 70, "ExampleText",ExpressionUUID->"6c57a790-499f-4f5e-b86a-5da042270b1c",
 CellID->132932993],
Cell[CellGroupData[{
Cell[64473, 1375, 541, 15, 75, "Input",ExpressionUUID->"e15d4cf1-b09d-44c2-a2f5-0042b192494a",
 CellID->309499686],
Cell[65017, 1392, 10841, 185, 381, "Output",ExpressionUUID->"b80db8a2-736d-49c8-b8ca-7a092b3d19fc",
 CellTags->"RasterizedOutput",
 CellID->345002701]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[75907, 1583, 284, 7, 70, "ExampleSection",ExpressionUUID->"cc481aec-9e6e-4b76-a7ff-0146f0a579ef"],
Cell[CellGroupData[{
Cell[76216, 1594, 310, 7, 70, "ExampleSubsection",ExpressionUUID->"5dd44aa9-dc01-4b9a-8fae-4598ecd343a2",
 CellID->266667140],
Cell[76529, 1603, 189, 4, 70, "ExampleText",ExpressionUUID->"b86ac3ed-1b95-4ac9-93cb-8c367a86da68",
 CellID->111123942],
Cell[CellGroupData[{
Cell[76743, 1611, 541, 15, 70, "Input",ExpressionUUID->"56435552-2807-4993-a307-67e881abcd79",
 CellID->414899548],
Cell[77287, 1628, 10840, 185, 70, "Output",ExpressionUUID->"838506dc-5d81-494a-8b92-7fe844a2019a",
 CellTags->"RasterizedOutput",
 CellID->99528209]
}, Open  ]],
Cell[88142, 1816, 390, 10, 70, "ExampleText",ExpressionUUID->"7c27687b-9927-4bd4-9a46-0ee86a0582d8",
 CellID->167673422],
Cell[CellGroupData[{
Cell[88557, 1830, 618, 17, 70, "Input",ExpressionUUID->"978342d5-336c-4004-8b96-5f77f9a4ffbb",
 CellID->85782494],
Cell[89178, 1849, 10284, 176, 70, "Output",ExpressionUUID->"e872d4c2-48ec-4430-8558-00d629e65fd0",
 CellTags->"RasterizedOutput",
 CellID->352900243]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[99511, 2031, 292, 7, 70, "ExampleSubsection",ExpressionUUID->"e45a098c-f15d-4090-b3f5-77d72453ffaf"],
Cell[99806, 2040, 137, 1, 70, "ExampleText",ExpressionUUID->"0ecab717-4778-40a5-8ac5-3148e0f92e8f",
 CellID->8253780],
Cell[CellGroupData[{
Cell[99968, 2045, 345, 9, 70, "Input",ExpressionUUID->"b3e135aa-06d5-491a-bc84-2d6c1d241fad",
 CellID->852940988],
Cell[100316, 2056, 8726, 150, 70, "Output",ExpressionUUID->"c5577508-d8ae-4d3a-973d-556e55e86fef",
 CellTags->"RasterizedOutput",
 CellID->181073946]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[109091, 2212, 292, 7, 70, "ExampleSubsection",ExpressionUUID->"03b85fa1-8fe1-4343-a23f-dd90f4e1fea6"],
Cell[109386, 2221, 139, 1, 70, "ExampleText",ExpressionUUID->"1cad1220-1fc3-42be-a50d-0edacb2a396b",
 CellID->813250167],
Cell[CellGroupData[{
Cell[109550, 2226, 345, 9, 70, "Input",ExpressionUUID->"ebc676ba-77e1-4986-af19-8cb5c63e9b99",
 CellID->121790852],
Cell[109898, 2237, 8173, 141, 70, "Output",ExpressionUUID->"d01775aa-1f5e-45a2-bdbb-781943f5febe",
 CellTags->"RasterizedOutput",
 CellID->105936974]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[118110, 2383, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"6750b990-b114-4335-b59f-e5d4c177fcc9"]
}, Open  ]],
Cell[CellGroupData[{
Cell[118233, 2388, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"ac98dcee-e08e-4472-a12f-cfbcd5fe58f1",
 CellID->1255426704],
Cell[118496, 2397, 1463, 38, 70, "SeeAlso",ExpressionUUID->"053a5ed2-34d9-459f-b469-37b83bcba204",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[119996, 2440, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"18f72d0e-2f66-4c54-b4e0-c2ac75f84796",
 CellID->38303248],
Cell[120265, 2449, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"2de658f3-0381-4319-a1e3-bb060d302af3"],
Cell[120354, 2451, 247, 6, 70, "MoreAbout",ExpressionUUID->"0c0a92e3-c916-4b0b-a6a5-8f216b8e296a",
 CellID->448876740]
}, Open  ]],
Cell[120616, 2460, 78, 0, 70, "FooterCell",ExpressionUUID->"e7e61c13-0f81-46ad-b130-28faa7abf814"]
}
]
*)

(* End of internal cache information *)

