(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    143877,       2957]
NotebookOptionsPosition[    136058,       2792]
NotebookOutlinePosition[    139162,       2865]
CellTagsIndexPosition[    139038,       2859]
WindowTitle->FigColumn
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "8b9f0e45-12ea-4c8e-afd1-5283f5e63b05"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"e006e3d6-8f53-44c4-b90f-3d0e24746692"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"FigGrid\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/FigGrid"], "\<\"Fig\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/Fig"], "\<\"SciDrawPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SciDrawPlot"], "\<\"DTPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DTPlot"], "\<\"DataTable\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/DataTable"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "32fb2be9-ad2d-48d6-a740-a0112f4b6145"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"246c4613-3b90-422e-b14c-a3fbb516f19b"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0ffc629b-204f-4a37-b5a0-5f65cd060cb4"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"14592efe-95da-46aa-a08f-f22e6014a505"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/FigColumn\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/FigColumn"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
FigColumn.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$20854], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/FigColumn", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "53e9a758-f49d-461a-932b-9e6fe2cf91cc"]
    }], "AnchorBar",ExpressionUUID->"88030269-2cf3-4a6a-9e7f-c0878189ac7c"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"578a2c95-7324-40d7-8df8-aa0391fb4f65"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["FigColumn", "ObjectName",ExpressionUUID->
  "4576d7fd-f89f-4174-8ba6-cc7a7af6cc9e"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"448067d1-667c-4eae-8b9c-70ca7ab063c0"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "634f995e-e5b4-4610-a4ff-0a13e1984533"]
}], "ObjectNameGrid",ExpressionUUID->"fe61da73-b2f8-405b-8e58-a2a12a837c5f"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FigColumn", "[", 
       RowBox[{
        StyleBox[
         SubscriptBox["datatable", "1"], "TI"], ",", 
        StyleBox["x", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "d34fe745-820b-4d65-b6d5-bd1abd7b4959"],
     "\[LineSeparator]returns a figure with vertically arranged panels \
plotting variable ",
     Cell[BoxData[
      StyleBox["x", "TI"]], "InlineFormula",ExpressionUUID->
      "5f03a4c3-03b8-43cc-8f20-f4dfb4e4543a"],
     " vs. all other columns in the ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "25a17377-d7df-4b66-afc0-2dc85d475331"],
     " using the SciDraw package."
    }],ExpressionUUID->"53d668ef-96db-4f51-a1a8-09c01a227495"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FigColumn", "[", 
       RowBox[{
        StyleBox["datatable", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["ycol", "TI"], "1"], ",", 
          SubscriptBox[
           StyleBox["ycol", "TI"], "2"], ",", ".."}], "}"}]}], "]"}]], 
      "InlineFormula",ExpressionUUID->"271dc22c-f40e-4214-b8af-8bae1d22a461"],
     "\[LineSeparator]returns a figure with vertically arranged panels \
plotting variable ",
     Cell[BoxData[
      StyleBox["x", "TI"]], "InlineFormula",ExpressionUUID->
      "827297d0-ed14-44bd-82f7-4eb4e71b051e"],
     " vs. columns ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["ycol", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula",ExpressionUUID->
      "a70bc7f5-722b-4263-88e8-1c5da3ec00aa"],
     " in the DataTable using the SciDraw package."
    }],ExpressionUUID->"7348888f-d657-4139-a7ca-2b2e0ee7d687"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FigColumn", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["dt", "TI"], "1"], ",", 
          SubscriptBox[
           StyleBox["dt", "TI"], "2"], ",", ".."}], "}"}], ",", 
        StyleBox["x", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "42ab1f6a-376b-43f3-871f-bf459ae980ca"],
     "\[LineSeparator]plots the variables for DataTables ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["dt", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula",ExpressionUUID->
      "aa3f9e71-4cce-43d1-a2ca-4f3ee0cf1d66"],
     "."
    }],ExpressionUUID->"a8b1f3fe-0108-42e4-bfec-119698639cf1"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436,ExpressionUUID->"ab6e58ca-f3a5-4b42-ac9e-53bca8d24c41"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"79f8bb78-6f62-46fe-8366-81077391df32"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"792b006e-357e-4bbc-a3b2-afa310d74f94"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"62213f6a-10d3-4a3f-89a7-ad536a25c926"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->95805692,ExpressionUUID->"a4bad988-afa7-4cfe-b0b4-3c977426f218"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"ff97d44c-79cb-48bd-a2e0-234a69a5ae67"],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigColumn"]],"paclet:DataAnalysis/ref/FigColumn"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f7c5cf65-6ceb-45a1-8392-27f4d64afe46"],
 " requires that the SciDraw package, created by Mark A. Caprio, University \
of Notre Dame, is installed. The package can be downloaded at ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["https://scidraw.nd.edu/."]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "89c908a1-c941-4df0-95e0-88c7662ba2d6"]
}], "Notes",
 CellID->632098388,ExpressionUUID->"d6808db6-5336-460c-91ab-236378855409"],

Cell["\<\
The SciDraw package allows the preparation of publication-quality scientific \
figures.\
\>", "Notes",
 CellID->153014549,ExpressionUUID->"c4250d33-8b6b-4545-bc4f-80a29beb5434"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigColumn"]],"paclet:DataAnalysis/ref/FigColumn"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "04eac3d1-8428-4eef-8b11-ac42fc72b3ab"],
 " function automatically produces simple figure columns with SciDraw, and \
styling options are limited."
}], "Notes",
 CellID->21661976,ExpressionUUID->"64959e17-5f12-45e1-8327-b892f5765c6a"],

Cell[TextData[{
 "More flexibility can be achieved using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDrawPlot"]],"paclet:DataAnalysis/ref/SciDrawPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "8b0ab280-4014-4700-b69b-32e8920fa72c"],
 " function, which is produces a DataPlot object which can be included into \
complex SciDraw figures."
}], "Notes",
 CellID->465025006,ExpressionUUID->"26dde9ae-c401-45c3-9bee-a2f8cf8665f3"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigGrid"]],"paclet:DataAnalysis/ref/FigGrid"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "7aeb2867-3842-4bf1-b1b0-7953855e6195"],
 " function can be used to produce figure grids with more than one column."
}], "Notes",
 CellID->573315287,ExpressionUUID->"2eacbd45-eb6c-4e32-870e-d46a17fad3c2"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Fig"]],"paclet:DataAnalysis/ref/Fig"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "5a0c884b-71d5-4707-8868-2dade67b3923"],
 " function can be used to automatically produce single figures with SciDraw."
}], "Notes",
 CellID->210011063,ExpressionUUID->"986bbefd-035f-4053-a5a6-a334b6d03a19"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigColumn"]],"paclet:DataAnalysis/ref/FigColumn"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "bda9becd-795b-453a-ac73-17e862e24b4b"],
 " takes the same options as Figure, Multipanel and DataPlot (from the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDraw"]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "433c495f-ebb4-46ef-b4ed-9a4d83ccf83b"],
 " package) with the following additions: "
}], "Notes",
 CellID->52142193,ExpressionUUID->"80d4d2f5-bb8d-4002-9554-8edc12a479a8"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "14bf79e4-1c18-4a40-af82-a7de99e9e01a"], 
    ButtonBox["ShowLegend",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/ShowLegend"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "Specifies if a plot legend should be shown", "TableText",ExpressionUUID->
     "e2d3b354-a3ec-4503-81e0-01480724cc5b"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "bfa46d52-9d56-42c7-9de7-6049633fe2e1"], 
    ButtonBox["XLogScale",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/XLogScale"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     "Specifies if ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Log10"]],"paclet:ref/Log10"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       StyleBox["x", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "2a6ea14b-8547-45d3-8016-b6d8e60c4302"],
     " should be applied to the x coordinates in the plot"
    }], "TableText",ExpressionUUID->"714cdbf5-5e1a-4e3d-bb33-3ef742ed87cf"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "4e061bbd-2247-4ea6-ba64-44fb6f07aaa8"], 
    ButtonBox["YLogScale",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/YLogScale"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     "Specifies if ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Log10"]],"paclet:ref/Log10"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       StyleBox["y", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "f39b7257-1c82-440c-835d-0689bbaf0731"],
     " should be applied to the y coordinates in the plot"
    }], "TableText",ExpressionUUID->"9126a9bc-7c31-4043-9fc1-eea0c2506a5d"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->318258773,ExpressionUUID->"5d6ce85d-e9a6-4351-8632-20c7d18cee3e"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"a7c91638-0c68-4db0-a047-5465f38f7aba"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"68db10df-be5b-4d42-8f83-39a6a6926b73"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "91ec7a54-860b-45da-9bd5-bf535e536d19"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->26058608,ExpressionUUID->"df5705d4-042f-4c4f-9979-86a1c9bd7375"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "b22a0a1a-cef4-42e4-beb2-639cef43236d"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->12126410,ExpressionUUID->"3c7f94e4-2aba-4fff-87aa-f43a2e8f94e7"],

Cell["Define some data:", "ExampleText",
 CellID->62019171,ExpressionUUID->"b636fc8b-bb53-4963-aa0c-5c8ca54e09fe"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<ID\>\"", ",", "\"\<a\>\"", ",", "\"\<b\>\"", ",", "\"\<c\>\""}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.05"}], "]"}], ",", "2", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.7"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<l\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.3"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"6", ",", "0.2"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<m\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"7", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"8", ",", "0.1"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.9"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<n\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1.5", ",", "0.8"}], "]"}], ",", "8", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
    "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->190611702,ExpressionUUID->"b3fcfff4-2148-446d-8533-5a32b3cc7ca9"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 10612995242620]]]]], Appearance -> Automatic,
         Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 10612995242620]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499], "b" -> 
                 8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 10612995242620]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499], "b" -> 
                 8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 10612995242620]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[0]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`UnknownShape, "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 4, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[1219734649], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1219734649]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.000\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "98", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.0\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "14", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"6.00\"", 6., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"7.00\"", 7., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"8.00\"", 8., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.0\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[157616911][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[157616911][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {267., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->557739664,ExpressionUUID->"3d1dbc83-4f25-4e7a-9733-083c0c15798c"]
}, Open  ]],

Cell["\<\
Draw a column of figures plotting a on the x-axsis and b, c on the y-axis:\
\>", "ExampleText",
 CellID->22770873,ExpressionUUID->"bb0f8726-a22c-4bee-982c-acded7eaa746"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FigColumn", "[", 
  RowBox[{
   RowBox[{"{", "tbl", "}"}], ",", "\"\<a\>\""}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->865837,ExpressionUUID->"2600fdbc-69f7-4c9d-887a-4df4310308c1"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3VFQG+e993G9xcd2cZu4TpuKQGNsE6zYxJYhh1DsAsFJKocYaWLngPE4
JPExxJOkxvbJq3RsvzR5e9DbUVJppuVl4pyTXjRzmDkz73DhiZlc6SIXXDK5
ojO+4JJLXepS7yMWxFqAtKxWu/s8z/czakd21s8+z2r10+5fq30OvXfjzbEf
BQKB23vF/735bvzlW7fe/f2F/eIPb/3u9vXx313713O/+7dr49dudb1XJ/7y
/f8RCOTF/wrP8wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
+M/f//73urq6AAAgEDh//rzXqeyS6enpY8eOHThwoOKSk6sqLtbc3Ly8vFx+
GbGAWMzNNWYymb6+vopNvfPOO3/7298qLib2kIrLiHZEaxUXE70SfSu/DJur
yJ+bixeoyJ8vkMXN1d/ff+rUqUgkUnFJNRiv6dzcXMUlxRZeXFysuJiV1yKX
y83Pz1dsSqyuYlOClc5ns9mK+2Te8pvFwc0ltoPYGuWXsbi5LL5ZHFyjgy+Q
xWwRL6J4KR1Zo4MvkMU0c39/tri5rIS/+/uzJ4GTTCat7IdqsPimsy4Wi1nZ
3/xJhKeV95Q//W2V172wSWx2K59c/iR2eLHbe90L+6wcFfuWs4HjeB76xKN0
91pVa+xh8S/v37/f0dEhRWgYRzszMzNWjgfAVoJviWP1ahLbOFQQrl692t/f
Pzo6eufOHfHHKnPsq6++ikajg4OD1TTiRyL6u9OP1p5txP/09HQ4HE6lUh52
zQpx1tZ08MjhUHtb9/nG5tah4cvynl+4wGKRE/CExfrqdsS/vX379uGWo79s
ajly6pWGg8//ItgkPggSiUTFotN2xOfR008/LcJfwZr/Y+G/9iwvyWnOwsKC
CPy3Pv7m7U+/NR49F26dCHd43S//IvzhZ1WGv0j4F052vHzpbjEQoh99+atD
R6s52zW+uJEiD+1Yq/tsJH9ekvBvDbW9cf0vxRfaeIR7Lnz+xZ+97ppPEf7w
syrDX7zxxdu/JBBERIigsN2myuH/cCywVdnn/PnzDQ0Nvatu3Lgx6T/xeHzX
7r0lL7R4iM/94DO/8rp3PjU6OhoOhz3c3YAyLl68GI1Gbe/eraHj5sP+4mPP
3noRF/ba7Onp2bdvn5I1/8dqPeKDYD39X3/99WAwaIT/+Pi47Zejdj788MM9
P963+YU+e+Wzp37R4HXvfEqEf1ub/aMgoKZEwFYT/odbjoq3/+ZMqP/Jk7dv
37bR4J07d06fPl1fX69mzX/jyN/8VI6yT/CZpjdvfl3yQp/qv3zv3v/yums+
RdkHflZl2Ue88cXbvyQQRESIoLDdpspln9XM33yppxSDnZubO3L8pcv35oov
9LlrXzx39Ljtb/aVR/jDz6r/wveXDU3Rj74sBsLw7//7cKi9mh/pqB3+W5Ll
Ov8/JT9vaDrU1n3+ZN/I0fBvToQ7rPxYUluEP/ysyvAXR4Pj4+O/CDYdDHUW
AuHF3/7s58ELFy5Wc8m6yJNgMKhkzX87slznn199dWZmZiYnJ638/l1zFn/P
DnjC4p0utiMSwCjUDw0NnTx5cmBgwCj1V5ljn3zyiZo1/21odZoDAGVolYda
DRYAytAqD2Wp+QNATS0uLkaj0YsXL3rdEZckk8lwOFzNPTEAQAFzc3PU/AFA
Q1rloVaDBYAytMpDav4AkKfmDwBaouYPAHrSKg+1GiwAlKFkHm5M4Bt4bEIX
av4AkNeh5v/YXC7U/AGgQPmav2kilwIlT3MAwAaV8/CxCb0KVB4sAOyEwnlo
nsPLYNT8jbnMstmsVx0DAA+J2BcZqG7Nv6TkU2DU/I3wX1xc9KZfAOCdXC6X
SCSM8Fez5r+p5pNX+jQHAHZE2Tzc4sBf3cECwA5plYdc5w8AeR2u838c1/kD
QF6D6/xLaHWaAwBlaJWHWg0WAMrQKg+p+QNAnpo/AGiJmj8A6EmrPNRqsABQ
hlZ5SM0fAPLU/AFAS9T8AUBPWuWhVoMFgDK0ykMxWHGaw82cAWhueXk5Ho8P
DQ153RHnbczhbrq3Zzqdbmxs1OfDDgC2lEqlQqFQb2+v1x1x2sbN/B+bwV2r
0xwAKEPJPNxqIpcCJQcLADYomYeFiVzS63UfU9nHqPlnVjGHLwA9LSwsiAxU
suYvwr84d7t5Ri+j5t+3Sozds/4BgEdyuVwsFhMZqGTN3xz45hKQkqc5AGCD
mnloSn/zB4GagwWAnVM1D4uXepq/+eU6fwDIK32d/5a4zh8A8gpf578NVU9z
AGCntMpDrQYLAGVolYfU/AEgT80fALREzR8A9KRVHmo1WAAoQ6s8pOYPDxk3
VNmMSUXhPmr+gDuWlpb61rW1tTU1NRX/ODs763XvoB1q/oD72A/hB1rth1oN
Fr7Ffgg/0Go/pOaPLeVWuba6qakpsR+6tjqB2StQQuGaf+GW/psm8aXmjy0l
VrmwooWFhYOHWg483Rh8NrR7957P/vcf3Vmpy5818D9pa/4b07OXzNVlWmCL
iRy1Os2BdZOrar0WEcKHWl+IfvTl259+Kx6X782Fey6MX/+w1uvNZDJ9fX21
XgukI2EeFpLfnOylf86XTNu+QcLBwg3uhL845i8mf/FxsKVNfCjUdL2EP7Yk
YR6ap2fZ5m/EX3R3l5/Dl4urUXTnzp3R0dEtL8J3yldffRVsOlKS/OLR/so7
w5dGarpqcYIv3g1eb2P4yOLiYmZ1Dt+RkRGv+7IzhWgvOfLffJj/6NGj9f9a
/I/JZDIYDBoXV9f6cAsSuXr1anNzc18ttbe3PxU8tDn8u974oPFXB2u66nA4
3Nra6vU2ho8U5/Dt7+/3ui8Wmb7FLbVFkcfAHL6oyIWyTzab3X/g55fvzZWE
f1v3+ZmZmZquOkPZB1tRMw9NdSDzkb+ag0XV3Kn5f/L7ux39w+bkf+P6X547
erzWFUjCH1tSNQ+LJwnM4YuK3Al/EfJDw5db2rq63vjg5Ut3T/b+y7EXTi0v
L9d6vYQ/NltZWZGx5m+bUfOPxWJedwT+Ynwx6s665ufne/r6n20+kkgk3Pnt
lXib17qyBOmIXUKqmn+1VD3NgVzYD+EHWu2HWg0WvsV+CD/Qaj+k5g+v5HK5
RCJhfLkQjUbD4fDkOnZIuI+aP+CObDZbTHvxphsdHS3+0bWvG4Aiav4AoCet
8lCrwQJAGVrlITV/AMhT8wcALVHzBwA9aZWHWg0WAMrQKg+p+QNAXoOaf8ls
jtT8ASCvfM1/dabfkrt66nOaAwBlqJuHhaP+sbFuwh8ANlM1D42CT0nZhzl8
AUDeOXwrWw/9LWv+xsSmzOELQE8SzuFr1WqxfwNz+AJACbXzcHPZR+HBAoB1
aufh5vAfGBhYWlrysEsA4Dnlr/MvkU6ng8Hg8PCw1x0BAC8lEolQKHTmzBmv
O+IStU9zAMA6rfJQq8ECQBla5SE1fwDIU/MHAC1R8wcAPWmVh1oNFgDK0CoP
qfkDQJ6aPwBoiZo/AOhJqzzUarAAUIZWeUjNHwDyStf8H46t3c957OHGX1Lz
B4C8wjV/Ef1rob/xLK/ZaQ4AlKF6HhL+ALAFhfPQmM/LXPYxav7M4QtAZyrP
4WtiPvQ3av7GHL7z8/Oe9gsAPCCOeyORiDGHr4I1fxPzZF4Kn+YAwI6omYem
w33zkb+agwWAnVM1D4uXejKHLwCUUPg6/y1xnT8A5BW+zn8bqp7mAMBOaZWH
Wg0WAMrQKg+p+QOAkM1m4/H4lStXvO6IS6ampoLBYCwW4xdeAHSWSqVCoVBv
b6/XHXGJVqc5AFCGVnmo1WABoAyt8pCaPwDkqfkDgJao+QOAnrTKQ60GCwBl
aJWH1PwBIK9yzd+YyKV0Et8qa/7Nzc3F5//xn18Hn2kSze/eveedd/9VbEnj
7ycmJubm5qrsPQDUlKo1/0L0r2W+6WnVpzki6o0n49c/fKHr3Js3v377028v
35s7Hf2wpfXYysqK+E+ifbGWqnoPALWnfNnHwclcjPDPZDKHQ+0i9s2Pl4c+
GYxdyBP+ACSheviXTuBenMPXRlsi/MU/7Oo+czp2syT8xWPXrn/67rvvRPuE
PwA/W1paMubwVbHmbxDJb57LZa3mb8zhayP/RfiLf7i3/qfnrn2xOfz31j/x
4osvivbFWhwcAwA4KJfLxWIxYw5f9Wr+BYVi/2PJn3eo7PPe1Wtdb3ywOfz/
afcesVUp+wCQgppln8e+5t3gSPiLM6ZfHTp6+d6cOflfOvfezVsf56n5A5CE
kuFfnMC3ZBrfKq/zL17t8803/yXy/3Ts5mvv/p+zVz57vuPsq78dMC4fJfwB
+J+61/lvrcrr/M2fkuITZHjkSmfX6Z6+s7Ozs8W/n5mZWVhYcKCvAFAzql7n
vx3HT3Pm5+flvUdcJpMp/jZNOsvLy4uLi173wiax2e1db+YHYocXu73XvbBP
6t9gOhs4SpZ9tuP4YJubm0UKOdigm6SuUE2u8roXNkn9phM7vPmn7tIpFm9l
5GzgSL0f7pQY7CuvvHLy5MmKS6ZWVVzMymuxsrLS1dXl1BpFU8ZPicsQh8Sx
WKxiUxbD38o7XRxNTUxMVFxM9Kri4brFzWUx/B3cXBZv3GFlc1l80zm4uRzc
uyyGv/v7s8UXyEr4u78/Oxg4FjfX9evX33zzTX1q/n/4wx92795dV1fX09PT
V9bhw4fFdi6/jFBfXy9e2fLLiAXEYhWbEqsTK6242N69e7u7u8svEw6HDxw4
ULGpYDB47Nixiov96Ec/qrhMKBR65plnKi62f//+9vb28stY3FwOvkCiS6Jj
FZsSAxTDrLiYlc0lNnvx9yZliBdRvJTllxE7g9glKjbF/lzE/mx48skn9+zZ
8/zzz3udyu75f6sylXz33XcPHjyouJiVpiwuJlYnVurmGh1syv3NxQu0o8XY
XDtaTJ/9+YcffvA6kgEAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAADAvuXl5cA2
5L2xNlwm9T3kvTU7O7vdGxAAdBONRr1OZZeIQ6yLFy9auRu5xdvFW/kgtnj/
cwfXmMlk+vr6KjZl8X7+AQv3P7d4g3rRq0ylGax02FxXr15taWmpuJg/N5cO
L5Bv9+ddu3Z9//335ZexvrnEfqjVZC5isFam/8tms1ZOryyehVlZo2jHyqSK
VprK5XJWJqm3+GZxcHNZnHjRymIW3ywOrtHBF8hi+IsX0cqcfS6/QBbTzP39
2eLmshL+7u/PFtdoJfwtrlGsbnp6Wp/wv3//fkdHh4Ml1omJCXmnwZV6rvm5
VV73wqa7d+/++te/9roXNokd3sosV74lddw98cQTTt2BX3xARKPRixcvOtKa
rzxKd69VtcYeFv8ymUyGw+FEIiHvrOuoBTengxfrunTpktgPK1YMnCL7lOso
cvALX3HsJMI/Eok40pqPiOjvTj9ae7YR/1pNWAzrXJsO/k/JzxuaDh3vjp7s
Gzkcau/pO+vCmaPFIjD8jwncK9rI/scpOVhUz53w/4///Pr5jrOX7829/em3
xuPlS3c7u07Xer2EvzII/4oejgXG0ut1H1PZR8nBonouhH8ul9v3kyfMyW88
jr8UqfV1/oS/Mgj/ikT4B9YP/QsfBOvxPz09HQ6HjXe6azVe+N+NGzd6e3sn
a+nq1au/bGopSX7x6Hrjg44XO2u66tHR0ba2Nq+3MRzgSPiL45BEIiF2DCVr
/ubAN5eAjKt9jHcEP5RDUTwer3X4j4+P/zx4cHP4/3Nk7KWuX9d01SL8xTGP
19sYDnDqyD+VSk2uhv/g4GD1rfmLKf3NHwRKnuagekZI1nQV4nDrlw1Nb338
TUn4Hw3/ptbXrFL2UQZlHyuKl3qav/lVdbCokgvhL8zPzzcfPTX8+//eqPkM
jA/GLtR6vYS/Mgh/27QaLKxzJ/yFb775r8ZnDz/b2n7kZF9jc+vQ8GUXfnJC
+CuD8LctmUwGg8FYLOZ1R+AvFn9c74iVlZVbt26dOXPGzUsOuLxBDQ6G/8zM
TCgU6u/vd6Q1/xOfdJFIhDcCvKXVERcc5GD4i4OQeDw+MjLiSGv+x5sOfsB+
CHso+9im1WDhW+yHsIfwt02rwcJvFhYWMqvE6XYkEsms4zaDsIjwty2dTtfV
1fGDF7hvaWmpb117e3tra2vxj7Ozs173DnJwMPwnJiYCgUBnZ6cjrfmfVp90
ABTDkb9tWg0WgGIIf9u0GiwAxRD+tonBDgwMWJkPFAD8xsHwz2az8Xj8ypUr
jrTmf1NTU8YvfLm+AoB0HAz/VCoVCoV6e3sdac3/tDrNAaAYyj62aTVYAIoh
/G3TarAAFEP428aN3QDIy8HwF+3E4/GhoSFHWvOVwjS+gdIZ3NPpdGNjoz4f
dgA8J442s9ls9e1kMpn9+/d/+eWXjrT2wQcfKPqFr3nm3g1aneYA8AOROSJ5
qmlBHKWfCHccDrWf7Bt57sTppoNHxAdBlQ2Kkwg187AwiePGAX+RmoMF4GNV
hn8ul3vu6PFz174ozv751sffND/3wsLCgu02VQ7/h2OB7u7u0qoP4Q/AbVWG
/x//fepU33Ax+Y1H9KMvDx5qsd2myuEvPHpkVH3ESUAx/qenp8PhsDFhq2vT
9gHQ2eDgYDQanbTrcMvRs1c+Kwl/8diztz4ej9trs6enZ9++faJXom9eb54a
Mlf/CX8ALqsy/FtDx1++dJfwt+rhWLHaYz7yV/Y0B4BfVVn2+fyLP4d7LpQk
/xvX/9IaarPdptpln+KlnuaLflQdLADf4gtfP9BqsAD8gEs9/YAfeQFwGT/y
8gNu7wBAXtzewTatTnMAKIYbu9mm1WABKIbwt02rwQJQDOFv29TUVF1dXSgU
YhpHANJxMPwnJycDgcCZM2ccac3/tPqkA6AYjvxt02qwABRD+Num1WABKIbw
t02rwQJQDOFvWzqdrqurC4fDXndkW9lsdv/+/YGtTE5Oet07AF5yMPwnJiZE
qnR2djrSmv/J9UmXyWT6+vq87gUAv+DI3za5Bkv4AzAj/G2Ta7CEPwAzwt82
uW7sRvgDMHMw/FdWVuLx+MjIiCOt+ZB5DkchmUwGg8FYLOZhlyzKZrOpVKq1
tVWWjypvsZWgAwfDf2ZmJhQK9ff3O9Ka74jol3Mmr/n5+aaDR55tOfFc+6uN
za1Dw5cduYO3qjhFgiYo+1hTOOofG+uWLvwXFhZE4L/18TfFWdt6Ltw6Ee7w
ul/+RfhDE4S/FUbBp6TsI8VgW0Ntb1z/S8l8zeGeC59/8Wevu+ZThD80QfhX
th76JeF//vz5hoaG3lU3btyY9J94PL5nb31J8ovHy5futoaOe907nxodHfXz
D/cApzgV/qlUSrxxotHo4OBg9a35ymqxf0Mx/19//fVgMGiE//j4uNehtYXb
t2/X/+TJzeF/9spnh1uOet07nxLh39bW5u0uB7jAkfDP5XKJRGJyNfwjkYgT
/fIjGcs+Bw+1RD/6siT8T/UN//Hfp7zumk9R9oEmKPtYJ2P4z83NHTn+0uV7
c8XkP3fti+eOHmcCmu0Q/tAE4W+bLIP9U/LzhqZDx156/WTfyNHwb06EOxx8
xdVD+EMThL9tyWSysbFRjNf/R9HiJb5586Z4rcWJgNd98Tvxas7Pz3vdC6Dm
HAx/kfyhUOjVV191pDX/u3//fiQSWVhY8LojlnBAC8DMwfAX7cTj8aGhIUda
8z+5TnMIfwBmlH1sk2uwhD8AM8LfNrkGS/gDMNM9/B+OBQKBsYeFp5vu3FZB
Op0OBoPDw8O1612VmMYRwHYcDP9EIhEKhc6cOeNIa64Q0f942hc+AIyPgsrE
J93AwMDS0lJNugYAtaT3/fw3Zf2mT4My5DvNAYB1upd9jLrPBquH/XkpBwsA
a7QPf/u0GiwAxRD+tiWTSXGqIDag1x0BgB1zMPwnJydFGEr1hW9VtPqkA6AY
jvxt02qwABRD+Num1WABKIbwt43r/AHIZWJiYstffQaDwWruTizhdf5WFa8H
NV8J6v9f+AKACyT8ha81IvrXQn/jWV6z0xwAKEP1PCT8AWALCufh6m3fHiv7
KDxYANgR5fPQfOh///79jo6OyVXZbNbTfgGAN0TsiwyMRqMXL170ui81JI7/
izd+SyaT4XDYCP/FxUVvOwYA7svlcolEwgj/SCTidXecZjrcNx/5K3+aAwAW
qZqHxUs9zfd7VnWwALBTWuWhVoMFgDK0ysPp6elwOJxKpbzuCAB4aW5uTs2a
/zaMq33E553XHQEAL2UyGRH+g4ODXnfEJVqd5gBAGVrloVaDBYAytMpDrQYL
AGVolYfJZDIYDMZiMa87AgBempmZCYVC/f39XnfEJeKTLhKJ8NteAJpT+H7+
W9LqNAcAytAqD7UaLACUoVUeajVYAChDqzxMp9N1dXXhcLiaRpaXlzPrHjx4
UHzOVwkAZGFMDdzZ2el1R1ziyCfd5ORk37r6+vru7m7jORcRAZCIVkf+jg+2
ublZnAg42CAAuIPwrwbhD0BSuoX/wMDA0tKSUw0S/gBklM1m4/H4lStXvO6I
S6ampoxf+OZyOUcaJPwByCiVSoVCod7eXq874rhH6e61mbw2JnGk7AMA65Qs
+xSify3zTU8JfwBYp2T4m4n0L07jS/gDgEH18H84Zqr7GDd2M36Tlc1mq2+d
8AcgnYWFBZGB8Xh8aGjI677UiEj+4lF/QTqdbmxsNH6TJcZe/QoIfwByyeVy
sVhMZKCiX/gaxf7Hkj9P2QcA1qlZ9nnsa94NhD8AGJQM/4djATO+8AWAEkqG
/3amp6fD4XAqlXKqQcIfgIwymUw0Gh0cHPS6Iy4h/AEgr1/4U/YBAINWZR/C
HwAMhH81CH8AktIq/I0feTk4XsIfgIzUvavn1ozbOzg42S7hD0BGIriUvr1D
Kco+AGDQquxD+AOAgfCvBuEPQFJahf/U1FRdXV0oFGIaRwA6m5ycDAQCZ86c
8bojLuHIHwAMWh35E/4AYCD8q0H4A5AU4V8Nwh+ApLQK/3Q6XVdXFw6H7f3z
zdP+NjQ0/PDDD+WXAQC/mZiYCAQCnZ2dXnekRh6bvT1f9Sfd/v37jSe5XO7m
rY93797zs6cP/njfT0+EO5aWloz/9P7778/OztrvMgC4Qt0jf2M6LyfDXzRn
PHn1twMvnXvv8r25tz/9VjzOXfvi4JGQkf+ifbGWavoNAC5QNPwfpbtF7Dt8
5G+Evziwf77jrBH7xYfIf3H8nyf8AUhC0fA3bBH+kUgks8rG77xE+It/2Nl1
+uVLd0vCXzx+XP+TBw8eiPYJfwB+tri4KKIsHo+PjIx43ZcaKQ3/ZDIZDAb7
Vi0sLOy0ORH+4h/+/OmGs1c+2xz+9T/9WVdXl2hfrMXBMQCAs2KxmIiyUCjU
39/vdV9qpCZln9v/9j9ffO3dkuS/fG9u9+49eco+ACShW9mn+vBfWVk51PL8
mze/Nof/idPn/zr9f/OEPwBJEP7WFa/2yWQyTQePnOz9l7NXPvvnyFhLW9fb
71w1/hPhD0AKSod/qfv373d0dNgO58nJyeLzbDabSCR++uSBt0ffnZ+fL/79
7Oxs8Zp/APAncQQbjUYHBwe97ohLpqenw+FwKpVyqsGnnnrqH//4h1OtuWxu
bk7ee1MYlyt43QubxGYXG9/rXtiUy+VmZma87oV9Dr793Se2vFO3oxd7oAj/
SCTiSGv+Z5zmWLkDQ25VxcV27dr1/fffV1zMwTVavH2ElcUsVqgcXKODTU2u
cnONDjZl8XTbwTU6uHeJT67m5mY312hxMYtNFYu3rq3RwRfI4s3ELHZeq7KP
GOzQ0FAoFKq4ZGJVxcWshP/KyoqDaxRNiQbLL7OwsGDlA91i+BdvalHG7Ozs
+++/X3Ex0auKV9ha3FwWw9/BzWXxxh1WNpfFN52Dm8vBvcti+Lu/P1t8gayE
v/v7s8XNZSX8rW8uQZ/w/+tf/yriOgAACARee+01r1MZAAAAAAAA8I/SH5FJ
4lG6e73kJ2H3jVt1y9n3NeIF6E4/8roXO1bc8jJu+42dXr6+m9+xBTLuPGrZ
Yr4AKRR2pLVem57KYuPzVtJP3rV3soTvX0k/slZt9F3Cfd5M8u4rYev5AqQj
8/tZ0o1f2ORjYxJudpljR+b9/DGS7vQqkv2lkLX/xlmwjF03UkjKLBI7S3d3
t5yVk8KOnk5L2vkNUu43qpI1PFcV3sxS70nybf31N6+sb+JHj4xOG+e9EimU
aNe3uHy7zTrp37FKkXY/Khw6S78fSRehynxtJ92WN79Rpev8OmnTRk1yvhwy
F2/Nm1zOrV8gZf6YNrd0R/4q7DZS7jQKk3I/Ml2wJ+XxZ7H/0vW8SNL3sdRb
vnjaJWPnC6QMGwAAAAAAAAAAAAAAAAAAAADwPblvpw0AsMF0dxapf2cNALCJ
X2wCgEakng8LALBzheCXdxY1AIAd5sBX4q7aAAArNi72KczlyKE/AAAAAAAA
AAAAAAAAAAAAAAAAAAAAAMCq/w+lmTlj
    "], {{0, 360}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 360},
  PlotRange->{{0, 511}, {0, 360}}]], "Output",
 ImageSize->{515, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->383058601,ExpressionUUID->"17586c7c-e98d-4388-a064-f538d8129859"]
}, Open  ]],

Cell[TextData[{
 "Define a second ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "2b4f0d05-c855-4075-b98d-1b4dd2e71aa5"],
 " with more data and plot it in a second column:"
}], "ExampleText",
 CellID->424126681,ExpressionUUID->"054aef2a-de30-41e0-97fd-6df735a08429"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl2", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<ID\>\"", ",", "\"\<a\>\"", ",", "\"\<b\>\"", ",", "\"\<c\>\""}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"3", ",", "0.05"}], "]"}], ",", "3", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"2", ",", "0.7"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<l\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.3"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"2", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"3", ",", "0.2"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<m\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.1"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.9"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<n\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"8.5", ",", "0.8"}], "]"}], ",", "8", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"3", ",", "0.2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
    "}"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->15737845,ExpressionUUID->"3f10e256-b40b-4ace-bd1c-edb433d442a4"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084], "b" -> 
                3, "c" -> DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086], "b" -> 
                DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087], "c" -> 
                DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089], "b" -> 
                DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090], "c" -> 
                DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092], "b" -> 
                8, "c" -> DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 221611853593690]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084], "b" -> 
                3, "c" -> DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086], "b" -> 
                DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087], "c" -> 
                DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089], "b" -> 
                DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090], "c" -> 
                DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092], "b" -> 
                8, "c" -> DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 221611853593690]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084], "b" -> 
                 3, "c" -> DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086], "b" -> 
                 DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087], "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089], "b" -> 
                 DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090], "c" -> 
                 DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092], 
                 "b" -> 8, "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 221611853593690]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084], "b" -> 
                 3, "c" -> DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086], "b" -> 
                 DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087], "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089], "b" -> 
                 DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090], "c" -> 
                 DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092], 
                 "b" -> 8, "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 221611853593690]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[1]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`UnknownShape, "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 4, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[2012015663], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[2012015663]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.000\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "98", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["3"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"2.0\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "14", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"2.00\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.00\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.00\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.0\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"8.5\"", 8.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.00\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[821139987][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[821139987][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {267., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->111478711,ExpressionUUID->"9c961136-7a26-4072-8ba5-bc832458c26d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FigColumn", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tbl", ",", "tbl2"}], "}"}], ",", "\"\<a\>\""}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->120619760,ExpressionUUID->"4c2cd4e1-8a5a-4980-b150-8a6d4ff678bc"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3X9sG+ed53G28g/5t6QoNm3ZsewoFu3YMi05iiorliIlDh1VEmsrkSut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    "], {{0, 360}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 360},
  PlotRange->{{0, 511}, {0, 360}}]], "Output",
 ImageSize->{515, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->387856971,ExpressionUUID->"50cbf289-744f-43ee-aca9-6e6a4b102868"]
}, Open  ]],

Cell["Plot only column \"c\" as the y-axis:", "ExampleText",
 CellID->208967134,ExpressionUUID->"4c1e0ed0-1f6e-4e7d-a231-00f40ec801c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FigColumn", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tbl", ",", "tbl2"}], "}"}], ",", "\"\<a\>\"", ",", 
   RowBox[{"{", "\"\<c\>\"", "}"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->258237459,ExpressionUUID->"277f26b6-0b5b-4d03-bc3a-af1b81946008"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3W9sFGdix/Et5l9sxzgmMRsc8+diyJIY8AEhruPaBA6yxFewCImNKTiG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    "], {{0, 216}, {511, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{511, 216},
  PlotRange->{{0, 511}, {0, 216}}]], "Output",
 ImageSize->{515, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->14511682,ExpressionUUID->"17b1e03e-4950-4699-b812-06ac8b659d56"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"a811c1f0-f076-4402-b247-2bc90961b1dc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"434f0708-d1d0-4a54-aa50-91e4efb66b89"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"05e249d6-9a07-47f5-8c6c-53255f1c3698"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigGrid"]],"paclet:DataAnalysis/ref/FigGrid"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"f5751ba0-7947-433b-af97-bee20ed34de1"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Fig"]],"paclet:DataAnalysis/ref/Fig"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"204e5e3a-0c76-472c-9477-93a33ef662a3"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDrawPlot"]],"paclet:DataAnalysis/ref/SciDrawPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"627fbe1c-f916-4d96-8ae0-970e4c3dafe4"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DTPlot"]],"paclet:DataAnalysis/ref/DTPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"e2889f40-a780-4906-bff5-df524342412d"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"7006382a-d31d-4001-b247-44977060e0dd"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"5159c5d7-b48d-4480-abba-186d5b7eb6c4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"bf7461b9-7b45-43ca-835b-f20179b2fc4c"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"e6c2e044-abe8-449c-81b2-57369a1acfe2"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"d7bc5789-b5ed-4bd7-8fd8-c78b2e9bc692"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->389286083,ExpressionUUID->"e8fd865d-898b-4ff4-a36b-9d66d1406449"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"dfe2aaef-3c9c-4137-bd72-7b5f89f306c5"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"FigColumn",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 29.4953843}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "FigColumn[datatable1, x] returns a figure with vertically arranged \
panels plotting variable x vs. all other columns in the DataTable using the \
SciDraw package. FigColumn[datatable, x, {ycol1, ycol2, ..}] returns a figure \
with vertically arranged panels plotting variable x vs. columns ycoli in the \
DataTable using the SciDraw package. FigColumn[{dt1, dt2, ..}, x] plots the \
variables for DataTables dti.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "FigColumn", "titlemodifier" -> "", "windowtitle" -> "FigColumn", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/FigColumn"}, "SearchTextTranslated" -> 
  "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[15018, 395, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"df5705d4-042f-4c4f-9979-86a1c9bd7375",
   CellTags->"PrimaryExamplesSection",
   CellID->26058608]},
 "RasterizedOutput"->{
  Cell[57674, 1266, 11292, 192, 381, "Output",ExpressionUUID->"17586c7c-e98d-4388-a064-f538d8129859",
   CellTags->"RasterizedOutput",
   CellID->383058601],
  Cell[111101, 2315, 13480, 228, 381, "Output",ExpressionUUID->"50cbf289-744f-43ee-aca9-6e6a4b102868",
   CellTags->"RasterizedOutput",
   CellID->387856971],
  Cell[125046, 2560, 8038, 139, 237, "Output",ExpressionUUID->"17b1e03e-4950-4699-b812-06ac8b659d56",
   CellTags->"RasterizedOutput",
   CellID->14511682]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 138342, 2842},
 {"RasterizedOutput", 138540, 2846}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[581, 21, 4478, 100, 55, "AnchorBarGrid",ExpressionUUID->"578a2c95-7324-40d7-8df8-aa0391fb4f65",
 CellID->1],
Cell[CellGroupData[{
Cell[5084, 125, 394, 9, 52, "ObjectNameGrid",ExpressionUUID->"fe61da73-b2f8-405b-8e58-a2a12a837c5f"],
Cell[5481, 136, 2874, 74, 298, "Usage",ExpressionUUID->"ab6e58ca-f3a5-4b42-ac9e-53bca8d24c41",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[8392, 215, 854, 21, 37, "NotesSection",ExpressionUUID->"a4bad988-afa7-4cfe-b0b4-3c977426f218",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->95805692],
Cell[9249, 238, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"ff97d44c-79cb-48bd-a2e0-234a69a5ae67"],
Cell[9338, 240, 690, 17, 70, "Notes",ExpressionUUID->"d6808db6-5336-460c-91ab-236378855409",
 CellID->632098388],
Cell[10031, 259, 187, 4, 70, "Notes",ExpressionUUID->"c4250d33-8b6b-4545-bc4f-80a29beb5434",
 CellID->153014549],
Cell[10221, 265, 445, 11, 70, "Notes",ExpressionUUID->"64959e17-5f12-45e1-8327-b892f5765c6a",
 CellID->21661976],
Cell[10669, 278, 486, 11, 70, "Notes",ExpressionUUID->"26dde9ae-c401-45c3-9bee-a2f8cf8665f3",
 CellID->465025006],
Cell[11158, 291, 411, 10, 70, "Notes",ExpressionUUID->"2eacbd45-eb6c-4e32-870e-d46a17fad3c2",
 CellID->573315287],
Cell[11572, 303, 406, 10, 70, "Notes",ExpressionUUID->"986bbefd-035f-4053-a5a6-a334b6d03a19",
 CellID->210011063],
Cell[11981, 315, 637, 16, 70, "Notes",ExpressionUUID->"80d4d2f5-bb8d-4002-9554-8edc12a479a8",
 CellID->52142193],
Cell[12621, 333, 2271, 55, 70, "3ColumnTableMod",ExpressionUUID->"5d6ce85d-e9a6-4351-8632-20c7d18cee3e",
 CellID->318258773],
Cell[14895, 390, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"a7c91638-0c68-4db0-a047-5465f38f7aba"]
}, Closed]],
Cell[CellGroupData[{
Cell[15018, 395, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"df5705d4-042f-4c4f-9979-86a1c9bd7375",
 CellTags->"PrimaryExamplesSection",
 CellID->26058608],
Cell[CellGroupData[{
Cell[15477, 410, 307, 7, 29, "ExampleSection",ExpressionUUID->"3c7f94e4-2aba-4fff-87aa-f43a2e8f94e7",
 CellID->12126410],
Cell[15787, 419, 114, 1, 38, "ExampleText",ExpressionUUID->"b636fc8b-bb53-4963-aa0c-5c8ca54e09fe",
 CellID->62019171],
Cell[CellGroupData[{
Cell[15926, 424, 1514, 39, 123, "Input",ExpressionUUID->"b3fcfff4-2148-446d-8533-5a32b3cc7ca9",
 CellID->190611702],
Cell[17443, 465, 39795, 784, 197, "Output",ExpressionUUID->"3d1dbc83-4f25-4e7a-9733-083c0c15798c",
 CellID->557739664]
}, Open  ]],
Cell[57253, 1252, 179, 3, 70, "ExampleText",ExpressionUUID->"bb0f8726-a22c-4bee-982c-acded7eaa746",
 CellID->22770873],
Cell[CellGroupData[{
Cell[57457, 1259, 214, 5, 26, "Input",ExpressionUUID->"2600fdbc-69f7-4c9d-887a-4df4310308c1",
 CellID->865837],
Cell[57674, 1266, 11292, 192, 381, "Output",ExpressionUUID->"17586c7c-e98d-4388-a064-f538d8129859",
 CellTags->"RasterizedOutput",
 CellID->383058601]
}, Open  ]],
Cell[68981, 1461, 408, 10, 70, "ExampleText",ExpressionUUID->"054aef2a-de30-41e0-97fd-6df735a08429",
 CellID->424126681],
Cell[CellGroupData[{
Cell[69414, 1475, 1514, 39, 70, "Input",ExpressionUUID->"3f10e256-b40b-4ace-bd1c-edb433d442a4",
 CellID->15737845],
Cell[70931, 1516, 39885, 786, 70, "Output",ExpressionUUID->"9c961136-7a26-4072-8ba5-bc832458c26d",
 CellID->111478711]
}, Open  ]],
Cell[CellGroupData[{
Cell[110853, 2307, 245, 6, 26, "Input",ExpressionUUID->"4c2cd4e1-8a5a-4980-b150-8a6d4ff678bc",
 CellID->120619760],
Cell[111101, 2315, 13480, 228, 381, "Output",ExpressionUUID->"50cbf289-744f-43ee-aca9-6e6a4b102868",
 CellTags->"RasterizedOutput",
 CellID->387856971]
}, Open  ]],
Cell[124596, 2546, 135, 1, 70, "ExampleText",ExpressionUUID->"4c1e0ed0-1f6e-4e7d-a231-00f40ec801c2",
 CellID->208967134],
Cell[CellGroupData[{
Cell[124756, 2551, 287, 7, 26, "Input",ExpressionUUID->"277f26b6-0b5b-4d03-bc3a-af1b81946008",
 CellID->258237459],
Cell[125046, 2560, 8038, 139, 237, "Output",ExpressionUUID->"17b1e03e-4950-4699-b812-06ac8b659d56",
 CellTags->"RasterizedOutput",
 CellID->14511682]
}, Open  ]]
}, Open  ]],
Cell[133111, 2703, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"a811c1f0-f076-4402-b247-2bc90961b1dc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[133234, 2708, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"05e249d6-9a07-47f5-8c6c-53255f1c3698",
 CellID->1255426704],
Cell[133497, 2717, 1822, 48, 70, "SeeAlso",ExpressionUUID->"5159c5d7-b48d-4480-abba-186d5b7eb6c4",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[135356, 2770, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"e6c2e044-abe8-449c-81b2-57369a1acfe2",
 CellID->38303248],
Cell[135625, 2779, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"d7bc5789-b5ed-4bd7-8fd8-c78b2e9bc692"],
Cell[135714, 2781, 247, 6, 70, "MoreAbout",ExpressionUUID->"e8fd865d-898b-4ff4-a36b-9d66d1406449",
 CellID->389286083]
}, Open  ]],
Cell[135976, 2790, 78, 0, 70, "FooterCell",ExpressionUUID->"dfe2aaef-3c9c-4137-bd72-7b5f89f306c5"]
}
]
*)

(* End of internal cache information *)

