(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    156752,       3180]
NotebookOptionsPosition[    148952,       3012]
NotebookOutlinePosition[    151953,       3084]
CellTagsIndexPosition[    151829,       3078]
WindowTitle->FigGrid
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "0ba039b9-7e55-4da2-a60a-96e4f4113e60"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"44b780d2-818b-4a6a-9a9d-900d873a55bc"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"FigColumn\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/FigColumn"], "\<\"Fig\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/Fig"], "\<\"SciDrawPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SciDrawPlot"], "\<\"DTPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DTPlot"], "\<\"DataTable\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/DataTable"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "558e3ee4-2565-4ff3-aab0-dd4513d7d501"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"04888181-d28b-4ccc-9142-f05be1bebab0"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7f62e533-aa64-470c-8f72-f6e909b42b5b"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"325a1b44-70a1-4d15-8360-4b9d47de7a5e"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/FigGrid\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/FigGrid"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
FigGrid.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$21503], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/FigGrid", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ee46ca5c-6387-443c-92a3-936f26c5e514"]
    }], "AnchorBar",ExpressionUUID->"32463985-19cf-40a0-9ae7-3e170b9c6312"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"759460ca-3999-4a85-bb35-b54ec76ca972"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["FigGrid", "ObjectName",ExpressionUUID->
  "3f000a61-96ed-4ed8-b92c-25755b8036ba"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"5a968139-f796-4a6b-ba9d-407e05c8d1e9"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "b4227841-84d0-40a2-8ff9-9d16d3b4d212"]
}], "ObjectNameGrid",ExpressionUUID->"673e910c-6000-4667-aaac-5d6f08304d38"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FigGrid", "[", 
       RowBox[{
        StyleBox[
         RowBox[{"{", 
          RowBox[{
           SubscriptBox["datatable", "1"], ",", 
           SubscriptBox["datatable", "2"], ",", "..."}], "}"}], "TI"], ",", 
        StyleBox["x", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "d34fe745-820b-4d65-b6d5-bd1abd7b4959"],
     "\[LineSeparator]returns a figure grid with plots of data in DataTable \
objects, where column ",
     Cell[BoxData[
      StyleBox["x", "TI"]], "InlineFormula",ExpressionUUID->
      "2a4f5006-193d-4197-9dfb-17afef99b08c"],
     " is plotted on the x-axis, using the SciDraw package."
    }],ExpressionUUID->"b011b43b-d16d-41d5-ab9c-cfdfaf5ab447"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FigGrid", "[", 
       RowBox[{
        StyleBox[
         RowBox[{"{", 
          RowBox[{
           SubscriptBox["datatable", "1"], ",", 
           SubscriptBox["datatable", "2"], ",", "..."}], "}"}], "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        StyleBox[
         RowBox[{"{", 
          RowBox[{
           SubscriptBox[
            StyleBox["ycol", "TI"], "1"], ",", 
           SubscriptBox[
            StyleBox["ycol", "TI"], "2"], ",", ".."}], "}"}], "TI"]}], "]"}]],
       "InlineFormula",ExpressionUUID->"e6fdeeb1-03f8-45de-b32b-4b4a608a6f69"],
     "\[LineSeparator]plots only columns specified by ",
     Cell[BoxData[
      StyleBox[
       RowBox[{"{", 
        RowBox[{
         SubscriptBox[
          StyleBox["ycol", "TI"], "1"], ",", 
         SubscriptBox[
          StyleBox["ycol", "TI"], "2"], ",", ".."}], "}"}], "TI"]], 
      "InlineFormula",ExpressionUUID->"7c2defeb-7133-42d0-a693-2e97a38b7b0c"],
     " in the figure grid."
    }],ExpressionUUID->"b76da39b-6282-4590-a26f-201a98666f9e"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436,ExpressionUUID->"2a551ca1-9918-4fdc-a4f6-ddddaf06e2a0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"5c031412-c7de-4f4c-93fc-75fe0da2a79a"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"3f9cd4bd-8011-4a1a-adb3-e57be2977d73"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"1f4d6aa3-0159-4a25-8029-cf7d4b8349eb"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->131787578,ExpressionUUID->"64a09c89-5ca4-4aea-99fd-6a954c9bab7c"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"78ca55f9-7548-403c-b9d0-cc78f6709ff3"],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigGrid"]],"paclet:DataAnalysis/ref/FigGrid"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "cab7e1e0-6c0a-4bda-8ff9-e5f29a1078be"],
 " requires that the SciDraw package, created by Mark A. Caprio, University \
of Notre Dame, is installed. The package can be downloaded at ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["https://scidraw.nd.edu/."]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "c40fde9d-b049-4cae-b7a3-8fa6a216ea3a"]
}], "Notes",
 CellID->632098388,ExpressionUUID->"cf30bf37-3806-4d41-a23b-ea38e103e5cb"],

Cell["\<\
The SciDraw package allows the preparation of publication-quality scientific \
figures.\
\>", "Notes",
 CellID->153014549,ExpressionUUID->"5f7e0f7c-ed46-4aba-bbf4-20d9b2fa8139"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigGrid"]],"paclet:DataAnalysis/ref/FigGrid"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "441cebee-87bc-4ec4-941a-7c03e5d2d965"],
 " function automatically produces simple figure grids with SciDraw, and \
styling options are limited."
}], "Notes",
 CellID->21661976,ExpressionUUID->"5f5ce066-453b-41ed-8518-9e61ac63f881"],

Cell[TextData[{
 "More flexibility can be achieved using the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDrawPlot"]],"paclet:DataAnalysis/ref/SciDrawPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "8b0ab280-4014-4700-b69b-32e8920fa72c"],
 " function, which is produces a DataPlot object which can be included into \
complex SciDraw figures."
}], "Notes",
 CellID->465025006,ExpressionUUID->"1efb0790-0fb0-4ab9-a858-444355e1ed51"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Fig"]],"paclet:DataAnalysis/ref/Fig"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "5a0c884b-71d5-4707-8868-2dade67b3923"],
 " function can be used to automatically produce single figures with SciDraw."
}], "Notes",
 CellID->210011063,ExpressionUUID->"0210c7fa-ec31-4e6c-8bf8-84bf56d568d5"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigGrid"]],"paclet:DataAnalysis/ref/FigGrid"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "5fa5b4e7-0b40-4398-94da-510861e3019b"],
 " takes the same options as Figure, Multipanel and DataPlot (from the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDraw"]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "8e846d60-e678-4682-8ba8-54e7f71fb404"],
 " package) with the following additions: "
}], "Notes",
 CellID->52142193,ExpressionUUID->"48a50a8b-b5bc-47c3-b637-7d76701f9422"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "b21a36e5-f14d-4554-83ba-0e2077fe3729"], 
    ButtonBox["ShowLegend",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/ShowLegend"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "Specifies if a plot legend should be shown", "TableText",ExpressionUUID->
     "e2d3b354-a3ec-4503-81e0-01480724cc5b"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "252517ad-73e6-4aae-9ee2-146ecc628490"], 
    ButtonBox["XLogScale",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/XLogScale"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     "Specifies if ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Log10"]],"paclet:ref/Log10"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       StyleBox["x", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "2a6ea14b-8547-45d3-8016-b6d8e60c4302"],
     " should be applied to the x coordinates in the plot"
    }], "TableText",ExpressionUUID->"714cdbf5-5e1a-4e3d-bb33-3ef742ed87cf"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "b7e00351-6445-49e2-8589-6e2e20f870cf"], 
    ButtonBox["YLogScale",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/YLogScale"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     "Specifies if ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["Log10"]],"paclet:ref/Log10"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       StyleBox["y", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "f39b7257-1c82-440c-835d-0689bbaf0731"],
     " should be applied to the y coordinates in the plot"
    }], "TableText",ExpressionUUID->"9126a9bc-7c31-4043-9fc1-eea0c2506a5d"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "851e1aaf-1959-478b-97de-024c76ad49f3"], 
    ButtonBox["FigPanelExtras",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/FigPanelExtras"], 
    RowBox[{"<|", "|>"}], Cell["\<\
Specifies an association with \"extra\" graphic elements to plot in \
individual grid cells (see examples below).\
\>", "TableText",ExpressionUUID->"4851bee0-0446-43a2-90a2-dfc6a6361ced"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True, True}}}},
 CellID->318258773,ExpressionUUID->"4809a24e-ac72-434d-ae6e-568db633b83b"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"e2834eca-ad46-446e-97f3-b9d51080ab21"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"a911a20d-3e23-4f59-8815-4cd7486f0b60"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "d6a0b20f-02d3-45db-9563-a58bceeb9501"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->378327059,ExpressionUUID->"3494d025-ddae-4874-9848-5a42d05c0f12"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "798cb197-5ec2-4f1d-b17d-3b8a0e181c4f"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->52925202,ExpressionUUID->"455be7aa-4e2e-4ddf-80df-eaaa2a58e8c5"],

Cell["Define some data:", "ExampleText",
 CellID->62019171,ExpressionUUID->"2ed8a27d-e2b2-442a-9368-1a186f6d7bdc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<ID\>\"", ",", "\"\<a\>\"", ",", "\"\<b\>\"", ",", "\"\<c\>\""}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.05"}], "]"}], ",", "2", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.7"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<l\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.3"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"6", ",", "0.2"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<m\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"7", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"8", ",", "0.1"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.9"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<n\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1.5", ",", "0.8"}], "]"}], ",", "8", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
    "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->190611702,ExpressionUUID->"63ad6216-3383-41c5-95c1-1e12b48370b1"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 10612995242620]]]]], Appearance -> Automatic,
         Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 10612995242620]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499], "b" -> 
                 8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 10612995242620]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499], "b" -> 
                 8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 10612995242620]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[0]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`UnknownShape, "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 4, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[1219734649], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1219734649]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.000\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "98", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.05, $CellContext`dv$10491]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.0\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "14", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.7, $CellContext`dv$10492]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.3, $CellContext`dv$10493]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.2, $CellContext`dv$10494]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"6.00\"", 6., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[6, 0.2, $CellContext`dv$10495]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"7.00\"", 7., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[7, 0.2, $CellContext`dv$10496]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"8.00\"", 8., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[8, 0.1, $CellContext`dv$10497]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.0\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.9, $CellContext`dv$10498]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$10499]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.2, $CellContext`dv$10500]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    157616911][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 157616911]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[157616911][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[157616911][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {267., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->557739664,ExpressionUUID->"9a2a8c7f-bb3a-4329-a05f-724e63f35830"]
}, Open  ]],

Cell["\<\
Draw a column of figures plotting a on the x-axsis and b, c on the y-axis:\
\>", "ExampleText",
 CellID->22770873,ExpressionUUID->"19bcbc3b-0eda-41f3-8327-2926f43e378c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FigGrid", "[", 
  RowBox[{
   RowBox[{"{", "tbl", "}"}], ",", "\"\<a\>\""}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->865837,ExpressionUUID->"40be0abd-23f1-4a95-8c77-d67d639d76f9"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3V1sU1e68HH3DU3Tbwq0xwy0BEjBMBE1CWPyhjQJ4bQ1DSVRS4dMUCgf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    "], {{0, 374}, {547, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{547, 374},
  PlotRange->{{0, 547}, {0, 374}}]], "Output",
 ImageSize->{551, 374},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->65403998,ExpressionUUID->"972f22dc-6a5e-449d-b90e-43f9765fe13a"]
}, Open  ]],

Cell[TextData[{
 "Define a second ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "2b4f0d05-c855-4075-b98d-1b4dd2e71aa5"],
 " with more data and plot it in a second column:"
}], "ExampleText",
 CellID->424126681,ExpressionUUID->"da914aee-1a97-47bb-962e-3594bdc5c035"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl2", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<ID\>\"", ",", "\"\<a\>\"", ",", "\"\<b\>\"", ",", "\"\<c\>\""}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"3", ",", "0.05"}], "]"}], ",", "3", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"2", ",", "0.7"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<l\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.3"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"2", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"3", ",", "0.2"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<m\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.1"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.9"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<n\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"8.5", ",", "0.8"}], "]"}], ",", "8", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"3", ",", "0.2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
    "}"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->15737845,ExpressionUUID->"28ea9ebd-7d4a-4b0f-a006-48e418585d22"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084], "b" -> 
                3, "c" -> DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086], "b" -> 
                DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087], "c" -> 
                DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089], "b" -> 
                DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090], "c" -> 
                DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092], "b" -> 
                8, "c" -> DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 221611853593690]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084], "b" -> 
                3, "c" -> DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086], "b" -> 
                DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087], "c" -> 
                DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089], "b" -> 
                DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090], "c" -> 
                DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092], "b" -> 
                8, "c" -> DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 221611853593690]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084], "b" -> 
                 3, "c" -> DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086], "b" -> 
                 DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087], "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089], "b" -> 
                 DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090], "c" -> 
                 DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092], 
                 "b" -> 8, "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 221611853593690]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084], "b" -> 
                 3, "c" -> DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086], "b" -> 
                 DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087], "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089], "b" -> 
                 DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090], "c" -> 
                 DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092], 
                 "b" -> 8, "c" -> 
                 DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 221611853593690]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[1]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`UnknownShape, "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 4, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[2012015663], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[2012015663]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.000\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "98", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[3, 0.05, $CellContext`dv$104084]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["3"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"2.0\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "14", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[2, 0.7, $CellContext`dv$104085]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.3, $CellContext`dv$104086]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"2.00\"", 2., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[2, 0.2, $CellContext`dv$104087]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.00\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[3, 0.2, $CellContext`dv$104088]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.00\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.2, $CellContext`dv$104089]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "20", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.1, $CellContext`dv$104090]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.0\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.9, $CellContext`dv$104091]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"8.5\"", 8.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "16", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[8.5, 0.8, $CellContext`dv$104092]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.00\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "39", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[3, 0.2, $CellContext`dv$104093]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    821139987][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 821139987]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[821139987][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[821139987][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {267., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->111478711,ExpressionUUID->"999ed65a-f3b6-4fc9-bba7-8c8adf46e005"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FigGrid", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"tbl", ",", "tbl2"}], "}"}], ",", "\"\<a\>\""}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->120619760,ExpressionUUID->"51c97e2a-e4bc-4de9-9898-444464ebd54b"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3WFsE1e+93G3CWkaWJpS2pokLSFkg5em1AWa5po0pHBLzdIluZQ+pEEh
pWzTVF22QB+uqba9udAVaZVnZevu5aLSFrQS2lxVtxtd9SlRpSvlBS/8Mlo9
LxIpL3bf+aVf+iXPP5nEGDuJx54zc2bG348sZMxwcnJ85pzfjI9ntr370bHh
hwOBwMe18sex07FXL1w4/cmb9fKXt3778Qfv//a9Xx/+7f9+7/33LnS+WyUv
/vNDgcD/kycLz+8BAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAApt29e3fHjh3bt2/vWVN3d/fOnTutbyNCoZCrtpE6
S83ds017e3tXV5d7tgmHw52dnd7aZu8i92wjFZZqu2cbedPlrXfPNqqGF9lm
27Zte/bsSafTWobTM2fOtLS0FO0PZpjpV06WY6ZfOVmOmX7lZDkmpz/Hyukx
N/05WY6Z6c/JcsxMf06WY2Zqc7KcF154QUazf/3Xf9Uylvrb2NhYfX19XV3d
9JomJiaCwaD1bUQgEHDVNlJnqbl7tpG9Jh6Pu2ebaDQai8W8tc3QIvdsIxWW
artnG3nT5a13zzaqhpdvv/32kUceqa2t/dvf/qZlOJXYv3HjxmPHjq1dTzPM
9CsnyzHTr5wsx0y/crIck9OfY+VMm5v+nCzHzPTnZDlmpj8nyzEztTlZjqT3
xx57TI4ptIyl/nbr1q3BwUGJ32tvlslkim4jk11zc3PRnzg6OuqqbaTORadp
+d2lBZzZ5vr166lUau1t5GhU9gvr5ZjZRoa42dlZ69u888470tmc+VnGuGF9
m9FF1suRCku1ndlGGlmaeu1t5E2Xt94925gZOswMQcY2ZvZom8iO+dlnnxXt
n2aY6VdOlmOmX5lhpg+bYaZfOVmOyemvKDP93CQz05+T5ajaMc1Mo2aYmf6c
LMfMFGmGmSnSjOnFw2Qlez3yqBpO7y2OYHKIpKQoJ0mdlew1Turr65uZmdFd
i9KcO3ducnJSdy1KE1+kuxalkUaWptZdi9KoHTr0Bm8lKdeFvNivnOTR6c9J
XpxqneTCKVJhPkQuadhoNKrk+Mg+cngr05mSg1z/0bWcFbhnrfvJsGOcj/3h
hx9yP6ste3aWyiSTyYaGBl3BOxKJyC/CLgm4lu93z5mZGSUDoIzDsVhsYGDA
elGVbD4RCRiG72RfHB8fDwaDIyMjGiu2BtlHTvSfXFfzSEtot/wpz32/15RK
3jslH90CZZDDdsm6ZfxHOY7u6+uTpLr5qS3ramqf2LJdRqbmbdu7u7svXbpU
XmVOnz79wgsv1NXV6QrebW1t4XDYbaetAGTV19frroJd/uu//rJhw8bG5rYn
nmrYuq21vJE56/r166FQ6MCBA/dWSY8oThoukphfena/8dz8UYJMze27dne/
eeHU5R+NhzyXVzj1nUvVwjCgDFYWV6RSqae3NB0cvJLdwV8+/O5rrx8puzLG
vsBSEwCrkfCouwq2+Pdr/9Ha3tn/yXfGWNp79qvmnz9vcThayoerpEcU90DT
LT275+7gff7CRZmIs5Oy8eg88v4HH57VXTUXIXhDIytR82jfm6+euJS3gz/f
efibb2+WVyDBG8DafBm8U6nUk083nvxsMncsfevi7ae3NFk5UblS8L6fHmHK
0qcFD7RbLBbr6OgwvkRm/fozaj3xZFCO2vLmZXlFXtddNReJRqMEb+hirGou
r+uuW1eTN1PI4+DglfDul8oo7YcffpChTAY07Wu8pTIu/9YMULFUXR3RVc6c
ObNj7+t5Y6k8Grfv+vLLL8so8Ouvv5ah7O23315a471SekRxd4YDK31YsH37
9pqamvpFSi66rlBV9brs5ybZh8zUDz9cpbtqLhIMBsfHxzX2LFQyY1VzGf22
q6trXU1t4Uzxxgd/3Fj/RBkFtre3y1AmA5r2Nd5SGdd+awaocBIfyxheXO6x
xx57oWegcDhtanupubm5jAI3b95s3OFlYY33KukRRT3wCYE043LbuXmpSUfn
vkOnvyicl9tC7bqr5iIsNYFGPRYWVwQbmo6dv5m3g+/rO98/MFhegSw1AbA2
Xy41mZyc3BF+ZYUz3s1tVq48bOTD1dIjirt/zJL71NXBW6awltDuvI7U2t45
NTWlu2ouQvCGRlai5jff3ny+83Du3t3/yXdbmraVHZsJ3gDW5svgLXaF9xx+
7w+5w+mrJy4d7XvTSplL+XCV9AgzpMUKLwgjDXvkyBHXrkgcvfz51tb2l6LD
h05/IX/Kc3lFd6XcheANjaxEzWQyGf3lr5pDezvf+FB28N3/+M5TW54Z++JL
K8H7008/bWxs1LvGm8suAa7l1+Atg97Pdzy3q+vYwcEr3cdj7ZFfSRS3cvll
+b/Z63ivmB5RtkQiEQwG+/v7dVdkVTI7/+Y3v+3o3Cd/WrwupS+puj8sUIay
b5dsXMdbcvuuXbsam5792WObtm5tluAqr5R9t1CpTEdHx/r163UF75aWlnA4
zEdygGuNjo7qroJdZFCVwbO752DvPx2XwdBiabdu3QqFQl1dXUrqhlxuXmoC
AKViqQkAWEc+tAkNC8BPCN4AYB350CYuX+MNAOYlk0nWeAOARblrvKGW+9d4
A4AZqVSqp6eHNd4AYBFrvO3DRwkA/ISlJgBgHfnQJjQsAD8heAOAdeRDm7DG
G4BvsMYbAKxjjbd9WOMNwB9Y4w0ASrDG2z58lADAT1hqAgDWkQ9tQsMC8BOC
NwBYRz60CWu8AfgGa7wBwDrWeFs3n4gEckQS88brrPEG4A+s8QYAJbJrvFdL
jyjBQiMO31n+Gx8lAPATlpoAgHX5+fDB9Ajz7gw/0HAEbwB+QvAGAOvy8mFe
eoRZcsDy4OcExhrv6UW6KgUAFqXTaWMc077GW+qgqwIAYN3s7KyMYw+s8S5I
jzBJDljyWs5Y492zaGZmRlfFAMCKW7duGeOY9jXeUodz585pqQAAWNff3y/j
WO51vAvTI8xZ4YMClpoA8BOWmgCAdTn5kGUm5VrpkwKCNwA/IXgDgHX38yHr
TMq20iEL1/EG4BtcxxsArHvgOt6c8FaK63gD8Aeu4w0ASmSv4627Ij7EUhMA
fsJSEwCwjnxoExoWgJ8QvAHAOvKhTYw13lx1FoAPzMzMaFzj3dXVxRpvAD5g
rPEeHBzUXREfunr1ajAY5KAGgNfJTNHT01NXVzc3N6elAq2treFweGJiQstP
BwBV4vF4KBTav3+/7or4EB8lAPATlpoAgHXkQ5vQsAD8hOANANaRD23CGm8A
vsEabwCwjjXe9mGNNwB/YI03ACjBGm/78FECAD9hqQkAWEc+tAkNC8BPCN4A
YB350Cas8QbgG6zxBgDrWOOtxHwiEjAM38m+yBpvAP7AGm8AUCJ3jfeK6RHF
ScNFEvNLz+43Hh8lAPATlpoAgHVL+XCV9Iii7rfcgwjeAPyE4A0A1hn5cLX0
iKLuDAeGE8ufFuQcsRhrvGWySCaTGqsHAFZkMpnpRdrXeEsd+NYMAO+anZ2V
ccxY471aekRR0nSB5YOWhWZcbjxjjXfPImlqfRUEgPJNTEwY45j2Nd5SBz5G
BOBRmUymr69PxjFjjfdq6RFF5TZX7gcHLDUB4CcsNQEA64x8uFp6RHE5bZfb
jARvAH5C8AYA65by4SrpEWZkLwiTe8DCdbwB+AbX8QYA63Kv471iekTZuI43
AH/gOt4AoETudbyhFktNAPgJS00AwDryoU1oWAB+QvAGAOvIhzZhjTcA32CN
NwBYl7vGG2qxxhuAP7DGGwCUYI23ffgoAYCfsNQEAKwjH9qEhgXgJwRvALCO
fGgT1ngD8A3WeAOAdazxtg9rvGEfCSGBldTW1qZSKd21g9+wxhsAlGCNt334
KAHOkG4mnU13LeB/LDUBAOvIhzahYeEMgjecQfAGAOvIhzahYeEMgjecQfAG
AOvIh9bdGc6usR2+s/xiIpGoqqoKh8M6awZ9HHjrk8lkd8/BhaXdj67v/afj
dq/unpmZYayoTNK1amtra2pqdAXvpqYm6eeTk5NafjoAqGJ8Raujo+PeKukR
9+7NJyI5315boW1kg0hiPv9VjmgqnHQWW8u/ffvPW1vbDw5eOXX5x/5Pvus+
Hmt8tmV2dta+nzg9Pd3T02Nf+XA5zngDgHXL+XDl9LiSokHUTxZ+2dx2yf/7
0ksrtALBu8LZGrwl/2zdHpK8Lak7++g9+9XPdzxn3yXXCN4VjuANANYt5cNV
0mMBE0HUV+4M5zdLwSvyQiQSKTgMIXhXOFuDdzwe39V1LDd1G4+tre3JZNKm
H0rwrnAEbwCwbikfrpIeC5gIov6y0DB5BxqFv+78/Pzyv2b/0VjjbbTozMyM
I5WFi6x4nW1Vqtc90vnGh4XBu7HtJVt/bmtrq+52hdOyF43XvsZb9PX1aakA
AFgXDoeNocxY471ieixkKoj6Qc6a93yr/sK563U4413hAnae8b5+/Xp75Fcr
BO/mNvuO8jjjXeE44w0A1hXmw1VWe5cTRCtCzin/3GMWgneFszV4p9Pppq3b
37p4Ozd1Hzr9RUfnPvt+KMG7whG8AcC6+0tNVkqPMCN7TJJ7wELwrnC2Bu97
izG48dmW7uOx3rNfHX7vDy8ffvfnO56zNRcRvCscwRsArMvmwxXTI8rGdbwr
nAOLUVOpVO8/HX/s8c1bt7Wev3DRvuuZGGZnZy9dumTrj4A7cR1vAFAi9zre
UIsz3nAGd66EMzjjDQDWkQ9tQsPCGQRvOIPgDQDWkQ9tQsPCPul0enpZNBqN
xWLGc/su4g0QvAHAOvKhTVjjDfvIbtuzrK2traOjI/vXVCqlu3bwG9Z4A4AS
rPG2D0c0APyEM94AYB350CY0LAA/IXgDgHXkQ5vQsAD8hOANANaRD23CGm8A
/sAabwBQgjXe9uGIBoCfcMYbAKwjH9qEhgXgJwRvALCOfGgTGhaAnxC8AcA6
8qEq84lIJDGf/StrvAH4gwvXeEsOHx0dNfnf5T8GFtXUrq+qXicPeWK8MjMz
Y7IQ+XGEfwAWFa7xzkuPMEsaLhDIbTqOaAD4iavOeJc6wMp/f2bbjlff/rT/
k+/kIU/kryUFaflx8kPNbw8AK3pg+CpIjzBn4XhleDhC8AbgV94N3plM5tnm
7cfO3zx1+cfs462Lt5u2bk+n0yYLIXgDUCJn+FohPcIM42OCvA8LCN4A/MS7
wXtycnJH+JXc1G08frHn4MTEhMlCCN4AlMgOXyumRxS33GR5TTc+Ph5Ypmu2
AgCLZI4wxrHq6mpdQ5lkfqMOksCNV3IHWDN2vHSkMHg/t+9YSYXID9Xy6wPw
h+xQ1tXVtVp6RFGLy3Puy7YeZ7wB+In/znjLi+ZvysMZbwBKGMPXaukR5rHU
BICPeTd4ZzKZn+94rvfsV7mp+9j5m882b5d/MlkIwRuAEnnDF2e8y0bwBuBj
3g3e4uuvv35qyzPdx2NvXbwtD3kif5UXzZdA8AagBMHbJsYSxOyKRADwqHQ6
XV9fr32Nd27uLek63rKxDMWRSCTY0FTzyKPykCfy15Luy8N1vAFYJyPJ0hpv
qMYZbwB+4qoz3gDgUeRDm9CwAPyE4A0A1pEPbULDAvATgjcAWEc+tAlrvAH4
gwvXeAOAF7HG2z4c0QDwE854A4B15EOb0LAA/ITgDQDWkQ9tQsMC8BOCNwBY
Rz60CWu8AfgDa7wBQAnWeNuHIxoAfsIZbwCwjnxoExoWgJ8QvAHAOvKhTWhY
AH5C8AYA68iH1t0ZDhiG79x/kTXeAPyBNd7+ZsxTmUzm/IWLW7e11tQ80t1z
MJlM3ltMCDQ7oFDuGu8V0yOKk4ZbarL7z+5xRAPAXzjj7Vcy78uxVfuu3S8f
frf37FcnP5s8OHhla2v7Vze+GV2ku4KAryzlw1XSI0pB8AbgWwRvv5LgfaL/
ZPebF05d/jH7kPj9zLYdH374IcEbUKsgHxK8yzGfiOR9WEDwBuAnBG+/ksmr
bsPPclO38XgpOvxy5z8QvAG1cvNhYXpESXIPWow13gZdsxUAWCRzhDGOaV/j
zbdmbCINu+HxpwuD96tvf1pTu35oaEh3BQGfyA5ledfx5pR32eTIJZKYN55z
xhuAn3DG26844w04qTAf5qZHFJdzoJJ7zELwBuAnBG+/kuB9tO/NV09cylvj
va3t+ffff5/gDahV8OVKzniXLHtBmNwDFoI3AD8hePuVTF6pVKq1bee+3t8c
O39TUveh01+0tneOXv6cq5oAymXz4YrpEWVLJBJVVVXhcFh3RQDAEklltbW1
NTU1uoJ3U1OTzE2Tk5NafrrvGSvn0+n0O6d/HWxYaOqOzn1TU1P3uI43oFo8
Hl/YxTo6dFfEhzjjDcBPOOMNANaRD21CwwLwE4I3AFhHPrQJDQvATwjeAGAd
+dAmrPEG4A+s8QYAJVjjbR+OaAD4CWe8AcA68qFNaFgAfkLwBgDryIc2oWEB
+AnBGwCsIx/ahDXeAPyBNd6ocP39/T3LpDdmn587d0531eAxrPG2D0c0APyE
M96oWLOzs9PLJDVln+vaI+Bp5EOb0LAA/ITgDQgJ3rqrAG8jH9qEhgXgJwRv
4B7BG5aRDy2bT0QCS4bvZF+1ssa7r68v+/ybb292dO7b9MST8ufU1JTxYjqd
5l0D4AzWeMOLksnk2NiYwgJlCpaJuLrm0dzpWIlLly7Nzs4qLBCulbPGe+X0
iKIWGm6pxXKeWjuiyR5Qv3Xi5POdhw+d/uKti7flz9b2zoux38nrMv01Nzdb
rjsAmMUZb3iL2vOK73/wG5mCZSI+dv5m7nSsBD28ohg9c7X0iJJI20US88Zz
68H7m29vSuo+dfnH3Ifs7HKgTfAG4DCCN7xFYfC+ffvPz710cMXpWEn59PCK
Utgzc9MjSnFnOOeQxXrw3rqttffsV3l7+sHBK909BwneABxG8Ia3KAzeu8J7
Dr/3h7zpWF6R15WUTw+vKAU984H0CNOk3R44XjHWeBuLd2ZmZkoqa3nRTyBv
N5fHsfM3q2selX/auHGj4t8AAAoYKxKF9jXeIvf7L8Dacmdhix56uOrkZ5N5
03H/J99VVa9TUv7DDz/8/fff624w2C4cDhvveM51vPPTI0xZWJ6T327Wz3gH
G5okZuft6YdOf9HRuY8z3gAcxhlveIvCM95tofY3Pvhj3nQsr8jrSsqnh1eU
+z1zpfSI4lZZFG89eF/65NOOQ6fy9vTnOw9/8+1NgjcAhxG84S0Kg/eX4/9n
d8+bedPxrn2/+vdr/6GkfHp4RVnqmXylslx3hh/4wEjhlytFd8/BPQf6jfPe
vWe/ktT91omT97iqCQDHEbzhLWqvamJMx8YXr+RPeW5Mx0rQwyuK0TNXS48o
m5XreOf+ryuf/z7YsLC+ceu21m++vWm8mEqlotGomooCwJq4jje8SKLsuXPn
FBYo07FMxMZ0LM8VliwxrNTvgsGjcq7jDcXUHmun02lVRTmGOjvDi3XOLNJd
i5J5sakV1pkz3jbxYr9yktvaJ+CyO1e6rX3cxoXtw50rbaKwYVOpVCgUUlKU
k6TOUnPdtShNNBpNJpO6a1GakZGRiYkJ3bUozdgi3bUojTSyNLXuWpRG7dBB
8LaDF/uVk1w4/bkteHtxqnWSC6dIgrdNpGEHBgaKfs4lx2JFtzG5otvM++jk
Nmamafndix6NqtpmdHS0aH3MzO9myjGzzfXr14uGfDPbyHshnc2ZnzW5yPo2
o4uslyMVlmo7s42ZoVLe9KK/l8PbFB06zAxBxjZ6g/f58+eVHBSb6VdOlqNq
CjbTh80w068cLkfJF5rM9HOTVAVvVdFL1Y5pZho1w8z052Q5ZqZIM8xMkWbI
uHH27FmCtx3+5V/+5aGHHqqurh5d00cffVRfX299GyGjgau2kTpLzd2zjYxO
Q0ND7tkmHA739vZ6a5v9i9yzjVRYqu2ebeRNl7fePduoGl5GRkZkNKuqqpqb
m9MynAaDQRlzXnzxxbXraYaZfuVkOWb6lZPlmOlXTpZjcvqzuxyjBxYKhUJl
l2lmGjXDzPTnZDlmpj8nyzEztTlZztatW43RTMtY6m9///vf33//fTPdhm2c
2ebMmTO/+93v3LONdI9YLOatbT5a5J5tpMJSbfdsI2+6vPXu2WZU6S724Ycf
6hpOr1279utf/7po/zTDTL9yshwz/crJckz2K8fKGTXXPynHPeWYmf6cLMfM
1OZkOTJujIyM/Od//qeu4RQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAABa3L17t7W1tbm5uWdN3d3dzz77rPVt
RFNTk6u2kTpLza1vI23Y1dVlfZuWlpZIJGJ9G3lbOzs7rW/T1tbW0dFR3jby
y4aXrV+/fsuWLcbz3bt3r1jOzp07V/unkrZpb2+Xn2J9G9lANrO+jVRYqm19
G2lkaWrr28ibLm+99W2kE0pXtL7N3r17q6ur195G+pLJYeoXv/hFJpPRMpy+
/vrr0vhF+6cZZvqnGWb6pxlm+qcZZvqnGWb6pxlm+qcZZvqnGSanUTPMTH9O
lmNmGjXDzDRqhplp1Awz06gZZqZaM8xMkWbIuBEKhU6dOqVlLPW3W7duHThw
IBgMTq9pYmJCyTYiEAi4ahups9TcPdvIRBmPx92zTTQajcVi1rdpbGz85S9/
6czPGlrknm2kwlJt92wjb7q89e7Z5t/+7d+qqqrW3sb8ECQ97W9/+5uW4VTm
cZk6i/ZPM8z0KyfLMdOvnCzHTL9yshyT059j5Uybm/6cLMfM9OdkOWamPyfL
MTO1OVmOjBv79u0bGBjQMpb6mwTvwcHBqampoltOTk6uvYFMdnIoar0ch7eR
Ohedps2UI21Y9Dybqm3kaFT2i7W3kQ3S6bR7tmltbT1z5sza28zMzBR9L5zc
ZnTR2ttIIVKUM9tIIxd932WPfuedd6yXY2Yb6ahFhw4z29y9e7e6utp6OfcW
d1Uze7RNZMf8+uuvlfx0M/3TDDP9ygwz/coMM/3KyXJM9quiTE5/ZpiZbrxY
jqod08wU6WQ5ZqY/M2T/kr3Mejmqhg4pZ3x8XMlejzzyRh85cmR2dtZ6UdL3
vPgeSZ2V7DVOOnfunK5oUbY9e/Z8+umnumtRGplxlIyETkomk2NjY7prUZq/
/vWvGzZsUFKU/Pp6z3jH43FdC11sNb14clh3LdzLo9Ofk7w41TpJxm0ZvnTX
4j55s2KxGGe8LZpPRAKG4TvZFxOJRDAY7O/v11gxaORMREmlUsbnX85kEs8d
lVQ4VWcLpZv19PSsX79eVwdoaWkJh8NKzqACgEa3bt0KhUJdXV33VkmPKE4a
LpKYX3p2v/FUfYAIj5I9ye4fceXz3z/5dGPw2VBTS/vjm568ffvPtv646elp
SV+2/giopfBj+nvqPtEug5k1YADgCUv5cJX0iKLut9yDCN4Vzu7g/f4Hvwl3
v3nys8lTl3+UR/8n3+0Iv2Jr9iZ4ew7BGwDcxsiHq6VHFHVnODCcWP60IOeI
heBd4WwN3slkcmtruxG5sw/J3k8FG+1b7Efw9hyCNwC4jZEPV0uPKEqaLrB8
0LLQjMuNd+PGjT179oyOjo6NjfnyO0FYm+xJo7bZv7/nhZ6384K3PJ5pDZ88
edKmHzo0NLR3717d7YoSKAneUojRATZv3qwreEvHk+4ndVB1IQgAcJ5EbhnH
ent7jx8/vlp6RFG5zZX7wcH4+Hg4HDYmLL6SVoFsDd4vd/7DS9HhwuC9NdRx
4sQJm36oJJ/29nbd7YoSKAne09PTRgd4/PHH5+bmlFSsVNLxjODNBUAAeFQm
kxkbGxtdDN7RaHS19IjictoutxlZalLhbF1qMjk5uSP8SmHwfuKpBvuO8lhq
4jksNQEAt1nKh6ukR5iRvSBM7gELwbvC2f3lyo7Ofa++/Wlu6n758Lvvf/Ab
+34iwdtzCN4A4DbZfLhiekTZCN4Vzu7gnU6nu3sO7gi/8kLPgDwWvmv5TpH7
V1pE8PYcgjcAuA350CbXrl0Lh8OsSKxYztyZcXJyUrpZb2+vA3fmkqjPV9u8
RVXwlrd+dHR006ZNuoK3scZbyS3aAUCj6elpY4237or4kHFVE8/dFxueIwfO
dDOsSFXwNr4TpPGqJnJ0KcG77J9ufFhjkKL27t2b/evs7KzSmgLAWmZmZiR4
Hz16VHdFfIiPEuAMgjdWw1ITQzqdnl42tCj7V671CsBh5EOb0LBwBsEbqyF4
FzIujaikKAAoA/nQJjQsnEHwxmoI3oUI3gD0Ih/aZHx8PBgMjoyM6K4IfCge
jwdWUltbm0qldNcObqHwy5XRaLSurk5X8G5rawuHw0q+20vwBqDR9evXQ6HQ
gQMHdFfEh+SIRqYqvrkDQBeFZ7yTyWRDg423Z1pbJBKRg03J/9aLIngD0CiV
SsVisYGBAd0V8SE+SgCgF0tNChG8AehFPrQJDQtAL4J3IYI3AL3IhzahYQHo
RfAuRPAGoBf50CaJRKKqqiocDuuuCIAKpSp4p1Kp2trampoaXcG7qakpEAjw
5UoAXmdcG6Gjo0N3RXyIIxoAenHGuxDBG4Be5EOb0LAA9CJ4FyJ4A9CLfGgT
GhaAXgTvQgRvAHqRD20iDXvkyBFd8xQAKAzeMzMzjY2Nuga0rq6ueDyeyWSs
F0XwBqBROp2OxWKDg4O6K+JDV69eDQaDHNQAKIOSO5D+z//8j4xC1u878/e/
/727u7uurm5ubs56rcrQ2toaDocnJiasF0XwBqBRPB4PhUL79+/XXRFvuzOc
vWX38J3lF/koAUDZenp6kslk2f99dnZ2V3jPU1u2bm5ordvws/MXLlo5XTwy
MiIDGktNAMC6bD5cMT3ChPlEJJKYz3+V4A2gbFaiZiqVany25fB7fzh1+Ufj
8fLhd1/Zf7DsyshQRvAGACWW8+HK6RHFScutdKhC8AZQNitR8/XoG6++/Wk2
dRuPXft+9e/X/qO8AgneAKDKUj5cJT2iuDvDgUgkUvBZgTRsNBqdXqTkO0EA
KkdnZ2c8Hp8uy7p1NSc/m8wL3gcHr4R3v1RGad9//31HR8fHH3/c0NCgK3hn
W2N2dtZiUQRvALrMzMzIOBaLxU6cOLFaeoQp8/PGZwVy+JJtvEQi0djY2LPI
+mQBoKIYXyfsKV1XV9e6mtq81C2PNz7448b6J8oocOfOnTU1NS0tLRs2bNAV
vLOtcenSJYtFEbwB6PLOO+/IOHb/y5UrpUeUJHe9DktNAJTNyuKKYEPTsfM3
84J35xsfvnvmvfIKZKkJAKhSmA9Z7V2aO8PZzwhyj1kI3gDKZiVq3r795x3h
V3JT91sXbzc+21L2JQoJ3gCgylI+XCU9wozsBWFyD1gI3gDKZjFqjl7+fGtr
+ws9A93HYy/s/19NW7fPzMyUXRrBGwBUKbycIKe7lbh27Vo4HJbm1V0RAN4j
Q4fFG98kk8mPPvpoY/0TY2NjFov67//+7wsXLmzatElX8JaxdGhoyMqxQxbB
G4BG09PTvb29R48e1V0RHyJ4A9BL1S3jM5mMpHeCNwBYRPC2D0tNAOilKngb
WGoCANaRD21CwwLQi+BdiOANQC/yoU1oWAB6EbwLEbwB6EU+tIlxAx3aFoAu
qoJ3KpWKRqPab6CjJHsTvAFoNDExcf8GOlDKuGW8km8DAUAZFJ7xltCr/Zbx
Fq/NYiB4A9AolUot3TIeqvFRAgC9WGpSiOANQC/yoU1oWAB6EbwLEbwB6EU+
tAkNC0AvgnchgjcAvciHNrl69WpVVZXMF7orsgJ5x3uWtba2Zp9funRJd9UA
KKMqeKfT6fr6+nXr1s3NzVkvrQzyWwQCASX3IyN4A9BIxh8Zzbq6unRXxIfc
fEQzMzMzvUw6QPb57Oys7qoBUIYz3oUI3gD0cnM+9DSvNKwEb91VAGALgnch
gjcAvbySDz3HKw1L8Ab8iuBdiOANQC+v5EPP8UrDErwBvyJ4FyJ4A9DLK/nQ
cxKJRFVVVTgc1l2RtWQyGQne8qfuiriRkrt1ABopvHNlbW1tTU2NruDd1NQk
I9Xk5GTui+XtoR8uKuM/MiAAsC4ej8to1tHRobsifjCfiEQS89m/uvyIRiaR
E/0n19U8sinYIn/Kc6aVPCMjIxMTE7prAZTPx2e8Zd+UPbSkQqampjY98eTj
mxvkIU/kryX9dwYEAErk5cO89AizpOECAa8E70wm075rd/ebF05d/tF4yHN5
hVPfueTtU3L5MkAXHwfvUgfY27f/3Lzjxbcu3jZGPHkif5UXzZfAgABAiQeG
r4L0CHMWjleGhz1zxvv8hYsvH343m7qNR+eR9z/48KzuqrkI8yy8juBtSKVS
jc+29H/yXe6Id/KzySefbpR/MlkIAwIAJXKGrxXSI8wwPibI+7AgFot1dHTE
F027zJbGZ3rPfpUXvOUVeV131VwkGo0yz8LTlATvdDpt7BENDQ26gnckEjEG
0uy9BmTflD3U5L782WeftYX354148pAX5Z8YEAA4w7iLiuTDgYGBe6ukRxS3
3GR5Tbd9+/aampr6RZ2dnT1usq7mkbyTP8b5n4erqnVXzUWCweD4+LjGngVY
pCR4T05OGntEXV2druDd1tYWDoelDtl13bJvyh5qcl9ubW0NvfxGYfBu73qz
paWFAQGAM/r6+mQwCYVCBw4cWC09oqjF5Tn3ZVvPzUtNOjr3HTr9Rd4c9MYH
f2wLteuumovwyTK8jqUmBvm/LaHdhcF7R/iVvCulrIEBAYASxvC1WnqEeR66
qkkymdza2n7ys8nc090yMU0rulKuPzDPwusI3lndPQdfffvT3NR9cPBKR+c+
8yUwIABQgquaqOKh4C2+uvHNM9t27P7Hdw6d/kL+lOfyiu5KuQvzLLyO4J2V
Tqd3hfe0R37VfTwmD3kify3pGqoMCACUIHjb5MaNG3v27HHzQD07O/vP/xyr
qV0vf2a/soSsiYkJmgWepip4ZzKZsbGxzZs36wre4XB4aGgo96fLvlnGVbWv
X7++s/0FeciTUv8vAwIA62ZmZnp7e48ePaq7Ij507do1mSzi8bjuihTBLeMB
v1IVvNPp9Ojo6KZNm3QF7/b2dgneMmFZL4pbxgPQaHp6WoJ3NBrVXREfcvlS
kyyCN+BXPl5qUjaCNwC9vJIPPccrDUvwBvyK4F2I4A1AL6/kQ8/xSsMSvAG/
IngXIngD0Msr+VCPO8OSS4fvLDxdvOJiCV88HR8fb2xsPHfunH21K1t/f3/2
rhA1NTXZ5+6sLYDyKFzj3dfXt2HDhrm5OeullSEUCoXD4ampKetFEbwBaCSp
Wwa01157zex/sBBEPUh+2wd/wYXf2fjti7tx40Y0GlXybSDlZmdns/dB/umn
n7LPdZ3OAmAHhWe8ZXzYsmWLriGis7MzHo+nUinrRRG8AWgko2gsFjtx4oS5
zS0FUQ8q+PUKGmANfJQAQC+WmhQieAPQq5R8aCmIetPiKf77SjjKIHgD0Ivg
XYjgDUCvEvNh+UG00hC8AehF8C5E8AagF/nQJolEIhgM9vf3664IgAqlKnin
UimJvuvXr9cVvFtaWvhypa1mZmamV5JOp3VXzRXOnTuXvQpBKBTiigQVQsac
7HstQ1BnZ6fxPBqNlj0YGl+u7OrqUlpTLJC2PXLkCLcYBqCLwjPeyWSysbFR
V/CORCLxeDyTyVgviuBdSNJ1Nl3s3bt38+bN2b+6/+bLzsg9MAkEAtnn7rx+
AlRJpVLZ91rCdiwWy/617OFIdjcpZ2BgQG1VcY+PEgDoxlKTQgTvtUk7S2vr
roWrcfOLyiSJTnKdkqLIhzahYQHoRfAuRPBeG8G7KIJ3ZSJ4ux8NC8B5mUwm
FAoFVmJxRCJ4VwKCd1EE78pE8Ha/8fFx2T0ZwQB4XTqdrq+vr66u1hW8JfPL
cKpk1iN4r81nwVvJ9wLy2BG87ainw3zwK6ztxIkT165ds16OjD/ShfhypUXZ
ayzmXl2RIxoAfsIZ70rgp+A9OTk5MjKiqjQJlucvXJSJ/pG6jfKnPFcYNfv6
+pLJpKrStAgGg7qrYJepqalNTzz56PqNtY+u3xXeY/2iGdl8uGJ6RHHScEtN
dv/ZPYI3AH8heFcCPwVvhbOwZOy9L+97+fC7py7/aDzk+Sv7Dyop/J7SHq6L
X1fg3L795+YdL7518bbxvh9+7w/PbNth8c1a6pmrpEeUguANwLcI3pWA4L2i
S5982nHoVDZ1G489B/qvfP57JeUTvN0plUo1PtvS/8l3ue/7sfM3n23ebuXz
joKeSfAux3wiUrjU5MiRI8b1HrVVCwCsSafTxjim/TreUgfrFSB4r81nwTs7
C1skQeuND/6YF7zlFXldSfm7d++e9nhUyL28uW+cP39+58u/zHvf5dEc2vvl
l1+WUeCf/vQnGcrefvvt7HW8C9MjSpJ70GLcudK4BwHX2AfgUZJejHFM+50r
ldwokOC9tmkfBe/cWdiidTWP5J32lIe8Iq8rKb++vv7777/X3WCWGFeT8Jnm
5uYXegYKg3fLru7cG5ia99RTT8l7XVdXl/flSk55l02OXCKJeeM5S00A+AlL
TSqBn4K3wlm4o3PfodNf5KUveUVeV1K+wh6uiy+XmkxOTu4Iv1IYvBub26yc
UC3smbnpEcXlHKjkHrMQvAH4CcG7EhC8VyTN0hLanZe+tra2q7oUCcHbtXaF
9xx+7w+57/urJy4d7XvTSpkFX67kjHfJsheEyT1gIXgD8BOCdyUgeK9m9PLn
krQ73/jw0Okv5E95/tWNb1QVTvB2LRn0fr7juV1dx+R9Pzh4pT3yK4ni6XTa
SpmFlxPkdLcSN27c2LNnz+TkpO6KAIBV8Xh88+bNuoL33r17h4aGlPx0gvfa
/BS8Z2dnr1+/rrDAZDL57pn3amrXy59qL7st+5eunUsV69+/cK1MJiNvULDh
mV88t8t6j5qZment7T1+/LiSuiHX+Ph4OByWN0t3RQDAknQ6LWH18ccfn5ub
01KB9vZ2Cd5KTgkSvNfmp+BtE7+e2sXaVN0yfnJyUoJ3NBq1XhTysNQEgJ+w
1KQSELyLInhXJlXB+x750DY0LAA/IXhXAoJ3UQTvykTwdj8aFoCfELwrAcG7
KIJ3ZSJ4u9+1a9dY4w3AB4w13ps2bdIVvI013kruREbwXhvBe0UjIyPZe6BU
V1dnn8vruqsGG01OTmbf64aGhp07d2b/WvZgKLsYa7xtYlzVRNXxEQDokslk
xsbGNF7VJBwOc1UTZxC8VzQ7O5u96/cPP/yQfS6v664abJROp1d83618AGdc
1eTo0aPqqoklfJQAwE9YalIJCN6A3ciHNqFhAfgJwbsSELwBu5EPbULDAvAT
gnclIHgDdiMf2mR8fDwYDPLNCwBel06no9FoXV2druDd1tYWDoeV3AiY4L02
gjdgq+vXr4dCoQMHDuiuiA/JEY1MVVa+eSETTWAlfX19CusJAEUlk8mGhgZd
wTsSicTjccn/1osieK+N4A3YKpVKxWKxgYEB3RXxIYUfJchk19zcrKQoACgP
S00qAcEbsBtLTWxC8AbgJwTvSkDwBuxG8LYJwRuAn3g3eE9NTWVve9HS0tLa
2pr9q5Kb8vgJwRuwG8HbJolEoqqqKhwOWy+K4A1Ao1QqVVtbW1NToyt4NzU1
BQKBsr9cmclksre9+Omnn5TcBcOvCN6AreLxuIxmHR0duiviafOJyPL3Hofv
ZF/ljDcAP/HuGW+szZhf0un0O6d/bUxlwYamb769eW8xJAjdFQR8ZTkfrpwe
UdRCwy21WM5TgjcAfyF4+5VM+6lUqrVt577e35y6/KM8jp2/+Xzn4Yux37Ek
HlDOyIerpUeURNoukpg3nhO8AfgJwduvJHh39xw8OHjFSN3ZR0to99DQEMEb
UKswH+amR5TiznDOIYs07JEjR2SySCaTFssleAPQJbtAurGxUVfw7urqisfj
UgddFfA3Cd6P1m3IS93yeCk6vPO5doI3oMrs7KyMY7FYbHBwMOflB9IjTJN2
e+B45erVq8Fg0PjivJXb6NwjeAPQZ2JiwhjH6urq5ubmtNShtbU1HA5LHbgU
gB0keD8R3FYYvA8OXvnZY5uGhoZ0VxDwg0wm09fXJ+NYKBTav3//8sv56RGm
LCzPyW83lpoA8BOWmviVBO91NY8UBu8XD5zcv7+HM96AWvfz4UrpEcWtsiie
4A3ATwjefiXB+/yFiy8ffjc3dZ/8bPLJpxs//vhjgjeg1lI+5CuV5bozHMjF
lysB+BLB269k5spkMq+9fuQXew4eOv2FPPb1nX9m244f/u8drmoCKGfkw9XS
I8omDRuNRpXcFo3gDUAvyb0NDQ26gndnZ2c8Hk+n01p+uu9lzxFNTEzsbH9h
0+an+wcGja8mTS7SWjvAV1KpVCwWO3HihO6K+FAikWhsbFRy0pvgDUAjmSmi
0eiGDRt0BW/jy5Wc9HYAd64EbCWHtw9+uRLKsNQEgJ+w1KQSELwBuynMh8hF
8AbgJwTvSkDwBuxG8LYJwRuAnxC8KwHBG7Abwdsm165dC4fD0rzWiyJ4A9Ao
k8mMjY1t2rRJV/CWsXRoaEjJd9WxNoI3YCvZxXp7e48ePaq7Ij5E8AbgDwTv
ykHwBmxF8LYPS00A+AlLTSoBwRuwG0tNbELwBuAnBO9KQPAG7EbwtgnBG4Cf
ELwrAcEbsBvB2ybcQAeAP3ADncpB8AZsxQ107MMt4wH4BreMrxAEb8BW3DLe
Piw1AeAnLDWpBARvwG4sNbEJwRuAnxC8KwHBG7AbwdsmBG8AfkLwrgQEb8Bu
BG+bXL16taqqSskIRvAGoFE6na6vr1+3bt3c3JyWCsgAGAgElNyPDGsjeAO2
Gh0dldGsq6tLd0V84M5wYPhOzt+tHNGEw+Hs8yuf//6ppxvkbdq6rfWbb28a
LxoXGSi/sgBQIs54VwKCN2C3B/NhfnqEOdJuQlnwlrKMJ909B/cc6D92/uap
yz/2nv3q+c7Db504eY9z4AAcR/CuBARvwG45+XCF9AgT5hMRaTSVZ7yN4H3p
k087Dp2SyJ37kOz9zbc3Cd4AHEbwrgQEb8Buy/lw5fQI09QH72BDk3GuO/dx
6PQXHZ37CN4AHEbwrgQEb8BuLDVRJL/pEolEVVVVYFGpt9EJLMtL3fKQKF5d
86j808aNG9X+AgBQKB6PG8NRTU2NruDd1NRk1KGvr09LBSoHwRuwTzgcNoay
jo6O5dcI3mVTf8Z767bW3rNf5QXvg4NXunsOcsYbgMM4410JCN6A3TjjrYj6
4P3Ntzef7zycF7xb2zunpqYI3gAcRvCuBARvwG4Eb0XUB2/x1omTkr0Pnf7i
rYu35U9J3Rdjv7vHVU0AOI7gXQkI3oDdCN42kYaNRqOzs7Nl/N/cdYzffHsz
vPuldY882tG5b2pqyngxnU5z2yMAjkkmkw0NDbqCdyQSicfjMu5p+ekVheAN
2CqVSsVisYGBAd0V8aHx8fFgMDgyMmK9KJnsmpqarJfjMF1ztBVerLPsxZlM
RnctSpNepLsWpZFGlqbWXYuSKenS8mZFo9G6ujpdO0hbW1s4HJ6cnNTy023l
tn7lwuDtxWHZSbTP2tw2RV6/fj0UCh04cEB3RXzIylKTPHfv3q2urlZSlJM0
fjBdNi9+oi3dzHO30h5dpLsWpVG4RztG7Zo0lprYwW39ym3Bm3WVRXlxqnWS
C6dIt+31viENOzAwUPTiV+l0uug2JoO3mdHSyW3MjAbyuxc986lqm5GRkaIr
f8zM72bKMbONJM+iP8vMNmZGFVU/69Yi69uYCd5mypEKFy1H1TZmhkp504t+
yOXkNmZCi5khyNhGb/AeGhpSkr3N9CuHy1EyBZvpw2b86U9/amhosF6Omf5p
hqrgbaafm6TqwERVOap2TDPTqBlmpj8ny1EVvM1MkWZIZc6cOUPwtoOx1KS2
trZnTZ2dnUW3efHFFx966KG1txGBQMBV28jvJb+de7apr68Ph8Pu2Ua6RygU
8tY2zYvcs41UWKrtnm3kTZe33j3bmBlezG+zYcOGubk5LcOpNP6mTZuK9k8z
zPQrJ8sx068cKGfv3r3hRY2NjVVVVeFlXV1d5RVopn+aYaZ/OllOj7npz8ly
zEx/TpZjZvpzshwzU5uT5ci4sXnz5tdee03LWOpvcuT4/fffT0xMTBfDNpW5
jXSPn376yVvb/LDIPdtIhaXa7tlm2n3dTOE2f/nLX3QNp3fv3jXTP80w06+c
LMdkv3KsnGlz/YFyKMcr5agaOhQOQVLUX//6V13DKQAAAAAAAAAAqBieu7j6
fCISWOKdiksre63KS6S5I4l53bUwK9vOHmrp+x3aI1XO2QMXeKh7VBJPjpPO
89b45jDPDU0Oo31QFiOneKnTLHT1pfrmPHW5+wc3XjvMWRxZvDMxeXAWvV9l
7/TnLA9WuUJ4cpx0nsfGN2d5emhyAO2Dckhvkc7itSiYw4Mxy1utvdDAw8Pe
aWQPjn8e7MP3eas3VyxP9zE7eW18cxbdpogHgjdNhZJ4d/L0WM2Nj6U8VGNj
NPHSmCI9IhKJeOqzv4VOnEh4q85LvNQzKpnHxknHeG98c5aHhybHLK01oQeh
VB4dlhcylhd7u2eae3lC8tjEND9v1NX4OMf9FhZ7LbevZ/rGIq/ugZWFd2kV
Hh3fHOTdockh9/ctD37UCs08uEstdHOvDpZeGee9/gU6r7Rz7u7nlTov8uC4
UWm8PE7azevjmwM8OzQ55IE2YThEabzWY7x4cJnTxl5rbk8NuTmN65Uz3l7t
G17qFhXJi+OkDnTkVXl0aHJMzqdJfLCEEnlsl8q5XpyXzlRkq+2VCmd5a2Ly
YjtnT755qM5eGzYqjkfHSed5a3xzmCeHJgfd38sYDAEAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAIAKlHNrN65RCgDlYzgFAKwl505c3AIPAMrHcAoA
MI+bFAKAEgynAICV5dx1mpkCAMrHcAoAWN3CLLE0PfDZKACUj+EUALCm3Nlh
4fnyAkUAQEkYTgEAxdz/Fn5keJhzNABQLoZTAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAC73/wFudk/D
    "], {{0, 374}, {979, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{979, 374},
  PlotRange->{{0, 979}, {0, 374}}]], "Output",
 ImageSize->{983, 374},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->677175987,ExpressionUUID->"0b6185df-6df0-4de0-8d2e-2c3663cbbfac"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "5b609a5f-da77-4ad2-976f-1e37ba8635c0"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341,ExpressionUUID->"38f94637-51c0-40ad-8b18-87d60a19e8f8"],

Cell[CellGroupData[{

Cell[TextData[{
 "FigPanelExtras",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "40a1fa3a-7dac-40e0-9fbf-7416ca5e8f58"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1295379749,ExpressionUUID->"01d02e92-65ad-462e-b976-9f809f6b8bc5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FigGrid", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", "tbl", "}"}], "}"}], ",", "\"\<a\>\"", ",", 
   "\[IndentingNewLine]", 
   RowBox[{"FigPanelExtras", "\[Rule]", 
    RowBox[{"<|", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\"\<c\>\"", ",", "1"}], "}"}], "\[Rule]", 
      RowBox[{"Hold", "@", 
       RowBox[{"{", 
        RowBox[{"FigLine", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "3"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"8", ",", "6"}], "}"}]}], "}"}], ",", 
          RowBox[{"LineColor", "\[Rule]", "Red"}]}], "]"}], "}"}]}]}], 
     "\[IndentingNewLine]", "|>"}]}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->561013958,ExpressionUUID->"dc67210f-aec7-4842-a8ff-8d1211f88b62"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3U1sW9eZ8HFm5CjKtyI7KR07sWwrNuMKDi25jEZWZFqeJHTkSEI+alWG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    "], {{0, 374}, {547, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{547, 374},
  PlotRange->{{0, 547}, {0, 374}}]], "Output",
 ImageSize->{551, 374},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->398077049,ExpressionUUID->"f31d3723-f929-44f2-80c2-a9cc07aad769"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"3d5fc2a8-2651-4c8e-b984-a4e7a8cca09e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"3c1b8fa6-3cbf-4770-84ba-fff5527040aa"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"11ff6c1a-d9a6-4617-b63d-05940ec92c46"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FigColumn"]],"paclet:DataAnalysis/ref/FigColumn"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"8accc0b7-b044-44ec-97ea-b9acdfbe1acf"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Fig"]],"paclet:DataAnalysis/ref/Fig"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"49271af8-7a5a-4236-8947-8c6a70cc5e81"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDrawPlot"]],"paclet:DataAnalysis/ref/SciDrawPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"42120733-d2b3-4e5e-9d4b-230c1ba345f9"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DTPlot"]],"paclet:DataAnalysis/ref/DTPlot"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"cc254f3f-aa25-4d9f-92e3-ca3d5195cf2a"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"8466ce93-0363-4729-9839-7705ea53f706"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"f56251c4-5579-4c8d-8319-48af9d2bec96"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"cd9c2a8f-7785-40e9-80ca-d0edcf9c96e4"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"fe5b143c-1961-4a22-9a44-f45c3e4ebf94"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"a6de4e84-36a0-4b9d-a599-5dd6e00b211f"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->696834363,ExpressionUUID->"def74d1b-ea48-4a7e-bbe5-79ce4b46d362"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"c69f65eb-0635-4776-917c-1463a3400668"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"FigGrid",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 33.4661405}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "FigGrid[{datatable1, datatable2, ...}, x] returns a figure grid with \
plots of data in DataTable objects, where column x is plotted on the x-axis, \
using the SciDraw package. FigGrid[{datatable1, datatable2, ...}, x, {ycol 1, \
ycol 2, ..}] plots only columns specified by {ycol 1, ycol 2, ..} in the \
figure grid.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "FigGrid", 
    "titlemodifier" -> "", "windowtitle" -> "FigGrid", "type" -> "Symbol", 
    "uri" -> "DataAnalysis/ref/FigGrid"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[14259, 372, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3494d025-ddae-4874-9848-5a42d05c0f12",
   CellTags->"PrimaryExamplesSection",
   CellID->378327059]},
 "RasterizedOutput"->{
  Cell[56914, 1243, 12304, 209, 375, "Output",ExpressionUUID->"972f22dc-6a5e-449d-b90e-43f9765fe13a",
   CellTags->"RasterizedOutput",
   CellID->65403998],
  Cell[111351, 2309, 20251, 339, 219, "Output",ExpressionUUID->"0b6185df-6df0-4de0-8d2e-2c3663cbbfac",
   CellTags->"RasterizedOutput",
   CellID->677175987],
  Cell[133210, 2702, 12752, 216, 70, "Output",ExpressionUUID->"f31d3723-f929-44f2-80c2-a9cc07aad769",
   CellTags->"RasterizedOutput",
   CellID->398077049]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 151132, 3061},
 {"RasterizedOutput", 151331, 3065}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[579, 21, 4474, 100, 55, "AnchorBarGrid",ExpressionUUID->"759460ca-3999-4a85-bb35-b54ec76ca972",
 CellID->1],
Cell[CellGroupData[{
Cell[5078, 125, 392, 9, 52, "ObjectNameGrid",ExpressionUUID->"673e910c-6000-4667-aaac-5d6f08304d38"],
Cell[5473, 136, 2097, 54, 203, "Usage",ExpressionUUID->"2a551ca1-9918-4fdc-a4f6-ddddaf06e2a0",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[7607, 195, 855, 21, 37, "NotesSection",ExpressionUUID->"64a09c89-5ca4-4aea-99fd-6a954c9bab7c",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->131787578],
Cell[8465, 218, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"78ca55f9-7548-403c-b9d0-cc78f6709ff3"],
Cell[8554, 220, 686, 17, 70, "Notes",ExpressionUUID->"cf30bf37-3806-4d41-a23b-ea38e103e5cb",
 CellID->632098388],
Cell[9243, 239, 187, 4, 70, "Notes",ExpressionUUID->"5f7e0f7c-ed46-4aba-bbf4-20d9b2fa8139",
 CellID->153014549],
Cell[9433, 245, 439, 11, 70, "Notes",ExpressionUUID->"5f5ce066-453b-41ed-8518-9e61ac63f881",
 CellID->21661976],
Cell[9875, 258, 486, 11, 70, "Notes",ExpressionUUID->"1efb0790-0fb0-4ab9-a858-444355e1ed51",
 CellID->465025006],
Cell[10364, 271, 406, 10, 70, "Notes",ExpressionUUID->"0210c7fa-ec31-4e6c-8bf8-84bf56d568d5",
 CellID->210011063],
Cell[10773, 283, 633, 16, 70, "Notes",ExpressionUUID->"48a50a8b-b5bc-47c3-b637-7d76701f9422",
 CellID->52142193],
Cell[11409, 301, 2724, 64, 70, "3ColumnTableMod",ExpressionUUID->"4809a24e-ac72-434d-ae6e-568db633b83b",
 CellID->318258773],
Cell[14136, 367, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"e2834eca-ad46-446e-97f3-b9d51080ab21"]
}, Closed]],
Cell[CellGroupData[{
Cell[14259, 372, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3494d025-ddae-4874-9848-5a42d05c0f12",
 CellTags->"PrimaryExamplesSection",
 CellID->378327059],
Cell[CellGroupData[{
Cell[14719, 387, 307, 7, 29, "ExampleSection",ExpressionUUID->"455be7aa-4e2e-4ddf-80df-eaaa2a58e8c5",
 CellID->52925202],
Cell[15029, 396, 114, 1, 38, "ExampleText",ExpressionUUID->"2ed8a27d-e2b2-442a-9368-1a186f6d7bdc",
 CellID->62019171],
Cell[CellGroupData[{
Cell[15168, 401, 1514, 39, 123, "Input",ExpressionUUID->"63ad6216-3383-41c5-95c1-1e12b48370b1",
 CellID->190611702],
Cell[16685, 442, 39795, 784, 197, "Output",ExpressionUUID->"9a2a8c7f-bb3a-4329-a05f-724e63f35830",
 CellID->557739664]
}, Open  ]],
Cell[56495, 1229, 179, 3, 70, "ExampleText",ExpressionUUID->"19bcbc3b-0eda-41f3-8327-2926f43e378c",
 CellID->22770873],
Cell[CellGroupData[{
Cell[56699, 1236, 212, 5, 26, "Input",ExpressionUUID->"40be0abd-23f1-4a95-8c77-d67d639d76f9",
 CellID->865837],
Cell[56914, 1243, 12304, 209, 375, "Output",ExpressionUUID->"972f22dc-6a5e-449d-b90e-43f9765fe13a",
 CellTags->"RasterizedOutput",
 CellID->65403998]
}, Open  ]],
Cell[69233, 1455, 408, 10, 70, "ExampleText",ExpressionUUID->"da914aee-1a97-47bb-962e-3594bdc5c035",
 CellID->424126681],
Cell[CellGroupData[{
Cell[69666, 1469, 1514, 39, 70, "Input",ExpressionUUID->"28ea9ebd-7d4a-4b0f-a006-48e418585d22",
 CellID->15737845],
Cell[71183, 1510, 39885, 786, 70, "Output",ExpressionUUID->"999ed65a-f3b6-4fc9-bba7-8c8adf46e005",
 CellID->111478711]
}, Open  ]],
Cell[CellGroupData[{
Cell[111105, 2301, 243, 6, 26, "Input",ExpressionUUID->"51c97e2a-e4bc-4de9-9898-444464ebd54b",
 CellID->120619760],
Cell[111351, 2309, 20251, 339, 219, "Output",ExpressionUUID->"0b6185df-6df0-4de0-8d2e-2c3663cbbfac",
 CellTags->"RasterizedOutput",
 CellID->677175987]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[131651, 2654, 302, 7, 70, "ExampleSection",ExpressionUUID->"38f94637-51c0-40ad-8b18-87d60a19e8f8",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[131978, 2665, 315, 7, 70, "ExampleSubsection",ExpressionUUID->"01d02e92-65ad-462e-b976-9f809f6b8bc5",
 CellID->1295379749],
Cell[CellGroupData[{
Cell[132318, 2676, 889, 24, 70, "Input",ExpressionUUID->"dc67210f-aec7-4842-a8ff-8d1211f88b62",
 CellID->561013958],
Cell[133210, 2702, 12752, 216, 70, "Output",ExpressionUUID->"f31d3723-f929-44f2-80c2-a9cc07aad769",
 CellTags->"RasterizedOutput",
 CellID->398077049]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[146001, 2923, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"3d5fc2a8-2651-4c8e-b984-a4e7a8cca09e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[146124, 2928, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"11ff6c1a-d9a6-4617-b63d-05940ec92c46",
 CellID->1255426704],
Cell[146387, 2937, 1826, 48, 70, "SeeAlso",ExpressionUUID->"f56251c4-5579-4c8d-8319-48af9d2bec96",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[148250, 2990, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"fe5b143c-1961-4a22-9a44-f45c3e4ebf94",
 CellID->38303248],
Cell[148519, 2999, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"a6de4e84-36a0-4b9d-a599-5dd6e00b211f"],
Cell[148608, 3001, 247, 6, 70, "MoreAbout",ExpressionUUID->"def74d1b-ea48-4a7e-bbe5-79ce4b46d362",
 CellID->696834363]
}, Open  ]],
Cell[148870, 3010, 78, 0, 70, "FooterCell",ExpressionUUID->"c69f65eb-0635-4776-917c-1463a3400668"]
}
]
*)

(* End of internal cache information *)

