(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    147333,       3039]
NotebookOptionsPosition[    142456,       2931]
NotebookOutlinePosition[    145127,       2994]
CellTagsIndexPosition[    145040,       2989]
WindowTitle->FilterOutliers
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "3f87adbd-d7e9-4427-9f03-451c8b727ace"], Cell[TextData[Cell[BoxData[
     ActionMenuBox[
      FrameBox[
       InterpretationBox[Cell[TextData[{
         "URL",
         StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
          StripOnInput->False]
        }],ExpressionUUID->"08d26a89-310e-4d7a-ba23-e57b11ea0809"],
        TextCell[
         Row[{"URL", 
           Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
       StripOnInput->False], {"\<\"DataAnalysis/ref/FilterOutliers\"\>":>
      None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["DataAnalysis/ref/FilterOutliers"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/language/DataAnalysis/ref/\
FilterOutliers.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
            If[
             TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$23252], 
             "http://reference.wolfram.com/system-modeler/", 
             "http://reference.wolfram.com/language/"], 
            "DataAnalysis/ref/FilterOutliers", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic,
      MenuStyle->"URLMenu"]],
     LineSpacing->{1.4, 0},ExpressionUUID->
     "deca8173-cafc-48dd-94c1-3d96d97b7afe"]], "AnchorBar",ExpressionUUID->
     "ba44e206-76e6-4a90-acf1-8e2a4231ec7b"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"08290afc-b5b2-4570-a431-234017e5989c"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["FilterOutliers", "ObjectName",ExpressionUUID->
  "a044bc7e-6b83-4059-ae6c-267339752587"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"7b115353-a22c-47b9-b77b-6cbe8931d4ab"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "ffcc9fba-51c0-4af9-b647-8a847db4d492"]
}], "ObjectNameGrid",ExpressionUUID->"e8586e68-f1dc-4040-ac50-6b4f298aecce"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FilterOutliers", "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["column", "TI"], "1"], ",", 
          SubscriptBox[
           StyleBox["column", "TI"], "2"], ",", "..."}], "}"}], ",", 
        StyleBox["i", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "8a8ec3f3-54d7-4860-a114-2567c348c7fe"],
     "\[LineSeparator]filters outliers in the specified columns (or keys) in \
data (",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "672183a7-b1fb-4384-8034-b35736a697a5"],
     " or ",
     ButtonBox["Association",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/Association"],
     ") based on a difference between the values and their mean which is \
larger than ",
     Cell[BoxData[
      StyleBox["i", "TI"]], "InlineFormula",ExpressionUUID->
      "23e0a3f3-36a2-454a-a4ec-0fcea9eb838e"],
     " standard deviations."
    }],ExpressionUUID->"315cfcce-524e-4212-8b08-d340e6cc3d2c"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FilterOutliers", "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["column", "TI"], "1"], ",", 
          SubscriptBox[
           StyleBox["column", "TI"], "2"], ",", "..."}], "}"}]}], "]"}]], 
      "InlineFormula",ExpressionUUID->"ba02e662-f9ab-4f8a-8f62-36859595985a"],
     "\[LineSeparator]filters outliers based on differences larger than 2 \
standard devations."
    }],ExpressionUUID->"00c4e114-a440-4529-a51d-342d9ea32803"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FilterOutliers", "[", 
       StyleBox["data", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "43a0b27e-f0b7-4703-8df1-fb9937ef6a40"],
     "\[LineSeparator]filters outliers in all columns based on differences \
larger than 2 standard devations."
    }],ExpressionUUID->"b7c68fc1-db09-42e7-8326-dac7c6ac5992"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"a0823cd6-d7ee-4a01-8b3b-79f18346885d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"868776c6-afa5-460b-b87c-0525e585017e"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "e3902ebd-2f56-479c-9cff-ff87a3e0d65a"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->680986660,ExpressionUUID->"5b8e2d13-8e63-49bf-8028-c3adeeabf239"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "85b04121-fa3d-451e-a64e-2440a51cc4d6"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->246878955,ExpressionUUID->"333b29c3-353c-4ac6-9366-e7f619866550"],

Cell["Define some data with an outlier (row6, column 1):", "ExampleText",
 CellID->141471489,ExpressionUUID->"6a74177e-18e5-4256-b13a-3fc40ad1567f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<row1\>\"", ",", "1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<row2\>\"", ",", "1.2", ",", "2.1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<row3\>\"", ",", "0.8", ",", "2.3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<row3\>\"", ",", "1.1", ",", "2.05"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<row4\>\"", ",", "0.7", ",", "2.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<row5\>\"", ",", "1.1", ",", "1.9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<row6\>\"", ",", 
       RowBox[{"-", "10"}], ",", "1.9"}], "}"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->30259546,ExpressionUUID->"e14174f7-eca3-408d-bef7-abb057b88e54"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
              Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
              Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
              Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
              Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
              Association["1" -> -10, "2" -> 1.9]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 6], 
             Association["ID" -> 286491629569307]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
              Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
              Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
              Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
              Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
              Association["1" -> -10, "2" -> 1.9]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 6], 
             Association["ID" -> 286491629569307]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
               Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
               Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
               Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
               Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
               Association["1" -> -10, "2" -> 1.9]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"1", "2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 6], 
              Association["ID" -> 286491629569307]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
               Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
               Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
               Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
               Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
               Association["1" -> -10, "2" -> 1.9]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"1", "2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 6], 
              Association["ID" -> 286491629569307]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 6, "Length" -> 6, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 6], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[20]} -> 1, {All, "1"} -> 
               1, {All, "2"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[57.60000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "1" -> TypeSystem`PackageScope`AtomShape[60], "2" -> 
                   TypeSystem`PackageScope`AtomShape[60]]]]], 6, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[965848328], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 6], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[965848328]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"1\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"1\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    All, "1"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[All, "1"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"2\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"2\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    All, "2"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[All, "2"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row2", 
                    Style[
                    "row2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    Key["row2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row3", 
                    Style[
                    "row3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    Key["row3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row3"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row3"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.3"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row3"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row3-2", 
                    Style[
                    "row3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    Key["row3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row3-2"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row3-2"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.05"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row3-2"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row4", 
                    Style[
                    "row4", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    Key["row4"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row4"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.7"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row4"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.5"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row4"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row5", 
                    Style[
                    "row5", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    Key["row5"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row5"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row5"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.9"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row5"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row6", 
                    Style[
                    "row6", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][{
                    Key["row6"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row6"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["-10"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row6"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.9"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    102966142][
                    GeneralUtilities`Slice[
                    Key["row6"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 102966142]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[102966142][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[102966142][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {207., {92., 98.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 222},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->87191158,ExpressionUUID->"0275ed7f-f7db-4040-96b7-4e83265de450"]
}, Open  ]],

Cell["Filter outliers based on all columns:", "ExampleText",
 CellID->311037158,ExpressionUUID->"4beb5e47-7c1d-424e-8800-dc4f7b4a8ff0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FilterOutliers", "[", "tbl", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->548161892,ExpressionUUID->"1e402873-6d9f-4127-ac2f-96131857d18f"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
              Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
              Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
              Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
              Association["1" -> 1.1, "2" -> 1.9]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
             Association["Origin" -> HoldComplete[
                Query[
                 Select[Apply[And, 
                   
                   Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$586673[#], 
                    1]] <= 2 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$586673[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
586673]]]& ]][
                 Dataset`DatasetHandle[286491629569307]]], "ID" -> 
              191581442262300]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
              Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
              Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
              Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
              Association["1" -> 1.1, "2" -> 1.9]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
             Association["Origin" -> HoldComplete[
                Query[
                 Select[Apply[And, 
                   
                   Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$586673[#], 
                    1]] <= 2 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$586673[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
586673]]]& ]][
                 Dataset`DatasetHandle[286491629569307]]], "ID" -> 
              191581442262300]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
               Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
               Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
               Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
               Association["1" -> 1.1, "2" -> 1.9]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"1", "2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
              Association["Origin" -> HoldComplete[
                 Query[
                  Select[Apply[And, 
                    Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$586673[#], 
                    1]] <= 2 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$586673[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
586673]]]& ]][
                  Dataset`DatasetHandle[286491629569307]]], "ID" -> 
               191581442262300]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
               Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
               Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
               Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
               Association["1" -> 1.1, "2" -> 1.9]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"1", "2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
              Association["Origin" -> HoldComplete[
                 Query[
                  Select[Apply[And, 
                    
                    Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$586673[#], 
                    1]] <= 2 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$586673[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
586673]]]& ]][
                  Dataset`DatasetHandle[286491629569307]]], "ID" -> 
               191581442262300]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 5, "Length" -> 5, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 5], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[21]} -> 1, {All, "1"} -> 
               1, {All, "2"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[57.60000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "1" -> TypeSystem`PackageScope`AtomShape[60], "2" -> 
                   TypeSystem`PackageScope`AtomShape[60]]]]], 5, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[254936606], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 5], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[254936606]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"1\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"1\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][{
                    All, "1"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[All, "1"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"2\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"2\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][{
                    All, "2"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[All, "2"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row2", 
                    Style[
                    "row2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][{
                    Key["row2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row3", 
                    Style[
                    "row3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][{
                    Key["row3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row3"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row3"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.3"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row3"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row3-2", 
                    Style[
                    "row3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][{
                    Key["row3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row3-2"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row3-2"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.05"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row3-2"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row4", 
                    Style[
                    "row4", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][{
                    Key["row4"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row4"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.7"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row4"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.5"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row4"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row5", 
                    Style[
                    "row5", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][{
                    Key["row5"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row5"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row5"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.9"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    358074184][
                    GeneralUtilities`Slice[
                    Key["row5"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 358074184]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[358074184][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[358074184][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {207., {80., 86.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 198},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->654292072,ExpressionUUID->"dfa814ff-c78d-40a9-9a73-4d5f09ee2d3e"]
}, Open  ]],

Cell["Look for outliers only in column 2:", "ExampleText",
 CellID->452673051,ExpressionUUID->"73fe053a-0d01-4ed6-83b6-30be7649433b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FilterOutliers", "[", 
  RowBox[{"tbl", ",", 
   RowBox[{"{", "\"\<2\>\"", "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->248297761,ExpressionUUID->"cfa081aa-f514-4d3c-b050-40f7790cfd0b"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
              Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
              Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
              Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
              Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
              Association["1" -> -10, "2" -> 1.9]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
             Association["Origin" -> HoldComplete[
                Query[
                 Select[Apply[And, 
                   
                   Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$588062[#], 
                    1]] <= 2 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$588062[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
588062]]]& ]][
                 Dataset`DatasetHandle[286491629569307]]], "ID" -> 
              108830307370276]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
              Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
              Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
              Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
              Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
              Association["1" -> -10, "2" -> 1.9]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
             Association["Origin" -> HoldComplete[
                Query[
                 Select[Apply[And, 
                   
                   Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$588062[#], 
                    1]] <= 2 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$588062[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
588062]]]& ]][
                 Dataset`DatasetHandle[286491629569307]]], "ID" -> 
              108830307370276]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
               Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
               Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
               Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
               Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
               Association["1" -> -10, "2" -> 1.9]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"1", "2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
              Association["Origin" -> HoldComplete[
                 Query[
                  Select[Apply[And, 
                    
                    Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$588062[#], 
                    1]] <= 2 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$588062[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
588062]]]& ]][
                  Dataset`DatasetHandle[286491629569307]]], "ID" -> 
               108830307370276]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
               Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
               Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
               Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
               Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
               Association["1" -> -10, "2" -> 1.9]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"1", "2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
              Association["Origin" -> HoldComplete[
                 Query[
                  Select[Apply[And, 
                    
                    Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$588062[#], 
                    1]] <= 2 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$588062[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
588062]]]& ]][
                  Dataset`DatasetHandle[286491629569307]]], "ID" -> 
               108830307370276]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 6, "Length" -> 6, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 6], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[24]} -> 1, {All, "1"} -> 
               1, {All, "2"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[57.60000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "1" -> TypeSystem`PackageScope`AtomShape[60], "2" -> 
                   TypeSystem`PackageScope`AtomShape[60]]]]], 6, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[476426572], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 6], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[476426572]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1550995478][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"1\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"1\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1550995478][{All, "1"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[All, "1"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"2\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"2\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1550995478][{All, "2"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[All, "2"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row2", 
                    Style[
                    "row2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1550995478][{
                    Key["row2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row3", 
                    Style[
                    "row3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1550995478][{
                    Key["row3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row3"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row3"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.3"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row3"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row3-2", 
                    Style[
                    "row3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1550995478][{
                    Key["row3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row3-2"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row3-2"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.05"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row3-2"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row4", 
                    Style[
                    "row4", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1550995478][{
                    Key["row4"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row4"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.7"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row4"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.5"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row4"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row5", 
                    Style[
                    "row5", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1550995478][{
                    Key["row5"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row5"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row5"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.9"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row5"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row6", 
                    Style[
                    "row6", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1550995478][{
                    Key["row6"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row6"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["-10"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row6"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.9"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1550995478][
                    GeneralUtilities`Slice[
                    Key["row6"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1550995478][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1550995478]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1550995478][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1550995478][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {207., {92., 98.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 222},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->148011519,ExpressionUUID->"62c606e3-a8f7-4378-9865-c5c6902f0362"]
}, Open  ]],

Cell["\<\
Change the outlier criterion to differences larges than 4 standard deviations:\
\>", "ExampleText",
 CellID->75703262,ExpressionUUID->"858e63e2-101c-4f38-897f-88b37c10e7f7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FilterOutliers", "[", 
  RowBox[{"tbl", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<1\>\"", ",", "\"\<2\>\""}], "}"}], ",", "4"}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->267967009,ExpressionUUID->"159f3a5c-d280-41a2-9f27-e33d2fd42707"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
              Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
              Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
              Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
              Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
              Association["1" -> -10, "2" -> 1.9]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
             Association["Origin" -> HoldComplete[
                Query[
                 Select[Apply[And, 
                   
                   Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$597000[#], 
                    1]] <= 4 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$597000[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
597000]]]& ]][
                 Dataset`DatasetHandle[286491629569307]]], "ID" -> 
              235342864041315]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
              Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
              Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
              Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
              Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
              Association["1" -> -10, "2" -> 1.9]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
             Association["Origin" -> HoldComplete[
                Query[
                 Select[Apply[And, 
                   
                   Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$597000[#], 
                    1]] <= 4 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$597000[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
597000]]]& ]][
                 Dataset`DatasetHandle[286491629569307]]], "ID" -> 
              235342864041315]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
               Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
               Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
               Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
               Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
               Association["1" -> -10, "2" -> 1.9]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"1", "2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
              Association["Origin" -> HoldComplete[
                 Query[
                  Select[Apply[And, 
                    
                    Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$597000[#], 
                    1]] <= 4 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$597000[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
597000]]]& ]][
                  Dataset`DatasetHandle[286491629569307]]], "ID" -> 
               235342864041315]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "row2" -> Association["1" -> 1.2, "2" -> 2.1], "row3" -> 
               Association["1" -> 0.8, "2" -> 2.3], "row3-2" -> 
               Association["1" -> 1.1, "2" -> 2.05], "row4" -> 
               Association["1" -> 0.7, "2" -> 2.5], "row5" -> 
               Association["1" -> 1.1, "2" -> 1.9], "row6" -> 
               Association["1" -> -10, "2" -> 1.9]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"1", "2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], TypeSystem`AnyLength], 
              Association["Origin" -> HoldComplete[
                 Query[
                  Select[Apply[And, 
                    
                    Module[{
                    DataAnalysis`CompositionalAnalysis`Private`RD$ = #}, 
                    Map[
                    Abs[DataAnalysis`CompositionalAnalysis`Private`RD$[#] - 
                    Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$597000[#], 
                    1]] <= 4 Part[
                    DataAnalysis`CompositionalAnalysis`Private`EVs$597000[#], 
                    2]& , DataAnalysis`CompositionalAnalysis`Private`Cols$\
597000]]]& ]][
                  Dataset`DatasetHandle[286491629569307]]], "ID" -> 
               235342864041315]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 6, "Length" -> 6, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 6], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[26]} -> 1, {All, "1"} -> 
               1, {All, "2"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[57.60000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "1" -> TypeSystem`PackageScope`AtomShape[60], "2" -> 
                   TypeSystem`PackageScope`AtomShape[60]]]]], 6, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[304455486], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"1", "2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 6], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[304455486]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"1\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"1\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    All, "1"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[All, "1"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"2\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"2\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    All, "2"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[All, "2"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row2", 
                    Style[
                    "row2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    Key["row2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row2"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row2"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row3", 
                    Style[
                    "row3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    Key["row3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row3"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row3"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.3"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row3"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row3-2", 
                    Style[
                    "row3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    Key["row3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row3-2"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row3-2"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.05"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row3-2"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row4", 
                    Style[
                    "row4", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    Key["row4"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row4"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.7"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row4"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2.5"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row4"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row5", 
                    Style[
                    "row5", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    Key["row5"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row5"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row5"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.9"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row5"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["row6", 
                    Style[
                    "row6", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][{
                    Key["row6"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row6"]]], "Mouse"], 
                    ImageSize -> {{57.60000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["-10"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row6"], 
                    Key["1"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1.9"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    178088863][
                    GeneralUtilities`Slice[
                    Key["row6"], 
                    Key["2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 178088863]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[178088863][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[178088863][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {207., {92., 98.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 222},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->122746002,ExpressionUUID->"47fd1be5-42ed-492f-bf38-3db5cd2a531f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"c9a1fbbf-051d-4aa6-b3d5-ee11301f2519"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"FilterOutliers",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 40.7743066}", 
    "history" -> {"XX", "", "", ""}, "context" -> 
    "DataAnalysis`CompositionalAnalysis`", "keywords" -> {}, 
    "specialkeywords" -> {}, "tutorialcollectionlinks" -> {}, "index" -> True,
     "label" -> "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "FilterOutliers[data, {column1, column2, ...}, i] filters outliers in the \
specified columns (or keys) in data (DataTable or Association) based on a \
difference between the values and their mean which is larger than i standard \
deviations. FilterOutliers[data, {column1, column2, ...}] filters outliers \
based on differences larger than 2 standard devations. FilterOutliers[data] \
filters outliers in all columns based on differences larger than 2 standard \
devations.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "FilterOutliers",
     "titlemodifier" -> "", "windowtitle" -> "FilterOutliers", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/FilterOutliers"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6104, 159, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"5b8e2d13-8e63-49bf-8028-c3adeeabf239",
   CellTags->"PrimaryExamplesSection",
   CellID->680986660]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 144842, 2982}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[586, 21, 2618, 56, 55, "AnchorBarGrid",ExpressionUUID->"08290afc-b5b2-4570-a431-234017e5989c",
 CellID->1],
Cell[CellGroupData[{
Cell[3229, 81, 399, 9, 52, "ObjectNameGrid",ExpressionUUID->"e8586e68-f1dc-4040-ac50-6b4f298aecce"],
Cell[3631, 92, 2436, 62, 277, "Usage",ExpressionUUID->"a0823cd6-d7ee-4a01-8b3b-79f18346885d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6104, 159, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"5b8e2d13-8e63-49bf-8028-c3adeeabf239",
 CellTags->"PrimaryExamplesSection",
 CellID->680986660],
Cell[CellGroupData[{
Cell[6564, 174, 308, 7, 29, "ExampleSection",ExpressionUUID->"333b29c3-353c-4ac6-9366-e7f619866550",
 CellID->246878955],
Cell[6875, 183, 148, 1, 38, "ExampleText",ExpressionUUID->"6a74177e-18e5-4256-b13a-3fc40ad1567f",
 CellID->141471489],
Cell[CellGroupData[{
Cell[7048, 188, 848, 21, 43, "Input",ExpressionUUID->"e14174f7-eca3-408d-bef7-abb057b88e54",
 CellID->30259546],
Cell[7899, 211, 31712, 633, 243, "Output",ExpressionUUID->"0275ed7f-f7db-4040-96b7-4e83265de450",
 CellID->87191158]
}, Open  ]],
Cell[39626, 847, 135, 1, 70, "ExampleText",ExpressionUUID->"4beb5e47-7c1d-424e-8800-dc4f7b4a8ff0",
 CellID->311037158],
Cell[CellGroupData[{
Cell[39786, 852, 167, 3, 70, "Input",ExpressionUUID->"1e402873-6d9f-4127-ac2f-96131857d18f",
 CellID->548161892],
Cell[39956, 857, 32265, 645, 70, "Output",ExpressionUUID->"dfa814ff-c78d-40a9-9a73-4d5f09ee2d3e",
 CellID->654292072]
}, Open  ]],
Cell[72236, 1505, 133, 1, 70, "ExampleText",ExpressionUUID->"73fe053a-0d01-4ed6-83b6-30be7649433b",
 CellID->452673051],
Cell[CellGroupData[{
Cell[72394, 1510, 222, 5, 70, "Input",ExpressionUUID->"cfa081aa-f514-4d3c-b050-40f7790cfd0b",
 CellID->248297761],
Cell[72619, 1517, 34628, 694, 70, "Output",ExpressionUUID->"62c606e3-a8f7-4378-9865-c5c6902f0362",
 CellID->148011519]
}, Open  ]],
Cell[107262, 2214, 183, 3, 70, "ExampleText",ExpressionUUID->"858e63e2-101c-4f38-897f-88b37c10e7f7",
 CellID->75703262],
Cell[CellGroupData[{
Cell[107470, 2221, 268, 7, 70, "Input",ExpressionUUID->"159f3a5c-d280-41a2-9f27-e33d2fd42707",
 CellID->267967009],
Cell[107741, 2230, 34594, 694, 70, "Output",ExpressionUUID->"47fd1be5-42ed-492f-bf38-3db5cd2a531f",
 CellID->122746002]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[142374, 2929, 78, 0, 70, "FooterCell",ExpressionUUID->"c9a1fbbf-051d-4aa6-b3d5-ee11301f2519"]
}
]
*)

(* End of internal cache information *)

