(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15988,        434]
NotebookOptionsPosition[     11615,        334]
NotebookOutlinePosition[     14049,        395]
CellTagsIndexPosition[     13964,        390]
WindowTitle->FoldValues
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "606ba679-5c41-42a3-88ba-371f49a01b92"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"f93e64dd-2100-4aa9-a934-afc9626fcf86"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"FoldList\"\>":>Documentation`HelpLookup[
       "paclet:ref/FoldList"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "1ff47662-3df3-48b9-b284-94f6058bc0ae"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"8447ef47-3b8f-4785-9d1f-79bbb71df631"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "c1616805-b677-49f9-bef4-0028c9a67ee5"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"ae601551-45c7-46e9-b2a0-a58e8cb1b68c"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/FoldValues\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/FoldValues"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
FoldValues.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$23759], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/FoldValues", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0a4b2360-496e-4047-8cce-529d0a921dda"]
    }], "AnchorBar",ExpressionUUID->"f48590db-67a5-4858-9f28-0767c1fe2c07"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"71e7a58a-125f-41fe-8d01-53bc3f8b711c"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["FoldValues", "ObjectName",ExpressionUUID->
  "930973f0-f423-4947-88b4-3737afe9705a"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"9889a0ec-a61f-4d1e-96b4-5d67b2058df2"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "10cfc072-a210-4397-86e7-08e029c4a908"]
}], "ObjectNameGrid",ExpressionUUID->"a0ded9b0-5f7b-4850-b25b-934374f0879a"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FoldValues", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        StyleBox["assoc", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "fdeac886-cae9-4b4d-9ba5-7a9556af69c9"],
     "\[LineSeparator]applies ",
     ButtonBox["FoldList",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/FoldList"],
     Cell[BoxData[
      RowBox[{"[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        StyleBox["list", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "e83c088d-acd2-429b-8371-e96421aadd04"],
     " to the values of items in an association and returns a new association \
using the keys from the second item in each operation. The arguments ",
     Cell[BoxData[
      StyleBox["x", "TI"]], "InlineFormula",ExpressionUUID->
      "20d8675e-d6e8-43dd-b01c-003ab85ab3a6"],
     " is optional. "
    }],ExpressionUUID->"8da1f6e7-acb3-425b-8e2e-e19aa197e58c"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FoldValues", "[", 
       StyleBox["f", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "02ef7a77-53c3-43a4-8d93-4464f6b9d424"],
     "\[LineSeparator]represents the operator form of ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["FoldValues"]],"paclet:DataAnalysis/ref/FoldValues"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "5c99c200-a8fa-49d1-a424-c1b8cb1cdd4b"],
     "."
    }],ExpressionUUID->"d3f67d31-6888-429c-bc28-062ac91e96d7"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"96cdffdf-a51b-442c-bdcb-eea2c191b457"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"456f7d7e-c023-483f-b0c0-bc70e3f2007d"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "5ce26056-14bb-452a-b8de-1dd10c00d11a"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->787493015,ExpressionUUID->"b3457bd5-e4c4-4363-89aa-564fa1476b2f"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "777bea17-a635-4be5-9524-9e79f4189028"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->698860105,ExpressionUUID->"84014a04-b87a-426f-9ce0-3258fe44f3c4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FoldValues", "[", 
  RowBox[{"f", ",", "x", ",", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"keya", "\[Rule]", "vala"}], ",", 
     RowBox[{"keyb", "\[Rule]", "valb"}], ",", 
     RowBox[{"keyc", "\[Rule]", "valc"}]}], "|>"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->80679152,ExpressionUUID->"bef92eb0-7117-4b67-8f8f-5cb6cc31f9e5"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"Key0\"\>", "\[Rule]", 
    RowBox[{"x", "[", "vala", "]"}]}], ",", 
   RowBox[{"keya", "\[Rule]", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"x", "[", "vala", "]"}], ",", "vala"}], "]"}]}], ",", 
   RowBox[{"keyb", "\[Rule]", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"x", "[", "vala", "]"}], ",", "vala"}], "]"}], ",", "valb"}], 
     "]"}]}], ",", 
   RowBox[{"keyc", "\[Rule]", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"f", "[", 
       RowBox[{
        RowBox[{"f", "[", 
         RowBox[{
          RowBox[{"x", "[", "vala", "]"}], ",", "vala"}], "]"}], ",", 
        "valb"}], "]"}], ",", "valc"}], "]"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{523, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->445907099,ExpressionUUID->"a0906d19-5d9a-4cee-bd34-03ceb971b245"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FoldValues", "[", 
  RowBox[{"f", ",", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"keya", "\[Rule]", "vala"}], ",", 
     RowBox[{"keyb", "\[Rule]", "valb"}], ",", 
     RowBox[{"keyc", "\[Rule]", "valc"}]}], "|>"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->76497719,ExpressionUUID->"59813011-68e9-4da8-a324-032ab95f530d"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"keya", "\[Rule]", "vala"}], ",", 
   RowBox[{"keyb", "\[Rule]", 
    RowBox[{"f", "[", 
     RowBox[{"vala", ",", "valb"}], "]"}]}], ",", 
   RowBox[{"keyc", "\[Rule]", 
    RowBox[{"f", "[", 
     RowBox[{
      RowBox[{"f", "[", 
       RowBox[{"vala", ",", "valb"}], "]"}], ",", "valc"}], "]"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{449, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->133988885,ExpressionUUID->"753fc071-a4a5-4b33-a3b7-c48446618d82"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"a63ef7e4-fce4-4e11-bdc0-1edbc1b2f9e8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"e30b0028-653f-4a84-b35c-5c207fbc44d1"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"36acd3b9-593e-4732-a058-c2dc557d0a50"],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["FoldList"]],"paclet:ref/FoldList"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> 
    "Verdana"}]], \
"InlineFormula",ExpressionUUID->"94deef3d-f5e2-4387-a45b-b23cfebe3db7"]], \
"SeeAlso",
 CellID->929782353,ExpressionUUID->"fa989d6a-6f69-4015-9a90-04ac6a52da0f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"15db8991-c149-4a72-b256-87f440c90357"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"e0fe1be4-f05e-4a23-b8a3-2674870f5962"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"2278552b-4a63-42ef-b75e-13f0abed14f3"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->202128961,ExpressionUUID->"15c657bc-812c-4d7e-b084-cdd97368e745"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"8a918aa2-1d5d-4ebf-9d76-6f359d8a5066"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"FoldValues",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 42.9968388}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "FoldValues[f, x, assoc] applies FoldList[f, x, list] to the values of \
items in an association and returns a new association using the keys from the \
second item in each operation. The arguments x is optional. FoldValues[f] \
represents the operator form of FoldValues.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "FoldValues", "titlemodifier" -> "", 
    "windowtitle" -> "FoldValues", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/FoldValues"}, "SearchTextTranslated" -> "", "NewStyles" -> 
  False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6977, 180, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"b3457bd5-e4c4-4363-89aa-564fa1476b2f",
   CellTags->"PrimaryExamplesSection",
   CellID->787493015]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13766, 383}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[582, 21, 4095, 93, 55, "AnchorBarGrid",ExpressionUUID->"71e7a58a-125f-41fe-8d01-53bc3f8b711c",
 CellID->1],
Cell[CellGroupData[{
Cell[4702, 118, 395, 9, 52, "ObjectNameGrid",ExpressionUUID->"a0ded9b0-5f7b-4850-b25b-934374f0879a"],
Cell[5100, 129, 1840, 46, 204, "Usage",ExpressionUUID->"96cdffdf-a51b-442c-bdcb-eea2c191b457"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6977, 180, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"b3457bd5-e4c4-4363-89aa-564fa1476b2f",
 CellTags->"PrimaryExamplesSection",
 CellID->787493015],
Cell[CellGroupData[{
Cell[7437, 195, 308, 7, 29, "ExampleSection",ExpressionUUID->"84014a04-b87a-426f-9ce0-3258fe44f3c4",
 CellID->698860105],
Cell[CellGroupData[{
Cell[7770, 206, 368, 9, 26, "Input",ExpressionUUID->"bef92eb0-7117-4b67-8f8f-5cb6cc31f9e5",
 CellID->80679152],
Cell[8141, 217, 986, 30, 52, "Output",ExpressionUUID->"a0906d19-5d9a-4cee-bd34-03ceb971b245",
 CellID->445907099]
}, Open  ]],
Cell[CellGroupData[{
Cell[9164, 252, 358, 9, 26, "Input",ExpressionUUID->"59813011-68e9-4da8-a324-032ab95f530d",
 CellID->76497719],
Cell[9525, 263, 596, 17, 35, "Output",ExpressionUUID->"753fc071-a4a5-4b33-a3b7-c48446618d82",
 CellID->133988885]
}, Open  ]]
}, Open  ]],
Cell[10148, 284, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"a63ef7e4-fce4-4e11-bdc0-1edbc1b2f9e8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10271, 289, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"36acd3b9-593e-4732-a058-c2dc557d0a50",
 CellID->1255426704],
Cell[10534, 298, 342, 9, 24, "SeeAlso",ExpressionUUID->"fa989d6a-6f69-4015-9a90-04ac6a52da0f",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[10913, 312, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"e0fe1be4-f05e-4a23-b8a3-2674870f5962",
 CellID->38303248],
Cell[11182, 321, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"2278552b-4a63-42ef-b75e-13f0abed14f3"],
Cell[11271, 323, 247, 6, 70, "MoreAbout",ExpressionUUID->"15c657bc-812c-4d7e-b084-cdd97368e745",
 CellID->202128961]
}, Open  ]],
Cell[11533, 332, 78, 0, 70, "FooterCell",ExpressionUUID->"8a918aa2-1d5d-4ebf-9d76-6f359d8a5066"]
}
]
*)

(* End of internal cache information *)

