(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18313,        491]
NotebookOptionsPosition[     13614,        387]
NotebookOutlinePosition[     15984,        447]
CellTagsIndexPosition[     15899,        442]
WindowTitle->IV
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "5d03af4a-b2d9-4ddb-8302-ab5df3aebec9"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"dedd3488-5eff-4bb5-8811-6117c65e8431"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"NDV\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/NDV"], "\<\"DV\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DV"], "\<\"DVEvaluate\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/DVEvaluate"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "3c4fccd5-4561-4bb6-b997-0885a17271ae"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"5d41d7ea-1988-45eb-bf1f-54eb956a8b4f"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ad30f9f1-ab87-4bfc-8522-bb94106ce179"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"ae626aff-a727-4999-8dcd-f8fb1433859b"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/IV\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/IV"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/IV.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$26310], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/IV", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "c4d68df9-bf74-4c75-adc2-5fe1339db429"]
    }], "AnchorBar",ExpressionUUID->"019d4872-2fca-4a63-80bd-27d32800c2c1"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"f715117c-e068-4595-a860-c992296ea6af"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["IV", "ObjectName",ExpressionUUID->
  "3ebd925f-2014-468b-a5bb-719accec843a"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"78815812-8b38-4ece-b186-9805637f1825"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "103ccb37-39fd-4374-a5de-143a7e3a7814"]
}], "ObjectNameGrid",ExpressionUUID->"ddcaf76d-0466-41e4-bf13-7569283dda32"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"IV", "[", 
       RowBox[{
        StyleBox["v", "TI"], ",", 
        StyleBox["r", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "49c52d7a-31f7-4539-8efc-68df455bc37d"],
     "\[LineSeparator]represents a value associated with a confidence \
interval that ranges from ",
     Cell[BoxData[
      RowBox[{
       StyleBox["v", "TI"], "-", 
       StyleBox["r", "TI"]}]], "InlineFormula",ExpressionUUID->
      "c7756715-ff4a-4733-ace8-17cd664421d7"],
     " to ",
     Cell[BoxData[
      RowBox[{
       StyleBox["v", "TI"], "+", 
       StyleBox["r", "TI"]}]], "InlineFormula",ExpressionUUID->
      "ededa39f-74f4-4cf8-9f24-c66c1c8d3a1d"],
     ". "
    }],ExpressionUUID->"20e7bb84-e5c4-4c40-a80c-88bf2bc0140f"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"IV", "[", 
       RowBox[{
        StyleBox["v", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["r", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["r", "TI"], 
           StyleBox["2", "TR"]]}], "}"}]}], "]"}]], "InlineFormula",
      ExpressionUUID->"5484ecf4-5751-40ed-9300-14eae95f93eb"],
     "\[LineSeparator]represents a value associated with a confidence \
interval from",
     Cell[BoxData[
      RowBox[{" ", 
       RowBox[{
        StyleBox["v", "TI"], "-", 
        StyleBox["r1", "TI"]}]}]], "InlineFormula",ExpressionUUID->
      "5089166f-aa34-4bd8-9a3f-c298681dc5d3"],
     " to ",
     Cell[BoxData[
      RowBox[{
       StyleBox["v", "TI"], "+", 
       StyleBox["r2", "TI"]}]], "InlineFormula",ExpressionUUID->
      "82edf8c9-b37d-44a4-bfbd-e05e758db4b6"],
     ". "
    }],ExpressionUUID->"3fc9187c-12d8-40ae-916d-cce16b14bd90"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"IV", "[", 
       RowBox[{
        TemplateBox[{Cell[
           TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
         "RefLink",
         BaseStyle->{"InlineFormula"}], "[", "...", "]"}], "]"}]], 
      "InlineFormula",ExpressionUUID->"288ef00a-5fca-4e67-a392-d35829682a4e"],
     "\[LineSeparator]gives the ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["IV"]],"paclet:DataAnalysis/ref/IV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "c846037c-0c82-4801-bf79-7b9ec2217047"],
     " for a ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "e842ac9c-815c-4b02-b56f-7d72ab240f1e"],
     " object."
    }],ExpressionUUID->"ce92aa5f-b70c-453a-a40e-53745aecee35"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"5612659a-3cb0-4ece-9cd7-d1a67fc476cd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"e42ecacc-9136-420d-990d-441593f9ccbd"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"fcf55721-2dcc-469a-a7c1-4847b2447880"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"22998189-b65e-4ef6-9fb5-9d6f52a8d15e"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->14962130,ExpressionUUID->"5353b760-4776-473e-80b2-6564190c6bff"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"f9309159-1aac-4d53-a6e7-7bc415efc19e"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["IV"]],"paclet:DataAnalysis/ref/IV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "b562c152-be86-4aad-a986-444b076b5160"],
 " symbols are mainly used internally by some functions in DataAnalysis."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"c55a289b-f5bd-4a5b-804c-0c882503a93f"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"3bcb371f-1854-4a0b-9599-3047a4cc67d1"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"86314533-5497-445e-b68e-bf288687a326"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "5c74b5f7-2b38-440c-a8cf-4330232e3061"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->24606955,ExpressionUUID->"c396bd44-dbf1-4a1a-b9fe-7cb69a6bf86c"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "860e53e7-a4e8-4b73-908d-6394e5e1a315"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->430887663,ExpressionUUID->"3487baea-27c6-4625-93c1-f69c01af7f2d"],

Cell[TextData[{
 "Get the relative confidence interval for a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f41317ec-5c66-4b6e-a7e9-bc1d76d917ca"],
 ":"
}], "ExampleText",
 CellID->309048743,ExpressionUUID->"97e84e21-164b-42c5-adcc-2e330685ce5c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IV", "[", 
  RowBox[{"NDV", "[", 
   RowBox[{"1", ",", "0.1"}], "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->690879624,ExpressionUUID->"6d8553f8-5e74-44be-a8c0-27ead955ef24"],

Cell[BoxData[
 RowBox[{"IV", "[", 
  RowBox[{"1", ",", "0.1959963984540054`"}], "]"}]], "Output",
 ImageSize->{106, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->250128797,ExpressionUUID->"cf02b3e3-2152-4337-a8f4-0662391fc2f6"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"b779870f-d0b1-45a7-a7dd-ab806ae90bfd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"10bea2eb-0665-4e2c-8fb0-7945979b7842"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"29519454-3d05-4d80-92bf-f336157dd035"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"c2928ec5-4600-4e70-b24c-ce9a46a93d64"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"0952870b-b8ac-4db4-813d-123986b7b459"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"f9a47ed1-9522-42df-ab4f-2a6feecd2a9a"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"945647d2-98d9-498b-9d18-7f532b69ff98"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"8175c37c-3ce8-4854-b463-5f65eb9b43e7"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"07a4e194-7cd8-4725-8584-b88720d7b19e"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"db72fce0-87ca-41ec-b86e-e046e9dbd2ef"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->124445699,ExpressionUUID->"ac42e1ec-36cb-425a-9d80-95e88fd92626"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"c0ffc0a8-f5a9-4d0a-ba6c-af9245c49fe8"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"IV",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 50.9356599}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "IV[v, r] represents a value associated with a confidence interval that \
ranges from v - r to v + r. IV[v, {r1, r2}] represents a value associated \
with a confidence interval from v - r1 to v + r2. IV[NDV[ ...]] gives the IV \
for a NDV object.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "IV", 
    "titlemodifier" -> "", "windowtitle" -> "IV", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/IV"}, "SearchTextTranslated" -> "", "NewStyles" -> 
  False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9721, 262, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"c396bd44-dbf1-4a1a-b9fe-7cb69a6bf86c",
   CellTags->"PrimaryExamplesSection",
   CellID->24606955]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15702, 435}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[574, 21, 4237, 95, 55, "AnchorBarGrid",ExpressionUUID->"f715117c-e068-4595-a860-c992296ea6af",
 CellID->1],
Cell[CellGroupData[{
Cell[4836, 120, 387, 9, 52, "ObjectNameGrid",ExpressionUUID->"ddcaf76d-0466-41e4-bf13-7569283dda32"],
Cell[5226, 131, 2986, 84, 258, "Usage",ExpressionUUID->"5612659a-3cb0-4ece-9cd7-d1a67fc476cd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8249, 220, 854, 21, 37, "NotesSection",ExpressionUUID->"5353b760-4776-473e-80b2-6564190c6bff",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->14962130],
Cell[9106, 243, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"f9309159-1aac-4d53-a6e7-7bc415efc19e"],
Cell[9195, 245, 400, 10, 70, "Notes",ExpressionUUID->"c55a289b-f5bd-4a5b-804c-0c882503a93f",
 CellID->1067943069],
Cell[9598, 257, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"3bcb371f-1854-4a0b-9599-3047a4cc67d1"]
}, Closed]],
Cell[CellGroupData[{
Cell[9721, 262, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"c396bd44-dbf1-4a1a-b9fe-7cb69a6bf86c",
 CellTags->"PrimaryExamplesSection",
 CellID->24606955],
Cell[CellGroupData[{
Cell[10180, 277, 308, 7, 29, "ExampleSection",ExpressionUUID->"3487baea-27c6-4625-93c1-f69c01af7f2d",
 CellID->430887663],
Cell[10491, 286, 377, 10, 39, "ExampleText",ExpressionUUID->"97e84e21-164b-42c5-adcc-2e330685ce5c",
 CellID->309048743],
Cell[CellGroupData[{
Cell[10893, 300, 209, 5, 26, "Input",ExpressionUUID->"6d8553f8-5e74-44be-a8c0-27ead955ef24",
 CellID->690879624],
Cell[11105, 307, 283, 7, 35, "Output",ExpressionUUID->"cf02b3e3-2152-4337-a8f4-0662391fc2f6",
 CellID->250128797]
}, Open  ]]
}, Open  ]],
Cell[11415, 318, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"b779870f-d0b1-45a7-a7dd-ab806ae90bfd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11538, 323, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"29519454-3d05-4d80-92bf-f336157dd035",
 CellID->1255426704],
Cell[11801, 332, 1074, 28, 24, "SeeAlso",ExpressionUUID->"945647d2-98d9-498b-9d18-7f532b69ff98",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12912, 365, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"07a4e194-7cd8-4725-8584-b88720d7b19e",
 CellID->38303248],
Cell[13181, 374, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"db72fce0-87ca-41ec-b86e-e046e9dbd2ef"],
Cell[13270, 376, 247, 6, 70, "MoreAbout",ExpressionUUID->"ac42e1ec-36cb-425a-9d80-95e88fd92626",
 CellID->124445699]
}, Open  ]],
Cell[13532, 385, 78, 0, 70, "FooterCell",ExpressionUUID->"c0ffc0a8-f5a9-4d0a-ba6c-af9245c49fe8"]
}
]
*)

(* End of internal cache information *)

