(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     11378,        310]
NotebookOptionsPosition[      8074,        240]
NotebookOutlinePosition[     10142,        292]
CellTagsIndexPosition[     10099,        289]
WindowTitle->MCEvaluate
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/MCEvaluate\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MCEvaluate"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MCEvaluate.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$30628], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MCEvaluate", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["MCEvaluate", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MCEvaluate", "[", 
       StyleBox["expr", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]evaluates expr while propagating errors in ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     " values using a Monte Carlo simulation with 1000 iterations. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MCEvaluate", "[", 
       RowBox[{
        StyleBox["expr", "TI"], ",", 
        StyleBox["i", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]evaluates expr while propagating errors in ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     " values using a Monte Carlo simulation with i iterations."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell["The following options can be given: ", "Notes"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["UseParallelKernels",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/UseParallelKernels"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell[TextData[{
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["UseParallelKernels"]],
        "paclet:DataAnalysis/ref/UseParallelKernels"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     " is an option for MonteCarloSimulation[...] which specifies whether \
parallel kernels should be used for the simulation."
    }], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["MatchPattern",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/MatchPattern"], "_", Cell[
    TextData[{
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["MatchPattern"]],"paclet:DataAnalysis/ref/MatchPattern"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     " is an option for MonteCarloSimulation[...] which specifies that only \
function results matching this pattern should be used (default is Blank[])."
    }], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["MissingBehavior",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/MissingBehavior"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell["\<\
MissingBehavior is an option to Query and related functions that specifies \
how expressions with head Missing should be interpreted in the context of \
other functions.\
\>", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}}],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MCEvaluate",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 4.6502745}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MCEvaluate[expr] evaluates expr while propagating errors in NDV values \
using a Monte Carlo simulation with 1000 iterations. MCEvaluate[expr, i] \
evaluates expr while propagating errors in NDV values using a Monte Carlo \
simulation with i iterations.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "MCEvaluate", "titlemodifier" -> "", "windowtitle" -> "MCEvaluate", 
    "type" -> "Symbol", "uri" -> "DataAnalysis/ref/MCEvaluate"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[582, 21, 3074, 74, 70, "AnchorBarGrid",ExpressionUUID->"2146990a-60f2-432b-948d-357b3360e2b7",
 CellID->1],
Cell[3659, 97, 167, 6, 70, "ObjectNameGrid",ExpressionUUID->"8ba6b966-386b-4075-9b79-af10e74086d0"],
Cell[3829, 105, 1146, 31, 70, "Usage",ExpressionUUID->"28183bcf-6d4f-43e9-8caa-8a6a978fb587"],
Cell[CellGroupData[{
Cell[5000, 140, 621, 19, 70, "NotesSection",ExpressionUUID->"b6f8bdeb-7e97-4e21-b012-e88ee478e7e0",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[5624, 161, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"0aacaa2e-fc92-4ca6-96c7-a1cc74798ff6"],
Cell[5658, 163, 53, 0, 70, "Notes",ExpressionUUID->"373f807a-4128-4b1d-a17f-2f76afa3c4ac"],
Cell[5714, 165, 1870, 46, 70, "3ColumnTableMod",ExpressionUUID->"9acd1c8f-9a5b-4b22-a881-461f8e80933e"],
Cell[7587, 213, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"c7141d9d-6729-469e-ab72-4f4b92d55373"]
}, Closed]],
Cell[CellGroupData[{
Cell[7655, 218, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"274b5110-8341-410b-a940-022f2e69261e",
 CellID->38303248],
Cell[7814, 227, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"f71a458d-337b-4fe6-aa2c-e824db3e1582"],
Cell[7848, 229, 184, 6, 70, "MoreAbout",ExpressionUUID->"26aff130-92f3-42f2-b038-05e7487b00fc",
 CellID->1]
}, Open  ]],
Cell[8047, 238, 23, 0, 70, "FooterCell",ExpressionUUID->"25a6d36f-db99-440d-bcc0-b49577a45e65"]
}
]
*)

(* End of internal cache information *)
