(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     23858,        619]
NotebookOptionsPosition[     17275,        480]
NotebookOutlinePosition[     19936,        543]
CellTagsIndexPosition[     19851,        538]
WindowTitle->MassFractionToMolality
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "3c11f476-555a-45f6-b0b6-f7f2db39da4d"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"7420b3f8-6c0b-4bb7-8c5e-49bc5aa308dd"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"MassFractionTomMolality\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassFractionTomMolality"], \
"\<\"MolalityToMassFraction\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolalityToMassFraction"], \
"\<\"RegisterOxide\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterOxide"], "\<\"RegisterComp\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterComp"], "\<\"MolarMass\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/MolarMass"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "9c42f81e-ff21-4912-93fc-13b9251b6ac0"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"9a553b4f-0c49-4a69-b3cc-93436f7c36b6"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "983fa4df-cfc0-4033-b449-bf5405ba20ff"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"a65c0758-f8d5-4f03-9760-e68503c367fd"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"DataAnalysis/ref/MassFractionToMolality\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MassFractionToMolality"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MassFractionToMolality.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$29015], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MassFractionToMolality", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "3f9bb305-29ec-40c0-86cd-4017dd62fe0f"]
    }], "AnchorBar",ExpressionUUID->"c4fefa86-a1c8-4330-a1c4-af952190408e"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"b256bebd-8661-41db-a27f-b3b36a3f7521"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["MassFractionToMolality", "ObjectName",ExpressionUUID->
  "caef2dce-7372-48b0-a5e8-ed33ded58026"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"d46d6297-5ea1-4d8e-821b-b1ed459a0334"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "20fe10eb-142d-4d83-8007-53f37d968b62"]
}], "ObjectNameGrid",ExpressionUUID->"6f78d8a8-3d97-4488-8a88-afdec6323077"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MassFractionToMolality", "[", 
       RowBox[{
        RowBox[{"<|", 
         RowBox[{
          RowBox[{
           SubscriptBox[
            StyleBox["comp", "TI"], "1"], "\[Rule]", 
           SubscriptBox[
            StyleBox["mass", "TI"], "1"]}], ",", 
          RowBox[{
           SubscriptBox[
            StyleBox["comp", "TI"], "2"], "\[Rule]", 
           SubscriptBox[
            StyleBox["mass", "TI"], "2"]}], ",", "..."}], "|>"}], ",", 
        StyleBox["prefix", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "8ba2233e-6d61-4963-8909-82944e334685"],
     "\[LineSeparator]converts mass fractions in an association where the \
keys are the component names (which can be suffixed by ' / ppm', etc.) and \
values are the mass fractions to molalities with the specified unit prefix \
(m,\[Mu],n,p), which is optional."
    }],ExpressionUUID->"0962b9e2-3aa7-4565-9510-cb310bce38fd"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MassFractionToMolality", "[", 
       RowBox[{
        StyleBox["mass", "TI"], ",", 
        StyleBox["comp", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "205e16f4-ab81-4137-8a98-5076ad136fbf"],
     "\[LineSeparator]converts a mass fractions of a component to molality \
assuming that it is the only solute."
    }],ExpressionUUID->"73c8a0c3-337d-41ae-8783-ce547996af6a"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"c1be052c-71da-4b0f-9ed2-d90f0862b543"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"44823086-6dce-435d-ae14-594962347d7e"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"77e8ee45-c176-4e72-854d-8cbb5cb75df7"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"af141fb7-383f-42d0-8a3d-7f8193028705"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->309155745,ExpressionUUID->"30a747d4-3de4-426a-b04d-43083041df0b"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"f8565c46-9b28-42fe-873c-f9a72ebd3f0c"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["molality"]],"https://en.wikipedia.org/wiki/Molality"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "9e4520d0-e7a7-4367-a6aa-8a7d5802d015"],
 " is the molar amount of a substance per mass of the solvent."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"d290d5f0-5f20-4874-89f8-c6fba6fe5bbe"],

Cell["\<\
Accurate molalities can only be calculated if all solutes of a compound are \
defined.\
\>", "Notes",
 CellID->453977726,ExpressionUUID->"54b1b3b8-e911-4ec2-9c94-beaeedd52eb2"],

Cell[TextData[{
 "Components have to be defined using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "b6aa2fe5-a124-4499-8f98-03f3bb22c635"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "901a81fa-02c8-46e0-b797-f4282e5b1ce3"],
 "."
}], "Notes",
 CellID->240785846,ExpressionUUID->"8c6db6df-da6b-42b8-814b-f6282d187fdd"],

Cell["Valid suffixes are %, ppm, ppb, ppt, and ppq.", "Notes",
 CellID->102413150,ExpressionUUID->"31a0a973-4143-4f06-8600-e96580d2ca49"],

Cell["\<\
Valid prefixes for molalities are m, \[Mu], n, p for milli, micro, nano, and \
pico molalities.\
\>", "Notes",
 CellID->371975926,ExpressionUUID->"822d569e-35fa-4205-aa01-2420f65ea3b3"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"be3f3568-3485-4707-bf9f-f71f4ceb1a5e"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"654398e1-6856-4e31-8071-b8b311b27315"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "73e234bf-ede3-4f2c-acf5-7e62e23db20a"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->124504677,ExpressionUUID->"8daf9d44-4d92-439f-8911-b57b71f605ae"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "eb638baf-fe1b-4f52-9ece-85450db503e9"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->20995714,ExpressionUUID->"7248c68b-78b9-4ba0-a92f-846e38bdba30"],

Cell["Calculate the molalities for a simple compound:", "ExampleText",
 CellID->3805587,ExpressionUUID->"aff07bf5-66c9-47e4-84fa-156c4c431c61"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassFractionToMolality", "[", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"\"\<MgO\>\"", "\[Rule]", "0.01"}], ",", 
    RowBox[{"\"\<CaO\>\"", "\[Rule]", "0.02"}]}], "|>"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->397596,ExpressionUUID->"62a4ac3d-2902-4263-ba9b-fad70594ce92"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO / mol/kg\"\>", "\[Rule]", "0.25578543162819606`"}], ",", 
   RowBox[{"\<\"CaO / mol/kg\"\>", "\[Rule]", "0.36768032578241727`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{346, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->400815276,ExpressionUUID->"60abede7-e18d-4f51-8be0-ed8a8a6015a9"]
}, Open  ]],

Cell["\<\
The calculated molality is slightly different if a solute is not defined:\
\>", "ExampleText",
 CellID->68588579,ExpressionUUID->"93356b0c-e310-48db-9af0-0f6ef01b9ffb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassFractionToMolality", "[", 
  RowBox[{"0.01", ",", "\"\<MgO\>\""}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->209314215,ExpressionUUID->"69b6affe-79c1-4c48-884f-dd3f34a31093"],

Cell[BoxData["0.25061804917106073`"], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->504502482,ExpressionUUID->"a3d9ddbe-695a-43d9-98f2-a31a56eb092c"]
}, Open  ]],

Cell["Use suffixes for mass fractions:", "ExampleText",
 CellID->167068885,ExpressionUUID->"7184b31f-9752-4d6e-8a44-f71385f67ffa"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassFractionToMolality", "[", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"\"\<MgO / ppm\>\"", "\[Rule]", "100"}], ",", 
    RowBox[{"\"\<CaO / ppq\>\"", "\[Rule]", "1000"}]}], "|>"}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->813569781,ExpressionUUID->"089ea62c-0141-4727-b833-2d72ca9dcf2d"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO / mol/kg\"\>", "\[Rule]", "0.0024813668234783307`"}], ",", 
   RowBox[{"\<\"CaO / mol/kg\"\>", "\[Rule]", "1.783427922838791`*^-11"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{405, 19},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->13967308,ExpressionUUID->"a67b9570-ee26-4a1f-b9c1-ae68acbc8083"]
}, Open  ]],

Cell["Use prefixes for molalities:", "ExampleText",
 CellID->264724132,ExpressionUUID->"95d926c2-baed-4bc5-9c7f-ef0aeb2af911"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassFractionToMolality", "[", 
  RowBox[{
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<MgO / ppm\>\"", "\[Rule]", "100"}], ",", 
     RowBox[{"\"\<CaO / ppq\>\"", "\[Rule]", "1000"}]}], "|>"}], ",", 
   "\"\<n\>\""}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->3079540,ExpressionUUID->"6cb3ceee-a9c0-4a84-8fca-e17bc89e05cb"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO / nmol/kg\"\>", "\[Rule]", "2.481366823478331`*^6"}], ",", 
   RowBox[{"\<\"CaO / nmol/kg\"\>", "\[Rule]", "0.01783427922838791`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{402, 19},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->623314015,ExpressionUUID->"3fa71b33-646f-41a0-9a88-455468198583"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"ec107335-d382-4109-a382-4088a972a0f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"98c65efe-3085-41a5-8af7-b17eb43de279"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"194e9cb2-60af-44b0-8e9f-173705d327ab"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassFractionTomMolality"]],
    "paclet:DataAnalysis/ref/MassFractionTomMolality"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"26dd56d8-9980-4d5f-9af7-fcfc1dd9441c"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolalityToMassFraction"]],
    "paclet:DataAnalysis/ref/MolalityToMassFraction"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"3af8d489-4055-433f-84db-d84e2475f092"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"b65ed2d5-5aa3-485e-bfaf-6b2e8ed64d04"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"2569dc97-568f-4708-a5e7-83054adc5d8e"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"d795c91d-c2b5-4d40-8b6c-b80a5c425402"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"75098c1f-af6e-4b0f-ace9-790a9d3cf1ce"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"877156d6-d6b2-40e7-b5c5-6dc9e325ef6a"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"11be8118-17fe-4e5a-a9a2-39e95b00bf13"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"cc08e842-c4ce-4e18-b513-80e568717a4a"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->65042479,ExpressionUUID->"545fd902-14f0-4977-86fc-126a01e7c241"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"6ed10d61-de0a-46db-8b57-82fc606c1194"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MassFractionToMolality",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 0.3748860}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MassFractionToMolality[<|comp1 -> mass1, comp2 -> mass2, ...|>, prefix] \
converts mass fractions in an association where the keys are the component \
names (which can be suffixed by ' / ppm', etc.) and values are the mass \
fractions to molalities with the specified unit prefix (m,\\[Mu],n,p), which \
is optional. MassFractionToMolality[mass, comp] converts a mass fractions of \
a component to molality assuming that it is the only solute.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "MassFractionToMolality", 
    "titlemodifier" -> "", "windowtitle" -> "MassFractionToMolality", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/MassFractionToMolality"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9966, 259, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"8daf9d44-4d92-439f-8911-b57b71f605ae",
   CellTags->"PrimaryExamplesSection",
   CellID->124504677]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 19653, 531}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 4638, 103, 55, "AnchorBarGrid",ExpressionUUID->"b256bebd-8661-41db-a27f-b3b36a3f7521",
 CellID->1],
Cell[CellGroupData[{
Cell[5257, 128, 407, 9, 52, "ObjectNameGrid",ExpressionUUID->"6f78d8a8-3d97-4488-8a88-afdec6323077"],
Cell[5667, 139, 1650, 39, 223, "Usage",ExpressionUUID->"c1be052c-71da-4b0f-9ed2-d90f0862b543"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7354, 183, 855, 21, 37, "NotesSection",ExpressionUUID->"30a747d4-3de4-426a-b04d-43083041df0b",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->309155745],
Cell[8212, 206, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"f8565c46-9b28-42fe-873c-f9a72ebd3f0c"],
Cell[8301, 208, 383, 10, 70, "Notes",ExpressionUUID->"d290d5f0-5f20-4874-89f8-c6fba6fe5bbe",
 CellID->1067943069],
Cell[8687, 220, 186, 4, 70, "Notes",ExpressionUUID->"54b1b3b8-e911-4ec2-9c94-beaeedd52eb2",
 CellID->453977726],
Cell[8876, 226, 626, 17, 70, "Notes",ExpressionUUID->"8c6db6df-da6b-42b8-814b-f6282d187fdd",
 CellID->240785846],
Cell[9505, 245, 137, 1, 70, "Notes",ExpressionUUID->"31a0a973-4143-4f06-8600-e96580d2ca49",
 CellID->102413150],
Cell[9645, 248, 195, 4, 70, "Notes",ExpressionUUID->"822d569e-35fa-4205-aa01-2420f65ea3b3",
 CellID->371975926],
Cell[9843, 254, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"be3f3568-3485-4707-bf9f-f71f4ceb1a5e"]
}, Closed]],
Cell[CellGroupData[{
Cell[9966, 259, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"8daf9d44-4d92-439f-8911-b57b71f605ae",
 CellTags->"PrimaryExamplesSection",
 CellID->124504677],
Cell[CellGroupData[{
Cell[10426, 274, 307, 7, 29, "ExampleSection",ExpressionUUID->"7248c68b-78b9-4ba0-a92f-846e38bdba30",
 CellID->20995714],
Cell[10736, 283, 143, 1, 38, "ExampleText",ExpressionUUID->"aff07bf5-66c9-47e4-84fa-156c4c431c61",
 CellID->3805587],
Cell[CellGroupData[{
Cell[10904, 288, 307, 7, 26, "Input",ExpressionUUID->"62a4ac3d-2902-4263-ba9b-fad70594ce92",
 CellID->397596],
Cell[11214, 297, 433, 10, 35, "Output",ExpressionUUID->"60abede7-e18d-4f51-8be0-ed8a8a6015a9",
 CellID->400815276]
}, Open  ]],
Cell[11662, 310, 178, 3, 38, "ExampleText",ExpressionUUID->"93356b0c-e310-48db-9af0-0f6ef01b9ffb",
 CellID->68588579],
Cell[CellGroupData[{
Cell[11865, 317, 209, 4, 26, "Input",ExpressionUUID->"69b6affe-79c1-4c48-884f-dd3f34a31093",
 CellID->209314215],
Cell[12077, 323, 232, 5, 35, "Output",ExpressionUUID->"a3d9ddbe-695a-43d9-98f2-a31a56eb092c",
 CellID->504502482]
}, Open  ]],
Cell[12324, 331, 130, 1, 38, "ExampleText",ExpressionUUID->"7184b31f-9752-4d6e-8a44-f71385f67ffa",
 CellID->167068885],
Cell[CellGroupData[{
Cell[12479, 336, 324, 8, 26, "Input",ExpressionUUID->"089ea62c-0141-4727-b833-2d72ca9dcf2d",
 CellID->813569781],
Cell[12806, 346, 437, 10, 40, "Output",ExpressionUUID->"a67b9570-ee26-4a1f-b9c1-ae68acbc8083",
 CellID->13967308]
}, Open  ]],
Cell[13258, 359, 126, 1, 70, "ExampleText",ExpressionUUID->"95d926c2-baed-4bc5-9c7f-ef0aeb2af911",
 CellID->264724132],
Cell[CellGroupData[{
Cell[13409, 364, 358, 9, 70, "Input",ExpressionUUID->"6cb3ceee-a9c0-4a84-8fca-e17bc89e05cb",
 CellID->3079540],
Cell[13770, 375, 436, 10, 40, "Output",ExpressionUUID->"3fa71b33-646f-41a0-9a88-455468198583",
 CellID->623314015]
}, Open  ]]
}, Open  ]],
Cell[14233, 389, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"ec107335-d382-4109-a382-4088a972a0f5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14356, 394, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"194e9cb2-60af-44b0-8e9f-173705d327ab",
 CellID->1255426704],
Cell[14619, 403, 1918, 50, 70, "SeeAlso",ExpressionUUID->"75098c1f-af6e-4b0f-ace9-790a9d3cf1ce",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[16574, 458, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"11be8118-17fe-4e5a-a9a2-39e95b00bf13",
 CellID->38303248],
Cell[16843, 467, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"cc08e842-c4ce-4e18-b513-80e568717a4a"],
Cell[16932, 469, 246, 6, 70, "MoreAbout",ExpressionUUID->"545fd902-14f0-4977-86fc-126a01e7c241",
 CellID->65042479]
}, Open  ]],
Cell[17193, 478, 78, 0, 70, "FooterCell",ExpressionUUID->"6ed10d61-de0a-46db-8b57-82fc606c1194"]
}
]
*)

(* End of internal cache information *)

