(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18310,        480]
NotebookOptionsPosition[     13566,        375]
NotebookOutlinePosition[     15879,        434]
CellTagsIndexPosition[     15794,        429]
WindowTitle->MassFractionTomMolality
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "2a7245ef-d32b-47a2-b490-550d6d67c9c5"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"31484150-bfba-48c2-94dd-ee2ccc063678"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"MassFractionToMolality\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassFractionToMolality"], \
"\<\"MolalityToMassFraction\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolalityToMassFraction"], \
"\<\"RegisterOxide\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterOxide"], "\<\"RegisterComp\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterComp"], "\<\"MolarMass\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/MolarMass"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "63523c05-86fd-455f-814b-cfc29339cd20"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"9dc524f1-385a-4430-bd38-d099431aef7e"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "5fac29ea-28ae-4142-b7f7-44ca109a9fb6"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"15061ec8-27d3-424b-a4ec-675028bed8e1"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"DataAnalysis/ref/MassFractionTomMolality\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MassFractionTomMolality"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MassFractionTomMolality.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$28465], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MassFractionTomMolality", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0cb2c137-9dfc-42af-a493-dd5907618a01"]
    }], "AnchorBar",ExpressionUUID->"4935663d-7ce5-48ea-9886-4fae01a08f39"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"e96f86ce-c607-441b-8f96-2841c7da4767"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["MassFractionTomMolality", "ObjectName",ExpressionUUID->
  "f3dffc6d-fd1f-46e6-b89c-a74c9b8ac419"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"3e099c48-7496-4363-89ae-5c2412f27526"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "4b66a12c-adcc-4e43-8853-99801393f1db"]
}], "ObjectNameGrid",ExpressionUUID->"eea54cc1-f2c4-4b0b-b88a-c2c1e31967c6"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MassFractionTomMolality", "[", 
       StyleBox["data", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "80f73202-a6ac-4c8b-8f78-9043b3c3c056"],
     "\[LineSeparator]is a short version of ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["MassFractionToMolality"]],
         "paclet:DataAnalysis/ref/MassFractionToMolality"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", 
        "\"\<\!\(\*StyleBox[\"m\", \"TI\"]\)\>\""}], "]"}]], "InlineFormula",
      ExpressionUUID->"6fdf9778-62f9-482c-8f84-d5bb90e4c640"]
    }],ExpressionUUID->"a7e975d7-9fe2-4484-ab6e-284dfa09ccdc"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"fd7e22a6-45da-4cb4-b96a-e6aff031206b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"ee138abe-94d6-4e27-ba17-e3d3f2d4b621"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"42006bc4-cbe7-4225-82cd-78cb39403b45"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"aa9691d7-dc17-402f-9602-d6ae8f04c4e1"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->104425389,ExpressionUUID->"7feb6402-8d36-4d26-8811-a6a5f2333e6c"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"9e29ca66-c576-45ce-a0d4-93a54efdf206"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["molality"]],"https://en.wikipedia.org/wiki/Molality"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "2c99d6e2-0f0f-4dab-b8f0-125092e60b86"],
 " is the molar amount of a substance per mass of the solvent."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"450271b9-0958-45fb-9583-889c14778935"],

Cell["\<\
Accurate molalities can only be calculated if all solutes of a compound are \
defined.\
\>", "Notes",
 CellID->453977726,ExpressionUUID->"34cee3a7-acc2-4a6b-8ce3-c26bd3b0da7f"],

Cell[TextData[{
 "Components have to be defined using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f130a528-f5d4-48ca-a9b2-ea90968a8f8b"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "3a4593d9-6ad1-4305-9df0-fe3272336f3f"],
 "."
}], "Notes",
 CellID->240785846,ExpressionUUID->"5e036cc3-ea6b-4fa9-a826-62432d34a654"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"517bb00b-f498-4325-9da9-1ddf7dcc5882"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"73598206-23c5-4080-b3fc-fb686a3dc313"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "0ea5dbf4-b079-4c6d-b25f-04b846f6ddb8"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->330500871,ExpressionUUID->"3ef18a04-a35e-448d-9c0f-66e4a3a6bca8"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "4e341b14-9bcc-4500-a895-6a96d6193a2f"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->385883715,ExpressionUUID->"f09a775a-1672-4b31-9692-98ebfa938f37"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassFractionTomMolality", "[", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"\"\<MgO\>\"", "\[Rule]", "0.0001"}], ",", 
    RowBox[{"\"\<CaO\>\"", "\[Rule]", "0.0002"}]}], "|>"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->397596,ExpressionUUID->"39510207-63bd-46d8-bd83-fc30218f2706"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO / mmol/kg\"\>", "\[Rule]", "2.4818632457672316`"}], ",", 
   RowBox[{"\<\"CaO / mmol/kg\"\>", "\[Rule]", "3.5675694309187236`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{353, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->6262622,ExpressionUUID->"1affbfbf-94b4-45ea-b7bc-287a18e25d5d"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"fd811bee-22f1-47b7-b998-6ee8129202a1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"86f33f57-0fc1-40d3-b5fc-781ba336b17e"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"fb81145a-d816-4b55-a633-8a97c2f478c0"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassFractionToMolality"]],
    "paclet:DataAnalysis/ref/MassFractionToMolality"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"93c30959-3530-4431-af29-6d094a96866c"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolalityToMassFraction"]],
    "paclet:DataAnalysis/ref/MolalityToMassFraction"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"bd962901-cee0-4b5c-b4a1-5bdb6952916b"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"0ed6e52d-98d3-4ea9-8f62-e82b2b12bb75"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"3e660cd8-214f-418c-91fb-6e2443e18ebb"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"81dbd8f0-df22-4623-a9ec-79bd68afb8b6"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"d337f95f-cd8d-48e2-aacc-781e377b3976"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"e7b7a2a8-e7dd-4480-9329-d4f35cf86fc0"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"67c1ec23-23a2-4f5c-81f9-1226de8ea7a9"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"88621916-52ea-44ca-b9e8-86f2ed8e3885"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->270189321,ExpressionUUID->"2d464750-8412-401b-883c-d6dc8d481497"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"507bd529-d3cb-4484-a890-21ca36585f34"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MassFractionTomMolality",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 36, 58.6396086}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MassFractionTomMolality[data] is a short version of \
MassFractionToMolality[data, \" m\"]", "synonyms" -> {}, "tabletags" -> {}, 
    "title" -> "MassFractionTomMolality", "titlemodifier" -> "", 
    "windowtitle" -> "MassFractionTomMolality", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/MassFractionTomMolality"}, "SearchTextTranslated" -> "",
   "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8959, 235, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3ef18a04-a35e-448d-9c0f-66e4a3a6bca8",
   CellTags->"PrimaryExamplesSection",
   CellID->330500871]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15596, 422}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 4640, 103, 55, "AnchorBarGrid",ExpressionUUID->"e96f86ce-c607-441b-8f96-2841c7da4767",
 CellID->1],
Cell[CellGroupData[{
Cell[5260, 128, 408, 9, 52, "ObjectNameGrid",ExpressionUUID->"eea54cc1-f2c4-4b0b-b88a-c2c1e31967c6"],
Cell[5671, 139, 977, 24, 110, "Usage",ExpressionUUID->"fd7e22a6-45da-4cb4-b96a-e6aff031206b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6685, 168, 855, 21, 37, "NotesSection",ExpressionUUID->"7feb6402-8d36-4d26-8811-a6a5f2333e6c",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->104425389],
Cell[7543, 191, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"9e29ca66-c576-45ce-a0d4-93a54efdf206"],
Cell[7632, 193, 383, 10, 70, "Notes",ExpressionUUID->"450271b9-0958-45fb-9583-889c14778935",
 CellID->1067943069],
Cell[8018, 205, 186, 4, 70, "Notes",ExpressionUUID->"34cee3a7-acc2-4a6b-8ce3-c26bd3b0da7f",
 CellID->453977726],
Cell[8207, 211, 626, 17, 70, "Notes",ExpressionUUID->"5e036cc3-ea6b-4fa9-a826-62432d34a654",
 CellID->240785846],
Cell[8836, 230, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"517bb00b-f498-4325-9da9-1ddf7dcc5882"]
}, Closed]],
Cell[CellGroupData[{
Cell[8959, 235, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3ef18a04-a35e-448d-9c0f-66e4a3a6bca8",
 CellTags->"PrimaryExamplesSection",
 CellID->330500871],
Cell[CellGroupData[{
Cell[9419, 250, 308, 7, 29, "ExampleSection",ExpressionUUID->"f09a775a-1672-4b31-9692-98ebfa938f37",
 CellID->385883715],
Cell[CellGroupData[{
Cell[9752, 261, 312, 7, 26, "Input",ExpressionUUID->"39510207-63bd-46d8-bd83-fc30218f2706",
 CellID->397596],
Cell[10067, 270, 431, 10, 35, "Output",ExpressionUUID->"1affbfbf-94b4-45ea-b7bc-287a18e25d5d",
 CellID->6262622]
}, Open  ]]
}, Open  ]],
Cell[10525, 284, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"fd811bee-22f1-47b7-b998-6ee8129202a1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10648, 289, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"fb81145a-d816-4b55-a633-8a97c2f478c0",
 CellID->1255426704],
Cell[10911, 298, 1916, 50, 45, "SeeAlso",ExpressionUUID->"d337f95f-cd8d-48e2-aacc-781e377b3976",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12864, 353, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"67c1ec23-23a2-4f5c-81f9-1226de8ea7a9",
 CellID->38303248],
Cell[13133, 362, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"88621916-52ea-44ca-b9e8-86f2ed8e3885"],
Cell[13222, 364, 247, 6, 24, "MoreAbout",ExpressionUUID->"2d464750-8412-401b-883c-d6dc8d481497",
 CellID->270189321]
}, Open  ]],
Cell[13484, 373, 78, 0, 41, "FooterCell",ExpressionUUID->"507bd529-d3cb-4484-a890-21ca36585f34"]
}
]
*)

(* End of internal cache information *)

