(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18622,        486]
NotebookOptionsPosition[     13605,        376]
NotebookOutlinePosition[     16157,        438]
CellTagsIndexPosition[     16072,        433]
WindowTitle->MassToMoles
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "7e037cb9-0718-4548-acd7-0e99181a1656"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"120c4a1e-bff0-47d6-b415-7ac449a19f05"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"MolesToMass\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolesToMass"], "\<\"MolarMass\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolarMass"], "\<\"MolalityToMassFraction\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolalityToMassFraction"], \
"\<\"MassFractionToMolality\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassFractionToMolality"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ef48fef6-fbc2-4a03-92b2-a3029d446afa"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"54e2b199-ad44-428f-8b82-9d054a169cdc"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4461fde7-7c66-4123-a6a7-0ff795ffd025"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"b8f07d03-d891-40eb-99b5-fb9227e01536"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/MassToMoles\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MassToMoles"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MassToMoles.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$29560], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MassToMoles", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "30834989-8589-46f8-9281-195001c49b61"]
    }], "AnchorBar",ExpressionUUID->"b011edca-2217-41e0-8334-02d08e217427"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"64e185da-2210-4b10-8e3a-b99402e8226f"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["MassToMoles", "ObjectName",ExpressionUUID->
  "97adc146-ca41-4654-9ac2-e98b994c0542"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"a128f791-7b3e-440d-8e2b-6096ea56fba5"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "09c0b7ab-1744-476c-825a-d2a4d93b3f0d"]
}], "ObjectNameGrid",ExpressionUUID->"c0feb2d5-d0bc-4bb4-83a6-646813b25467"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MassToMoles", "[", 
       RowBox[{
        StyleBox["comp", "TI"], ",", 
        StyleBox["mass", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "d84b1f6d-529b-407b-ba27-70a7ee1f3587"],
     "\[LineSeparator]converts a mass of a chemical component to a molar \
amount. "
    }],ExpressionUUID->"5bdb0e3e-b041-4a31-8c7a-fb59030364ce"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MassToMoles", "[", 
       StyleBox["datatable", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "2e69b28f-c532-4b6a-9203-aa46a005cd45"],
     "\[LineSeparator]convert the data in all columns of a ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "3515cb41-e89e-471c-81c9-65cacc4c16e1"],
     " from masses to molar amounts based on the component specified as \
column header. "
    }],ExpressionUUID->"1f501e45-4329-47c9-90f5-802c24530b5f"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MassToMoles", "[", 
       StyleBox["association", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "2e534cee-794e-4885-8d90-157dbd0334a8"],
     "\[LineSeparator]convert the data in elements of an Association from \
masses to molar amounts based on the component specified as keys."
    }],ExpressionUUID->"bce1faac-472d-433a-8745-0712032e767b"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"d9a0be58-cf7a-46db-9af4-ef672085d61e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"c54a42df-3fea-4279-8158-28765a9ca3a2"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"e6e1f4ee-064b-4b0c-8570-faa262ac1a1c"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"7c9261d0-024c-40d1-a22d-8129e39312c7"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->42348471,ExpressionUUID->"0aca1501-f92c-41c7-b8c9-8bb51d3ebc50"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"4702b93f-e15e-4ef0-8cf5-b63850ad1c73"],

Cell[TextData[{
 "Components have to be defined using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "12bbcc5d-4f06-4dee-a944-39692f278ba9"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "a131ff8b-1a98-4c7b-b3c9-84c7fa2d8774"],
 "."
}], "Notes",
 CellID->240785846,ExpressionUUID->"8fc7f709-f076-466a-a070-1a35777faad8"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"bd9cb2cf-b3a8-42bf-bafa-682bd916148f"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"26d9b5eb-6aae-4e26-8f8d-e075da3c4675"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "eb113742-27bc-4991-8355-9b165f664dae"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->2447104,ExpressionUUID->"9fbc6ce5-0108-4758-9fa2-5b798acf54ca"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "9426be81-6f80-44b6-aaff-e49e60644ecf"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->516047973,ExpressionUUID->"69736f9d-2197-418c-abc8-2b0747fe9534"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassToMoles", "[", 
  RowBox[{"\"\<CaO\>\"", ",", "10"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->185766337,ExpressionUUID->"f5fdaa94-e197-4ceb-92a0-873bc3b345d3"],

Cell[BoxData["0.17832495800447237`"], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->72088626,ExpressionUUID->"429a4935-9961-4d78-ba68-034143273fad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassToMoles", "[", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"\"\<MgO\>\"", "\[Rule]", "10"}], ",", 
    RowBox[{"\"\<CaO\>\"", "\[Rule]", "20"}]}], "|>"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->325650084,ExpressionUUID->"7e11a05d-99d6-4003-8892-08bbb489f0f3"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO\"\>", "\[Rule]", "0.24811186867935014`"}], ",", 
   RowBox[{"\<\"CaO\"\>", "\[Rule]", "0.35664991600894475`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{220, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->54812237,ExpressionUUID->"b2be3ea9-7c8b-4467-9ced-22f47fbb9a3e"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"f77c6c93-4a7a-48ec-9203-217cf47358ab"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"f445eff4-bfe6-4076-bf44-8213a35385dc"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"16dbd388-1ff4-4697-9579-b6ab86bcbbb6"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolesToMass"]],"paclet:DataAnalysis/ref/MolesToMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"e3de0b70-b3d5-4901-ace7-a8c7d7f15825"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"7b15ea1f-9b6a-4f33-9927-5129313f2a56"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolalityToMassFraction"]],
    "paclet:DataAnalysis/ref/MolalityToMassFraction"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"2291187c-6f68-4bc3-8d4e-10caea1a0698"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassFractionToMolality"]],
    "paclet:DataAnalysis/ref/MassFractionToMolality"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"86a3afc9-dfca-4de2-a3b4-b390623ed05e"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"f10e8364-2c5f-4d85-8b97-cf9f1c7dfdea"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"2fdd7f1b-9b2c-41e7-b424-f2dbd7ab12eb"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"d4e85566-cca3-480e-97bf-cd82f3543491"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"82017090-dbf4-4da7-b42c-a85c689f1a3e"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->110266729,ExpressionUUID->"e8b7a6ab-1514-4e1c-895b-111f87943308"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"64614193-cc9e-45f1-ac30-ff993c02ffee"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MassToMoles",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 2.0834303}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MassToMoles[comp, mass] converts a mass of a chemical component to a \
molar amount. MassToMoles[datatable] convert the data in all columns of a \
DataTable from masses to molar amounts based on the component specified as \
column header. MassToMoles[association] convert the data in elements of an \
Association from masses to molar amounts based on the component specified as \
keys.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "MassToMoles", 
    "titlemodifier" -> "", "windowtitle" -> "MassToMoles", "type" -> "Symbol",
     "uri" -> "DataAnalysis/ref/MassToMoles"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8948, 230, 433, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"9fbc6ce5-0108-4758-9fa2-5b798acf54ca",
   CellTags->"PrimaryExamplesSection",
   CellID->2447104]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15876, 426}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[583, 21, 4472, 100, 55, "AnchorBarGrid",ExpressionUUID->"64e185da-2210-4b10-8e3a-b99402e8226f",
 CellID->1],
Cell[CellGroupData[{
Cell[5080, 125, 396, 9, 52, "ObjectNameGrid",ExpressionUUID->"c0feb2d5-d0bc-4bb4-83a6-646813b25467"],
Cell[5479, 136, 1734, 40, 298, "Usage",ExpressionUUID->"d9a0be58-cf7a-46db-9af4-ef672085d61e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7250, 181, 854, 21, 37, "NotesSection",ExpressionUUID->"0aca1501-f92c-41c7-b8c9-8bb51d3ebc50",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->42348471],
Cell[8107, 204, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"4702b93f-e15e-4ef0-8cf5-b63850ad1c73"],
Cell[8196, 206, 626, 17, 70, "Notes",ExpressionUUID->"8fc7f709-f076-466a-a070-1a35777faad8",
 CellID->240785846],
Cell[8825, 225, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"bd9cb2cf-b3a8-42bf-bafa-682bd916148f"]
}, Closed]],
Cell[CellGroupData[{
Cell[8948, 230, 433, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"9fbc6ce5-0108-4758-9fa2-5b798acf54ca",
 CellTags->"PrimaryExamplesSection",
 CellID->2447104],
Cell[CellGroupData[{
Cell[9406, 245, 308, 7, 29, "ExampleSection",ExpressionUUID->"69736f9d-2197-418c-abc8-2b0747fe9534",
 CellID->516047973],
Cell[CellGroupData[{
Cell[9739, 256, 196, 4, 26, "Input",ExpressionUUID->"f5fdaa94-e197-4ceb-92a0-873bc3b345d3",
 CellID->185766337],
Cell[9938, 262, 231, 5, 35, "Output",ExpressionUUID->"429a4935-9961-4d78-ba68-034143273fad",
 CellID->72088626]
}, Open  ]],
Cell[CellGroupData[{
Cell[10206, 272, 295, 7, 26, "Input",ExpressionUUID->"7e11a05d-99d6-4003-8892-08bbb489f0f3",
 CellID->325650084],
Cell[10504, 281, 414, 10, 35, "Output",ExpressionUUID->"b2be3ea9-7c8b-4467-9ced-22f47fbb9a3e",
 CellID->54812237]
}, Open  ]]
}, Open  ]],
Cell[10945, 295, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"f77c6c93-4a7a-48ec-9203-217cf47358ab"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11068, 300, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"16dbd388-1ff4-4697-9579-b6ab86bcbbb6",
 CellID->1255426704],
Cell[11331, 309, 1535, 40, 70, "SeeAlso",ExpressionUUID->"f10e8364-2c5f-4d85-8b97-cf9f1c7dfdea",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12903, 354, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"d4e85566-cca3-480e-97bf-cd82f3543491",
 CellID->38303248],
Cell[13172, 363, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"82017090-dbf4-4da7-b42c-a85c689f1a3e"],
Cell[13261, 365, 247, 6, 70, "MoreAbout",ExpressionUUID->"e8b7a6ab-1514-4e1c-895b-111f87943308",
 CellID->110266729]
}, Open  ]],
Cell[13523, 374, 78, 0, 70, "FooterCell",ExpressionUUID->"64614193-cc9e-45f1-ac30-ff993c02ffee"]
}
]
*)

(* End of internal cache information *)

