(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     23576,        611]
NotebookOptionsPosition[     17060,        473]
NotebookOutlinePosition[     19767,        537]
CellTagsIndexPosition[     19682,        532]
WindowTitle->MolalityToMassFraction
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "c0e41491-231a-40cc-9881-3995124b6ab8"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"003ebc22-004d-451e-a55b-bc6500dd46d5"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"MolalityToPpm\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolalityToPpm"], \
"\<\"MassToMolarFraction\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassToMolarFraction"], \
"\<\"RegisterOxide\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterOxide"], "\<\"RegisterComp\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterComp"], "\<\"MolarMass\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/MolarMass"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "3a21c582-ab98-48a1-88cd-72794eaed3be"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"139629ee-b048-4916-aacb-b673b5aead27"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "f7aeba8d-9fe8-4f0d-8592-b08c0105cbf2"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"6e49d261-fe32-4779-9f38-c161a8037906"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"DataAnalysis/ref/MolalityToMassFraction\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MolalityToMassFraction"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MolalityToMassFraction.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$32656], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MolalityToMassFraction", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "50942790-c894-4dc2-a723-9f7c5e67b5aa"]
    }], "AnchorBar",ExpressionUUID->"abfc0f48-245f-4534-8c08-c800c199f146"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"ed9b4613-0e81-45cc-985f-d6b7e8b6cf9b"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["MolalityToMassFraction", "ObjectName",ExpressionUUID->
  "c48d305b-2fc8-4b5e-b8d9-f975096ec704"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"dde3729b-aabb-4da4-b259-f172e9a7a3db"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "ad7d41a0-137d-4772-a000-0cded8abc9f5"]
}], "ObjectNameGrid",ExpressionUUID->"cd9f3117-b323-42d4-87f0-64c5e1b9ae13"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MolalityToMassFraction", "[", 
       RowBox[{
        RowBox[{"<|", 
         RowBox[{
          RowBox[{
           SubscriptBox[
            StyleBox["comp", "TI"], "1"], "\[Rule]", 
           SubscriptBox[
            StyleBox["amount", "TI"], "1"]}], ",", 
          RowBox[{
           SubscriptBox[
            StyleBox["comp", "TI"], "2"], "\[Rule]", 
           SubscriptBox[
            StyleBox["amount", "TI"], "2"]}], ",", "..."}], "|>"}], ",", 
        StyleBox["quantifier", "TI"]}], "]"}]], "InlineFormula",
      ExpressionUUID->"01244ea8-a65e-4c9c-ab05-764758b0c215"],
     "\[LineSeparator]converts molalities in an association where the keys \
are the component names (which can have a unit with unit prefix \
mmol/kg,\[Mu]mol/kg,nmol/kg,pmol/kg) and values are the molalities to mass \
fractions with the specified unit quantifier (ppm, etc.), which is optional."
    }],ExpressionUUID->"9ed98798-7ded-4999-8511-640ab93c6bfb"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MolalityToMassFraction", "[", 
       RowBox[{
        StyleBox["amount", "TI"], ",", 
        StyleBox["comp", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "5b3aed7c-6015-4be3-b689-cc0aec0adf39"],
     "\[LineSeparator]converts a molality of a component to a mass fraction \
assuming that it is the only solute."
    }],ExpressionUUID->"338834e1-92b2-498a-a3d5-508bdfed4385"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"3b78249c-ff10-44b3-8665-c7f64d645a61"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"e0f04149-f1e7-4e1d-8874-f8611295a1c9"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"a2d6c7a8-0b2a-4180-9fa3-e5792b3e1b66"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"66f3331e-b7f1-4844-a8d5-39fe06480458"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->70444123,ExpressionUUID->"7521296e-6929-4b53-87c9-6df87af45c31"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"b12bdf4e-f60d-416f-af52-0a631dbd853b"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["molality"]],"https://en.wikipedia.org/wiki/Molality"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "681a1594-9f2f-472a-b88e-ba2051af376c"],
 " is the molar amount of a substance per mass of the solvent."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"b4e5fab4-0b1e-4215-9613-b09b55c6e24d"],

Cell[TextData[{
 "Components have to be defined using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "07e83550-78e5-405a-a29d-b1fe27aba7f4"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "85058d45-67fa-4a53-a341-dd15ed890258"],
 "."
}], "Notes",
 CellID->240785846,ExpressionUUID->"d0c11fda-2869-41cd-8ecf-587021f32b1b"],

Cell["Valid unit quantifiers are %, ppm, ppb, ppt, and ppq.", "Notes",
 CellID->102413150,ExpressionUUID->"472f010b-4585-4635-a0a3-3ad5659028a6"],

Cell["\<\
Valid units for molalities are mol/kg, mmol/kg, \[Mu]mol/kg, nmol/kg, and \
pmol/kg.\
\>", "Notes",
 CellID->371975926,ExpressionUUID->"753867de-16c9-4ce5-91ab-392b040468aa"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"feb18bef-d50a-4766-aa17-787ae2c1c784"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"747abcb6-d7b1-43ac-8507-c0c422737181"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "70f3f41a-e0b5-4590-8996-50f47a919dba"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->728328099,ExpressionUUID->"f13b231d-900b-4850-b8e1-5e42d7b3d2b7"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "4eab111a-abd5-4ff6-a355-78a816c16d3f"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->151913526,ExpressionUUID->"085db422-b7ad-468d-9b00-91d9d7c27b22"],

Cell["Calculate the mass fractions for a simple compound:", "ExampleText",
 CellID->3805587,ExpressionUUID->"92ddf9a9-ac2f-4d43-bddd-ff8d7f011830"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolalityToMassFraction", "[", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"\"\<MgO\>\"", "\[Rule]", "0.01"}], ",", 
    RowBox[{"\"\<CaO\>\"", "\[Rule]", "0.02"}]}], "|>"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->397596,ExpressionUUID->"6a240b38-6091-4b56-9428-f750fba7e617"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO\"\>", "\[Rule]", "0.00040243045774356783`"}], ",", 
   RowBox[{"\<\"CaO\"\>", "\[Rule]", "0.0011198406998277682`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{255, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->591737595,ExpressionUUID->"f1389214-f959-4a42-adab-5bd0327efa30"]
}, Open  ]],

Cell["\<\
The calculated mass fraction is slightly different if a solute is not defined:\
\>", "ExampleText",
 CellID->68588579,ExpressionUUID->"b46639f5-e80a-412d-8ce9-b70d2024e8f1"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolalityToMassFraction", "[", 
  RowBox[{"0.01", ",", "\"\<MgO\>\""}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->209314215,ExpressionUUID->"1ad622ca-62b0-49ed-a7ad-14b19e2fa3b1"],

Cell[BoxData["0.00040288162097995377`"], "Output",
 ImageSize->{81, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->240912031,ExpressionUUID->"eacf850f-65b5-48e8-a881-a0d1db0627dc"]
}, Open  ]],

Cell["Use a unit quantifier for mass fractions:", "ExampleText",
 CellID->167068885,ExpressionUUID->"5615fd8b-b01a-4f42-8d69-96bcf423b436"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolalityToMassFraction", "[", 
  RowBox[{
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<MgO\>\"", "\[Rule]", "0.01"}], ",", 
     RowBox[{"\"\<CaO\>\"", "\[Rule]", "0.02"}]}], "|>"}], ",", 
   "\"\<ppm\>\""}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->813569781,ExpressionUUID->"c525fc44-e165-4e22-825e-87f53caeb1d2"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO / ppm\"\>", "\[Rule]", "402.43045774356784`"}], ",", 
   RowBox[{"\<\"CaO / ppm\"\>", "\[Rule]", "1119.8406998277683`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{290, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->50348476,ExpressionUUID->"24b9b54a-856f-40e5-9606-85254f9ebecd"]
}, Open  ]],

Cell["Use a different unit for molalities:", "ExampleText",
 CellID->264724132,ExpressionUUID->"6609da18-0cd9-4cfe-b089-3f71f2ab263c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolalityToMassFraction", "[", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"\"\<MgO / mmol/kg\>\"", "\[Rule]", "100"}], ",", 
    RowBox[{"\"\<CaO / \[Mu]mol/kg\>\"", "\[Rule]", "100000"}]}], "|>"}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->3079540,ExpressionUUID->"24742573-70a0-478b-b0d6-71cf4fa552fc"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO\"\>", "\[Rule]", "0.003991964725422726`"}], ",", 
   RowBox[{"\<\"CaO\"\>", "\[Rule]", "0.0055542075478960205`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{255, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->350599813,ExpressionUUID->"aa4f3fff-5023-4634-ac29-ee3276ce2a84"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"7cee3360-b2f6-4b01-9e98-7eb2b1a5a230"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"97143260-df88-48a8-9fa5-7bf19f670217"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"cc80e76c-ec7c-4c03-a517-9fd4629d0df9"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolalityToPpm"]],"paclet:DataAnalysis/ref/MolalityToPpm"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"1b67a241-b6d9-49c5-8194-75b7f815553d"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassToMolarFraction"]],
    "paclet:DataAnalysis/ref/MassToMolarFraction"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"424a317d-d6c3-4eba-bfda-57e323fe13f6"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"5a919306-035c-49f5-a3a0-6c82d40c5987"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"96fdc4a0-3ea3-4a05-8443-167e59882f25"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"c9be4547-eedc-4b2f-bcac-4b8fe34d261e"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"e860f8db-5ecd-4067-a43a-ce8b40f2ba10"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"1b326649-a8d2-4f78-a3b7-83a7459196bb"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"8e139283-600d-4d6b-b5ed-304b3e2a1569"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"59af5362-fc4e-4262-9620-3408bff2dff3"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->40296058,ExpressionUUID->"f4a0ff40-a4db-45b8-9552-3cfaf6044765"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"9a2524c1-5e83-4fed-b89f-6f46592e9e0c"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MolalityToMassFraction",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 9.3969001}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MolalityToMassFraction[<|comp1 -> amount1, comp2 -> amount2, ...|>, \
quantifier] converts molalities in an association where the keys are the \
component names (which can have a unit with unit prefix \
mmol/kg,\\[Mu]mol/kg,nmol/kg,pmol/kg) and values are the molalities to mass \
fractions with the specified unit quantifier (ppm, etc.), which is optional. \
MolalityToMassFraction[amount, comp] converts a molality of a component to a \
mass fraction assuming that it is the only solute.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "MolalityToMassFraction", "titlemodifier" -> 
    "", "windowtitle" -> "MolalityToMassFraction", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/MolalityToMassFraction"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9791, 253, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"f13b231d-900b-4850-b8e1-5e42d7b3d2b7",
   CellTags->"PrimaryExamplesSection",
   CellID->728328099]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 19484, 525}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[594, 21, 4612, 103, 55, "AnchorBarGrid",ExpressionUUID->"ed9b4613-0e81-45cc-985f-d6b7e8b6cf9b",
 CellID->1],
Cell[CellGroupData[{
Cell[5231, 128, 407, 9, 52, "ObjectNameGrid",ExpressionUUID->"cd9f3117-b323-42d4-87f0-64c5e1b9ae13"],
Cell[5641, 139, 1694, 39, 223, "Usage",ExpressionUUID->"3b78249c-ff10-44b3-8665-c7f64d645a61"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7372, 183, 854, 21, 37, "NotesSection",ExpressionUUID->"7521296e-6929-4b53-87c9-6df87af45c31",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->70444123],
Cell[8229, 206, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"b12bdf4e-f60d-416f-af52-0a631dbd853b"],
Cell[8318, 208, 383, 10, 70, "Notes",ExpressionUUID->"b4e5fab4-0b1e-4215-9613-b09b55c6e24d",
 CellID->1067943069],
Cell[8704, 220, 626, 17, 70, "Notes",ExpressionUUID->"d0c11fda-2869-41cd-8ecf-587021f32b1b",
 CellID->240785846],
Cell[9333, 239, 145, 1, 70, "Notes",ExpressionUUID->"472f010b-4585-4635-a0a3-3ad5659028a6",
 CellID->102413150],
Cell[9481, 242, 184, 4, 70, "Notes",ExpressionUUID->"753867de-16c9-4ce5-91ab-392b040468aa",
 CellID->371975926],
Cell[9668, 248, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"feb18bef-d50a-4766-aa17-787ae2c1c784"]
}, Closed]],
Cell[CellGroupData[{
Cell[9791, 253, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"f13b231d-900b-4850-b8e1-5e42d7b3d2b7",
 CellTags->"PrimaryExamplesSection",
 CellID->728328099],
Cell[CellGroupData[{
Cell[10251, 268, 308, 7, 29, "ExampleSection",ExpressionUUID->"085db422-b7ad-468d-9b00-91d9d7c27b22",
 CellID->151913526],
Cell[10562, 277, 147, 1, 38, "ExampleText",ExpressionUUID->"92ddf9a9-ac2f-4d43-bddd-ff8d7f011830",
 CellID->3805587],
Cell[CellGroupData[{
Cell[10734, 282, 307, 7, 26, "Input",ExpressionUUID->"6a240b38-6091-4b56-9428-f750fba7e617",
 CellID->397596],
Cell[11044, 291, 420, 10, 35, "Output",ExpressionUUID->"f1389214-f959-4a42-adab-5bd0327efa30",
 CellID->591737595]
}, Open  ]],
Cell[11479, 304, 183, 3, 38, "ExampleText",ExpressionUUID->"b46639f5-e80a-412d-8ce9-b70d2024e8f1",
 CellID->68588579],
Cell[CellGroupData[{
Cell[11687, 311, 209, 4, 26, "Input",ExpressionUUID->"1ad622ca-62b0-49ed-a7ad-14b19e2fa3b1",
 CellID->209314215],
Cell[11899, 317, 235, 5, 35, "Output",ExpressionUUID->"eacf850f-65b5-48e8-a881-a0d1db0627dc",
 CellID->240912031]
}, Open  ]],
Cell[12149, 325, 139, 1, 38, "ExampleText",ExpressionUUID->"5615fd8b-b01a-4f42-8d69-96bcf423b436",
 CellID->167068885],
Cell[CellGroupData[{
Cell[12313, 330, 351, 9, 26, "Input",ExpressionUUID->"c525fc44-e165-4e22-825e-87f53caeb1d2",
 CellID->813569781],
Cell[12667, 341, 424, 10, 35, "Output",ExpressionUUID->"24b9b54a-856f-40e5-9606-85254f9ebecd",
 CellID->50348476]
}, Open  ]],
Cell[13106, 354, 134, 1, 70, "ExampleText",ExpressionUUID->"6609da18-0cd9-4cfe-b089-3f71f2ab263c",
 CellID->264724132],
Cell[CellGroupData[{
Cell[13265, 359, 336, 8, 70, "Input",ExpressionUUID->"24742573-70a0-478b-b0d6-71cf4fa552fc",
 CellID->3079540],
Cell[13604, 369, 418, 10, 35, "Output",ExpressionUUID->"aa4f3fff-5023-4634-ac29-ee3276ce2a84",
 CellID->350599813]
}, Open  ]]
}, Open  ]],
Cell[14049, 383, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"7cee3360-b2f6-4b01-9e98-7eb2b1a5a230"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14172, 388, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"cc80e76c-ec7c-4c03-a517-9fd4629d0df9",
 CellID->1255426704],
Cell[14435, 397, 1887, 49, 70, "SeeAlso",ExpressionUUID->"e860f8db-5ecd-4067-a43a-ce8b40f2ba10",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[16359, 451, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"8e139283-600d-4d6b-b5ed-304b3e2a1569",
 CellID->38303248],
Cell[16628, 460, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"59af5362-fc4e-4262-9620-3408bff2dff3"],
Cell[16717, 462, 246, 6, 70, "MoreAbout",ExpressionUUID->"f4a0ff40-a4db-45b8-9552-3cfaf6044765",
 CellID->40296058]
}, Open  ]],
Cell[16978, 471, 78, 0, 70, "FooterCell",ExpressionUUID->"9a2524c1-5e83-4fed-b89f-6f46592e9e0c"]
}
]
*)

(* End of internal cache information *)

