(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18122,        477]
NotebookOptionsPosition[     13436,        373]
NotebookOutlinePosition[     15694,        431]
CellTagsIndexPosition[     15609,        426]
WindowTitle->MolalityToPpm
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "2d49b925-0e27-4340-82e7-d331b003040d"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"cf8bc168-3380-4ce9-be7e-127197f8a504"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"MolalityToMassFraction\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolalityToMassFraction"], \
"\<\"MassToMolarFraction\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassToMolarFraction"], \
"\<\"RegisterOxide\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterOxide"], "\<\"RegisterComp\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterComp"], "\<\"MolarMass\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/MolarMass"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "44efd7b4-63d7-40ad-b3cd-c664adcd72e3"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"8bfdb859-8b64-414a-ad5e-b6793062596d"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "d24eb1ae-791d-4c37-9e27-2bda84b47a8a"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"4916beb6-5608-40a2-b922-a30a33544924"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/MolalityToPpm\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MolalityToPpm"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MolalityToPpm.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$33188], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MolalityToPpm", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "1f5bd9e0-4754-4ee1-a24b-e82297a526a8"]
    }], "AnchorBar",ExpressionUUID->"652d8557-509a-4d1a-ac6e-1ac584aff66d"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"314481d4-cdc4-4728-a961-bfd06116e1ad"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["MolalityToPpm", "ObjectName",ExpressionUUID->
  "6722683f-ccb2-4e42-ba58-d5d0597c1062"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"c32cdd16-c956-417f-974a-265f2bf273d8"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "0f1c4886-117c-4c9f-b4b0-e8baf2a34098"]
}], "ObjectNameGrid",ExpressionUUID->"054d0634-28ba-4426-b831-15077cb76dd2"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MolalityToPpm", "[", 
       StyleBox["data", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "15e1f542-bd58-4d90-bbfc-1d4547e82d49"],
     "\[LineSeparator]is a short version of ",
     Cell[BoxData[
      RowBox[{
       TemplateBox[{Cell[
          TextData["MolalityToMassFraction"]],
         "paclet:DataAnalysis/ref/MolalityToMassFraction"},
        "RefLink",
        BaseStyle->{"InlineFormula"}], "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", 
        "\"\<\!\(\*StyleBox[\"ppm\", \"TI\"]\)\>\""}], "]"}]], 
      "InlineFormula",ExpressionUUID->"157f4eca-f0f8-4e42-9a63-ba0e1ff40b57"]
    }],ExpressionUUID->"73cd04c0-ec3b-4c5d-bc06-6ae3bbb7afe8"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"3a3f4c9b-1c37-4c16-a2f2-9d95e639f469"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"3eefd42e-365f-4c74-9932-e994687152cb"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"443475c1-dcdc-4de9-8fc1-1e7b4c596feb"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"e1d1a1ab-c2c6-4574-a388-4821c0c55218"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->308976459,ExpressionUUID->"71a5ed98-e136-43a5-942c-02282313fc5c"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"9561b252-b140-4ece-9595-2c60c574866c"],

Cell[TextData[{
 "The ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["molality"]],"https://en.wikipedia.org/wiki/Molality"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "0799ee01-60fc-4f53-850a-b27b2daa281c"],
 " is the molar amount of a substance per mass of the solvent."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"144ba9f3-c9ec-45ee-86c2-9c72414fabd4"],

Cell[TextData[{
 "Components have to be defined using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "fb69135d-bf42-4d90-9eaa-303e2e7c7ab4"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "cae1b53b-77ad-4da5-b56a-d1ac168f4328"],
 "."
}], "Notes",
 CellID->240785846,ExpressionUUID->"6f87079b-6d8c-46d4-98a0-a7687bd2f799"],

Cell["\<\
Valid units for molalities are mol/kg, mmol/kg, \[Mu]mol/kg, nmol/kg, and \
pmol/kg.\
\>", "Notes",
 CellID->371975926,ExpressionUUID->"3f78f51a-c842-4ee5-8aa6-7331ca7ce488"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"9b14f244-344b-46d2-927e-46a4a30b7e25"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"4db097c0-954b-4abb-8df7-20b6ca9496f1"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "d070ce91-4e58-4fb2-8776-06585ff65353"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->6630396,ExpressionUUID->"b7c99ab3-08ae-432a-b22a-a273aca86a1a"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "718bbb1b-2173-465a-b2e5-ccfb9f468a9c"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->51976196,ExpressionUUID->"bd5e1391-5eb4-40bf-af1f-0fbd16eb29c2"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolalityToPpm", "[", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"\"\<MgO\>\"", "\[Rule]", "0.01"}], ",", 
    RowBox[{"\"\<CaO\>\"", "\[Rule]", "0.02"}]}], "|>"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->397596,ExpressionUUID->"96badcf2-ac3d-4bc3-b4c1-e14267fb5848"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO / ppm\"\>", "\[Rule]", "402.43045774356784`"}], ",", 
   RowBox[{"\<\"CaO / ppm\"\>", "\[Rule]", "1119.8406998277683`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{290, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->249319220,ExpressionUUID->"5f5ce474-f9a0-406c-9744-069dd63e20d4"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"03507ddd-9fb2-406f-aa10-cc5804eb7410"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"ba60f361-08d3-4502-b3d5-a12db3807226"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"c0509d8a-06c7-4a0c-bb36-39d84cfe0495"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolalityToMassFraction"]],
    "paclet:DataAnalysis/ref/MolalityToMassFraction"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"b4ba0df1-84d9-4e53-b175-93ad334ce522"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassToMolarFraction"]],
    "paclet:DataAnalysis/ref/MassToMolarFraction"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"2666daf4-9dec-44c0-8dfc-ad8b671246c2"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"e222418b-ba5c-4017-996a-da182d3d6477"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"69fce4c3-5236-4a0d-bf54-19d27aa3bda8"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"86f18bc1-6e01-431a-ae0f-d127a446ee11"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"1b8e97f6-580e-4fbc-be32-4dfc7e3ec23e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"843e62d2-58d5-4bfd-83c3-27227cc5a5f1"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"79d68bc7-c943-42b6-b0d3-8d2a34d2800f"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"9aec536d-8f51-46bc-a267-91999f53f131"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->91925388,ExpressionUUID->"b757a5da-1bf0-4d72-91b2-4769cc697467"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"8b5b9e47-4fd5-4665-bfb9-4c431d2acbd9"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MolalityToPpm",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 10.8798446}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MolalityToPpm[data] is a short version of MolalityToMassFraction[data, \
\" ppm\"]", "synonyms" -> {}, "tabletags" -> {}, "title" -> "MolalityToPpm", 
    "titlemodifier" -> "", "windowtitle" -> "MolalityToPpm", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/MolalityToPpm"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8859, 233, 433, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"b7c99ab3-08ae-432a-b22a-a273aca86a1a",
   CellTags->"PrimaryExamplesSection",
   CellID->6630396]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15413, 419}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 4570, 101, 55, "AnchorBarGrid",ExpressionUUID->"314481d4-cdc4-4728-a961-bfd06116e1ad",
 CellID->1],
Cell[CellGroupData[{
Cell[5180, 126, 398, 9, 52, "ObjectNameGrid",ExpressionUUID->"054d0634-28ba-4426-b831-15077cb76dd2"],
Cell[5581, 137, 969, 24, 110, "Usage",ExpressionUUID->"3a3f4c9b-1c37-4c16-a2f2-9d95e639f469"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6587, 166, 855, 21, 37, "NotesSection",ExpressionUUID->"71a5ed98-e136-43a5-942c-02282313fc5c",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->308976459],
Cell[7445, 189, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"9561b252-b140-4ece-9595-2c60c574866c"],
Cell[7534, 191, 383, 10, 70, "Notes",ExpressionUUID->"144ba9f3-c9ec-45ee-86c2-9c72414fabd4",
 CellID->1067943069],
Cell[7920, 203, 626, 17, 70, "Notes",ExpressionUUID->"6f87079b-6d8c-46d4-98a0-a7687bd2f799",
 CellID->240785846],
Cell[8549, 222, 184, 4, 70, "Notes",ExpressionUUID->"3f78f51a-c842-4ee5-8aa6-7331ca7ce488",
 CellID->371975926],
Cell[8736, 228, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"9b14f244-344b-46d2-927e-46a4a30b7e25"]
}, Closed]],
Cell[CellGroupData[{
Cell[8859, 233, 433, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"b7c99ab3-08ae-432a-b22a-a273aca86a1a",
 CellTags->"PrimaryExamplesSection",
 CellID->6630396],
Cell[CellGroupData[{
Cell[9317, 248, 307, 7, 29, "ExampleSection",ExpressionUUID->"bd5e1391-5eb4-40bf-af1f-0fbd16eb29c2",
 CellID->51976196],
Cell[CellGroupData[{
Cell[9649, 259, 298, 7, 26, "Input",ExpressionUUID->"96badcf2-ac3d-4bc3-b4c1-e14267fb5848",
 CellID->397596],
Cell[9950, 268, 425, 10, 35, "Output",ExpressionUUID->"5f5ce474-f9a0-406c-9744-069dd63e20d4",
 CellID->249319220]
}, Open  ]]
}, Open  ]],
Cell[10402, 282, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"03507ddd-9fb2-406f-aa10-cc5804eb7410"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10525, 287, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"c0509d8a-06c7-4a0c-bb36-39d84cfe0495",
 CellID->1255426704],
Cell[10788, 296, 1910, 50, 45, "SeeAlso",ExpressionUUID->"1b8e97f6-580e-4fbc-be32-4dfc7e3ec23e",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12735, 351, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"79d68bc7-c943-42b6-b0d3-8d2a34d2800f",
 CellID->38303248],
Cell[13004, 360, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"9aec536d-8f51-46bc-a267-91999f53f131"],
Cell[13093, 362, 246, 6, 24, "MoreAbout",ExpressionUUID->"b757a5da-1bf0-4d72-91b2-4769cc697467",
 CellID->91925388]
}, Open  ]],
Cell[13354, 371, 78, 0, 41, "FooterCell",ExpressionUUID->"8b5b9e47-4fd5-4665-bfb9-4c431d2acbd9"]
}
]
*)

(* End of internal cache information *)

