(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18584,        503]
NotebookOptionsPosition[     13081,        379]
NotebookOutlinePosition[     15326,        437]
CellTagsIndexPosition[     15241,        432]
WindowTitle->MolarMass
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "58edc688-d253-417b-9bf0-c93e6d1e908d"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"85d741c0-0041-4970-86ca-5dff5f36c316"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"RegisterOxide\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterOxide"], "\<\"RegisterComp\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/RegisterComp"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "6634f53e-a199-4d8a-a85c-2b2a2cc77749"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"ea139fa3-4909-42a4-a0bc-b162cb2f6ba2"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "a4c63475-a1f0-4382-b22f-b015ba1bbd4b"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"fcc678a8-2a1f-407a-960b-70ea67da5e29"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/MolarMass\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MolarMass"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MolarMass.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$33714], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MolarMass", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "e800eb81-e4a2-459a-a917-518426eb918f"]
    }], "AnchorBar",ExpressionUUID->"1d161db4-22b3-42d2-9c74-37a7cf273324"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"2a9ee078-154f-4a62-9639-bbbeae2fefc1"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["MolarMass", "ObjectName",ExpressionUUID->
  "40dbd915-3cc4-4b52-9c12-cfdaad666cee"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"76ed4cbe-ccb2-470c-a7d7-19d1fb97c231"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "35723d96-bf18-4392-b00e-7b110d556de1"]
}], "ObjectNameGrid",ExpressionUUID->"690d9ab5-7506-4521-abc0-ce62c957b048"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MolarMass", "[", 
       StyleBox["str", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "cf6d0562-9d99-46f0-8225-e062fc41afc7"],
     "\[LineSeparator]represents the molar mass of the element, species or \
compound ",
     Cell[BoxData[
      StyleBox["str", "TI"]], "InlineFormula",ExpressionUUID->
      "80d4f916-4d40-4b58-9c88-baad9747f7ef"],
     "."
    }],ExpressionUUID->"00ce017c-984a-4891-ba83-0f37c485d36c"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"ded6c01b-e2f4-419d-8f6e-56a32a80d160"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"7916f3b4-6061-46c7-9c5e-41e3a4892e0f"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"2458bb41-56f2-4f02-8990-8e67c2218898"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"cf583422-869d-4152-9667-ed12addc72d4"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->94456651,ExpressionUUID->"0748809f-253f-4fb4-8eeb-53be9b078683"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"248c3857-7150-467b-a699-a165d6b7a8e4"],

Cell[TextData[{
 "Components have to be defined using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "2372d691-b45d-462c-aa22-332fee3694c0"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "02f9e09b-f6ab-417d-bf5f-91ddef3b2b7f"],
 "."
}], "Notes",
 CellID->240785846,ExpressionUUID->"ebb868e5-2717-4e2f-8074-9bff0e2f3e98"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"ad99e66b-f71e-4b73-b360-4cfb272d35ae"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"8242cd6a-4e01-4a8f-8754-f2ae2bcfe1dc"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "b89020e8-9137-4712-bb3a-dd5b0e3392d6"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->135239880,ExpressionUUID->"bc8692ac-e441-4836-b4e7-0ff1be4f477d"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "c750dd51-a4cd-4781-8a70-79183f80862e"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->772848650,ExpressionUUID->"91dfdad7-a004-4e18-8a6d-af9916680687"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolarMass", "[", "\"\<Ca\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->621106830,ExpressionUUID->"17fa2bf6-565e-4e9a-b41e-c081873fda22"],

Cell[BoxData["40.078`"], "Output",
 ImageSize->{46, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->47282843,ExpressionUUID->"4913753f-5eaa-4a18-9160-4bf71b9661f2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolarMass", "[", "\"\<CaO\>\"", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->15288011,ExpressionUUID->"eaf2f8b1-2109-463a-8b23-39748bf6671c"],

Cell[BoxData["56.077400000000004`"], "Output",
 ImageSize->{53, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->149254304,ExpressionUUID->"be6fe41a-30c2-4462-9035-e31f1260750c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolarMass", "[", "\"\<Calcite\>\"", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->147462756,ExpressionUUID->"bb6dca65-1623-4108-bafd-c0cbf0f86dce"],

Cell[BoxData["100.0869`"], "Output",
 ImageSize->{53, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->299490803,ExpressionUUID->"a214a7f5-ac47-44d1-b5ea-274622df6786"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Possible Issues",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "fbb42070-71cb-4748-8a08-81bd18ee09d1"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373,ExpressionUUID->"efd7dbf3-bbc5-41c9-af5a-8c6aca1b0e50"],

Cell[TextData[{
 "Components have to be defined using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "0140cc5c-9b83-4c1d-88ef-3f1cd59bc0a4"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "3e72a930-a545-4135-a7b7-1c115fb1fc7c"],
 ":"
}], "ExampleText",
 CellID->324628683,ExpressionUUID->"8bf371b4-f942-46cf-865a-a2ec98f9c6dd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolarMass", "[", "\"\<Unknown\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->54308596,ExpressionUUID->"5898f0a2-0d3d-46d2-9d4d-f2aac18bb832"],

Cell[BoxData[
 RowBox[{"MolarMass", "[", "\<\"Unknown\"\>", "]"}]], "Output",
 ImageSize->{130, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->965627284,ExpressionUUID->"953d17e5-5d1b-461e-9fa2-cc9723ffad25"]
}, Open  ]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"6f4459ea-6709-4df2-a0b5-1c0b930e7fb4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"3abe08ea-996d-4817-abcd-b610d4f77ca7"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"2cb7e088-b085-45f5-91da-9808c61f7519"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"61b65241-b200-4756-9d34-3f976812043f"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"a8c49c17-1f5a-4c07-9d7a-33078772f700"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"f68c8ea0-a958-4920-978d-2cb7382d92b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"f8f7ac71-87aa-44bf-b395-5446dab57a87"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"b25d124f-60e9-48e0-9f40-90756fb68d5b"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"2c037080-b4e1-41f8-888b-269528c66072"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->75407546,ExpressionUUID->"9e292ec0-57ce-40fb-b60a-2ac36f39485d"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"c88da475-6bd9-4a64-90e0-4d2fe8d90906"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MolarMass",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 12.3776491}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MolarMass[str] represents the molar mass of the element, species or \
compound str.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "MolarMass", 
    "titlemodifier" -> "", "windowtitle" -> "MolarMass", "type" -> "Symbol", 
    "uri" -> "DataAnalysis/ref/MolarMass"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7673, 203, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"bc8692ac-e441-4836-b4e7-0ff1be4f477d",
   CellTags->"PrimaryExamplesSection",
   CellID->135239880]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15043, 425}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[581, 21, 4218, 95, 55, "AnchorBarGrid",ExpressionUUID->"2a9ee078-154f-4a62-9639-bbbeae2fefc1",
 CellID->1],
Cell[CellGroupData[{
Cell[4824, 120, 394, 9, 52, "ObjectNameGrid",ExpressionUUID->"690d9ab5-7506-4521-abc0-ce62c957b048"],
Cell[5221, 131, 717, 18, 109, "Usage",ExpressionUUID->"ded6c01b-e2f4-419d-8f6e-56a32a80d160"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5975, 154, 854, 21, 37, "NotesSection",ExpressionUUID->"0748809f-253f-4fb4-8eeb-53be9b078683",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->94456651],
Cell[6832, 177, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"248c3857-7150-467b-a699-a165d6b7a8e4"],
Cell[6921, 179, 626, 17, 70, "Notes",ExpressionUUID->"ebb868e5-2717-4e2f-8074-9bff0e2f3e98",
 CellID->240785846],
Cell[7550, 198, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"ad99e66b-f71e-4b73-b360-4cfb272d35ae"]
}, Closed]],
Cell[CellGroupData[{
Cell[7673, 203, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"bc8692ac-e441-4836-b4e7-0ff1be4f477d",
 CellTags->"PrimaryExamplesSection",
 CellID->135239880],
Cell[CellGroupData[{
Cell[8133, 218, 308, 7, 29, "ExampleSection",ExpressionUUID->"91dfdad7-a004-4e18-8a6d-af9916680687",
 CellID->772848650],
Cell[CellGroupData[{
Cell[8466, 229, 169, 3, 26, "Input",ExpressionUUID->"17fa2bf6-565e-4e9a-b41e-c081873fda22",
 CellID->621106830],
Cell[8638, 234, 218, 5, 35, "Output",ExpressionUUID->"4913753f-5eaa-4a18-9160-4bf71b9661f2",
 CellID->47282843]
}, Open  ]],
Cell[CellGroupData[{
Cell[8893, 244, 169, 3, 26, "Input",ExpressionUUID->"eaf2f8b1-2109-463a-8b23-39748bf6671c",
 CellID->15288011],
Cell[9065, 249, 231, 5, 35, "Output",ExpressionUUID->"be6fe41a-30c2-4462-9035-e31f1260750c",
 CellID->149254304]
}, Open  ]],
Cell[CellGroupData[{
Cell[9333, 259, 174, 3, 26, "Input",ExpressionUUID->"bb6dca65-1623-4108-bafd-c0cbf0f86dce",
 CellID->147462756],
Cell[9510, 264, 221, 5, 35, "Output",ExpressionUUID->"a214a7f5-ac47-44d1-b5ea-274622df6786",
 CellID->299490803]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9780, 275, 310, 7, 29, "ExampleSection",ExpressionUUID->"efd7dbf3-bbc5-41c9-af5a-8c6aca1b0e50",
 CellID->1305812373],
Cell[10093, 284, 632, 17, 70, "ExampleText",ExpressionUUID->"8bf371b4-f942-46cf-865a-a2ec98f9c6dd",
 CellID->324628683],
Cell[CellGroupData[{
Cell[10750, 305, 173, 3, 70, "Input",ExpressionUUID->"5898f0a2-0d3d-46d2-9d4d-f2aac18bb832",
 CellID->54308596],
Cell[10926, 310, 263, 6, 35, "Output",ExpressionUUID->"953d17e5-5d1b-461e-9fa2-cc9723ffad25",
 CellID->965627284]
}, Open  ]]
}, Closed]],
Cell[11216, 320, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"6f4459ea-6709-4df2-a0b5-1c0b930e7fb4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11339, 325, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"2cb7e088-b085-45f5-91da-9808c61f7519",
 CellID->1255426704],
Cell[11602, 334, 741, 18, 24, "SeeAlso",ExpressionUUID->"f68c8ea0-a958-4920-978d-2cb7382d92b8",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12380, 357, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"b25d124f-60e9-48e0-9f40-90756fb68d5b",
 CellID->38303248],
Cell[12649, 366, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"2c037080-b4e1-41f8-888b-269528c66072"],
Cell[12738, 368, 246, 6, 70, "MoreAbout",ExpressionUUID->"9e292ec0-57ce-40fb-b60a-2ac36f39485d",
 CellID->75407546]
}, Open  ]],
Cell[12999, 377, 78, 0, 70, "FooterCell",ExpressionUUID->"c88da475-6bd9-4a64-90e0-4d2fe8d90906"]
}
]
*)

(* End of internal cache information *)

