(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18625,        486]
NotebookOptionsPosition[     13601,        376]
NotebookOutlinePosition[     16156,        438]
CellTagsIndexPosition[     16071,        433]
WindowTitle->MolesToMass
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "1a4714ed-3d09-459c-9af6-2af824cf7ed1"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"4937e82c-5216-43ac-b446-07ed85b30f41"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"MassToMoles\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassToMoles"], "\<\"MolarMass\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolarMass"], "\<\"MolalityToMassFraction\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolalityToMassFraction"], \
"\<\"MassFractionToMolality\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MassFractionToMolality"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ef578f7a-1192-40f6-8bf1-23d12014c6f3"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"11129481-c208-4659-aa79-81f0c3155b74"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7b3432b9-4678-46e8-9bd9-cbaa7bab19bd"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"49469af4-2484-4077-8cb6-8da5738a28c4"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/MolesToMass\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MolesToMass"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MolesToMass.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$34242], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MolesToMass", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4cf63e9a-f472-45ec-a660-5ab954a56969"]
    }], "AnchorBar",ExpressionUUID->"a10aecff-8c16-4070-9370-9e42df62734a"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"13862538-6fd2-44e1-a1f3-e5231b606362"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["MolesToMass", "ObjectName",ExpressionUUID->
  "2100b4be-f321-4606-b918-0fc4f6474b95"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"b3df1975-5186-46ca-aa19-12d7028adca4"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "059e1761-5bbb-4e2d-8833-21bb5db3d62a"]
}], "ObjectNameGrid",ExpressionUUID->"34b9609d-4f8e-4193-b30f-0abd5caf5fc3"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MolesToMass", "[", 
       RowBox[{
        StyleBox["comp", "TI"], ",", 
        StyleBox["moles", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "2f79655c-d869-4fb2-aef4-d5b4c710a54c"],
     "\[LineSeparator]converts a molar amount of a chemical component to a \
mass. "
    }],ExpressionUUID->"1e5facf9-3430-414e-a84a-21a5513343db"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MolesToMass", "[", 
       StyleBox["datatable", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "1dbd4861-8cce-4400-bb3e-c03a6b38c572"],
     "\[LineSeparator]convert the data in all columns of a ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "cc8888c3-8065-4060-8636-c82292608e38"],
     " from molar amounts to masses based on the component specified as \
column header. "
    }],ExpressionUUID->"e56b8890-5238-4277-83ad-e89cb653cb0b"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MolesToMass", "[", 
       StyleBox["association", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "8684e7d2-4b11-4a43-a948-0a128bf17a82"],
     "\[LineSeparator]convert the data in elements of an Association from \
molar amounts to masses based on the component specified as keys."
    }],ExpressionUUID->"f2d670bc-7f53-4fd1-99b6-d04a77b2d309"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"72c9fc0e-38d9-47a5-ad90-f419d329c651"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"9fe59ee1-fe34-47f4-a976-df48dff7ea31"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"03b564a8-3613-46d6-95e4-9336c174d41c"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"8321917e-6e28-4f83-ab41-8136441b3c2d"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->152993461,ExpressionUUID->"74c08b80-6f2d-4df5-bbc9-386747621592"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"4f993c97-90ad-4f3d-a737-6966e5e44d2b"],

Cell[TextData[{
 "Components have to be defined using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterOxide"]],"paclet:DataAnalysis/ref/RegisterOxide"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "351f7e21-6c01-4e47-9c7a-5f43c1023069"],
 " or ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterComp"]],"paclet:DataAnalysis/ref/RegisterComp"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "a6312b4b-1601-4a31-ae39-b99c4a44497d"],
 "."
}], "Notes",
 CellID->240785846,ExpressionUUID->"12653735-9c79-4cfc-b569-f5a5d60debb2"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"049c9d88-49ce-44a0-a8e7-ba3cfe47d611"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"c89f2635-d387-4af9-9635-c228baf599a3"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "bf00aacf-07ff-4b0a-b0c1-7b4b94f0e607"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->64930435,ExpressionUUID->"a245bfdd-0666-4d57-b159-c5b2be335d81"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "70a54e1b-3415-4cc0-a71d-3526c7c849dc"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->182324740,ExpressionUUID->"ac104bb7-654f-4fbe-891f-dc1e0161c317"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolesToMass", "[", 
  RowBox[{"\"\<CaO\>\"", ",", "0.1"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->185766337,ExpressionUUID->"400ece0e-9b32-4a9c-87da-e2bfc41bb40b"],

Cell[BoxData["5.607740000000001`"], "Output",
 ImageSize->{53, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->485128428,ExpressionUUID->"716ff339-30f3-483d-9d59-f0464d4a2cb9"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolesToMass", "[", 
  RowBox[{"<|", 
   RowBox[{
    RowBox[{"\"\<MgO\>\"", "\[Rule]", "0.01"}], ",", 
    RowBox[{"\"\<CaO\>\"", "\[Rule]", "0.02"}]}], "|>"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->325650084,ExpressionUUID->"d13db32e-933d-4164-abb2-735501a36a62"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"\<\"MgO\"\>", "\[Rule]", "0.403044`"}], ",", 
   RowBox[{"\<\"CaO\"\>", "\[Rule]", "1.1215480000000002`"}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{220, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->636099999,ExpressionUUID->"2e6c5bca-bd2b-415a-87ae-64e7211f68d4"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"5e20f3a2-cc25-4075-ad3b-d68d7dd97a17"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"50c779c7-8a38-4608-8a79-98caf2fd3440"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"4a3bfc07-0cb3-40dc-9f77-7576ede14d59"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassToMoles"]],"paclet:DataAnalysis/ref/MassToMoles"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"193204bb-7c02-4dac-9c95-eb28e27ee752"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"3aec419d-0d25-49de-8e60-75a311b3429f"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolalityToMassFraction"]],
    "paclet:DataAnalysis/ref/MolalityToMassFraction"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"20fbda09-d3ea-4802-9495-e5bd809caf15"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassFractionToMolality"]],
    "paclet:DataAnalysis/ref/MassFractionToMolality"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"1866e32c-044e-4a73-978a-056d5cad7b7c"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"561abd21-c41d-41fe-9ac3-3ceeea91c363"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"85af8464-8ad0-4aca-bf78-b59ae1d07534"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"6c21b9ce-42a1-485e-925f-ccf783c357ed"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"839dd8f8-925b-4523-85fe-07bed1b617c8"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->400145613,ExpressionUUID->"5e76ee4d-36bf-43a5-a337-03d5f9d991e8"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"031052fd-4fbd-4a83-b29f-6aada95671a5"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MolesToMass",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 14.1423438}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MolesToMass[comp, moles] converts a molar amount of a chemical component \
to a mass. MolesToMass[datatable] convert the data in all columns of a \
DataTable from molar amounts to masses based on the component specified as \
column header. MolesToMass[association] convert the data in elements of an \
Association from molar amounts to masses based on the component specified as \
keys.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "MolesToMass", 
    "titlemodifier" -> "", "windowtitle" -> "MolesToMass", "type" -> "Symbol",
     "uri" -> "DataAnalysis/ref/MolesToMass"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8950, 230, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"a245bfdd-0666-4d57-b159-c5b2be335d81",
   CellTags->"PrimaryExamplesSection",
   CellID->64930435]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15874, 426}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[583, 21, 4472, 100, 55, "AnchorBarGrid",ExpressionUUID->"13862538-6fd2-44e1-a1f3-e5231b606362",
 CellID->1],
Cell[CellGroupData[{
Cell[5080, 125, 396, 9, 52, "ObjectNameGrid",ExpressionUUID->"34b9609d-4f8e-4193-b30f-0abd5caf5fc3"],
Cell[5479, 136, 1735, 40, 298, "Usage",ExpressionUUID->"72c9fc0e-38d9-47a5-ad90-f419d329c651"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7251, 181, 855, 21, 37, "NotesSection",ExpressionUUID->"74c08b80-6f2d-4df5-bbc9-386747621592",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->152993461],
Cell[8109, 204, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"4f993c97-90ad-4f3d-a737-6966e5e44d2b"],
Cell[8198, 206, 626, 17, 70, "Notes",ExpressionUUID->"12653735-9c79-4cfc-b569-f5a5d60debb2",
 CellID->240785846],
Cell[8827, 225, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"049c9d88-49ce-44a0-a8e7-ba3cfe47d611"]
}, Closed]],
Cell[CellGroupData[{
Cell[8950, 230, 434, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"a245bfdd-0666-4d57-b159-c5b2be335d81",
 CellTags->"PrimaryExamplesSection",
 CellID->64930435],
Cell[CellGroupData[{
Cell[9409, 245, 308, 7, 29, "ExampleSection",ExpressionUUID->"ac104bb7-654f-4fbe-891f-dc1e0161c317",
 CellID->182324740],
Cell[CellGroupData[{
Cell[9742, 256, 197, 4, 26, "Input",ExpressionUUID->"400ece0e-9b32-4a9c-87da-e2bfc41bb40b",
 CellID->185766337],
Cell[9942, 262, 230, 5, 35, "Output",ExpressionUUID->"716ff339-30f3-483d-9d59-f0464d4a2cb9",
 CellID->485128428]
}, Open  ]],
Cell[CellGroupData[{
Cell[10209, 272, 299, 7, 26, "Input",ExpressionUUID->"d13db32e-933d-4164-abb2-735501a36a62",
 CellID->325650084],
Cell[10511, 281, 403, 10, 35, "Output",ExpressionUUID->"2e6c5bca-bd2b-415a-87ae-64e7211f68d4",
 CellID->636099999]
}, Open  ]]
}, Open  ]],
Cell[10941, 295, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"5e20f3a2-cc25-4075-ad3b-d68d7dd97a17"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11064, 300, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"4a3bfc07-0cb3-40dc-9f77-7576ede14d59",
 CellID->1255426704],
Cell[11327, 309, 1535, 40, 70, "SeeAlso",ExpressionUUID->"561abd21-c41d-41fe-9ac3-3ceeea91c363",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12899, 354, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"6c21b9ce-42a1-485e-925f-ccf783c357ed",
 CellID->38303248],
Cell[13168, 363, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"839dd8f8-925b-4523-85fe-07bed1b617c8"],
Cell[13257, 365, 247, 6, 70, "MoreAbout",ExpressionUUID->"5e76ee4d-36bf-43a5-a337-03d5f9d991e8",
 CellID->400145613]
}, Open  ]],
Cell[13519, 374, 78, 0, 70, "FooterCell",ExpressionUUID->"031052fd-4fbd-4a83-b29f-6aada95671a5"]
}
]
*)

(* End of internal cache information *)

