(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    102620,       2308]
NotebookOptionsPosition[     92903,       2107]
NotebookOutlinePosition[     95534,       2170]
CellTagsIndexPosition[     95448,       2165]
WindowTitle->MonteCarloSimulation
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "411adcd4-71e9-4d0a-ae9f-7c786a91c973"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"410fc3af-926a-48f8-9496-3d14774e02f2"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"MonteCarloResult\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MonteCarloResult"], "\<\"MCEvaluate\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MCEvaluate"], "\<\"NDV\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/NDV"], "\<\"DVEvaluate\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/DVEvaluate"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "5400fba6-7cc2-443f-ae54-82f0ad0767e1"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"96069ae9-ec03-4faa-b189-f0b74ee9631d"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7d188aa5-2706-4868-b573-56ba1aa7cc5d"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"f1a93f53-c4d8-4235-8c46-f02f91a5d853"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"DataAnalysis/ref/MonteCarloSimulation\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/MonteCarloSimulation"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
MonteCarloSimulation.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$35504], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/MonteCarloSimulation", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "c3a09205-bd60-46b4-90b3-a25cfcdb1ca3"]
    }], "AnchorBar",ExpressionUUID->"9905e4ac-d1d4-4f0f-b441-4634922c77cd"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"e879ebb3-dc4f-408f-a503-f853f51b29da"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["MonteCarloSimulation", "ObjectName",ExpressionUUID->
  "9fffb878-8a57-41e3-a46a-e1e30f4194b7"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"b680d11a-167f-4ee0-82dd-1b4afd0951f4"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "438d6504-347f-455c-853e-321f5addf7d0"]
}], "ObjectNameGrid",ExpressionUUID->"6c1fd402-db6d-4c8c-a5cd-93762b5b8404"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MonteCarloSimulation", "[", 
       RowBox[{
        StyleBox["expr", "TI"], ",", 
        StyleBox["i", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           SubscriptBox[
            StyleBox["param", "TI"], "1"], "\[Rule]", 
           SubscriptBox[
            StyleBox["distribution", "TI"], "1"]}], ",", 
          RowBox[{
           SubscriptBox[
            StyleBox["param", "TI"], "2"], "\[Rule]", 
           SubscriptBox[
            StyleBox["distribution", "TI"], "2"]}], ",", "..."}], "}"}]}], 
       "]"}]], "InlineFormula",ExpressionUUID->
      "b56f92e7-ba86-48da-8519-8d3dc91a03e3"],
     " carries out a Monte Carlo simulation with ",
     Cell[BoxData[
      StyleBox["i", "TI"]], "InlineFormula",ExpressionUUID->
      "1d05c540-3e9b-4383-8285-277803ea0247"],
     " iterations, to propagate uncertainties (in ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "983a625e-a2b1-4ea9-88f0-be2672e42d85"],
     " objects or standard Mathematica Distribution objects) in ",
     Cell[BoxData[
      StyleBox["expr", "TI"]], "InlineFormula",ExpressionUUID->
      "b0aa6ebc-893f-4744-ab2c-21cdb8ff7241"],
     ". Parameters in ",
     Cell[BoxData[
      StyleBox["expr", "TI"]], "InlineFormula",ExpressionUUID->
      "d034ecac-951f-45f9-95c2-df5942a8a578"],
     " may be separately specified as rules ",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["param", "TI"], 
        StyleBox["i", "TI"]], "\[Rule]", 
       SubscriptBox[
        StyleBox["distribution", "TI"], 
        StyleBox["i", "TI"]]}]], "InlineFormula",ExpressionUUID->
      "078489a3-aab7-48ac-a5d5-39226904851e"],
     ", where ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["distribution", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula",ExpressionUUID->
      "f38a0f3f-78c4-4c1d-88e2-d36962d82df2"],
     " can be either an ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "605d37b5-fb5c-423c-a80e-dc0ba0208823"],
     " object or a standard Mathematica distribution object."
    }],ExpressionUUID->"d4c76555-afe3-4028-ab51-eddd1f5de235"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"bfda5447-1a6a-445c-ae2e-211e3ee26ddd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"e8e7f403-0f92-4b76-965e-f6d54fae1098"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"e520e5a2-13d1-4967-9648-22ed655c17cc"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"bb020d90-e29b-4bc8-a483-a45990465733"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->313577501,ExpressionUUID->"f2c57992-0d09-4f00-b88b-8debd17b7161"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"3b794ec8-c4ef-49b4-bce1-c3db33b806c7"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "18af0be3-8faa-482d-872d-42550d16fecc"],
 " uses ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["random sampling"]],
    "https://en.wikipedia.org/wiki/Monte_Carlo_method"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "25ea7b6f-dac2-436d-95f2-e0687a2c1f0e"],
 " from the input parameter distributions to estimate the distribution of the \
output variable, resulting uncertainties, and other parameters useful for \
sensitify analyses."
}], "Notes",
 CellID->795731367,ExpressionUUID->"a22afa6b-c95c-452d-85a5-a662668238f0"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "2a2cfd3a-3f66-4200-b05f-4ec615327cde"],
 " uses the ",
 ButtonBox["RandomVariate",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/RandomVariate"],
 " function to generate random samples."
}], "Notes",
 CellID->30591226,ExpressionUUID->"97677ad2-ed9d-4000-be3c-fa588492d053"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "a5639906-423e-4456-8379-17eab9ba8009"],
 " can be run in parallel, making use of the ",
 ButtonBox["ParallelEvaluate",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/ParallelEvaluate"],
 " function."
}], "Notes",
 CellID->449242119,ExpressionUUID->"9fbc88cf-220d-44dd-84ce-63ff2267ae70"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "00ec6367-e41c-40ad-8cec-c62736f79f37"],
 " returns a symbolic ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloResult"]],"paclet:DataAnalysis/ref/MonteCarloResult"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "9941511b-17a8-4b6a-a771-458af252734a"],
 " object, which can be used to access various parameters from ",
 StyleBox["result[\"property\"]", "TI",
  FontSlant->"Italic"],
 "."
}], "Notes",
 CellID->222801089,ExpressionUUID->"dcfbc2a7-b5d0-45bb-89bd-314220f08a71"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "e8bede32-7f89-44b8-9cb3-7a0e77594269"],
 " does not have the attribute ",
 ButtonBox["HoldFirst",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/HoldFirst"],
 ", so ",
 ButtonBox["Hold",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Hold"],
 " should be applied to the expression where necessary."
}], "Notes",
 CellID->56206725,ExpressionUUID->"bb9e5e18-5839-49ea-b66b-f6ab5978b9ed"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "94f7a6f1-612b-4d08-8eb6-23ef4bc3721d"],
 " or ",
 ButtonBox["MCE",
  BaseStyle->"Link",
  ButtonData->"paclet:DataAnalysis/ref/MCE"],
 " can be used if only the basic information in form of a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "8cc48a59-5034-4f68-ba0d-67ac37d7b848"],
 " object is required."
}], "Notes",
 CellID->257908114,ExpressionUUID->"af6c86f3-f891-44e1-aa44-06a4bd5b2923"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "754e4d91-dfc4-4a5b-9c00-5bb088180e35"],
 " can be used if only the basic uncertainty propagation is required and the \
expressions is relatively linear. As this is using analytical expressions, \
this is much faster."
}], "Notes",
 CellID->378738187,ExpressionUUID->"6b7cff89-e933-4d92-a7d0-4c2201b3154e"],

Cell["\<\
Parameters with uncertainties can be included directly into the expression, \
or they can be defined in the third argument and referenced in the expression.\
\>", "Notes",
 CellID->163845120,ExpressionUUID->"865f101f-5bfc-4007-af60-cb42b5cdae5a"],

Cell[TextData[{
 "Apart from ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "c93f1a3e-dc94-4d50-88d0-6e001b5103be"],
 " objects, all standard Mathematica ",
 ButtonBox["distributions",
  BaseStyle->"Link",
  ButtonData->"paclet:guide/ProbabilityAndStatistics"],
 " such as ",
 ButtonBox["PoissonDistribution",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/PoissonDistribution"],
 " can be used to specifiy input parameter uncertainties."
}], "Notes",
 CellID->330142473,ExpressionUUID->"680d93c9-7d06-4ea7-a999-24f6df6f0a96"],

Cell["The following options can be given: ", "Notes",ExpressionUUID->"778f817c-7db7-4e2e-87b6-19c4622733ee"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "4452fe72-c695-48ca-8239-cd3f81ac4fd6"], 
    ButtonBox["UseParallelKernels",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/UseParallelKernels"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell["\<\
specifies whether parallel kernels should be used for the simulation.\
\>", "TableText",ExpressionUUID->"1ee86cd7-9b10-4eb6-8121-c77ecd795658"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "32d1c529-7a2f-4773-ae9e-5c95c1cf952b"], 
    ButtonBox["MatchPattern",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/MatchPattern"], "_", Cell["\<\
specifies that only function results matching this pattern should be used.\
\>", "TableText",ExpressionUUID->"f137f7dd-e7de-47f0-938f-9c0be9a2c9e9"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "0c122f95-587f-400a-9881-29e8ea7d721e"], 
    ButtonBox["MissingBehavior",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/MissingBehavior"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[{
     "specifies how expressions with head ",
     ButtonBox["Missing",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/Missing"],
     " should be interpreted in the context of other functions."
    }], "TableText",ExpressionUUID->"fa779468-1c0a-48a4-9280-6821eff33d80"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True, True, 
      True}}}},ExpressionUUID->"8e2d7077-3d7e-41da-96d7-9929f31032ea"],

Cell["Properties that can be accessed include:", "Notes",
 CellID->698688889,ExpressionUUID->"53e306d6-6100-46d6-ae33-c95ffc609d04"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "c22673e8-8def-464f-9514-3b9d5ee3b824"], Cell[
    "\"SingleMean\"", "TableText",ExpressionUUID->
     "a2880602-b7c7-4283-acee-a3571d21575e"], Cell["\<\
Expression as evaluated using the means of the input parameters\
\>", "TableText",ExpressionUUID->"baa4a16c-2cb7-4115-a5ec-c9996cd942fc"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "6a81e1b9-afde-44d2-a514-3ffbb48ee628"], Cell[
    "\"SingleMeanDV\"", "TableText",ExpressionUUID->
     "3101e9b1-ec5b-4f03-ae1b-9f140b98c217"], Cell[TextData[{
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "504a18b6-9312-453b-a37c-bd697ba50d1a"],
     " object including the confidence intervals."
    }], "TableText",ExpressionUUID->"27bd85d1-fbe2-4927-8347-732b58f14185"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "ff4cf51d-51c6-4f42-bf49-9da14caa7cab"], Cell[
    "\"SingleMeanNDV\"", "TableText",ExpressionUUID->
     "5fc43775-d6b0-45bc-87a8-6a73b4d1ca1a"], Cell[TextData[{
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
      "51f490ab-5684-4ccd-9ee5-6e2d42203909"],
     " object based on the calculated standard deviation."
    }], "TableText",ExpressionUUID->"2699f85a-5a05-4136-b50e-07c075f51ff3"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "8b64c30c-acd6-4f17-a408-7528e38b5162"], Cell[
    "\"QuantileCI\"", "TableText",ExpressionUUID->
     "0b2e01aa-9288-46ae-8283-3757a21a93ba"], Cell[
    "Confidence intervals, calculated from quantiles.", "TableText",
     ExpressionUUID->"e5a77441-2e32-4364-9270-f183b1711f10"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "267ee5a8-b48e-4f9e-983d-e9f84dbc34b6"], Cell[
    "\"DistributionMean\"", "TableText",ExpressionUUID->
     "a5d2b673-90c0-4439-9a86-c769fc63774c"], Cell[
    "Mean of all random expression evaluations", "TableText",ExpressionUUID->
     "55a89026-5c40-444a-a7df-88359f790dc5"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "da4d0891-7c3d-491c-be8e-1c6e902e7b84"], Cell[
    "\"DistributionMeanDV\"", "TableText",ExpressionUUID->
     "e6f9bc9b-8841-4a8c-bddc-dd3cc543db9f"], Cell[
    "As \"SingleMeanDV\" but using the DistributionMean", "TableText",
     ExpressionUUID->"138559bf-949e-4d09-abb8-af167cb4df16"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "9343fdb2-b909-4821-b3da-51e840bb13a9"], Cell[
    "\"DistributionMeanNDV\"", "TableText",ExpressionUUID->
     "97c977c6-fcf2-47de-b5d1-be2415b951a2"], Cell[
    "As \"SingleMeanNDV\" but using the DistributionMean", "TableText",
     ExpressionUUID->"ae56b9e7-a428-480b-bdf3-c9870a386b97"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "5921f8ab-0365-4932-96f5-61bac584bc0f"], Cell[
    "\"FindDistribution\"", "TableText",ExpressionUUID->
     "b751c8f9-53dd-4944-8a20-77b7c479c710"], Cell[TextData[{
     ButtonBox["FindDistribution",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/FindDistribution"],
     " for output"
    }], "TableText",ExpressionUUID->"8c740212-a412-41c2-a2a8-b535e9ed7a00"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "8ba98171-9380-45f1-9dd1-80cc20a543c6"], Cell[
    "\"EmpiricalDistribution\"", "TableText",ExpressionUUID->
     "dd78f284-49d6-4730-9f3e-58ec7b966aab"], Cell[TextData[{
     ButtonBox["EmpiricalDistribution",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/EmpiricalDistribution"],
     " for output"
    }], "TableText",ExpressionUUID->"22f0079e-5a52-4939-9203-61bd9d35027f"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "9b733e04-f6b0-483d-a831-0422b5bf3bae"], Cell[
    "\"StandardDeviation\"", "TableText",ExpressionUUID->
     "c76aac69-7597-4991-90eb-1f209c2077bd"], Cell[TextData[{
     ButtonBox["StandardDeviation",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/StandardDeviation"],
     " of output sample"
    }], "TableText",ExpressionUUID->"c68c5b8c-a345-4a44-82e3-8294f203caf5"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "7c01359e-b640-4682-8ab9-83533e04d152"], Cell[
    "\"Histogram\"", "TableText",ExpressionUUID->
     "c3c9b414-8716-4477-b802-634edb8dd485"], Cell[TextData[{
     ButtonBox["Histogram",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/Histogram"],
     " plot of output sample"
    }], "TableText",ExpressionUUID->"c855e35d-a6b9-42ec-a3b9-8dbbdbf83276"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "fbbad31f-9389-4060-ad98-57fe226c79f0"], Cell[
    "\"SensitivityPlots\"", "TableText",ExpressionUUID->
     "1a167572-0fa4-4c77-81b8-36e107bab96b"], Cell["\<\
Plots of the randomly sampled input parameter values vs. the resulting output \
value\
\>", "TableText",ExpressionUUID->"df34a914-be0d-4481-a776-fe8b18f7556e"]},
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "c0191e4f-97be-474e-8203-67f3fb5924d4"], Cell[
    "\"SimulationData\"", "TableText",ExpressionUUID->
     "81eb3fc4-3085-4288-a490-95fbdbd70fda"], Cell[
    "Raw random sampling/output data", "TableText",ExpressionUUID->
     "315813a8-fb4e-4a62-a4fe-48dfe14827c3"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {
    None, None, None, None, None, None, None, None, None, None, None, None, {
     None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True, True, True, True, True, True, True, True, True, True, True, 
      True, True}}}},
 CellID->1366643,ExpressionUUID->"34948acc-bc92-4592-9152-ff3a6f77bf71"],

Cell["\<\
Some properties work only properly if the expression is numeric if evaluated, \
but most of them (e.g. \"SingleMeanDV\", \"QuantileDV\", \"Histogram\", ...) \
thread over lists and associations.\
\>", "Notes",
 CellID->41860136,ExpressionUUID->"385c1436-b014-4f94-a70d-f1910e994849"],

Cell[TextData[{
 "Some properties use the confidence level set by ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SetConfidenceLevel"]],
    "paclet:DataAnalysis/ref/SetConfidenceLevel"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "b06d794c-1d41-45e5-ac48-a0d23c0be374"],
 "."
}], "Notes",
 CellID->1023409504,ExpressionUUID->"e2b92434-e330-47db-b01d-035d19ba9422"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"f05cc91c-d689-48ae-9295-c071f4725134"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"e883f80b-f623-4b8e-977f-738726a4935c"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(3)", "ExampleCount",ExpressionUUID->
  "b661b1ba-3022-4886-bdd0-9b5aedb9885d"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->470189143,ExpressionUUID->"05881783-c1e5-460a-9d5f-41bfe6b7fcc9"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "65b6c0ca-cb10-4832-961c-7951b0f636eb"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->647834,ExpressionUUID->"d00127cd-b5c6-4494-aecc-6ca29dd46b49"],

Cell["\<\
Carry out a simple Monte Carlo Simulation for a numeric function with two \
input parameters with uncertainties and 1000 iterations:\
\>", "ExampleText",
 CellID->124235360,ExpressionUUID->"f88189dd-242c-4b19-8a75-2cb964455013"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "=", 
  RowBox[{"MonteCarloSimulation", "[", 
   RowBox[{
    RowBox[{"Hold", "[", "\[IndentingNewLine]", 
     RowBox[{"NArgMin", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"a", " ", 
         RowBox[{"x", "^", "2"}]}], "-", 
        RowBox[{"b", " ", "x"}], "+", "5"}], ",", "x"}], "]"}], 
     "\[IndentingNewLine]", "]"}], ",", "1000", ",", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"a", "\[Rule]", 
       RowBox[{"NDV", "[", 
        RowBox[{"2", ",", "0.1"}], "]"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"b", "\[Rule]", 
       RowBox[{"NDV", "[", 
        RowBox[{"3", ",", "0.2"}], "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
   "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->236744516,ExpressionUUID->"e3c4d20c-f65c-4bde-9ca0-aab3865459a6"],

Cell[BoxData[
 RowBox[{"MonteCarloResult", "[", 
  PanelBox[
   TemplateBox[{"\"n = \"","1000"},
    "RowDefault"],
   FrameMargins->5], "]"}]], "Output",
 ImageSize->{191, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->11584445,ExpressionUUID->"ee9cebcb-09bf-48de-bf38-438c521387c5"]
}, Open  ]],

Cell["Get a NDV object for the resulting output:", "ExampleText",
 CellID->241171748,ExpressionUUID->"801cd4d9-756e-4e20-803a-924c94233e48"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<SingleMeanNDV\>\"", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->17322896,ExpressionUUID->"c7817aa9-8873-4766-af83-e3a503ff7d11"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"0.75\"", 0.7499999905779959, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "12","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[
  0.7499999905779959, 
   0.062373120478248084`, $CellContext`dv$27809]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->283871147,ExpressionUUID->"72fb5d69-cc85-436b-8ebe-6b30872e5610"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<DistributionMeanNDV\>\"", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->68104181,ExpressionUUID->"356b87d3-cf17-4903-9a3b-67300c461cda"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"0.75\"", 0.7541042368429696, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "12","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[
  0.7541042368429696, 
   0.062373120478248084`, $CellContext`dv$29401]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->110534577,ExpressionUUID->"cc3a24d7-1a96-4dbc-babd-c76224a01ea7"]
}, Open  ]],

Cell["Show a histogram of the output:", "ExampleText",
 CellID->70907048,ExpressionUUID->"0e9e32f7-9789-4da7-87d7-29c62c7c25c4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<Histogram\>\"", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->19360320,ExpressionUUID->"21d4c3f0-9e72-4df1-8a5b-a0e0af0f25ce"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], EdgeForm[{
    Opacity[0.5459999999999999], Thickness[Small]}], {}, 
    {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], EdgeForm[{
     Opacity[0.5459999999999999], Thickness[Small]}], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.58, 0}, {0.6, 5.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{24.929343474779785`, 35.8777021617293}, {
          50.86262855236895, 55.58941623502808}}],
        StatusArea[#, 5]& ,
        TagBoxNote->"5"],
       StyleBox["5", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[5, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.6, 0}, {0.62, 7.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{35.3777021617293, 46.32606084867888}, {
          49.171913479305296`, 55.58941623502808}}],
        StatusArea[#, 7]& ,
        TagBoxNote->"7"],
       StyleBox["7", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[7, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.62, 0}, {0.64, 20.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{45.82606084867888, 56.774419535628454`}, {
          38.18226550439155, 55.58941623502808}}],
        StatusArea[#, 20]& ,
        TagBoxNote->"20"],
       StyleBox["20", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[20, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.64, 0}, {0.66, 31.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{56.274419535628454`, 67.22277822257803}, {
          28.883332602541465`, 55.58941623502808}}],
        StatusArea[#, 31]& ,
        TagBoxNote->"31"],
       StyleBox["31", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[31, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.66, 0}, {0.68, 56.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{66.72277822257803, 77.6711369095276}, {
          7.749394189245805, 55.58941623502808}}],
        StatusArea[#, 56]& ,
        TagBoxNote->"56"],
       StyleBox["56", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[56, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.68, 0}, {0.7, 75.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{77.1711369095276, 
          88.11949559647712}, {-8.31239900485889, 55.58941623502808}}],
        StatusArea[#, 75]& ,
        TagBoxNote->"75"],
       StyleBox["75", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[75, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.7, 0}, {0.72, 90.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{87.61949559647712, 
          98.5678542834267}, {-20.992762052836284`, 55.58941623502808}}],
        StatusArea[#, 90]& ,
        TagBoxNote->"90"],
       StyleBox["90", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[90, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.72, 0}, {0.74, 122.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{98.0678542834267, 
          109.01621297037627`}, {-48.04420322185473, 55.58941623502808}}],
        StatusArea[#, 122]& ,
        TagBoxNote->"122"],
       StyleBox["122", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[122, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.74, 0}, {0.76, 148.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{108.51621297037627`, 
          119.46457165732579`}, {-70.02349917168222, 55.58941623502808}}],
        StatusArea[#, 148]& ,
        TagBoxNote->"148"],
       StyleBox["148", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[148, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.76, 0}, {0.78, 128.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{118.96457165732579`, 
          129.91293034427537`}, {-53.11634844104569, 55.58941623502808}}],
        StatusArea[#, 128]& ,
        TagBoxNote->"128"],
       StyleBox["128", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[128, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.78, 0}, {0.8, 92.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{129.41293034427537`, 
          140.36128903122494`}, {-22.68347712589994, 55.58941623502808}}],
        StatusArea[#, 92]& ,
        TagBoxNote->"92"],
       StyleBox["92", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[92, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.8, 0}, {0.82, 86.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{139.86128903122494`, 
          150.80964771817446`}, {-17.611331906708983`, 55.58941623502808}}],
        StatusArea[#, 86]& ,
        TagBoxNote->"86"],
       StyleBox["86", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[86, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.82, 0}, {0.84, 58.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{150.30964771817446`, 161.25800640512404`}, {
          6.058679116182155, 55.58941623502808}}],
        StatusArea[#, 58]& ,
        TagBoxNote->"58"],
       StyleBox["58", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[58, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.84, 0}, {0.86, 31.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{160.75800640512404`, 171.7063650920736}, {
          28.883332602541465`, 55.58941623502808}}],
        StatusArea[#, 31]& ,
        TagBoxNote->"31"],
       StyleBox["31", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[31, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.86, 0}, {0.88, 29.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{171.2063650920736, 182.1547237790232}, {
          30.57404767560512, 55.58941623502808}}],
        StatusArea[#, 29]& ,
        TagBoxNote->"29"],
       StyleBox["29", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[29, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.88, 0}, {0.9, 9.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{181.6547237790232, 192.60308246597276`}, {
          47.481198406241646`, 55.58941623502808}}],
        StatusArea[#, 9]& ,
        TagBoxNote->"9"],
       StyleBox["9", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[9, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.9, 0}, {0.92, 4.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{192.10308246597276`, 203.05144115292228`}, {
          51.707986088900775`, 55.58941623502808}}],
        StatusArea[#, 4]& ,
        TagBoxNote->"4"],
       StyleBox["4", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[4, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.92, 0}, {0.94, 4.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{202.55144115292228`, 213.4997998398718}, {
          51.707986088900775`, 55.58941623502808}}],
        StatusArea[#, 4]& ,
        TagBoxNote->"4"],
       StyleBox["4", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[4, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.94, 0}, {0.96, 4.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{212.9997998398718, 223.94815852682137`}, {
          51.707986088900775`, 55.58941623502808}}],
        StatusArea[#, 4]& ,
        TagBoxNote->"4"],
       StyleBox["4", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[4, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.96, 0}, {0.98, 1.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{223.44815852682137`, 234.39651721377095`}, {
          54.244058698496254`, 55.58941623502808}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {}], 
       "Tooltip"]& ]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0.572, 0},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  PlotRange->{{0.58, 0.98}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 ImageSize->{244, 149},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->282727161,ExpressionUUID->"ec129c2b-641a-46e2-97fc-97b7030dc89a"]
}, Open  ]],

Cell["Show sensitivity plots (scroll to right for second plot):", \
"ExampleText",
 CellID->237470719,ExpressionUUID->"5b0821d5-1583-4aa7-8a1a-73502786a9c4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<SensitivityPlots\>\"", "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->361198366,ExpressionUUID->"1462c796-0df2-4f68-a911-2c5c492f6154"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     GraphicsBox[{{}, {
        {RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
         AbsolutePointSize[6], AbsoluteThickness[1.6], 
         GeometricTransformationBox[InsetBox[
           GraphicsBox[
            {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
             AbsoluteThickness[1.6], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}]},
            ImageSize->10], {0., 0.}], CompressedData["
1:eJwVm3dcje8bx59TCQ0rFUohQkOb9vVURgpRtLSXVF8pIymlNBFJSxkNDdJC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          "]]}, {}}, {}, {}, {}, {}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->{False, False},
      AxesLabel->{None, None},
      AxesOrigin->{1.6729758746628465`, 0.5626614563720871},
      DisplayFunction->Identity,
      Frame->{{True, True}, {True, True}},
      FrameLabel->{{None, None}, {None, None}},
      FrameStyle->GrayLevel[0],
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      FrameTicksStyle->12,
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->450,
      LabelStyle->12,
      Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotLabel->FormBox[
        StyleBox["a", 16, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{1.6830346006437304`, 2.32679306342031}, {
       0.5820200999518762, 0.9691929715476582}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}], 
     GraphicsBox[{{}, {
        {RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
         AbsolutePointSize[6], AbsoluteThickness[1.6], 
         GeometricTransformationBox[InsetBox[
           GraphicsBox[
            {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
             AbsoluteThickness[1.6], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}]},
            ImageSize->10], {0., 0.}], CompressedData["
1:eJwVmnk4VG8bx4WZc2aQpLSotMsWaSXcN6WFFm2UKEqlKEtFJJUUpeKnEipr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          "]]}, {}}, {}, {}, {}, {}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->{False, False},
      AxesLabel->{None, None},
      AxesOrigin->{2.4056504422994074`, 0.5626614563720871},
      DisplayFunction->Identity,
      Frame->{{True, True}, {True, True}},
      FrameLabel->{{None, None}, {None, None}},
      FrameStyle->GrayLevel[0],
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      FrameTicksStyle->12,
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->450,
      LabelStyle->12,
      Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotLabel->FormBox[
        StyleBox["b", 16, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{2.426334527794761, 3.750115999497397}, {0.5820200999518762,
        0.9691929715476582}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{5}}}],
  "Grid"]], "Output",
 ImageSize->{964, 305},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->300507258,ExpressionUUID->"ef0e5e84-2f8e-4fab-a821-7d76cb6b470d"]
}, Open  ]],

Cell["Get some more properties:", "ExampleText",
 CellID->442318850,ExpressionUUID->"c0a0a61f-ae28-4107-8056-2a2cfc769228"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<FindDistribution\>\"", "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->54886802,ExpressionUUID->"998cefa0-a389-4f82-bab7-9b0082db7b89"],

Cell[BoxData[
 RowBox[{"NormalDistribution", "[", 
  RowBox[{"0.7543806595097057`", ",", "0.06319325654242229`"}], 
  "]"}]], "Output",
 ImageSize->{274, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->220669165,ExpressionUUID->"1fc3da7b-b58d-44ed-9044-ddcca282b158"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<QuantileCI\>\"", "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->164279433,ExpressionUUID->"9aea463b-107b-45d9-aa28-25dcd3d8eb17"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.63218109691192`", ",", "0.8784000229439822`"}], "}"}]], "Output",
 ImageSize->{127, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->63173912,ExpressionUUID->"dec51a61-2356-4f82-924d-cb66f1c8978b"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "0f157597-1190-47c7-b022-c345e4642cf7"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265,ExpressionUUID->"527d1f2c-7bee-45bb-b729-e276429f8419"],

Cell[CellGroupData[{

Cell[TextData[{
 "Explore the raw \"SimulationData\":",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "21313fc7-8c1a-412b-b5c8-7d1820730e31"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->192514020,ExpressionUUID->"d0269c7c-b51c-4e26-b922-70e9e021db55"],

Cell["\<\
The \"SimulationData\" property returns a list with all random simulations. \
Each list item is a sub-list where the first item is the output of the \
expression, and the second item is the list of the random input parameters.\
\>", "ExampleText",
 CellID->174300166,ExpressionUUID->"478202cc-ac0a-4c2f-978a-adcc9bf6fb36"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"res", "[", "\"\<SimulationData\>\"", "]"}], "[", 
  RowBox[{"[", "1", "]"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->576401315,ExpressionUUID->"97e7caac-d8df-4afa-a20b-52ae2ad14f3a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.8287395272868924`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "1.780631963632374`"}], ",", 
     RowBox[{"b", "\[Rule]", "2.9513602237471597`"}]}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{249, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->873569941,ExpressionUUID->"51b6f21c-d674-4b6f-bd6e-9fe220430d0d"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Options",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "ad6272b2-d690-41b9-a8c7-1bde1543cb9d"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"8d271351-2bea-4c18-bcdd-67821e2410ed"],

Cell[CellGroupData[{

Cell[TextData[{
 "UseParallelKernels",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "c65f401c-1b53-40fd-825e-99eb3d2168d9"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->
  True,ExpressionUUID->"7e8ad16f-58d2-49ef-9ea9-e26b9d8d8981"],

Cell["\<\
If multiple kernels can be run in parallel on the machine, setting \
UseParallelKernel to True runs the Monte Carlo simulations in parallel, which \
can speed up the overall duration siginificantly.\
\>", "ExampleText",
 CellID->5602006,ExpressionUUID->"bbfb5f61-a353-4212-84d6-5a166ad08ae7"]
}, Closed]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"7b6c66d7-ad42-441a-937c-f582862e105e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"028bed95-532e-4f82-a7e2-96e68665c33d"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"8ebf7f97-1e32-46e3-9041-79542f248213"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloResult"]],"paclet:DataAnalysis/ref/MonteCarloResult"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"59079635-ab9d-49fc-b0a2-c71d81aa6aa9"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"f2217ad2-2dec-47f4-abe0-498d9b1c09a0"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"8b5222da-47a7-4411-ba9b-56971a651820"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"b7ae6a46-91a3-4c0e-94b3-0b11e37f143b"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"11d2a50c-558a-4671-9046-606469a96925"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"cdc9ee79-a096-4ed7-9f72-71637fb194f8"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"156cf1ed-7324-45bf-90ab-ba5b1a2498d9"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"1582b7fe-ddfe-4c80-9c89-d7da8110aad8"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->42927162,ExpressionUUID->"7b2762f4-c0f9-4bcb-b6f9-9f6060b702fe"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"5f10d570-87e4-429d-983f-bc37e30f69b0"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MonteCarloSimulation",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 16.9387808}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "MonteCarloSimulation[expr, i, {param1 -> distribution1, param2 -> \
distribution2, ...}] carries out a Monte Carlo simulation with i iterations, \
to propagate uncertainties (in NDV objects or standard Mathematica \
Distribution objects) in expr. Parameters in expr may be separately specified \
as rules parami -> distributioni, where distributioni can be either an NDV \
object or a standard Mathematica distribution object.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "MonteCarloSimulation", "titlemodifier" -> 
    "", "windowtitle" -> "MonteCarloSimulation", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/MonteCarloSimulation"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[23181, 583, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"05881783-c1e5-460a-9d5f-41bfe6b7fcc9",
   CellTags->"PrimaryExamplesSection",
   CellID->470189143]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 95249, 2158}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 4480, 101, 55, "AnchorBarGrid",ExpressionUUID->"e879ebb3-dc4f-408f-a503-f853f51b29da",
 CellID->1],
Cell[CellGroupData[{
Cell[5097, 126, 405, 9, 52, "ObjectNameGrid",ExpressionUUID->"6c1fd402-db6d-4c8c-a5cd-93762b5b8404"],
Cell[5505, 137, 2699, 70, 174, "Usage",ExpressionUUID->"bfda5447-1a6a-445c-ae2e-211e3ee26ddd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8241, 212, 855, 21, 37, "NotesSection",ExpressionUUID->"f2c57992-0d09-4f00-b88b-8debd17b7161",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->313577501],
Cell[9099, 235, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"3b794ec8-c4ef-49b4-bce1-c3db33b806c7"],
Cell[9188, 237, 773, 20, 70, "Notes",ExpressionUUID->"a22afa6b-c95c-452d-85a5-a662668238f0",
 CellID->795731367],
Cell[9964, 259, 504, 14, 70, "Notes",ExpressionUUID->"97677ad2-ed9d-4000-be3c-fa588492d053",
 CellID->30591226],
Cell[10471, 275, 517, 14, 70, "Notes",ExpressionUUID->"9fbc88cf-220d-44dd-84ce-63ff2267ae70",
 CellID->449242119],
Cell[10991, 291, 758, 20, 70, "Notes",ExpressionUUID->"dcfbc2a7-b5d0-45bb-89bd-314220f08a71",
 CellID->222801089],
Cell[11752, 313, 615, 18, 70, "Notes",ExpressionUUID->"bb9e5e18-5839-49ea-b66b-f6ab5978b9ed",
 CellID->56206725],
Cell[12370, 333, 724, 20, 70, "Notes",ExpressionUUID->"af6c86f3-f891-44e1-aa44-06a4bd5b2923",
 CellID->257908114],
Cell[13097, 355, 510, 11, 70, "Notes",ExpressionUUID->"6b7cff89-e933-4d92-a7d0-4c2201b3154e",
 CellID->378738187],
Cell[13610, 368, 256, 4, 70, "Notes",ExpressionUUID->"865f101f-5bfc-4007-af60-cb42b5cdae5a",
 CellID->163845120],
Cell[13869, 374, 656, 18, 70, "Notes",ExpressionUUID->"680d93c9-7d06-4ea7-a999-24f6df6f0a96",
 CellID->330142473],
Cell[14528, 394, 108, 0, 70, "Notes",ExpressionUUID->"778f817c-7db7-4e2e-87b6-19c4622733ee"],
Cell[14639, 396, 1758, 40, 70, "3ColumnTableMod",ExpressionUUID->"8e2d7077-3d7e-41da-96d7-9929f31032ea"],
Cell[16400, 438, 132, 1, 70, "Notes",ExpressionUUID->"53e306d6-6100-46d6-ae33-c95ffc609d04",
 CellID->698688889],
Cell[16535, 441, 5809, 115, 70, "2ColumnTableMod",ExpressionUUID->"34948acc-bc92-4592-9152-ff3a6f77bf71",
 CellID->1366643],
Cell[22347, 558, 293, 5, 70, "Notes",ExpressionUUID->"385c1436-b014-4f94-a70d-f1910e994849",
 CellID->41860136],
Cell[22643, 565, 412, 11, 70, "Notes",ExpressionUUID->"e2b92434-e330-47db-b01d-035d19ba9422",
 CellID->1023409504],
Cell[23058, 578, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"f05cc91c-d689-48ae-9295-c071f4725134"]
}, Closed]],
Cell[CellGroupData[{
Cell[23181, 583, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"05881783-c1e5-460a-9d5f-41bfe6b7fcc9",
 CellTags->"PrimaryExamplesSection",
 CellID->470189143],
Cell[CellGroupData[{
Cell[23641, 598, 305, 7, 29, "ExampleSection",ExpressionUUID->"d00127cd-b5c6-4494-aecc-6ca29dd46b49",
 CellID->647834],
Cell[23949, 607, 238, 4, 57, "ExampleText",ExpressionUUID->"f88189dd-242c-4b19-8a75-2cb964455013",
 CellID->124235360],
Cell[CellGroupData[{
Cell[24212, 615, 830, 22, 107, "Input",ExpressionUUID->"e3c4d20c-f65c-4bde-9ca0-aab3865459a6",
 CellID->236744516],
Cell[25045, 639, 339, 10, 56, "Output",ExpressionUUID->"ee9cebcb-09bf-48de-bf38-438c521387c5",
 CellID->11584445]
}, Open  ]],
Cell[25399, 652, 140, 1, 38, "ExampleText",ExpressionUUID->"801cd4d9-756e-4e20-803a-924c94233e48",
 CellID->241171748],
Cell[CellGroupData[{
Cell[25564, 657, 173, 3, 26, "Input",ExpressionUUID->"c7817aa9-8873-4766-af83-e3a503ff7d11",
 CellID->17322896],
Cell[25740, 662, 630, 18, 35, "Output",ExpressionUUID->"72fb5d69-cc85-436b-8ebe-6b30872e5610",
 CellID->283871147]
}, Open  ]],
Cell[CellGroupData[{
Cell[26407, 685, 179, 3, 26, "Input",ExpressionUUID->"356b87d3-cf17-4903-9a3b-67300c461cda",
 CellID->68104181],
Cell[26589, 690, 630, 18, 35, "Output",ExpressionUUID->"cc3a24d7-1a96-4dbc-babd-c76224a01ea7",
 CellID->110534577]
}, Open  ]],
Cell[27234, 711, 128, 1, 70, "ExampleText",ExpressionUUID->"0e9e32f7-9789-4da7-87d7-29c62c7c25c4",
 CellID->70907048],
Cell[CellGroupData[{
Cell[27387, 716, 169, 3, 70, "Input",ExpressionUUID->"21d4c3f0-9e72-4df1-8a5b-a0e0af0f25ce",
 CellID->19360320],
Cell[27559, 721, 13479, 388, 70, "Output",ExpressionUUID->"ec129c2b-641a-46e2-97fc-97b7030dc89a",
 CellID->282727161]
}, Open  ]],
Cell[41053, 1112, 157, 2, 70, "ExampleText",ExpressionUUID->"5b0821d5-1583-4aa7-8a1a-73502786a9c4",
 CellID->237470719],
Cell[CellGroupData[{
Cell[41235, 1118, 177, 3, 70, "Input",ExpressionUUID->"1462c796-0df2-4f68-a911-2c5c492f6154",
 CellID->361198366],
Cell[41415, 1123, 44994, 777, 326, "Output",ExpressionUUID->"ef0e5e84-2f8e-4fab-a821-7d76cb6b470d",
 CellID->300507258]
}, Open  ]],
Cell[86424, 1903, 123, 1, 70, "ExampleText",ExpressionUUID->"c0a0a61f-ae28-4107-8056-2a2cfc769228",
 CellID->442318850],
Cell[CellGroupData[{
Cell[86572, 1908, 176, 3, 70, "Input",ExpressionUUID->"998cefa0-a389-4f82-bab7-9b0082db7b89",
 CellID->54886802],
Cell[86751, 1913, 321, 8, 35, "Output",ExpressionUUID->"1fc3da7b-b58d-44ed-9044-ddcca282b158",
 CellID->220669165]
}, Open  ]],
Cell[CellGroupData[{
Cell[87109, 1926, 171, 3, 70, "Input",ExpressionUUID->"9aea463b-107b-45d9-aa28-25dcd3d8eb17",
 CellID->164279433],
Cell[87283, 1931, 292, 7, 35, "Output",ExpressionUUID->"dec51a61-2356-4f82-924d-cb66f1c8978b",
 CellID->63173912]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[87624, 1944, 300, 7, 70, "ExampleSection",ExpressionUUID->"527d1f2c-7bee-45bb-b729-e276429f8419",
 CellID->1293636265],
Cell[CellGroupData[{
Cell[87949, 1955, 335, 7, 70, "ExampleSubsection",ExpressionUUID->"d0269c7c-b51c-4e26-b922-70e9e021db55",
 CellID->192514020],
Cell[88287, 1964, 332, 5, 70, "ExampleText",ExpressionUUID->"478202cc-ac0a-4c2f-978a-adcc9bf6fb36",
 CellID->174300166],
Cell[CellGroupData[{
Cell[88644, 1973, 226, 5, 70, "Input",ExpressionUUID->"97e7caac-d8df-4afa-a20b-52ae2ad14f3a",
 CellID->576401315],
Cell[88873, 1980, 428, 12, 35, "Output",ExpressionUUID->"51b6f21c-d674-4b6f-bd6e-9fe220430d0d",
 CellID->873569941]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[89362, 1999, 284, 7, 70, "ExampleSection",ExpressionUUID->"8d271351-2bea-4c18-bcdd-67821e2410ed"],
Cell[CellGroupData[{
Cell[89671, 2010, 301, 7, 70, "ExampleSubsection",ExpressionUUID->"7e8ad16f-58d2-49ef-9ea9-e26b9d8d8981"],
Cell[89975, 2019, 302, 5, 70, "ExampleText",ExpressionUUID->"bbfb5f61-a353-4212-84d6-5a166ad08ae7",
 CellID->5602006]
}, Closed]]
}, Closed]],
Cell[90304, 2028, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"7b6c66d7-ad42-441a-937c-f582862e105e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[90427, 2033, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"8ebf7f97-1e32-46e3-9041-79542f248213",
 CellID->1255426704],
Cell[90690, 2042, 1475, 38, 70, "SeeAlso",ExpressionUUID->"11d2a50c-558a-4671-9046-606469a96925",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[92202, 2085, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"156cf1ed-7324-45bf-90ab-ba5b1a2498d9",
 CellID->38303248],
Cell[92471, 2094, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"1582b7fe-ddfe-4c80-9c89-d7da8110aad8"],
Cell[92560, 2096, 246, 6, 70, "MoreAbout",ExpressionUUID->"7b2762f4-c0f9-4bcb-b6f9-9f6060b702fe",
 CellID->42927162]
}, Open  ]],
Cell[92821, 2105, 78, 0, 70, "FooterCell",ExpressionUUID->"5f10d570-87e4-429d-983f-bc37e30f69b0"]
}
]
*)

(* End of internal cache information *)

