(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     43457,       1169]
NotebookOptionsPosition[     33728,        956]
NotebookOutlinePosition[     36213,       1020]
CellTagsIndexPosition[     36091,       1014]
WindowTitle->NDV
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "782f16d4-9c4d-4122-8088-65fec2bf031d"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"8f60b4e8-04fe-4b1d-830a-8545b5e39dcb"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DV\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DV"], "\<\"DVEvaluate\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/DVEvaluate"], "\<\"MCEvaluate\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MCEvaluate"], "\<\"MonteCarloSimulation\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MonteCarloSimulation"], \
"\<\"SetConfidenceLevel\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/SetConfidenceLevel"], \
"\<\"$UsePlusMinusForm\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/$UsePlusMinusForm"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "3c451334-d2c8-4ed7-8e9a-45519aa23570"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"156d2f95-7e09-473d-8e52-318ffe778330"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "4beeb47c-0732-44d7-8170-b8cf2fd04d02"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"3739fc5b-1f02-4ab0-908e-ef620726ece1"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/NDV\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/NDV"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/NDV.\
html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$36102], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/NDV", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ecb6fb14-670b-4cdf-830d-57b822070495"]
    }], "AnchorBar",ExpressionUUID->"3ba19ceb-f54f-4793-88e4-61bed097cb9a"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"590f2b44-67f6-4f1b-9720-b00b54f44a9e"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["NDV", "ObjectName",ExpressionUUID->
  "5a6a3d08-f0da-4d97-86a1-dd5e8cb70654"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"fc31ab20-cb2a-4fbb-9a02-078b46bb34ab"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "fa27441a-ee7f-4075-b6f5-07a0fd1e4eb3"]
}], "ObjectNameGrid",ExpressionUUID->"4f13948f-f359-401e-83d2-d2be6448a84e"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"NDV", "[", 
       RowBox[{
        StyleBox["v", "TI"], ",", 
        StyleBox["se", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "6cd6fcec-0284-4014-9757-9a214ef1cc5b"],
     "\[LineSeparator]represents a value associated with an uncertainty in \
the form of a normal distribution with mean v and standard error se."
    }],ExpressionUUID->"11722019-805d-4328-b424-7ef67da8190c"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"773df666-f978-4a6e-915c-788163fe7080"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"6dfbe038-86c7-4435-8098-704e1733ed25"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"685a80a6-6c94-4cb8-9129-ba7d9039beab"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"00e0f000-180d-4b59-9137-a461aae81b1d"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->594878995,ExpressionUUID->"b4ebbb51-1360-49e0-89a0-779e562c7136"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"53c151dd-151e-4afa-ae4a-d8fd68ac81df"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "255d094b-3b20-47c0-b3f6-4473cede56bd"],
 " values can be used to propagate uncertainties and carry out sensitivity \
tests using the functions ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "0f09d2d3-b62b-4375-8728-a0b35847d08e"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f7e1653a-f36d-4fe6-85e2-69d8c32f9e12"],
 " and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "115fe3a4-24ac-4f5c-998d-c83b19dfef98"],
 "."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"8c840358-6b43-469a-a3b9-7aaca5e13f5e"],

Cell[TextData[{
 "The arguments v and se are similar to the arguments of ",
 ButtonBox["NormalDistribution",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NormalDistribution"],
 "."
}], "Notes",
 CellID->632505456,ExpressionUUID->"4e84b157-5773-4e6f-bf73-22c1c3f15664"],

Cell[TextData[{
 "By default, ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "9e0dfcbd-25ba-4d9f-a4c9-d6bef463b007"],
 " values show the mean and (relative) 95% confidence interval using the \
parenthesis form. For example, a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f2e807f7-579b-45e3-a13c-bdf96fe2fd17"],
 " with mean 1 and standard error 0.1 is displayed as 1.00(20)."
}], "Notes",
 CellID->118183324,ExpressionUUID->"c1189c87-21a4-46cf-901d-c354aa6ece30"],

Cell[TextData[{
 "Values can be shown using the \[PlusMinus] form, e.g. 1.00\[PlusMinus]0.20, \
by setting ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["$UsePlusMinusForm"]],
    "paclet:DataAnalysis/ref/$UsePlusMinusForm"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "a2b9b7b0-2855-41a7-81d4-56f2c30e27df"],
 " to True."
}], "Notes",
 CellID->88864061,ExpressionUUID->"17aa013a-28da-42c1-9ee5-b0d51e56f58d"],

Cell[TextData[{
 "Confidence intervals for the output are calculated using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["Z-values"]],"https://en.wikipedia.org/wiki/Standard_score"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "43ca7ca0-7426-49d1-928d-170ae6b61887"],
 "."
}], "Notes",
 CellID->222152739,ExpressionUUID->"0fa7f6bc-9987-4ea0-bf26-1c9fa72d8cc2"],

Cell[TextData[{
 "Different confidence levels can be set using the function ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SetConfidenceLevel"]],
    "paclet:DataAnalysis/ref/SetConfidenceLevel"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "f8ae47dd-a162-4629-b607-e578010c90c4"],
 "."
}], "Notes",
 CellID->88498757,ExpressionUUID->"cf15e9d4-acf6-4020-96fe-cef49ee26297"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"de67d37c-8a1a-49b4-8427-53b89602b77a"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"4f04b51f-fcd1-4505-bb97-6ad075567a5a"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "c66bfb1a-e7d0-485b-be9a-e93f6f4f296a"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->357857239,ExpressionUUID->"0d37927d-86a5-4ec4-b501-b1952fc9546b"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "c3e3d7dd-dfc5-46ec-8878-063d1cd0f9da"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->142222817,ExpressionUUID->"656470a1-303c-4a8e-bd9e-b77e5a26bf9e"],

Cell["\<\
Define a normal distribution value with mean 1 and standard error 0.1:\
\>", "ExampleText",
 CellID->320056803,ExpressionUUID->"80669bc0-3db9-4d86-8f54-f78dc1c3b65d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"v", "=", 
  RowBox[{"NDV", "[", 
   RowBox[{"1", ",", "0.1"}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->933923315,ExpressionUUID->"01ad212e-5f3b-4673-9f1f-ae125643eee2"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "20","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1, 0.1, $CellContext`dv$748683]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->164079176,ExpressionUUID->"b5e520c7-0993-49e6-90a2-30aca8249f5b"]
}, Open  ]],

Cell["Change the displayed uncertainty level to 99%:", "ExampleText",
 CellID->335203102,ExpressionUUID->"e07c9dd2-90b3-42b1-bfc6-9db6fa5659c0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetConfidenceLevel", "[", "0.99", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->815185054,ExpressionUUID->"15cb4456-6207-436f-9de3-4c980072fd4e"],

Cell[BoxData["0.99`"], "Output",
 ImageSize->{32, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->158370850,ExpressionUUID->"bb4c3a92-6ad6-40b7-b336-27dfe4f3c3a4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["v"], "Input",
 CellLabel->"In[3]:=",
 CellID->381330855,ExpressionUUID->"08d5edb4-d442-4ff7-9866-57d5dc3c4420"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(SE=\"",
     TagBox[
      InterpretationBox["\"0.10\"", 0.1, AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[1, 0.1, Null, $CellContext`dv$915395]]], "Output",
 ImageSize->{95, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->46014209,ExpressionUUID->"8a1c1615-1451-40f1-b61e-e0cb1f488fae"]
}, Open  ]],

Cell["Display the value using the \[PlusMinus] form:", "ExampleText",
 CellID->549217134,ExpressionUUID->"724f3247-4b3a-4d36-aa81-378ab1f24b28"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$UsePlusMinusForm", "=", "True"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->132867000,ExpressionUUID->"24e60057-2a68-422a-9aa2-f08731211716"],

Cell[BoxData["True"], "Output",
 ImageSize->{32, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->340031220,ExpressionUUID->"5770b5b9-be6f-4450-967d-c30a390d50bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["v"], "Input",
 CellLabel->"In[5]:=",
 CellID->160693972,ExpressionUUID->"87130da6-43ed-461f-9bfd-c91b70566275"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus]\"",TagBox[
      InterpretationBox["\"0.26\"", 0.25758293035489005`, AutoDelete -> True],
       NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ]},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1, 0.1, $CellContext`dv$702166]]], "Output",
 ImageSize->{67, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->676433893,ExpressionUUID->"1bdf1318-0a3e-4b1b-9350-a40c7a092886"]
}, Open  ]],

Cell[TextData[{
 "Use ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "33dcff5f-31b8-427f-b302-dda286e81b2d"],
 " to propagate uncertainties:"
}], "ExampleText",
 CellID->65440302,ExpressionUUID->"591a1242-be06-4ad2-8832-420017129906"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"3", "*", "v"}], "+", 
   RowBox[{"NDV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->51731737,ExpressionUUID->"6299cbd3-2252-4822-b6d0-c771554513f1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"8.0\"", 8., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus]\"",TagBox[
      InterpretationBox["\"1.3\"", 1.2879146517744502`, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ]},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[8., 0.5, $CellContext`dv$915480]]], "Output",
 ImageSize->{53, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->625639463,ExpressionUUID->"1fdbe2dd-9373-42d3-b92a-32274b094f35"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Scope",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "64209361-d029-4b5c-937f-9618048d8d5f"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265,ExpressionUUID->"c2c918c2-5192-4e38-a987-609993125c8d"],

Cell[CellGroupData[{

Cell[TextData[{
 "Uncertainty propagation",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "b7545813-b193-458d-8448-b02267b687c7"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->77239095,ExpressionUUID->"4ede3105-619d-428e-a636-5f2dd4f32ab5"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "100b47fe-6efc-4116-98f7-ff532330eb80"],
 " uses linearizations to propagate uncertainties, which works well for \
relatively linear functions:"
}], "ExampleText",
 CellID->140850270,ExpressionUUID->"301a0688-abd5-45d0-a2f1-048d2179691a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"3", "*", "v"}], "+", 
   RowBox[{"NDV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->181431349,ExpressionUUID->"dc8c5e57-a654-4e17-b567-3e5facb2e635"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"8.0\"", 8., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus]\"",TagBox[
      InterpretationBox["\"1.3\"", 1.2879146517744502`, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ]},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[8., 0.5, $CellContext`dv$748705]]], "Output",
 ImageSize->{53, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->489337095,ExpressionUUID->"97f56be8-4bd5-4e8b-b5d2-4e7245885be6"]
}, Open  ]],

Cell[TextData[{
 "Using ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "ddecf752-52a6-46aa-bf18-cfc248080556"],
 " (effectively carrying out a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "93c8de78-d72a-4885-a37b-181c200ab15c"],
 ") to propagate uncertainties is slower, but yields similar information in \
such cases (but returns a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "1c2138f8-c20a-4264-843d-ab0811e55142"],
 " instead of assuming a normal distribution (",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "fdb100ae-d82e-4516-98f6-32d923b0bf5a"],
 ") of the result):"
}], "ExampleText",
 CellID->258831177,ExpressionUUID->"f1883a66-8d84-4535-a185-57ec1a512279"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MCEvaluate", "[", 
  RowBox[{
   RowBox[{"3", "*", "v"}], "+", 
   RowBox[{"NDV", "[", 
    RowBox[{"5", ",", "0.4"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->86985097,ExpressionUUID->"a21ebb15-605f-430e-9705-55845ccf7063"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"8.0\"", 8., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus][-\"",TagBox[
      InterpretationBox["\"1.3\"", 1.2737422621208339`, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],"\"+\"",
     TagBox[
      InterpretationBox["\"1.3\"", 1.2756144864938026`, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],"\"]\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[
  8, 0.49554018251894233`, {1.2737422621208339`, 
   1.2756144864938026`}, $CellContext`dv$828904]]], "Output",
 ImageSize->{102, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->236496427,ExpressionUUID->"9c129752-4da2-4ad2-8ab7-10440dd13636"]
}, Open  ]],

Cell[TextData[{
 "For highly non-linear functions, ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "1fd45086-fba6-42d7-bdc9-0351c2f44b31"],
 " and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "5307be82-bb3f-4d80-ae80-7e989c0c7c3c"],
 " yield different results as ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "8b743494-88fd-4cc8-a1b4-0c3cf43e31d5"],
 " uses ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "bad5e1e0-c4d4-431a-a343-d9ba31400e4b"],
 " which does not use linearizations:"
}], "ExampleText",
 CellID->378591257,ExpressionUUID->"9977f697-5836-4315-8d3c-34c0a4d260b8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{"v", "^", "5"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->12560657,ExpressionUUID->"9642a7e3-5a93-4257-bf0f-53aeef3d884c"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.0\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus]\"",TagBox[
      InterpretationBox["\"1.3\"", 1.2879146517744502`, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ]},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1., 0.5, $CellContext`dv$768760]]], "Output",
 ImageSize->{53, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->258755158,ExpressionUUID->"e694f088-244c-44bc-a71d-4936c773254d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MCEvaluate", "[", 
  RowBox[{"v", "^", "5"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->652441307,ExpressionUUID->"3d55abc9-a320-4630-a2e8-ddf3dea55e21"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus][-\"",TagBox[
      InterpretationBox["\"0.77\"", 0.7688815791816134, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"+\"",
     TagBox[
      InterpretationBox["\"2.14\"", 2.141293095224526, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"]\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[
  1, 0.5486885315493072, {0.7688815791816134, 
   2.141293095224526}, $CellContext`dv$808846]]], "Output",
 ImageSize->{123, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->233418334,ExpressionUUID->"eb1a64ba-0ce5-4021-9b69-c2edc4b9b4c0"]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "9f61eccc-9ded-4998-b084-6a9a37ddcd4a"],
 " can be used if more information about the resulting uncertainties is \
required:"
}], "ExampleText",
 CellID->275110610,ExpressionUUID->"d1865b0b-9120-4cba-803e-f95d6f1e7e88"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mc", "=", 
  RowBox[{"MonteCarloSimulation", "[", 
   RowBox[{
    RowBox[{"v", "^", "5"}], ",", "10000", ",", 
    RowBox[{"{", "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->367586701,ExpressionUUID->"6e2ae160-1a82-436c-bc94-76a4b1cb24ee"],

Cell[BoxData[
 RowBox[{"MonteCarloResult", "[", 
  PanelBox[
   TemplateBox[{"\"n = \"","10000"},
    "RowDefault"],
   FrameMargins->5], "]"}]], "Output",
 ImageSize->{199, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->55212792,ExpressionUUID->"292ee096-42c8-4193-b313-9357e4cdc927"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mc", "[", "\"\<SingleMeanDV\>\"", "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->366086389,ExpressionUUID->"afa0e0cb-0b8d-4003-92b6-2a306620c6ad"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus][-\"",TagBox[
      InterpretationBox["\"0.77\"", 0.7652095201266067, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"+\"",
     TagBox[
      InterpretationBox["\"2.10\"", 2.104017692624734, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"]\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`DV[
  1, 0.5519664346887586, {0.7652095201266067, 
   2.104017692624734}, $CellContext`dv$909399]]], "Output",
 ImageSize->{123, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->28161295,ExpressionUUID->"017c9c3f-d085-4241-bf42-3982d169daca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mc", "[", "\"\<Histogram\>\"", "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->106362550,ExpressionUUID->"b10e9745-b7bb-4124-849c-24720075e5ee"],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnUFu20YUQI12k2WvUPQS7bIBSqDbFD1AglpBgcIFnAJFNwUEGD1Bt7qG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    "], {{0, 148}, {240, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  DefaultBaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{240, 148},
  PlotRange->{{0, 240}, {0, 148}}]], "Output",
 ImageSize->{244, 148},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[7]=",
 CellID->278865371,ExpressionUUID->"54f1cab1-cc0a-4577-90c9-2eaef75be8da"]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"d3a209c4-aad2-4630-9195-0935b3790ace"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"5aa38f9c-4ffc-4733-a78d-16ac5e046049"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"29f3cd47-c5bd-492a-9246-38836aea371a"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DV"]],"paclet:DataAnalysis/ref/DV"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"4ce5fc01-58c8-4d9c-adad-b2c5813f57aa"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DVEvaluate"]],"paclet:DataAnalysis/ref/DVEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"a93b9149-f3e6-437c-a442-e856993112d5"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MCEvaluate"]],"paclet:DataAnalysis/ref/MCEvaluate"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"f0bca42e-3f20-4e4e-a001-ddb511de5fc3"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MonteCarloSimulation"]],
    "paclet:DataAnalysis/ref/MonteCarloSimulation"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"5e63bfbf-1360-4d5d-98af-51f96dd4a083"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SetConfidenceLevel"]],
    "paclet:DataAnalysis/ref/SetConfidenceLevel"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"8b67eee1-4cf8-49eb-a736-1e5ad4dbb310"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["$UsePlusMinusForm"]],
    "paclet:DataAnalysis/ref/$UsePlusMinusForm"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"f8a79802-46e7-4e99-b329-65ea6ddb7fb3"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"08eb07a3-bea1-4a06-8c4b-cf2c22145240"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"9d32d5ac-0439-441e-8bfc-ac28247f224f"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"b9a25009-c67e-4a80-8fdc-41072c85d821"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"e966ce50-8817-49e7-a921-9dd1ab73deab"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->472682509,ExpressionUUID->"f81d4c5a-8d65-44b3-82a2-01080aca1ee1"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"f388cb4d-6766-4388-a900-1dfaeff5290f"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"NDV",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 18.7776860}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "NDV[v, se] represents a value associated with an uncertainty in the form \
of a normal distribution with mean v and standard error se.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "NDV", "titlemodifier" -> 
    "", "windowtitle" -> "NDV", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/NDV"}, "SearchTextTranslated" -> "", "NewStyles" -> 
  False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[10829, 292, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"0d37927d-86a5-4ec4-b501-b1952fc9546b",
   CellTags->"PrimaryExamplesSection",
   CellID->357857239]},
 "RasterizedOutput"->{
  Cell[27552, 797, 2740, 52, 70, "Output",ExpressionUUID->"54f1cab1-cc0a-4577-90c9-2eaef75be8da",
   CellTags->"RasterizedOutput",
   CellID->278865371]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 35714, 1003},
 {"RasterizedOutput", 35913, 1007}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[575, 21, 4615, 103, 55, "AnchorBarGrid",ExpressionUUID->"590f2b44-67f6-4f1b-9720-b00b54f44a9e",
 CellID->1],
Cell[CellGroupData[{
Cell[5215, 128, 388, 9, 52, "ObjectNameGrid",ExpressionUUID->"4f13948f-f359-401e-83d2-d2be6448a84e"],
Cell[5606, 139, 684, 16, 130, "Usage",ExpressionUUID->"773df666-f978-4a6e-915c-788163fe7080"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6327, 160, 855, 21, 37, "NotesSection",ExpressionUUID->"b4ebbb51-1360-49e0-89a0-779e562c7136",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->594878995],
Cell[7185, 183, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"53c151dd-151e-4afa-ae4a-d8fd68ac81df"],
Cell[7274, 185, 1159, 32, 70, "Notes",ExpressionUUID->"8c840358-6b43-469a-a3b9-7aaca5e13f5e",
 CellID->1067943069],
Cell[8436, 219, 270, 7, 70, "Notes",ExpressionUUID->"4e84b157-5773-4e6f-bf73-22c1c3f15664",
 CellID->632505456],
Cell[8709, 228, 726, 18, 70, "Notes",ExpressionUUID->"c1189c87-21a4-46cf-901d-c354aa6ece30",
 CellID->118183324],
Cell[9438, 248, 457, 12, 70, "Notes",ExpressionUUID->"17aa013a-28da-42c1-9ee5-b0d51e56f58d",
 CellID->88864061],
Cell[9898, 262, 382, 10, 70, "Notes",ExpressionUUID->"0fa7f6bc-9987-4ea0-bf26-1c9fa72d8cc2",
 CellID->222152739],
Cell[10283, 274, 420, 11, 70, "Notes",ExpressionUUID->"cf15e9d4-acf6-4020-96fe-cef49ee26297",
 CellID->88498757],
Cell[10706, 287, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"de67d37c-8a1a-49b4-8427-53b89602b77a"]
}, Closed]],
Cell[CellGroupData[{
Cell[10829, 292, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"0d37927d-86a5-4ec4-b501-b1952fc9546b",
 CellTags->"PrimaryExamplesSection",
 CellID->357857239],
Cell[CellGroupData[{
Cell[11289, 307, 308, 7, 29, "ExampleSection",ExpressionUUID->"656470a1-303c-4a8e-bd9e-b77e5a26bf9e",
 CellID->142222817],
Cell[11600, 316, 176, 3, 38, "ExampleText",ExpressionUUID->"80669bc0-3db9-4d86-8f54-f78dc1c3b65d",
 CellID->320056803],
Cell[CellGroupData[{
Cell[11801, 323, 203, 5, 26, "Input",ExpressionUUID->"01ad212e-5f3b-4673-9f1f-ae125643eee2",
 CellID->933923315],
Cell[12007, 330, 566, 15, 35, "Output",ExpressionUUID->"b5e520c7-0993-49e6-90a2-30aca8249f5b",
 CellID->164079176]
}, Open  ]],
Cell[12588, 348, 144, 1, 38, "ExampleText",ExpressionUUID->"e07c9dd2-90b3-42b1-bfc6-9db6fa5659c0",
 CellID->335203102],
Cell[CellGroupData[{
Cell[12757, 353, 172, 3, 26, "Input",ExpressionUUID->"15cb4456-6207-436f-9de3-4c980072fd4e",
 CellID->815185054],
Cell[12932, 358, 217, 5, 35, "Output",ExpressionUUID->"bb4c3a92-6ad6-40b7-b336-27dfe4f3c3a4",
 CellID->158370850]
}, Open  ]],
Cell[CellGroupData[{
Cell[13186, 368, 125, 2, 26, "Input",ExpressionUUID->"08d5edb4-d442-4ff7-9866-57d5dc3c4420",
 CellID->381330855],
Cell[13314, 372, 720, 17, 35, "Output",ExpressionUUID->"8a1c1615-1451-40f1-b61e-e0cb1f488fae",
 CellID->46014209]
}, Open  ]],
Cell[14049, 392, 144, 1, 38, "ExampleText",ExpressionUUID->"724f3247-4b3a-4d36-aa81-378ab1f24b28",
 CellID->549217134],
Cell[CellGroupData[{
Cell[14218, 397, 166, 3, 26, "Input",ExpressionUUID->"24e60057-2a68-422a-9aa2-f08731211716",
 CellID->132867000],
Cell[14387, 402, 216, 5, 35, "Output",ExpressionUUID->"5770b5b9-be6f-4450-967d-c30a390d50bf",
 CellID->340031220]
}, Open  ]],
Cell[CellGroupData[{
Cell[14640, 412, 125, 2, 26, "Input",ExpressionUUID->"87130da6-43ed-461f-9bfd-c91b70566275",
 CellID->160693972],
Cell[14768, 416, 740, 18, 35, "Output",ExpressionUUID->"1bdf1318-0a3e-4b1b-9350-a40c7a092886",
 CellID->676433893]
}, Open  ]],
Cell[15523, 437, 378, 10, 70, "ExampleText",ExpressionUUID->"591a1242-be06-4ad2-8832-420017129906",
 CellID->65440302],
Cell[CellGroupData[{
Cell[15926, 451, 265, 7, 70, "Input",ExpressionUUID->"6299cbd3-2252-4822-b6d0-c771554513f1",
 CellID->51731737],
Cell[16194, 460, 738, 18, 35, "Output",ExpressionUUID->"1fdbe2dd-9373-42d3-b92a-32274b094f35",
 CellID->625639463]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16981, 484, 300, 7, 70, "ExampleSection",ExpressionUUID->"c2c918c2-5192-4e38-a987-609993125c8d",
 CellID->1293636265],
Cell[CellGroupData[{
Cell[17306, 495, 322, 7, 70, "ExampleSubsection",ExpressionUUID->"4ede3105-619d-428e-a636-5f2dd4f32ab5",
 CellID->77239095],
Cell[17631, 504, 442, 10, 70, "ExampleText",ExpressionUUID->"301a0688-abd5-45d0-a2f1-048d2179691a",
 CellID->140850270],
Cell[CellGroupData[{
Cell[18098, 518, 266, 7, 70, "Input",ExpressionUUID->"dc8c5e57-a654-4e17-b567-3e5facb2e635",
 CellID->181431349],
Cell[18367, 527, 738, 18, 35, "Output",ExpressionUUID->"97f56be8-4bd5-4e8b-b5d2-4e7245885be6",
 CellID->489337095]
}, Open  ]],
Cell[19120, 548, 1242, 33, 70, "ExampleText",ExpressionUUID->"f1883a66-8d84-4535-a185-57ec1a512279",
 CellID->258831177],
Cell[CellGroupData[{
Cell[20387, 585, 265, 7, 70, "Input",ExpressionUUID->"a21ebb15-605f-430e-9705-55845ccf7063",
 CellID->86985097],
Cell[20655, 594, 1003, 24, 35, "Output",ExpressionUUID->"9c129752-4da2-4ad2-8ab7-10440dd13636",
 CellID->236496427]
}, Open  ]],
Cell[21673, 621, 1181, 32, 70, "ExampleText",ExpressionUUID->"9977f697-5836-4315-8d3c-34c0a4d260b8",
 CellID->378591257],
Cell[CellGroupData[{
Cell[22879, 657, 183, 4, 70, "Input",ExpressionUUID->"9642a7e3-5a93-4257-bf0f-53aeef3d884c",
 CellID->12560657],
Cell[23065, 663, 738, 18, 35, "Output",ExpressionUUID->"e694f088-244c-44bc-a71d-4936c773254d",
 CellID->258755158]
}, Open  ]],
Cell[CellGroupData[{
Cell[23840, 686, 184, 4, 70, "Input",ExpressionUUID->"3d55abc9-a320-4630-a2e8-ddf3dea55e21",
 CellID->652441307],
Cell[24027, 692, 998, 24, 35, "Output",ExpressionUUID->"eb1a64ba-0ce5-4021-9b69-c2edc4b9b4c0",
 CellID->233418334]
}, Open  ]],
Cell[25040, 719, 448, 11, 70, "ExampleText",ExpressionUUID->"d1865b0b-9120-4cba-803e-f95d6f1e7e88",
 CellID->275110610],
Cell[CellGroupData[{
Cell[25513, 734, 278, 7, 70, "Input",ExpressionUUID->"6e2ae160-1a82-436c-bc94-76a4b1cb24ee",
 CellID->367586701],
Cell[25794, 743, 340, 10, 56, "Output",ExpressionUUID->"292ee096-42c8-4193-b313-9357e4cdc927",
 CellID->55212792]
}, Open  ]],
Cell[CellGroupData[{
Cell[26171, 758, 172, 3, 70, "Input",ExpressionUUID->"afa0e0cb-0b8d-4003-92b6-2a306620c6ad",
 CellID->366086389],
Cell[26346, 763, 997, 24, 35, "Output",ExpressionUUID->"017c9c3f-d085-4241-bf42-3982d169daca",
 CellID->28161295]
}, Open  ]],
Cell[CellGroupData[{
Cell[27380, 792, 169, 3, 70, "Input",ExpressionUUID->"b10e9745-b7bb-4124-849c-24720075e5ee",
 CellID->106362550],
Cell[27552, 797, 2740, 52, 70, "Output",ExpressionUUID->"54f1cab1-cc0a-4577-90c9-2eaef75be8da",
 CellTags->"RasterizedOutput",
 CellID->278865371]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[30331, 854, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"d3a209c4-aad2-4630-9195-0935b3790ace"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30454, 859, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"29f3cd47-c5bd-492a-9246-38836aea371a",
 CellID->1255426704],
Cell[30717, 868, 2272, 61, 70, "SeeAlso",ExpressionUUID->"08eb07a3-bea1-4a06-8c4b-cf2c22145240",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[33026, 934, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"b9a25009-c67e-4a80-8fdc-41072c85d821",
 CellID->38303248],
Cell[33295, 943, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"e966ce50-8817-49e7-a921-9dd1ab73deab"],
Cell[33384, 945, 247, 6, 70, "MoreAbout",ExpressionUUID->"f81d4c5a-8d65-44b3-82a2-01080aca1ee1",
 CellID->472682509]
}, Open  ]],
Cell[33646, 954, 78, 0, 70, "FooterCell",ExpressionUUID->"f388cb4d-6766-4388-a900-1dfaeff5290f"]
}
]
*)

(* End of internal cache information *)

