(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     15803,        409]
NotebookOptionsPosition[     11038,        306]
NotebookOutlinePosition[     13642,        369]
CellTagsIndexPosition[     13557,        364]
WindowTitle->PartitionAssociation
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "67650c80-0dd6-43e9-b734-7f93922246ea"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"50d8a10a-ffb3-49f1-a0a5-8df26bbc52ea"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "f854b0f3-3841-4b20-9c9d-3592855b3f30"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"efb841e7-2d63-462b-bf32-d6aab00bc31a"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->
         False], {"\<\"DataAnalysis/ref/PartitionAssociation\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/PartitionAssociation"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
PartitionAssociation.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$38642], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/PartitionAssociation", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "74bf385b-caab-4e36-bf86-9203b897312e"]
    }], "AnchorBar",ExpressionUUID->"105bf4fa-b160-4a2d-9389-7c4ead5565ea"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"bfc45d88-cbb5-42d7-a2c0-3390f20b0fbc"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["PartitionAssociation", "ObjectName",ExpressionUUID->
  "388fda3a-599b-4193-9553-8889c353a495"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"fff551ff-5b3f-49f2-92a6-dca5425debfd"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "e73560cc-fe8a-4b42-bfba-d26b6931cac1"]
}], "ObjectNameGrid",ExpressionUUID->"0457fb68-8e7d-49bf-aff7-f8a28abdf9d7"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PartitionAssociation", "[", 
       RowBox[{
        StyleBox["assoc", "TI"], ",", 
        StyleBox["n", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "d827d84a-7fa9-4815-a1d0-7e734061293f"],
     "\[LineSeparator]partitions the association assoc into nonoverlapping \
subassociations of length n and returns a new association. "
    }],ExpressionUUID->"ee023690-9b61-40fb-a9c9-262f1f8f6ded"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PartitionAssociation", "[", 
       RowBox[{
        StyleBox["assoc", "TI"], ",", 
        StyleBox["n", "TI"], ",", 
        StyleBox["d", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "e923825b-031f-4315-87dd-d8eca86c8e46"],
     "\[LineSeparator]generates subassociations with offet d. "
    }],ExpressionUUID->"b5e1f94f-ebc9-4ef3-83ec-da8ac9f5efff"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PartitionAssociation", "[", 
       RowBox[{
        StyleBox["assoc", "TI"], ",", 
        StyleBox["n", "TI"], ",", 
        StyleBox["d", "TI"], ",", 
        StyleBox["i", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "5986a0ab-f1cd-454f-ada2-1905b2337252"],
     "\[LineSeparator]generates subassociations with offet d and the keys of \
the resulting association are generated from item number i of the partition \
group."
    }],ExpressionUUID->"90180438-908e-4397-9432-a0b1238d7f1c"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"50c30560-1677-43be-a388-058ce42d8e22"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"75014663-c09d-4bbe-9deb-7321dcb8ec74"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"0ceebb72-e858-4f42-83ed-4dc1d40a63a7"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"3a2adeb1-70b2-49a2-a63f-7d99e72055c8"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->465793973,ExpressionUUID->"9518b724-64c7-43f6-9e46-f4667377d809"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"a763ae42-b5ef-4cb4-8c21-8cb3b0033f2c"],

Cell[TextData[{
 "PartitionAssociation works for ",
 ButtonBox["Association",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Association"],
 " objects in a similar way as ",
 ButtonBox["Partition",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Partition"],
 " works for lists."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"815a3a41-228d-4091-a524-c55a2e65f2e3"],

Cell["\<\
By default, the key of the new items are taken from the first items in the \
sub-associations.\
\>", "Notes",
 CellID->113034147,ExpressionUUID->"5015eaed-9f4b-4b86-93d1-862cf1406caf"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"ad043166-10ea-4936-af3e-68afaf235bf1"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"97a9bb35-4670-4590-810a-9642d8659242"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "04fc3a95-5780-4ba4-b8f5-40311e19cd08"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->285858654,ExpressionUUID->"3d04a44b-bcdf-4cc6-9c21-8c6b456a8ce8"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "57316a20-2c86-4283-b88e-85e0885a46b9"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2691673,ExpressionUUID->"3421cdf8-4935-4724-82a5-84d27e7c5295"],

Cell["Partition an association:", "ExampleText",
 CellID->909856861,ExpressionUUID->"e0f1d901-be0a-4d74-ba2c-16352c211053"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PartitionAssociation", "[", 
  RowBox[{
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "x"}], ",", 
     RowBox[{"b", "\[Rule]", "y"}], ",", 
     RowBox[{"c", "\[Rule]", "z"}], ",", 
     RowBox[{"d", "\[Rule]", "1"}], ",", 
     RowBox[{"e", "\[Rule]", "2"}], ",", 
     RowBox[{"f", "\[Rule]", "3"}]}], "|>"}], ",", "2"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2232595,ExpressionUUID->"c304e5fd-5925-4bce-a5e7-e80a124713b8"],

Cell[BoxData[
 RowBox[{"\[LeftAssociation]", 
  RowBox[{
   RowBox[{"a", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"a", "\[Rule]", "x"}], ",", 
      RowBox[{"b", "\[Rule]", "y"}]}], "\[RightAssociation]"}]}], ",", 
   RowBox[{"c", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"c", "\[Rule]", "z"}], ",", 
      RowBox[{"d", "\[Rule]", "1"}]}], "\[RightAssociation]"}]}], ",", 
   RowBox[{"e", "\[Rule]", 
    RowBox[{"\[LeftAssociation]", 
     RowBox[{
      RowBox[{"e", "\[Rule]", "2"}], ",", 
      RowBox[{"f", "\[Rule]", "3"}]}], "\[RightAssociation]"}]}]}], 
  "\[RightAssociation]"}]], "Output",
 ImageSize->{413, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->182993499,ExpressionUUID->"688aa629-c863-4c8e-b413-808785704479"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"f5be2afe-1387-4336-8dd1-9bb479c7bb9e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"8a915e1e-b2ca-4227-8817-854d40a46f46"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"347d572e-da40-49ba-bec2-f1e2dc3ab400"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"582ac343-0673-4129-b2d7-7b578894762d"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->98564927,ExpressionUUID->"80d5bac5-c508-4303-9700-4c4647a189a4"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"aaafd54e-beb3-4ea7-930b-d639b81c484a"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PartitionAssociation",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 25.3784262}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "PartitionAssociation[assoc, n] partitions the association assoc into \
nonoverlapping subassociations of length n and returns a new association. \
PartitionAssociation[assoc, n, d] generates subassociations with offet d. \
PartitionAssociation[assoc, n, d, i] generates subassociations with offet d \
and the keys of the resulting association are generated from item number i of \
the partition group.", "synonyms" -> {}, "tabletags" -> {}, "title" -> 
    "PartitionAssociation", "titlemodifier" -> "", "windowtitle" -> 
    "PartitionAssociation", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/PartitionAssociation"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7939, 209, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3d04a44b-bcdf-4cc6-9c21-8c6b456a8ce8",
   CellTags->"PrimaryExamplesSection",
   CellID->285858654]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13359, 357}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[592, 21, 3543, 79, 55, "AnchorBarGrid",ExpressionUUID->"bfc45d88-cbb5-42d7-a2c0-3390f20b0fbc",
 CellID->1],
Cell[CellGroupData[{
Cell[4160, 104, 405, 9, 52, "ObjectNameGrid",ExpressionUUID->"0457fb68-8e7d-49bf-aff7-f8a28abdf9d7"],
Cell[4568, 115, 1697, 40, 297, "Usage",ExpressionUUID->"50c30560-1677-43be-a388-058ce42d8e22"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6302, 160, 855, 21, 37, "NotesSection",ExpressionUUID->"9518b724-64c7-43f6-9e46-f4667377d809",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->465793973],
Cell[7160, 183, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"a763ae42-b5ef-4cb4-8c21-8cb3b0033f2c"],
Cell[7249, 185, 367, 11, 70, "Notes",ExpressionUUID->"815a3a41-228d-4091-a524-c55a2e65f2e3",
 CellID->1067943069],
Cell[7619, 198, 194, 4, 70, "Notes",ExpressionUUID->"5015eaed-9f4b-4b86-93d1-862cf1406caf",
 CellID->113034147],
Cell[7816, 204, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"ad043166-10ea-4936-af3e-68afaf235bf1"]
}, Closed]],
Cell[CellGroupData[{
Cell[7939, 209, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"3d04a44b-bcdf-4cc6-9c21-8c6b456a8ce8",
 CellTags->"PrimaryExamplesSection",
 CellID->285858654],
Cell[CellGroupData[{
Cell[8399, 224, 306, 7, 29, "ExampleSection",ExpressionUUID->"3421cdf8-4935-4724-82a5-84d27e7c5295",
 CellID->2691673],
Cell[8708, 233, 123, 1, 38, "ExampleText",ExpressionUUID->"e0f1d901-be0a-4d74-ba2c-16352c211053",
 CellID->909856861],
Cell[CellGroupData[{
Cell[8856, 238, 475, 12, 26, "Input",ExpressionUUID->"c304e5fd-5925-4bce-a5e7-e80a124713b8",
 CellID->2232595],
Cell[9334, 252, 853, 23, 35, "Output",ExpressionUUID->"688aa629-c863-4c8e-b413-808785704479",
 CellID->182993499]
}, Open  ]]
}, Open  ]],
Cell[10214, 279, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"f5be2afe-1387-4336-8dd1-9bb479c7bb9e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10337, 284, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"347d572e-da40-49ba-bec2-f1e2dc3ab400",
 CellID->38303248],
Cell[10606, 293, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"582ac343-0673-4129-b2d7-7b578894762d"],
Cell[10695, 295, 246, 6, 24, "MoreAbout",ExpressionUUID->"80d5bac5-c508-4303-9700-4c4647a189a4",
 CellID->98564927]
}, Open  ]],
Cell[10956, 304, 78, 0, 70, "FooterCell",ExpressionUUID->"aaafd54e-beb3-4ea7-930b-d639b81c484a"]
}
]
*)

(* End of internal cache information *)

