(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     30355,        689]
NotebookOptionsPosition[     25531,        583]
NotebookOutlinePosition[     27795,        641]
CellTagsIndexPosition[     27710,        636]
WindowTitle->PhreeqcCloseLink
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "0a31f695-5213-4773-b7b7-6e055efc62b4"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"504815ee-d8cf-4bc0-ad4a-1761927245d3"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"PhreeqcOpenLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcOpenLink"], "\<\"PhreeqcLoadDB\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcLoadDB"], "\<\"PhreeqcRunString\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcRunString"], "\<\"PhreeqcRunFile\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/PhreeqcRunFile"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "cdcc7f20-3631-491a-ad91-955224b4c8ca"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"25cd223f-9ddb-4fac-a331-ed0bb36e155c"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "f5acba32-5873-4bb5-98f4-07422d9d8ad3"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"8c15758f-7c98-4eb0-aa59-46ce9fbc708d"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/PhreeqcCloseLink\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/PhreeqcCloseLink"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
PhreeqcCloseLink.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$39137], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/PhreeqcCloseLink", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "7595e253-da23-493f-a52f-a624006c722f"]
    }], "AnchorBar",ExpressionUUID->"131e48ea-7a7a-45e6-915b-63cf3194038f"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"764cdad1-d9d9-4a07-89d3-808fe2ba9f3c"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["PhreeqcCloseLink", "ObjectName",ExpressionUUID->
  "0932df1b-ca88-49f1-9bb9-d64501cca8db"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"af6275e3-e03b-445d-a4cb-7c1ca23ad92f"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "3a84c021-9eed-416a-9db0-9f9c988ecace"]
}], "ObjectNameGrid",ExpressionUUID->"12e21f68-6bf9-47ba-ac52-62f6f2597d61"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PhreeqcCloseLink", "[", 
       StyleBox["link", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "7d3db0d0-7b52-4576-9f89-e72e6e41f165"],
     "\[LineSeparator]closes a link to certain IPhreeqc link object."
    }],ExpressionUUID->"52bb8911-60be-441f-a4c5-a3543e8a9b76"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"f763cfa0-896d-4b7f-90f5-e31e1452b71b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"bc366f29-6c29-4959-930d-5c5dd2b3eab5"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"e9b4e40e-daae-4ec5-9793-a1c5dac22a8e"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"603d2630-f4f0-47e9-9e56-1696b799f438"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->417453335,ExpressionUUID->"5617dfa8-9714-4ddd-b9e4-2e844131e5ff"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"b2dbd390-156c-40ad-865b-5b5cffa9f2e0"],

Cell[TextData[{
 "PHREEQC is a computer program for speciation, batch-reaction, \
one-dimensional transport and inverse geochemical calculations which is being \
developed at the USGS: ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"]],
    "https://en.wikipedia.org/wiki/Monte_Carlo_method"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "3150f11b-09b9-430b-b07f-c03b41e64611"]
}], "Notes",
 CellID->86668955,ExpressionUUID->"3cbd01ef-3b78-4ff1-ad5c-709660caea7f"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"8925884e-d3b4-4c4c-854d-1b4e103a207e"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"834a240b-c2f4-4d8d-a3b2-a258a8811066"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "cdd44312-a7e7-4210-923b-3ff7b888980e"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->123764910,ExpressionUUID->"f5c2701f-2682-474a-ac51-f991be3f76b4"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "c4b416e1-3645-4de4-a9cb-058ca757a31f"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->194806697,ExpressionUUID->"6e372d4d-4bd2-41a0-8d61-863af6d587e5"],

Cell["Open a link to PHREEQC:", "ExampleText",
 CellID->163781936,ExpressionUUID->"2da5cf8b-2dc9-447a-8ed6-77f9f8ba34d0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"link", "=", 
  RowBox[{"PhreeqcOpenLink", "[", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->958059035,ExpressionUUID->"93b4f884-88ca-408a-97b2-525674d5a817"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["LinkObject",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}]], 
            GraphicsBox[{
              Thickness[0.038461538461538464`], {
               FaceForm[{
                 GrayLevel[0.93], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {
                1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}}, {{{
                25.499999999999996`, 2.5}, {25.499999999999996`, 
                1.3953100000000003`}, {24.604699999999998`, 
                0.49999999999999994`}, {23.5, 0.49999999999999994`}, {2.5, 
                0.49999999999999994`}, {1.3953100000000003`, 
                0.49999999999999994`}, {0.49999999999999994`, 
                1.3953100000000003`}, {0.49999999999999994`, 2.5}, {
                0.49999999999999994`, 23.5}, {0.49999999999999994`, 
                24.604699999999998`}, {1.3953100000000003`, 
                25.499999999999996`}, {2.5, 25.499999999999996`}, {23.5, 
                25.499999999999996`}, {24.604699999999998`, 
                25.499999999999996`}, {25.499999999999996`, 
                24.604699999999998`}, {25.499999999999996`, 23.5}, {
                25.499999999999996`, 2.5}}}]}, {
               FaceForm[{
                 RGBColor[0.5, 0.5, 0.5], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{20.5426, 
                19.116799999999998`}, {16.3832, 21.876199999999997`}, {
                16.3832, 20.021499999999996`}, {6.930469999999999, 
                20.021499999999996`}, {6.930469999999999, 
                18.212100000000003`}, {16.3832, 18.212100000000003`}, {
                16.3832, 16.357399999999995`}, {20.5426, 
                19.116799999999998`}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
                 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIRIGYC4sIjUTVcAooO8+XdOPpnKDg8YkwNXuen7JA2
W/qycJSgw5sbHEde31CB82PFhGf3n1V1aFVgVz0zR8oBrF9czWFHsFXE/9Wy
Dje0Dj4qiFWDy7cVLYptDVKH65/g6Xbu0HMNOB9sn4I23H6w+SWacD5De8DS
tDQNB7ldC/alskg4aD2+nx6joeFgnPFi/oMZog5B9vlaQa/UHao9k7f0KUhA
+D/UUPVbqML5jCB+oIpDzJHypGv8Eg4eGad3ikiqwM2T57H5LndPGW6eya7m
GzMvKcH1o4cXABG3d/Y=
                "]], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}}}, {{{14.163129999999999`, 
                4.337966249999999}, {16.96813, 4.337966249999999}, {16.96813, 
                5.047809999999999}, {14.98813, 5.047809999999999}, {14.98813, 
                8.29796625}, {14.163129999999999`, 8.29796625}, {
                14.163129999999999`, 4.337966249999999}}}]}}, Background -> 
             GrayLevel[0.93], Axes -> False, AspectRatio -> 1, 
             ImageSize -> {Automatic, 
               Dynamic[
               3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification]), ImageSizeCache -> {45., {0., 9.}}]}, Frame -> 
             True, FrameTicks -> None, FrameStyle -> Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Name: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  StyleBox[
                   PaneBox[
                   "\"\\\"C:\\\\Users\\\\Martin\\\\Dropbox\\\\Eclipse\\\\\
DataAnalysis\\\\DataAnalysis\\\\bin\\\\Windows-x86-64\\\\PhreeqMathematica.\
exe\\\"\"", ContentPadding -> False, FrameMargins -> 0, StripOnInput -> True, 
                    BaselinePosition -> Baseline, 
                    ImageSize -> {{1, 300}, Automatic}], LineBreakWithin -> 
                   False], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link mode: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["Listen", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}]], 
            GraphicsBox[{
              Thickness[0.038461538461538464`], {
               FaceForm[{
                 GrayLevel[0.93], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {
                1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}}, {{{
                25.499999999999996`, 2.5}, {25.499999999999996`, 
                1.3953100000000003`}, {24.604699999999998`, 
                0.49999999999999994`}, {23.5, 0.49999999999999994`}, {2.5, 
                0.49999999999999994`}, {1.3953100000000003`, 
                0.49999999999999994`}, {0.49999999999999994`, 
                1.3953100000000003`}, {0.49999999999999994`, 2.5}, {
                0.49999999999999994`, 23.5}, {0.49999999999999994`, 
                24.604699999999998`}, {1.3953100000000003`, 
                25.499999999999996`}, {2.5, 25.499999999999996`}, {23.5, 
                25.499999999999996`}, {24.604699999999998`, 
                25.499999999999996`}, {25.499999999999996`, 
                24.604699999999998`}, {25.499999999999996`, 23.5}, {
                25.499999999999996`, 2.5}}}]}, {
               FaceForm[{
                 RGBColor[0.5, 0.5, 0.5], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{20.5426, 
                19.116799999999998`}, {16.3832, 21.876199999999997`}, {
                16.3832, 20.021499999999996`}, {6.930469999999999, 
                20.021499999999996`}, {6.930469999999999, 
                18.212100000000003`}, {16.3832, 18.212100000000003`}, {
                16.3832, 16.357399999999995`}, {20.5426, 
                19.116799999999998`}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
                 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIRIGYC4sIjUTVcAooO8+XdOPpnKDg8YkwNXuen7JA2
W/qycJSgw5sbHEde31CB82PFhGf3n1V1aFVgVz0zR8oBrF9czWFHsFXE/9Wy
Dje0Dj4qiFWDy7cVLYptDVKH65/g6Xbu0HMNOB9sn4I23H6w+SWacD5De8DS
tDQNB7ldC/alskg4aD2+nx6joeFgnPFi/oMZog5B9vlaQa/UHao9k7f0KUhA
+D/UUPVbqML5jCB+oIpDzJHypGv8Eg4eGad3ikiqwM2T57H5LndPGW6eya7m
GzMvKcH1o4cXABG3d/Y=
                "]], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}}}, {{{14.163129999999999`, 
                4.337966249999999}, {16.96813, 4.337966249999999}, {16.96813, 
                5.047809999999999}, {14.98813, 5.047809999999999}, {14.98813, 
                8.29796625}, {14.163129999999999`, 8.29796625}, {
                14.163129999999999`, 4.337966249999999}}}]}}, Background -> 
             GrayLevel[0.93], Axes -> False, AspectRatio -> 1, 
             ImageSize -> {Automatic, 
               Dynamic[
               3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification]), ImageSizeCache -> {45., {0., 9.}}]}, Frame -> 
             True, FrameTicks -> None, FrameStyle -> Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Name: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  PaneBox[
                  "\"\\\"C:\\\\Users\\\\Martin\\\\Dropbox\\\\Eclipse\\\\\
DataAnalysis\\\\DataAnalysis\\\\bin\\\\Windows-x86-64\\\\PhreeqMathematica.\
exe\\\"\"", ImageSize -> {{1, 500}, Automatic}, BaselinePosition -> Baseline, 
                   ContentPadding -> False, FrameMargins -> 0, StripOnInput -> 
                   True], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link mode: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["Listen", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link protocol: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"SharedMemory\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel",
     DisplayFunction->(
      ButtonBox[#, Active -> False, Alignment -> Left, 
       Appearance -> {
        "Default" -> 
         FrontEnd`FileName[{"Typeset", "SummaryBox"}, "Panel.9.png"]}, 
       FrameMargins -> 7, BaseStyle -> {}, 
       DefaultBaseStyle -> {"Panel", Background -> None}, BaselinePosition -> 
       Baseline]& )],
    DynamicModuleValues:>{}], "]"}],
  LinkObject[
  "\"C:\\Users\\Martin\\Dropbox\\Eclipse\\DataAnalysis\\DataAnalysis\\bin\\\
Windows-x86-64\\PhreeqMathematica.exe\"", 347, 12],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 ImageSize->{499, 54},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->448874885,ExpressionUUID->"ba800b4f-27d5-4f9b-aed9-943afffa1ad9"]
}, Open  ]],

Cell["Close the link again:", "ExampleText",
 CellID->118606300,ExpressionUUID->"bc1b47ee-c5b4-431a-9e62-1521aa6d89c9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"PhreeqcCloseLink", "[", "link", "]"}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->827052696,ExpressionUUID->"806d6994-a846-4ec6-8165-69260318842f"]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"a530cf16-1345-404a-bb79-12b73a069127"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"7760fe4b-c3b8-45b6-a1fd-59553156ca04"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"c14ee687-10e4-4971-8303-7686870b127f"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcOpenLink"]],"paclet:DataAnalysis/ref/PhreeqcOpenLink"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"4f17094d-5293-416c-b6cb-a48c4cb5c765"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcLoadDB"]],"paclet:DataAnalysis/ref/PhreeqcLoadDB"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"a25ee6c1-d2e4-4843-8513-c4baca3ba43c"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunString"]],"paclet:DataAnalysis/ref/PhreeqcRunString"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"52d9d6fb-c60e-4689-b662-f15f4b191431"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunFile"]],"paclet:DataAnalysis/ref/PhreeqcRunFile"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"51772efd-b7ee-4e4c-9071-21f9e5c7f0f9"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"ba9e4db8-bc27-4d31-894e-84b4550a096f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"e55d537d-2f33-4b2b-b52b-b31821d4bfde"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"bd41f792-0bd3-4fa3-89b2-1f308c175db2"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"4a62f64f-f17d-413b-a9a4-3d64e5dba9e2"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->12873933,ExpressionUUID->"8e7f4179-7569-4488-b579-34a9bfa3afa1"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"11d7914b-97fb-4f9f-a70a-4308d3063643"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PhreeqcCloseLink",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 26.8673520}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`Phreeqc`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "PhreeqcCloseLink[link] closes a link to certain IPhreeqc link object.", 
    "synonyms" -> {}, "tabletags" -> {}, "title" -> "PhreeqcCloseLink", 
    "titlemodifier" -> "", "windowtitle" -> "PhreeqcCloseLink", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/PhreeqcCloseLink"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7715, 197, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"f5c2701f-2682-474a-ac51-f991be3f76b4",
   CellTags->"PrimaryExamplesSection",
   CellID->123764910]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 27512, 629}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[588, 21, 4478, 99, 55, "AnchorBarGrid",ExpressionUUID->"764cdad1-d9d9-4a07-89d3-808fe2ba9f3c",
 CellID->1],
Cell[CellGroupData[{
Cell[5091, 124, 401, 9, 52, "ObjectNameGrid",ExpressionUUID->"12e21f68-6bf9-47ba-ac52-62f6f2597d61"],
Cell[5495, 135, 568, 13, 109, "Usage",ExpressionUUID->"f763cfa0-896d-4b7f-90f5-e31e1452b71b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6100, 153, 855, 21, 37, "NotesSection",ExpressionUUID->"5617dfa8-9714-4ddd-b9e4-2e844131e5ff",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->417453335],
Cell[6958, 176, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"b2dbd390-156c-40ad-865b-5b5cffa9f2e0"],
Cell[7047, 178, 542, 12, 70, "Notes",ExpressionUUID->"3cbd01ef-3b78-4ff1-ad5c-709660caea7f",
 CellID->86668955],
Cell[7592, 192, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"8925884e-d3b4-4c4c-854d-1b4e103a207e"]
}, Closed]],
Cell[CellGroupData[{
Cell[7715, 197, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"f5c2701f-2682-474a-ac51-f991be3f76b4",
 CellTags->"PrimaryExamplesSection",
 CellID->123764910],
Cell[CellGroupData[{
Cell[8175, 212, 308, 7, 29, "ExampleSection",ExpressionUUID->"6e372d4d-4bd2-41a0-8d61-863af6d587e5",
 CellID->194806697],
Cell[8486, 221, 121, 1, 38, "ExampleText",ExpressionUUID->"2da5cf8b-2dc9-447a-8ed6-77f9f8ba34d0",
 CellID->163781936],
Cell[CellGroupData[{
Cell[8632, 226, 187, 4, 26, "Input",ExpressionUUID->"93b4f884-88ca-408a-97b2-525674d5a817",
 CellID->958059035],
Cell[8822, 232, 13732, 259, 75, "Output",ExpressionUUID->"ba800b4f-27d5-4f9b-aed9-943afffa1ad9",
 CellID->448874885]
}, Open  ]],
Cell[22569, 494, 119, 1, 38, "ExampleText",ExpressionUUID->"bc1b47ee-c5b4-431a-9e62-1521aa6d89c9",
 CellID->118606300],
Cell[22691, 497, 188, 4, 26, "Input",ExpressionUUID->"806d6994-a846-4ec6-8165-69260318842f",
 CellID->827052696]
}, Open  ]],
Cell[22894, 504, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"a530cf16-1345-404a-bb79-12b73a069127"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23017, 509, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"c14ee687-10e4-4971-8303-7686870b127f",
 CellID->1255426704],
Cell[23280, 518, 1513, 38, 24, "SeeAlso",ExpressionUUID->"ba9e4db8-bc27-4d31-894e-84b4550a096f",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[24830, 561, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"bd41f792-0bd3-4fa3-89b2-1f308c175db2",
 CellID->38303248],
Cell[25099, 570, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"4a62f64f-f17d-413b-a9a4-3d64e5dba9e2"],
Cell[25188, 572, 246, 6, 70, "MoreAbout",ExpressionUUID->"8e7f4179-7569-4488-b579-34a9bfa3afa1",
 CellID->12873933]
}, Open  ]],
Cell[25449, 581, 78, 0, 70, "FooterCell",ExpressionUUID->"11d7914b-97fb-4f9f-a70a-4308d3063643"]
}
]
*)

(* End of internal cache information *)

