(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     18368,        475]
NotebookOptionsPosition[     13477,        368]
NotebookOutlinePosition[     15816,        427]
CellTagsIndexPosition[     15731,        422]
WindowTitle->PhreeqcLoadDB
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "30086ac9-7fd7-47bc-98de-3ac730283b67"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"d2c384a2-3cb6-4f35-be4b-cacc2ec6761d"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"PhreeqcOpenLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcOpenLink"], "\<\"PhreeqcCloseLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcCloseLink"], \
"\<\"PhreeqcRunString\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcRunString"], "\<\"PhreeqcRunFile\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/PhreeqcRunFile"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "81c99b26-95c5-4801-9658-e9f05362754a"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"0ed09927-92af-437b-a2de-d7f4d4484fbe"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "04d91caf-f52f-44dc-a95a-884a34b8f14c"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"fba6abc0-bf3c-424d-9c70-e9b785576a30"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/PhreeqcLoadDB\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/PhreeqcLoadDB"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
PhreeqcLoadDB.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$39668], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/PhreeqcLoadDB", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "63700810-0324-4946-95dd-a6813790b4ca"]
    }], "AnchorBar",ExpressionUUID->"9aaae596-6a92-4460-ad8a-066e0388131c"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"2396df48-b50c-4874-bab1-808401be954a"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["PhreeqcLoadDB", "ObjectName",ExpressionUUID->
  "a3feaefe-c0d2-41ba-9fdf-cdc1823a5bc9"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"b0f8d566-4384-4f7d-a1cf-84529d652b93"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "3dc03229-c314-42a9-b168-fd3858bda89c"]
}], "ObjectNameGrid",ExpressionUUID->"657108cc-3478-428d-973c-2fe9f9406cfa"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PhreeqcLoadDB", "[", 
       RowBox[{
        StyleBox["link", "TI"], ",", 
        StyleBox["file", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "32430997-8e49-4627-90a5-6044b8902e5d"],
     "\[LineSeparator]sets a new database for certain IPhreeqc link object."
    }],ExpressionUUID->"0ff42083-7781-488f-b027-fb9f6d04c0e0"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PhreeqcLoadDB", "[", 
       StyleBox["file", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "6f88df5b-dbe8-4137-badc-8aade04a8dd6"],
     "\[LineSeparator]set a new database for the default IPhreeeqc link \
object."
    }],ExpressionUUID->"ff98ac44-db66-4380-bbce-78e8aa27d9fe"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"3d6e5fea-9d08-49d9-a622-bda6266677ca"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"bf1d8c70-ab60-4c0c-be78-2604699ac51e"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"7db7cecb-ab7e-4aac-a1fa-300f1858d69d"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"61238573-9168-4829-8d6e-1e6f33683caf"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->5543853,ExpressionUUID->"f00f638a-766c-46dc-bd9f-bf16331fd6cd"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"dc31cc93-00fa-41a3-ab65-65c7675ef43b"],

Cell[TextData[{
 "PHREEQC is a computer program for speciation, batch-reaction, \
one-dimensional transport and inverse geochemical calculations which is being \
developed at the USGS: ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"]],
    "https://en.wikipedia.org/wiki/Monte_Carlo_method"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "97a770f4-a1ba-4786-b2cf-f95f564450ee"]
}], "Notes",
 CellID->86668955,ExpressionUUID->"ed93d96d-560d-4068-a86f-59063488d119"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcLoadDB"]],"paclet:DataAnalysis/ref/PhreeqcLoadDB"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "e7115f10-7b4a-4a91-b2c5-c730eddc34a7"],
 " loads a database file which is used when scripts are called later on using \
",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunString"]],"paclet:DataAnalysis/ref/PhreeqcRunString"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "ebcdd56f-fdf6-435f-9d10-ce7496815577"],
 " and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunFile"]],"paclet:DataAnalysis/ref/PhreeqcRunFile"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "654c721a-6949-4602-a070-30c3f8b36f5f"],
 "."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"11a74ac2-b34f-46ff-8562-eb970b182d06"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcLoadDB"]],"paclet:DataAnalysis/ref/PhreeqcLoadDB"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "870dc2e1-ad3e-4fa6-90dd-64aaf4e343cc"],
 " returns 0 if the database was successfully loaded."
}], "Notes",
 CellID->310809577,ExpressionUUID->"43b6bafb-5c61-40a6-80b5-853d57dea49a"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"37ddd92f-a518-4735-aaae-095efb1c6c1a"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"94c7c5ad-5437-4ae1-9b3e-8d8fb6c2f37a"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "ebaf8562-d268-41aa-86f2-3440fc57a7c2"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->155118828,ExpressionUUID->"6f460805-b703-491b-beb2-677b23649e46"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "bf015dae-4470-46d5-a3e3-8d4d334aaea4"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->342316372,ExpressionUUID->"c46f5cbd-2f9c-480e-9df9-84c4cf241576"],

Cell["Load the core10.dat database for the default PHREEQC link:", \
"ExampleText",
 CellID->163781936,ExpressionUUID->"0c99f0f3-f4b8-4448-8a04-e9862aec15b5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PhreeqcLoadDB", "[", 
  "\"\<C:\\\\phreeqc\\\\database\\\\core10.dat\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->958059035,ExpressionUUID->"21c441f8-939b-4234-bd7b-39532694008a"],

Cell[BoxData["0"], "Output",
 ImageSize->{11, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->194090895,ExpressionUUID->"9d6bac62-a200-4217-a30d-76efa2a10a4c"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"0d620163-1601-480d-bdcc-b70886088a64"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"07b34f69-12bd-4b08-a515-9d81a4b9e5ce"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"88a3adfe-2e54-4440-986c-eb9d34b04cba"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcOpenLink"]],"paclet:DataAnalysis/ref/PhreeqcOpenLink"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"b0590968-5d88-4ce4-b9d1-50ab0cd6bf44"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcCloseLink"]],"paclet:DataAnalysis/ref/PhreeqcCloseLink"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"88e98c83-ef84-4d69-b27f-22ca398a10bb"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunString"]],"paclet:DataAnalysis/ref/PhreeqcRunString"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"202aaa4a-47e8-4f5e-8829-fa6ef6a68b7e"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunFile"]],"paclet:DataAnalysis/ref/PhreeqcRunFile"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"71b7ec48-762f-4754-951c-fb1331296221"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"650fabb2-aedb-4419-ac37-c0f745018807"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"b33aa04d-72ab-489f-a0c2-3d59d7533fa5"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"96e25c91-67bc-4de9-a51c-2719fde89309"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"6969db8f-e9ef-402c-b9f8-20bcc6270fad"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->348903224,ExpressionUUID->"8c0879fb-62bb-4e99-bbf3-8007613f4975"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"0cc9d57d-b457-4c50-a335-3a26a74d6c73"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PhreeqcLoadDB",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 28.4114575}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`Phreeqc`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "PhreeqcLoadDB[link, file] sets a new database for certain IPhreeqc link \
object. PhreeqcLoadDB[file] set a new database for the default IPhreeeqc link \
object.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "PhreeqcLoadDB", 
    "titlemodifier" -> "", "windowtitle" -> "PhreeqcLoadDB", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/PhreeqcLoadDB"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9423, 244, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"6f460805-b703-491b-beb2-677b23649e46",
   CellTags->"PrimaryExamplesSection",
   CellID->155118828]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15533, 415}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 4466, 99, 55, "AnchorBarGrid",ExpressionUUID->"2396df48-b50c-4874-bab1-808401be954a",
 CellID->1],
Cell[CellGroupData[{
Cell[5076, 124, 398, 9, 52, "ObjectNameGrid",ExpressionUUID->"657108cc-3478-428d-973c-2fe9f9406cfa"],
Cell[5477, 135, 982, 23, 182, "Usage",ExpressionUUID->"3d6e5fea-9d08-49d9-a622-bda6266677ca"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6496, 163, 853, 21, 37, "NotesSection",ExpressionUUID->"f00f638a-766c-46dc-bd9f-bf16331fd6cd",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->5543853],
Cell[7352, 186, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"dc31cc93-00fa-41a3-ab65-65c7675ef43b"],
Cell[7441, 188, 542, 12, 70, "Notes",ExpressionUUID->"ed93d96d-560d-4068-a86f-59063488d119",
 CellID->86668955],
Cell[7986, 202, 915, 24, 70, "Notes",ExpressionUUID->"11a74ac2-b34f-46ff-8562-eb970b182d06",
 CellID->1067943069],
Cell[8904, 228, 393, 9, 70, "Notes",ExpressionUUID->"43b6bafb-5c61-40a6-80b5-853d57dea49a",
 CellID->310809577],
Cell[9300, 239, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"37ddd92f-a518-4735-aaae-095efb1c6c1a"]
}, Closed]],
Cell[CellGroupData[{
Cell[9423, 244, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"6f460805-b703-491b-beb2-677b23649e46",
 CellTags->"PrimaryExamplesSection",
 CellID->155118828],
Cell[CellGroupData[{
Cell[9883, 259, 308, 7, 29, "ExampleSection",ExpressionUUID->"c46f5cbd-2f9c-480e-9df9-84c4cf241576",
 CellID->342316372],
Cell[10194, 268, 158, 2, 38, "ExampleText",ExpressionUUID->"0c99f0f3-f4b8-4448-8a04-e9862aec15b5",
 CellID->163781936],
Cell[CellGroupData[{
Cell[10377, 274, 213, 4, 26, "Input",ExpressionUUID->"21c441f8-939b-4234-bd7b-39532694008a",
 CellID->958059035],
Cell[10593, 280, 213, 5, 35, "Output",ExpressionUUID->"9d6bac62-a200-4217-a30d-76efa2a10a4c",
 CellID->194090895]
}, Open  ]]
}, Open  ]],
Cell[10833, 289, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"0d620163-1601-480d-bdcc-b70886088a64"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10956, 294, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"88a3adfe-2e54-4440-986c-eb9d34b04cba",
 CellID->1255426704],
Cell[11219, 303, 1519, 38, 24, "SeeAlso",ExpressionUUID->"650fabb2-aedb-4419-ac37-c0f745018807",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12775, 346, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"96e25c91-67bc-4de9-a51c-2719fde89309",
 CellID->38303248],
Cell[13044, 355, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"6969db8f-e9ef-402c-b9f8-20bcc6270fad"],
Cell[13133, 357, 247, 6, 24, "MoreAbout",ExpressionUUID->"8c0879fb-62bb-4e99-bbf3-8007613f4975",
 CellID->348903224]
}, Open  ]],
Cell[13395, 366, 78, 0, 70, "FooterCell",ExpressionUUID->"0cc9d57d-b457-4c50-a335-3a26a74d6c73"]
}
]
*)

(* End of internal cache information *)

