(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     30626,        696]
NotebookOptionsPosition[     25810,        590]
NotebookOutlinePosition[     28073,        648]
CellTagsIndexPosition[     27988,        643]
WindowTitle->PhreeqcOpenLink
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "2c9efa8c-94d6-44bb-b47b-8e084c53e47d"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"ade2caab-3af8-4e71-95d8-795f17019372"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"PhreeqcCloseLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcCloseLink"], "\<\"PhreeqcLoadDB\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcLoadDB"], "\<\"PhreeqcRunString\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcRunString"], "\<\"PhreeqcRunFile\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/PhreeqcRunFile"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "659bc2ec-4528-4d22-ac56-6d624a5e87c8"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"08b281af-bd9c-4416-b405-451b85d802fe"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "551490c5-2ffa-41e7-8dbb-1f45a7a18515"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"52fcee02-babd-4f3c-88ff-d1d951593f47"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/PhreeqcOpenLink\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/PhreeqcOpenLink"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
PhreeqcOpenLink.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$40197], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/PhreeqcOpenLink", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "dd021ab7-eb75-4ccd-831a-074432724063"]
    }], "AnchorBar",ExpressionUUID->"2a12b987-9a8b-4c28-a0be-78cc42784278"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"32fd0976-24ae-4862-b59a-addf73a3fb6c"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["PhreeqcOpenLink", "ObjectName",ExpressionUUID->
  "0bd3c9a5-2868-434f-bd34-0c1301a4b873"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"2bfc7d06-60fb-4ee4-bb9f-dccf2907f7e3"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "2862541e-7bb0-4a28-b7c1-3d8a84306040"]
}], "ObjectNameGrid",ExpressionUUID->"9d660db3-45e3-45de-97f0-691f25c5ca25"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PhreeqcOpenLink", "[", "]"}]], "InlineFormula",ExpressionUUID->
      "334842ce-2edc-4b3e-b932-d88e6419d50b"],
     "\[LineSeparator]opens a new link to IPhreeqc and returns the link \
object."
    }],ExpressionUUID->"8f8d15f8-6731-4a74-9748-3c2b5c6d3d1b"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"d541f626-30c8-4bcb-9d2a-8346177464a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"191fe07c-3af2-49d7-9d35-51023bd9dbec"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"2dc47020-b599-4de5-be86-3ea29d9231de"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"ef050e93-a145-4f70-b67a-d26fb9fa6afd"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->257399053,ExpressionUUID->"c92bfab0-540d-4845-8a9a-c04ed6832539"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"acbd6d3c-3583-42f7-a95e-940f2060a269"],

Cell[TextData[{
 "PHREEQC is a computer program for speciation, batch-reaction, \
one-dimensional transport and inverse geochemical calculations which is being \
developed at the USGS:  ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"]],
    "https://en.wikipedia.org/wiki/Monte_Carlo_method"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "470ca9bb-60c5-4d96-b7d1-114a597ab301"]
}], "Notes",
 CellID->1067943069,ExpressionUUID->"059d4a2f-e1c1-485d-b3bb-a5d6de58c7d2"],

Cell[TextData[{
 ButtonBox["PhreeqcOpenLink",
  BaseStyle->"Link",
  ButtonData->"paclet:DataAnalysis/ref/PhreeqcOpenLink"],
 " installs an instance of a custom IPhreeqc library which can then be used \
to execute PHREEQC scripts from within Mathematica."
}], "Notes",
 CellID->81743113,ExpressionUUID->"9accf025-11b2-4983-9551-2b8a158ef8cc"],

Cell["\<\
Currently, thist custom, compliled IPhreeqc library is only available for \
Windows platforms, but the source code is available for compilation on other \
systems.\
\>", "Notes",
 CellID->336872752,ExpressionUUID->"aedf3c9b-eadc-447e-bfd4-b270120df3b4"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"cadc53f1-5cef-4879-ab18-69c0dcaf3757"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"0168722b-c3c9-4fec-81ae-812a9be56a20"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "bc689fc4-03bc-4c46-a576-9bfd78560d00"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->401120317,ExpressionUUID->"0abdc26b-5d68-44b1-8615-2959d97cc753"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "26a0e591-2e67-4b9c-9de9-7d6d3c58d8b0"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->237287921,ExpressionUUID->"0d5915f2-62cc-4059-b3b1-c376239bdd79"],

Cell["Open a link to PHREEQC:", "ExampleText",
 CellID->163781936,ExpressionUUID->"45941a86-72fe-4b49-914d-f961a9f817c5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"link", "=", 
  RowBox[{"PhreeqcOpenLink", "[", "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->958059035,ExpressionUUID->"7b432547-5a17-44b9-8700-81ba84c2df5e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   TagBox["LinkObject",
    "SummaryHead"], "[", 
   DynamicModuleBox[{Typeset`open$$ = False, Typeset`embedState$$ = "Ready"}, 
    TemplateBox[{PaneSelectorBox[{False -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquarePlusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = True), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}]], 
            GraphicsBox[{
              Thickness[0.038461538461538464`], {
               FaceForm[{
                 GrayLevel[0.93], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {
                1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}}, {{{
                25.499999999999996`, 2.5}, {25.499999999999996`, 
                1.3953100000000003`}, {24.604699999999998`, 
                0.49999999999999994`}, {23.5, 0.49999999999999994`}, {2.5, 
                0.49999999999999994`}, {1.3953100000000003`, 
                0.49999999999999994`}, {0.49999999999999994`, 
                1.3953100000000003`}, {0.49999999999999994`, 2.5}, {
                0.49999999999999994`, 23.5}, {0.49999999999999994`, 
                24.604699999999998`}, {1.3953100000000003`, 
                25.499999999999996`}, {2.5, 25.499999999999996`}, {23.5, 
                25.499999999999996`}, {24.604699999999998`, 
                25.499999999999996`}, {25.499999999999996`, 
                24.604699999999998`}, {25.499999999999996`, 23.5}, {
                25.499999999999996`, 2.5}}}]}, {
               FaceForm[{
                 RGBColor[0.5, 0.5, 0.5], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{20.5426, 
                19.116799999999998`}, {16.3832, 21.876199999999997`}, {
                16.3832, 20.021499999999996`}, {6.930469999999999, 
                20.021499999999996`}, {6.930469999999999, 
                18.212100000000003`}, {16.3832, 18.212100000000003`}, {
                16.3832, 16.357399999999995`}, {20.5426, 
                19.116799999999998`}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
                 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIRIGYC4sIjUTVcAooO8+XdOPpnKDg8YkwNXuen7JA2
W/qycJSgw5sbHEde31CB82PFhGf3n1V1aFVgVz0zR8oBrF9czWFHsFXE/9Wy
Dje0Dj4qiFWDy7cVLYptDVKH65/g6Xbu0HMNOB9sn4I23H6w+SWacD5De8DS
tDQNB7ldC/alskg4aD2+nx6joeFgnPFi/oMZog5B9vlaQa/UHao9k7f0KUhA
+D/UUPVbqML5jCB+oIpDzJHypGv8Eg4eGad3ikiqwM2T57H5LndPGW6eya7m
GzMvKcH1o4cXABG3d/Y=
                "]], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}}}, {{{14.163129999999999`, 
                4.337966249999999}, {16.96813, 4.337966249999999}, {16.96813, 
                5.047809999999999}, {14.98813, 5.047809999999999}, {14.98813, 
                8.29796625}, {14.163129999999999`, 8.29796625}, {
                14.163129999999999`, 4.337966249999999}}}]}}, Background -> 
             GrayLevel[0.93], Axes -> False, AspectRatio -> 1, 
             ImageSize -> {Automatic, 
               Dynamic[
               3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification]), ImageSizeCache -> {45., {0., 9.}}]}, Frame -> 
             True, FrameTicks -> None, FrameStyle -> Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Name: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  StyleBox[
                   PaneBox[
                   "\"\\\"C:\\\\Users\\\\Martin\\\\Dropbox\\\\Eclipse\\\\\
DataAnalysis\\\\DataAnalysis\\\\bin\\\\Windows-x86-64\\\\PhreeqMathematica.\
exe\\\"\"", ContentPadding -> False, FrameMargins -> 0, StripOnInput -> True, 
                    BaselinePosition -> Baseline, 
                    ImageSize -> {{1, 300}, Automatic}], LineBreakWithin -> 
                   False], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link mode: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["Listen", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}], True -> GridBox[{{
            PaneBox[
             ButtonBox[
              DynamicBox[
               FEPrivate`FrontEndResource[
               "FEBitmaps", "SquareMinusIconMedium"]], 
              ButtonFunction :> (Typeset`open$$ = False), Appearance -> None, 
              Evaluator -> Automatic, Method -> "Preemptive"], 
             Alignment -> {Center, Center}, ImageSize -> 
             Dynamic[{
               Automatic, 
                3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification])}]], 
            GraphicsBox[{
              Thickness[0.038461538461538464`], {
               FaceForm[{
                 GrayLevel[0.93], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{1, 4, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}, {
                1, 3, 3}, {0, 1, 0}, {1, 3, 3}, {0, 1, 0}}}, {{{
                25.499999999999996`, 2.5}, {25.499999999999996`, 
                1.3953100000000003`}, {24.604699999999998`, 
                0.49999999999999994`}, {23.5, 0.49999999999999994`}, {2.5, 
                0.49999999999999994`}, {1.3953100000000003`, 
                0.49999999999999994`}, {0.49999999999999994`, 
                1.3953100000000003`}, {0.49999999999999994`, 2.5}, {
                0.49999999999999994`, 23.5}, {0.49999999999999994`, 
                24.604699999999998`}, {1.3953100000000003`, 
                25.499999999999996`}, {2.5, 25.499999999999996`}, {23.5, 
                25.499999999999996`}, {24.604699999999998`, 
                25.499999999999996`}, {25.499999999999996`, 
                24.604699999999998`}, {25.499999999999996`, 23.5}, {
                25.499999999999996`, 2.5}}}]}, {
               FaceForm[{
                 RGBColor[0.5, 0.5, 0.5], 
                 Opacity[1.]}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{20.5426, 
                19.116799999999998`}, {16.3832, 21.876199999999997`}, {
                16.3832, 20.021499999999996`}, {6.930469999999999, 
                20.021499999999996`}, {6.930469999999999, 
                18.212100000000003`}, {16.3832, 18.212100000000003`}, {
                16.3832, 16.357399999999995`}, {20.5426, 
                19.116799999999998`}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{5.30508, 13.8391}, {
                9.46445, 11.079700000000003`}, {9.46445, 
                12.933999999999997`}, {18.917199999999998`, 
                12.933999999999997`}, {18.917199999999998`, 14.7438}, {
                9.46445, 14.7438}, {9.46445, 16.598}, {5.30508, 13.8391}}}], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {0,
                 1, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}}}, CompressedData["
1:eJxTTMoPSmVmYGBgBGIRIGYC4sIjUTVcAooO8+XdOPpnKDg8YkwNXuen7JA2
W/qycJSgw5sbHEde31CB82PFhGf3n1V1aFVgVz0zR8oBrF9czWFHsFXE/9Wy
Dje0Dj4qiFWDy7cVLYptDVKH65/g6Xbu0HMNOB9sn4I23H6w+SWacD5De8DS
tDQNB7ldC/alskg4aD2+nx6joeFgnPFi/oMZog5B9vlaQa/UHao9k7f0KUhA
+D/UUPVbqML5jCB+oIpDzJHypGv8Eg4eGad3ikiqwM2T57H5LndPGW6eya7m
GzMvKcH1o4cXABG3d/Y=
                "]], 
               
               FilledCurveBox[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 0}, {
                0, 1, 0}, {0, 1, 0}}}, {{{14.163129999999999`, 
                4.337966249999999}, {16.96813, 4.337966249999999}, {16.96813, 
                5.047809999999999}, {14.98813, 5.047809999999999}, {14.98813, 
                8.29796625}, {14.163129999999999`, 8.29796625}, {
                14.163129999999999`, 4.337966249999999}}}]}}, Background -> 
             GrayLevel[0.93], Axes -> False, AspectRatio -> 1, 
             ImageSize -> {Automatic, 
               Dynamic[
               3.5 (CurrentValue["FontCapHeight"]/AbsoluteCurrentValue[
                 Magnification]), ImageSizeCache -> {45., {0., 9.}}]}, Frame -> 
             True, FrameTicks -> None, FrameStyle -> Directive[
               Thickness[Tiny], 
               GrayLevel[0.7]]], 
            GridBox[{{
               RowBox[{
                 TagBox["\"Name: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox[
                  PaneBox[
                  "\"\\\"C:\\\\Users\\\\Martin\\\\Dropbox\\\\Eclipse\\\\\
DataAnalysis\\\\DataAnalysis\\\\bin\\\\Windows-x86-64\\\\PhreeqMathematica.\
exe\\\"\"", ImageSize -> {{1, 500}, Automatic}, BaselinePosition -> Baseline, 
                   ContentPadding -> False, FrameMargins -> 0, StripOnInput -> 
                   True], "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link mode: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["Listen", "SummaryItem"]}]}, {
               RowBox[{
                 TagBox["\"Link protocol: \"", "SummaryItemAnnotation"], 
                 "\[InvisibleSpace]", 
                 TagBox["\"SharedMemory\"", "SummaryItem"]}]}}, 
             GridBoxAlignment -> {
              "Columns" -> {{Left}}, "Rows" -> {{Automatic}}}, AutoDelete -> 
             False, GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{2}}, "Rows" -> {{Automatic}}},
              BaseStyle -> {
              ShowStringCharacters -> False, NumberMarks -> False, 
               PrintPrecision -> 3, ShowSyntaxStyles -> False}]}}, 
          GridBoxAlignment -> {"Rows" -> {{Top}}}, AutoDelete -> False, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
          BaselinePosition -> {1, 1}]}, 
       Dynamic[Typeset`open$$], ImageSize -> Automatic]},
     "SummaryPanel",
     DisplayFunction->(
      ButtonBox[#, Active -> False, Alignment -> Left, 
       Appearance -> {
        "Default" -> 
         FrontEnd`FileName[{"Typeset", "SummaryBox"}, "Panel.9.png"]}, 
       FrameMargins -> 7, BaseStyle -> {}, 
       DefaultBaseStyle -> {"Panel", Background -> None}, BaselinePosition -> 
       Baseline]& )],
    DynamicModuleValues:>{}], "]"}],
  LinkObject[
  "\"C:\\Users\\Martin\\Dropbox\\Eclipse\\DataAnalysis\\DataAnalysis\\bin\\\
Windows-x86-64\\PhreeqMathematica.exe\"", 318, 12],
  Editable->False,
  SelectWithContents->True,
  Selectable->False]], "Output",
 ImageSize->{499, 54},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->91838074,ExpressionUUID->"f6934c56-c51a-498c-8d1b-d4ea14be6e2d"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"b508037d-88a6-4e25-bb28-3038c2211625"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"6e2bcd43-0678-41e8-b0b1-f0a7915ef373"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"b53a6704-e4b5-42e3-9972-56d9406b08d8"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcCloseLink"]],"paclet:DataAnalysis/ref/PhreeqcCloseLink"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"0403e9d9-f9a2-476b-bec3-d69cc7155ac8"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcLoadDB"]],"paclet:DataAnalysis/ref/PhreeqcLoadDB"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"e9ec0f03-a57c-4d91-ab5e-8260cc6fba93"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunString"]],"paclet:DataAnalysis/ref/PhreeqcRunString"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"a282df54-a65d-47fa-a53b-10106194e5ff"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunFile"]],"paclet:DataAnalysis/ref/PhreeqcRunFile"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"8eb2134c-7b25-4c32-baa0-d43504e3d7b8"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"3f7b654c-cdb6-4077-832d-bed22f0c662a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"1e95a908-9ab9-484c-8f05-05d9824f4b0c"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"9dfae023-0da7-41c0-8ccb-29a970d66947"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"3fd5f14e-ca2b-4864-9f56-750e9207d790"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->734291286,ExpressionUUID->"26ce1554-202b-4e5f-8ccb-84b9c9d5917e"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"c727f675-de46-4f43-8928-94fd92189621"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PhreeqcOpenLink",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 29.8081810}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`Phreeqc`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "PhreeqcOpenLink[] opens a new link to IPhreeqc and returns the link \
object.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "PhreeqcOpenLink", 
    "titlemodifier" -> "", "windowtitle" -> "PhreeqcOpenLink", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/PhreeqcOpenLink"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8305, 213, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"0abdc26b-5d68-44b1-8615-2959d97cc753",
   CellTags->"PrimaryExamplesSection",
   CellID->401120317]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 27790, 636}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[587, 21, 4476, 99, 55, "AnchorBarGrid",ExpressionUUID->"32fd0976-24ae-4862-b59a-addf73a3fb6c",
 CellID->1],
Cell[CellGroupData[{
Cell[5088, 124, 400, 9, 52, "ObjectNameGrid",ExpressionUUID->"9d660db3-45e3-45de-97f0-691f25c5ca25"],
Cell[5491, 135, 548, 13, 109, "Usage",ExpressionUUID->"d541f626-30c8-4bcb-9d2a-8346177464a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6076, 153, 855, 21, 37, "NotesSection",ExpressionUUID->"c92bfab0-540d-4845-8a9a-c04ed6832539",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->257399053],
Cell[6934, 176, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"acbd6d3c-3583-42f7-a95e-940f2060a269"],
Cell[7023, 178, 545, 12, 70, "Notes",ExpressionUUID->"059d4a2f-e1c1-485d-b3bb-a5d6de58c7d2",
 CellID->1067943069],
Cell[7571, 192, 342, 7, 70, "Notes",ExpressionUUID->"9accf025-11b2-4983-9551-2b8a158ef8cc",
 CellID->81743113],
Cell[7916, 201, 263, 5, 70, "Notes",ExpressionUUID->"aedf3c9b-eadc-447e-bfd4-b270120df3b4",
 CellID->336872752],
Cell[8182, 208, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"cadc53f1-5cef-4879-ab18-69c0dcaf3757"]
}, Closed]],
Cell[CellGroupData[{
Cell[8305, 213, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"0abdc26b-5d68-44b1-8615-2959d97cc753",
 CellTags->"PrimaryExamplesSection",
 CellID->401120317],
Cell[CellGroupData[{
Cell[8765, 228, 308, 7, 29, "ExampleSection",ExpressionUUID->"0d5915f2-62cc-4059-b3b1-c376239bdd79",
 CellID->237287921],
Cell[9076, 237, 121, 1, 38, "ExampleText",ExpressionUUID->"45941a86-72fe-4b49-914d-f961a9f817c5",
 CellID->163781936],
Cell[CellGroupData[{
Cell[9222, 242, 187, 4, 26, "Input",ExpressionUUID->"7b432547-5a17-44b9-8700-81ba84c2df5e",
 CellID->958059035],
Cell[9412, 248, 13731, 259, 75, "Output",ExpressionUUID->"f6934c56-c51a-498c-8d1b-d4ea14be6e2d",
 CellID->91838074]
}, Open  ]]
}, Open  ]],
Cell[23170, 511, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"b508037d-88a6-4e25-bb28-3038c2211625"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23293, 516, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"b53a6704-e4b5-42e3-9972-56d9406b08d8",
 CellID->1255426704],
Cell[23556, 525, 1515, 38, 24, "SeeAlso",ExpressionUUID->"3f7b654c-cdb6-4077-832d-bed22f0c662a",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[25108, 568, 266, 7, 72, "MoreAboutSection",ExpressionUUID->"9dfae023-0da7-41c0-8ccb-29a970d66947",
 CellID->38303248],
Cell[25377, 577, 86, 0, 14, "SectionHeaderSpacer",ExpressionUUID->"3fd5f14e-ca2b-4864-9f56-750e9207d790"],
Cell[25466, 579, 247, 6, 24, "MoreAbout",ExpressionUUID->"26ce1554-202b-4e5f-8ccb-84b9c9d5917e",
 CellID->734291286]
}, Open  ]],
Cell[25728, 588, 78, 0, 41, "FooterCell",ExpressionUUID->"c727f675-de46-4f43-8928-94fd92189621"]
}
]
*)

(* End of internal cache information *)

