(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     13148,        372]
NotebookOptionsPosition[      9496,        293]
NotebookOutlinePosition[     11489,        344]
CellTagsIndexPosition[     11446,        341]
WindowTitle->PhreeqcRunFile
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"PhreeqcRunString\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcRunString"], "\<\"PhreeqcOpenLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcOpenLink"], "\<\"PhreeqcCloseLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcCloseLink"], "\<\"PhreeqcLoadDB\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcLoadDB"], "\<\"PhreeqcRun\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/PhreeqcRun"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/PhreeqcRunFile\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/PhreeqcRunFile"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
PhreeqcRunFile.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$40742], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/PhreeqcRunFile", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[TextData[{
 Cell["PhreeqcRunFile", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PhreeqcRunFile", "[", 
       RowBox[{
        StyleBox["link", "TI"], ",", 
        StyleBox["file", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]evaluates a PHREEQC script from a file using the \
specified link object."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PhreeqcRunFile", "[", 
       StyleBox["file", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]uses the default link object."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell[TextData[{
 "PHREEQC is a computer program for speciation, batch-reaction, \
one-dimensional transport and inverse geochemical calculations which is being \
developed at the USGS: ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"]],
    "https://en.wikipedia.org/wiki/Monte_Carlo_method"},
   "WebLink",
   BaseStyle->{"Notes"}]]]
}], "Notes",
 CellID->86668955],

Cell["The following options can be given: ", "Notes",
 CellID->12034227],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["SelectedOutput",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/SelectedOutput"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell["\<\
specifies whether a selected output table should be returned.\
\>", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True}}}},
 CellID->13743563],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunString"]],"paclet:DataAnalysis/ref/PhreeqcRunString"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcOpenLink"]],"paclet:DataAnalysis/ref/PhreeqcOpenLink"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcCloseLink"]],"paclet:DataAnalysis/ref/PhreeqcCloseLink"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcLoadDB"]],"paclet:DataAnalysis/ref/PhreeqcLoadDB"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRun"]],"paclet:DataAnalysis/ref/PhreeqcRun"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PhreeqcRunFile",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 31.3342312}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`Phreeqc`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "PhreeqcRunFile[link, file] evaluates a PHREEQC script from a file using \
the specified link object. PhreeqcRunFile[file] uses the default link \
object.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "PhreeqcRunFile", 
    "titlemodifier" -> "", "windowtitle" -> "PhreeqcRunFile", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/PhreeqcRunFile"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[586, 21, 4054, 97, 70, "AnchorBarGrid",ExpressionUUID->"826cd8df-91ef-4dd9-bc4c-a7e8c999674d",
 CellID->1],
Cell[4643, 120, 171, 6, 70, "ObjectNameGrid",ExpressionUUID->"97521af7-2511-415b-9e95-ebaf725e41d5"],
Cell[4817, 128, 683, 20, 70, "Usage",ExpressionUUID->"574f896c-f72f-4f64-b4d1-f2064f048a4e"],
Cell[CellGroupData[{
Cell[5525, 152, 621, 19, 70, "NotesSection",ExpressionUUID->"ca1ff74b-154e-4953-bab2-ab1ece674d74",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6149, 173, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"29188b60-b316-4617-ad69-a2d453985531"],
Cell[6183, 175, 429, 11, 70, "Notes",ExpressionUUID->"55199cf5-6e18-4b38-b77e-7abab0997210",
 CellID->86668955],
Cell[6615, 188, 72, 1, 70, "Notes",ExpressionUUID->"725f5778-00a7-4ae0-95af-10a321ae4201",
 CellID->12034227],
Cell[6690, 191, 581, 16, 70, "3ColumnTableMod",ExpressionUUID->"66ddebdd-ec8c-4136-91e2-c49d5ea04def",
 CellID->13743563],
Cell[7274, 209, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"3b109940-661f-4ee2-bb95-af05148c2b5f"]
}, Closed]],
Cell[CellGroupData[{
Cell[7342, 214, 150, 7, 70, "SeeAlsoSection",ExpressionUUID->"26f8c591-8ccd-413b-9d49-394702440815",
 CellID->1255426704],
Cell[7495, 223, 1545, 43, 70, "SeeAlso",ExpressionUUID->"4125f478-d710-45d0-9f98-f4ef2c3dc898",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[9077, 271, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"06122773-65b5-4fca-a729-b858b379d411",
 CellID->38303248],
Cell[9236, 280, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"544d8d79-589f-40a5-9267-92978eac833a"],
Cell[9270, 282, 184, 6, 70, "MoreAbout",ExpressionUUID->"a6f6ec3c-c626-4811-bb62-a8f8de8fd213",
 CellID->1]
}, Open  ]],
Cell[9469, 291, 23, 0, 70, "FooterCell",ExpressionUUID->"b9b82f7a-acbf-4181-b7f3-e1f5685eaa36"]
}
]
*)

(* End of internal cache information *)
