(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     30257,        676]
NotebookOptionsPosition[     24351,        549]
NotebookOutlinePosition[     26698,        608]
CellTagsIndexPosition[     26613,        603]
WindowTitle->PhreeqcRunString
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "99ea57ea-788e-484d-9255-539bf8e2a2bd"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"dcf7cf9f-6e99-4ac6-a3ec-183fe2d3e1b3"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"PhreeqcRunFile\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcRunFile"], "\<\"PhreeqcOpenLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcOpenLink"], "\<\"PhreeqcCloseLink\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/PhreeqcCloseLink"], "\<\"PhreeqcLoadDB\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/PhreeqcLoadDB"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "730a59d2-ac3e-4e98-baa9-9f18a61bea0e"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"28802731-ce66-4cfa-ba12-27883216efc5"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "5cb28cb3-cd62-41a5-b204-170f530c47e9"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"8ca11802-88b5-4311-b371-31a040e3798e"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/PhreeqcRunString\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/PhreeqcRunString"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
PhreeqcRunString.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$41312], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/PhreeqcRunString", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "46378513-2de0-4a53-92dc-ea7104dad900"]
    }], "AnchorBar",ExpressionUUID->"668dd164-f98e-424d-9206-f402d646fcdf"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"ca611c2f-d674-4cf8-8e73-f0e9864e82c5"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["PhreeqcRunString", "ObjectName",ExpressionUUID->
  "5ed27b51-7ee0-4edf-b2ac-b18f8268b85c"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"3f81c8b5-25dc-4c36-b836-e712dc8f2817"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "ac7e4914-14bc-49fe-bc59-e09a261d55d2"]
}], "ObjectNameGrid",ExpressionUUID->"68f14ba5-a45a-41fb-8c09-9c30197327f0"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PhreeqcRunString", "[", 
       RowBox[{
        StyleBox["link", "TI"], ",", 
        StyleBox["str", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "1a6970c9-fcb3-4eb5-9cac-3f762e6547ee"],
     "\[LineSeparator]evaluates a PHREEQC script from a string using the \
specified link object."
    }],ExpressionUUID->"9f29a76b-ff38-4a38-a880-bedfd19d7693"]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PhreeqcRunString", "[", 
       StyleBox["str", "TI"], "]"}]], "InlineFormula",ExpressionUUID->
      "b55f842f-44dd-43c4-a15d-2ea335df42a5"],
     "\[LineSeparator]uses the default link object."
    }],ExpressionUUID->"059db250-ca61-46b7-9c12-a6073b74f48b"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"46b6f2b4-68a0-4017-98cd-175521571490"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"3619b6b9-5c68-4718-89af-0db0cc0f7b0c"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"0904784e-8a60-4482-9444-63be387cdb79"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"9bef2fb5-40bf-4b92-b942-bf397fe3c123"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->51876294,ExpressionUUID->"d485af87-9160-4f36-8b89-d8ea69a33acd"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"623128e6-456e-4b7e-99f7-da2d149c7436"],

Cell[TextData[{
 "PHREEQC is a computer program for speciation, batch-reaction, \
one-dimensional transport and inverse geochemical calculations which is being \
developed at the USGS: ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"]],
    "https://en.wikipedia.org/wiki/Monte_Carlo_method"},
   "WebLink",
   BaseStyle->{"Notes"}]],ExpressionUUID->
  "dfceb0d2-2159-44f9-8e80-d9ebd88d6ca4"]
}], "Notes",
 CellID->86668955,ExpressionUUID->"4f55197b-a309-47f0-ab3b-51f365da0829"],

Cell["The following options can be given: ", "Notes",ExpressionUUID->"7a209649-f3a8-424c-bdc9-78bf284d52ef"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon",ExpressionUUID->
     "87559e55-3f21-432c-ac9e-2bf900117eb8"], 
    ButtonBox["SelectedOutput",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/SelectedOutput"], 
    ButtonBox["False",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/False"], Cell["\<\
specifies whether a selected output table should be returned.\
\>", "TableText",ExpressionUUID->"fe13f318-e65f-4576-90b6-ed98e81f20d9"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True}}}},ExpressionUUID->"6d745b0b-3ac1-4348-bc4e-597ab0787933"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"131bdc4c-c2f1-43cf-ae2e-16d5aeaeb2c4"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"15aab544-fd93-467d-8c9b-2b05aa8bddb4"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "6b0aa774-3b14-4574-91f8-9aa49e278271"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->332493783,ExpressionUUID->"674c7c08-bfb2-4d78-8427-8f26bc3ededf"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "5c875822-0f19-4934-a289-bfd3526231e6"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->25521832,ExpressionUUID->"6629a60a-91b0-49ae-b3cd-a02412763cba"],

Cell["\<\
Run a very simple PHREEQC script defined by a string and show the selected \
output:\
\>", "ExampleText",
 CellID->21160806,ExpressionUUID->"108dd3be-1259-4dec-94e7-ab242b9671dd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PhreeqcRunString", "[", 
  RowBox[{
  "\"\<\nSOLUTION\n  pH 8\n  temp 25\n  C 0.01\n  Ca 10\n  Na 10\n\n\
SELECTED_OUTPUT\n  -reset false\n  -pH true\n  -totals Ca C\n  \
-saturation_indices Calcite\n\>\"", ",", 
   RowBox[{"SelectedOutput", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->24979620,ExpressionUUID->"d4635d4d-2c28-43a0-86a1-3bc373850976"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\<\"ID\"\>", ",", "\<\"pH\"\>", ",", "\<\"Ca\"\>", 
     ",", "\<\"C\"\>", ",", "\<\"si_Calcite\"\>"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\"Result-1\"\>", ",", "8", ",", "0.01`", ",", "0.00001`", ",", 
     RowBox[{"-", "1.1726`"}]}], "}"}]}], "}"}]], "Output",
 ImageSize->{454, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->482537188,ExpressionUUID->"f5269648-803e-4883-a2c4-36485be1f28d"]
}, Open  ]],

Cell["Show the normal PHREEQC output instead:", "ExampleText",
 CellID->37513714,ExpressionUUID->"6a230dc2-f45b-4cf2-9994-18e2540e7b31"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PhreeqcRunString", "[", 
  "\"\<\nSOLUTION\n  pH 8\n  temp 25\n  C 0.01\n  Ca 10\n  Na 10\n\>\"", 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->79931591,ExpressionUUID->"3bd52b99-2d27-4199-bcf6-3c3e575252ca"],

Cell[BoxData["\<\"------------------------------------\\nReading input data \
for simulation \
1.\\n------------------------------------\\n\\n\\tSOLUTION\\n\\t  pH 8\\n\\t  \
temp 25\\n\\t  C 0.01\\n\\t  Ca 10\\n\\t  Na \
10\\n-------------------------------------------\\nBeginning of initial \
solution calculations.\\n-------------------------------------------\\n\\\
nInitial solution 1.\\t\\n\\n-----------------------------Solution \
composition------------------------------\\n\\n\\tElements           Molality \
      Moles\\n\\n\\tC                 1.000e-05   1.000e-05\\n\\tCa           \
     1.000e-02   1.000e-02\\n\\tNa                1.000e-02   \
1.000e-02\\n\\n----------------------------Description of \
solution----------------------------\\n\\n                                    \
   pH  =   8.000    \\n                                       pe  =   4.000   \
 \\n                          Density (g/cm\.b3)  =   0.99786\\n              \
                 Volume (L)  =   1.00278\\n                        Activity \
of water  =   1.000\\n                 Ionic strength (mol/kgw)  =   \
2.500e-02\\n                       Mass of water (kg)  =   1.000e+00\\n       \
          Total alkalinity (eq/kg)  =   1.146e-05\\n                       \
Total CO2 (mol/kg)  =   1.000e-05\\n                         Temperature (\
\[Degree]C)  =  25.00\\n                  Electrical balance (eq)  =   \
2.999e-02\\n Percent error, 100*(Cat-|An|)/(Cat+|An|)  =  99.93\\n            \
                   Iterations  =   4\\n                                  \
Total H  = 1.110507e+02\\n                                  Total O  = \
5.552536e+01\\n\\n----------------------------Distribution of \
species----------------------------\\n\\n                                     \
          Log       Log       Log    mole V\\n   Species          Molality    \
Activity  Molality  Activity     Gamma   cm\.b3/mol\\n\\n   OH-             \
1.125e-06   9.631e-07    -5.949    -6.016    -0.067     -3.96\\n   H+         \
     1.133e-08   1.000e-08    -7.946    -8.000    -0.054      0.00\\n   H2O   \
          5.553e+01   9.997e-01     1.744    -0.000     0.000     \
18.07\\nC(-2)         0.000e+00\\n   C2H4            0.000e+00   0.000e+00  \
-141.908  -141.908     0.000     45.52\\nC(-3)         0.000e+00\\n   C2H6    \
        0.000e+00   0.000e+00  -147.447  -147.447     0.000     51.20\\nC(-4) \
        0.000e+00\\n   CH4             0.000e+00   0.000e+00   -81.203   \
-81.203     0.000     37.32\\nC(2)          1.666e-36\\n   CO              \
1.666e-36   1.666e-36   -35.778   -35.778     0.000     33.62\\nC(4)          \
1.000e-05\\n   HCO3-           9.195e-06   7.900e-06    -5.036    -5.102    \
-0.066     24.68\\n   CaCO3           4.615e-07   4.615e-07    -6.336    \
-6.336     0.000    -15.66\\n   CO2             1.822e-07   1.833e-07    \
-6.739    -6.737     0.003     33.24\\n   NaHCO3          9.709e-08   \
9.709e-08    -7.013    -7.013     0.000      1.80\\n   CO3-2           \
6.394e-08   3.505e-08    -7.194    -7.455    -0.261     -4.61\\n   HCOO-      \
     1.449e-29   1.241e-29   -28.839   -28.906    -0.067     26.24\\n   HCOOH \
          8.094e-34   8.094e-34   -33.092   -33.092     0.000     34.67\\n   \
CH2O            0.000e+00   0.000e+00   -61.684   -61.684     0.000     26.92\
\\n   CH3OH           0.000e+00   0.000e+00   -73.914   -73.914     0.000     \
38.18\\n   CH3COO-         0.000e+00   0.000e+00   -88.737   -88.802    \
-0.065     40.58\\n   CaCH3COO+       0.000e+00   0.000e+00   -90.024   \
-90.090    -0.066     29.45\\n   NaCH3COO        0.000e+00   0.000e+00   \
-90.946   -90.946     0.000     48.21\\n   CH3COOH         0.000e+00   \
0.000e+00   -92.029   -92.029     0.000     52.02\\n   CH3CH2OH        \
0.000e+00   0.000e+00  -136.302  -136.302     0.000     55.09\\n   \
Ca(CH3COO)2     0.000e+00   0.000e+00  -177.663  -177.663     0.000     82.12\
\\n   Na(CH3COO)2-    0.000e+00   0.000e+00  -180.040  -180.106    -0.066    \
103.25\\n   C3H8            0.000e+00   0.000e+00  -211.931  -211.931     \
0.000     65.51\\nCa            1.000e-02\\n   Ca+2            1.000e-02   \
5.681e-03    -2.000    -2.246    -0.246    -17.77\\n   CaCO3           \
4.615e-07   4.615e-07    -6.336    -6.336     0.000    -15.66\\n   CaCH3COO+  \
     0.000e+00   0.000e+00   -90.024   -90.090    -0.066     29.45\\n   \
Ca(CH3COO)2     0.000e+00   0.000e+00  -177.663  -177.663     0.000     82.12\
\\nH(0)          1.577e-27\\n   H2              7.887e-28   7.935e-28   \
-27.103   -27.100     0.003     25.21\\nNa            1.000e-02\\n   Na+      \
       1.000e-02   8.592e-03    -2.000    -2.066    -0.066     -1.30\\n   \
NaHCO3          9.709e-08   9.709e-08    -7.013    -7.013     0.000      1.80\
\\n   NaOH            1.428e-09   1.428e-09    -8.845    -8.845     0.000     \
 3.50\\n   NaCH3COO        0.000e+00   0.000e+00   -90.946   -90.946     \
0.000     48.21\\n   Na(CH3COO)2-    0.000e+00   0.000e+00  -180.040  \
-180.106    -0.066    103.25\\nO(0)         -1.449e-29\\n   HCOO-           \
1.449e-29   1.241e-29   -28.839   -28.906    -0.067     26.24\\n   HCOOH      \
     8.094e-34   8.094e-34   -33.092   -33.092     0.000     34.67\\n   O2    \
          1.005e-38   1.011e-38   -37.998   -37.995     0.003     30.40\\n   \
CH2O            0.000e+00   0.000e+00   -61.684   -61.684     0.000     26.92\
\\n   CH3OH           0.000e+00   0.000e+00   -73.914   -73.914     0.000     \
38.18\\n   CH3COO-         0.000e+00   0.000e+00   -88.737   -88.802    \
-0.065     40.58\\n   CaCH3COO+       0.000e+00   0.000e+00   -90.024   \
-90.090    -0.066     29.45\\n   NaCH3COO        0.000e+00   0.000e+00   \
-90.946   -90.946     0.000     48.21\\n   CH3COOH         0.000e+00   \
0.000e+00   -92.029   -92.029     0.000     52.02\\n   CH3CH2OH        \
0.000e+00   0.000e+00  -136.302  -136.302     0.000     55.09\\n   \
Ca(CH3COO)2     0.000e+00   0.000e+00  -177.663  -177.663     0.000     82.12\
\\n   Na(CH3COO)2-    0.000e+00   0.000e+00  -180.040  -180.106    -0.066    \
103.25\\n   C3H8            0.000e+00   0.000e+00  -211.931  -211.931     \
0.000     65.51\\n\\n------------------------------Saturation \
indices-------------------------------\\n\\n  Phase               SI** log \
IAP   log K(298 K,   1 atm)\\n\\n  [(aro)-O-(aro)]   1.61    -19.00  -20.61  \
O\\n  Aragonite        -1.32      0.65    1.97  CaCO3\\n  C               \
-39.25     24.89   64.15  C\\n  C2H4(g)        -139.60   -141.91   -2.31  \
C2H4\\n  C2H6(g)        -144.53   -147.45   -2.92  C2H6\\n  C3H8(g)        \
-209.06   -211.93   -2.87  C3H8\\n  Ca             -107.08     32.75  139.83  \
Ca\\n  Calcite          -1.17      0.65    1.82  CaCO3\\n  CH4(g)          \
-78.36    -81.20   -2.84  CH4\\n  CO(g)           -32.78    -35.78   -3.00  \
CO\\n  CO2(g)           -5.27    -13.10   -7.83  CO2\\n  H2(g)           \
-24.00    -27.10   -3.10  H2\\n  H2O(g)           -1.59     -0.00    1.59  \
H2O\\n  Ice              -0.14     -0.00    0.14  H2O\\n  KerogenC128    \
-6219.42   4514.0310733.44  C128H68O7\\n  KerogenC292    -15183.41  \
11635.1726818.59  C292H288O12\\n  KerogenC515    -27707.35  20391.5948098.95  \
C515H596O72\\n  Lime            -18.81     13.75   32.57  CaO\\n  \
Monohydrocalcite  -2.03      0.65    2.68  CaCO3:H2O\\n  Na              \
-51.94     15.43   67.37  Na\\n  Na2CO3          -12.40     -1.23   11.16  \
Na2CO3\\n  Na2CO3:7H2O     -11.17     -1.24    9.94  Na2CO3:7H2O\\n  Na2O     \
       -55.55     11.87   67.42  Na2O\\n  Nahcolite        -7.03     -7.17   \
-0.14  NaHCO3\\n  Natron          -10.82     -1.24    9.59  Na2CO3:10H2O\\n  \
O2(g)           -35.10    -38.00   -2.89  O2\\n  Portlandite      -8.79     \
13.75   22.55  Ca(OH)2\\n  Thermonatrite   -12.17     -1.23   10.94  \
Na2CO3:H2O\\n\\n**For a gas, SI = log10(fugacity). Fugacity = pressure * phi \
/ 1 atm.\\n  For ideal gases, phi = 1.\\n\\n------------------\\nEnd of \
simulation.\\n------------------\\n\\n------------------------------------\\\
nReading input data for simulation \
2.\\n------------------------------------\\n\\n-------------------------------\
--\\nEnd of Run after 357.865 Seconds.\\n---------------------------------\\n\
\\n\"\>"], "Output",
 ImageSize->{564, 2591},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->94283462,ExpressionUUID->"1b854a4a-e24f-4da1-a8e4-844cbf7db759"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Possible Issues",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "30447ff1-b416-495a-bd8d-a6b3803b4574"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373,ExpressionUUID->"52087d5c-e89e-4454-807d-3afb524c976c"],

Cell["\<\
It seems there is currently an issue with tab characters in the scripts, so \
these should be avoided:\
\>", "ExampleText",
 CellID->173310740,ExpressionUUID->"daf6375e-9df9-4a5c-8f17-f4d4353981ce"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PhreeqcRunString", "[", 
  RowBox[{
  "\"\<\nSOLUTION\n  \\t pH 8\n  temp 25\n  C 0.01\n  Ca 10\n  Na 10\n\n\
SELECTED_OUTPUT\n  -reset false\n  -pH true\n  -totals Ca C\n  \
-saturation_indices Calcite\n\>\"", ",", 
   RowBox[{"SelectedOutput", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->115064901,ExpressionUUID->"964257e9-4594-4cb9-896b-0943c55623d4"],

Cell[BoxData[
 TemplateBox[{
  "PhreeqcRunString","noresult",
   "\"PHREEQC did not return any selected output for the script \
'\\!\\(\\*RowBox[{\\\"\\\\\\\"\\\\\\\\nSOLUTION\\\\\\\\n  \\\\\\\\t pH \
8\\\\\\\\n  temp 25\\\\\\\\n  C 0.01\\\\\\\\n  Ca 10\\\\\\\\n  Na 10\\\\\\\\n\
\\\\\\\\nSELECTED_OUTPUT\\\\\\\\n  -reset false\\\\\\\\n  -pH true\\\\\\\\n  \
-totals Ca C\\\\\\\\n  -saturation_indices \
Calcite\\\\\\\\n\\\\\\\"\\\"}]\\)'.\"",2,27,5,24817731058676293210,"Local",
   "DataAnalysis`Phreeqc`PhreeqcRunString"},
  "MessageTemplate2"]], "Message", "MSG",
 CellLabel->"During evaluation of In[1]:=",
 CellID->642978312,ExpressionUUID->"08acbbce-cb79-4622-9ba4-e52886fed408"],

Cell[BoxData["$Aborted"], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->866657177,ExpressionUUID->"ef86100e-b5b2-4dcd-a90a-42479e3d64e5"]
}, Open  ]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"313c8755-6650-4684-ac37-5596b5600dc1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"5ae47999-a194-4f00-a021-b08a2a5768b1"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"9473e2cc-2b4b-40de-a663-48bc6e2ac60f"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcRunFile"]],"paclet:DataAnalysis/ref/PhreeqcRunFile"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"24095c45-a991-45b0-886e-933108f8d478"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcOpenLink"]],"paclet:DataAnalysis/ref/PhreeqcOpenLink"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"364bc7dc-0ca7-4c24-9e52-f6e22721c671"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcCloseLink"]],"paclet:DataAnalysis/ref/PhreeqcCloseLink"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"c29f8ecc-5e97-4390-911d-bceb5b1de8ff"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PhreeqcLoadDB"]],"paclet:DataAnalysis/ref/PhreeqcLoadDB"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"a97b83db-120c-4157-8e64-4c303b271df4"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"cd4eab5f-28d3-4d1d-be85-a3af8dfa242a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"21283b6d-cd3a-4063-9b81-4cc26dffe1b1"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"6ee3fdeb-9030-4ca6-9544-ba3fdd00f765"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"8e8f951b-f068-46da-806c-4def1cc90c48"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->468303291,ExpressionUUID->"244ac2be-cfda-42aa-a2ea-e9fe4b1005c2"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"77af183a-5f61-4cab-8fa2-4ff237e91910"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PhreeqcRunString",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 32.5404389}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`Phreeqc`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "PhreeqcRunString[link, str] evaluates a PHREEQC script from a string \
using the specified link object. PhreeqcRunString[str] uses the default link \
object.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "PhreeqcRunString", 
    "titlemodifier" -> "", "windowtitle" -> "PhreeqcRunString", "type" -> 
    "Symbol", "uri" -> "DataAnalysis/ref/PhreeqcRunString"}, 
  "SearchTextTranslated" -> "", "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8980, 229, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"674c7c08-bfb2-4d78-8427-8f26bc3ededf",
   CellTags->"PrimaryExamplesSection",
   CellID->332493783]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 26415, 596}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[588, 21, 4478, 99, 55, "AnchorBarGrid",ExpressionUUID->"ca611c2f-d674-4cf8-8e73-f0e9864e82c5",
 CellID->1],
Cell[CellGroupData[{
Cell[5091, 124, 401, 9, 52, "ObjectNameGrid",ExpressionUUID->"68f14ba5-a45a-41fb-8c09-9c30197327f0"],
Cell[5495, 135, 978, 23, 182, "Usage",ExpressionUUID->"46b6f2b4-68a0-4017-98cd-175521571490"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6510, 163, 854, 21, 37, "NotesSection",ExpressionUUID->"d485af87-9160-4f36-8b89-d8ea69a33acd",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->51876294],
Cell[7367, 186, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"623128e6-456e-4b7e-99f7-da2d149c7436"],
Cell[7456, 188, 542, 12, 70, "Notes",ExpressionUUID->"4f55197b-a309-47f0-ab3b-51f365da0829",
 CellID->86668955],
Cell[8001, 202, 108, 0, 70, "Notes",ExpressionUUID->"7a209649-f3a8-424c-bdc9-78bf284d52ef"],
Cell[8112, 204, 742, 18, 70, "3ColumnTableMod",ExpressionUUID->"6d745b0b-3ac1-4348-bc4e-597ab0787933"],
Cell[8857, 224, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"131bdc4c-c2f1-43cf-ae2e-16d5aeaeb2c4"]
}, Closed]],
Cell[CellGroupData[{
Cell[8980, 229, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"674c7c08-bfb2-4d78-8427-8f26bc3ededf",
 CellTags->"PrimaryExamplesSection",
 CellID->332493783],
Cell[CellGroupData[{
Cell[9440, 244, 307, 7, 29, "ExampleSection",ExpressionUUID->"6629a60a-91b0-49ae-b3cd-a02412763cba",
 CellID->25521832],
Cell[9750, 253, 189, 4, 38, "ExampleText",ExpressionUUID->"108dd3be-1259-4dec-94e7-ab242b9671dd",
 CellID->21160806],
Cell[CellGroupData[{
Cell[9964, 261, 402, 8, 235, "Input",ExpressionUUID->"d4635d4d-2c28-43a0-86a1-3bc373850976",
 CellID->24979620],
Cell[10369, 271, 528, 13, 35, "Output",ExpressionUUID->"f5269648-803e-4883-a2c4-36485be1f28d",
 CellID->482537188]
}, Open  ]],
Cell[10912, 287, 136, 1, 38, "ExampleText",ExpressionUUID->"6a230dc2-f45b-4cf2-9994-18e2540e7b31",
 CellID->37513714],
Cell[CellGroupData[{
Cell[11073, 292, 238, 5, 70, "Input",ExpressionUUID->"3bd52b99-2d27-4199-bcf6-3c3e575252ca",
 CellID->79931591],
Cell[11314, 299, 8459, 115, 2612, "Output",ExpressionUUID->"1b854a4a-e24f-4da1-a8e4-844cbf7db759",
 CellID->94283462]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19822, 420, 310, 7, 70, "ExampleSection",ExpressionUUID->"52087d5c-e89e-4454-807d-3afb524c976c",
 CellID->1305812373],
Cell[20135, 429, 208, 4, 70, "ExampleText",ExpressionUUID->"daf6375e-9df9-4a5c-8f17-f4d4353981ce",
 CellID->173310740],
Cell[CellGroupData[{
Cell[20368, 437, 407, 8, 70, "Input",ExpressionUUID->"964257e9-4594-4cb9-896b-0943c55623d4",
 CellID->115064901],
Cell[20778, 447, 685, 12, 70, "Message",ExpressionUUID->"08acbbce-cb79-4622-9ba4-e52886fed408",
 CellID->642978312],
Cell[21466, 461, 220, 5, 35, "Output",ExpressionUUID->"ef86100e-b5b2-4dcd-a90a-42479e3d64e5",
 CellID->866657177]
}, Open  ]]
}, Closed]],
Cell[21713, 470, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"313c8755-6650-4684-ac37-5596b5600dc1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[21836, 475, 260, 7, 70, "SeeAlsoSection",ExpressionUUID->"9473e2cc-2b4b-40de-a663-48bc6e2ac60f",
 CellID->1255426704],
Cell[22099, 484, 1513, 38, 70, "SeeAlso",ExpressionUUID->"cd4eab5f-28d3-4d1d-be85-a3af8dfa242a",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[23649, 527, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"6ee3fdeb-9030-4ca6-9544-ba3fdd00f765",
 CellID->38303248],
Cell[23918, 536, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"8e8f951b-f068-46da-806c-4def1cc90c48"],
Cell[24007, 538, 247, 6, 70, "MoreAbout",ExpressionUUID->"244ac2be-cfda-42aa-a2ea-e9fe4b1005c2",
 CellID->468303291]
}, Open  ]],
Cell[24269, 547, 78, 0, 70, "FooterCell",ExpressionUUID->"77af183a-5f61-4cab-8fa2-4ff237e91910"]
}
]
*)

(* End of internal cache information *)

