(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10237,        287]
NotebookOptionsPosition[      7076,        218]
NotebookOutlinePosition[      9002,        269]
CellTagsIndexPosition[      8959,        266]
WindowTitle->QueryTo
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/QueryTo\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/QueryTo"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
QueryTo.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$43345], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/QueryTo", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["QueryTo", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"QueryTo", "[", 
       RowBox[{
        StyleBox["obj", "TI"], ",", 
        SubscriptBox[
         StyleBox["operator", "TI"], "1"], ",", 
        SubscriptBox[
         StyleBox["operator", "TI"], "2"], ",", "..."}], "]"}]], 
      "InlineFormula"],
     " applies the query with the given operators to the Dataset or Datatable \
obj."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell["The following options can be given: ", "Notes"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["FailureAction",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/FailureAction"], 
    ButtonBox["Abort",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Abort"], Cell["\<\
FailureAction is an option to Query and related functions that determines \
what should happen when a failure or message is generated.\
\>", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["MissingBehavior",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/MissingBehavior"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell["\<\
MissingBehavior is an option to Query and related functions that specifies \
how expressions with head Missing should be interpreted in the context of \
other functions.\
\>", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["PartBehavior",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/PartBehavior"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell["\<\
PartBehavior is an option to Query and related functions that specifies how \
nonexistent parts should be resolved.\
\>", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}}],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"QueryTo",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 37.7382649}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "QueryTo[obj, operator1, operator2, ...] applies the query with the given \
operators to the Dataset or Datatable obj.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "QueryTo", "titlemodifier" -> "", 
    "windowtitle" -> "QueryTo", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/QueryTo"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[579, 21, 3060, 74, 70, "AnchorBarGrid",ExpressionUUID->"468e2ec8-9cc6-4658-bb6d-e4d217aeca82",
 CellID->1],
Cell[3642, 97, 164, 6, 70, "ObjectNameGrid",ExpressionUUID->"75e58d76-e860-42a5-88be-e826b88449ca"],
Cell[3809, 105, 580, 18, 70, "Usage",ExpressionUUID->"84e67651-3e10-479d-852b-99fca1d259ae"],
Cell[CellGroupData[{
Cell[4414, 127, 621, 19, 70, "NotesSection",ExpressionUUID->"0645b3cb-2695-4891-8a06-a4f3b1153b9f",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[5038, 148, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"20661fb6-54ac-4699-b1c9-8a1da72fc93b"],
Cell[5072, 150, 53, 0, 70, "Notes",ExpressionUUID->"bc881afb-9817-490f-b143-4793bb8e2018"],
Cell[5128, 152, 1458, 37, 70, "3ColumnTableMod",ExpressionUUID->"858b0cbf-a06d-4e4e-a047-8ff552f23fed"],
Cell[6589, 191, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"c50b1b4a-0916-4e58-918c-5b04e9b687fe"]
}, Closed]],
Cell[CellGroupData[{
Cell[6657, 196, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"672c6e6c-ca1b-4439-84ff-38f9f9c1411e",
 CellID->38303248],
Cell[6816, 205, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"f5fbead5-6a99-44a5-89bd-39afd23a0224"],
Cell[6850, 207, 184, 6, 70, "MoreAbout",ExpressionUUID->"adc2bfb7-ed5a-42f4-a7d1-25247903c716",
 CellID->1]
}, Open  ]],
Cell[7049, 216, 23, 0, 70, "FooterCell",ExpressionUUID->"5f68c319-ad1c-46ab-9213-28403bd7de7b"]
}
]
*)

(* End of internal cache information *)
