(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     23042,        607]
NotebookOptionsPosition[     17026,        476]
NotebookOutlinePosition[     19334,        535]
CellTagsIndexPosition[     19249,        530]
WindowTitle->RegisterOxide
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "1bac67e2-b955-4e4d-ad84-be274c1be031"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "See Also",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"66857c85-2b3a-4498-9bee-39f27269160b"],
         TextCell[
          Row[{"See Also", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"MolarMass\"\>":>Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolarMass"], "\<\"RegisterCompound\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/RegisterCompound"], "\<\"ConvertComps\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/ConvertComps"], "\<\"ChemElementName\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/ChemElementName"], "\<\"OxideName\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/OxideName"], "\<\"MolesToMass\"\>":>
       Documentation`HelpLookup[
       "paclet:DataAnalysis/ref/MolesToMass"], "\<\"MassToMoles\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/ref/MassToMoles"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlso"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "0fe3df2b-afbb-421c-afb5-d4a96efd04b9"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"50818d9b-d31c-452b-95fa-08970c186531"],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "2ab230ef-0a62-47cb-af33-fa159ad4144c"],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }],ExpressionUUID->"525ba765-c3f4-4b79-986c-99b622da99bf"],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/RegisterOxide\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/RegisterOxide"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
RegisterOxide.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$44357], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/RegisterOxide", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0},ExpressionUUID->
      "ebe05f5d-eef8-48f4-96da-6cc5ee61950a"]
    }], "AnchorBar",ExpressionUUID->"f93653f4-0fa2-4e4a-89d2-80536cd6338b"]}
  }]], "AnchorBarGrid",
 CellID->1,ExpressionUUID->"0b7feb66-4d7a-4f1e-959a-0513e8ffeb16"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["RegisterOxide", "ObjectName",ExpressionUUID->
  "be866328-f531-43d8-99f5-0dea483c785e"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"f3abd453-7a8b-46c6-a236-3509bca37fdf"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "0bfc8fdf-e418-4466-b167-17e84f944fd8"]
}], "ObjectNameGrid",ExpressionUUID->"35776b52-1464-4019-b794-086c8500df16"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RegisterOxide", "[", 
       RowBox[{
        StyleBox["element", "TI"], ",", 
        StyleBox["c", "TI"], ",", 
        StyleBox["ox", "TI"]}], "]"}]], "InlineFormula",ExpressionUUID->
      "725e58b9-edab-42e3-85ac-fd05d126d378"],
     "\[LineSeparator]registers the oxide with the chemical formula ",
     Cell[BoxData[
      SubscriptBox["Element", 
       StyleBox["c", "TI"]]], "InlineFormula",ExpressionUUID->
      "ffd20c1b-a4a3-4863-ae9e-a7d270d903bc"],
     Cell[BoxData[
      SubscriptBox["O", 
       StyleBox["ox", "TI"]]], "InlineFormula",ExpressionUUID->
      "8f1556fa-bb20-4b38-a95c-22242667a3d4"],
     " for later use with other functions."
    }],ExpressionUUID->"32f9908f-5164-4e2b-a8fa-f5b178f6defb"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"20926417-abe4-492a-b48c-d190be0fc04c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"10726057-a9ec-4642-8076-589cca2b5730"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"55ae05ca-4c9e-409f-b076-f474ac14ecaa"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"1e84f51b-9522-4dd7-b686-169506494b71"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->153769166,ExpressionUUID->"02a393e6-7cae-4224-98c6-6629b644bdca"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"69ac63bf-e554-4b5a-aba9-2738b61d0d8e"],

Cell[TextData[{
 "Oxides have to be defined for the conversion between masses and molar \
amounts of chemical compounds in various functions such as ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "ed7176d0-e5e6-44e4-9a44-1ada85b2fdd8"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ConvertComps"]],"paclet:DataAnalysis/ref/ConvertComps"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "e2fe7cd1-6ea2-4f3c-bad3-9c07e400831c"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolesToMass"]],"paclet:DataAnalysis/ref/MolesToMass"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "144e2ec5-5e18-439d-8e07-fe955f5a28fc"],
 ", and ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassToMoles"]],"paclet:DataAnalysis/ref/MassToMoles"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "836712d8-dc12-49b5-bffb-38cfcf27660c"],
 "."
}], "Notes",
 CellID->1067943069,ExpressionUUID->"f5b7a6b6-efa2-4be6-904a-3cb1519f856b"],

Cell["\<\
Some common oxides are already defined when the package is loaded.\
\>", "Notes",
 CellID->187992969,ExpressionUUID->"cdcc89c9-2e07-41ca-95a9-f83d032e9232"],

Cell["", "SectionFooterSpacer",ExpressionUUID->"23f51f9d-a128-4a14-b757-c81cc405b37c"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"bbcf72f8-5c04-4899-8e1d-1263430d3c6b"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(2)", "ExampleCount",ExpressionUUID->
  "b1a85c0a-99cb-4d72-8e76-2100aa585292"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->197350286,ExpressionUUID->"49f0881e-c013-4ace-95b8-9e79b8867a26"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "5fef8b0d-71bd-4df1-93fd-05605b363472"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->62940976,ExpressionUUID->"e220d42f-2f4c-450a-9fb9-fca120e94ec8"],

Cell[TextData[{
 "Register ",
 Cell[BoxData[
  SubscriptBox["La", "2"]],ExpressionUUID->
  "a514d2c6-5b10-4ea9-9984-9970abdf60d7"],
 Cell[BoxData[
  SubscriptBox["O", "3"]],ExpressionUUID->
  "17f6f5e2-cf8f-497d-82d2-b51e39937439"],
 " as an oxide:"
}], "ExampleText",
 CellID->474546119,ExpressionUUID->"a61d9fcf-9b7c-464c-97b3-50a91c0af9be"],

Cell[BoxData[
 RowBox[{"RegisterOxide", "[", 
  RowBox[{"\"\<La\>\"", ",", "2", ",", "3"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->26759553,ExpressionUUID->"ea123e19-9127-4a48-88d5-d7f75303757a"],

Cell["Get the molar mass of the oxide:", "ExampleText",
 CellID->7219950,ExpressionUUID->"4fda35ec-a491-4ea0-b214-0bccd95b036a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MolarMass", "[", "\"\<La2O3\>\"", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->755137712,ExpressionUUID->"9b558f07-3805-467a-b5c3-c71e8edd9d32"],

Cell[BoxData["325.80914`"], "Output",
 ImageSize->{53, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->152015877,ExpressionUUID->"07330a3d-3e06-4d32-98ab-a0b1479f3974"]
}, Open  ]],

Cell[TextData[{
 "Convert a mass of ",
 Cell[BoxData[
  SubscriptBox["La", "2"]],ExpressionUUID->
  "88d73d82-004d-4862-84ba-532bc3e2ad9e"],
 Cell[BoxData[
  SubscriptBox["O", "3"]],ExpressionUUID->
  "f21ff0cf-b29d-4335-8f28-fd7ef38bda93"],
 " to the molar amount:"
}], "ExampleText",
 CellID->159143773,ExpressionUUID->"e1c425b2-819f-40dc-9b7c-741fd2d3a79d"],

Cell[CellGroupData[{

Cell["MassToMoles[\"La2O3\",0.01]", "Input",
 CellLabel->"In[3]:=",
 CellID->555330262,ExpressionUUID->"d982b620-5c87-47bf-a088-5dd973ff7ac3"],

Cell[BoxData["0.00003069281604561493`"], "Output",
 ImageSize->{88, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->153207608,ExpressionUUID->"c260aa24-2057-4b5b-87f1-ff531029b364"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Possible Issues",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "27573bd9-7075-4dfb-a6e2-3ed2d99f6596"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373,ExpressionUUID->"7ca51d9e-c72d-4bf6-ab54-690187f6ae7f"],

Cell["You can only register oxide for known elements:", "ExampleText",
 CellID->310505551,ExpressionUUID->"f1747967-3b47-478c-8dc4-38b3db90ada6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RegisterOxide", "[", 
  RowBox[{"\"\<Ma\>\"", ",", "1", ",", "2"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->6521777,ExpressionUUID->"0c720a01-528c-4a27-b84f-4a0bd9df06cf"],

Cell[BoxData[
 TemplateBox[{
  "RegisterComp","elementudef",
   "\"The element \\!\\(\\*RowBox[{\\\"\\\\\\\"Ma\\\\\\\"\\\"}]\\) is not \
known.\"",2,20,4,24809244206830334157,"Local",
   "DataAnalysis`GeoChem`RegisterComp"},
  "MessageTemplate2"]], "Message", "MSG",
 CellLabel->"During evaluation of In[1]:=",
 CellID->28598019,ExpressionUUID->"944ff216-e3fc-4e59-a98c-7ba13da0b06f"],

Cell[BoxData["$Aborted"], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->9592203,ExpressionUUID->"5fecfc87-4f18-45b1-a25c-bb1e8cb2198d"]
}, Open  ]]
}, Closed]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"7654630d-bf3f-46ea-a56d-f03471de98ec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"6be5dda6-53d0-4edb-9613-3ad4859468c6"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"84e136f7-5c71-4c81-9910-2088fb224729"],

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolarMass"]],"paclet:DataAnalysis/ref/MolarMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"d55b9af0-d123-4f07-8e8a-45ce66f1bdac"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["RegisterCompound"]],"paclet:DataAnalysis/ref/RegisterCompound"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"1a56156b-0310-4d75-b505-be48f8a527c6"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ConvertComps"]],"paclet:DataAnalysis/ref/ConvertComps"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"b54f158a-a902-45bd-a9f9-65e27c044de0"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["ChemElementName"]],"paclet:DataAnalysis/ref/ChemElementName"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"920010bc-bb7d-4a9d-a1df-6a7b63df71a3"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["OxideName"]],"paclet:DataAnalysis/ref/OxideName"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"85d71331-0bd9-4a41-9ac8-9502dd2b5986"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MolesToMass"]],"paclet:DataAnalysis/ref/MolesToMass"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"d400960d-535b-4ace-a5c0-f45a3644d020"],
 "\[NonBreakingSpace]",
 StyleBox["\[MediumSpace]\[FilledVerySmallSquare]\[MediumSpace]", 
  "InlineSeparator"],
 " ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MassToMoles"]],"paclet:DataAnalysis/ref/MassToMoles"},
   "RefLink",
   BaseStyle->{"InlineFormula", FontFamily -> "Verdana"}]], "InlineFormula",
  ExpressionUUID->"db2c050f-3703-4e04-a9e8-809a8f257ca8"]
}], "SeeAlso",
 CellID->929782353,ExpressionUUID->"4986878b-c823-4020-8b73-f7fc77d932cf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"76664652-72ca-4d41-991c-76378ef20e9d"],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248,ExpressionUUID->"d341a8a6-cffa-4cda-9671-5ddee38f28ac"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"d967672b-6139-41fb-8af0-a97b6d6dcaf7"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->434287608,ExpressionUUID->"db6042e1-fc31-445a-893b-1e42ae4ec0a5"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"f6864c99-b95b-4de2-a1d8-5cf82353fd7a"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"RegisterOxide",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 40.1135821}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`GeoChem`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "RegisterOxide[element, c, ox] registers the oxide with the chemical \
formula ElementcOox for later use with other functions.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "RegisterOxide", "titlemodifier" -> "", 
    "windowtitle" -> "RegisterOxide", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/RegisterOxide"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9254, 239, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"49f0881e-c013-4ace-95b8-9e79b8867a26",
   CellTags->"PrimaryExamplesSection",
   CellID->197350286]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 19051, 523}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[585, 21, 4754, 104, 55, "AnchorBarGrid",ExpressionUUID->"0b7feb66-4d7a-4f1e-959a-0513e8ffeb16",
 CellID->1],
Cell[CellGroupData[{
Cell[5364, 129, 398, 9, 52, "ObjectNameGrid",ExpressionUUID->"35776b52-1464-4019-b794-086c8500df16"],
Cell[5765, 140, 1018, 25, 109, "Usage",ExpressionUUID->"20926417-abe4-492a-b48c-d190be0fc04c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6820, 170, 855, 21, 37, "NotesSection",ExpressionUUID->"02a393e6-7cae-4224-98c6-6629b644bdca",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->153769166],
Cell[7678, 193, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"69ac63bf-e554-4b5a-aba9-2738b61d0d8e"],
Cell[7767, 195, 1192, 32, 70, "Notes",ExpressionUUID->"f5b7a6b6-efa2-4be6-904a-3cb1519f856b",
 CellID->1067943069],
Cell[8962, 229, 166, 3, 70, "Notes",ExpressionUUID->"cdcc89c9-2e07-41ca-95a9-f83d032e9232",
 CellID->187992969],
Cell[9131, 234, 86, 0, 70, "SectionFooterSpacer",ExpressionUUID->"23f51f9d-a128-4a14-b757-c81cc405b37c"]
}, Closed]],
Cell[CellGroupData[{
Cell[9254, 239, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"49f0881e-c013-4ace-95b8-9e79b8867a26",
 CellTags->"PrimaryExamplesSection",
 CellID->197350286],
Cell[CellGroupData[{
Cell[9714, 254, 307, 7, 29, "ExampleSection",ExpressionUUID->"e220d42f-2f4c-450a-9fb9-fca120e94ec8",
 CellID->62940976],
Cell[10024, 263, 343, 10, 38, "ExampleText",ExpressionUUID->"a61d9fcf-9b7c-464c-97b3-50a91c0af9be",
 CellID->474546119],
Cell[10370, 275, 205, 4, 26, "Input",ExpressionUUID->"ea123e19-9127-4a48-88d5-d7f75303757a",
 CellID->26759553],
Cell[10578, 281, 128, 1, 38, "ExampleText",ExpressionUUID->"4fda35ec-a491-4ea0-b214-0bccd95b036a",
 CellID->7219950],
Cell[CellGroupData[{
Cell[10731, 286, 172, 3, 26, "Input",ExpressionUUID->"9b558f07-3805-467a-b5c3-c71e8edd9d32",
 CellID->755137712],
Cell[10906, 291, 222, 5, 35, "Output",ExpressionUUID->"07330a3d-3e06-4d32-98ab-a0b1479f3974",
 CellID->152015877]
}, Open  ]],
Cell[11143, 299, 360, 10, 38, "ExampleText",ExpressionUUID->"e1c425b2-819f-40dc-9b7c-741fd2d3a79d",
 CellID->159143773],
Cell[CellGroupData[{
Cell[11528, 313, 142, 2, 26, "Input",ExpressionUUID->"d982b620-5c87-47bf-a088-5dd973ff7ac3",
 CellID->555330262],
Cell[11673, 317, 235, 5, 35, "Output",ExpressionUUID->"c260aa24-2057-4b5b-87f1-ff531029b364",
 CellID->153207608]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11957, 328, 310, 7, 29, "ExampleSection",ExpressionUUID->"7ca51d9e-c72d-4bf6-ab54-690187f6ae7f",
 CellID->1305812373],
Cell[12270, 337, 145, 1, 70, "ExampleText",ExpressionUUID->"f1747967-3b47-478c-8dc4-38b3db90ada6",
 CellID->310505551],
Cell[CellGroupData[{
Cell[12440, 342, 204, 4, 70, "Input",ExpressionUUID->"0c720a01-528c-4a27-b84f-4a0bd9df06cf",
 CellID->6521777],
Cell[12647, 348, 384, 8, 70, "Message",ExpressionUUID->"944ff216-e3fc-4e59-a98c-7ba13da0b06f",
 CellID->28598019],
Cell[13034, 358, 218, 5, 35, "Output",ExpressionUUID->"5fecfc87-4f18-45b1-a25c-bb1e8cb2198d",
 CellID->9592203]
}, Open  ]]
}, Closed]],
Cell[13279, 367, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"7654630d-bf3f-46ea-a56d-f03471de98ec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[13402, 372, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"84e136f7-5c71-4c81-9910-2088fb224729",
 CellID->1255426704],
Cell[13665, 381, 2622, 68, 45, "SeeAlso",ExpressionUUID->"4986878b-c823-4020-8b73-f7fc77d932cf",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[16324, 454, 266, 7, 70, "MoreAboutSection",ExpressionUUID->"d341a8a6-cffa-4cda-9671-5ddee38f28ac",
 CellID->38303248],
Cell[16593, 463, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"d967672b-6139-41fb-8af0-a97b6d6dcaf7"],
Cell[16682, 465, 247, 6, 70, "MoreAbout",ExpressionUUID->"db6042e1-fc31-445a-893b-1e42ae4ec0a5",
 CellID->434287608]
}, Open  ]],
Cell[16944, 474, 78, 0, 70, "FooterCell",ExpressionUUID->"f6864c99-b95b-4de2-a1d8-5cf82353fd7a"]
}
]
*)

(* End of internal cache information *)

