(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     10990,        309]
NotebookOptionsPosition[      7623,        238]
NotebookOutlinePosition[      9754,        291]
CellTagsIndexPosition[      9711,        288]
WindowTitle->SciDrawPlot
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "Related Guides",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"Related Guides", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis Package\"\>":>
       Documentation`HelpLookup["paclet:DataAnalysis/guide/DataAnalysis"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAbout"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox[
        InterpretationBox[Cell[TextData[{
          "URL",
          StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
           StripOnInput->False]
         }]],
         TextCell[
          Row[{"URL", 
            Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
        StripOnInput->False], {"\<\"DataAnalysis/ref/SciDrawPlot\"\>":>
       None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["DataAnalysis/ref/SciDrawPlot"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/language/DataAnalysis/ref/\
SciDrawPlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
             If[
              TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$46461], 
              "http://reference.wolfram.com/system-modeler/", 
              "http://reference.wolfram.com/language/"], 
             "DataAnalysis/ref/SciDrawPlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"URLMenu"]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[TextData[{
 Cell["SciDrawPlot", "ObjectName"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]]],
 Cell[BoxData[""], "ObjectNameTranslation"]
}], "ObjectNameGrid"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SciDrawPlot", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           SubscriptBox[
            StyleBox["x", "TI"], "1"], ",", 
           SubscriptBox[
            StyleBox["y", "TI"], "1"]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           SubscriptBox[
            StyleBox["x", "TI"], "2"], ",", 
           SubscriptBox[
            StyleBox["y", "TI"], "2"]}], "}"}], ",", "..."}], "}"}], "]"}]], 
      "InlineFormula"],
     "\[LineSeparator]returns a DataPlot object which can be used to plot the \
data inside a SciDraw Figure. Error bars can be plotted if",
     Cell[BoxData[
      RowBox[{" ", 
       SubscriptBox[
        StyleBox["x", "TI"], 
        StyleBox["i", "TI"]]}]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["y", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula"],
     " are ",
     Cell[BoxData[
      TemplateBox[{Cell[
         TextData["NDV"]],"paclet:DataAnalysis/ref/NDV"},
       "RefLink",
       BaseStyle->{"InlineFormula"}]], "InlineFormula"],
     "-type objects."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SciDrawPlot", "[", 
       StyleBox["datatable", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns a DataPlot object with data in a DataTable, \
which can be used inside a SciDraw Figure."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}}],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]]],
   "Details"
  }], "NotesFrameText"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],

Cell["", "SectionHeaderSpacer"],

Cell["\<\
The following options can be given in addition to those of SciDraw's DataPlot \
options:\
\>", "Notes"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["XErrorBars",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/XErrorBars"], 
    ButtonBox["True",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/True"], Cell[
    "specifies if error bars should be drawn for the x-axis.", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["YErrorBars",
     BaseStyle->"Link",
     ButtonData->"paclet:DataAnalysis/ref/YErrorBars"], 
    ButtonBox["True",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/True"], Cell[
    "specifies if error bars should be drawn for the y-axis.", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}}],

Cell["", "SectionFooterSpacer"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]]],
 "Related Guides"
}], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell["", "SectionHeaderSpacer"],

Cell[BoxData[
 TemplateBox[{Cell[
    TextData["DataAnalysis Package"]],
   "paclet:DataAnalysis/guide/DataAnalysis"},
  "RefLink",
  BaseStyle->"MoreAbout"]], "MoreAbout",
 CellID->1]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SciDrawPlot",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 44.3037282}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "SciDrawPlot[{{x1, y1}, {x2, y2}, ...}] returns a DataPlot object which \
can be used to plot the data inside a SciDraw Figure. Error bars can be \
plotted if xi and yi are NDV-type objects. SciDrawPlot[datatable] returns a \
DataPlot object with data in a DataTable, which can be used inside a SciDraw \
Figure.", "synonyms" -> {}, "tabletags" -> {}, "title" -> "SciDrawPlot", 
    "titlemodifier" -> "", "windowtitle" -> "SciDrawPlot", "type" -> "Symbol",
     "uri" -> "DataAnalysis/ref/SciDrawPlot"}},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[583, 21, 3078, 74, 70, "AnchorBarGrid",ExpressionUUID->"631f8693-7ae7-46b3-a2ab-c869ea4d05c0",
 CellID->1],
Cell[3664, 97, 168, 6, 70, "ObjectNameGrid",ExpressionUUID->"d9ce1149-e659-484e-81ec-92218711d95d"],
Cell[3835, 105, 1631, 50, 70, "Usage",ExpressionUUID->"bfed9233-2ce6-4e2d-b82d-912cbe02c03b"],
Cell[CellGroupData[{
Cell[5491, 159, 621, 19, 70, "NotesSection",ExpressionUUID->"fc25ea94-3985-46d0-811e-7d48aadc71dc",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1],
Cell[6115, 180, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"41a28797-dd4f-413e-8148-ef827a84b48b"],
Cell[6149, 182, 113, 3, 70, "Notes",ExpressionUUID->"c8972afc-373d-49b8-a055-d567aaf86ba7"],
Cell[6265, 187, 868, 22, 70, "3ColumnTableMod",ExpressionUUID->"bcab22aa-d047-474b-8afe-740738f4d7bd"],
Cell[7136, 211, 31, 0, 70, "SectionFooterSpacer",ExpressionUUID->"0f692d36-df58-490e-8852-650e40943d0d"]
}, Closed]],
Cell[CellGroupData[{
Cell[7204, 216, 156, 7, 70, "MoreAboutSection",ExpressionUUID->"490c538c-982c-4197-b79e-6f78f0da8c4b",
 CellID->38303248],
Cell[7363, 225, 31, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"01f05cea-32ee-4444-a16e-9e21d7ec2941"],
Cell[7397, 227, 184, 6, 70, "MoreAbout",ExpressionUUID->"4ed49894-0f84-4c97-bcb9-4b2e31f56d06",
 CellID->1]
}, Open  ]],
Cell[7596, 236, 23, 0, 70, "FooterCell",ExpressionUUID->"252e7ce3-e1a1-4535-aafe-30b9ccdbd295"]
}
]
*)

(* End of internal cache information *)
