(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     14221,        381]
NotebookOptionsPosition[      9435,        272]
NotebookOutlinePosition[     11754,        331]
CellTagsIndexPosition[     11669,        326]
WindowTitle->SetConfidenceLevel
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE SYMBOL", "PacletNameCell",ExpressionUUID->
     "aaff6982-64b4-4ed2-afb0-976bef856f97"], Cell[TextData[Cell[BoxData[
     ActionMenuBox[
      FrameBox[
       InterpretationBox[Cell[TextData[{
         "URL",
         StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
          StripOnInput->False]
        }],ExpressionUUID->"a304e510-6c67-4003-9067-99f4baffe619"],
        TextCell[
         Row[{"URL", 
           Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
       StripOnInput->False], {"\<\"DataAnalysis/ref/SetConfidenceLevel\"\>":>
      None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["DataAnalysis/ref/SetConfidenceLevel"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/language/DataAnalysis/ref/\
SetConfidenceLevel.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
            If[
             TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$47446], 
             "http://reference.wolfram.com/system-modeler/", 
             "http://reference.wolfram.com/language/"], 
            "DataAnalysis/ref/SetConfidenceLevel", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic,
      MenuStyle->"URLMenu"]],
     LineSpacing->{1.4, 0},ExpressionUUID->
     "3601666b-5663-4b65-b077-dc58533ed0d0"]], "AnchorBar",ExpressionUUID->
     "c5e156a4-1549-44d5-a25a-b0c1ae353b43"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"45aee57c-1771-4597-b9d4-bc2ddde59627"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell["SetConfidenceLevel", "ObjectName",ExpressionUUID->
  "f93e6995-e2f9-40b2-bce3-5c70d959b8ea"],
 Cell[BoxData[
  TemplateBox[{8},
   "Spacer1"]],ExpressionUUID->"ce42a65d-b316-4eff-b484-a20aed50df83"],
 Cell[BoxData[
 ""], "ObjectNameTranslation",ExpressionUUID->
  "796a84f8-16ca-4a6c-bb5e-a8fd296951fb"]
}], "ObjectNameGrid",ExpressionUUID->"8117ef45-2541-47f9-910b-c9c04055676a"],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     "SetConfidenceLevel[",
     StyleBox["n",
      FontSlant->"Italic"],
     "] sets the confidence level for the DataAnalysis functions, for example \
to control the output display."
    }],ExpressionUUID->"ac6d5104-189a-4759-ba4f-bbf0b7d1dbb4"]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> \
{}}},ExpressionUUID->"883869e1-386d-4b6d-ad46-1aef15588346"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[Cell[TextData[{
   Cell[BoxData[
    TemplateBox[{6},
     "Spacer1"]],ExpressionUUID->"57b16508-21e8-4395-aee9-33d91fdb18be"],
   "Details"
  }], "NotesFrameText",ExpressionUUID->"211e33bc-1d34-415a-be93-242ac84ba9ea"],
  Appearance->{Automatic, None, "Normal", Automatic},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->
   "Preemptive"]],ExpressionUUID->"c21ea99c-eb5a-49c0-8df4-56e5aeb069dc"]], \
"NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->217836869,ExpressionUUID->"f9c6bcc1-d64b-4f6f-94ff-0fdb2d1d1d97"],

Cell["", "SectionHeaderSpacer",ExpressionUUID->"d26977bd-1b89-4a65-8801-1bbc37a9b39a"],

Cell["The default confidence level is 0.95.", "Notes",
 CellID->1067943069,ExpressionUUID->"25688d5a-f3c8-4651-a407-66f3cbda7e44"]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"2e269566-090c-4d9d-a11a-386f7b7d3f5d"],
 "Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "667bf19e-e663-4a8e-bcd7-000cabaac5fd"]
}], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->686288290,ExpressionUUID->"fcfa9e99-3af8-4d62-94b2-0286d8459780"],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount",ExpressionUUID->
  "b230265c-130b-42aa-9afe-86654dcf68fa"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->11750468,ExpressionUUID->"bf021ea9-02ca-4c30-b386-20d41d94b5c5"],

Cell["\<\
By default, the displayed uncertainties is the confidence interval at the \
0.95 confidence level, here shown for a normal distribution with mean 1 and \
standard deviation 0.1:\
\>", "ExampleText",
 CellID->212750254,ExpressionUUID->"bf2a59ae-3f44-43c3-9fa4-e9a0cd508f1c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NDV", "[", 
  RowBox[{"1", ",", "0.1"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->6260626,ExpressionUUID->"ddb84e26-1814-46cb-85db-a3438b8d6c3a"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "20","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1, 0.1, $CellContext`dv$371729]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->203031903,ExpressionUUID->"d1fc635b-62d2-4982-af6d-525f6ee1bd3e"]
}, Open  ]],

Cell["Changing the confidence level affects the output:", "ExampleText",
 CellID->387305972,ExpressionUUID->"a88aa673-7da1-48b2-ab31-19d0b8c50baf"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetConfidenceLevel", "[", "0.99", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->150385587,ExpressionUUID->"11ab4475-0e10-4fa4-90b3-547127ffee0c"],

Cell[BoxData["0.99`"], "Output",
 ImageSize->{32, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->673865938,ExpressionUUID->"26984c31-b057-4f33-a0ee-df635ab0bfda"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NDV", "[", 
  RowBox[{"1", ",", "0.1"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->403371443,ExpressionUUID->"5495c640-c722-4396-a704-7cd5ebea25a8"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.00\"", 1., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "26","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[1, 0.1, $CellContext`dv$371737]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->423682265,ExpressionUUID->"69f16cc2-b2fc-4489-8983-4d7191499830"]
}, Open  ]]
}, Open  ]],

Cell["", "SectionFooterSpacer",ExpressionUUID->"d9a0e801-3069-4dc6-8524-1e3720404444"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  TemplateBox[{6},
   "Spacer1"]],ExpressionUUID->"6e80164c-cf7d-4f76-8294-171dabc351e2"],
 "See Also"
}], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704,ExpressionUUID->"3caae8c8-8d3a-4486-8cda-f7875f3afd31"],

Cell[TextData[Cell[BoxData[
 TemplateBox[{Cell[
    TextData["NDV DV $UseParenthesesForm MonteCarloSimulation"]],
   "paclet:ref/NDV DV $UseParenthesesForm MonteCarloSimulation"},
  "RefLink",
  BaseStyle->{
   "InlineFormula", FontFamily -> 
    "Verdana"}]], \
"InlineFormula",ExpressionUUID->"7f1cf0ff-2348-46f0-ab26-3594a351f203"]], \
"SeeAlso",
 CellID->929782353,ExpressionUUID->"10c1ac24-a610-430f-bc48-86b3d85515a0"]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"c4a34f7e-dc29-4e5f-bc24-b0d113e34c85"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SetConfidenceLevel",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "DataAnalysis Package", ButtonData -> 
         "paclet:DataAnalysis/guide/DataAnalysis", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "HasOptions" -> False, "ExampleCounter" -> 1, "NeedPlatMsgIn" -> 
  None, "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 37, 46.5908107}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Symbol", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "SetConfidenceLevel[n] sets the confidence level for the DataAnalysis \
functions, for example to control the output display.", "synonyms" -> {}, 
    "tabletags" -> {}, "title" -> "SetConfidenceLevel", "titlemodifier" -> "",
     "windowtitle" -> "SetConfidenceLevel", "type" -> "Symbol", "uri" -> 
    "DataAnalysis/ref/SetConfidenceLevel"}, "SearchTextTranslated" -> "", 
  "NewStyles" -> False},
CellContext->"Global`",
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  TaggingRules -> {"NewStyles" -> False}, FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5313, 141, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"fcfa9e99-3af8-4d62-94b2-0286d8459780",
   CellTags->"PrimaryExamplesSection",
   CellID->686288290]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 11471, 319}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[590, 21, 2634, 56, 55, "AnchorBarGrid",ExpressionUUID->"45aee57c-1771-4597-b9d4-bc2ddde59627",
 CellID->1],
Cell[CellGroupData[{
Cell[3249, 81, 403, 9, 52, "ObjectNameGrid",ExpressionUUID->"8117ef45-2541-47f9-910b-c9c04055676a"],
Cell[3655, 92, 507, 13, 110, "Usage",ExpressionUUID->"883869e1-386d-4b6d-ad46-1aef15588346"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4199, 110, 855, 21, 37, "NotesSection",ExpressionUUID->"f9c6bcc1-d64b-4f6f-94ff-0fdb2d1d1d97",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->217836869],
Cell[5057, 133, 86, 0, 70, "SectionHeaderSpacer",ExpressionUUID->"d26977bd-1b89-4a65-8801-1bbc37a9b39a"],
Cell[5146, 135, 130, 1, 70, "Notes",ExpressionUUID->"25688d5a-f3c8-4651-a407-66f3cbda7e44",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[5313, 141, 435, 11, 35, "PrimaryExamplesSection",ExpressionUUID->"fcfa9e99-3af8-4d62-94b2-0286d8459780",
 CellTags->"PrimaryExamplesSection",
 CellID->686288290],
Cell[CellGroupData[{
Cell[5773, 156, 307, 7, 29, "ExampleSection",ExpressionUUID->"bf021ea9-02ca-4c30-b386-20d41d94b5c5",
 CellID->11750468],
Cell[6083, 165, 283, 5, 57, "ExampleText",ExpressionUUID->"bf2a59ae-3f44-43c3-9fa4-e9a0cd508f1c",
 CellID->212750254],
Cell[CellGroupData[{
Cell[6391, 174, 177, 4, 26, "Input",ExpressionUUID->"ddb84e26-1814-46cb-85db-a3438b8d6c3a",
 CellID->6260626],
Cell[6571, 180, 566, 15, 35, "Output",ExpressionUUID->"d1fc635b-62d2-4982-af6d-525f6ee1bd3e",
 CellID->203031903]
}, Open  ]],
Cell[7152, 198, 147, 1, 38, "ExampleText",ExpressionUUID->"a88aa673-7da1-48b2-ab31-19d0b8c50baf",
 CellID->387305972],
Cell[CellGroupData[{
Cell[7324, 203, 172, 3, 26, "Input",ExpressionUUID->"11ab4475-0e10-4fa4-90b3-547127ffee0c",
 CellID->150385587],
Cell[7499, 208, 217, 5, 35, "Output",ExpressionUUID->"26984c31-b057-4f33-a0ee-df635ab0bfda",
 CellID->673865938]
}, Open  ]],
Cell[CellGroupData[{
Cell[7753, 218, 179, 4, 26, "Input",ExpressionUUID->"5495c640-c722-4396-a704-7cd5ebea25a8",
 CellID->403371443],
Cell[7935, 224, 566, 15, 35, "Output",ExpressionUUID->"69f16cc2-b2fc-4489-8983-4d7191499830",
 CellID->423682265]
}, Open  ]]
}, Open  ]],
Cell[8528, 243, 86, 0, 29, "SectionFooterSpacer",ExpressionUUID->"d9a0e801-3069-4dc6-8524-1e3720404444"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8651, 248, 260, 7, 72, "SeeAlsoSection",ExpressionUUID->"3caae8c8-8d3a-4486-8cda-f7875f3afd31",
 CellID->1255426704],
Cell[8914, 257, 424, 10, 24, "SeeAlso",ExpressionUUID->"10c1ac24-a610-430f-bc48-86b3d85515a0",
 CellID->929782353]
}, Open  ]],
Cell[9353, 270, 78, 0, 41, "FooterCell",ExpressionUUID->"c4a34f7e-dc29-4e5f-bc24-b0d113e34c85"]
}
]
*)

(* End of internal cache information *)

