(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    703235,      14431]
NotebookOptionsPosition[    689775,      14137]
NotebookOutlinePosition[    692136,      14197]
CellTagsIndexPosition[    692093,      14194]
WindowTitle->Examples
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["DATA ANALYSIS PACKAGE TUTORIAL", "PacletNameCell",ExpressionUUID->
     "103997e1-98e0-4f8b-810a-bda25afb47be"], Cell[TextData[Cell[BoxData[
     ActionMenuBox[
      FrameBox[
       InterpretationBox[Cell[TextData[{
         "URL",
         StyleBox[" \[FilledDownTriangle]", "AnchorBarArrow",
          StripOnInput->False]
        }],ExpressionUUID->"8490c4f1-e38a-4e87-bd42-ac2d09cdfa40"],
        TextCell[
         Row[{"URL", 
           Style[" \[FilledDownTriangle]", "AnchorBarArrow"]}]]],
       StripOnInput->False], {"\<\"DataAnalysis/tutorial/Features\"\>":>
      None, "\<\"Copy Wolfram Documentation Center URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["DataAnalysis/tutorial/Features"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/language/DataAnalysis/tutorial/\
Features.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
           Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
            If[
             TrueQ[DocumentationBuild`Make`Private`wsmlinkQ$55354], 
             "http://reference.wolfram.com/system-modeler/", 
             "http://reference.wolfram.com/language/"], 
            "DataAnalysis/tutorial/Features", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic,
      MenuStyle->"URLMenu"]],
     LineSpacing->{1.4, 0},ExpressionUUID->
     "e31e0f04-16ec-4d94-a4a9-29dcf346cb0d"]], "AnchorBar",ExpressionUUID->
     "49272ebe-8da8-45a5-9bdd-dd79a1ca3bad"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1,ExpressionUUID->"0be2e5c4-42d0-4fca-a47b-49b2374b8594"],

Cell[CellGroupData[{

Cell["Examples", "Title",
 CellID->509267359,ExpressionUUID->"8190d425-9c8f-4460-8281-e3bc0cba2ca0"],

Cell["Load the package:", "Text",
 CellID->739107753,ExpressionUUID->"de3d892d-bc89-4d80-8dab-b0b1bdb8a16a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"<<", "DataAnalysis`"}], ";"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->74146225,ExpressionUUID->"aab4c968-ffc2-43b9-bdbe-7072d7f7efff"],

Cell[CellGroupData[{

Cell["Uncertainty propagation", "Section",
 CellID->132105619,ExpressionUUID->"9115affe-a21d-45b5-8383-b64babc50ed3"],

Cell["\<\
Carry out simple forward propagation of uncertainties in an algebraic \
functions (95% confidence intervals are shown):\
\>", "Text",
 CellID->589426246,ExpressionUUID->"dba0c22a-d4c8-4992-ba60-53caf20c6afd"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"var", "=", 
  RowBox[{"DVEvaluate", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"NDV", "[", 
       RowBox[{"1", ",", "0.02"}], "]"}], "+", 
      RowBox[{"2", "*", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.1"}], "]"}]}]}], ")"}], "^", "2"}], 
   "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->87344918,ExpressionUUID->"d00a8f33-eb9a-4a02-a441-cb7499da6b91"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"121.0\"", 121., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "87","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[121., 4.421945273293192, $CellContext`dv$7319]]], "Output",
 ImageSize->{67, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->466118847,ExpressionUUID->"59e60168-f5e9-4816-bd19-037de73e261b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{"var", "^", 
   RowBox[{"NDV", "[", 
    RowBox[{"2", ",", "0.02"}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->72611468,ExpressionUUID->"01da872e-522e-4bbe-b113-d98f74c4a407"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"1.46\"", 1.4641000000000002`, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "35","\")\[Times]\"",
     TemplateBox[{"10", "4"}, "Superscript", SyntaxForm -> SuperscriptBox]},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[14641., 1765.56082724926, $CellContext`dv$7327]]], "Output",
 ImageSize->{87, 16},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->659205163,ExpressionUUID->"ccfc1f99-a9dc-43a1-b78b-becc3a8b95ad"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DVEvaluate", "[", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{"var", "/", 
     RowBox[{"NDV", "[", 
      RowBox[{"2", ",", "0.1"}], "]"}]}], "]"}], "//", "N"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->165117697,ExpressionUUID->"95f03170-581f-431d-a44f-2cbe6dbff286"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"4.10\"", 4.102643365036796, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "12","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[
  4.102643365036796, 0.06193171392818581, $CellContext`dv$7336]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->112864039,ExpressionUUID->"53df9b43-a5cd-4171-8bf4-ca4be0758d57"]
}, Open  ]],

Cell["Show confidence intervals with \[PlusMinus] instead of in \
parentheses:", "Text",
 CellID->175075549,ExpressionUUID->"dbccecb9-7111-46cc-bce5-3e5d607b465b"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"$UsePlusMinusForm", "=", "True"}], 
  ";"}], "\[IndentingNewLine]", "var"}], "Input",
 CellLabel->"In[4]:=",
 CellID->563333876,ExpressionUUID->"f49f951c-91af-4066-9a91-4d8db321ce31"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"121.0\"", 121., AutoDelete -> True], NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus]\"",TagBox[
      InterpretationBox["\"8.7\"", 8.666853477261782, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ]},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[121., 4.421945273293192, $CellContext`dv$7319]]], "Output",
 ImageSize->{67, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->18188078,ExpressionUUID->"defdb727-3a30-411e-9a72-a86cd1932a36"]
}, Open  ]],

Cell["\<\
Carry out a Monte Carlo simulation (optionally with parallel kernels) with a \
numerical function and input parameters with uncertainties and 1000 \
iterations:\
\>", "Text",
 CellID->499431572,ExpressionUUID->"9f7edc6b-6c91-432b-ac73-13ac2431ef23"],

Cell[BoxData[
 RowBox[{
  RowBox[{"res", "=", 
   RowBox[{"MonteCarloSimulation", "[", 
    RowBox[{
     RowBox[{"Hold", "[", "\[IndentingNewLine]", 
      RowBox[{"NArgMin", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"a", " ", 
          RowBox[{"x", "^", "2"}]}], "-", 
         RowBox[{"b", " ", "x"}], "+", "5"}], ",", "x"}], "]"}], 
      "\[IndentingNewLine]", "]"}], ",", "1000", ",", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"a", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"2", ",", "0.1"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"b", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"3", ",", "0.2"}], "]"}]}]}], "\[IndentingNewLine]", "}"}]}],
     "]"}]}], ";"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->589378977,ExpressionUUID->"17deac04-22ac-4d0b-8dc7-4678403ffd8d"],

Cell["Display the resulting mean and standard deviation:", "Text",
 CellID->474298645,ExpressionUUID->"a1d5af39-7c5b-4d73-ad70-e7b89c01f413"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<DistributionMeanNDV\>\"", "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->531204403,ExpressionUUID->"b841a787-8fd7-4b40-a195-f8d72862a73d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"0.75\"", 0.7518174621721718, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
     "\"\[PlusMinus]\"",TagBox[
      InterpretationBox["\"0.13\"", 0.1257948365255468, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ]},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[
  0.7518174621721718, 0.06418221840697096, $CellContext`dv$20239]]], "Output",
 ImageSize->{67, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->244107574,ExpressionUUID->"c45b8662-598d-4b2e-abaa-3baa0c3dc042"]
}, Open  ]],

Cell["\<\
Display sensitivity plots, which can be used to identify input uncertainties \
that affect the variance in the result, and explore the simulation data:\
\>", "Text",
 CellID->242637655,ExpressionUUID->"87a9820b-6872-4f1d-9293-74a86558c8fb"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<SensitivityPlots\>\"", "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->44106417,ExpressionUUID->"20b9eb40-175d-4ac0-8ae5-18eeec2e9d0f"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     GraphicsBox[{{}, {
        {RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
         AbsolutePointSize[6], AbsoluteThickness[1.6], 
         GeometricTransformationBox[InsetBox[
           GraphicsBox[
            {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
             AbsoluteThickness[1.6], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}]},
            ImageSize->10], {0., 0.}], CompressedData["
1:eJwVmnk8VG8bxs8IkTV72SmEsm8l91GRfUlRiqKUbIUopT1LlK2fvUhCqVQI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          "]]}, {}}, {}, {}, {}, {}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->{False, False},
      AxesLabel->{None, None},
      AxesOrigin->{1.6665412740801873`, 0.5587107411077231},
      DisplayFunction->Identity,
      Frame->{{True, True}, {True, True}},
      FrameLabel->{{None, None}, {None, None}},
      FrameStyle->GrayLevel[0],
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      FrameTicksStyle->12,
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->450,
      LabelStyle->12,
      Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotLabel->FormBox[
        StyleBox["a", 16, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{1.676017439864541, 2.282492050063191}, {0.5780402270754109,
        0.964629946429167}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]},
    {
     GraphicsBox[{{}, {
        {RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
         AbsolutePointSize[6], AbsoluteThickness[1.6], 
         GeometricTransformationBox[InsetBox[
           GraphicsBox[
            {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
             AbsoluteThickness[1.6], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}]},
            ImageSize->10], {0., 0.}], CompressedData["
1:eJwVmHk4VP8bhomZc2ZIlqKyVkIUJaHI+2qRJWVPC0kqSSnK2r4qpMgSRRSK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          "]]}, {}}, {}, {}, {}, {}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->{False, False},
      AxesLabel->{None, None},
      AxesOrigin->{2.3762930047821142`, 0.5587107411077231},
      DisplayFunction->Identity,
      Frame->{{True, True}, {True, True}},
      FrameLabel->{{None, None}, {None, None}},
      FrameStyle->GrayLevel[0],
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      FrameTicksStyle->12,
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->450,
      LabelStyle->12,
      Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotLabel->FormBox[
        StyleBox["b", 16, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{2.395901036457799, 3.6508150637016374`}, {
       0.5780402270754109, 0.964629946429167}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{5}}}],
  "Grid"]], "Output",
 ImageSize->{454, 613},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->790959085,ExpressionUUID->"332e9b51-d87f-4460-b010-5ef185c787f5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"res", "[", "\"\<Histogram\>\"", "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->864329415,ExpressionUUID->"0dafd77e-3e28-4221-ac1a-e85c42db8fb5"],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], EdgeForm[{
    Opacity[0.5389999999999999], Thickness[Small]}], {}, 
    {RGBColor[0.987148, 0.8073604000000001, 0.49470040000000004`], EdgeForm[{
     Opacity[0.5389999999999999], Thickness[Small]}], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.56, 0}, {0.58, 2.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{24.92934347477984, 35.38016127187461}, {
          53.149681112443425`, 55.58941623502808}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.58, 0}, {0.6, 5.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{34.88016127187461, 45.33097906896944}, {
          50.24007842856644, 55.58941623502808}}],
        StatusArea[#, 5]& ,
        TagBoxNote->"5"],
       StyleBox["5", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[5, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.6, 0}, {0.62, 8.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{44.83097906896944, 55.28179686606427}, {
          47.33047574468946, 55.58941623502808}}],
        StatusArea[#, 8]& ,
        TagBoxNote->"8"],
       StyleBox["8", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[8, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.62, 0}, {0.64, 22.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{54.78179686606427, 65.2326146631591}, {
          33.752329886596854`, 55.58941623502808}}],
        StatusArea[#, 22]& ,
        TagBoxNote->"22"],
       StyleBox["22", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[22, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.64, 0}, {0.66, 36.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{64.7326146631591, 75.18343246025393}, {
          20.174184028504264`, 55.58941623502808}}],
        StatusArea[#, 36]& ,
        TagBoxNote->"36"],
       StyleBox["36", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[36, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.66, 0}, {0.68, 56.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{74.68343246025393, 85.13425025734875}, {
          0.7768328026576938, 55.58941623502808}}],
        StatusArea[#, 56]& ,
        TagBoxNote->"56"],
       StyleBox["56", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[56, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.68, 0}, {0.7, 83.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{84.63425025734875, 
          95.08506805444352}, {-25.409591352235168`, 55.58941623502808}}],
        StatusArea[#, 83]& ,
        TagBoxNote->"83"],
       StyleBox["83", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[83, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.7, 0}, {0.72, 109.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{94.58506805444352, 
          105.03588585153835`}, {-50.6261479458357, 55.58941623502808}}],
        StatusArea[#, 109]& ,
        TagBoxNote->"109"],
       StyleBox["109", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[109, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.72, 0}, {0.74, 114.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{104.53588585153835`, 
          114.98670364863318`}, {-55.475485752297345`, 55.58941623502808}}],
        StatusArea[#, 114]& ,
        TagBoxNote->"114"],
       StyleBox["114", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[114, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.74, 0}, {0.76, 129.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{114.48670364863318`, 
          124.93752144572801`}, {-70.02349917168227, 55.58941623502808}}],
        StatusArea[#, 129]& ,
        TagBoxNote->"129"],
       StyleBox["129", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[129, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.76, 0}, {0.78, 109.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{124.43752144572801`, 
          134.88833924282284`}, {-50.6261479458357, 55.58941623502808}}],
        StatusArea[#, 109]& ,
        TagBoxNote->"109"],
       StyleBox["109", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[109, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.78, 0}, {0.8, 93.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{134.38833924282284`, 
          144.83915703991767`}, {-35.10826696515845, 55.58941623502808}}],
        StatusArea[#, 93]& ,
        TagBoxNote->"93"],
       StyleBox["93", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[93, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.8, 0}, {0.82, 86.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{144.33915703991767`, 
          154.78997483701244`}, {-28.31919403611215, 55.58941623502808}}],
        StatusArea[#, 86]& ,
        TagBoxNote->"86"],
       StyleBox["86", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[86, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.82, 0}, {0.84, 60.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{154.28997483701244`, 
          164.74079263410727`}, {-3.1026374425116146`, 55.58941623502808}}],
        StatusArea[#, 60]& ,
        TagBoxNote->"60"],
       StyleBox["60", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[60, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.84, 0}, {0.86, 42.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{164.24079263410727`, 174.6916104312021}, {
          14.354978660750291`, 55.58941623502808}}],
        StatusArea[#, 42]& ,
        TagBoxNote->"42"],
       StyleBox["42", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[42, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.86, 0}, {0.88, 23.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{174.1916104312021, 184.64242822829692`}, {
          32.782462325304536`, 55.58941623502808}}],
        StatusArea[#, 23]& ,
        TagBoxNote->"23"],
       StyleBox["23", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[23, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.88, 0}, {0.9, 12.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{184.14242822829692`, 194.59324602539175`}, {
          43.45100549952014, 55.58941623502808}}],
        StatusArea[#, 12]& ,
        TagBoxNote->"12"],
       StyleBox["12", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[12, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.9, 0}, {0.92, 3.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{194.09324602539175`, 204.54406382248658`}, {
          52.1798135511511, 55.58941623502808}}],
        StatusArea[#, 3]& ,
        TagBoxNote->"3"],
       StyleBox["3", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[3, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.92, 0}, {0.94, 5.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{204.04406382248658`, 214.49488161958135`}, {
          50.24007842856644, 55.58941623502808}}],
        StatusArea[#, 5]& ,
        TagBoxNote->"5"],
       StyleBox["5", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[5, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.94, 0}, {0.96, 2.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{213.99488161958135`, 224.44569941667618`}, {
          53.149681112443425`, 55.58941623502808}}],
        StatusArea[#, 2]& ,
        TagBoxNote->"2"],
       StyleBox["2", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[2, {}], "Tooltip"]& ], 
     TagBox[
      TooltipBox[
       TagBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          RectangleBox[{0.96, 0}, {0.98, 1.}, "RoundingRadius" -> 0]},
         ImageSizeCache->{{223.94569941667618`, 234.396517213771}, {
          54.11954867373576, 55.58941623502808}}],
        StatusArea[#, 1]& ,
        TagBoxNote->"1"],
       StyleBox["1", {}, StripOnInput -> False]],
      Annotation[#, 
       Style[1, {}], 
       "Tooltip"]& ]}, {}, {}}, {{}, {}, {}, {}, {}, {}, {}, {}, {}, {}, {}, \
{}, {}, {}, {}, {}, {}, {}, {}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{True, True},
  AxesLabel->{None, None},
  AxesOrigin->{0.5516000000000001, 0},
  FrameLabel->{{None, None}, {None, None}},
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  PlotRange->{{0.56, 0.98}, {All, All}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.05]}},
  Ticks->{Automatic, Automatic}]], "Output",
 ImageSize->{244, 149},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->203639560,ExpressionUUID->"3c0df588-722a-4053-b336-b7d882f6ff73"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Data tables", "Section",
 CellID->54902907,ExpressionUUID->"67df2717-ed14-4a8e-8aaa-580723863377"],

Cell[TextData[{
 "Construct a ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["DataTable"]],"paclet:DataAnalysis/ref/DataTable"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "bbe5b152-c2e0-4744-888e-884fca0f822a"],
 " from an array of data or associations. The buttons can be used to show the \
table in Microsoft Excel (in Windows systems) or copy it to the clipboard as \
tab separated values (TSV):"
}], "Text",
 CellID->17510087,ExpressionUUID->"2f587f95-2006-4b64-af1a-0e5124ea7f4b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "\"\<ID\>\"", ",", "\"\<a\>\"", ",", "\"\<b\>\"", ",", "\"\<c\>\""}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<k\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.05"}], "]"}], ",", "2", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1", ",", "0.7"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<l\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.3"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"6", ",", "0.2"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<m\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"7", ",", "0.2"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"8", ",", "0.1"}], "]"}], ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"5", ",", "0.9"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\"\<n\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1.5", ",", "0.8"}], "]"}], ",", "8", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4", ",", "0.2"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", 
    "}"}], "]"}]}]], "Input",
 CellLabel->"In[10]:=",
 CellID->186041130,ExpressionUUID->"3d1ac562-3202-492a-a9ed-477ce3eb5bbb"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$20943], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$20944], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$20945]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$20946], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$20947], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$20948]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$20949], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$20950]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 124494055493069]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$20943], "b" -> 
                DataAnalysis`NDV[5, 0.2, $CellContext`dv$20944], "c" -> 
                DataAnalysis`NDV[6, 0.2, $CellContext`dv$20945]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$20946], "b" -> 
                DataAnalysis`NDV[8, 0.1, $CellContext`dv$20947], "c" -> 
                DataAnalysis`NDV[5, 0.9, $CellContext`dv$20948]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$20949], "b" -> 
                8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$20950]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association["ID" -> 124494055493069]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$20943], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$20944], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$20945]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$20946], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$20947], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$20948]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$20949], "b" -> 
                 8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$20950]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 124494055493069]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[4, 0.3, $CellContext`dv$20943], "b" -> 
                 DataAnalysis`NDV[5, 0.2, $CellContext`dv$20944], "c" -> 
                 DataAnalysis`NDV[6, 0.2, $CellContext`dv$20945]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[7, 0.2, $CellContext`dv$20946], "b" -> 
                 DataAnalysis`NDV[8, 0.1, $CellContext`dv$20947], "c" -> 
                 DataAnalysis`NDV[5, 0.9, $CellContext`dv$20948]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$20949], "b" -> 
                 8, "c" -> DataAnalysis`NDV[4, 0.2, $CellContext`dv$20950]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association["ID" -> 124494055493069]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[0]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`UnknownShape, "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 4, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[163373316], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[163373316]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1895329451][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1895329451][{All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1895329451][{All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1895329451][{All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1895329451][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.000\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.098\"", 0.0979981992270027, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.0\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"1.4\"", 1.3719747891780378`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1895329451][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.59\"", 0.5879891953620162, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.3, $CellContext`dv$20943]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.3919927969080108, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.2, $CellContext`dv$20944]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"6.00\"", 6., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.3919927969080108, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[6, 0.2, $CellContext`dv$20945]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1895329451][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"7.00\"", 7., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.3919927969080108, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[7, 0.2, $CellContext`dv$20946]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"8.00\"", 8., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.20\"", 0.1959963984540054, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[8, 0.1, $CellContext`dv$20947]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.0\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"1.8\"", 1.7639675860860486`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[5, 0.9, $CellContext`dv$20948]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1895329451][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.5\"", 1.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"1.6\"", 1.5679711876320432`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1.5, 0.8, $CellContext`dv$20949]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"4.00\"", 4., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.3919927969080108, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[4, 0.2, $CellContext`dv$20950]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1895329451][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1895329451][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1895329451]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1895329451][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1895329451][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {299., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->596105155,ExpressionUUID->"f3cbb242-c2ab-4cac-aca5-9b70f30ee35e"]
}, Open  ]],

Cell["\<\
Use a queries and other Dataset functions to the results with automatic \
uncertainty propagation:\
\>", "Text",
 CellID->177205639,ExpressionUUID->"2f8e1253-874c-47e2-8042-9251e07029df"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl", "[", 
  RowBox[{"All", ",", 
   RowBox[{
    RowBox[{
     RowBox[{"#\"a\"", "*", "#\"b\""}], "+", "#\"c\""}], "&"}]}], 
  "]"}]], "Input",
 CellLabel->"In[11]:=",
 CellID->600157041,ExpressionUUID->"d8bf62aa-c5ff-4acb-8e9d-a8cb5b0be969"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> DataAnalysis`NDV[
               3., 0.7071067811865475, $CellContext`dv$21376], "l" -> 
              DataAnalysis`NDV[26., 1.711724276862369, $CellContext`dv$21381],
               "m" -> DataAnalysis`NDV[
               61., 1.9646882704388502`, $CellContext`dv$21386], "n" -> 
              DataAnalysis`NDV[
               16., 6.403124237432849, $CellContext`dv$21390]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[
               TypeSystem`Enumeration["k", "l", "m", "n"]], 
              TypeSystem`AnyType, 4], 
             Association[
             "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                Dataset`DatasetHandle[249477603806671]], "ID" -> 
              249499078643151]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> DataAnalysis`NDV[
               3., 0.7071067811865475, $CellContext`dv$21376], "l" -> 
              DataAnalysis`NDV[26., 1.711724276862369, $CellContext`dv$21381],
               "m" -> DataAnalysis`NDV[
               61., 1.9646882704388502`, $CellContext`dv$21386], "n" -> 
              DataAnalysis`NDV[
               16., 6.403124237432849, $CellContext`dv$21390]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[
               TypeSystem`Enumeration["k", "l", "m", "n"]], 
              TypeSystem`AnyType, 4], 
             Association[
             "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                Dataset`DatasetHandle[249477603806671]], "ID" -> 
              249499078643151]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> DataAnalysis`NDV[
                3., 0.7071067811865475, $CellContext`dv$21376], "l" -> 
               DataAnalysis`NDV[
                26., 1.711724276862369, $CellContext`dv$21381], "m" -> 
               DataAnalysis`NDV[
                61., 1.9646882704388502`, $CellContext`dv$21386], "n" -> 
               DataAnalysis`NDV[
                16., 6.403124237432849, $CellContext`dv$21390]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[
                TypeSystem`Enumeration["k", "l", "m", "n"]], 
               TypeSystem`AnyType, 4], 
              Association[
              "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                 Dataset`DatasetHandle[249477603806671]], "ID" -> 
               249499078643151]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> DataAnalysis`NDV[
                3., 0.7071067811865475, $CellContext`dv$21376], "l" -> 
               DataAnalysis`NDV[
                26., 1.711724276862369, $CellContext`dv$21381], "m" -> 
               DataAnalysis`NDV[
                61., 1.9646882704388502`, $CellContext`dv$21386], "n" -> 
               DataAnalysis`NDV[
                16., 6.403124237432849, $CellContext`dv$21390]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[
                TypeSystem`Enumeration["k", "l", "m", "n"]], 
               TypeSystem`AnyType, 4], 
              Association[
              "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                 Dataset`DatasetHandle[249477603806671]], "ID" -> 
               249499078643151]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[
               TypeSystem`Enumeration["k", "l", "m", "n"]], 
              TypeSystem`AnyType, 4], "Shape" -> 
            TypeSystem`PackageScope`Limited[
              TypeSystem`PackageScope`ColumnShape[
               TypeSystem`PackageScope`KeyValueShape[
                TypeSystem`PackageScope`AtomShape[27.], 
                TypeSystem`PackageScope`UnknownShape]], 4, {}], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[1251379375], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[
               TypeSystem`Enumeration["k", "l", "m", "n"]], 
              TypeSystem`AnyType, 4], "HandleQ" -> True, "RowTarget" -> 20, 
            "Data" -> TypeSystem`PackageScope`CacheHandle[1251379375]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 936656951][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    936656951][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{27., Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"3.0\"", 3., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"1.4\"", 1.3859038243496777`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3., 0.7071067811865475, $CellContext`dv$21376]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    936656951][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 936656951][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    936656951][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{27., Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"26.0\"", 26., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"3.4\"", 3.3549179341131117`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    26., 1.711724276862369, $CellContext`dv$21381]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    936656951][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 936656951][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    936656951][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{27., Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"61.0\"", 61., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"3.9\"", 3.850718250908436, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    61., 1.9646882704388502`, $CellContext`dv$21386]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    936656951][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 936656951][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    936656951][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{27., Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    
                    TemplateBox[{"16", "\"\[PlusMinus]\"", "13"}, 
                    "RowDefault"], ShowStringCharacters -> False, 
                    StripOnInput -> False], 
                    DataAnalysis`NDV[
                    16., 6.403124237432849, $CellContext`dv$21390]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    936656951][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 936656951][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 936656951]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[936656951][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[936656951][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {111., {57., 63.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 152},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]=",
 CellID->8792351,ExpressionUUID->"a25281bb-1d15-460a-b0ab-77e24557c655"]
}, Open  ]],

Cell[TextData[{
 "Use functions or operators such as ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["FoldValues"]],"paclet:DataAnalysis/ref/FoldValues"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "0dafee69-a14d-4e2c-89a6-3860cfbabb17"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["GroupByKey"]],"paclet:DataAnalysis/ref/GroupByKey"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "b2348de7-b349-47c8-9ad3-10e523360070"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["MeanAndStandardError"]],
    "paclet:DataAnalysis/ref/MeanAndStandardError"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "e901b0f3-7cc3-414b-bc0d-3dee9d38cc32"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PartitionAssociation"]],
    "paclet:DataAnalysis/ref/PartitionAssociation"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "1a941d41-cf08-42fa-b6f3-a27b7c439869"],
 ", ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["QueryTo"]],"paclet:DataAnalysis/ref/QueryTo"},
   "RefLink",
   BaseStyle->{"InlineFormula"}]], "InlineFormula",ExpressionUUID->
  "064e21f6-2107-4b12-8cb7-0bb53cd849b1"],
 " for transformations of data tables:"
}], "Text",
 CellID->162507499,ExpressionUUID->"7d0ed4ac-3b04-4f2e-9ba6-15932676d794"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tbl", "[", 
  RowBox[{"FoldValues", "[", "Plus", "]"}], "]"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->247362543,ExpressionUUID->"6d87107d-1f56-4f26-9da8-4760e2bbad9e"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[
                 5., 0.30413812651491096`, $CellContext`dv$22023], "b" -> 
                DataAnalysis`NDV[7., 0.2, $CellContext`dv$22026], "c" -> 
                DataAnalysis`NDV[
                 7., 0.7280109889280517, $CellContext`dv$22030]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[
                 12., 0.3640054944640259, $CellContext`dv$22036], "b" -> 
                DataAnalysis`NDV[
                 15., 0.223606797749979, $CellContext`dv$22040], "c" -> 
                DataAnalysis`NDV[
                 12., 1.1575836902790226`, $CellContext`dv$22045]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[
                 13.5, 0.8789197915623473, $CellContext`dv$22052], "b" -> 
                DataAnalysis`NDV[
                 23., 0.223606797749979, $CellContext`dv$22056], "c" -> 
                DataAnalysis`NDV[
                 16., 1.174734012447073, $CellContext`dv$22062]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association[
             "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                Dataset`DatasetHandle[126478330383826]], "ID" -> 
              126499805220306]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "k" -> Association[
               "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941], "b" -> 
                2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
              "l" -> Association[
               "a" -> DataAnalysis`NDV[
                 5., 0.30413812651491096`, $CellContext`dv$22023], "b" -> 
                DataAnalysis`NDV[7., 0.2, $CellContext`dv$22026], "c" -> 
                DataAnalysis`NDV[
                 7., 0.7280109889280517, $CellContext`dv$22030]], "m" -> 
              Association[
               "a" -> DataAnalysis`NDV[
                 12., 0.3640054944640259, $CellContext`dv$22036], "b" -> 
                DataAnalysis`NDV[
                 15., 0.223606797749979, $CellContext`dv$22040], "c" -> 
                DataAnalysis`NDV[
                 12., 1.1575836902790226`, $CellContext`dv$22045]], "n" -> 
              Association[
               "a" -> DataAnalysis`NDV[
                 13.5, 0.8789197915623473, $CellContext`dv$22052], "b" -> 
                DataAnalysis`NDV[
                 23., 0.223606797749979, $CellContext`dv$22056], "c" -> 
                DataAnalysis`NDV[
                 16., 1.174734012447073, $CellContext`dv$22062]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], 
             Association[
             "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                Dataset`DatasetHandle[126478330383826]], "ID" -> 
              126499805220306]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[
                  5., 0.30413812651491096`, $CellContext`dv$22023], "b" -> 
                 DataAnalysis`NDV[7., 0.2, $CellContext`dv$22026], "c" -> 
                 DataAnalysis`NDV[
                  7., 0.7280109889280517, $CellContext`dv$22030]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[
                  12., 0.3640054944640259, $CellContext`dv$22036], "b" -> 
                 DataAnalysis`NDV[
                  15., 0.223606797749979, $CellContext`dv$22040], "c" -> 
                 DataAnalysis`NDV[
                  12., 1.1575836902790226`, $CellContext`dv$22045]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[
                  13.5, 0.8789197915623473, $CellContext`dv$22052], "b" -> 
                 DataAnalysis`NDV[
                  23., 0.223606797749979, $CellContext`dv$22056], "c" -> 
                 DataAnalysis`NDV[
                  16., 1.174734012447073, $CellContext`dv$22062]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association[
              "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                 Dataset`DatasetHandle[126478330383826]], "ID" -> 
               126499805220306]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "k" -> Association[
                "a" -> DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941], "b" -> 
                 2, "c" -> DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
               "l" -> Association[
                "a" -> DataAnalysis`NDV[
                  5., 0.30413812651491096`, $CellContext`dv$22023], "b" -> 
                 DataAnalysis`NDV[7., 0.2, $CellContext`dv$22026], "c" -> 
                 DataAnalysis`NDV[
                  7., 0.7280109889280517, $CellContext`dv$22030]], "m" -> 
               Association[
                "a" -> DataAnalysis`NDV[
                  12., 0.3640054944640259, $CellContext`dv$22036], "b" -> 
                 DataAnalysis`NDV[
                  15., 0.223606797749979, $CellContext`dv$22040], "c" -> 
                 DataAnalysis`NDV[
                  12., 1.1575836902790226`, $CellContext`dv$22045]], "n" -> 
               Association[
                "a" -> DataAnalysis`NDV[
                  13.5, 0.8789197915623473, $CellContext`dv$22052], "b" -> 
                 DataAnalysis`NDV[
                  23., 0.223606797749979, $CellContext`dv$22056], "c" -> 
                 DataAnalysis`NDV[
                  16., 1.174734012447073, $CellContext`dv$22062]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               
               TypeSystem`Struct[{"a", "b", "c"}, {
                TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
               4], 
              Association[
              "Origin" -> HoldComplete[Map, DataAnalysis`DVEvaluate[#]& , 
                 Dataset`DatasetHandle[126478330383826]], "ID" -> 
               126499805220306]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[1]} -> 1, {All, "a"} -> 
               1, {All, "b"} -> 1, {All, "c"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[28.800000000000004`], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "a" -> TypeSystem`PackageScope`UnknownShape, "b" -> 
                   TypeSystem`PackageScope`UnknownShape, "c" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 4, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[491009146], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              
              TypeSystem`Struct[{"a", "b", "c"}, {
               TypeSystem`AnyType, TypeSystem`AnyType, TypeSystem`AnyType}], 
              4], "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[491009146]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1925153369][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"a\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"a\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1925153369][{All, "a"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[All, "a"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"b\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"b\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1925153369][{All, "b"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[All, "b"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"c\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"c\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1925153369][{All, "c"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[All, "c"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["k", 
                    Style[
                    "k", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1925153369][{
                    Key["k"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["k"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.000\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.098\"", 0.0979981992270027, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.05, $CellContext`dv$20941]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"1.0\"", 1., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"1.4\"", 1.3719747891780378`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[1, 0.7, $CellContext`dv$20942]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["k"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["l", 
                    Style[
                    "l", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1925153369][{
                    Key["l"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["l"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"5.00\"", 5., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.60\"", 0.596099774294712, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    5., 0.30413812651491096`, $CellContext`dv$22023]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"7.00\"", 7., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.39\"", 0.3919927969080108, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[7., 0.2, $CellContext`dv$22026]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"7.0\"", 7., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"1.4\"", 1.4268753186483694`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    7., 0.7280109889280517, $CellContext`dv$22030]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["l"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["m", 
                    Style[
                    "m", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1925153369][{
                    Key["m"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["m"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"12.00\"", 12., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.71\"", 0.7134376593241848, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    12., 0.3640054944640259, $CellContext`dv$22036]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"15.00\"", 15., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.44\"", 0.4382612702882908, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    15., 0.223606797749979, $CellContext`dv$22040]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"12.0\"", 12., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"2.3\"", 2.268822342037853, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    12., 1.1575836902790226`, $CellContext`dv$22045]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["m"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["n", 
                    Style[
                    "n", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1925153369][{
                    Key["n"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["n"]]], "Mouse"], 
                    ImageSize -> {{28.800000000000004`, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"13.5\"", 13.5, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"1.7\"", 1.7226511367616522`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    13.5, 0.8789197915623473, $CellContext`dv$22052]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["a"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"23.00\"", 23., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"0.44\"", 0.4382612702882908, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    23., 0.223606797749979, $CellContext`dv$22056]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["b"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox["\"16.0\"", 16., AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, ExponentFunction -> (Null& )]& ],
                     "\"\[PlusMinus]\"", 
                    TagBox[
                    InterpretationBox[
                    "\"2.3\"", 2.302436355810491, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 1}, 
                    ExponentFunction -> (Null& )]& ]}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    16., 1.174734012447073, $CellContext`dv$22062]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1925153369][
                    GeneralUtilities`Slice[
                    Key["n"], 
                    Key["c"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1925153369][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1925153369]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1925153369][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1925153369][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {299., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]=",
 CellID->535427235,ExpressionUUID->"15ef125f-fc46-4521-8516-8119e613a1f4"]
}, Open  ]],

Cell["\<\
Construct an effective variance fit, fitting the data to a non-linear \
equation under consideration of uncertainties in all variables:\
\>", "Text",
 CellID->41393484,ExpressionUUID->"310a84f6-bee0-4cbf-956b-510b6c249392"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fit", "=", 
  RowBox[{"EffectiveVarianceFit", "[", 
   RowBox[{
    RowBox[{"tbl", "[", 
     RowBox[{"All", ",", 
      RowBox[{"{", 
       RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"\"\<a\>\"", "^", "2"}], "*", "x"}], "+", 
     RowBox[{"\"\<a\>\"", "*", "y"}], "+", "z"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}], ",", 
    RowBox[{"{", "\"\<a\>\"", "}"}], ",", "5"}], "]"}]}]], "Input",
 CellLabel->"In[13]:=",
 CellID->27194385,ExpressionUUID->"335d8e05-2c26-46aa-81ac-be73c58018ff"],

Cell[BoxData[
 TagBox[
  RowBox[{"FittedModel", "[", 
   TagBox[
    PanelBox[
     TagBox[
      RowBox[{
       RowBox[{"-", "1.7237209772845679`"}], "+", 
       RowBox[{"3.2369725008181036`", " ", 
        RowBox[{"VarKey", "[", "\<\"a\"\>", "]"}]}], "-", 
       RowBox[{"0.32580990579558483`", " ", 
        SuperscriptBox[
         RowBox[{"VarKey", "[", "\<\"a\"\>", "]"}], "2"]}]}],
      Short[#, 2]& ],
     FrameMargins->5],
    Editable -> False], "]"}],
  InterpretTemplate[
  FittedModel[{
    "Nonlinear", {$CellContext`x -> -0.32580990579558483`, $CellContext`y -> 
      3.2369725008181036`, $CellContext`z -> -1.7237209772845679`}, {{
       DataAnalysis`VarKey["a"]}, $CellContext`z + $CellContext`y 
       DataAnalysis`VarKey["a"] + $CellContext`x 
       DataAnalysis`VarKey["a"]^2}}, {{1.9735300567983292`, 
    13.199074761963628`, 1.1361669832810302`, 
    0.3024109493854418}}, {{1, 1}, {4, 6}, {7, 5}, {1.5, 4}}, 
    Function[Null, 
     Internal`LocalizedBlock[{$CellContext`x, $CellContext`y, $CellContext`z, 
       DataAnalysis`VarKey["a"]}, #], {HoldAll}], 
    VarianceEstimatorFunction -> (1& )]& ],
  Editable->False,
  SelectWithContents->True,
  Selectable->True]], "Output",
 ImageSize->{363, 36},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[13]=",
 CellID->829375379,ExpressionUUID->"e8479e16-7f1f-4c61-b22b-0cf1c4846d7e"]
}, Open  ]],

Cell[TextData[{
 "Plot the data using error bars (the ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["SciDraw"]],"https://scidraw.nd.edu/"},
   "WebLink",
   BaseStyle->{"Text"}]],ExpressionUUID->
  "c6003af6-1cc8-4fc1-8b62-8cb4d56b1d63"],
 " package can also be used):"
}], "Text",
 CellID->123141521,ExpressionUUID->"73ddfa70-9194-42cb-a238-9b8db9af7a1c"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DTPlot", "[", 
    RowBox[{
     RowBox[{"tbl", "[", 
      RowBox[{"All", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<a\>\"", ",", "\"\<c\>\""}], "}"}]}], "]"}], ",", 
     RowBox[{"ImageSize", "\[Rule]", "500"}], ",", 
     RowBox[{"PlotRangePadding", "\[Rule]", "0.5"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"fit", "[", "a", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "0", ",", "10"}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->595642825,ExpressionUUID->"0db31235-173a-4645-8105-9324c694152d"],

Cell[BoxData[
 GraphicsBox[{{{}, {{{}, 
      {RGBColor[0.368417, 0.506779, 0.709798], PointSize[
       0.012833333333333334`], AbsoluteThickness[1.6], 
       PointBox[{{1., 1.}, {4., 6.}, {7., 5.}, {1.5, 4.}}], {{
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{1.0979981992270027`, 1.}, {0.9020018007729973, 1.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {1.0979981992270027`, 1.}], 
            Offset[{0, -1.5}, {1.0979981992270027`, 1.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {0.9020018007729973, 1.}], 
            Offset[{0, -1.5}, {0.9020018007729973, 1.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{1., 2.371974789178038}, {1., -0.37197478917803783`}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {1., 2.371974789178038}], 
            Offset[{-1.5, 0}, {1., 2.371974789178038}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {1., -0.37197478917803783`}], 
            Offset[{-1.5, 0}, {1., -0.37197478917803783`}]}]}}, {
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{4.587989195362017, 6.}, {3.412010804637984, 6.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {4.587989195362017, 6.}], 
            Offset[{0, -1.5}, {4.587989195362017, 6.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {3.412010804637984, 6.}], 
            Offset[{0, -1.5}, {3.412010804637984, 6.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{4., 6.391992796908011}, {4., 5.608007203091989}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {4., 6.391992796908011}], 
            Offset[{-1.5, 0}, {4., 6.391992796908011}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {4., 5.608007203091989}], 
            Offset[{-1.5, 0}, {4., 5.608007203091989}]}]}}, {
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{7.391992796908011, 5.}, {6.608007203091989, 5.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {7.391992796908011, 5.}], 
            Offset[{0, -1.5}, {7.391992796908011, 5.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {6.608007203091989, 5.}], 
            Offset[{0, -1.5}, {6.608007203091989, 5.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{7., 6.763967586086048}, {7., 3.2360324139139514`}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {7., 6.763967586086048}], 
            Offset[{-1.5, 0}, {7., 6.763967586086048}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {7., 3.2360324139139514`}], 
            Offset[{-1.5, 0}, {7., 3.2360324139139514`}]}]}}, {
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{3.0679711876320432`, 4.}, {-0.06797118763204324, 4.}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {3.0679711876320432`, 4.}], 
            Offset[{0, -1.5}, {3.0679711876320432`, 4.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{0, 1.5}, {-0.06797118763204324, 4.}], 
            Offset[{0, -1.5}, {-0.06797118763204324, 4.}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{{1.5, 4.391992796908011}, {1.5, 3.608007203091989}}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {1.5, 4.391992796908011}], 
            Offset[{-1.5, 0}, {1.5, 4.391992796908011}]}]}, 
         {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
          LineBox[{
           Offset[{1.5, 0}, {1.5, 3.608007203091989}], 
            Offset[{-1.5, 0}, {1.5, 3.608007203091989}]}]}}}}, {}}, {
      TagBox[
       TooltipBox[
        {Opacity[0.], PointBox[{{1., 1.}}], {
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{1.0979981992270027`, 1.}, {0.9020018007729973, 1.}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {1.0979981992270027`, 1.}], 
             Offset[{0, -1.5}, {1.0979981992270027`, 1.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {0.9020018007729973, 1.}], 
             Offset[{0, -1.5}, {0.9020018007729973, 1.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{1., 2.371974789178038}, {1., -0.37197478917803783`}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {1., 2.371974789178038}], 
             Offset[{-1.5, 0}, {1., 2.371974789178038}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {1., -0.37197478917803783`}], 
             Offset[{-1.5, 0}, {1., -0.37197478917803783`}]}]}}},
        "\"k {1.000\[PlusMinus]0.098, 1.0\[PlusMinus]1.4}\"",
        TooltipStyle->"TextStyling"],
       Annotation[#, "k {1.000\[PlusMinus]0.098, 1.0\[PlusMinus]1.4}", 
        "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {Opacity[0.], PointBox[{{4., 6.}}], {
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{4.587989195362017, 6.}, {3.412010804637984, 6.}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {4.587989195362017, 6.}], 
             Offset[{0, -1.5}, {4.587989195362017, 6.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {3.412010804637984, 6.}], 
             Offset[{0, -1.5}, {3.412010804637984, 6.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{4., 6.391992796908011}, {4., 5.608007203091989}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {4., 6.391992796908011}], 
             Offset[{-1.5, 0}, {4., 6.391992796908011}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {4., 5.608007203091989}], 
             Offset[{-1.5, 0}, {4., 5.608007203091989}]}]}}},
        "\"l {4.00\[PlusMinus]0.59, 6.00\[PlusMinus]0.39}\"",
        TooltipStyle->"TextStyling"],
       Annotation[#, "l {4.00\[PlusMinus]0.59, 6.00\[PlusMinus]0.39}", 
        "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {Opacity[0.], PointBox[{{7., 5.}}], {
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{7.391992796908011, 5.}, {6.608007203091989, 5.}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {7.391992796908011, 5.}], 
             Offset[{0, -1.5}, {7.391992796908011, 5.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {6.608007203091989, 5.}], 
             Offset[{0, -1.5}, {6.608007203091989, 5.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{7., 6.763967586086048}, {7., 3.2360324139139514`}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {7., 6.763967586086048}], 
             Offset[{-1.5, 0}, {7., 6.763967586086048}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {7., 3.2360324139139514`}], 
             Offset[{-1.5, 0}, {7., 3.2360324139139514`}]}]}}},
        "\"m {7.00\[PlusMinus]0.39, 5.0\[PlusMinus]1.8}\"",
        TooltipStyle->"TextStyling"],
       Annotation[#, "m {7.00\[PlusMinus]0.39, 5.0\[PlusMinus]1.8}", 
        "Tooltip"]& ], 
      TagBox[
       TooltipBox[
        {Opacity[0.], PointBox[{{1.5, 4.}}], {
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{3.0679711876320432`, 4.}, {-0.06797118763204324, 4.}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {3.0679711876320432`, 4.}], 
             Offset[{0, -1.5}, {3.0679711876320432`, 4.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{0, 1.5}, {-0.06797118763204324, 4.}], 
             Offset[{0, -1.5}, {-0.06797118763204324, 4.}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{{1.5, 4.391992796908011}, {1.5, 3.608007203091989}}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {1.5, 4.391992796908011}], 
             Offset[{-1.5, 0}, {1.5, 4.391992796908011}]}]}, 
          {GrayLevel[0], Thickness[Tiny], Dashing[{}], 
           LineBox[{
            Offset[{1.5, 0}, {1.5, 3.608007203091989}], 
             Offset[{-1.5, 0}, {1.5, 3.608007203091989}]}]}}},
        "\"n {1.5\[PlusMinus]1.6, 4.00\[PlusMinus]0.39}\"",
        TooltipStyle->"TextStyling"],
       Annotation[#, "n {1.5\[PlusMinus]1.6, 4.00\[PlusMinus]0.39}", 
        "Tooltip"]& ]}}, {}, {}, {}, {}}, {{{}, {}, 
     TagBox[
      {RGBColor[0.368417, 0.506779, 0.709798], AbsoluteThickness[1.6], 
       Opacity[1.], LineBox[CompressedData["
1:eJwV13k4FV0YAHBblPXeO3eZq2xRhIRUStw3lSgKJVJZk30pRChSklRkVxRR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        "]]},
      Annotation[#, "Charting`Private`Tag$23158#1"]& ]}, {}, {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{False, False},
  AxesLabel->{None, None},
  AxesOrigin->{0.535, 0.53},
  DisplayFunction->Identity,
  Frame->{{True, True}, {True, True}},
  FrameLabel->{{
     FormBox["\"c\"", TraditionalForm], None}, {
     FormBox["\"a\"", TraditionalForm], None}},
  FrameStyle->GrayLevel[0],
  FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
  FrameTicksStyle->12,
  GridLines->{None, None},
  GridLinesStyle->Directive[
    GrayLevel[0.5, 0.4]],
  ImagePadding->All,
  ImageSize->500,
  LabelStyle->12,
  Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& ), "CopiedValueFunction" -> ({
        (Identity[#]& )[
         Part[#, 1]], 
        (Identity[#]& )[
         Part[#, 2]]}& )}},
  PlotRange->{{1., 7.}, {1., 6.}},
  PlotRangeClipping->True,
  PlotRangePadding->{{0.5, 0.5}, {0.5, 0.5}},
  Ticks->{Automatic, Automatic}]], "Output",
 ImageSize->{504, 329},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]=",
 CellID->292116934,ExpressionUUID->"0c471f88-45a7-4ead-a678-41358bacc1ac"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Calibration of chemical data", "Section",
 CellID->9144692,ExpressionUUID->"2d39a9cb-80f9-4323-a4de-58d1b68a5336"],

Cell["Load some measurement data:", "Text",
 CellID->1534169418,ExpressionUUID->"53b31f43-7ee3-4991-bd0c-b57a44029536"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"measurements", "=", 
  RowBox[{"DataTable", "@", 
   RowBox[{"<|", 
    RowBox[{
     RowBox[{"\"\<Blanc-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "55", ",", "21."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{
           RowBox[{"-", "0.01758562332"}], ",", "0.00033863693000000036"}], 
          "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<STD 1-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "56", ",", "11."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.03964178048", ",", "0.0004196894400000026"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 2-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "57", ",", "1."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.12384595475", ",", "0.0016846698500000005"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 3-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "57", ",", "52."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.23293354845", ",", "0.0006201796499999968"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<STD 4-2\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "14", ",", "58", ",", "44."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.3619620833", ",", "0.0008638827000000127"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 00\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "1", ",", "20."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.19625917165", ",", "0.001488907949999993"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 07\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "3", ",", "4."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.15008595425", ",", "0.0003870700500000074"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 05\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "3", ",", "57."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.1584623842", ",", "0.0022980622000000057"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Sample 06\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "4", ",", "47."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.155255631", ",", "0.0004266695999999986"}], "]"}]}]}], 
       "|>"}]}], ",", 
     RowBox[{"\"\<Blanc-3\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "5", ",", "36."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{
           RowBox[{"-", "0.001228706227"}], ",", "0.00005203780300000005"}], 
          "]"}]}]}], "|>"}]}], ",", 
     RowBox[{"\"\<DRIFT-3\>\"", "\[Rule]", 
      RowBox[{"<|", 
       RowBox[{
        RowBox[{"\"\<Time\>\"", "\[Rule]", 
         RowBox[{"DateObject", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "2015", ",", "6", ",", "15", ",", "15", ",", "6", ",", "26."}], 
            "}"}], ",", "\"\<Instant\>\"", ",", "\"\<Gregorian\>\"", ",", 
           "0."}], "]"}]}], ",", 
        RowBox[{"\"\<Ca\>\"", "\[Rule]", 
         RowBox[{"NDV", "[", 
          RowBox[{"0.36115560739999997", ",", "0.00001406480000001875"}], 
          "]"}]}]}], "|>"}]}]}], "|>"}]}]}]], "Input",
 CellLabel->"In[17]:=",
 CellID->185992016,ExpressionUUID->"732f96c9-a1a6-45fe-8448-b21b001dd2f5"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.01758562332, 
                  0.00033863693000000036`, $CellContext`dv$26019]], "STD 1-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.03964178048, 
                  0.0004196894400000026, $CellContext`dv$26020]], "STD 2-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.12384595475, 
                  0.0016846698500000005`, $CellContext`dv$26021]], "STD 3-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.23293354845, 
                  0.0006201796499999968, $CellContext`dv$26022]], "STD 4-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.3619620833, 0.0008638827000000127, $CellContext`dv$26023]],
               "Sample 00" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.19625917165, 0.001488907949999993, $CellContext`dv$26024]],
               "Sample 07" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.15008595425, 
                  0.0003870700500000074, $CellContext`dv$26025]], "Sample 05" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.1584623842, 
                  0.0022980622000000057`, $CellContext`dv$26026]], 
              "Sample 06" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.155255631, 0.0004266695999999986, $CellContext`dv$26027]], 
              "Blanc-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.001228706227, 
                  0.00005203780300000005, $CellContext`dv$26028]], "DRIFT-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.36115560739999997`, 
                  0.00001406480000001875, $CellContext`dv$26029]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
             Association["ID" -> 267941668212231]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.01758562332, 
                  0.00033863693000000036`, $CellContext`dv$26019]], "STD 1-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.03964178048, 
                  0.0004196894400000026, $CellContext`dv$26020]], "STD 2-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.12384595475, 
                  0.0016846698500000005`, $CellContext`dv$26021]], "STD 3-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.23293354845, 
                  0.0006201796499999968, $CellContext`dv$26022]], "STD 4-2" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.3619620833, 0.0008638827000000127, $CellContext`dv$26023]],
               "Sample 00" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.19625917165, 0.001488907949999993, $CellContext`dv$26024]],
               "Sample 07" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.15008595425, 
                  0.0003870700500000074, $CellContext`dv$26025]], "Sample 05" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.1584623842, 
                  0.0022980622000000057`, $CellContext`dv$26026]], 
              "Sample 06" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.155255631, 0.0004266695999999986, $CellContext`dv$26027]], 
              "Blanc-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[-0.001228706227, 
                  0.00005203780300000005, $CellContext`dv$26028]], "DRIFT-3" -> 
              Association[
               "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                  "Gregorian", 0.], "Ca" -> 
                DataAnalysis`NDV[
                 0.36115560739999997`, 
                  0.00001406480000001875, $CellContext`dv$26029]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
             Association["ID" -> 267941668212231]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.01758562332, 
                   0.00033863693000000036`, $CellContext`dv$26019]], 
               "STD 1-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.03964178048, 
                   0.0004196894400000026, $CellContext`dv$26020]], "STD 2-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.12384595475, 
                   0.0016846698500000005`, $CellContext`dv$26021]], "STD 3-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.23293354845, 
                   0.0006201796499999968, $CellContext`dv$26022]], "STD 4-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.3619620833, 
                   0.0008638827000000127, $CellContext`dv$26023]], 
               "Sample 00" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.19625917165, 
                   0.001488907949999993, $CellContext`dv$26024]], "Sample 07" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.15008595425, 
                   0.0003870700500000074, $CellContext`dv$26025]], 
               "Sample 05" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.1584623842, 
                   0.0022980622000000057`, $CellContext`dv$26026]], 
               "Sample 06" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.155255631, 0.0004266695999999986, $CellContext`dv$26027]],
                "Blanc-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.001228706227, 
                   0.00005203780300000005, $CellContext`dv$26028]], "DRIFT-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.36115560739999997`, 
                   0.00001406480000001875, $CellContext`dv$26029]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Time", "Ca"}, {
                 TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
              Association["ID" -> 267941668212231]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 55, 21.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.01758562332, 
                   0.00033863693000000036`, $CellContext`dv$26019]], 
               "STD 1-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 56, 11.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.03964178048, 
                   0.0004196894400000026, $CellContext`dv$26020]], "STD 2-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 1.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.12384595475, 
                   0.0016846698500000005`, $CellContext`dv$26021]], "STD 3-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 57, 52.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.23293354845, 
                   0.0006201796499999968, $CellContext`dv$26022]], "STD 4-2" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 14, 58, 44.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.3619620833, 
                   0.0008638827000000127, $CellContext`dv$26023]], 
               "Sample 00" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 1, 20.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.19625917165, 
                   0.001488907949999993, $CellContext`dv$26024]], "Sample 07" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 4.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.15008595425, 
                   0.0003870700500000074, $CellContext`dv$26025]], 
               "Sample 05" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 3, 57.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.1584623842, 
                   0.0022980622000000057`, $CellContext`dv$26026]], 
               "Sample 06" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 4, 47.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.155255631, 0.0004266695999999986, $CellContext`dv$26027]],
                "Blanc-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 5, 36.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[-0.001228706227, 
                   0.00005203780300000005, $CellContext`dv$26028]], "DRIFT-3" -> 
               Association[
                "Time" -> DateObject[{2015, 6, 15, 15, 6, 26.}, "Instant", 
                   "Gregorian", 0.], "Ca" -> 
                 DataAnalysis`NDV[
                  0.36115560739999997`, 
                   0.00001406480000001875, $CellContext`dv$26029]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Time", "Ca"}, {
                 TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
              Association["ID" -> 267941668212231]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[3]} -> 1, {All, "Time"} -> 
               1, {All, "Ca"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Time" -> TypeSystem`PackageScope`AtomShape[75], "Ca" -> 
                   TypeSystem`PackageScope`UnknownShape]]]], 11, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[2074929957], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Time", "Ca"}, {
                TypeSystem`Atom[DateObject], TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[2074929957]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1371748376][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Time\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Time\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1371748376][{All, "Time"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[All, "Time"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1371748376][{All, "Ca"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[All, "Ca"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:55:21\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.01759\"", -0.01758562332, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "66", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.01758562332, 
                    0.00033863693000000036`, $CellContext`dv$26019]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:56:11\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.03964\"", 0.03964178048, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "82", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.03964178048, 
                    0.0004196894400000026, $CellContext`dv$26020]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:57:01\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1238\"", 0.12384595475, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "33", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.12384595475, 
                    0.0016846698500000005`, $CellContext`dv$26021]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:57:52\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.2329\"", 0.23293354845, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "12", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.23293354845, 
                    0.0006201796499999968, $CellContext`dv$26022]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 14:58:44\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.3620\"", 0.3619620833, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "17", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.3619620833, 
                    0.0008638827000000127, $CellContext`dv$26023]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:01:20\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1963\"", 0.19625917165, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "29", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.19625917165, 
                    0.001488907949999993, $CellContext`dv$26024]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:03:04\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.15009\"", 0.15008595425, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "76", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.15008595425, 
                    0.0003870700500000074, $CellContext`dv$26025]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:03:57\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.1585\"", 0.1584623842, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "45", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.1584623842, 
                    0.0022980622000000057`, $CellContext`dv$26026]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:04:47\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.15526\"", 0.155255631, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "84", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.155255631, 
                    0.0004266695999999986, $CellContext`dv$26027]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:05:36\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.00123\"", -0.001228706227, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 5}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "10", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.001228706227, 
                    0.00005203780300000005, $CellContext`dv$26028]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Mon 15 Jun 2015 15:06:26\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.361156\"", 0.36115560739999997`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 6}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "28", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.36115560739999997`, 
                    0.00001406480000001875, $CellContext`dv$26029]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1371748376][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1371748376]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1371748376][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1371748376][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {381., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{385, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[17]=",
 CellID->84066839,ExpressionUUID->"21ba8dda-fabf-4aa8-acd9-18a5b46d73ef"]
}, Open  ]],

Cell["\<\
Load known concentrations of calibration standards and measurement data (more \
than one element, isotope or compound can be used):\
\>", "Text",
 CellID->455748696,ExpressionUUID->"e2cad087-f71d-4dae-813f-7d686f3b45bc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"stds", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<ID\>\"", ",", "\"\<Ca / ppm\>\""}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<STD 1\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"0.5049652620285187", ",", "0.0005222986739878592"}], "]"}]}],
       "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<STD 2\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"1.623565252889819", ",", "0.0007242565923152135"}], "]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<STD 3\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"3.1122617784207023", ",", "0.0011361423406811462"}], "]"}]}],
       "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<STD 4\>\"", ",", 
       RowBox[{"NDV", "[", 
        RowBox[{"4.993042482195919", ",", "0.001721214491302021"}], "]"}]}], 
      "}"}]}], "}"}], "]"}]}]], "Input",
 CellLabel->"In[18]:=",
 CellID->193905331,ExpressionUUID->"e67bac62-fb48-41a6-b940-608429a893cb"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "STD 1" -> Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5049652620285187, 
                  0.0005222986739878592, $CellContext`dv$26740]], "STD 2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.623565252889819, 
                  0.0007242565923152135, $CellContext`dv$26741]], "STD 3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.1122617784207023`, 
                  0.0011361423406811462`, $CellContext`dv$26742]], "STD 4" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.993042482195919, 
                  0.001721214491302021, $CellContext`dv$26743]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
             Association["ID" -> 253016656858638]]]]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "STD 1" -> Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.5049652620285187, 
                  0.0005222986739878592, $CellContext`dv$26740]], "STD 2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.623565252889819, 
                  0.0007242565923152135, $CellContext`dv$26741]], "STD 3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.1122617784207023`, 
                  0.0011361423406811462`, $CellContext`dv$26742]], "STD 4" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.993042482195919, 
                  0.001721214491302021, $CellContext`dv$26743]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
             Association["ID" -> 253016656858638]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "STD 1" -> Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5049652620285187, 
                   0.0005222986739878592, $CellContext`dv$26740]], "STD 2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.623565252889819, 
                   0.0007242565923152135, $CellContext`dv$26741]], "STD 3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.1122617784207023`, 
                   0.0011361423406811462`, $CellContext`dv$26742]], "STD 4" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.993042482195919, 
                   0.001721214491302021, $CellContext`dv$26743]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
              Association["ID" -> 253016656858638]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "STD 1" -> Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.5049652620285187, 
                   0.0005222986739878592, $CellContext`dv$26740]], "STD 2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.623565252889819, 
                   0.0007242565923152135, $CellContext`dv$26741]], "STD 3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.1122617784207023`, 
                   0.0011361423406811462`, $CellContext`dv$26742]], "STD 4" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.993042482195919, 
                   0.001721214491302021, $CellContext`dv$26743]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
              Association["ID" -> 253016656858638]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 4, "Length" -> 4, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[4]} -> 1, {All, "Ca / ppm"} -> 
               1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[48.00000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               4, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[1747616834], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 4], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1747616834]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 614984780][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 614984780][{
                    All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1", 
                    Style[
                    "STD 1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 614984780][{
                    Key["STD 1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[
                    Key["STD 1"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.5050\"", 0.5049652620285187, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "10", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.5049652620285187, 
                    0.0005222986739878592, $CellContext`dv$26740]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[
                    Key["STD 1"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2", 
                    Style[
                    "STD 2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 614984780][{
                    Key["STD 2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[
                    Key["STD 2"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.6236\"", 1.623565252889819, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "14", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.623565252889819, 
                    0.0007242565923152135, $CellContext`dv$26741]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[
                    Key["STD 2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3", 
                    Style[
                    "STD 3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 614984780][{
                    Key["STD 3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[
                    Key["STD 3"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.1123\"", 3.1122617784207023`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "22", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.1122617784207023`, 
                    0.0011361423406811462`, $CellContext`dv$26742]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[
                    Key["STD 3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4", 
                    Style[
                    "STD 4", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 614984780][{
                    Key["STD 4"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[
                    Key["STD 4"]]], "Mouse"], 
                    ImageSize -> {{48.00000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.9930\"", 4.993042482195919, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 4}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "34", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.993042482195919, 
                    0.001721214491302021, $CellContext`dv$26743]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    614984780][
                    GeneralUtilities`Slice[
                    Key["STD 4"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 614984780][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 614984780]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[614984780][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[614984780][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {149., {69., 75.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[18]=",
 CellID->133453163,ExpressionUUID->"ccdb16ed-d00f-4b86-a73b-a25dff32b8e8"]
}, Open  ]],

Cell["\<\
Show the calibration curve, optionally subtracting blank measurements and \
using a quadratic calibration curve:\
\>", "Text",
 CellID->622342540,ExpressionUUID->"f17456bc-392c-4965-9573-172f19dce367"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrationPlot", "[", 
  RowBox[{"measurements", ",", "stds", ",", "\"\<Ca\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<STD\>\"", "~~", "__", "~~", "\"\<-2\>\""}], "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}]}], "]"}]], "Input",
 CellLabel->"In[19]:=",
 CellID->565915028,ExpressionUUID->"a879f8e1-07ed-4a90-8ce7-0541459527b9"],

Cell[BoxData[
 TemplateBox[{GraphicsBox[{{{}, {{{}, {
         Hue[0.67, 0.6, 0.6], 
         Directive[
          PointSize[0.012833333333333334`], 
          AbsoluteThickness[1.6], 
          RGBColor[0.368417, 0.506779, 0.709798]], {
          
          PointBox[{{0.5049652620285187, 0.05589757314203252}, {
           1.623565252889819, 0.13877191675406503`}, {3.1122617784207023`, 
           0.2465030831829382}, {4.993042482195919, 
           0.37414859414865204`}}], {{{
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             
             LineBox[{{0.5059889486187079, 0.05589757314203252}, {
              0.5039415754383294, 0.05589757314203252}}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{0, 1.5}, {0.5059889486187079, 0.05589757314203252}], 
               
               Offset[{0, -1.5}, {0.5059889486187079, 
                0.05589757314203252}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{0, 1.5}, {0.5039415754383294, 0.05589757314203252}], 
               
               Offset[{0, -1.5}, {0.5039415754383294, 
                0.05589757314203252}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             
             LineBox[{{0.5049652620285187, 0.05692646302152953}, {
              0.5049652620285187, 0.0548686832625355}}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{1.5, 0}, {0.5049652620285187, 0.05692646302152953}], 
               
               Offset[{-1.5, 0}, {0.5049652620285187, 
                0.05692646302152953}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{1.5, 0}, {0.5049652620285187, 0.0548686832625355}], 
               Offset[{-1.5, 0}, {0.5049652620285187, 
                0.0548686832625355}]}]}}, {{
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             
             LineBox[{{1.6249847697263224`, 0.13877191675406503`}, {
              1.6221457360533156`, 0.13877191675406503`}}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{0, 1.5}, {1.6249847697263224`, 0.13877191675406503`}], 
               
               Offset[{0, -1.5}, {1.6249847697263224`, 
                0.13877191675406503`}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{0, 1.5}, {1.6221457360533156`, 0.13877191675406503`}], 
               
               Offset[{0, -1.5}, {1.6221457360533156`, 
                0.13877191675406503`}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             
             LineBox[{{1.623565252889819, 0.14212305237952647`}, {
              1.623565252889819, 0.1354207811286036}}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{1.5, 0}, {1.623565252889819, 0.14212305237952647`}], 
               
               Offset[{-1.5, 0}, {1.623565252889819, 
                0.14212305237952647`}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{1.5, 0}, {1.623565252889819, 0.1354207811286036}], 
               
               Offset[{-1.5, 0}, {1.623565252889819, 
                0.1354207811286036}]}]}}, {{
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             
             LineBox[{{3.1144885764897485`, 0.2465030831829382}, {
              3.110034980351656, 0.2465030831829382}}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{0, 1.5}, {3.1144885764897485`, 0.2465030831829382}], 
               
               Offset[{0, -1.5}, {3.1144885764897485`, 
                0.2465030831829382}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{0, 1.5}, {3.110034980351656, 0.2465030831829382}], 
               Offset[{0, -1.5}, {3.110034980351656, 0.2465030831829382}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             
             LineBox[{{3.1122617784207023`, 0.24782746043032933`}, {
              3.1122617784207023`, 0.24517870593554708`}}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{1.5, 0}, {3.1122617784207023`, 0.24782746043032933`}], 
               
               Offset[{-1.5, 0}, {3.1122617784207023`, 
                0.24782746043032933`}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{1.5, 0}, {3.1122617784207023`, 0.24517870593554708`}], 
               
               Offset[{-1.5, 0}, {3.1122617784207023`, 
                0.24517870593554708`}]}]}}, {{
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             
             LineBox[{{4.996416000608539, 0.37414859414865204`}, {
              4.9896689637832985`, 0.37414859414865204`}}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{0, 1.5}, {4.996416000608539, 0.37414859414865204`}], 
               
               Offset[{0, -1.5}, {4.996416000608539, 
                0.37414859414865204`}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{0, 1.5}, {4.9896689637832985`, 0.37414859414865204`}], 
               Offset[{0, -1.5}, {4.9896689637832985`, 
                0.37414859414865204`}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             
             LineBox[{{4.993042482195919, 0.37590803368543324`}, {
              4.993042482195919, 0.37238915461187083`}}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{1.5, 0}, {4.993042482195919, 0.37590803368543324`}], 
               
               Offset[{-1.5, 0}, {4.993042482195919, 
                0.37590803368543324`}]}]}, {
             GrayLevel[0], 
             Thickness[Tiny], 
             Dashing[{}], 
             LineBox[{
               Offset[{1.5, 0}, {4.993042482195919, 0.37238915461187083`}], 
               
               Offset[{-1.5, 0}, {4.993042482195919, 
                0.37238915461187083`}]}]}}}}}, {}}, {
        TagBox[
         TooltipBox[{
           Opacity[0.], {
            PointBox[{{0.5049652620285187, 0.05589757314203252}}], {{{
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               
               LineBox[{{0.5059889486187079, 0.05589757314203252}, {
                0.5039415754383294, 0.05589757314203252}}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{0, 1.5}, {0.5059889486187079, 0.05589757314203252}], 
                 
                 Offset[{0, -1.5}, {0.5059889486187079, 
                  0.05589757314203252}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{0, 1.5}, {0.5039415754383294, 0.05589757314203252}], 
                 
                 Offset[{0, -1.5}, {0.5039415754383294, 
                  0.05589757314203252}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{{0.5049652620285187, 0.05692646302152953}, {
                0.5049652620285187, 0.0548686832625355}}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{1.5, 0}, {0.5049652620285187, 0.05692646302152953}], 
                 
                 Offset[{-1.5, 0}, {0.5049652620285187, 
                  0.05692646302152953}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{1.5, 0}, {0.5049652620285187, 0.0548686832625355}], 
                 
                 Offset[{-1.5, 0}, {0.5049652620285187, 
                  0.0548686832625355}]}]}}}}}, 
          "\"STD 1 {0.5050(10), 0.0559(10)}\"", LabelStyle -> "TextStyling"], 
         Annotation[#, "STD 1 {0.5050(10), 0.0559(10)}", "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Opacity[0.], {
            PointBox[{{1.623565252889819, 0.13877191675406503`}}], {{{
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               
               LineBox[{{1.6249847697263224`, 0.13877191675406503`}, {
                1.6221457360533156`, 0.13877191675406503`}}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 
                 Offset[{0, 1.5}, {1.6249847697263224`, 
                  0.13877191675406503`}], 
                 
                 Offset[{0, -1.5}, {1.6249847697263224`, 
                  0.13877191675406503`}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 
                 Offset[{0, 1.5}, {1.6221457360533156`, 
                  0.13877191675406503`}], 
                 
                 Offset[{0, -1.5}, {1.6221457360533156`, 
                  0.13877191675406503`}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{{1.623565252889819, 0.14212305237952647`}, {
                1.623565252889819, 0.1354207811286036}}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{1.5, 0}, {1.623565252889819, 0.14212305237952647`}], 
                 
                 Offset[{-1.5, 0}, {1.623565252889819, 
                  0.14212305237952647`}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{1.5, 0}, {1.623565252889819, 0.1354207811286036}], 
                 
                 Offset[{-1.5, 0}, {1.623565252889819, 
                  0.1354207811286036}]}]}}}}}, 
          "\"STD 2 {1.6236(14), 0.1388(34)}\"", LabelStyle -> "TextStyling"], 
         Annotation[#, "STD 2 {1.6236(14), 0.1388(34)}", "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Opacity[0.], {
            PointBox[{{3.1122617784207023`, 0.2465030831829382}}], {{{
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               
               LineBox[{{3.1144885764897485`, 0.2465030831829382}, {
                3.110034980351656, 0.2465030831829382}}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{0, 1.5}, {3.1144885764897485`, 0.2465030831829382}], 
                 
                 Offset[{0, -1.5}, {3.1144885764897485`, 
                  0.2465030831829382}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{0, 1.5}, {3.110034980351656, 0.2465030831829382}], 
                 
                 Offset[{0, -1.5}, {3.110034980351656, 
                  0.2465030831829382}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               
               LineBox[{{3.1122617784207023`, 0.24782746043032933`}, {
                3.1122617784207023`, 0.24517870593554708`}}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 
                 Offset[{1.5, 0}, {3.1122617784207023`, 
                  0.24782746043032933`}], 
                 
                 Offset[{-1.5, 0}, {3.1122617784207023`, 
                  0.24782746043032933`}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 
                 Offset[{1.5, 0}, {3.1122617784207023`, 
                  0.24517870593554708`}], 
                 
                 Offset[{-1.5, 0}, {3.1122617784207023`, 
                  0.24517870593554708`}]}]}}}}}, 
          "\"STD 3 {3.1123(22), 0.2465(13)}\"", LabelStyle -> "TextStyling"], 
         Annotation[#, "STD 3 {3.1123(22), 0.2465(13)}", "Tooltip"]& ], 
        TagBox[
         TooltipBox[{
           Opacity[0.], {
            PointBox[{{4.993042482195919, 0.37414859414865204`}}], {{{
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               
               LineBox[{{4.996416000608539, 0.37414859414865204`}, {
                4.9896689637832985`, 0.37414859414865204`}}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{0, 1.5}, {4.996416000608539, 0.37414859414865204`}], 
                 
                 Offset[{0, -1.5}, {4.996416000608539, 
                  0.37414859414865204`}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 
                 Offset[{0, 1.5}, {4.9896689637832985`, 
                  0.37414859414865204`}], 
                 
                 Offset[{0, -1.5}, {4.9896689637832985`, 
                  0.37414859414865204`}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               
               LineBox[{{4.993042482195919, 0.37590803368543324`}, {
                4.993042482195919, 0.37238915461187083`}}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{1.5, 0}, {4.993042482195919, 0.37590803368543324`}], 
                 
                 Offset[{-1.5, 0}, {4.993042482195919, 
                  0.37590803368543324`}]}]}, {
               GrayLevel[0], 
               Thickness[Tiny], 
               Dashing[{}], 
               LineBox[{
                 Offset[{1.5, 0}, {4.993042482195919, 0.37238915461187083`}], 
                 
                 Offset[{-1.5, 0}, {4.993042482195919, 
                  0.37238915461187083`}]}]}}}}}, 
          "\"STD 4 {4.9930(34), 0.3741(18)}\"", LabelStyle -> "TextStyling"], 
         Annotation[#, "STD 4 {4.9930(34), 0.3741(18)}", 
          "Tooltip"]& ]}}, {}, {}, {}, {}}, {{{{}, {}, 
        TagBox[{
          Directive[
           Opacity[1.], 
           AbsoluteThickness[1.6], 
           GrayLevel[0]], 
          LineBox[CompressedData["
1:eJwVxX8403kcAPBh6DRpvj364bIpv1IpPU8/H3p/TE+nGneS6uaqMxldy4/d
9NQmdiSW5hBC53YKV09heZaHTvNr+TFsZvLVUXmaUbRDmmyJu/vj9bycmbFH
I80JBELgf/6/JIlp5X2Wv7/Ag+g3k5MDcg2VfoL6PdBJ+iyTJAeW2mSpVOo5
2JaSJ7DozYGSJhHFknoZkl0o365akQts34QLnyhCoPlvLPK+nguaz9F505Qi
OP5ubISRchOsh9646yn3oR4Pg2hOPpQqxPGTlHo457uwOya4CKqqhUNsLwXU
J984Ix78A6JAXfSeo4G3dJ4hVlYGMbpNWmnVCxjtvFmhEt0DG+er7q/3jMB8
dfJi2cOHkLWyy7P0Ry1IiKteLvOTAHPoWKNF9xi8oF+z3h5SA/HPrjJj3Seg
I3TpkjlDCo/iSCFrDukBu3zaj+dTC6X88xPbT0xDRfNvjVYH6yBFvBD88f0M
bLhYfYC1+QkQNCOogTcLSVnlcd2WDeDGZV065mmA/XbyFL2VDEYNt44vfzoH
aheabs9oIxzW/XQlN34eCqenKk2zTRA0mr3ZyckESXGJG4Omm2GilSnoqPwM
6i+eXO3fLeBFHljvf+YLRAgWI1IHW8EGDOHDs4vwNKNkji+Xwzd6xqcNoQR0
6lDVKkbrMxhsOWvG2GKGah3cZLKGNnicIT9NNZgh/rq46Xtl7cCyTBhRKs2R
A+Np1mFxB0Rw+I9JxRZoN3f8VkZGJ2yL2qykhxNRgFY0zWMrQGW/ZXnCXksU
6RVY/4nZBX9VpdzeYmGFOu55l/sEdAPfzPO77pdWiPDPsPU49IDNMC8gRmqN
+mkFxbt3KEFX4ZwnTlyG9ineOVzBVJDnsZZYH/oV4julWV6x6IXsYlZ7ONUG
mSbQqWZuLzDyTilJ4zbIUNP0e6y2F+YPlBvFsuXIy47ttTFMDVod7VJLOgn5
HnWK5ijUcMfX27En3Bb11KYKpLQ+qExLIEdtXYEmyUt1JTV9kB4accTCsAIR
AiDeSNHAzuHS++k9dmjZ1E6Bd4EGCjfdruw5shJRV3vkuxH7IblJVHikfiU6
qSIk6nj9EOgYWq5wIaNgV4XKbqof/GLaw8hCMnJ/db3ANuw5iL9munQbyEhS
W+kqUz0Hl9Y/C4LC7FHRJkl+oM8AZG9t8eyT2aOD938OOlMxAKxZorrTE0Oi
sYETtmtxYD76QBX+iiESZ9caSSoO7JSQhcM5GFrnYc7OTMMhIUSKk25i6OgP
+XWsdBwyDAlZ2QUYooG9z/pMHKr2Gj/fKsGQy1Tke2EuDsbmpYGKBxgan+N+
CC/FIbuPJJK3Y4hb4Z1HasSh+O6F6GudGBp01hPGm3C4y1X6B3RhiOUYx2pu
waHWIdvUpcSQubDb8WIbDsMMLFrzHEO+Qa+3ve7BwV271v+NFkOPBOwv1cM4
bJfynMp0GGp8JZ4TvsJhX9qQMXIcQ6YnxW8jRnCgu5dI3k1gaFI/Vrt6FAfO
earTzAyG1L4vFpImcUj0+cVYM4uhXaKAhpN6HNJs3/RzDRiSM5K5O6ZwKKy+
mzk/jyFmnL9K9wGHOwJi1BMThjh1vfGNH3F4EBxJS1zA0MMkV9uiORykG9rW
71/EkF2rXylnHgfZrJtxaQlD4jRXL7oJh38BipJU1A==
           "]]}, 
         Annotation[#, "Charting`Private`Tag$28094#1"]& ]}}, {}, {}}}, {
    DisplayFunction -> Identity, PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.05]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, AxesOrigin -> {0, 0}, PlotRange -> NCache[{{0, 5}, {0, 
         Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True, 
     ImagePadding -> All, DisplayFunction -> Identity, AspectRatio -> 
     NCache[GoldenRatio^(-1), 0.6180339887498948], Axes -> {False, False}, 
     AxesLabel -> {None, None}, AxesOrigin -> {0, 0}, DisplayFunction :> 
     Identity, Frame -> {{True, True}, {True, True}}, FrameLabel -> {{
        FormBox["\"Measurement\"", TraditionalForm], None}, {
        FormBox["\"Concentration\"", TraditionalForm], None}}, FrameStyle -> 
     GrayLevel[0], 
     FrameTicks -> {{Automatic, Automatic}, {Automatic, Automatic}}, 
     FrameTicksStyle -> 12, GridLines -> {None, None}, GridLinesStyle -> 
     Directive[
       GrayLevel[0.5, 0.4]], ImageSize -> 500, LabelStyle -> 12, 
     Method -> {"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& ), "CopiedValueFunction" -> ({
           (Identity[#]& )[
            Part[#, 1]], 
           (Identity[#]& )[
            Part[#, 2]]}& )}}, PlotLabel -> FormBox[
       StyleBox["\"Ca\"", 16, 
        GrayLevel[0], StripOnInput -> False], TraditionalForm], PlotRange -> 
     NCache[{{0, 5}, {0, 
         Rational[2, 5]}}, {{0, 5}, {0, 0.4}}], PlotRangeClipping -> True, 
     PlotRangePadding -> {{
        Scaled[0.02], 
        Scaled[0.05]}, {
        Scaled[0.02], 
        Scaled[0.05]}}, Ticks -> {Automatic, Automatic}}],FormBox[
    FormBox[
     TemplateBox[{
       RowBox[{"\"STD\"", "~~", "__", "~~", "\"-2\""}]}, "PointLegend", 
      DisplayFunction -> (FormBox[
        StyleBox[
         StyleBox[
          PaneBox[
           TagBox[
            GridBox[{{
               TagBox[
                GridBox[{{
                   GraphicsBox[{{}, {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], {
                    Directive[
                    EdgeForm[
                    Directive[
                    Opacity[0.3], 
                    GrayLevel[0]]], 
                    PointSize[0.462], 
                    AbsoluteThickness[1.6], 
                    RGBColor[0.368417, 0.506779, 0.709798]], 
                    PointBox[
                    NCache[{
                    Scaled[{
                    Rational[1, 2], 
                    Rational[1, 2]}]}, {
                    Scaled[{0.5, 0.5}]}]]}}}, AspectRatio -> Full, 
                    ImageSize -> {10, 10}, PlotRangePadding -> None, 
                    ImagePadding -> Automatic, 
                    BaselinePosition -> (Scaled[0.038000000000000006`] -> 
                    Baseline)], #}}, 
                 GridBoxAlignment -> {
                  "Columns" -> {Center, Left}, "Rows" -> {{Baseline}}}, 
                 AutoDelete -> False, 
                 GridBoxDividers -> {
                  "Columns" -> {{False}}, "Rows" -> {{False}}}, 
                 GridBoxItemSize -> {"Columns" -> {{All}}, "Rows" -> {{All}}},
                  GridBoxSpacings -> {
                  "Columns" -> {{0.5}}, "Rows" -> {{0.8}}}], "Grid"]}}, 
             GridBoxAlignment -> {"Columns" -> {{Left}}, "Rows" -> {{Top}}}, 
             AutoDelete -> False, 
             GridBoxItemSize -> {
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
             GridBoxSpacings -> {"Columns" -> {{1}}, "Rows" -> {{0}}}], 
            "Grid"], Alignment -> Left, AppearanceElements -> None, 
           ImageMargins -> {{5, 5}, {5, 5}}, ImageSizeAction -> 
           "ResizeToFit"], LineIndent -> 0, StripOnInput -> False], {
         FontSize -> 12, FontFamily -> "Arial"}, Background -> Automatic, 
         StripOnInput -> False], TraditionalForm]& ), 
      InterpretationFunction :> (RowBox[{"PointLegend", "[", 
         RowBox[{
           RowBox[{"{", 
             RowBox[{"Directive", "[", 
               RowBox[{
                 RowBox[{"PointSize", "[", "0.012833333333333334`", "]"}], 
                 ",", 
                 RowBox[{"AbsoluteThickness", "[", "1.6`", "]"}], ",", 
                 InterpretationBox[
                  ButtonBox[
                   TooltipBox[
                    GraphicsBox[{{
                    GrayLevel[0], 
                    RectangleBox[{0, 0}]}, {
                    GrayLevel[0], 
                    RectangleBox[{1, -1}]}, {
                    RGBColor[0.368417, 0.506779, 0.709798], 
                    RectangleBox[{0, -1}, {2, 1}]}}, DefaultBaseStyle -> 
                    "ColorSwatchGraphics", AspectRatio -> 1, Frame -> True, 
                    FrameStyle -> 
                    RGBColor[
                    0.24561133333333335`, 0.3378526666666667, 
                    0.4731986666666667], FrameTicks -> None, PlotRangePadding -> 
                    None, ImageSize -> 
                    Dynamic[{
                    Automatic, 1.35 CurrentValue["FontCapHeight"]/
                    AbsoluteCurrentValue[Magnification]}]], 
                    "RGBColor[0.368417, 0.506779, 0.709798]"], Appearance -> 
                   None, BaseStyle -> {}, BaselinePosition -> Baseline, 
                   DefaultBaseStyle -> {}, ButtonFunction :> 
                   With[{Typeset`box$ = EvaluationBox[]}, 
                    If[
                    Not[
                    AbsoluteCurrentValue["Deployed"]], 
                    SelectionMove[Typeset`box$, All, Expression]; 
                    FrontEnd`Private`$ColorSelectorInitialAlpha = 1; 
                    FrontEnd`Private`$ColorSelectorInitialColor = 
                    RGBColor[0.368417, 0.506779, 0.709798]; 
                    FrontEnd`Private`$ColorSelectorUseMakeBoxes = True; 
                    MathLink`CallFrontEnd[
                    FrontEnd`AttachCell[Typeset`box$, 
                    FrontEndResource["RGBColorValueSelector"], {
                    0, {Left, Bottom}}, {Left, Top}, 
                    "ClosingActions" -> {
                    "SelectionDeparture", "ParentChanged", 
                    "EvaluatorQuit"}]]]], BaseStyle -> Inherited, Evaluator -> 
                   Automatic, Method -> "Preemptive"], 
                  RGBColor[0.368417, 0.506779, 0.709798], Editable -> False, 
                  Selectable -> False]}], "]"}], "}"}], ",", 
           RowBox[{"{", #, "}"}], ",", 
           RowBox[{"LegendMarkers", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"{", 
                 RowBox[{"False", ",", "Automatic"}], "}"}], "}"}]}], ",", 
           RowBox[{"Joined", "\[Rule]", 
             RowBox[{"{", "False", "}"}]}], ",", 
           RowBox[{"LabelStyle", "\[Rule]", "12"}], ",", 
           RowBox[{"LegendLayout", "\[Rule]", "\"Column\""}]}], "]"}]& ), 
      Editable -> True], TraditionalForm], TraditionalForm]},
  "Legended",
  DisplayFunction->(GridBox[{{
      TagBox[
       ItemBox[
        PaneBox[
         TagBox[#, "SkipImageSizeLevel"], Alignment -> {Center, Baseline}, 
         BaselinePosition -> Baseline], DefaultBaseStyle -> "Labeled"], 
       "SkipImageSizeLevel"], 
      ItemBox[#2, DefaultBaseStyle -> "LabeledLabel"]}}, 
    GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}, 
    AutoDelete -> False, GridBoxItemSize -> Automatic, 
    BaselinePosition -> {1, 1}]& ),
  Editable->True,
  InterpretationFunction->(RowBox[{"Legended", "[", 
     RowBox[{#, ",", 
       RowBox[{"Placed", "[", 
         RowBox[{#2, ",", "After"}], "]"}]}], "]"}]& )]], "Output",
 ImageSize->{629, 343},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[19]=",
 CellID->53360647,ExpressionUUID->"63579422-e549-475c-a496-f35d09b2db6f"]
}, Open  ]],

Cell["\<\
Calibrate the measurements by interpolating standard and drift measurements \
based on the time of analysis:\
\>", "Text",
 CellID->83641357,ExpressionUUID->"fab3cf87-e448-4361-affa-8bd599fafb53"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CalibrateCompositionalData", "[", 
  RowBox[{"measurements", ",", "stds", ",", 
   RowBox[{"{", "\"\<Ca\>\"", "}"}], ",", 
   RowBox[{"IncludeQuadraticTerm", "\[Rule]", "True"}], ",", 
   RowBox[{"IncludeConstantBasis", "\[Rule]", "True"}], ",", 
   RowBox[{"BlankPattern", "\[Rule]", 
    RowBox[{"\"\<Blanc\>\"", "~~", "__"}]}], ",", 
   RowBox[{"DriftStandard", "\[Rule]", "\"\<STD 4\>\""}]}], "]"}]], "Input",
 CellLabel->"In[20]:=",
 CellID->295086487,ExpressionUUID->"045e1868-af7f-4df8-bebb-28f83e6a4b41"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22671109651240204`, 
                  0.016133598728604377`, $CellContext`dv$28854]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.505085356721548, 
                  0.017921828167261015`, $CellContext`dv$28905]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613806140707826, 
                  0.03869735056006944, $CellContext`dv$28956]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112949605710551, 
                  0.06292559103956663, $CellContext`dv$29007]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12111731684957971`, $CellContext`dv$29058]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.603240200398011, 
                  0.048865766217893576`, $CellContext`dv$29109]], "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9707776677963589`, 
                  0.030896600392822875`, $CellContext`dv$29160]], "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0852688522822533`, 
                  0.044207316264084216`, $CellContext`dv$29211]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.042036066525968, 
                  0.03003457664039987, $CellContext`dv$29262]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019357837373813518`, 
                  0.009438202591552744, $CellContext`dv$29313]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.99247000650331, 
                  0.091372761188262, $CellContext`dv$29364]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[197414010244628]]], "ID" -> 
              197418305211924]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Blanc-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.22671109651240204`, 
                  0.016133598728604377`, $CellContext`dv$28854]], "STD 1-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 0.505085356721548, 
                  0.017921828167261015`, $CellContext`dv$28905]], "STD 2-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.613806140707826, 
                  0.03869735056006944, $CellContext`dv$28956]], "STD 3-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 3.112949605710551, 
                  0.06292559103956663, $CellContext`dv$29007]], "STD 4-2" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.992377480653775, 
                  0.12111731684957971`, $CellContext`dv$29058]], "Sample 00" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.603240200398011, 
                  0.048865766217893576`, $CellContext`dv$29109]], "Sample 07" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 1.9707776677963589`, 
                  0.030896600392822875`, $CellContext`dv$29160]], "Sample 05" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.0852688522822533`, 
                  0.044207316264084216`, $CellContext`dv$29211]], "Sample 06" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 2.042036066525968, 
                  0.03003457664039987, $CellContext`dv$29262]], "Blanc-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[-0.019357837373813518`, 
                  0.009438202591552744, $CellContext`dv$29313]], "DRIFT-3" -> 
              Association[
               "Ca / ppm" -> 
                DataAnalysis`NDV[
                 4.99247000650331, 
                  0.091372761188262, $CellContext`dv$29364]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
             Association["Origin" -> HoldComplete[
                Query[All, {"Ca / ppm"}][
                 Dataset`DatasetHandle[197414010244628]]], "ID" -> 
              197418305211924]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22671109651240204`, 
                   0.016133598728604377`, $CellContext`dv$28854]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.505085356721548, 
                   0.017921828167261015`, $CellContext`dv$28905]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613806140707826, 
                   0.03869735056006944, $CellContext`dv$28956]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112949605710551, 
                   0.06292559103956663, $CellContext`dv$29007]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12111731684957971`, $CellContext`dv$29058]], "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.603240200398011, 
                   0.048865766217893576`, $CellContext`dv$29109]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9707776677963589`, 
                   0.030896600392822875`, $CellContext`dv$29160]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0852688522822533`, 
                   0.044207316264084216`, $CellContext`dv$29211]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.042036066525968, 
                   0.03003457664039987, $CellContext`dv$29262]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019357837373813518`, 
                   0.009438202591552744, $CellContext`dv$29313]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.99247000650331, 
                   0.091372761188262, $CellContext`dv$29364]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[197414010244628]]], "ID" -> 
               197418305211924]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Blanc-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.22671109651240204`, 
                   0.016133598728604377`, $CellContext`dv$28854]], "STD 1-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  0.505085356721548, 
                   0.017921828167261015`, $CellContext`dv$28905]], "STD 2-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.613806140707826, 
                   0.03869735056006944, $CellContext`dv$28956]], "STD 3-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  3.112949605710551, 
                   0.06292559103956663, $CellContext`dv$29007]], "STD 4-2" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.992377480653775, 
                   0.12111731684957971`, $CellContext`dv$29058]], "Sample 00" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.603240200398011, 
                   0.048865766217893576`, $CellContext`dv$29109]], 
               "Sample 07" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  1.9707776677963589`, 
                   0.030896600392822875`, $CellContext`dv$29160]], 
               "Sample 05" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.0852688522822533`, 
                   0.044207316264084216`, $CellContext`dv$29211]], 
               "Sample 06" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  2.042036066525968, 
                   0.03003457664039987, $CellContext`dv$29262]], "Blanc-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[-0.019357837373813518`, 
                   0.009438202591552744, $CellContext`dv$29313]], "DRIFT-3" -> 
               Association[
                "Ca / ppm" -> 
                 DataAnalysis`NDV[
                  4.99247000650331, 
                   0.091372761188262, $CellContext`dv$29364]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
              Association["Origin" -> HoldComplete[
                 Query[All, {"Ca / ppm"}][
                  Dataset`DatasetHandle[197414010244628]]], "ID" -> 
               197418305211924]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 11, "Length" -> 11, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "Shape" -> TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[5]} -> 1, {All, "Ca / ppm"} -> 
               1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[86.4], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca / ppm" -> TypeSystem`PackageScope`UnknownShape]]]], 
               11, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[1789646125], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca / ppm"}, {TypeSystem`AnyType}], 11], 
            "HandleQ" -> True, "RowTarget" -> 20, "Data" -> 
            TypeSystem`PackageScope`CacheHandle[1789646125]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    2073736671][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca / ppm\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca / ppm\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    2073736671][{All, "Ca / ppm"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[All, "Ca / ppm"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-2", 
                    Style[
                    "Blanc-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["Blanc-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.227\"", -0.22671109651240204`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "32", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    
                    DataAnalysis`NDV[-0.22671109651240204`, 
                    0.016133598728604377`, $CellContext`dv$28854]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Blanc-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 1-2", 
                    Style[
                    "STD 1-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["STD 1-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"0.505\"", 0.505085356721548, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "35", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    0.505085356721548, 
                    0.017921828167261015`, $CellContext`dv$28905]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["STD 1-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 2-2", 
                    Style[
                    "STD 2-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["STD 2-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.614\"", 1.613806140707826, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "76", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.613806140707826, 
                    0.03869735056006944, $CellContext`dv$28956]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["STD 2-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 3-2", 
                    Style[
                    "STD 3-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["STD 3-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"3.11\"", 3.112949605710551, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "12", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    3.112949605710551, 
                    0.06292559103956663, $CellContext`dv$29007]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["STD 3-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["STD 4-2", 
                    Style[
                    "STD 4-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["STD 4-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.992377480653775, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "24", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.992377480653775, 
                    0.12111731684957971`, $CellContext`dv$29058]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["STD 4-2"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 00", 
                    Style[
                    "Sample 00", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["Sample 00"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Sample 00"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.603\"", 2.603240200398011, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "96", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.603240200398011, 
                    0.048865766217893576`, $CellContext`dv$29109]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Sample 00"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 07", 
                    Style[
                    "Sample 07", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["Sample 07"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Sample 07"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"1.971\"", 1.9707776677963589`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "61", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    1.9707776677963589`, 
                    0.030896600392822875`, $CellContext`dv$29160]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Sample 07"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 05", 
                    Style[
                    "Sample 05", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["Sample 05"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Sample 05"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.085\"", 2.0852688522822533`, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "87", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.0852688522822533`, 
                    0.044207316264084216`, $CellContext`dv$29211]], 
                    FontFamily -> "Source Code Pro", FontSize -> 13, 
                    ShowStringCharacters -> True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Sample 05"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 06", 
                    Style[
                    "Sample 06", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["Sample 06"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Sample 06"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"2.042\"", 2.042036066525968, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "59", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    2.042036066525968, 
                    0.03003457664039987, $CellContext`dv$29262]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Sample 06"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Blanc-3", 
                    Style[
                    "Blanc-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["Blanc-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"-0.019\"", -0.019357837373813518`, AutoDelete -> True],
                     NumberForm[#, {
                    DirectedInfinity[1], 3}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[-0.019357837373813518`, 
                    0.009438202591552744, $CellContext`dv$29313]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["Blanc-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["DRIFT-3", 
                    Style[
                    "DRIFT-3", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][{
                    Key["DRIFT-3"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"]]], "Mouse"], 
                    ImageSize -> {{86.4, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    InterpretationBox[
                    StyleBox[
                    TemplateBox[{
                    TagBox[
                    InterpretationBox[
                    "\"4.99\"", 4.99247000650331, AutoDelete -> True], 
                    NumberForm[#, {
                    DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],
                     "\"(\"", "18", "\")\""}, "RowDefault"], 
                    ShowStringCharacters -> False, StripOnInput -> False], 
                    DataAnalysis`NDV[
                    4.99247000650331, 
                    0.091372761188262, $CellContext`dv$29364]], FontFamily -> 
                    "Source Code Pro", FontSize -> 13, ShowStringCharacters -> 
                    True]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    2073736671][
                    GeneralUtilities`Slice[
                    Key["DRIFT-3"], 
                    Key["Ca / ppm"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 2073736671]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[2073736671][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[2073736671][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {187., {160., 166.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 358},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[20]=",
 CellID->161828421,ExpressionUUID->"db274f6d-1704-47f4-a7dc-85a20f063c66"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Conversion", "Section",
 CellID->92390272,ExpressionUUID->"2b5510c4-5129-4a71-a8ba-71c315f181ab"],

Cell["Define chemical components using the chemical formula:", "Text",
 CellID->284149851,ExpressionUUID->"d4300a00-b30a-45ab-a23c-aba7eac9b0ec"],

Cell[BoxData[{
 RowBox[{"RegisterComp", "[", 
  RowBox[{"\"\<MgCO3\>\"", ",", 
   RowBox[{"Synonyms", "\[Rule]", 
    RowBox[{"{", "\"\<Magnesite\>\"", "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"RegisterComp", "[", 
  RowBox[{"\"\<CaMg(CO3)2\>\"", ",", 
   RowBox[{"Synonyms", "\[Rule]", 
    RowBox[{"{", "\"\<Dolomite\>\"", "}"}]}]}], "]"}]}], "Input",
 CellLabel->"In[21]:=",
 CellID->272165702,ExpressionUUID->"71e57eff-e29c-421b-982b-ae09c64a8213"],

Cell["Convert between from a mass to a molar amounts:", "Text",
 CellID->522230009,ExpressionUUID->"7a8d267f-1ab1-431d-8016-ae8e9c389b61"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MassToMoles", "[", 
  RowBox[{"\"\<Dolomite\>\"", ",", "5"}], "]"}]], "Input",
 CellLabel->"In[23]:=",
 CellID->25993159,ExpressionUUID->"241124d8-2383-4e59-b875-7385309ec942"],

Cell[BoxData["0.027114849827115716`"], "Output",
 ImageSize->{67, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[23]=",
 CellID->75817136,ExpressionUUID->"15c4529d-9024-4908-95e9-337b6204ec48"]
}, Open  ]],

Cell["\<\
Input some sample compositions and convert to a different set of chemical \
components and project from components:\
\>", "Text",
 CellID->480545825,ExpressionUUID->"0becf994-347d-4de8-8f30-fe5f5e124327"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"comps", "=", 
  RowBox[{"DataTable", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\"\<ID\>\"", ",", "\"\<Dolomite\>\"", ",", "\"\<MgCO3\>\""}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<Sample 1\>\"", ",", "0.5", ",", "0.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\"\<Sample 2\>\"", ",", "4", ",", "3"}], "}"}]}], "}"}], 
   "]"}]}]], "Input",
 CellLabel->"In[24]:=",
 CellID->202163725,ExpressionUUID->"42e6bd40-5b13-4fc7-a6d5-7f5e5a85b374"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Sample 1" -> Association["Dolomite" -> 0.5, "MgCO3" -> 0.5], 
              "Sample 2" -> Association["Dolomite" -> 4, "MgCO3" -> 3]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Dolomite", "MgCO3"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], 
             Association["ID" -> 68423257443870]]]]], Appearance -> Automatic,
         Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Sample 1" -> Association["Dolomite" -> 0.5, "MgCO3" -> 0.5], 
              "Sample 2" -> Association["Dolomite" -> 4, "MgCO3" -> 3]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Dolomite", "MgCO3"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], 
             Association["ID" -> 68423257443870]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Sample 1" -> Association["Dolomite" -> 0.5, "MgCO3" -> 0.5], 
               "Sample 2" -> Association["Dolomite" -> 4, "MgCO3" -> 3]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Dolomite", "MgCO3"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 2], 
              Association["ID" -> 68423257443870]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Sample 1" -> Association["Dolomite" -> 0.5, "MgCO3" -> 0.5], 
               "Sample 2" -> Association["Dolomite" -> 4, "MgCO3" -> 3]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Dolomite", "MgCO3"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 2], 
              Association["ID" -> 68423257443870]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 2, "Length" -> 2, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Dolomite", "MgCO3"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[6]} -> 1, {All, "Dolomite"} -> 
               1, {All, "MgCO3"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[76.80000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Dolomite" -> TypeSystem`PackageScope`AtomShape[60], 
                   "MgCO3" -> TypeSystem`PackageScope`AtomShape[60]]]]], 
               2, {}]], "InitialData" -> 
            TypeSystem`PackageScope`CacheHandle[1331508376], "Type" -> 
            TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Dolomite", "MgCO3"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[1331508376]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1028067760][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Dolomite\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Dolomite\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1028067760][{All, "Dolomite"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[All, "Dolomite"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"MgCO3\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"MgCO3\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1028067760][{All, "MgCO3"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[All, "MgCO3"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 1", 
                    Style[
                    "Sample 1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1028067760][{
                    Key["Sample 1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[
                    Key["Sample 1"]]], "Mouse"], 
                    ImageSize -> {{76.80000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.5"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[
                    Key["Sample 1"], 
                    Key["Dolomite"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.5"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[
                    Key["Sample 1"], 
                    Key["MgCO3"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 2", 
                    Style[
                    "Sample 2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1028067760][{
                    Key["Sample 2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[
                    Key["Sample 2"]]], "Mouse"], 
                    ImageSize -> {{76.80000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["4"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[
                    Key["Sample 2"], 
                    Key["Dolomite"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["3"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1028067760][
                    GeneralUtilities`Slice[
                    Key["Sample 2"], 
                    Key["MgCO3"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1028067760][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1028067760]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1028067760][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1028067760][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {226., {42., 48.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 122},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[24]=",
 CellID->818252484,ExpressionUUID->"71f4a949-05b6-4905-bc24-7805ac0e2e75"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"comps2", "=", 
  RowBox[{"ConvertComps", "[", 
   RowBox[{"comps", ",", 
    RowBox[{"{", 
     RowBox[{
     "\"\<CaO\>\"", ",", "\"\<MgO\>\"", ",", "\"\<CO2\>\"", ",", 
      "\"\<O\>\""}], "}"}], ",", 
    RowBox[{"ProjectFrom", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"\"\<CO2\>\"", ",", "\"\<O\>\""}], "}"}]}], ",", 
    RowBox[{"ToMolarData", "\[Rule]", "True"}], ",", 
    RowBox[{"ToPercent", "\[Rule]", "True"}], ",", 
    RowBox[{"FromMolarData", "\[Rule]", "True"}]}], "]"}]}]], "Input",
 CellLabel->"In[25]:=",
 CellID->477182104,ExpressionUUID->"9be2d73b-04cd-49c3-b4bc-f8240ea7e262"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Sample 1" -> 
              Association[
               "CaO" -> 33.33333333333333, "MgO" -> 66.66666666666666], 
              "Sample 2" -> 
              Association[
               "CaO" -> Rational[400, 11], "MgO" -> Rational[700, 11]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"CaO", "MgO"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], 
             Association["Origin" -> HoldComplete[
                Query[All, All, Simplify[
                  DataAnalysis`DVE[#]]& ][
                 Dataset`DatasetHandle[153536624348704]]], "ID" -> 
              153540919316000]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Sample 1" -> 
              Association[
               "CaO" -> 33.33333333333333, "MgO" -> 66.66666666666666], 
              "Sample 2" -> 
              Association[
               "CaO" -> Rational[400, 11], "MgO" -> Rational[700, 11]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"CaO", "MgO"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], 
             Association["Origin" -> HoldComplete[
                Query[All, All, Simplify[
                  DataAnalysis`DVE[#]]& ][
                 Dataset`DatasetHandle[153536624348704]]], "ID" -> 
              153540919316000]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Sample 1" -> 
               Association[
                "CaO" -> 33.33333333333333, "MgO" -> 66.66666666666666], 
               "Sample 2" -> 
               Association[
                "CaO" -> Rational[400, 11], "MgO" -> Rational[700, 11]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"CaO", "MgO"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 2], 
              Association["Origin" -> HoldComplete[
                 Query[All, All, Simplify[
                   DataAnalysis`DVE[#]]& ][
                  Dataset`DatasetHandle[153536624348704]]], "ID" -> 
               153540919316000]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Sample 1" -> 
               Association[
                "CaO" -> 33.33333333333333, "MgO" -> 66.66666666666666], 
               "Sample 2" -> 
               Association[
                "CaO" -> Rational[400, 11], "MgO" -> Rational[700, 11]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"CaO", "MgO"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 2], 
              Association["Origin" -> HoldComplete[
                 Query[All, All, Simplify[
                   DataAnalysis`DVE[#]]& ][
                  Dataset`DatasetHandle[153536624348704]]], "ID" -> 
               153540919316000]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 2, "Length" -> 2, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"CaO", "MgO"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[7]} -> 1, {All, "CaO"} -> 
               1, {All, "MgO"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[76.80000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "CaO" -> TypeSystem`PackageScope`AtomShape[60], "MgO" -> 
                   TypeSystem`PackageScope`AtomShape[60]]]]], 2, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[580850714], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"CaO", "MgO"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[580850714]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 851366740][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"CaO\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"CaO\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 851366740][{
                    All, "CaO"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[All, "CaO"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"MgO\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"MgO\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 851366740][{
                    All, "MgO"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[All, "MgO"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 1", 
                    Style[
                    "Sample 1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 851366740][{
                    Key["Sample 1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[
                    Key["Sample 1"]]], "Mouse"], 
                    ImageSize -> {{76.80000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["33.3333"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[
                    Key["Sample 1"], 
                    Key["CaO"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["66.6667"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[
                    Key["Sample 1"], 
                    Key["MgO"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 2", 
                    Style[
                    "Sample 2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 851366740][{
                    Key["Sample 2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[
                    Key["Sample 2"]]], "Mouse"], 
                    ImageSize -> {{76.80000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["36.3636"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[
                    Key["Sample 2"], 
                    Key["CaO"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["63.6364"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    851366740][
                    GeneralUtilities`Slice[
                    Key["Sample 2"], 
                    Key["MgO"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 851366740][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 851366740]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[851366740][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[851366740][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {226., {42., 48.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 122},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[25]=",
 CellID->339068688,ExpressionUUID->"268cccd9-f244-4c66-bd4a-2fde6a442b6f"]
}, Open  ]],

Cell["\<\
Calculate the coefficients for the cations for a mineral formula for a given \
number of oxygens:\
\>", "Text",
 CellID->3613955,ExpressionUUID->"b6adf989-98ee-401d-91a6-0a24ded7d463"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MinFormulaCations", "[", 
  RowBox[{"comps2", ",", "3", ",", 
   RowBox[{"FromMolarData", "\[Rule]", "True"}]}], "]"}]], "Input",
 CellLabel->"In[26]:=",
 CellID->57002934,ExpressionUUID->"360ba714-f1cd-482d-b6c8-591f17fb4dc7"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Sample 1" -> Association["Ca" -> 1., "Mg" -> 2.], "Sample 2" -> 
              Association[
               "Ca" -> Rational[12, 11], "Mg" -> Rational[21, 11]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca", "Mg"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], 
             Association["Origin" -> HoldComplete[
                Query[All, Association[
                  KeyValueMap[
                  DataAnalysis`GeoChem`ChemElementName[#] -> #2 
                    DataAnalysis`GeoChem`Private`NumberCations[#]/
                    DataAnalysis`GeoChem`Private`NumberOxygens[#]& , #]]& ][
                 Dataset`DatasetHandle[4230676237858]]], "ID" -> 
              4239266172450]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Sample 1" -> Association["Ca" -> 1., "Mg" -> 2.], "Sample 2" -> 
              Association[
               "Ca" -> Rational[12, 11], "Mg" -> Rational[21, 11]]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca", "Mg"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], 
             Association["Origin" -> HoldComplete[
                Query[All, Association[
                  KeyValueMap[
                  DataAnalysis`GeoChem`ChemElementName[#] -> #2 
                    DataAnalysis`GeoChem`Private`NumberCations[#]/
                    DataAnalysis`GeoChem`Private`NumberOxygens[#]& , #]]& ][
                 Dataset`DatasetHandle[4230676237858]]], "ID" -> 
              4239266172450]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Sample 1" -> Association["Ca" -> 1., "Mg" -> 2.], "Sample 2" -> 
               Association[
                "Ca" -> Rational[12, 11], "Mg" -> Rational[21, 11]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca", "Mg"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 2], 
              Association["Origin" -> HoldComplete[
                 Query[All, Association[
                   KeyValueMap[
                   DataAnalysis`GeoChem`ChemElementName[#] -> #2 
                    DataAnalysis`GeoChem`Private`NumberCations[#]/
                    DataAnalysis`GeoChem`Private`NumberOxygens[#]& , #]]& ][
                  Dataset`DatasetHandle[4230676237858]]], "ID" -> 
               4239266172450]]]], "TSV"]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Sample 1" -> Association["Ca" -> 1., "Mg" -> 2.], "Sample 2" -> 
               Association[
                "Ca" -> Rational[12, 11], "Mg" -> Rational[21, 11]]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"Ca", "Mg"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 2], 
              Association["Origin" -> HoldComplete[
                 Query[All, Association[
                   KeyValueMap[
                   DataAnalysis`GeoChem`ChemElementName[#] -> #2 
                    DataAnalysis`GeoChem`Private`NumberCations[#]/
                    DataAnalysis`GeoChem`Private`NumberOxygens[#]& , #]]& ][
                  Dataset`DatasetHandle[4230676237858]]], "ID" -> 
               4239266172450]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 2, "Length" -> 2, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca", "Mg"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[8]} -> 1, {All, "Ca"} -> 
               1, {All, "Mg"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[76.80000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Ca" -> TypeSystem`PackageScope`AtomShape[60], "Mg" -> 
                   TypeSystem`PackageScope`AtomShape[60]]]]], 2, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[517652491], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"Ca", "Mg"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[517652491]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 48043454][{
                    All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 48043454][{
                    All, "Ca"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[All, "Ca"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Mg\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Mg\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 48043454][{
                    All, "Mg"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[All, "Mg"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 1", 
                    Style[
                    "Sample 1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 48043454][{
                    Key["Sample 1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[
                    Key["Sample 1"]]], "Mouse"], 
                    ImageSize -> {{76.80000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["1."], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[
                    Key["Sample 1"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["2."], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[
                    Key["Sample 1"], 
                    Key["Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Sample 2", 
                    Style[
                    "Sample 2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 48043454][{
                    Key["Sample 2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[
                    Key["Sample 2"]]], "Mouse"], 
                    ImageSize -> {{76.80000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["12/11"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[
                    Key["Sample 2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["21/11"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    48043454][
                    GeneralUtilities`Slice[
                    Key["Sample 2"], 
                    Key["Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 48043454][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 48043454]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[48043454][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[48043454][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {226., {42., 48.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{305, 122},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[26]=",
 CellID->642215501,ExpressionUUID->"3101c0c5-ac50-4648-a3e0-a71441f9e592"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["PHREEQC", "Section",
 CellID->140195933,ExpressionUUID->"eb018c90-5bba-400b-86ea-e98b1857a1b7"],

Cell[TextData[{
 "Open a link to ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["IPhreeqC"]],
    "https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"},
   "WebLink",
   BaseStyle->{"Text"}]],ExpressionUUID->
  "e1ceb88b-a5b2-4e0d-a768-2978be2580e7"],
 " (a library for the popular USGS geochemistry software package ",
 Cell[BoxData[
  TemplateBox[{Cell[
     TextData["PHREEQC"]],
    "https://wwwbrr.cr.usgs.gov/projects/GWC_coupled/phreeqc/"},
   "WebLink",
   BaseStyle->{"Text"}]],ExpressionUUID->
  "dff9df73-b853-4c3c-b321-caed978e3e32"],
 ") and load a database:"
}], "Text",
 CellID->579455607,ExpressionUUID->"8228c4fb-3ea1-481a-a3f2-d2c01b80514f"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"phrcLink", "=", 
   RowBox[{"PhreeqcOpenLink", "[", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"PhreeqcLoadDB", "[", 
   RowBox[{
   "phrcLink", ",", "\"\<C:\\\\phreeqc\\\\database\\\\core10.dat\>\""}], 
   "]"}], ";"}]}], "Input",
 CellLabel->"In[27]:=",
 CellID->83402267,ExpressionUUID->"7d9387c6-44e2-45de-adc4-4bb0795b26dd"],

Cell["Define a PHREEQC script with variables:", "Text",
 CellID->703741967,ExpressionUUID->"d10ecde7-ddd0-44ea-8b9a-23ec880d5f2e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"script", "[", 
    RowBox[{"pco2_", ",", "siCalcite_"}], "]"}], ":=", 
   RowBox[{
   "\"\<\nSOLUTION 1\n  Na      0.1 mol/kgw\nEQUILIBRIUM_PHASES\n  CO2(g)  \>\
\"", "<>", 
    RowBox[{"ToString", "[", "pco2", "]"}], "<>", "\"\<\n  Calcite \>\"", "<>", 
    RowBox[{"ToString", "[", "siCalcite", "]"}], "<>", 
    "\"\<\nEND\n\nSELECTED_OUTPUT\n  -reset false\n  -pH true\n  -totals Ca \
Na\n  -activities Ca+2 CO3-2\n\>\""}]}], ";"}]], "Input",
 CellLabel->"In[29]:=",
 CellID->36518888,ExpressionUUID->"b2abdf72-7ad9-426e-a222-eb652b819e11"],

Cell["Run the script and return the full SELECTED_OUTPUT:", "Text",
 CellID->218242064,ExpressionUUID->"f20f507b-f0c9-4e67-9365-85f79f0bfb82"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DataTable", "@", 
  RowBox[{"PhreeqcRunString", "[", 
   RowBox[{"phrcLink", ",", 
    RowBox[{"script", "[", 
     RowBox[{
      RowBox[{"-", "3.4"}], ",", "0"}], "]"}], ",", 
    RowBox[{"SelectedOutput", "\[Rule]", "True"}]}], "]"}]}]], "Input",
 CellLabel->"In[31]:=",
 CellID->457539375,ExpressionUUID->"7c27d248-b1e8-41c3-a858-8f98cba54433"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Result-1" -> 
              Association[
               "pH" -> 7, "Ca" -> 0., "Na" -> 0.1, "la_Ca+2" -> -1000., 
                "la_CO3-2" -> -1000.], "Result-2" -> 
              Association[
               "pH" -> 8.25504, "Ca" -> 0.00073767, "Na" -> 0.1, 
                "la_Ca+2" -> -3.456, "la_CO3-2" -> -5.0723]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"pH", "Ca", "Na", "la_Ca+2", "la_CO3-2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], 
             Association["ID" -> 76656709750334]]]]], Appearance -> Automatic,
         Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             "Result-1" -> 
              Association[
               "pH" -> 7, "Ca" -> 0., "Na" -> 0.1, "la_Ca+2" -> -1000., 
                "la_CO3-2" -> -1000.], "Result-2" -> 
              Association[
               "pH" -> 8.25504, "Ca" -> 0.00073767, "Na" -> 0.1, 
                "la_Ca+2" -> -3.456, "la_CO3-2" -> -5.0723]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"pH", "Ca", "Na", "la_Ca+2", "la_CO3-2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], 
             Association["ID" -> 76656709750334]]], True]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Result-1" -> 
               Association[
                "pH" -> 7, "Ca" -> 0., "Na" -> 0.1, "la_Ca+2" -> -1000., 
                 "la_CO3-2" -> -1000.], "Result-2" -> 
               Association[
                "pH" -> 8.25504, "Ca" -> 0.00073767, "Na" -> 0.1, 
                 "la_Ca+2" -> -3.456, "la_CO3-2" -> -5.0723]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"pH", "Ca", "Na", "la_Ca+2", "la_CO3-2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 2], 
              Association["ID" -> 76656709750334]]]], "TSV"]], Appearance -> 
        Automatic, Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              "Result-1" -> 
               Association[
                "pH" -> 7, "Ca" -> 0., "Na" -> 0.1, "la_Ca+2" -> -1000., 
                 "la_CO3-2" -> -1000.], "Result-2" -> 
               Association[
                "pH" -> 8.25504, "Ca" -> 0.00073767, "Na" -> 0.1, 
                 "la_Ca+2" -> -3.456, "la_CO3-2" -> -5.0723]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[String], 
               TypeSystem`Struct[{"pH", "Ca", "Na", "la_Ca+2", "la_CO3-2"}, {
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 2], 
              Association["ID" -> 76656709750334]]], True], "TSV"]], 
        Appearance -> Automatic, Evaluator -> Automatic, Method -> 
        "Preemptive", ButtonData -> "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 2, "Length" -> 2, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"pH", "Ca", "Na", "la_Ca+2", "la_CO3-2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[9]} -> 1, {All, "pH"} -> 
               1, {All, "Ca"} -> 1, {All, "Na"} -> 1, {All, "la_Ca+2"} -> 
               1, {All, "la_CO3-2"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[76.80000000000001], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "pH" -> TypeSystem`PackageScope`AtomShape[60], "Ca" -> 
                   TypeSystem`PackageScope`AtomShape[60], "Na" -> 
                   TypeSystem`PackageScope`AtomShape[60], "la_Ca+2" -> 
                   TypeSystem`PackageScope`AtomShape[60], "la_CO3-2" -> 
                   TypeSystem`PackageScope`AtomShape[60]]]]], 2, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[1940065760], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[String], 
              TypeSystem`Struct[{"pH", "Ca", "Na", "la_Ca+2", "la_CO3-2"}, {
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 2], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[1940065760]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1152851105][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"pH\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"pH\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1152851105][{All, "pH"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[All, "pH"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Ca\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Ca\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1152851105][{All, "Ca"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[All, "Ca"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Na\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Na\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1152851105][{All, "Na"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[All, "Na"]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"la_Ca+2\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"la_Ca+2\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1152851105][{All, "la_Ca+2"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[All, "la_Ca+2"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"la_CO3-2\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"la_CO3-2\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1152851105][{All, "la_CO3-2"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[All, "la_CO3-2"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Result-1", 
                    Style[
                    "Result-1", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1152851105][{
                    Key["Result-1"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-1"]]], "Mouse"], 
                    ImageSize -> {{76.80000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["7"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-1"], 
                    Key["pH"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0."], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-1"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-1"], 
                    Key["Na"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["-1000."], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-1"], 
                    Key["la_Ca+2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["-1000."], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-1"], 
                    Key["la_CO3-2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover["Result-2", 
                    Style[
                    "Result-2", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1152851105][{
                    Key["Result-2"]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-2"]]], "Mouse"], 
                    ImageSize -> {{76.80000000000001, Full}, Automatic}], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["8.25504"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-2"], 
                    Key["pH"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00073767"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-2"], 
                    Key["Ca"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.1"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-2"], 
                    Key["Na"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["-3.456"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-2"], 
                    Key["la_Ca+2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["-5.0723"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1152851105][
                    GeneralUtilities`Slice[
                    Key["Result-2"], 
                    Key["la_CO3-2"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1152851105][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1152851105]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1152851105][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1152851105][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {449., {42., 48.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{453, 122},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[31]=",
 CellID->460763692,ExpressionUUID->"ad0d1244-2f73-4cb6-add1-309d1798da0a"]
}, Open  ]],

Cell["\<\
Run a Monte Carlo simulation with PHREEQC and uncertainties in the input \
variables:\
\>", "Text",
 CellID->481346176,ExpressionUUID->"cc948fab-653b-450f-b0fb-9a63db9158b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"mcres", "=", 
   RowBox[{"MonteCarloSimulation", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"DataTable", "[", 
        RowBox[{"PhreeqcRunString", "[", 
         RowBox[{"phrcLink", ",", 
          RowBox[{"script", "[", 
           RowBox[{"pco2", ",", "siCalcite"}], "]"}], ",", 
          RowBox[{"SelectedOutput", "\[Rule]", "True"}]}], "]"}], "]"}], "[", 
       RowBox[{"\"\<Result-2\>\"", ",", "\"\<pH\>\""}], "]"}], "]"}], ",", 
     "\[IndentingNewLine]", "1000", ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"pco2", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{
          RowBox[{"-", "3.4"}], ",", "0.1"}], "]"}]}], ",", 
       RowBox[{"siCalcite", "\[Rule]", 
        RowBox[{"NDV", "[", 
         RowBox[{"0", ",", "0.5"}], "]"}]}]}], "}"}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}]], "Input",
 CellLabel->"In[32]:=",
 CellID->19586121,ExpressionUUID->"184ebc70-183f-45b2-b150-9f5d0a939d53"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mcres", "[", "\"\<DistributionMeanNDV\>\"", "]"}]], "Input",
 CellLabel->"In[33]:=",
 CellID->252273675,ExpressionUUID->"2658b682-dcb5-4ac5-a623-87001d1789a1"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[
   TemplateBox[{TagBox[
      InterpretationBox["\"8.26\"", 8.25776909, AutoDelete -> True], 
      NumberForm[#, {
        DirectedInfinity[1], 2}, ExponentFunction -> (Null& )]& ],"\"(\"",
     "35","\")\""},
    "RowDefault"],
   StripOnInput->False,
   ShowStringCharacters->False],
  DataAnalysis`NDV[
  8.25776909, 0.17883799427265828`, $CellContext`dv$77565]]], "Output",
 ImageSize->{60, 14},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[33]=",
 CellID->103211626,ExpressionUUID->"1a29ee89-c6c1-4d53-82cb-896560048c33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mcres", "[", "\"\<SensitivityPlots\>\"", "]"}]], "Input",
 CellLabel->"In[34]:=",
 CellID->258458251,ExpressionUUID->"ed7389bd-66c3-438f-b736-fc6ea4efede8"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     GraphicsBox[{{}, {
        {RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
         AbsolutePointSize[6], AbsoluteThickness[1.6], 
         GeometricTransformationBox[InsetBox[
           GraphicsBox[
            {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
             AbsoluteThickness[1.6], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}]},
            ImageSize->10], {0., 0.}], CompressedData["
1:eJxFmwk4VV/7/iXS2fvQaKjU2cdYolHIkIVEpISQUiSSkoSSMU0qhaRIhhKp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          "]]}, {}}, {}, {}, {}, {}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->{False, False},
      AxesLabel->{None, None},
      AxesOrigin->{-3.069914453702842, 7.701754},
      DisplayFunction->Identity,
      Frame->{{True, True}, {True, True}},
      FrameLabel->{{None, None}, {None, None}},
      FrameStyle->GrayLevel[0],
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      FrameTicksStyle->12,
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->450,
      LabelStyle->12,
      Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotLabel->FormBox[
        StyleBox["pco2", 16, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-3.781910711013966, -3.0808682422768596`}, {7.7518, 
       8.75272}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]},
    {
     GraphicsBox[{{}, {
        {RGBColor[0.28026441037696703`, 0.715, 0.4292089322474965], 
         AbsolutePointSize[6], AbsoluteThickness[1.6], 
         GeometricTransformationBox[InsetBox[
           GraphicsBox[
            {RGBColor[0.368417, 0.506779, 0.709798], AbsolutePointSize[6], 
             AbsoluteThickness[1.6], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}]},
            ImageSize->10], {0., 0.}], CompressedData["
1:eJw9mwc41t///1OkFA0you73XaRFZDeck4YkiYS0REMSSQkNRX1UZpREyMjI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          "]]}, {}}, {}, {}, {}, {}},
      AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
      Axes->{False, False},
      AxesLabel->{None, None},
      AxesOrigin->{0, 7.701754},
      DisplayFunction->Identity,
      Frame->{{True, True}, {True, True}},
      FrameLabel->{{None, None}, {None, None}},
      FrameStyle->GrayLevel[0],
      FrameTicks->{{Automatic, Automatic}, {Automatic, Automatic}},
      FrameTicksStyle->12,
      GridLines->{None, None},
      GridLinesStyle->Directive[
        GrayLevel[0.5, 0.4]],
      ImagePadding->All,
      ImageSize->450,
      LabelStyle->12,
      Method->{"CoordinatesToolOptions" -> {"DisplayFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& ), "CopiedValueFunction" -> ({
            (Identity[#]& )[
             Part[#, 1]], 
            (Identity[#]& )[
             Part[#, 2]]}& )}},
      PlotLabel->FormBox[
        StyleBox["siCalcite", 16, 
         GrayLevel[0], StripOnInput -> False], TraditionalForm],
      PlotRange->{{-1.516812672548676, 1.7076719698030896`}, {7.7518, 
       8.75272}},
      PlotRangeClipping->True,
      PlotRangePadding->{{
         Scaled[0.02], 
         Scaled[0.02]}, {
         Scaled[0.05], 
         Scaled[0.05]}},
      Ticks->{Automatic, Automatic}]}
   },
   AutoDelete->False,
   GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{5}}}],
  "Grid"]], "Output",
 ImageSize->{454, 621},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[34]=",
 CellID->443047036,ExpressionUUID->"0a978467-cc3a-44e6-a01f-f1c2d4d5581a"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Data import", "Section",
 CellID->11826752,ExpressionUUID->"bd8599ca-a0bb-4a5f-98c3-829efcb91427"],

Cell["\<\
Import data from common file formats in analytical chemistry, for example \
mass-spectrometer .exp files:\
\>", "Text",
 CellID->78545527,ExpressionUUID->"fd9c7774-b1d4-4473-9e1f-d1f0ae9c4ff9"],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"ImportDataTable", "[", 
    RowBox[{"exampleFolder", ",", 
     RowBox[{"{", 
      RowBox[{"\"\<ThermoFisherNeptune\>\"", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<24Mg\>\"", ",", "\"\<25Mg\>\"", ",", "\"\<26Mg\>\""}], 
        "}"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[36]:=",
 CellID->22074223,ExpressionUUID->"d7f2356a-057a-4d14-9c51-b8f968a84477"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"data", "//", "First"}]], "Input",
 CellLabel->"In[37]:=",
 CellID->238579963,ExpressionUUID->"f93460a1-8335-496d-a70c-07fe5db57e31"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TemplateBox[{
      ButtonBox[
       "\"Show in Excel\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             1 -> Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 11, 31.916000366210938`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006000274350392442, "25Mg" -> 
                0.0007911182958764921, "26Mg" -> 0.0010200738351586467`], 2 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 11, 40.30799865722656}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006062528553356249,
                 "25Mg" -> 0.0007868021729332518, "26Mg" -> 
                0.0010042034225217968`], 3 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 11, 48.698997497558594`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.00605335992541427, "25Mg" -> 
                0.0008079719093901368, "26Mg" -> 0.0010204743067879776`], 4 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 11, 57.08899688720703}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.00606240909186658, 
                "25Mg" -> 0.0007971374104635725, "26Mg" -> 
                0.0010145117458559923`], 5 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 12, 5.482002258300781}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006180055691484342,
                 "25Mg" -> 0.0008185928926272694, "26Mg" -> 
                0.0010388220130958443`], 6 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 12, 13.873001098632812`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.00745733933447296, "25Mg" -> 
                0.0009683045872361269, "26Mg" -> 0.0012263871134601493`], 7 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 12, 22.26300048828125}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006196020733142285,
                 "25Mg" -> 0.0008062395560310346, "26Mg" -> 
                0.0010304713174443482`], 8 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 12, 30.65399932861328}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 
                0.0060410854440738435`, "25Mg" -> 0.0007854515533114398, 
                "26Mg" -> 0.0010182494664422962`], 9 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 12, 39.045997619628906`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006028631926861925, "25Mg" -> 
                0.0007943480601073072, "26Mg" -> 0.0010076741266595811`], 10 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 12, 47.439002990722656`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.0060662467993422755`, "25Mg" -> 
                0.0007728556464268572, "26Mg" -> 0.0010242713791295596`], 11 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 12, 55.83100128173828}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006011922576065725,
                 "25Mg" -> 0.0007894153335452814, "26Mg" -> 
                0.0009987749095462684], 12 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 13, 4.2220001220703125`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006026408378915154, "25Mg" -> 
                0.0007945095485967318, "26Mg" -> 0.0010037881254015793`], 13 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 12.61199951171875}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006056406170344615,
                 "25Mg" -> 0.0007720922633064961, "26Mg" -> 
                0.0010420110183740898`], 14 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 21.00299835205078}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006066500655997109,
                 "25Mg" -> 0.0007593497247173536, "26Mg" -> 
                0.0009986414218951588], 15 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 29.39600372314453}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006085271293854985,
                 "25Mg" -> 0.0007961244349472722, "26Mg" -> 
                0.001009928607625562], 16 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 37.78600311279297}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006052254917286871,
                 "25Mg" -> 0.0008288391533814544, "26Mg" -> 
                0.0010203408162269777`], 17 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 46.17900085449219}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006087152856892557,
                 "25Mg" -> 0.0008112238712572262, "26Mg" -> 
                0.0010188130921928251`], 18 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 13, 54.569000244140625`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006111434296828967, "25Mg" -> 
                0.0008044631629529921, "26Mg" -> 0.0010101807538404064`], 19 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 2.9599990844726562`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.0060264681146181606`, "25Mg" -> 
                0.0007630785150348491, "26Mg" -> 0.0010062205824284466`], 20 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 11.350997924804688`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006806662936294101, "25Mg" -> 
                0.0009150851845181147, "26Mg" -> 0.0011280141855538155`], 21 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 19.742996215820312`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006140405542183254, "25Mg" -> 
                0.0007973576226702954, "26Mg" -> 0.0010262440825865378`], 22 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 28.134002685546875`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006072862026103549, "25Mg" -> 
                0.0007948472064331002, "26Mg" -> 0.0010215718965234579`], 23 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 14, 36.5260009765625}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006037203036015139,
                 "25Mg" -> 0.0007817520394814356, "26Mg" -> 
                0.0009850999343085174], 24 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 14, 44.91699981689453}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 
                0.0060323351148542145`, "25Mg" -> 0.0008117082873041469, 
                "26Mg" -> 0.0009991308767032284], 25 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 53.308998107910156`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006054226013717082, "25Mg" -> 
                0.0008192534649638263, "26Mg" -> 0.0010101955859728627`], 26 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 15, 1.6999969482421875`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006029990756350372, "25Mg" -> 
                0.0008076636089932022, "26Mg" -> 0.0010129395342469863`], 27 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 15, 10.092002868652344`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006003589600839594, "25Mg" -> 
                0.0007733547818639748, "26Mg" -> 0.0009867017655118848], 28 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 15, 18.483001708984375`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.008316897903629245, "25Mg" -> 
                0.001111549791200362, "26Mg" -> 0.0013804309746649737`], 29 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 15, 26.875}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006218393127711418, "25Mg" -> 
                0.0008000442155538357, "26Mg" -> 0.0010396378041713835`], 30 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 15, 35.26599884033203}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006097844980588943,
                 "25Mg" -> 0.0007857011241889993, "26Mg" -> 
                0.001017552350823933]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[Integer], 
              TypeSystem`Struct[{"Time", "24Mg", "25Mg", "26Mg"}, {
                TypeSystem`Atom[DateObject], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 30], 
             Association["Origin" -> HoldComplete[First, 
                Dataset`DatasetHandle[297950604709480]], "ID" -> 
              297954899676779]]]]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show in Excel"],ButtonBox[
       "\"Show using \[PlusMinus]\"", ButtonFunction :> 
        DataAnalysis`Private`DataTableViewExcel[
          DataAnalysis`Private`PrepareListData[
           DataAnalysis`DataTable[
            Dataset[
             Association[
             1 -> Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 11, 31.916000366210938`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006000274350392442, "25Mg" -> 
                0.0007911182958764921, "26Mg" -> 0.0010200738351586467`], 2 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 11, 40.30799865722656}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006062528553356249,
                 "25Mg" -> 0.0007868021729332518, "26Mg" -> 
                0.0010042034225217968`], 3 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 11, 48.698997497558594`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.00605335992541427, "25Mg" -> 
                0.0008079719093901368, "26Mg" -> 0.0010204743067879776`], 4 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 11, 57.08899688720703}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.00606240909186658, 
                "25Mg" -> 0.0007971374104635725, "26Mg" -> 
                0.0010145117458559923`], 5 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 12, 5.482002258300781}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006180055691484342,
                 "25Mg" -> 0.0008185928926272694, "26Mg" -> 
                0.0010388220130958443`], 6 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 12, 13.873001098632812`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.00745733933447296, "25Mg" -> 
                0.0009683045872361269, "26Mg" -> 0.0012263871134601493`], 7 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 12, 22.26300048828125}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006196020733142285,
                 "25Mg" -> 0.0008062395560310346, "26Mg" -> 
                0.0010304713174443482`], 8 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 12, 30.65399932861328}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 
                0.0060410854440738435`, "25Mg" -> 0.0007854515533114398, 
                "26Mg" -> 0.0010182494664422962`], 9 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 12, 39.045997619628906`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006028631926861925, "25Mg" -> 
                0.0007943480601073072, "26Mg" -> 0.0010076741266595811`], 10 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 12, 47.439002990722656`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.0060662467993422755`, "25Mg" -> 
                0.0007728556464268572, "26Mg" -> 0.0010242713791295596`], 11 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 12, 55.83100128173828}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006011922576065725,
                 "25Mg" -> 0.0007894153335452814, "26Mg" -> 
                0.0009987749095462684], 12 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 13, 4.2220001220703125`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006026408378915154, "25Mg" -> 
                0.0007945095485967318, "26Mg" -> 0.0010037881254015793`], 13 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 12.61199951171875}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006056406170344615,
                 "25Mg" -> 0.0007720922633064961, "26Mg" -> 
                0.0010420110183740898`], 14 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 21.00299835205078}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006066500655997109,
                 "25Mg" -> 0.0007593497247173536, "26Mg" -> 
                0.0009986414218951588], 15 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 29.39600372314453}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006085271293854985,
                 "25Mg" -> 0.0007961244349472722, "26Mg" -> 
                0.001009928607625562], 16 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 37.78600311279297}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006052254917286871,
                 "25Mg" -> 0.0008288391533814544, "26Mg" -> 
                0.0010203408162269777`], 17 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 13, 46.17900085449219}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006087152856892557,
                 "25Mg" -> 0.0008112238712572262, "26Mg" -> 
                0.0010188130921928251`], 18 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 13, 54.569000244140625`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006111434296828967, "25Mg" -> 
                0.0008044631629529921, "26Mg" -> 0.0010101807538404064`], 19 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 2.9599990844726562`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.0060264681146181606`, "25Mg" -> 
                0.0007630785150348491, "26Mg" -> 0.0010062205824284466`], 20 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 11.350997924804688`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006806662936294101, "25Mg" -> 
                0.0009150851845181147, "26Mg" -> 0.0011280141855538155`], 21 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 19.742996215820312`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006140405542183254, "25Mg" -> 
                0.0007973576226702954, "26Mg" -> 0.0010262440825865378`], 22 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 28.134002685546875`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006072862026103549, "25Mg" -> 
                0.0007948472064331002, "26Mg" -> 0.0010215718965234579`], 23 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 14, 36.5260009765625}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006037203036015139,
                 "25Mg" -> 0.0007817520394814356, "26Mg" -> 
                0.0009850999343085174], 24 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 14, 44.91699981689453}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 
                0.0060323351148542145`, "25Mg" -> 0.0008117082873041469, 
                "26Mg" -> 0.0009991308767032284], 25 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 14, 53.308998107910156`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006054226013717082, "25Mg" -> 
                0.0008192534649638263, "26Mg" -> 0.0010101955859728627`], 26 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 15, 1.6999969482421875`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006029990756350372, "25Mg" -> 
                0.0008076636089932022, "26Mg" -> 0.0010129395342469863`], 27 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 15, 10.092002868652344`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006003589600839594, "25Mg" -> 
                0.0007733547818639748, "26Mg" -> 0.0009867017655118848], 28 -> 
              Association[
               "Time" -> DateObject[{
                  2015, 7, 29, 18, 15, 18.483001708984375`}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.008316897903629245, "25Mg" -> 
                0.001111549791200362, "26Mg" -> 0.0013804309746649737`], 29 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 15, 26.875}, "Instant", 
                  "Gregorian", 1.], "24Mg" -> 0.006218393127711418, "25Mg" -> 
                0.0008000442155538357, "26Mg" -> 0.0010396378041713835`], 30 -> 
              Association[
               "Time" -> DateObject[{2015, 7, 29, 18, 15, 35.26599884033203}, 
                  "Instant", "Gregorian", 1.], "24Mg" -> 0.006097844980588943,
                 "25Mg" -> 0.0007857011241889993, "26Mg" -> 
                0.001017552350823933]], 
             TypeSystem`Assoc[
              TypeSystem`Atom[Integer], 
              TypeSystem`Struct[{"Time", "24Mg", "25Mg", "26Mg"}, {
                TypeSystem`Atom[DateObject], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 30], 
             Association["Origin" -> HoldComplete[First, 
                Dataset`DatasetHandle[297950604709480]], "ID" -> 
              297954899676779]]], True]], Appearance -> Automatic, Evaluator -> 
        Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Show using \[PlusMinus]"],ButtonBox[
       "\"Copy TSV\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              1 -> Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 11, 31.916000366210938`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006000274350392442, "25Mg" -> 
                 0.0007911182958764921, "26Mg" -> 0.0010200738351586467`], 2 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 11, 40.30799865722656},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006062528553356249, "25Mg" -> 0.0007868021729332518, 
                 "26Mg" -> 0.0010042034225217968`], 3 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 11, 48.698997497558594`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.00605335992541427, "25Mg" -> 
                 0.0008079719093901368, "26Mg" -> 0.0010204743067879776`], 4 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 11, 57.08899688720703},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.00606240909186658, "25Mg" -> 0.0007971374104635725, "26Mg" -> 
                 0.0010145117458559923`], 5 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 12, 5.482002258300781},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006180055691484342, "25Mg" -> 0.0008185928926272694, 
                 "26Mg" -> 0.0010388220130958443`], 6 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 12, 13.873001098632812`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.00745733933447296, "25Mg" -> 
                 0.0009683045872361269, "26Mg" -> 0.0012263871134601493`], 7 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 12, 22.26300048828125},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006196020733142285, "25Mg" -> 0.0008062395560310346, 
                 "26Mg" -> 0.0010304713174443482`], 8 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 12, 30.65399932861328},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.0060410854440738435`, "25Mg" -> 0.0007854515533114398, 
                 "26Mg" -> 0.0010182494664422962`], 9 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 12, 39.045997619628906`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006028631926861925, "25Mg" -> 
                 0.0007943480601073072, "26Mg" -> 0.0010076741266595811`], 10 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 12, 47.439002990722656`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.0060662467993422755`, "25Mg" -> 
                 0.0007728556464268572, "26Mg" -> 0.0010242713791295596`], 11 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 12, 55.83100128173828},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006011922576065725, "25Mg" -> 0.0007894153335452814, 
                 "26Mg" -> 0.0009987749095462684], 12 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 13, 4.2220001220703125`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006026408378915154, "25Mg" -> 
                 0.0007945095485967318, "26Mg" -> 0.0010037881254015793`], 13 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 12.61199951171875},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006056406170344615, "25Mg" -> 0.0007720922633064961, 
                 "26Mg" -> 0.0010420110183740898`], 14 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 21.00299835205078},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006066500655997109, "25Mg" -> 0.0007593497247173536, 
                 "26Mg" -> 0.0009986414218951588], 15 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 29.39600372314453},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006085271293854985, "25Mg" -> 0.0007961244349472722, 
                 "26Mg" -> 0.001009928607625562], 16 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 37.78600311279297},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006052254917286871, "25Mg" -> 0.0008288391533814544, 
                 "26Mg" -> 0.0010203408162269777`], 17 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 46.17900085449219},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006087152856892557, "25Mg" -> 0.0008112238712572262, 
                 "26Mg" -> 0.0010188130921928251`], 18 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 13, 54.569000244140625`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006111434296828967, "25Mg" -> 
                 0.0008044631629529921, "26Mg" -> 0.0010101807538404064`], 19 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 2.9599990844726562`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.0060264681146181606`, "25Mg" -> 
                 0.0007630785150348491, "26Mg" -> 0.0010062205824284466`], 20 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 11.350997924804688`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006806662936294101, "25Mg" -> 
                 0.0009150851845181147, "26Mg" -> 0.0011280141855538155`], 21 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 19.742996215820312`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006140405542183254, "25Mg" -> 
                 0.0007973576226702954, "26Mg" -> 0.0010262440825865378`], 22 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 28.134002685546875`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006072862026103549, "25Mg" -> 
                 0.0007948472064331002, "26Mg" -> 0.0010215718965234579`], 23 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 14, 36.5260009765625}, 
                   "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006037203036015139, "25Mg" -> 0.0007817520394814356, 
                 "26Mg" -> 0.0009850999343085174], 24 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 14, 44.91699981689453},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.0060323351148542145`, "25Mg" -> 0.0008117082873041469, 
                 "26Mg" -> 0.0009991308767032284], 25 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 53.308998107910156`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006054226013717082, "25Mg" -> 
                 0.0008192534649638263, "26Mg" -> 0.0010101955859728627`], 26 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 15, 1.6999969482421875`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006029990756350372, "25Mg" -> 
                 0.0008076636089932022, "26Mg" -> 0.0010129395342469863`], 27 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 15, 10.092002868652344`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006003589600839594, "25Mg" -> 
                 0.0007733547818639748, "26Mg" -> 0.0009867017655118848], 28 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 15, 18.483001708984375`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.008316897903629245, "25Mg" -> 
                 0.001111549791200362, "26Mg" -> 0.0013804309746649737`], 29 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 15, 26.875}, "Instant",
                    "Gregorian", 1.], "24Mg" -> 0.006218393127711418, "25Mg" -> 
                 0.0008000442155538357, "26Mg" -> 0.0010396378041713835`], 30 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 15, 35.26599884033203},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006097844980588943, "25Mg" -> 0.0007857011241889993, 
                 "26Mg" -> 0.001017552350823933]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[Integer], 
               TypeSystem`Struct[{"Time", "24Mg", "25Mg", "26Mg"}, {
                 TypeSystem`Atom[DateObject], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 30], 
              Association["Origin" -> HoldComplete[First, 
                 Dataset`DatasetHandle[297950604709480]], "ID" -> 
               297954899676779]]]], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy TSV"],ButtonBox[
       "\"Copy using \[PlusMinus]\"", ButtonFunction :> CopyToClipboard[
          ExportString[
           DataAnalysis`Private`PrepareListData[
            DataAnalysis`DataTable[
             Dataset[
              Association[
              1 -> Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 11, 31.916000366210938`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006000274350392442, "25Mg" -> 
                 0.0007911182958764921, "26Mg" -> 0.0010200738351586467`], 2 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 11, 40.30799865722656},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006062528553356249, "25Mg" -> 0.0007868021729332518, 
                 "26Mg" -> 0.0010042034225217968`], 3 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 11, 48.698997497558594`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.00605335992541427, "25Mg" -> 
                 0.0008079719093901368, "26Mg" -> 0.0010204743067879776`], 4 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 11, 57.08899688720703},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.00606240909186658, "25Mg" -> 0.0007971374104635725, "26Mg" -> 
                 0.0010145117458559923`], 5 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 12, 5.482002258300781},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006180055691484342, "25Mg" -> 0.0008185928926272694, 
                 "26Mg" -> 0.0010388220130958443`], 6 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 12, 13.873001098632812`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.00745733933447296, "25Mg" -> 
                 0.0009683045872361269, "26Mg" -> 0.0012263871134601493`], 7 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 12, 22.26300048828125},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006196020733142285, "25Mg" -> 0.0008062395560310346, 
                 "26Mg" -> 0.0010304713174443482`], 8 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 12, 30.65399932861328},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.0060410854440738435`, "25Mg" -> 0.0007854515533114398, 
                 "26Mg" -> 0.0010182494664422962`], 9 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 12, 39.045997619628906`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006028631926861925, "25Mg" -> 
                 0.0007943480601073072, "26Mg" -> 0.0010076741266595811`], 10 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 12, 47.439002990722656`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.0060662467993422755`, "25Mg" -> 
                 0.0007728556464268572, "26Mg" -> 0.0010242713791295596`], 11 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 12, 55.83100128173828},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006011922576065725, "25Mg" -> 0.0007894153335452814, 
                 "26Mg" -> 0.0009987749095462684], 12 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 13, 4.2220001220703125`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006026408378915154, "25Mg" -> 
                 0.0007945095485967318, "26Mg" -> 0.0010037881254015793`], 13 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 12.61199951171875},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006056406170344615, "25Mg" -> 0.0007720922633064961, 
                 "26Mg" -> 0.0010420110183740898`], 14 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 21.00299835205078},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006066500655997109, "25Mg" -> 0.0007593497247173536, 
                 "26Mg" -> 0.0009986414218951588], 15 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 29.39600372314453},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006085271293854985, "25Mg" -> 0.0007961244349472722, 
                 "26Mg" -> 0.001009928607625562], 16 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 37.78600311279297},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006052254917286871, "25Mg" -> 0.0008288391533814544, 
                 "26Mg" -> 0.0010203408162269777`], 17 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 13, 46.17900085449219},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006087152856892557, "25Mg" -> 0.0008112238712572262, 
                 "26Mg" -> 0.0010188130921928251`], 18 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 13, 54.569000244140625`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006111434296828967, "25Mg" -> 
                 0.0008044631629529921, "26Mg" -> 0.0010101807538404064`], 19 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 2.9599990844726562`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.0060264681146181606`, "25Mg" -> 
                 0.0007630785150348491, "26Mg" -> 0.0010062205824284466`], 20 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 11.350997924804688`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006806662936294101, "25Mg" -> 
                 0.0009150851845181147, "26Mg" -> 0.0011280141855538155`], 21 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 19.742996215820312`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006140405542183254, "25Mg" -> 
                 0.0007973576226702954, "26Mg" -> 0.0010262440825865378`], 22 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 28.134002685546875`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006072862026103549, "25Mg" -> 
                 0.0007948472064331002, "26Mg" -> 0.0010215718965234579`], 23 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 14, 36.5260009765625}, 
                   "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006037203036015139, "25Mg" -> 0.0007817520394814356, 
                 "26Mg" -> 0.0009850999343085174], 24 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 14, 44.91699981689453},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.0060323351148542145`, "25Mg" -> 0.0008117082873041469, 
                 "26Mg" -> 0.0009991308767032284], 25 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 14, 53.308998107910156`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006054226013717082, "25Mg" -> 
                 0.0008192534649638263, "26Mg" -> 0.0010101955859728627`], 26 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 15, 1.6999969482421875`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006029990756350372, "25Mg" -> 
                 0.0008076636089932022, "26Mg" -> 0.0010129395342469863`], 27 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 15, 10.092002868652344`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.006003589600839594, "25Mg" -> 
                 0.0007733547818639748, "26Mg" -> 0.0009867017655118848], 28 -> 
               Association[
                "Time" -> DateObject[{
                   2015, 7, 29, 18, 15, 18.483001708984375`}, "Instant", 
                   "Gregorian", 1.], "24Mg" -> 0.008316897903629245, "25Mg" -> 
                 0.001111549791200362, "26Mg" -> 0.0013804309746649737`], 29 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 15, 26.875}, "Instant",
                    "Gregorian", 1.], "24Mg" -> 0.006218393127711418, "25Mg" -> 
                 0.0008000442155538357, "26Mg" -> 0.0010396378041713835`], 30 -> 
               Association[
                "Time" -> DateObject[{2015, 7, 29, 18, 15, 35.26599884033203},
                    "Instant", "Gregorian", 1.], "24Mg" -> 
                 0.006097844980588943, "25Mg" -> 0.0007857011241889993, 
                 "26Mg" -> 0.001017552350823933]], 
              TypeSystem`Assoc[
               TypeSystem`Atom[Integer], 
               TypeSystem`Struct[{"Time", "24Mg", "25Mg", "26Mg"}, {
                 TypeSystem`Atom[DateObject], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real], 
                 TypeSystem`Atom[Real]}], 30], 
              Association["Origin" -> HoldComplete[First, 
                 Dataset`DatasetHandle[297950604709480]], "ID" -> 
               297954899676779]]], True], "TSV"]], Appearance -> Automatic, 
        Evaluator -> Automatic, Method -> "Preemptive", ButtonData -> 
        "paclet:ref/Copy using \[PlusMinus]"]},
      "Row",
      DisplayFunction->(PaneBox[
        RowBox[{
          TemplateSlotSequence[1, "\[InvisibleSpace]"]}], 
        ImageSize -> {All, Automatic}]& ),
      InterpretationFunction->(RowBox[{"Row", "[", 
         RowBox[{
           RowBox[{"{", 
             TemplateSlotSequence[1, ","], "}"}], ",", 
           RowBox[{"ImageSize", "\[Rule]", 
             RowBox[{"{", 
               RowBox[{"All", ",", "Automatic"}], "}"}]}]}], "]"}]& )]},
    {
     TemplateBox[{TagBox[
        DynamicModuleBox[{
         TypeSystem`NestedGrid`PackagePrivate`$state$$ = 
          Data`UnorderedAssociation[
           "RowCount" -> 20, "Length" -> 30, "InitialType" -> TypeSystem`Assoc[
              TypeSystem`Atom[Integer], 
              TypeSystem`Struct[{"Time", "24Mg", "25Mg", "26Mg"}, {
                TypeSystem`Atom[DateObject], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 30], "Shape" -> 
            TypeSystem`PackageScope`HeaderShape[
              Association[{All, 
                 TypeSystem`PackageScope`KeyDummy[10]} -> 1, {All, "Time"} -> 
               1, {All, "24Mg"} -> 1, {All, "25Mg"} -> 1, {All, "26Mg"} -> 1], 
              TypeSystem`PackageScope`Limited[
               TypeSystem`PackageScope`ColumnShape[
                TypeSystem`PackageScope`KeyValueShape[
                 TypeSystem`PackageScope`AtomShape[34], 
                 TypeSystem`PackageScope`RowShape[
                  Association[
                  "Time" -> TypeSystem`PackageScope`AtomShape[75], "24Mg" -> 
                   TypeSystem`PackageScope`AtomShape[60], "25Mg" -> 
                   TypeSystem`PackageScope`AtomShape[60], "26Mg" -> 
                   TypeSystem`PackageScope`AtomShape[60]]]]], 20, {}]], 
            "InitialData" -> TypeSystem`PackageScope`CacheHandle[815323723], 
            "Type" -> TypeSystem`Assoc[
              TypeSystem`Atom[Integer], 
              TypeSystem`Struct[{"Time", "24Mg", "25Mg", "26Mg"}, {
                TypeSystem`Atom[DateObject], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real], 
                TypeSystem`Atom[Real]}], 30], "HandleQ" -> True, "RowTarget" -> 
            20, "Data" -> TypeSystem`PackageScope`CacheHandle[815323723]], 
          TypeSystem`NestedGrid`PackagePrivate`$path$$ = {}, 
          TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 1, 
          TypeSystem`NestedGrid`PackagePrivate`$grid$$ = 
          DynamicModule[{
            TypeSystem`NestedGrid`PackagePrivate`renderedGrid = Deploy[
               Style[
                Grid[{{
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox["\"\"", FontColor -> GrayLevel[0.4]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], 
                    Style[
                    Pane[
                    Style[
                    RawBoxes[
                    StyleBox[
                    "\"\"", FontColor -> 
                    RGBColor[0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], Italic, 
                    GrayLevel[0.7]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1591925782][{All, Keys}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[All, Keys]], "Mouse"], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"Time\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"Time\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1591925782][{All, "Time"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[All, "Time"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"24Mg\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"24Mg\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1591925782][{All, "24Mg"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[All, "24Mg"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"25Mg\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"25Mg\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1591925782][{All, "25Mg"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[All, "25Mg"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Item[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Pane[
                    RawBoxes[
                    StyleBox["\"26Mg\"", FontColor -> GrayLevel[0.4]]], {{
                    20, Full}, 15}], 
                    Style[
                    Pane[
                    RawBoxes[
                    StyleBox[
                    "\"26Mg\"", FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], {{20, Full}, 15}], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
                    1591925782][{All, "26Mg"}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[All, "26Mg"]], "Mouse"], 
                    Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["1"], 
                    Style[
                    RawBoxes["1"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[1]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[1]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:11:31\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[1], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00600027"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[1], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000791118"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[1], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00102007"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[1], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["2"], 
                    Style[
                    RawBoxes["2"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[2]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[2]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:11:40\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[2], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00606253"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[2], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000786802"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[2], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.0010042"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[2], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["3"], 
                    Style[
                    RawBoxes["3"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[3]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[3]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:11:48\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[3], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00605336"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[3], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000807972"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[3], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00102047"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[3], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["4"], 
                    Style[
                    RawBoxes["4"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[4]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[4]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:11:57\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[4], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00606241"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[4], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000797137"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[4], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00101451"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[4], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["5"], 
                    Style[
                    RawBoxes["5"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[5]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[5]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:12:05\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[5], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00618006"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[5], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000818593"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[5], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00103882"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[5], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["6"], 
                    Style[
                    RawBoxes["6"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[6]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[6]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:12:13\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[6], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00745734"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[6], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000968305"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[6], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00122639"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[6], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["7"], 
                    Style[
                    RawBoxes["7"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[7]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[7]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:12:22\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[7], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00619602"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[7], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00080624"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[7], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00103047"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[7], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["8"], 
                    Style[
                    RawBoxes["8"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[8]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[8]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:12:30\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[8], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00604109"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[8], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000785452"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[8], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00101825"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[8], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["9"], 
                    Style[
                    RawBoxes["9"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[9]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[9]]], "Mouse"], ImageSize -> {{34, Full}, Automatic}],
                     Background -> GrayLevel[0.95], 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:12:39\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[9], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00602863"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[9], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000794348"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[9], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00100767"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[9], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["10"], 
                    Style[
                    RawBoxes["10"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[10]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[10]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:12:47\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[10], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00606625"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[10], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000772856"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[10], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00102427"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[10], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["11"], 
                    Style[
                    RawBoxes["11"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[11]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[11]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:12:55\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[11], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00601192"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[11], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000789415"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[11], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000998775"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[11], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["12"], 
                    Style[
                    RawBoxes["12"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[12]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[12]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:13:04\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[12], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00602641"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[12], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00079451"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[12], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00100379"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[12], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["13"], 
                    Style[
                    RawBoxes["13"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[13]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[13]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:13:12\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[13], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00605641"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[13], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000772092"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[13], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00104201"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[13], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["14"], 
                    Style[
                    RawBoxes["14"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[14]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[14]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:13:21\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[14], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.0060665"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[14], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00075935"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[14], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000998641"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[14], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["15"], 
                    Style[
                    RawBoxes["15"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[15]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[15]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:13:29\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[15], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00608527"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[15], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000796124"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[15], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00100993"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[15], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["16"], 
                    Style[
                    RawBoxes["16"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[16]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[16]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:13:37\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[16], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00605225"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[16], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000828839"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[16], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00102034"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[16], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["17"], 
                    Style[
                    RawBoxes["17"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[17]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[17]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:13:46\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[17], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00608715"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[17], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000811224"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[17], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00101881"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[17], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["18"], 
                    Style[
                    RawBoxes["18"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[18]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[18]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:13:54\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[18], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00611143"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[18], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000804463"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[18], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00101018"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[18], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["19"], 
                    Style[
                    RawBoxes["19"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[19]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[19]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:14:02\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[19], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00602647"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[19], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000763079"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[19], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00100622"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[19], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Pane[
                    Annotation[
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    RawBoxes["20"], 
                    Style[
                    RawBoxes["20"], FontColor -> 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], "LinkHand"], {"MouseClicked", 1} :> 
                    TypeSystem`NestedGrid`PackagePrivate`updateState[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][{
                    Key[20]}]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[20]]], "Mouse"], 
                    ImageSize -> {{34, Full}, Automatic}], Background -> 
                    GrayLevel[0.95], Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes[
                    StyleBox[
                    "\"Wed 29 Jul 2015 18:14:11\"", FontColor -> RGBColor[{
                    Rational[33, 74], 
                    Rational[27, 74], 
                    Rational[117, 370]}]]], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[20], 
                    Key["Time"]]], "Mouse"], 
                    ImageSize -> {{75, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00680666"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[20], 
                    Key["24Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.000915085"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[20], 
                    Key["25Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}], 
                   Pane[
                    Annotation[
                    RawBoxes["0.00112801"], 
                    TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[
                    1591925782][
                    GeneralUtilities`Slice[
                    Key[20], 
                    Key["26Mg"]]], "Mouse"], 
                    ImageSize -> {{60, Full}, Automatic}, 
                    Alignment -> {Left, Baseline}]}, {
                   Item[
                    Deploy[
                    Mouseover[
                    Row[{
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    GrayLevel[0.5]]], 
                    GrayLevel[0.5], {
                    Thickness[0.023255813953488372`], 
                    FaceForm[{
                    RGBColor[0.481, 0.481, 0.481], 
                    Opacity[1.]}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{0.56, 
                    1.031}, {6.429, 1.031}, {6.429, 60.967}, {0.56, 
                    60.967}}}], 
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{6.192899999999999, 
                    30.980699999999995`}, {42.4399, 0.7526999999999973}, {
                    42.4399, 8.209699999999994}, {16.432899999999997`, 
                    30.982699999999994`}, {42.4119, 53.6547}, {42.4399, 
                    61.244699999999995`}}}]}}, ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]], 
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098], {
                    Thickness[0.023255813953488372`], 
                    FaceForm[{
                    RGBColor[0.481, 0.481, 0.481], 
                    Opacity[1.]}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{0.56, 
                    1.031}, {6.429, 1.031}, {6.429, 60.967}, {0.56, 
                    60.967}}}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{6.192899999999999, 
                    30.980699999999995`}, {42.4399, 0.7526999999999973}, {
                    42.4399, 8.209699999999994}, {16.432899999999997`, 
                    30.982699999999994`}, {42.4119, 53.6547}, {42.4399, 
                    61.244699999999995`}}}]}}, ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]]], "LinkHand"], {
                    "MouseClicked" :> (
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$pos$$ + 
                    30 (-20), {1, 30 - -20 + 1}])}], 
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    GrayLevel[0.3]]], 
                    GrayLevel[0.3], {
                    Thickness[0.026431741349551847`], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5499, 30.980699999999995`}, {
                    36.7969, 0.7526999999999973}, {36.7969, 
                    8.209699999999994}, {10.7899, 30.982699999999994`}, {
                    36.7689, 53.6547}, {36.7969, 61.244699999999995`}}}]}}, 
                    ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]], 
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098], {
                    Thickness[0.026431741349551847`], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5499, 30.980699999999995`}, {
                    36.7969, 0.7526999999999973}, {36.7969, 
                    8.209699999999994}, {10.7899, 30.982699999999994`}, {
                    36.7689, 53.6547}, {36.7969, 61.244699999999995`}}}]}}, 
                    ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]]], "LinkHand"], {
                    "MouseClicked" :> (
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$pos$$ - 20, {
                    1, 30 - -20 + 1}])}], 
                    Pane[
                    Row[{"showing ", 1, "\[Dash]", 20, " of ", 
                    Style[
                    30, FontColor -> GrayLevel[0], FontWeight -> "Medium"]}, 
                    BaseStyle -> {
                    FontSize -> 8., FontColor -> 
                    RGBColor[
                    0.5098039215686274, 0.5098039215686274, 
                    0.5098039215686274]}], 150, ContentPadding -> False, 
                    Alignment -> {Center, Center}], 
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    GrayLevel[0.3]]], 
                    GrayLevel[0.3], {
                    Thickness[0.026431741349551847`], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5778000000000001, 
                    53.654399999999995`}, {26.5568, 30.982399999999995`}, {
                    0.5498000000000001, 8.209399999999995}, {
                    0.5498000000000001, 0.7523999999999944}, {
                    36.796800000000005`, 30.980399999999992`}, {
                    0.5498000000000001, 61.2454}}}]}}, 
                    ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]], 
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098], {
                    Thickness[0.026431741349551847`], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5778000000000001, 
                    53.654399999999995`}, {26.5568, 30.982399999999995`}, {
                    0.5498000000000001, 8.209399999999995}, {
                    0.5498000000000001, 0.7523999999999944}, {
                    36.796800000000005`, 30.980399999999992`}, {
                    0.5498000000000001, 61.2454}}}]}}, 
                    ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]]], "LinkHand"], {
                    "MouseClicked" :> (
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$pos$$ + 20, {
                    1, 30 - 20 + 1}])}], 
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    GrayLevel[0.5]]], 
                    GrayLevel[0.5], {
                    Thickness[0.023255813953488372`], 
                    FaceForm[{
                    RGBColor[0.481, 0.481, 0.481], 
                    Opacity[1.]}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
                    36.571, 1.031}, {42.440999999999995`, 1.031}, {
                    42.440999999999995`, 60.967}, {36.571, 60.967}}}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5598000000000001, 
                    53.788500000000006`}, {26.5668, 31.015500000000007`}, {
                    0.5878000000000001, 8.343500000000006}, {
                    0.5598000000000001, 0.7525000000000048}, {36.8068, 
                    31.017500000000005`}, {0.5598000000000001, 
                    61.24450000000001}}}]}}, ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]], 
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098], {
                    Thickness[0.023255813953488372`], 
                    FaceForm[{
                    RGBColor[0.481, 0.481, 0.481], 
                    Opacity[1.]}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
                    36.571, 1.031}, {42.440999999999995`, 1.031}, {
                    42.440999999999995`, 60.967}, {36.571, 60.967}}}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5598000000000001, 
                    53.788500000000006`}, {26.5668, 31.015500000000007`}, {
                    0.5878000000000001, 8.343500000000006}, {
                    0.5598000000000001, 0.7525000000000048}, {36.8068, 
                    31.017500000000005`}, {0.5598000000000001, 
                    61.24450000000001}}}]}}, ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]]], "LinkHand"], {
                    "MouseClicked" :> (
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$pos$$ + 
                    30 20, {1, 30 - 20 + 1}])}]}, "   "], 
                    Row[{
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    GrayLevel[0.5]]], 
                    GrayLevel[0.5], {
                    Thickness[0.023255813953488372`], 
                    FaceForm[{
                    RGBColor[0.481, 0.481, 0.481], 
                    Opacity[1.]}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{0.56, 
                    1.031}, {6.429, 1.031}, {6.429, 60.967}, {0.56, 
                    60.967}}}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{6.192899999999999, 
                    30.980699999999995`}, {42.4399, 0.7526999999999973}, {
                    42.4399, 8.209699999999994}, {16.432899999999997`, 
                    30.982699999999994`}, {42.4119, 53.6547}, {42.4399, 
                    61.244699999999995`}}}]}}, ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]], 
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098], {
                    Thickness[0.023255813953488372`], 
                    FaceForm[{
                    RGBColor[0.481, 0.481, 0.481], 
                    Opacity[1.]}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{0.56, 
                    1.031}, {6.429, 1.031}, {6.429, 60.967}, {0.56, 
                    60.967}}}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{6.192899999999999, 
                    30.980699999999995`}, {42.4399, 0.7526999999999973}, {
                    42.4399, 8.209699999999994}, {16.432899999999997`, 
                    30.982699999999994`}, {42.4119, 53.6547}, {42.4399, 
                    61.244699999999995`}}}]}}, ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]]], "LinkHand"], {
                    "MouseClicked" :> (
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$pos$$ + 
                    30 (-20), {1, 30 - -20 + 1}])}], 
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    GrayLevel[0.3]]], 
                    GrayLevel[0.3], {
                    Thickness[0.026431741349551847`], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5499, 30.980699999999995`}, {
                    36.7969, 0.7526999999999973}, {36.7969, 
                    8.209699999999994}, {10.7899, 30.982699999999994`}, {
                    36.7689, 53.6547}, {36.7969, 61.244699999999995`}}}]}}, 
                    ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]], 
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098], {
                    Thickness[0.026431741349551847`], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5499, 30.980699999999995`}, {
                    36.7969, 0.7526999999999973}, {36.7969, 
                    8.209699999999994}, {10.7899, 30.982699999999994`}, {
                    36.7689, 53.6547}, {36.7969, 61.244699999999995`}}}]}}, 
                    ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]]], "LinkHand"], {
                    "MouseClicked" :> (
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$pos$$ - 20, {
                    1, 30 - -20 + 1}])}], 
                    Pane[
                    Row[{"showing ", 1, "\[Dash]", 20, " of ", 
                    Style[
                    30, FontColor -> GrayLevel[0], FontWeight -> "Medium"]}, 
                    BaseStyle -> {
                    FontSize -> 8., FontColor -> 
                    RGBColor[
                    0.5098039215686274, 0.5098039215686274, 
                    0.5098039215686274]}], 150, ContentPadding -> False, 
                    Alignment -> {Center, Center}], 
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    GrayLevel[0.3]]], 
                    GrayLevel[0.3], {
                    Thickness[0.026431741349551847`], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5778000000000001, 
                    53.654399999999995`}, {26.5568, 30.982399999999995`}, {
                    0.5498000000000001, 8.209399999999995}, {
                    0.5498000000000001, 0.7523999999999944}, {
                    36.796800000000005`, 30.980399999999992`}, {
                    0.5498000000000001, 61.2454}}}]}}, 
                    ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]], 
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098], {
                    Thickness[0.026431741349551847`], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5778000000000001, 
                    53.654399999999995`}, {26.5568, 30.982399999999995`}, {
                    0.5498000000000001, 8.209399999999995}, {
                    0.5498000000000001, 0.7523999999999944}, {
                    36.796800000000005`, 30.980399999999992`}, {
                    0.5498000000000001, 61.2454}}}]}}, 
                    ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]]], "LinkHand"], {
                    "MouseClicked" :> (
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$pos$$ + 20, {
                    1, 30 - 20 + 1}])}], 
                    EventHandler[
                    MouseAppearance[
                    Mouseover[
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    GrayLevel[0.5]]], 
                    GrayLevel[0.5], {
                    Thickness[0.023255813953488372`], 
                    FaceForm[{
                    RGBColor[0.481, 0.481, 0.481], 
                    Opacity[1.]}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
                    36.571, 1.031}, {42.440999999999995`, 1.031}, {
                    42.440999999999995`, 60.967}, {36.571, 60.967}}}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5598000000000001, 
                    53.788500000000006`}, {26.5668, 31.015500000000007`}, {
                    0.5878000000000001, 8.343500000000006}, {
                    0.5598000000000001, 0.7525000000000048}, {36.8068, 
                    31.017500000000005`}, {0.5598000000000001, 
                    61.24450000000001}}}]}}, ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]], 
                    Graphics[{
                    EdgeForm[
                    Directive[
                    Thickness[0.05], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098]]], 
                    RGBColor[
                    0.27450980392156865`, 0.5372549019607843, 
                    0.792156862745098], {
                    Thickness[0.023255813953488372`], 
                    FaceForm[{
                    RGBColor[0.481, 0.481, 0.481], 
                    Opacity[1.]}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}}}, {{{
                    36.571, 1.031}, {42.440999999999995`, 1.031}, {
                    42.440999999999995`, 60.967}, {36.571, 60.967}}}], 
                    
                    FilledCurve[{{{0, 2, 0}, {0, 1, 0}, {0, 1, 0}, {0, 1, 
                    0}, {0, 1, 0}}}, {{{0.5598000000000001, 
                    53.788500000000006`}, {26.5668, 31.015500000000007`}, {
                    0.5878000000000001, 8.343500000000006}, {
                    0.5598000000000001, 0.7525000000000048}, {36.8068, 
                    31.017500000000005`}, {0.5598000000000001, 
                    61.24450000000001}}}]}}, ImageSize -> {Automatic, 9}, 
                    ImagePadding -> {{1, 1}, {0, 0}}, BaselinePosition -> 
                    Scaled[-0.2]]], "LinkHand"], {
                    "MouseClicked" :> (
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$ = 
                    Clip[TypeSystem`NestedGrid`PackagePrivate`$pos$$ + 
                    30 20, {1, 30 - 20 + 1}])}]}, "   "]]], Background -> 
                    GrayLevel[0.98], Alignment -> {Left, Top}, 
                    BaseStyle -> {ContextMenu -> {
                    MenuItem["Hide", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782},
                     1, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 10 rows", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782},
                     10, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 30 rows", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782},
                     30, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show up to 100 rows", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782},
                     100, {}]], MenuEvaluator -> Automatic], 
                    MenuItem["Show all", 
                    KernelExecute[
                    
                    TypeSystem`NestedGrid`PackagePrivate`adjustLimits[{
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782},
                     100000000, {}]], MenuEvaluator -> Automatic]}}], 
                   SpanFromLeft, SpanFromLeft, SpanFromLeft, SpanFromLeft}}, 
                 BaseStyle -> {ContextMenu -> {
                    MenuItem["Copy position to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Copy data to clipboard", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`copyClip]], 
                    MenuEvaluator -> Automatic], Delimiter, 
                    MenuItem["Paste position in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentPosition[
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic], 
                    MenuItem["Paste data in new cell", 
                    KernelExecute[
                    TypeSystem`NestedGrid`PackagePrivate`toCurrentData[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`cellPaste]], 
                    MenuEvaluator -> Automatic]}, FontFamily -> "Verdana", 
                   FontSize -> 12}, Alignment -> Left, RowMinHeight -> 1.5, 
                 Dividers -> All, FrameStyle -> GrayLevel[0.85], 
                 BaseStyle -> {FontFamily -> "Verdana", FontSize -> 12}], 
                LineBreakWithin -> False, ContextMenu -> {}, NumberMarks -> 
                False, ShowAutoStyles -> False]], 
             TypeSystem`NestedGrid`PackagePrivate`initialQ = True, 
             TypeSystem`NestedGrid`PackagePrivate`self = $Failed}, 
            Dynamic[
             TypeSystem`NestedGrid`PackagePrivate`setupViewPath[
             TypeSystem`NestedGrid`PackagePrivate`$path$$, If[
                Not[TypeSystem`NestedGrid`PackagePrivate`initialQ], 
                
                Module[{
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = $Failed, 
                  TypeSystem`NestedGrid`PackagePrivate`tmpData$ = 
                  TypeSystem`NestedGrid`PackagePrivate`LookupCacheValue[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$["Data"]]}, 
                 TypeSystem`NestedGrid`PackagePrivate`tmpGrid$ = 
                  If[TypeSystem`NestedGrid`PackagePrivate`tmpData$ === 
                    TypeSystem`NestedGrid`PackagePrivate`$NotCached, 
                    TypeSystem`NestedGrid`PackagePrivate`renderedGrid, 
                    TypeSystem`NestedGrid`PackagePrivate`renderGrid[
                    TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782][
                    TypeSystem`NestedGrid`PackagePrivate`tmpData$]]; If[
                   Not[
                    FailureQ[TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]], 
                   TypeSystem`NestedGrid`PackagePrivate`renderedGrid = 
                   TypeSystem`NestedGrid`PackagePrivate`tmpGrid$]; Null]]; 
              TypeSystem`NestedGrid`PackagePrivate`initialQ = False; 
              TypeSystem`NestedGrid`PackagePrivate`$pos$$; If[
                FailureQ[TypeSystem`NestedGrid`PackagePrivate`renderedGrid], 
                TypeSystem`SparseGrid[
                 TypeSystem`H["(data no longer present)"]], 
                If[GeneralUtilities`$DebugMode, 
                 Row[{TypeSystem`NestedGrid`PackagePrivate`renderedGrid, "  ", 
                   TypeSystem`NestedGrid`PackagePrivate`formatState[
                   TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                    TypeSystem`NestedGrid`PackagePrivate`$pos$$]}], 
                 TypeSystem`NestedGrid`PackagePrivate`renderedGrid]]], 
             TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$pos$$}],
             DynamicModuleValues :> {}], 
          TypeSystem`NestedGrid`PackagePrivate`$posCell$$, 
          TypeSystem`NestedGrid`PackagePrivate`$topBar$$ = Dynamic[
            TypeSystem`NestedGrid`PackagePrivate`alignBar[
            TypeSystem`NestedGrid`PackagePrivate`$state$$][
             TypeSystem`NestedGrid`PackagePrivate`makeFramedBar[
              TypeSystem`PackageScope`Pathbar[
              TypeSystem`NestedGrid`PackagePrivate`$path$$, 
               TypeSystem`NestedGrid`PackagePrivate`updateState[
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
                TypeSystem`NestedGrid`PackagePrivate`$path$$, 
                TypeSystem`NestedGrid`PackagePrivate`$pos$$, 
                TypeSystem`NestedGrid`PackagePrivate`$grid$$, 1591925782]]]], 
            TrackedSymbols :> {TypeSystem`NestedGrid`PackagePrivate`$path$$}],
           TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$ = Framed[
            Dynamic[
             Replace[
              MouseAnnotation[Null], {
              TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1591925782][
                Null] -> "", 
               TypeSystem`NestedGrid`PackagePrivate`$SliceMarker[1591925782][
                 Pattern[TypeSystem`NestedGrid`PackagePrivate`path, 
                  Blank[]]] :> (
                TypeSystem`NestedGrid`PackagePrivate`$lastPath = 
                 TypeSystem`NestedGrid`PackagePrivate`path; 
                TypeSystem`NestedGrid`PackagePrivate`makePathTrail[
                 TypeSystem`NestedGrid`PackagePrivate`path, 
                  TypeSystem`NestedGrid`PackagePrivate`makePathElements]), 
               Null :> Spacer[10], Blank[] :> Spacer[10]}], 
             TrackedSymbols :> {}], FrameStyle -> None, ImageMargins -> 0, 
            FrameMargins -> 0, Alignment -> Top, 
            ImageSize -> {Automatic, 14}]}, 
         DynamicBox[
          ToBoxes[
           Column[
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, {
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}, {
             TypeSystem`NestedGrid`PackagePrivate`$topBar$$, 
              TypeSystem`NestedGrid`PackagePrivate`displayScrollBar[
              TypeSystem`NestedGrid`PackagePrivate`$grid$$, 
               TypeSystem`NestedGrid`PackagePrivate`$state$$, 
               TypeSystem`NestedGrid`PackagePrivate`$pos$$], 
              TypeSystem`NestedGrid`PackagePrivate`onDesktopShow[
               TypeSystem`NestedGrid`PackagePrivate`alignBar[
               TypeSystem`NestedGrid`PackagePrivate`$state$$][
               TypeSystem`NestedGrid`PackagePrivate`$bottomBar$$]]}], 
            Spacings -> 
            If[TypeSystem`NestedGrid`PackagePrivate`$path$$ == {}, 
              0, {{}, {0, 0.05, 0}}]], StandardForm], 
          ImageSizeCache -> {510., {279., 285.}}, 
          TrackedSymbols :> {
           TypeSystem`NestedGrid`PackagePrivate`$state$$, 
            TypeSystem`NestedGrid`PackagePrivate`$grid$$}], 
         BaseStyle -> {LineBreakWithin -> False}, Deinitialization :> 
         TypeSystem`NestedGrid`PackagePrivate`deleteState[
          TypeSystem`NestedGrid`PackagePrivate`$state$$], 
         DynamicModuleValues :> {}, Initialization :> 
         Block[{$ContextPath = $ContextPath}, 
           Needs["TypeSystem`"]]], Deploy, DefaultBaseStyle -> "Deploy"]},
      "CopyTag",
      DisplayFunction->(#& ),
      InterpretationFunction->("Dataset[<>]"& )]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 ImageSize->{514, 596},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[37]=",
 CellID->360858227,ExpressionUUID->"a1d2cbc1-b914-4b8c-9a15-883b61bd2d99"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell",ExpressionUUID->"877abdf3-be96-498e-b1ef-ed6f8e6e5bfe"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Examples",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "TutorialColor", 
  "LinkTrails" -> GridBox[{{
      RowBox[{
        ButtonBox[
        "Wolfram Language", ButtonData -> "paclet:guide/WolframRoot", 
         BaseStyle -> {"Link", "DockedLinkTrail"}]}]}}, ColumnAlignments -> 
    Left], "ExampleCounter" -> 1, "NeedPlatMsgIn" -> None, "RootCaptions" -> 
  "", "Metadata" -> {
   "built" -> "{2018, 3, 25, 14, 38, 8.0241495}", 
    "history" -> {"XX", "", "", ""}, "context" -> "DataAnalysis`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Data Analysis Package Tutorial", "language" -> "en", "paclet" -> 
    "DataAnalysis Package", "status" -> "None", "summary" -> 
    "Load the package: Carry out simple forward propagation of uncertainties \
in an algebraic functions (95% confidence intervals are shown): Show \
confidence intervals with \[PlusMinus] instead of in parentheses:", 
    "synonyms" -> {}, "tabletags" -> 
    DocumentationBuild`Make`Private`tabletaggingrules$55144, "title" -> 
    "Examples", "titlemodifier" -> "", "windowtitle" -> "Examples", "type" -> 
    "Tutorial", "uri" -> "DataAnalysis/tutorial/Features"}, 
  "SearchTextTranslated" -> ""},
FrontEndVersion->"11.2 for Microsoft Windows (64-bit) (September 10, 2017)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> Notebook], 
   Cell[
    StyleData["Output"], CellContext -> Notebook], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> 
  "11.2 for Microsoft Windows (64-bit) (September 10, 2017)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[580, 21, 2614, 56, 55, "AnchorBarGrid",ExpressionUUID->"0be2e5c4-42d0-4fca-a47b-49b2374b8594",
 CellID->1],
Cell[CellGroupData[{
Cell[3219, 81, 100, 1, 63, "Title",ExpressionUUID->"8190d425-9c8f-4460-8281-e3bc0cba2ca0",
 CellID->509267359],
Cell[3322, 84, 108, 1, 35, "Text",ExpressionUUID->"de3d892d-bc89-4d80-8dab-b0b1bdb8a16a",
 CellID->739107753],
Cell[3433, 87, 172, 4, 26, "Input",ExpressionUUID->"aab4c968-ffc2-43b9-bdbe-7072d7f7efff",
 CellID->74146225],
Cell[CellGroupData[{
Cell[3630, 95, 117, 1, 70, "Section",ExpressionUUID->"9115affe-a21d-45b5-8383-b64babc50ed3",
 CellID->132105619],
Cell[3750, 98, 218, 4, 58, "Text",ExpressionUUID->"dba0c22a-d4c8-4992-ba60-53caf20c6afd",
 CellID->589426246],
Cell[CellGroupData[{
Cell[3993, 106, 422, 13, 26, "Input",ExpressionUUID->"d00a8f33-eb9a-4a02-a441-cb7499da6b91",
 CellID->87344918],
Cell[4418, 121, 584, 15, 35, "Output",ExpressionUUID->"59e60168-f5e9-4816-bd19-037de73e261b",
 CellID->466118847]
}, Open  ]],
Cell[CellGroupData[{
Cell[5039, 141, 244, 6, 26, "Input",ExpressionUUID->"01da872e-522e-4bbe-b113-d98f74c4a407",
 CellID->72611468],
Cell[5286, 149, 690, 17, 37, "Output",ExpressionUUID->"ccfc1f99-a9dc-43a1-b78b-becc3a8b95ad",
 CellID->659205163]
}, Open  ]],
Cell[CellGroupData[{
Cell[6013, 171, 305, 8, 26, "Input",ExpressionUUID->"95f03170-581f-431d-a44f-2cbe6dbff286",
 CellID->165117697],
Cell[6321, 181, 621, 17, 35, "Output",ExpressionUUID->"53df9b43-a5cd-4171-8bf4-ca4be0758d57",
 CellID->112864039]
}, Open  ]],
Cell[6957, 201, 163, 2, 35, "Text",ExpressionUUID->"dbccecb9-7111-46cc-bce5-3e5d607b465b",
 CellID->175075549],
Cell[CellGroupData[{
Cell[7145, 207, 219, 5, 43, "Input",ExpressionUUID->"f49f951c-91af-4066-9a91-4d8db321ce31",
 CellID->563333876],
Cell[7367, 214, 753, 18, 35, "Output",ExpressionUUID->"defdb727-3a30-411e-9a72-a86cd1932a36",
 CellID->18188078]
}, Open  ]],
Cell[8135, 235, 259, 5, 58, "Text",ExpressionUUID->"9f7edc6b-6c91-432b-ac73-13ac2431ef23",
 CellID->499431572],
Cell[8397, 242, 867, 23, 107, "Input",ExpressionUUID->"17deac04-22ac-4d0b-8dc7-4678403ffd8d",
 CellID->589378977],
Cell[9267, 267, 141, 1, 70, "Text",ExpressionUUID->"a1d5af39-7c5b-4d73-ad70-e7b89c01f413",
 CellID->474298645],
Cell[CellGroupData[{
Cell[9433, 272, 180, 3, 70, "Input",ExpressionUUID->"b841a787-8fd7-4b40-a195-f8d72862a73d",
 CellID->531204403],
Cell[9616, 277, 796, 20, 35, "Output",ExpressionUUID->"c45b8662-598d-4b2e-abaa-3baa0c3dc042",
 CellID->244107574]
}, Open  ]],
Cell[10427, 300, 250, 4, 70, "Text",ExpressionUUID->"87a9820b-6872-4f1d-9293-74a86558c8fb",
 CellID->242637655],
Cell[CellGroupData[{
Cell[10702, 308, 176, 3, 70, "Input",ExpressionUUID->"20b9eb40-175d-4ac0-8ae5-18eeec2e9d0f",
 CellID->44106417],
Cell[10881, 313, 45015, 778, 634, "Output",ExpressionUUID->"332e9b51-d87f-4460-b010-5ef185c787f5",
 CellID->790959085]
}, Open  ]],
Cell[CellGroupData[{
Cell[55933, 1096, 170, 3, 70, "Input",ExpressionUUID->"0dafd77e-3e28-4221-ac1a-e85c42db8fb5",
 CellID->864329415],
Cell[56106, 1101, 14123, 406, 70, "Output",ExpressionUUID->"3c0df588-722a-4053-b336-b7d882f6ff73",
 CellID->203639560]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[70278, 1513, 104, 1, 70, "Section",ExpressionUUID->"67df2717-ed14-4a8e-8aaa-580723863377",
 CellID->54902907],
Cell[70385, 1516, 533, 12, 70, "Text",ExpressionUUID->"2f587f95-2006-4b64-af1a-0e5124ea7f4b",
 CellID->17510087],
Cell[CellGroupData[{
Cell[70943, 1532, 1515, 39, 70, "Input",ExpressionUUID->"3d1ac562-3202-492a-a9ed-477ce3eb5bbb",
 CellID->186041130],
Cell[72461, 1573, 42571, 844, 70, "Output",ExpressionUUID->"f3cbb242-c2ab-4cac-aca5-9b70f30ee35e",
 CellID->596105155]
}, Open  ]],
Cell[115047, 2420, 197, 4, 70, "Text",ExpressionUUID->"2f8e1253-874c-47e2-8042-9251e07029df",
 CellID->177205639],
Cell[CellGroupData[{
Cell[115269, 2428, 268, 8, 70, "Input",ExpressionUUID->"d8bf62aa-c5ff-4acb-8e9d-a8cb5b0be969",
 CellID->600157041],
Cell[115540, 2438, 24661, 482, 70, "Output",ExpressionUUID->"a25281bb-1d15-460a-b0ab-77e24557c655",
 CellID->8792351]
}, Open  ]],
Cell[140216, 2923, 1399, 40, 70, "Text",ExpressionUUID->"7d0ed4ac-3b04-4f2e-9ba6-15932676d794",
 CellID->162507499],
Cell[CellGroupData[{
Cell[141640, 2967, 195, 4, 70, "Input",ExpressionUUID->"6d87107d-1f56-4f26-9da8-4760e2bbad9e",
 CellID->247362543],
Cell[141838, 2973, 45806, 919, 70, "Output",ExpressionUUID->"15ef125f-fc46-4521-8516-8119e613a1f4",
 CellID->535427235]
}, Open  ]],
Cell[187659, 3895, 233, 4, 70, "Text",ExpressionUUID->"310a84f6-bee0-4cbf-956b-510b6c249392",
 CellID->41393484],
Cell[CellGroupData[{
Cell[187917, 3903, 605, 16, 70, "Input",ExpressionUUID->"335d8e05-2c26-46aa-81ac-be73c58018ff",
 CellID->27194385],
Cell[188525, 3921, 1401, 36, 57, "Output",ExpressionUUID->"e8479e16-7f1f-4c61-b22b-0cf1c4846d7e",
 CellID->829375379]
}, Open  ]],
Cell[189941, 3960, 363, 10, 70, "Text",ExpressionUUID->"73ddfa70-9194-42cb-a238-9b8db9af7a1c",
 CellID->123141521],
Cell[CellGroupData[{
Cell[190329, 3974, 704, 19, 70, "Input",ExpressionUUID->"0db31235-173a-4645-8105-9324c694152d",
 CellID->595642825],
Cell[191036, 3995, 16762, 327, 70, "Output",ExpressionUUID->"0c471f88-45a7-4ead-a678-41358bacc1ac",
 CellID->292116934]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[207847, 4328, 120, 1, 70, "Section",ExpressionUUID->"2d39a9cb-80f9-4323-a4de-58d1b68a5336",
 CellID->9144692],
Cell[207970, 4331, 119, 1, 70, "Text",ExpressionUUID->"53b31f43-7ee3-4991-bd0c-b57a44029536",
 CellID->1534169418],
Cell[CellGroupData[{
Cell[208114, 4336, 6757, 173, 70, "Input",ExpressionUUID->"732f96c9-a1a6-45fe-8448-b21b001dd2f5",
 CellID->185992016],
Cell[214874, 4511, 64718, 1316, 70, "Output",ExpressionUUID->"21ba8dda-fabf-4aa8-acd9-18a5b46d73ef",
 CellID->84066839]
}, Open  ]],
Cell[279607, 5830, 230, 4, 70, "Text",ExpressionUUID->"e2cad087-f71d-4dae-813f-7d686f3b45bc",
 CellID->455748696],
Cell[CellGroupData[{
Cell[279862, 5838, 1032, 28, 70, "Input",ExpressionUUID->"e67bac62-fb48-41a6-b940-608429a893cb",
 CellID->193905331],
Cell[280897, 5868, 29131, 586, 70, "Output",ExpressionUUID->"ccdb16ed-d00f-4b86-a73b-a25dff32b8e8",
 CellID->133453163]
}, Open  ]],
Cell[310043, 6457, 211, 4, 70, "Text",ExpressionUUID->"f17456bc-392c-4965-9573-172f19dce367",
 CellID->622342540],
Cell[CellGroupData[{
Cell[310279, 6465, 528, 10, 70, "Input",ExpressionUUID->"a879f8e1-07ed-4a90-8ce7-0541459527b9",
 CellID->565915028],
Cell[310810, 6477, 25498, 600, 70, "Output",ExpressionUUID->"63579422-e549-475c-a496-f35d09b2db6f",
 CellID->53360647]
}, Open  ]],
Cell[336323, 7080, 206, 4, 70, "Text",ExpressionUUID->"fab3cf87-e448-4361-affa-8bd599fafb53",
 CellID->83641357],
Cell[CellGroupData[{
Cell[336554, 7088, 536, 10, 70, "Input",ExpressionUUID->"045e1868-af7f-4df8-bebb-28f83e6a4b41",
 CellID->295086487],
Cell[337093, 7100, 52452, 1078, 70, "Output",ExpressionUUID->"db274f6d-1704-47f4-a7dc-85a20f063c66",
 CellID->161828421]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[389594, 8184, 103, 1, 70, "Section",ExpressionUUID->"2b5510c4-5129-4a71-a8ba-71c315f181ab",
 CellID->92390272],
Cell[389700, 8187, 145, 1, 70, "Text",ExpressionUUID->"d4300a00-b30a-45ab-a23c-aba7eac9b0ec",
 CellID->284149851],
Cell[389848, 8190, 462, 10, 70, "Input",ExpressionUUID->"71e57eff-e29c-421b-982b-ae09c64a8213",
 CellID->272165702],
Cell[390313, 8202, 138, 1, 70, "Text",ExpressionUUID->"7a8d267f-1ab1-431d-8016-ae8e9c389b61",
 CellID->522230009],
Cell[CellGroupData[{
Cell[390476, 8207, 200, 4, 70, "Input",ExpressionUUID->"241124d8-2383-4e59-b875-7385309ec942",
 CellID->25993159],
Cell[390679, 8213, 233, 5, 35, "Output",ExpressionUUID->"15c4529d-9024-4908-95e9-337b6204ec48",
 CellID->75817136]
}, Open  ]],
Cell[390927, 8221, 214, 4, 70, "Text",ExpressionUUID->"0becf994-347d-4de8-8f30-fe5f5e124327",
 CellID->480545825],
Cell[CellGroupData[{
Cell[391166, 8229, 517, 14, 70, "Input",ExpressionUUID->"42e6bd40-5b13-4fc7-a6d5-7f5e5a85b374",
 CellID->202163725],
Cell[391686, 8245, 22853, 445, 70, "Output",ExpressionUUID->"71f4a949-05b6-4905-bc24-7805ac0e2e75",
 CellID->818252484]
}, Open  ]],
Cell[CellGroupData[{
Cell[414576, 8695, 626, 15, 70, "Input",ExpressionUUID->"9be2d73b-04cd-49c3-b4bc-f8240ea7e262",
 CellID->477182104],
Cell[415205, 8712, 23889, 474, 70, "Output",ExpressionUUID->"268cccd9-f244-4c66-bd4a-2fde6a442b6f",
 CellID->339068688]
}, Open  ]],
Cell[439109, 9189, 194, 4, 70, "Text",ExpressionUUID->"b6adf989-98ee-401d-91a6-0a24ded7d463",
 CellID->3613955],
Cell[CellGroupData[{
Cell[439328, 9197, 251, 5, 70, "Input",ExpressionUUID->"360ba714-f1cd-482d-b6c8-591f17fb4dc7",
 CellID->57002934],
Cell[439582, 9204, 24261, 474, 70, "Output",ExpressionUUID->"3101c0c5-ac50-4648-a3e0-a71441f9e592",
 CellID->642215501]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[463892, 9684, 101, 1, 70, "Section",ExpressionUUID->"eb018c90-5bba-400b-86ea-e98b1857a1b7",
 CellID->140195933],
Cell[463996, 9687, 671, 19, 70, "Text",ExpressionUUID->"8228c4fb-3ea1-481a-a3f2-d2c01b80514f",
 CellID->579455607],
Cell[464670, 9708, 382, 10, 70, "Input",ExpressionUUID->"7d9387c6-44e2-45de-adc4-4bb0795b26dd",
 CellID->83402267],
Cell[465055, 9720, 130, 1, 70, "Text",ExpressionUUID->"d10ecde7-ddd0-44ea-8b9a-23ec880d5f2e",
 CellID->703741967],
Cell[465188, 9723, 591, 13, 70, "Input",ExpressionUUID->"b2abdf72-7ad9-426e-a222-eb652b819e11",
 CellID->36518888],
Cell[465782, 9738, 142, 1, 70, "Text",ExpressionUUID->"f20f507b-f0c9-4e67-9365-85f79f0bfb82",
 CellID->218242064],
Cell[CellGroupData[{
Cell[465949, 9743, 372, 9, 70, "Input",ExpressionUUID->"7c27d248-b1e8-41c3-a858-8f98cba54433",
 CellID->457539375],
Cell[466324, 9754, 31771, 636, 70, "Output",ExpressionUUID->"ad0d1244-2f73-4cb6-add1-309d1798da0a",
 CellID->460763692]
}, Open  ]],
Cell[498110, 10393, 184, 4, 70, "Text",ExpressionUUID->"cc948fab-653b-450f-b0fb-9a63db9158b8",
 CellID->481346176],
Cell[498297, 10399, 1046, 26, 70, "Input",ExpressionUUID->"184ebc70-183f-45b2-b150-9f5d0a939d53",
 CellID->19586121],
Cell[CellGroupData[{
Cell[499368, 10429, 183, 3, 70, "Input",ExpressionUUID->"2658b682-dcb5-4ac5-a623-87001d1789a1",
 CellID->252273675],
Cell[499554, 10434, 610, 17, 35, "Output",ExpressionUUID->"1a29ee89-c6c1-4d53-82cb-896560048c33",
 CellID->103211626]
}, Open  ]],
Cell[CellGroupData[{
Cell[500201, 10456, 180, 3, 70, "Input",ExpressionUUID->"ed7389bd-66c3-438f-b736-fc6ea4efede8",
 CellID->258458251],
Cell[500384, 10461, 42781, 742, 642, "Output",ExpressionUUID->"0a978467-cc3a-44e6-a01f-f1c2d4d5581a",
 CellID->443047036]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[543214, 11209, 104, 1, 70, "Section",ExpressionUUID->"bd8599ca-a0bb-4a5f-98c3-829efcb91427",
 CellID->11826752],
Cell[543321, 11212, 203, 4, 70, "Text",ExpressionUUID->"fd9c7774-b1d4-4473-9e1f-d1f0ae9c4ff9",
 CellID->78545527],
Cell[543527, 11218, 436, 11, 70, "Input",ExpressionUUID->"d7f2356a-057a-4d14-9c51-b8f968a84477",
 CellID->22074223],
Cell[CellGroupData[{
Cell[543988, 11233, 156, 3, 70, "Input",ExpressionUUID->"f93460a1-8335-496d-a70c-07fe5db57e31",
 CellID->238579963],
Cell[544147, 11238, 145507, 2892, 70, "Output",ExpressionUUID->"a1d2cbc1-b914-4b8c-9a15-883b61bd2d99",
 CellID->360858227]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[689693, 14135, 78, 0, 70, "FooterCell",ExpressionUUID->"877abdf3-be96-498e-b1ef-ed6f8e6e5bfe"]
}
]
*)

(* End of internal cache information *)

